<?php
/*
gacc.php

Copyright (C)2002 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Accounts Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Accounts Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(gacc_qry1, "gaccref")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}

switch($_REQUEST['action']){
	case "clear" :
		addAh();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseAh($_REQUEST['id']);
         break;
      }
		browseAh($_POST['id']);
		break;

	case "edit" :
		editAh($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelAh($_REQUEST['id']);
      }
      else{
         deleteAh($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listAh();
      }
      break;  
	
   case "cfmdelete" :
      deleteAh($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listAh();
		break;

	case "add" :
		insertAh($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listAh();
		break;

	case "commit" :
		commitAh($_POST);
		listAh();
		break;

   case "duplicate" :
      $id=duplicateAh($_REQUEST['id']);
      editAh($id);
      break;
      
	case "list":
	default :
		listAh();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(gacc_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "";
	$frm["accountnumber"] = "";
	$frm["name"] = "";
   	
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(gacc_qry2, $id);
   }
   else{
      $qry=sprintf(gacc_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

   $frm["id"] = $id;
	$frm["accountnumber"] = $row["accountnumber"];
	$frm["name"] = $row["name"];
	
	return $frm;
}

function addAh()
{
   $frm=clearForm();
	$frm["newaction"] = "add";
	$frm["heading"] = erp_gacc_add;
   
	include("templates/gaccedit.php");
}

function editAh($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
	
	include("templates/gaccedit.php");
}

function browseAh($id) 
{
   $frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/gaccedit.php");
}

function chkdelAh($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/gaccedit.php");
}


function deleteAh($id) 
{
	$qry=sprintf(gacc_qry7, $id);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function insertAh($frm) 
{ 
   $qry=sprintf(gacc_qry5, $frm['accountnumber'], $frm['name']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitAh($frm) 
{
   $qry=sprintf(gacc_qry6, $frm['accountnumber'], $frm['name'],$frm['id']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function listAh()
{
   $q=$_SESSION["pageindex"]->query(gacc_qry4);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
   echo "<table class=\"list\">\n";
   echo "<th class=\"title\" colspan=\"3\">".erp_gacc_list."</th>\n";
   if(db_num_rows($result)==0){
      echo "<tr><td colspan=\"2\">".erp_gacc_nogacc."</td></td></table>\n";
      exit;
   }
   echo "<tr><td>";
	echo "<tr><td><h3>".erp_gacc_name."</h3></td><td><h3>".misc_listheadaction."</h3></td></tr>";

	while($row = $result->FetchRow()){
		$n=$row["name"];		
		echo "<tr><td>$n</td><td>";
		$wibbler=$row["id"];
		if($_SESSION['CFG']->pageimages){
         echo "<a href=\"gacc.php?action=browse&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['CFG']->menuimagedir."/menu_node_view.png\"></a>&nbsp;\n";
		   echo "<a href=\"gacc.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['CFG']->menuimagedir."/menu_node_edit.png\"></a>&nbsp; \n";
		   echo "<a href=\"gacc.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['CFG']->menuimagedir."/menu_node_delete.png\"></a>&nbsp; \n";
      }
      else{
      	echo "<a href=\"gacc.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		   echo "<a href=\"gacc.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		   echo "<a href=\"gacc.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
      }
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "</td></tr>";
}
?>
