<?php
/*
type.php

Copyright (C)2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){   // session timeout...
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Account Type Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Account Type Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(accountm_acchead_qry1, "accountheading")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addAh();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseAh($_REQUEST['id']);
         break;
      }
		browseAh($_POST['id']);
		break;

	case "edit" :
		editAh($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelAh($_REQUEST['id']);
      }
      else{
         deleteAh($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listAh();
      }
      break;  
	
   case "cfmdelete" :
      deleteAh($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listAh();
		break;

	case "add" :
		insertAh($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listAh();
		break;

	case "commit" :
		commitAh($_POST);
		listAh();
		break;

   case "duplicate" :
      $id=duplicateAh($_REQUEST['id']);
      editAh($id);
      break;
      
	case "list":
	default :
		listAh();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(accountm_acchead_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "0";
   $frm["parentid"] = "0";
	$frm["name"] = "";
	$frm["sref"] = "";
	$frm["eref"] = "";
	$frm["gref"] = "";
	$frm["type"] = 0;
   $frm["guitypeid"] = 0;

	return $frm;
}
function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(accountm_acchead_qry2, $id);
   }
   else{
      $qry=sprintf(accountm_acchead_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

   $frm["id"] = $id;
   $frm["parentid"] = $row["parentid"];
   $frm["name"] = $row["name"];
	$frm["sref"] = $row["sref"];
	$frm["eref"] = $row["eref"];
	$frm["gref"] = $row["gref"];
	$frm["type"] = $row["type"];
   $frm["guitypeid"] = $row["guitypeid"];
	$frm["newaction"] = "commit";
   
   return $frm;
}

function addAh()
{
   $frm=clearForm();
	$frm["newaction"] = "add";
	
	include("templates/type.php");
}

function editAh($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
	
	include("templates/type.php");
}

function browseAh($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   
	include("templates/type.php");
}

function insertAh($frm) 
{
   $qry=sprintf(accountm_acchead_qry4, $frm['parentid'],$frm['name'],$frm['sref'],$frm['eref'],$frm['gref'],$frm['type'],
   $frm['guitypeid']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   return $row[0];
}

function commitAh($frm) 
{
   $qry=sprintf(accountm_acchead_qry10, $frm['guicolour'], $frm['guitypeid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(accountm_acchead_qry5, $frm['parentid'],$frm['name'],$frm['sref'],$frm['eref'],$frm['gref'],$frm['type'],
   $frm['guitypeid'], $frm['id']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function chkdelAh($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/type.php");
}

function deleteAh($id) 
{
   $qry=sprintf(accountm_acchead_qry6,$id);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function duplicateAccount($id) 
{
   $frm=fillForm($id, false);
   insertAh($frm);
}

function fillParentCombo($a, $id)
{
   $acc=new Account();
   $acc->HeadingCombo($a, $id, "parentid");
}

function fillHeadingTypeCombo($a, $id)
{
   $acc=new Account();
   $acc->TypeCombo($a, $id, "type");
}

function colourControl($a, $id)
{
   require_once($_SESSION['VxCFG']->libdir."/colpick.js");
   
   $c="FFFFFF";
   $qry=sprintf(accountm_acchead_qry9, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){
      $c=$row['value'];
   }

   if($a=="commit" || $a=="add"){
      echo "<input id=\"colourselectorfield\" size=\"7\" readonly title=\"color\" name=\"guicolour\" value=\"".$c."\">";
      echo "<a href=\"javascript:pickColor('colourselector');\" id=\"colourselector\"";
      echo "style=\"border: 1px solid #000000; font-family:Verdana; font-size:10px; text-decoration: none;\">";
      echo "&nbsp;&nbsp;&nbsp;</a>\n";
      echo "<script language=\"javascript\">relateColor('colourselector', getWankObj('colourselectorfield').value);</script>";
   }
   else{
      echo "<span style=\"background-color:".$c."\">&nbsp;$c&nbsp;</span>";
   }
}

function listAh()
{
   $typelist=array(0=>'Income',1=>'Expense',2=>'Asset',3=>'Liability',4=>'Capital');
	
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(accountm_acchead_qry8, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no account types defined")."</td></td></table>\n";
      return;
   }

   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='parentid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Parent")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Parent")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=parentid\">"._("Parent")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='parentid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='type'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Type")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Type")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=type\">"._("Type")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='type'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">".$row['name']."</td>";

         $qry=sprintf(accountm_acchead_qry3, $row["parentid"]);
         $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
         if(isset($presult)){
            if($prow = $presult->FetchRow()){
               $p=$prow["name"];
            }
            else{
               $p="Not Set";
            }
         }
         else{
            $p="Not Set";
         }
         $type=$typelist[$row["type"]];
      
         $col="000000";
         $qry=sprintf(accountm_acchead_qry9, $row["guitypeid"]);
         $cresult=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($crow = $cresult->FetchRow()){
            $col=$crow['value'];
         }
   
         echo "<td class=\"listdata\">".$p."</td>";
         echo "<td class=\"listdata\"><font color=\"".$col."\">".$type."</font></td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row['name']."</td>";

         $qry=sprintf(accountm_acchead_qry3, $row["parentid"]);
         $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
         if(isset($presult)){
            if($prow = $presult->FetchRow()){
               $p=$prow["name"];
            }
            else{
               $p="Not Set";
            }
         }
         else{
            $p="Not Set";
         }
         $type=$typelist[$row["type"]];
      
         $col="FFFFFF";
         $qry=sprintf(accountm_acchead_qry9, $row["guitypeid"]);
         $cresult=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($crow = $cresult->FetchRow()){
            $col=$crow['value'];
         }
   
         echo "<td class=\"listdataeven\">".$p."</td>";
         echo "<td class=\"listdataeven\"><font color=\"".$col."\">".$type."</font></td><td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"type.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"type.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"type.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"type.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"type.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"type.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
