<?php
/*
type.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Part of:
  BhPos, Copyright (C) 2001 - 2004 Al Kingsley
  BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/tree.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(3);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm("browse", $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){   // session timeout...
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Account Type Organisation"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Account Type Organisation");
}

include($_SESSION['VxCFG']->styledir."/headertree.php");

HtmlBuildTree();

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function HtmlBuildTree()
{
   echo "<table>\n<tr>\n<td>&nbsp;</td></tr>";
   $closed="tree_folderclosed.png";
   $open="tree_folderopen.png";
   $ah_icon="icon_acccount.png";
   
   $tree = new HTML_TreeMenu();
   $acc = new HTML_TreeNode(array('text'=>_("Account Types"),'icon'=>$closed,'expandedIcon'=>$open));
   
   // from the root account headings, loop over parentid's (0 being root headings)
  $result=$_SESSION['VxCFG']->dbh->Execute(accountm_accheadorg_qry1);
  while($row = $result->FetchRow()){
      $z=&$acc->addItem(new HTML_TreeNode('cssClass'=>"treelink", array('text'=>$row['name'], 'link'=>"type.php?action=browse&id=".$row['id'],
            'icon'=>$closed,'expandedIcon'=>$open)));
      RecurseTree($row['id'], $z, $open, $closed, $ah_icon);
   }
   $tree->addItem($acc);
   $treedisp = new HTML_TreeMenu_DHTML($tree, array('images'=>$_SESSION['VxCFG']->styleimagedir));
   
   echo "<tr><td class=\"formdata\">";
   $treedisp->printMenu();
   echo "</td>\n</tr>\n</table>\n";
}

function RecurseTree($id, $node, $open, $closed, $ahicon)
{
   $qry=sprintf(accountm_accheadorg_qry2, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   while($row = $result->FetchRow()){
      if($row['parentid']==0){
         $z=&$node->addItem(new HTML_TreeNode(array('text'=>$row['name'], 'link'=>"type.php?action=browse&id=".$row['id'],
               'icon'=>$ahicon)));
         return;
      }
      else{
         $z=&$node->addItem(new HTML_TreeNode(array('text'=>$row['name'], 'link'=>"type.php?action=browse&id=".$row['id'],
            'icon'=>$closed,'expandedIcon'=>$open)));
         RecurseTree($row['id'], $z, $open, $closed, $ahicon);
      }
   }
}

?>
