<?php
/*
misuser.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/tree.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('lname');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("MIS User Administration"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("MIS User Administration");
}

if($_SESSION['pageindex']->CheckNum(misadmin_misuser_qry1, "misuser")){
   $_SESSION['pageindex']->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/headertree.php");

switch($action){
	case "clear" :
		addMisuser();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseMisuser($_REQUEST['id']);
         break;
      }
		browseMisuser($_POST['id']);
		break;

	case "edit" :
		editMisuser($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->confirmdelete){
         chkdelMisuser($_REQUEST['id']);
      }
      else{
         deleteMisuser($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listMisuser($_REQUEST['id']);
      }
      break;  
	
   case "cfmdelete" :
      deleteMisuser($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listMisuser();
		break;

	case "add" :
		insertMisuser($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listMisuser();
		break;

	case "commit" :
		commitMisuser($_POST);
      listMisuser();
		break;
      
   case "enablepage" :
		enablePage($_REQUEST['id'], $_REQUEST['menuid']);
      editMisuser($_REQUEST['menuid']);
		break;
      
   case "disablepage" :
      disablePage($_REQUEST['id'], $_REQUEST['menuid']);
      editMisuser($_REQUEST['menuid']);
		break;
      
   case 'chperm':
      changePerm($_REQUEST['perm'], $_REQUEST['id']);
      editMisuser($_REQUEST['id']);
      break;

	case "list":
	default :
		listMisuser();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(misadmin_misuser_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = "0";
   $frm["userid"] = "0";
   $frm["menuid"] = "0";
   $frm["fname"]= "";
   $frm["lname"]= "";
   $frm["employeeid"]=0;
   $frm["login"]="";
   $frm["password"]="";
   $frm["rpassword"]="";
   
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(misadmin_misuser_qry2, $id);
   }
   else{
      $qry=sprintf(misadmin_misuser_qry3, $id);
   }
   $frm=clearForm();
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	if($row = $result->FetchRow()){
      $frm["id"] = $id;
      $frm["userid"] = $row["userid"];
      $frm["menuid"] = $row["menuid"];
	}
   
   $qry=sprintf(misadmin_misuser_qry5, $frm["userid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	if(!($row = $result->FetchRow())) return $frm;
   
   $frm["employeeid"] = $row["employeeid"];
   $qry=sprintf(misadmin_misuser_qry6, $row["employeeid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	if(!($row = $result->FetchRow())) return $frm;
   
   $qry=sprintf(misadmin_misuser_qry9, $row["contactid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	if(!($row = $result->FetchRow())) return $frm;
   $frm["fname"]=$row['firstname'];
   $frm["lname"]=$row['lastname'];
   
   $qry=sprintf(misadmin_misuser_qry40, $frm["employeeid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   
   $qry=sprintf(misadmin_misuser_qry41, $row["logintypesid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm['login']=$row["ident"];
   $frm['password']=$row["data"];
   $frm['rpassword']=$row["data"];
   
   return $frm;
}

function addMisuser()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   
	include("templates/misuser.php");
}

function editMisuser($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/misuser.php");
}

function browseMisuser($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";

	include("templates/misuser.php");
}

function insertMisuser($frm) 
{
   // passwords match?
   if(strcmp($frm['password'], $frm['rpassword'])!=0){
      echo "<table class=\"formtable\">\n<tr>\n<td class=\"formdata\">Passwords do not match...</td>\n</tr>\n</table>\n";
      return;
   }
   
   // check to see if misuser already exists
   // obvious multiple users per employee are allowed - just not yet
   $qry=sprintf(misadmin_misuser_qry25, $frm['employeeid']);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result->RecordCount()!=0){
      echo "<table class=\"formtable\">\n<tr>\n<td class=\"formdata\">User already exists...</td>\n</tr>\n</table>\n";
      return;
   }

   // see if a user exists for employee
   $qry=sprintf(misadmin_misuser_qry25, $frm['employeeid']);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result->RecordCount()==0){
      // insert a logintype
      $qry=sprintf(misadmin_misuser_qry27, 0,$frm['login'],$frm['password']);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
      $row = $result->FetchRow();
      $litid=$row[0];
      $qry=sprintf(misadmin_misuser_qry29, $litid, $litid);
      
      // insert a user
      $qry=sprintf(misadmin_misuser_qry30,0,$frm['login'],$frm['password'],'','',$litid,$frm['employeeid']);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
      $row = $result->FetchRow();
      $userid=$row[0];
   }
   else{
      // see if a logintype exists...
      $row=$result->FetchRow();
      $userid=$row['id'];
      $qry=sprintf(misadmin_misuser_qry26, $row['id']);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($result->RecordCount()==0){
         // insert a logintype
         $qry=sprintf(misadmin_misuser_qry27, $row['logintypesid'],$frm['login'],$frm['password']);
         $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      }
      else{
         $bUserset=true;        
      }
   }
   
   // insert a blank set of default attributes
   $_SESSION['VxCFG']->dbh->Execute(misadmin_misuser_qry16);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $attribid=$row[0];
   $result=$_SESSION['VxCFG']->dbh->Execute(misadmin_misuser_qry15);
   $row = $result->FetchRow();
   $qry=sprintf(misadmin_misuser_qry18, $attribid, $row['name'],$row['type'],$row['format'],$row['mask'],$row['value']);
   while($row = $result->FetchRow()){
      $qry=sprintf(misadmin_misuser_qry17, $attribid, $row['name'],$row['type'],$row['format'],$row['mask'],$row['value']);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }

   // add minimum menu set
   $result=$_SESSION['VxCFG']->dbh->Execute(misadmin_misuser_qry31);
   $row = $result->FetchRow();
   $menuid=$row[0]+1;
   $qry=sprintf(misadmin_misuser_qry32,$menuid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_misuser_qry33,$menuid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_misuser_qry34,$menuid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_misuser_qry35,$menuid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_misuser_qry36,$menuid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_misuser_qry37,$menuid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_misuser_qry38,$menuid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_misuser_qry39,$menuid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   // add misuer entry
	$qry=sprintf(misadmin_misuser_qry4,$userid,$menuid,$attribid);
   $_SESSION['VxCFG']->dbh->StartTrans();
	$_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=admin&err=insert");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
}

function commitMisuser($frm) 
{
   /*
   $qry=sprintf(misadmin_misuser_qry5,$frm['userid'],$frm['menuid'],$frm['id']);
   $_SESSION['VxCFG']->dbh->StartTrans();
	$_SESSION['VxCFG']->dbh->Execute($query);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=admin&err=commit");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
   */
}

function chkdelMisuser($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/misuser.php");
}

function deleteMisuser($id) 
{
   $qry=sprintf(misadmin_misuser_qry7,$id);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function enablePage($id, $menuid)
{
   // insert page...
}

function disablePage($id, $menuid)
{
   // remove page...
}

function changePerm($p, $id)
{
   $qry=sprintf(misadmin_misuser_qry7, $p, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result){
      return;
   }
   if($result->RecordCount()==0){
      return;
   }
   if(!($row = $result->FetchRow())){
      return ;
   }
   if($row[0]=='Y') $np='N';
   else $np='Y';
   
   $qry=sprintf(misadmin_misuser_qry8, $p, $np, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
}

function EmployeeCombo($a, $id)
{
   if($a=="add"){
      echo "<select name=\"employeeid\">\n";
      //echo "<option value='0'>"._("Not Set")."</option>\n";

  	  $result=$_SESSION['VxCFG']->dbh->Execute(misadmin_misuser_qry24);
         
     	while($r = $result->FetchRow()){
         $qry=sprintf(misadmin_misuser_qry22, $r['contactid']);
         $res=$_SESSION['VxCFG']->dbh->Execute($qry);
         $row = $res->FetchRow();
     		if($id==$r['contactid']){
      		echo "<option selected value=\"".$row['id']."\">".$row['firstname']." ".$row['lastname']."</option>\n";
	      }
  		   else{
   		   echo "<option value=\"".$row['id']."\">".$row['firstname']." ".$row['lastname']."</option>\n";
	      }
  	   }
      echo "</select>\n";
   }
   else{
  	   $qry=sprintf(misadmin_misuser_qry23, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      $qry=sprintf(misadmin_misuser_qry22, $row['contactid']);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      echo $row['firstname']." ".$row['lastname'];
   }
}

function PageList($a, $menuid) 
{
   $closed="tree_folderclosed.png";
   $open="tree_folderopen.png";
   $mod_icon="tree_icon_mismodule.png";
   $menu_icon="tree_icon_mismenu.png";
   $yes_icon="tree_tick.png";
   $no_icon="tree_cancel.png";
   
   $tree = new HTML_TreeMenu();
   
   $qry=sprintf(misuser_qry9, $menuid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result) return 2;
   $this->num_modules=$result->RecordCount();
   if($this->num_modules==0){
      return ;
   }
   $modules = new HTML_TreeNode(array('text'=>_("Enabled Modules"),'icon'=>$mod_icon));
   while($row = $result->FetchRow()){
      $qry=sprintf(misuser_qry12, $row[0]);
      $mresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$mresult) return 4;
	   if(!($mrow = $mresult->FetchRow())){
         return 5;
      }
      $node = &$modules->addItem(new HTML_TreeNode(array('text'=>$mrow['name'],'icon'=>$mod_icon)));
      
      $qry=sprintf(misuser_qry10, $mrow['id'], $menuid);
      $mresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$mresult) return 4;
      
	   while($mrow = $mresult->FetchRow()){
         $z="misuser.php?action=disablepage&id=".$mrow['id']."&menuid=".$menuid;
         $menu=&$node->addItem(new HTML_TreeNode(array('text'=>$mrow['name'],'link'=>$z,'icon'=>$menu_icon)));
            //'link'=>"mismenu.php?action=browse&id=".$mrow['id'],)));
         if($mrow['perm_browse']=='Y'){
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Browse"),
                  'link'=>'misuser.php?action=chperm&perm=perm_browse&id='.$mrow['id'],
                  'cssClass'=>'enable','icon'=>$yes_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Browse"),'icon'=>$yes_icon)));
            }
         }
         else{
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Browse"),
                  'link'=>'misuser.php?action=chperm&perm=perm_browse&id='.$mrow['id'],
                  'icon'=>$no_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>'Browse','icon'=>$no_icon)));
            }
         }
         
         if($mrow['perm_add']=='Y'){
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Add"),
                  'link'=>'misuser.php?action=chperm&perm=perm_add&id='.$mrow['id'],
                  'icon'=>$yes_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Add"),'icon'=>$yes_icon)));
            }
         }
         else{
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Add"),
                  'link'=>'misuser.php?action=chperm&perm=perm_add&id='.$mrow['id'],
                  'icon'=>$no_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Add"),'icon'=>$no_icon)));
            }
         }
         
         if($mrow['perm_edit']=='Y'){
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Edit"),
                  'link'=>'misuser.php?action=chperm&perm=perm_edit&id='.$mrow['id'],
                  'icon'=>$yes_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Edit"),'icon'=>$yes_icon)));
            }
         }
         else{
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Edit"),
                  'link'=>'misuser.php?action=chperm&perm=perm_edit&id='.$mrow['id'],
                  'icon'=>$no_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Edit"),'icon'=>$no_icon)));
            }
         }
         
         if($mrow['perm_delete']=='Y'){
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Delete"),
                  'link'=>'misuser.php?action=chperm&perm=perm_delete&id='.$mrow['id'],
                  'icon'=>$yes_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Delete"),'icon'=>$yes_icon)));
            }
         }
         else{
             if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Delete"),
                  'link'=>'misuser.php?action=chperm&perm=perm_delete&id='.$mrow['id'],
                  'icon'=>$no_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Delete"),'icon'=>$no_icon)));
            }
         }
      }
   }
   
   $tree->addItem($modules);
   $treedisp = new HTML_TreeMenu_DHTML($tree, array('images'=>$_SESSION['VxCFG']->styleimagedir));
   $treedisp->printMenu();
}

function ExtraPageList($a, $menuid) 
{
   $closed="tree_folderclosed.png";
   $open="tree_folderopen.png";
   $mod_icon="tree_icon_mismoduled.png";
   $menu_icon="tree_icon_mismenud.png";
   $yes_icon="tree_tick.png";
   $no_icon="tree_cancel.png";
   
   $tree = new HTML_TreeMenu();
   
   
   $qry=sprintf(misadmin_misuser_qry14, $menuid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result) return 2;
   $this->num_modules=$result->RecordCount();
   if($this->num_modules==0){
      return ;
   }
   $modules = new HTML_TreeNode(array('text'=>_("Disabled Modules"),'icon'=>$mod_icon));
   while($row = $result->FetchRow()){
      $qry=sprintf(misadmin_misuser_qry12, $row[0]);
      $mresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$mresult) return 4;
	   if(!($mrow = $mresult->FetchRow())){
         return 5;
      }
      $node = &$modules->addItem(new HTML_TreeNode(array('text'=>$mrow['name'],'icon'=>$mod_icon)));
      
      $qry=sprintf(misadmin_misuser_qry13,$mrow['id']);
      $mresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$mresult) return 4;
      
	   while($mrow = $mresult->FetchRow()){
         $z="misuser.php?action=enablepage&id=".$mrow['id']."&menuid=".$menuid;
         $menu=&$node->addItem(new HTML_TreeNode(array('text'=>$mrow['name'],'link'=>$z,'icon'=>$menu_icon)));
            //'link'=>"misuser.php?action=browse&id=".$mrow['id'],)));
         /*
         if($mrow['perm_browse']=='Y'){
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Browse"),
                  'link'=>'misuser.php?action=chperm&perm=perm_browse&id='.$mrow['id'],
                  'icon'=>$yes_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Browse"),'icon'=>$yes_icon)));
            }
         }
         else{
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Browse"),
                  'link'=>'misuser.php?action=chperm&perm=perm_browse&id='.$mrow['id'],
                  'icon'=>$no_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>'Browse','icon'=>$no_icon)));
            }
         }
         
         if($mrow['perm_add']=='Y'){
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Add"),
                  'link'=>'misuser.php?action=chperm&perm=perm_add&id='.$mrow['id'],
                  'icon'=>$yes_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Add"),'icon'=>$yes_icon)));
            }
         }
         else{
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Add"),
                  'link'=>'misuser.php?action=chperm&perm=perm_add&id='.$mrow['id'],
                  'icon'=>$no_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Add"),'icon'=>$no_icon)));
            }
         }
         
         if($mrow['perm_edit']=='Y'){
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Edit"),
                  'link'=>'misuser.php?action=chperm&perm=perm_edit&id='.$mrow['id'],
                  'icon'=>$yes_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Edit"),'icon'=>$yes_icon)));
            }
         }
         else{
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Edit"),
                  'link'=>'misuser.php?action=chperm&perm=perm_edit&id='.$mrow['id'],
                  'icon'=>$no_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Edit"),'icon'=>$no_icon)));
            }
         }
         
         if($mrow['perm_delete']=='Y'){
            if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Delete"),
                  'link'=>'misuser.php?action=chperm&perm=perm_delete&id='.$mrow['id'],
                  'icon'=>$yes_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Delete"),'icon'=>$yes_icon)));
            }
         }
         else{
             if($a=='commit'){
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Delete"),
                  'link'=>'misuser.php?action=chperm&perm=perm_delete&id='.$mrow['id'],
                  'icon'=>$no_icon)));
            }
            else{
               $menu->addItem(new HTML_TreeNode(array('text'=>_("Delete"),'icon'=>$no_icon)));
            }
         }
         */
      }
   }
   
   $tree->addItem($modules);
   $treedisp = new HTML_TreeMenu_DHTML($tree, array('images'=>$_SESSION['VxCFG']->styleimagedir));
   $treedisp->printMenu();
}

function listMisuser()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(misadmin_misuser_qry10, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"3\">"._("There are no MIS users defined")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"3\">"._("There are no MIS users defined")."</td></td></table>\n";
      exit;
   }
   echo "<tr>\n<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='lname'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Surname")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Surname")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=lname\">"._("Surname")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='lname'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='fname'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Forename")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Forename")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=fname\">"._("Forename")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='fname'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
	echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
   /*
   echo "<td class=\"listdata\">"._("All Users")."</td>\n";
   echo "<td class=\"listdata\">"._("All Users")."</td>\n";
   echo "<td class=\"listdata\">";
	if($_SESSION['vxmisuser']->GetShowImages()){
      if($_SESSION['vxmisuser']->GetPerm('edit')){
	      echo "<a href=\"misuser.php?action=edit&id=0\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
      }
   }
   else{
     	if($_SESSION['vxmisuser']->GetPerm('edit')){
	      echo "<a href=\"misuser.php?action=edit&id=0\">"._("Edit")."</a>&nbsp; \n";
      }
   }
   echo "</td></tr>\n";*/

	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      $qry=sprintf(misadmin_misuser_qry5, $row['userid']);
	   $nresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$nresult) break;
      if(!($nrow = $nresult->FetchRow())) break;
      $qry=sprintf(misadmin_misuser_qry6, $nrow['employeeid']);
	   $nresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$nresult) break;
      if(!($nrow = $nresult->FetchRow())) break;
      $qry=sprintf(misadmin_misuser_qry9, $nrow['contactid']);
	   $nresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$nresult) break;
      if(!($nrow = $nresult->FetchRow())) break;
      if($c%2){
         echo "<tr class=\"listdata\">\n";
         if(isset($nrow['lastname']) && $nrow['lastname']!=''){
            echo "<td class=\"listdata\">".$nrow['lastname']."</td>\n";
         }
         else{
            echo "<td class=\"listdata\">"._("Not Set")."</td>\n";
         }
         if(isset($nrow['firstname']) && $nrow['firstname']!=''){
            echo "<td class=\"listdata\">".$nrow['firstname']."</td>\n";
         }
         else{
            echo "<td class=\"listdata\">"._("Not Set")."</td>\n";
         }
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\">\n";
         if(isset($nrow['lastname']) && $nrow['lastname']!=''){
            echo "<td class=\"listdataeven\">".$nrow['lastname']."</td>\n";
         }
         else{
            echo "<td class=\"listdataeven\">"._("Not Set")."</td>\n";
         }
         if(isset($nrow['firstname']) && $nrow['firstname']!=''){
            echo "<td class=\"listdataeven\">".$nrow['firstname']."</td>\n";
         }
         else{
            echo "<td class=\"listdataeven\">"._("Not Set")."</td>\n";
         }
         echo "<td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"misuser.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"misuser.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"misuser.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"misuser.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"misuser.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"misuser.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
