<?php
/*
efaq.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(3);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('start');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Product FAQ Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Product FAQ Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(cart_efaq_qry1, "eproductfaq")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
   case "clear" :
      addFaq();
      break;

   case "browse":
      if(isset($_REQUEST['id'])){
         browseFaq($_REQUEST['id']);
         break;
      }
      browseFaq($_POST['id']);
      break;

   case "edit" :
      editFaq($_REQUEST['id']);
      break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelFaq($_REQUEST['id']);
      }
      else{
         deleteFaq($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listFaq();
      }
      break;

   case "cfmdelete" :
      deleteFaq($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listFaqg();
      break;

   case "add" :
      insertFaq($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listFaq();
      break;

   case "commit" :
      commitFaq($_POST);
      listFaq();
      break;

   case "search" :
      searchFaq();
      break;
   
   case "sresults" :
      searchResults($_POST);
      break;
      
   case "list":
   default :
      listFaq();
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(cart_efaq_qry1);
   if(!$result) return 0;
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
  $frm["newaction"] = "";
  $frm["id"] = 0;
  $frm["targerid"] = "";
  $frm["targettype"] = "";
  $frm["when"] = "";
  $frm["postedby"] = "";
  $frm["postedtype"]="";
  $frm["subject"]="";
  $frm["content"]="";
  
  $frm['pname']="";
  
  return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(cart_efaq_qry2, $id);
   }
   else{
      $qry=sprintf(cart_efaq_qry3, $id);
   }
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();

   $frm["id"] = $row['id'];
   $frm["targerid"] = $row["targerid"];
   $frm["targettype"]=$row["targettype"];
   $frm["when"]=$row["when"];
   $frm["postedby"]=$row["postedby"];
   $frm["postedtype"]=$row["postedtype"];
   $frm["subject"]=$row["subject"];
   $frm["content"]=$row["content"];
   
   if($row['productid']==0){
      $frm['pname']="";
   }
   else{
      $qry=sprintf(cart_featureditems_qry8, $row["productid"]);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      $frm["pname"]=$row["name"];
   }
   
   return $frm;
}

function addFaq()
{
  $frm=clearForm();
  $frm["newaction"] = "add";

  include("templates/efaq.php");
}

function editFaq($id) 
{
  $frm=fillForm($id, false);
  $frm["newaction"] = "commit";

  include("templates/efaq.php");
}

function browseFaq($id) 
{
  $frm=fillForm($id, true);
  $frm["newaction"] = "browse";
  
  include("templates/efaqs.php");
}

function chkdelFaq($id)
{
  $frm=fillForm($id, false);
  $frm["newaction"] = "cfmdelete";
   
  include("templates/efaq.php");
}

function insertFaq($frm) 
{
   $qry=sprintf(cart_efaq_qry4,$frm['targerid'],$frm['targertype'],$frm['postedby'], $frm['postedtype'],
   $frm['subject'], $frm['content']);
   
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitFaq($frm) 
{
   $qry=sprintf(cart_efaq_qry5,$frm['targerid'],$frm['targertype'],$frm['postedby'], $frm['postedtype'],
   $frm['subject'], $frm['content'],$frm['id']);

  $_SESSION['VxCFG']->dbh->Execute($qry);
}

function deleteFaq($frm) 
{
   $qry=sprintf(cart_efaq_qry6, $frm["id"]);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function searchRating()
{
   $frm["newaction"] = "sresults";
   
  include("templates/ratingssearch.php");
}

function searchResults($frm)
{
}

function DateControl($a, $d, $n)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
     $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
      if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->displayex('date', $a, $n, $d);
}

function TargetTypeCombo($a, $id)
{
}

function PostedTypeCombo($a, $id)
{
}

function listFaq()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(cart_efaq_qry7, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no faqs defined")."</td></td></table>\n";
      return;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no faqs defined")."</td></td></table>\n";
      return;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='productid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Product")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Product")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=productid\">"._("Product")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='productid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='count'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Count")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Count")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=count\">"._("Count")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='count'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='average'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Average")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Average")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=average\">"._("Average")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='average'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   while($row = $result->FetchRow()){
      if($row['productid']==0){
         $pn= _("Not Set");
      }
      else{
         $qry=sprintf(cart_featureditems_qry8, $row["productid"]);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         $row = $result->FetchRow();
         $pn=$row["name"];
      }
      
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">$pn</td>";
         echo "<td class=\"listdata\">";
         $qry=sprintf(cart_ratings_qry9, $row["productid"]);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         $row = $result->FetchRow();
         echo $row["counts"];
         echo "</td><td class=\"listdata\">".$row["avgrating"]."</td>";
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">$pn</td>";
         echo "<td class=\"listdataeven\">";
         $qry=sprintf(cart_ratings_qry9, $row["productid"]);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         $row = $result->FetchRow();
         echo $row["counts"];
         echo "</td><td class=\"listdataeven\">".$row["avgrating"]."</td>";
         echo "<td class=\"listdataeven\">";
      }
      $wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"ratings.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"ratings.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"ratings.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
         echo "<a href=\"ratings.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
            echo "<a href=\"site.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
            echo "<a href=\"ratings.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
   }
   echo "</table>";
}

?>
