<?php
/*
review.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('start');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Review Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Review Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(vxcart_review_qry1, "ereview")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
   case "clear" :
      addReview();
      break;

   case "browse":
      if(isset($_REQUEST['id'])){
         browseReview($_REQUEST['id']);
         break;
      }
      browseReview($_POST['id']);
      break;

   case "edit" :
      editReview($_REQUEST['id']);
      break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelReview($_REQUEST['id']);
      }
      else{
         deleteReview($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listReview();
      }
      break;

   case "cfmdelete" :
      deleteReview($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listReview();
      break;

   case "add" :
      insertReview($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listReview();
      break;

   case "commit" :
      commitReview($_POST);
      listReview();
      break;

   case "search" :
      searchReview();
      break;
   
   case "sresults" :
      searchResults($_POST);
      break;
      
   case "list":
   default :
      listReview();
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(vxcart_review_qry1);
   if($result) return 0;
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["newaction"] = "";
   $frm["id"] = 0;
   $frm["productid"] = 0;
   $frm["postedby"] = "";
   $frm["postedtype"]="";
   $frm["postedwhen"]="";
   $frm["numreads"]=0;
   $frm["approved"]="N";
   $frm["review"]="";
   
   $frm["pname"]="";
   
  return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(cart_review_qry2, $id);
   }
   else{
      $qry=sprintf(cart_review_qry3, $id);
   }
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();

   $frm["id"] = $row['id'];
   $frm["productid"] = $row["productid"];
   $frm["postedby"]=$row["postedby"];
   $frm["postedtype"]=$row["postedtype"];
   $frm["postedwhen"]=$row["postedwhen"];
   $frm["numreads"]=$row["numreads"];
   $frm["approved"]=$row["approved"];
   $frm["review"]=$row["review"];
   
   if($row['productid']==0){
      $frm['pname']="";
   }
   else{
      $qry=sprintf(vxcart_promo_qry8, $row["productid"]);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      $frm["pname"]=$row["name"];
   }
   
   return $frm;
}

function addReview()
{
  $frm=clearForm();
  $frm["newaction"] = "add";

  include("templates/review.php");
}

function editReview($id) 
{
  $frm=fillForm($id, false);
  $frm["newaction"] = "commit";

  include("templates/review.php");
}

function browseReview($id) 
{
  $frm=fillForm($id, true);
  $frm["newaction"] = "browse";
  
  include("templates/review.php");
}

function chkdelReview($id)
{
  $frm=fillForm($id, false);
  $frm["newaction"] = "cfmdelete";
   
  include("templates/review.php");
}

function insertReview($frm) 
{
   $qry=sprintf(cart_review_qry4,$frm['productid'],$frm['postedby'],$frm['postedtype'], $frm['postedwhen'],
   $frm['numreads'], $frm['approved'],$frm['review']);
   
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitReview($frm) 
{
   $qry=sprintf(cart_review_qry5,$frm['productid'],$frm['postedby'],$frm['postedtype'], $frm['postedwhen'],
   $frm['numreads'], $frm['approved'],$frm['review'],$frm['id']);

  $_SESSION['VxCFG']->dbh->Execute($qry);
}

function deleteReview($frm) 
{
   $qry=sprintf(cart_review_qry6, $frm["id"]);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function searchRating()
{
   $frm["newaction"] = "sresults";
   
  include("templates/reviewsearch.php");
}

function searchResults($frm)
{
}

function DateControl($a, $d, $n)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
     $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
      if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->displayex('date', $a, $n, $d);
}

function TargetTypeCombo($a, $id)
{
}

function PostedTypeCombo($a, $id)
{
}

function listReview()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(cart_review_qry7, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no reviews defined")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no reviews defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='productid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Product")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Product")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=productid\">"._("Product")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='productid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='customerid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Customer")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Customer")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=customerid\">"._("Customer")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='customerid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='numreads'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Num Reads")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Num Reads")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=numreads\">"._("Num Reads")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='numreads'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   while($row = $result->FetchRow()){
      if($row['productid']==0){
         $pn= _("Not Set");
      }
      else{
         $qry=sprintf(cart_featureditems_qry8, $row["productid"]);
         $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
         $prow = $presult->FetchRow();
         $pn=$prow["name"];
      }
      $qry=sprintf(cart_review_qry8, $row["customerid"]);
		$res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      
      $qry=sprintf(cart_review_qry9,$r["contactid"]);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">$pn</td>\n";
         echo "<td class=\"listdata\">".$r["firstname"]." ".$r["lastname"]."</td>\n";
         echo "<td class=\"listdata\">".$row["numreads"]."</td>";
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">$pn</td>\n";
         echo "<td class=\"listdataeven\">".$r["firstname"]." ".$r["lastname"]."</td>\n";
         echo "<td class=\"listdataeven\">".$row["numreads"]."</td>";
         echo "<td class=\"listdataeven\">";
      }
      /*
      $qry=sprintf(vxcart_review_qry8, $row["productid"]);
      $cresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      $crow = $cresult->FetchRow();
      echo $crow["counts"];
      echo "</td><td class=\"listdata\">".$crow["avgrating"]."</td>";*/
      
      $wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"review.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"review.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"review.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
         echo "<a href=\"review.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
            echo "<a href=\"review.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
            echo "<a href=\"review.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
   }
   echo "</table>";
}

?>
