<?php
/*
dept.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/locale.php");
require_once($_SESSION['VxCFG']->libdir."/currency.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(3);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Department Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Department Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(company_dept_qry1, "departments")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addDept();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseDept($_REQUEST['id']);
         break;
      }
		browseDept($_POST['id']);
		break;

	case "edit" :
		editDept($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelDept($_REQUEST['id']);
      }
      else{
         deleteDept($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listDept($_POST['ID']);
      }
		break;

	case "cfmdelete" :
		deleteDept($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
		listDept();
		break;

	case "add" :
		insertDept($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listDept();
		break;

	case "commit" :
		commitDept($_POST);
		listDept();
		break;

   case "duplicate" :
      duplicateDept($_REQUEST['id']);
      editDept($_REQUEST['id']);
      break;
      
	case "nameindex" :
		nameIndex($id, $_POST);
		break;

   case "search" :
		searchDept();
		break;
   
   case "sresults" :
		searchResults($_POST);
		break;
      
	case "list":
	default :
		listDept();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(company_dept_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
	$frm["id"] = 0;
   $frm["deptid"] = "";
   $frm["name"] = "";
   $frm["siteid"] = "";
   $frm["annualbudget"] = "";
   $frm["headid"] = "";
   $frm["localeid"] = "";
   $frm["currencyid"] = "";
   $frm["active"] = "";
	$frm["bcname"]="";
	$frm["sitename"]="";

	return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(company_dept_qry2, $id);
   }
   else{
      $qry=sprintf(company_dept_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
	$frm["id"] = $row["id"];
	$frm["deptid"]=$row["deptid"];
	$frm["name"] = $row["name"];
	$frm["siteid"]=$row["siteid"];
	$frm["annualbudget"] = $row["annualbudget"];
	$frm["headid"] = $row["headid"];
	$frm["localeid"] = $row["localeid"];
   $frm["currencyid"] = $row["currencyid"];
   $frm["active"] = $row["active"];

   $qry=sprintf(company_site_qry12, $frm["siteid"]);
	$result=db_query($qry);
	$row = $result->FetchRow();
	$frm["sitename"]=$row["name"];

	return $frm;
}

function fillNames($fl) 
{
   $qry=sprintf(company_dept_qry6, $fl.'%');
	$result=db_query($qry);
	echo "<select name=\"index\">\n";
	while($row = $result->FetchRow()){
		$i=$row["id"];
		$l=$row["lname"];
		$f=$row["fname"];
		$n=$row["lname"] . ", " . $row["fname"];
		if($id==$boo){
			echo "<option selected value=\"$i\"> $n </option>\n";
		}
		else{
			echo "<option value=\"$i\"> $n </option>\n";
		}
	}
	echo "</select>\n";
}

function addDept()
{
	$frm=clearform();
	$frm["newaction"] = "add";
   
	include("templates/dept.php");
}

function editDept($id) 
{
	$frm=fillform($id, false);
	$frm["newaction"] = "commit";

	include("templates/dept.php");
}

function browseDept($id) 
{
	$frm=fillform($id, true);
	$frm["newaction"] = "browse";
   
	include("templates/dept.php");
}

function fillGroupDeps($id)
{
	echo "<tr><td colspan=\"2\" class=\"formdata\">"._("Dependant Groups")."</td></tr>";
	fillassignedgroups($id);
}

function fillassignedgroups($id)
{
   $qry=sprintf(company_dept_qry6, $id);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result) return;
	while($row = $result->FetchRow()){
		$idg=$row["groupid"];
		$name=$row["name"];
		echo "<tr><td colspan=\"2\" class=\"formdata\"><a href=\"group.php?action=browse&id=$idg\">$name</a></td></tr>\n";
	}
}

function insertDept($frm) 
{
	$name=$frm["name"];
   
	$query = sprintf(company_dept_qry8, $frm['name'],$frm['siteid'],$frm['annualbudget'],$frm['headid'],
      $frm['localeid'],$frm['currencyid'],$frm['active']);
   $_SESSION['VxCFG']->dbh->StartTrans();
	$_SESSION['VxCFG']->dbh->Execute($query);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=dept&err=insert");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
   
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   return $row[0];
}

function commitDept($frm) 
{
   $query = sprintf(company_dept_qry9, $frm['deptid'],$frm['name'],$frm['siteid'],$frm['annualbudget'],$frm['headid'],
      $frm['localeid'],$frm['currencyid'],$frm['active'],$frm['id']);
   $_SESSION['VxCFG']->dbh->StartTrans();
	$_SESSION['VxCFG']->dbh->Execute($query);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=dept&err=commit");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
}

function chkdelDept($id)
{
   $query = sprintf(company_dept_qry10, $id);
	$result=$_SESSION['VxCFG']->dbh->Execute($query);
	$frm["numgroups"]=db_num_rows($result);

	$query = sprintf(company_dept_qry11, $id);
	$result=$_SESSION['VxCFG']->dbh->Execute($query);
	if($row = $result->FetchRow()){
	   $frm["name"]=$row["name"];
   }
   else{
      $frm["name"]="&nbsp;";
   }
	$frm["newaction"] = "cfmdelete";
   $frm["reassign"] = "0";
   $frm["id"] = $id;
   
	include("templates/deptdel.php");
}

function deleteDept($frm)
{
	if($frm["reassign"]=="1"){
		$ndept=$frm["deptid"];
      $qry=sprintf(company_dept_qry12, $ndept, $frm['id']);
		$_SESSION['VxCFG']->dbh->Execute($qry);
	}
	else{
      $qry=sprintf(company_dept_qry13, $frm['id']);
		$_SESSION['VxCFG']->dbh->Execute($qry);
	}
   $qry=sprintf(company_dept_qry14, $frm['id']);
	$_SESSION['VxCFG']->dbh->Execute($qry);

}

function duplicateDept($id) 
{
   $frm=fillForm($id, false);
   return insertDept($frm);
}

function searchDept()
{
   $frm["newaction"] = "sresults";
   
	include("templates/deptsearch.php");
}

function searchResults($frm)
{
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "currencyid");
}

function LocaleCombo($action, $id)
{
   $a=new Locale();
   $a->Combo($action, $id, "localeid");
}

function listDept()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(company_dept_qry15, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<table class=\"listtable\">\n";
   if(db_num_rows($result)==0){
      echo "<tr><td colspan=\"2\">"._("There are no defined deparments")."</td></td></table>\n";
      exit;
   }
   
	echo "<tr><td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='siteid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Site")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Site")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=siteid\">"._("Site")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='siteid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
		   echo "<tr class=\"listdata\">\n<td class=\"listdata\">";
         if($row['name']!=""){
            echo $row['name'];
         }
         else{
            echo _("Not Set");
         }
         echo "</td>\n<td class=\"listdata\">";
         $qry=sprintf(company_site_qry12, $row['siteid']);
	      $sresult=$_SESSION['VxCFG']->dbh->Execute($qry);
         $srow = $sresult->FetchRow();
         if($srow['name']!=""){
            echo $srow['name'];
         }
         else{
            echo _("Not Set");
         }
         echo "</td>\n<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\">\n<td class=\"listdataeven\">";
         if($row['name']!=""){
            echo $row['name'];
         }
         else{
            echo _("Not Set");
         }
         echo "</td>\n<td class=\"listdataeven\">";
         $qry=sprintf(company_site_qry12, $row['siteid']);
	      $sresult=$_SESSION['VxCFG']->dbh->Execute($qry);
         $srow = $sresult->FetchRow();
         if($srow['name']!=""){
            echo $srow['name'];
         }
         else{
            echo _("Not Set");
         }
         echo "</td>\n<td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"dept.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"dept.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"dept.php?action=delete&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"dept.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"dept.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"dept.php?action=delete&id=$wibbler&offset=$offset\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
