<?php
/*
group.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/locale.php");
require_once($_SESSION['VxCFG']->libdir."/currency.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(4);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Group Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Group Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(company_group_qry1, "groups")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addGroup();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseGroup($_REQUEST['id']);
         break;
      }
		browseGroup($_POST['id']);
		break;

	case "edit" :
		editGroup($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelGroup($_REQUEST['id']);
      }
      else{
         deleteGroup($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listGroup();
      }
		break;

	case "cfmdelete" :
		deleteGroup($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
		listGroup();
		break;

	case "add" :
		insertGroup($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listGroup();
		break;

	case "commit" :
		commitGroup($_POST);
		listGroup();
		break;

   case "duplicate" :
      duplicateGroup($_REQUEST['id']);
      editGroup($_REQUEST['id']);
      break;
      
   case "search" :
		searchGroup();
		break;
   
   case "sresults" :
		searchResults($_POST);
		break;
      
	case "list":
	default :
		listGroup();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(company_group_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{  
	$frm["id"] = 0;
   $frm["deptid"] = "";
	$frm["name"] = "";
	$frm["currencyid"]="";
	$frm["localeid"]="";
	$frm["active"]="";
   $frm["numstations"]="0";
   $frm["numemployees"]="0";

	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(company_group_qry2, $id);
   }
   else{
      $qry=sprintf(company_group_qry3, $id);
   }
   
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
   $frm["deptid"] = $row["deptid"];
	$frm["name"] = $row["name"];
	$frm["currencyid"]=$row["currencyid"];
	$frm["localeid"]=$row["localeid"];
	$frm["active"]=$row["active"];
   
   $qry=sprintf(company_group_qry7, $frm["id"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   
   $frm["numstations"]=$row[0];
   $qry=sprintf(company_group_qry8, $frm["id"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["numemployees"]=$row[0];
	return $frm;
}

function addGroup()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
		
	include("templates/group.php");
}

function editGroup($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/group.php");
}

function browseGroup($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";

	include("templates/group.php");
}

function fillassignedstations($id)
{
	$qry=sprintf(company_group_qry9, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	if(!$result || $result->RecordCount()==0){
   	echo "<tr><td colspan=\"2\" class=\"formdata\">"._("There are no dependant stations.")."</td></tr>";
	}
   else{
      while($row = $result->FetchRow()){
   		$name=$row["name"];
   		$sid=$row["id"];
   		echo "<tr><td class=\"formdata\" colspan=\"2\" class=\"formdata\"><a href=\"../station/station.php?action=edit&id=$sid\">$name</a></td></tr>";
   	}
   }
}

function fillassignedusers($id)
{
	$qry=sprintf(company_group_qry10, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	if(!$result || $result->RecordCount()==0){
   	echo "<tr><td colspan=\"2\" class=\"formdata\">"._("There are no dependant users.")."</td></tr>";
   }
   else{
      while($row = $result->FetchRow()){
   		$fname=$row["fname"];
   		$lname=$row["lname"];
   		$eid=$row["id"];
   		echo "<tr><td class=\"formdata\" colspan=\"2\" class=\"formdata\"><a href=\"../users/users.php?action=edit&id=$eid\">$fname $lname</a></td></tr>";
   	}
   }
}

function chkdelGroup($id)
{
   $frm=fillForm($id, false);
   
   $frm["reassignstation"]='0';
   $frm["reassignuser"]='0';
	$frm["newaction"] = "cfmdelete";
   
	include("templates/groupdel.php");
}

function deleteGroup($frm) 
{
	if($frm["reassignstation"]=="1"){
      $qry=sprintf(company_group_qry11, $frm["id"], $frm['id']);
		$_SESSION['VxCFG']->dbh->Execute($qry);
	}
	else{
      $qry=sprintf(company_group_qry11, 0, $frm['id']);
		$_SESSION['VxCFG']->dbh->Execute($qry);
	}
   if($frm["reassignuser"]=="1"){
		$qry=sprintf(company_group_qry12, $frm["id"], $frm['id']);
		$qid = $_SESSION['VxCFG']->dbh->Execute($qry);
	}
	else{
		$qry=sprintf(company_group_qry12, 0, $frm['id']);
		$qid = $_SESSION['VxCFG']->dbh->Execute($qry);
	}

	$qry=sprintf(company_group_qry13, $frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);

}

function insertGroup($frm) 
{
   $qry=sprintf(company_group_qry14,$frm['deptid'],$frm['name'],$frm['localeid'],$frm['currencyid'],yesno(isset($frm['active'])));
   echo $qry;
   $_SESSION['VxCFG']->dbh->StartTrans();
   $_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=group&err=insert");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
   
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   return $row[0];
}

function commitGroup($frm) 
{
	$qry=sprintf(company_group_qry15,$frm['deptid'],$frm['name'],$frm['localeid'],$frm['currencyid'],yesno(isset($frm['active'])),$frm['id']);
   $_SESSION['VxCFG']->dbh->StartTrans();
   $_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=group&err=commit");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
}

function duplicateGroup($id) 
{
   $frm=fillForm($id, false);
   return insertGroup($frm);
}

function searchGroup()
{
   $frm["newaction"] = "sresults";
   
	include("templates/groupsearch.php");
}

function searchResults($frm)
{
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "currencyid");
}

function LocaleCombo($action, $id)
{
   $a=new Locale();
   $a->Combo($action, $id, "localeid");
}

function listGroup()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(company_group_qry18, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no groupd defined.")."</td></td></table>\n";
      exit;
   }
   
	echo "<tr><td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='deptid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Department")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Department")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=deptid\">"._("Department")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='deptid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";   
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
         $qry=sprintf(company_dept_qry3,$row["deptid"]);
   		$dresult=$_SESSION['VxCFG']->dbh->Execute($qry);
	   	if($drow = $dresult->FetchRow()){
		      $dn=$drow["name"];
         }
         else{
            $dn="&nbsp;";
         }
	   	echo "<tr class=\"listdata\">\n<td class=\"listdata\">".$row["name"]."</td>\n";
         echo "<td class=\"listdata\">$dn</td>\n<td class=\"listdata\">";
      }
      else{
         $qry=sprintf(company_dept_qry3,$row["deptid"]);
   		$dresult=$_SESSION['VxCFG']->dbh->Execute($qry);
	   	if($drow = $dresult->FetchRow()){
		      $dn=$drow["name"];
         }
         else{
            $dn="&nbsp;";
         }
	   	echo "<tr class=\"listdataeven\">\n<td class=\"listdataeven\">".$row["name"]."</td>\n";
         echo "<td class=\"listdataeven\">$dn</td>\n<td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"group.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"group.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"group.php?action=delete&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"group.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"group.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"group.php?action=delete&id=$wibbler&offset=$offset\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
