<?php
/*
attributes.php

Copyright (C)2005  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/attribute.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()=='' || $_SESSION['vxmisuser']->GetSortOn()!='name'){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if($_SESSION['vxmisuser']->GetFocusType()!=FOCUSIDTYPE_CONTACT){
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("Select a contact.")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(isset($_REQUEST['paction'])){
   if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_CONTACT){
      $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
   }
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_CONTACT){
         $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
         $action=$_SESSION['vxmisuser']->GetFocusAction();
         $action='list';
      }
      else{
         $action='list';
      }
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Attributes"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Attributes");
}

if($_SESSION["pageindex"]->CheckNum(product_attribute_qry1, "contactattribute")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}
$NoNavigationFlag=true;
include($_SESSION['VxCFG']->styledir."/header.php");
   
switch($action){
	case "clear" :
		addAttribute();
		break;

	case "browse":
		browseAttribute($_SESSION['vxmisuser']->GetFocusID());
		break;

	case "edit" :
      editAttribute($_REQUEST['id']);
      /*
		if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_CONTACT){
         editAttribute($_SESSION['vxmisuser']->GetFocusID());
      }
      else{
         editAttribute($_REQUEST['id']);
      }*/
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelAttribute($_REQUEST['id']);
      }
      else{
         deleteAttribute($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listAttribute();
      }
      break;  
	
   case "cfmdelete" :
      deleteAttribute($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listAttribute();
		break;

	case "add" :
		insertAttribute($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listAttribute();
		break;

	case "commit" :
		commitAttribute($_POST);
		browseAttribute($_POST['id']);
		break;

	case "list":
	default :
      //$_SESSION['vxmisuser']->ClearFocus();
		listAttribute();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   if(isset($_REQUEST['id'])){
      $qry=sprintf(product_attribute_qry1,$_SESSION['vxmisuser']->GetFocusID());
   }
   else{
      $qry=product_attribute_qry12;
   }
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"]="";
   $frm["attributeid"]="";
	$frm["name"]="";
	$frm["type"]="";
	$frm["format"]="";
	$frm["mask"]="";
	$frm["value"]="";
   $frm["pname"]=$_SESSION['vxmisuser']->GetFocusName();
   return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(contact_attribute_qry2, $id);
   }
   else{
      $qry=sprintf(contact_attribute_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();

   $frm["id"]=$row["id"];
   $frm["attributeid"]=$row["attributeid"];
	$frm["name"]=$row["name"];
	$frm["type"]=$row["type"];
	$frm["format"]=$row["format"];
	$frm["mask"]=$row["mask"];
	$frm["value"]=$row["value"];
   
   $qry=sprintf(contact_attribute_qry13, $row["attributeid"]);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
	
   $frm["cname"]=$row["firstname"]." ".$row["lastname"];
   
   return $frm;
}

function addAttribute()
{
   $frm=clearform();
	$frm["newaction"] = "add";
	$frm["id"] = 0;

	include("templates/attributes.php");
}

function editAttribute($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";
   $_REQUEST['action'] = "commit";
	include("templates/attributes.php");
}

function browseAttribute($id) 
{
   $frm=fillform($id, true);
   $frm["newaction"] = "browse";
	
	include("templates/attributes.php");
}

function chkdelAttribute($id) 
{
   $frm=fillform($id, false);
   $frm["newaction"] = "cfmdelete";
   
   include("templates/attributes.php");
}


function deleteAttributee($id) 
{
   $qry=srpintf(product_attribute_qry6, $id);
   db_query($qry);
}

function insertAttribute($frm) 
{
   $qry=sprintf(contact_attribute_qry4,$frm["attributeid"],$frm["name"],$frm["type"],$frm["format"],$frm["mask"],
	$frm["value"]);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitAttribute($frm) 
{
   $qry=sprintf(contact_attribute_qry5,$frm["attributeid"],$frm["name"],$frm["type"],$frm["format"],$frm["mask"],
	$frm["value"],$frm['id']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function TypeCombo($a, $t) 
{
   $attrib=new Attribute();
   $attrib->ComboType($a, $t);
}

function listAttribute()
{
   
	$sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   if(isset($_REQUEST['id'])){
      $qry=sprintf(contact_attribute_qry11, $_REQUEST['id']);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      $lid=$row['attributeid'];
   }
   else{
      $lid=0;
   }

   $qry=sprintf(contact_attribute_qry10, $lid, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no attributes defined.")."</td></td></table>\n";
      return;
   }
   
	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='value'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Value")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Value")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=value\">"._("Value")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='value'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";

	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">".$row['name']."</td>\n";
         echo "<td class=\"listdata\">".$row['value']."</td>\n";
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row['name']."</td>\n";
         echo "<td class=\"listdataeven\">".$row['value']."</td>\n";
         echo "<td class=\"listdataeven\">";
      }
      $wibbler=$row['id'];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"attributes.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"attributes.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"attributes.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"attributes.php?action=browse&id=$wibbler&offset=$offset\">".misc_listview."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"attributes.php?action=edit&id=$wibbler&offset=$offset\">".misc_listedit."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"attributes.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
