<?php
/*
orders.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/currency.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()=='' || $_SESSION['vxmisuser']->GetSortOn()!='dateplaced'){
   $_SESSION['vxmisuser']->SetSortOn('dateplaced');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if($_SESSION['vxmisuser']->GetFocusType()!=FOCUSIDTYPE_CUSTOMER){
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("Select a customer.")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(isset($_REQUEST['paction'])){
   if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_CUSTOMER){
      $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
   }
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_CUSTOMER){
         $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
         //$action=$_SESSION['vxmisuser']->GetFocusAction();
         $action='list';
      }
      else{
         $action='list';
      }
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Orders"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Orders");
}

if($_SESSION["pageindex"]->CheckNum(order_order_qry1, "orders")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}
$NoNavigationFlag=true;
include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addOrder();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseOrder($_REQUEST['id']);
         break;
      }
		browseOrder($_POST['id']);
		break;

	case "edit" :
		editOrder($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelOrder($_REQUEST['id']);
      }
      else{
         deleteOrder($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listOrder();
      }
		break;

	case "cfmdelete" :
		deleteOrder($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listOrder();
		break;

	case "add" :
		insertOrder($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listOrder();
		break;

	case "commit" :
		commitOrder($_POST);
		break;

   case "search" :
		searchOrder();
		break;
   
   case "sresults" :
		searchResults($_POST);
		break;
      
	case "list":
	default :
      if(isset($_POST['statusfilter'])) $sf=$_POST['statusfilter'];
      else $sf='All';
		listOrder($sf);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(order_order_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
   $frm["orderid"] = 0;
   $frm["ordernumber"] = "";
   $frm["enteredby"] = 0;
   $frm["customerid"] = "";
   $frm["deliveryaddressid"] = "";
   $frm["billingaddressid"] = "";
   $frm["statusid"] = 0;
   $frm['waitonallitems']='Y';
   $frm["dateplaced"] = "";
   $frm["daterequired"] = "";
   $frm["billeddate"] = "";
   $frm["shippeddate"] = "";
   $frm["subtotal"] = "";
   $frm["shipcost"] = "";
   $frm["tax"] = "";
   $frm["total"] = "";
   $frm["basecurrencyid"] = "";
   $frm["accountid"] = "";
   $frm["transactionid"] = "";
   $frm["shipmethodid"] = "";
	
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(order_order_qry2, $id);
   }
   else{
      $qry=sprintf(order_order_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

   $frm["id"] = $row['id'];
   $frm["orderid"] = $row["orderid"];
   $frm["ordernumber"] = $row["ordernumber"];
   $frm["enteredby"] = $row["enteredby"];
   $frm["customerid"] = $row["customerid"];
   $frm["deliveryaddressid"] = $row["deliveryaddressid"];
   $frm["billingaddressid"] = $row["billingaddressid"];
   $frm["statusid"] = $row["statusid"];
   $frm["waitonallitems"] = $row["waitonallitems"];
   $frm["dateplaced"] = $row["dateplaced"];
   $frm["daterequired"] = $row["daterequired"];
   $frm["billeddate"] = $row["billeddate"];
   $frm["shippeddate"] = $row["shippeddate"];
   $frm["subtotal"] = $row["subtotal"];
   $frm["shipcost"] = $row["shipcost"];
   $frm["tax"] = $row["tax"];
   $frm["total"] = $row["total"];
   $frm["basecurrencyid"] = $row["basecurrencyid"];
   $frm["ledgerentryid"] = $row["ledgerentryid"];
   $frm["transactionid"] = $row["transactionid"];
   $frm["shippingid"] = $row["shippingid"];
   
   $qry=sprintf(order_approval_qry13, $frm["id"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   $frm["paytype"]=$row["bank"];
   $frm["cardnumber"]=$row["cardnumber"];
   $frm["expdate"]=$row["expdate"];
   
   /*
   $frm["shipcarrierid"]=row['shipperid'];
	$frm["shipamount"]="";
   $frm["trackingnumber"]="";
   */
	return $frm;
}

function addOrder()
{
	$frm=clearForm();
	$frm["newaction"] = "add";

	include("templates/orders.php");
}

function editOrder($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/orders.php");
}

function browseOrder($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/orders.php");
}

function chkdelOrder($id)
{
   $frm["id"]=$id; 
	$frm["newaction"] = "cfmdelete";
   
	include("templates/orders.php");
}

function insertOrder($frm) 
{
	$qry=sprintf(order_order_qry16,$frm["orderid"],
   $frm["ordernumber"],
   $frm["enteredby"],
   $frm["customerid"],
   $frm["statusid"],
   $frm['waitonallitems'],
   $frm["dateplaced"],
   $frm["daterequired"],
   $frm["billeddate"],
   $frm["shippeddate"],
   $frm["subtotal"],
   $frm["shipcost"],
   $frm["tax"],
   $frm["total"],
   $frm["basecurrencyid"],
   $frm["ledgerentryid"],
   $frm["transactionid"],
   $frm["shipmethodid"]);
   $_SESSION['VxCFG']->dbh->StartTrans();
	$_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=orders&err=insert");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
}

function commitOrder($frm) 
{
   $qry=sprintf(order_order_qry17,$frm["orderid"],
   $frm["ordernumber"],
   $frm["enteredby"],
   $frm["customerid"],
   $frm["statusid"],
   $frm['waitonallitems'],
   $frm["dateplaced"],
   $frm["daterequired"],
   $frm["billeddate"],
   $frm["shippeddate"],
   $frm["subtotal"],
   $frm["shipcost"],
   $frm["tax"],
   $frm["total"],
   $frm["basecurrencyid"],
   $frm["ledgerentryid"],
   $frm["transactionid"],
   $frm["shipmethodid"],$frm['id']);
   $_SESSION['VxCFG']->dbh->StartTrans();
	$_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=orders&err=commit");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
}

function deleteOrder($frm) 
{
}

function searchOrder()
{
   $frm["newaction"] = "sresults";
   
	include("templates/ordersearch.php");
}

function searchResults($frm)
{
}

function ItemsTable($action, $id)
{
   //$a=new Address();
   //$a->FillTable($action, $id, "Address");
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "Address");
}

function fillBankCombo($a, $id)
{
   $b=new BankDetails();
   $b->Combo($a, $id, "bankid");
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "currencyid");
}

function LocaleCombo($action, $id)
{
   $a=new Locale();
   $a->Combo($action, $id, "localeid");
}

function EnteredBy($action, $id)
{
   $qry=sprintf(order_approval_qry15, $id);
   $res=$_SESSION['VxCFG']->dbh->Execute($qry);
   $r = $res->FetchRow();
   
   $qry=sprintf(order_approval_qry16, $r['contactid']);
   $res=$_SESSION['VxCFG']->dbh->Execute($qry);
   $r = $res->FetchRow();
   echo $r["firstname"]." ".$r["lastname"];
}

function Customer($action, $id)
{
   $qry=sprintf(order_approval_qry9, $id);
   $res=$_SESSION['VxCFG']->dbh->Execute($qry);
   $r = $res->FetchRow();
      
   $qry=sprintf(order_approval_qry10,$r["contactid"]);
   $res=$_SESSION['VxCFG']->dbh->Execute($qry);
   $r = $res->FetchRow();
      
   echo $r["firstname"]." ".$r["lastname"];
}

function AccountCombo($a, $id) 
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function StatusCombo($a, $id)
{
   if($a=="commit" || $a=="add"){
      echo "<select name=\"statusid\">\n";
      if($id==0){
         echo "<option selected value='0'>Not Set</option>\n";
      }
      else{
         echo "<option value='0'>Not Set</option>\n";
      }
      $qry=sprintf(order_order_qry14);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      while($row = $result->FetchRow()){
         if($row["id"]==$id){
            echo "<option selected value=\"".$row["id"]."\">".$row["name"]."</option>\n";
         }
         else{
            echo "<option value=\"".$row["id"]."\">".$row["name"]."</option>\n";
         }
      }
      echo "</select>\n";
   }
   else{
      $qry=sprintf(order_order_qry15, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo $row["name"];
      }
      else{
         echo _("Not Set");
      }
   }
}

function StatusFormCombo($a, $id)
{
   echo "<select onChange=\"this.form.submit();\" name=\"statusfilter\">\n";
   if($id=='All'){
      echo "<option selected value='All'>All</option>\n";
   }
   else{
      echo "<option value='All'>All</option>\n";
   }
   $qry=sprintf(order_order_qry14);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   while($row = $result->FetchRow()){
      if($row["id"]==$id){
         echo "<option selected value=\"".$row["id"]."\">".$row["name"]."</option>\n";
      }
      else{
         echo "<option value=\"".$row["id"]."\">".$row["name"]."</option>\n";
      }
   }
   echo "</select>\n";
}

function orderNumber($orderid)
{
   return sprintf(date('y').'%010d', $orderid);
}

function OrderItems($orderid)
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();

   echo "<table class=\"listtable\">\n";
   $qry=sprintf(order_approval_qry6, $orderid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      exit;
   }
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='partnumber'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Part No")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Part No")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=partnumber\">"._("Part No")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='parnumber'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='stocklocation'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Location")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Location")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=stocklocation\">"._("Location")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='stocklocation'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='description'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Description")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Description")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=description\">"._("Description")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='description'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \">"._("Quantity")."</td>\n";
   echo "</tr>\n";
   
   while($row = $result->FetchRow()){
      $qry=sprintf(warehouse_stockpick_qry7, $row['productid']);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$res) continue;
      if($res->RecordCount()==0) continue;
      if(!($r = $res->FetchRow())) continue;
      echo "<tr><td class=\"listdata\">";
      if(isset($r["partnumber"])){
         echo $r["partnumber"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n<td class=\"listdata\">";
      if(isset($r["stocklocation"]) && $r["stocklocation"]!=''){
         echo $r["stocklocation"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n";
      
      echo "<td class=\"listdata\">".$r["description"]."</td>\n";
      echo "<td class=\"listdata\">".$row["quantity"]."</td>\n";
      echo "</tr>\n";
   }
   echo "</table>\n";
}

function listOrder($statusfilter='All')
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   if($statusfilter=='All'){
      $qry=sprintf(order_order_qry20, $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID(), $sorton, $sortorder);
   }
   else{
      $qry=sprintf(order_order_qry21, $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID(), $statusfilter, $sorton, $sortorder);
   }
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<form action=\"".$_SERVER['PHP_SELF']."\" method=\"POST\">\n";
   $_REQUEST['action']="list";
   
   //echo "<input type=\"hidden\" name=\"statusfilter\" value=\"$statusfilter\">\n";
   echo "<table class=\"listtable\">\n";
   echo "<tr>\n<td class=\"alphaselect\" align=\"left\">"._("Status Filter ");   
   StatusFormCombo("commit", $statusfilter);
   echo "&nbsp;";
   echo "</td>\n<td class=\"alphaselect\" colspan=\"4\">&nbsp</td>\n</tr>\n";
   
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no orders defined")."</td></td></table>\n";
      exit;
   }
   
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no orders defined")."</td></td></table>\n";
      exit;
   }
   
	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='dateplaced'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Date")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Date")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=dateplaced\">"._("Date")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='dateplaced'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='ordernumber'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Order Number")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Order Number")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=ordernumber\">"._("Order Number")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='ordernumber'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='status'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Status")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Status")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=status\">"._("Status")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='status'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">".$row["dateplaced"]."</td>\n";
         echo "<td class=\"listdata\">".$row["ordernumber"]."</td>\n";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row["dateplaced"]."</td>\n";
         echo "<td class=\"listdataeven\">".$row["ordernumber"]."</td>\n";
      }
      $qry=sprintf(order_approval_qry9, $row["customerid"]);
		$res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      
      $qry=sprintf(order_approval_qry10,$r["contactid"]);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      if($c%2){
         echo "<td class=\"listdata\">".$r["firstname"]." ".$r["lastname"]."</td>\n";
      }
      else{
         echo "<td class=\"listdataeven\">".$r["firstname"]." ".$r["lastname"]."</td>\n";
      }
      
      $qry=sprintf(order_order_qry15,$row["statusid"]);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      if($c%2){
         echo "<td class=\"listdata\">".$r["name"]."</td>\n";
      	echo "<td class=\"listdata\">";
      }
      else{
         echo "<td class=\"listdataeven\">".$r["name"]."</td>\n";
      	echo "<td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"orders.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"orders.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"orders.php?action=delete&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"orders.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"orders.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"orders.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
