<?php
/*
emp.php

Copyright (C)2004 Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
require_once("../vxmis.php"); 
require_once($_SESSION['VxCFG']->libdir."/timedate.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("End of Day Summary"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("End of Day Summary");
}

if(!isset($start_time)){
   $start_ts=& new TimeDate();
   $start_ts->midnight();
   $start_time=$start_ts->ansidate();
   $nice_start_time=$start_ts->displayts();
}

if(!isset($end_time)){
   $end_ts=& new TimeDate();
   $result = $_SESSION['VxCFG']->dbh->Execute(login_qry1);
   $row=$result->FetchRow();
   $end_ts->Set($row[0]);
   $end_time=$end_ts->ansidate();
   $nice_end_time=$end_ts->displayts();
}

include($_SESSION['VxCFG']->styledir."/header.php");
$_SESSION['vxmisuser']->SetTab(2);
include("templates/employee.php");
include($_SESSION['VxCFG']->styledir."/footer.php");
   
exit();
   
function EmployeeSummary($start_time, $end_time)
{
   $qry=sprintf(daily_emp_qry1, $start_time, $end_time);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result){
      return;
   }
   while($row = $result->FetchRow()){
      echo "<tr><td class=\"replistheading\" colspan=\"2\"><b><i>";
      echo $row["fname"] . " " . $row["lname"] . " (" . $row["employeenumber"] . ")";
      echo "</i></b></td></tr>\n<tr><td class=\"replistdata\">"._("Sales")."</td><td>";
      echo $row["sale_count"];
      echo "</td></tr><td class=\"replistdata\">"._("Value")."</td><td>\n";
      EmployeeValues($start_time, $end_time, $row[0]);
      echo "</td></tr><tr><td class=\"replistdata\">"._("No Sales")."</td><td>\n";
      EmployeeLog($start_time, $end_time, $row[0], "9");
      echo "</td></tr><tr><td class=\"replistdata\">"._("Void Sales")."</td><td>\n";
      EmployeeLog($start_time, $end_time, $row[0], "10");
      echo "</td></tr><tr><td class=\"replistdata\">"._("Logins")."</td><td>\n";
      EmployeeLog($start_time, $end_time, $row[0], "3");
      echo "</td></tr><tr><td class=\"replistdata\">"._("Pay In")."</td><td>\n";
      Adjustments($start_time, $end_time, $row[0], "2");
      echo "</td></tr><tr><td class=\"replistdata\">"._("Pay Out")."</td><td>\n";
      Adjustments($start_time, $end_time, $row[0], "3");
      echo "</td></tr>";
   }
}

function EmployeeValues($start_time, $end_time, $emp) 
{
   $qry=sprintf(daily_emp_qry2, $start_time, $end_time, $emp);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){
      echo "$row[0]";
   }
   else{
      echo "&nbsp;";
   }
}

function EmployeeLog($start_time, $end_time, $emp, $action) 
{
   $qry=sprintf(daily_emp_qry3, $start_time, $end_time, $action, $emp);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){
      echo $row[0];
   }
}

function Adjustments($start_time, $end_time, $emp, $type)
{
   $qry=sprintf(daily_emp_qry4, $start_time, $end_time, $type, $emp);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){
      if($row[0]!=0)
         echo $row[0];
      else
         echo "0.00";
   }
}

function printSummary($start_time, $end_time)
{
   /*
   $pdf = new PDFReport('P','pt','A4');
   $pdf->Watermark("Sample PDF");
   $pdf->Title("Today's Breakdown", "centre", "h1");
   $pdf->SubTitle("Summary","centre", "h3");
   $cols=array("Type"=>80, "Count"=>50, "Value"=>50);
   $pdf->addCols( $cols);
   $cols=array("Type"=>"L", "Count"=>"R", "Value"=>"R");
   $pdf->addLineFormat($cols);
   $y=50;
   */
   $qry=sprintf(daily_summary_qry1, $start_time, $end_time);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){
      //$line = array("Type"=>"Total Transactions", "Count"=>"$row[0]");
   }
   $qry=sprintf(daily_summary_qry2, $start_time, $end_time);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){
      if($row[0]){
         //array_push($line, "Value"=>"$row[0]");
      }
      else{
         //array_push($line, "Value"=>"0.00");
      }
      //$size = $pdf->addLine($y, $line);
      //$y+=$size + 1;
   }
   
   $qry=sprintf(daily_summary_qry3, $start_time, $end_time);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){
      //$line = array("Type"=>"Total Returns", "Count"=>$row[0]");
   }
   
   $qry=sprintf(daily_summary_qry4, $start_time, $end_time);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){
      if($row[0]){
         //array_push($line, "Value"=>"$row[0]");
      }
      else{
         //array_push($line, "Value"=>"0.00");
      }
      //$size = $pdf->addLine($y, $line);
      //$y+=$size + 1;
   }
   
   $qry=sprintf(daily_summary_ry5, $start_time, $end_time);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){
      //$line = array("Type"=>"Total No Sales", "Count"=>"$row[0]", "Value"=>"");
      //$size = $pdf->addLine($y, $line);
      //$y+=$size + 1;
   }
   
   $qry=sprintf(daily_summary_qry6, $start_time, $end_time);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){  
      //$line = array("Type"=>"Total Voide", "Count"=>"$row[0]", "Value"=>"");
      //$size = $pdf->addLine($y, $line);
      //$y+=$size + 1;
   }   
}
?>
