<?php
/*
emp.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/bank.php");
require_once($_SESSION['VxCFG']->libdir."/contact.php");
require_once($_SESSION['VxCFG']->libdir."/createmod.php");
require_once($_SESSION['VxCFG']->libdir."/image.php");
require_once($_SESSION['VxCFG']->libdir."/memo.php");
require_once($_SESSION['VxCFG']->libdir."/org.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['siteid'])){
   $action='sitechange';
}
else if(isset($_REQUEST['deptid'])){
   $action='deptchange';
}
else if(isset($_REQUEST['groupid'])){
   $action='groupchange';
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if($action=='list'){
   $_SESSION['vxmisuser']->ClearFocus();
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Employee Administration"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Employee Administration");
}

if(isset($_REQUEST['paction'])){
}

if($_SESSION["pageindex"]->CheckNum(employee_emp_qry1, "employee")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

if(isset($_FILES['reffile'])){
   insertimage();
}

if(isset($_POST['memoadd'])){

   $frm=fillForm($frm['id'], false);
   $frm["newaction"] = "memoadd";
   include($_SESSION['VxCFG']->styledir."/header.php");
   include("templates/emp.php");
   include($_SESSION['CFG']->templatedir."/footer.php");
   exit;
}

switch($action){
  case "clear" :
    addEmp();
    break;

  case "browse":
      if(isset($_REQUEST['id'])){
         browseEmp($_REQUEST['id']);
         break;
      }
    browseEmp($_POST['id']);
    break;

  case "edit" :
    editEmp($_REQUEST['id']);
    break;

  case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelEmp($_REQUEST['id']);
      }
      else{
         deleteEmp($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listEmp();
      }
    break;

  case "cfmdelete" :
    deleteEmp($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
    listEmp();
    break;

  case "add" :
    insertEmp($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
    listEmp();
    break;

  case "commit" :
    commitEmp($_POST);
    listEmp();
    break;
      
   case "memocommit" :
      commitMemo($_POST);
      editEmp($frm['id']);
      break;
      
   case 'sitechange':
      sitechange($_POST);
      break;
      
   case 'deptchange':
      deptchange($_POST);
      break;
      
   case 'groupchange':
      groupchange($_POST);
      break;
      
   case "list":
   default :
      $_SESSION['vxmisuser']->ClearFocus();
      listEmp();
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(employee_emp_qry1);
   if(!$result) return 0;
  if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $_SESSION['vxmisuser']->ClearFocus();
   $frm["id"] = "";
   $frm["employeeid"] = "";
   $frm["employeenumber"] = "";
   $frm["groupid"] = "";
   $frm["contactid"] =0;
   $frm["startdate"] = "";
   $frm["enddate"] = "";
   $frm["titleid"] = 0;
   $frm["fname"] = "not set";
   $frm["lname"] = "not set";
   $frm["sex"] = "m";
   $frm["dob"] = "";
   $frm["addressid"] = "";
   $frm["jobdesc"] = "";
   $frm["imageid"] = "";
   $frm["payid"] = "";
   $frm["annualpay"] = "";
   $frm["holidayentitlementid"] =0;
   $frm["holidaytakenid"] = 0;
   $frm["taxcode"] = "";
   $frm["nicode"] = "";
   $frm["ninumber"] = "";
   $frm["prevtax"] = "";
   $frm["prevpay"] = "";
   $frm["bankid"] = "";
   $frm["memoid"] = "";
   
   $frm["userid"]="";
   
   $frm["c_id"] = 0;
   $frm["c_contactid"] = 0;
   $frm["c_contactdetailsid"] = 0;
   $frm["c_ownerid"] = 0;
   $frm["c_addressid"] = 0;
   $frm["c_imageid"] = 0;
   $frm["c_titleid"] = 0;
   $frm["c_firstname"] = "";
   $frm["c_lastname"] = "";
   $frm["c_givenname"] = "";
   $frm["c_middleinitial"] = "";
   $frm["c_suffix"] = "";
   $frm["c_birthdate"] = "";
   $frm["c_lastcontact"] = "";
   $frm["c_timezone"] = "";
   $frm["c_private"] = "";
   $frm["c_memoid"] = 0;
   
   $frm["c_homephone"] = "";
   
   $frm["bankid"]=0;
   $frm["bankaccountid"]=0;
   $frm["bankaccount"]="";
   $frm["bankname"]="";
   
  return $frm;
}

function fillForm($id, $bOffset)
{
  if($bOffset){
      $qry=sprintf(employee_emp_qry2, $id);
   }
   else{
      $qry=sprintf(employee_emp_qry3, $id);
   }
  $result=$_SESSION['VxCFG']->dbh->Execute($qry);
  $row = $result->FetchRow();

   $frm["id"] = $row["id"];
   $frm["employeeid"] = $row["employeeid"];
   $frm["employeenumber"] = $row["employeenumber"];
   $frm["contactid"] = $row["contactid"];
   $frm["groupid"] = $row["groupid"];
   $frm["startdate"] = $row["startdate"];
   $frm["enddate"] = $row["enddate"];
   $frm["gender"] = $row["gender"];
   $frm["jobdesc"] = $row["jobdesc"];
   $frm["payid"] = $row["payid"];
   $frm["annualpay"] = $row["annualpay"];
   $frm["holidayentitlementid"] = $row["holidayentitlementid"];
   $frm["holidaytakenid"] = $row["holidaytakenid"];
   $frm["taxcode"] = $row["taxcode"];
   $frm["nicode"] = $row["nicode"];
   $frm["ninumber"] = $row["ninumber"];
   $frm["prevtax"] = $row["prevtax"];
   $frm["prevpay"] = $row["prevpay"];
   $frm["bankid"] = $row["bankid"];

   $qry=sprintf(employee_emp_qry6, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){
      $frm["userid"]=$row["id"];
   }
   else{
      $frm["userid"]=0;
   }
   $qry=sprintf(employee_emp_qry14, $frm["groupid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["groupname"]=$row["name"];
   
   if($bOffset){
      $qry=sprintf(contact_contact_qry2, $frm["contactid"], $_SESSION['vxmisuser']->GetEmployee());
   }
   else{
      $qry=sprintf(contact_contact_qry3, $frm["contactid"]);
   }
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["c_id"] = $row["id"];
   $frm["c_contactid"] = $row["contactid"];
   $frm["c_contactdetailsid"] = $row["contactdetailsid"];
   $frm["c_ownerid"] = $row["ownerid"];
   $frm["c_addressid"] = $row["addressid"];
   $frm["c_imageid"] = $row["imageid"];
   $frm["c_titleid"] = $row["titleid"];
   $frm["c_firstname"] = $row["firstname"];
   $frm["c_lastname"] = $row["lastname"];
   $frm["c_givenname"] = $row["givenname"];
   $frm["c_middleinitial"] = $row["middleinitial"];
   $frm["c_suffix"] = $row["suffix"];
   $frm["c_birthdate"] = $row["birthdate"];
   $frm["c_lastcontact"] = $row["lastcontact"];
   $frm["c_timezone"] = $row["timezone"];
   $frm["c_private"] = $row["private"];
   $frm["c_memoid"] = $row["memoid"];
   
   $qry=sprintf(employee_emp_qry23, $frm["c_contactdetailsid"]);
   $row = $result->FetchRow();
   $frm["c_homephone"] = $row['data'];
   
   $qry=sprintf(employee_emp_qry17, $frm["bankid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result){
      $frm["bankid"]=0;
      $frm["bankaccountid"]=0;
      $frm["bankaccount"]="";
      $frm["bankname"]="";
   }
   else{
      if($result->RecordCount()==0){
         $frm["bankid"]=0;
         $frm["bankaccountid"]=0;
         $frm["bankaccount"]="";
         $frm["bankname"]="";
      }
      else{
         $row = $result->FetchRow();
         $frm["bankaccountid"]=$row["id"];
         $frm["bankid"]=$row["bankid"];
         $frm["bankaccount"]=$row["bankaccount"];
         $frm["bankname"]=$row["bankname"];
      }
   }
   
   $_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_EMPLOYEE);
   $_SESSION['vxmisuser']->SetFocusID($row["$id"]);   
   $_SESSION['vxmisuser']->SetFocusName($frm["c_firstname"]." ".$frm["c_lastname"]);

  return $frm;
}

function addEmp()
{
  $frm=clearForm();
  $frm["newaction"] = "add";
  include($_SESSION['VxCFG']->styledir."/header.php");
  include("templates/emp.php");
}

function editEmp($id) 
{
   $frm=fillForm($id, false);
   $frm["newaction"] = "commit";
   include($_SESSION['VxCFG']->styledir."/header.php");
   include("templates/emp.php");
}

function browseEmp($id) 
{
   $frm=fillForm($id, true);
   $frm["newaction"] = "browse";
   include($_SESSION['VxCFG']->styledir."/header.php");
   include("templates/emp.php");
}


function chkdelEmp($id)
{
   $frm=fillForm($id, false);
   $frm["newaction"] = "cfmdelete";
   $frm["deletion"] = "0";
   $frm["addressdel"] = "0";
   include($_SESSION['VxCFG']->styledir."/header.php");
   include("templates/empdel.php");
}

function deleteEmp($frm) 
{
   if($frm['deletion']==0){
      $sdate=$frm['enddateyear']."-".$frm['enddatemonth']."-".$frm['enddateday'];
   }
   else{
      if($frm['addressdel']==1){
         $qry=sprintf(employee_emp_qry9, $frm['addressid']);
         $_SESSION['VxCFG']->dbh->Execute($qry);
      }
      $qry=sprintf(employee_emp_qry10, $frm['id']);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
}

function insertEmp($frm)
{
   /*
   if($frm["c_homephone"]==""){
      echo "<table class=\"formtable\">\n<tr>\n<td class=\"formdata\">A phone number must be supplied.</td>\n</tr>\n</table>\n";
      return;
   }*/
   
   $a=new Address();
   $a->SetFromForm($frm);
   $adid=$a->Add();
   
   $sdate=$frm['startdateyear']."-".$frm['startdatemonth']."-".$frm['startdateday'];
   $edate="1971-01-01";
   $dob=$frm['c_birthdateyear']."-".$frm['c_birthdatemonth']."-".$frm['c_birthdateday'];
   
   $qry=sprintf(employee_emp_qry18,$frm['bankid'],$frm['bankname'],$frm["bankaccount"]);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $bid=$row[0];
   
   // insert contactdetail is set
   $qry=sprintf(employee_emp_qry24,$frm['c_homephone']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $cdid=$row[0];
   $qry=sprintf(employee_emp_qry25,$cdid,$cdid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   /* insert image
   if($frm['c_imageid']!=""){
   }
   else{
   }
   */
   $imageid=0;
   
   // insert contact
   $qry=sprintf(employee_emp_qry21,$cdid,0,$adid,$imageid,$frm["c_titleid"], $frm['c_firstname'],$frm['c_lastname'],$frm['c_givenname'],
      $frm['c_middleinitial'],$frm['c_suffix'],$dob,$frm['c_lastcontact'],$frm['c_timezone'],'U',$frm['c_memoid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);

   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $contactid=$row[0];
   $qry=sprintf(employee_emp_qry22,$contactid,$contactid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   // insert employee
   $qry=sprintf(employee_emp_qry11, $frm['employeenumber'],$frm['groupid'],$contactid,$sdate,$edate,$frm['gender'],
   $frm['jobdesc'],$frm['payid'],$frm['annualpay'],$frm["holidayentitlementid"],$frm["holidaytakenid"],$frm['taxcode'],
   $frm['nicode'],$frm['ninumber'],$frm['prevtax'],$frm['prevpay'],$bid);
   
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $empid=$row[0];
   $qry=sprintf(employee_emp_qry26,$empid,$contactid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
}

function commitEmp($frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
   $aid=$frm['addressid'];
   $a->Commit($aid);
   
   $sdate=$frm['startdateyear']."-".$frm['startdatemonth']."-".$frm['startdateday'];
   $edate="1971-01-01";
   $dob=$frm['c_birthdateyear']."-".$frm['c_birthdatemonth']."-".$frm['c_birthdateday'];

   $qry=sprintf(employee_emp_qry19,$frm['bankid'],$frm['bankname'],$frm["bankaccount"],$frm['bankaccountid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
  
   $qry=sprintf(employee_emp_qry12, $frm['employeeid'],$frm['employeenumber'],$frm['groupid'],$frm['contactid'],
   $sdate,$edate,$frm['gender'],$frm['jobdesc'],$frm['payid'],$frm['annualpay'],$frm["holidayentitlementid"],
   $frm["holidaytakenid"], $frm['taxcode'],$frm['nicode'],$frm['ninumber'],$frm['prevtax'],$frm['prevpay'],
   $frm['bankaccountid'],$frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   $qry=sprintf(employee_emp_qry20, 0,$frm["c_titleid"], $frm['c_firstname'],$frm['c_lastname'],$frm['c_givenname'],
   $frm['c_middleinitial'],$frm['c_suffix'],$dob,$frm['c_lastcontact'],$frm['c_timezone'],'U',$frm['c_memoid'],$frm['id']);
   
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function sitechange($frm)
{
   
}

function deptchange($frm)
{
}

function groupchange($frm)
{
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "Address");
}

function DateControl($a, $d, $n)
{
   $td=new TimeDate();
   /*
   if($a=="commit" || $a=="add"){
     $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
      if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{*/
      $td->parse($d);
   //}
   $td->datecontrol($a, $n);
   //$td->displayex('date', $a, $n, $d);
}

function DateControlRanged($a, $d, $n)
{
   $td=new TimeDate();
   /*
   if($a=="commit" || $a=="add"){
     $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
      if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{*/
      $td->parse($d);
   //}
   $td->datecontrol_ranged($a, $n, 65, 16);
}

function ImageView($action, $id)
{
   $i=new Image();
   $i->Fill($id);
   $i->SetWidth($_SESSION['vxmisuser']->GetDefaultImageX());
   $i->SetHeight($_SESSION['vxmisuser']->GetDefaultImageY());
   $i->View($action, $id, "Image");
   //echo "<a href=\"javascript:popWindow('".$_SESSION["VxCFG"]->styledir."/imgpopup.php','imgpop','reffile')\">Cunt</a>\n";
   /*
   echo "<input class=\"help\" type=\"image\" height=\"24\" width=\"24\"";
   echo "src=\"".$_SESSION['VxCFG']->styleimagedir."/icon_help.png\" name=\"test\"";
   echo "<onclick=\"popWindow('".$_SESSION["VxCFG"]->styledir."/imgpopup.php','imgpop','reffile')\">\n";*/
}

function BankDetails($action, $id)
{
   $b=new BankDetails();
   //$b->Fill($id);
   $b->Combo($action, $id, "bankid");
}

function PayGradeCombo($action, $id)
{
}

function MemoList($action, $id)
{
   $m=new Memo();
   $m->FillList($action, $id);
}

function addMemo($frm)
{
   $m=new Memo();
   $m->SetFromForm($frm);
   $m->Add();
}

function commitMemo($frm)
{
   $m=new Memo();
   $m->SetFromForm($frm);
   $m->Commit();
}

function fillUserTable($a, $id)
{
   $qry=sprintf(employee_emp_qry16, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();

   $logintypeid=$row["logintypesid"];
   
   $qry=sprintf(employee_emp_qry27, $logintypeid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $login=$row["ident"];
   $password=$row["data"];
   
   $qry=sprintf(employee_emp_qry28, $logintypeid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $passivelogin=$row["data"];
   
   $qry=sprintf(employee_emp_qry29, $logintypeid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $bclogin=$row["data"];
   
   echo "<fieldset>\n<legend>"._("User Entry")."</legend>\n<table>\n";
   echo "<tr>\n";
   echo "<td class=\"formlabel\">"._("login")."</td>\n";
   echo "<td class=\"formdata\">\n";
   entry($a, "login", 22, 16, $login);
   echo "</td class=\"formdata\">\n";
   echo "</tr>\n";

   echo "<tr>\n";
   echo "<td class=\"formlabel\">"._("password")."</td>\n";
   echo "<td class=\"formdata\">\n";
   pentry($a, "password", 22, 16, $password, "password");
   echo "</td>\n";
   echo "</tr>\n";
  
   echo "<tr>\n";
   echo "<td class=\"formlabel\">"._("passive login")."</td>\n";
   echo "<td class=\"formdata\">\n";
   entry($a, "passivelogin", 22, 10, $passivelogin);
   echo "</td>\n";
   echo "</tr>\n";
  
   echo "<tr>\n";
   echo "<td class=\"formlabel\">"._("barcode login")."</td>\n";
   echo "<td class=\"formdata\">\n";
   entry($a, "userdata", 22, 10, $bclogin);
   echo "</td>\n</tr></table>\n</fieldset>\n";
}

function insertImage() 
{
   $size = getimagesize($_FILES['reffile']['tmp_name']);
   $w=$size[0];
   $h=$size[1];
   
   //$owner=fileowner($_SERVER['PHP_SELF']);
   
   if($frm['type']==BHSQL_IMAGEDATA_PERSON){
      if(move_uploaded_file($_FILES['reffile']['tmp_name'], $_SESSION['VxCFG']->relpeopleimg .'/'. $_FILES['reffile']['name'])){
         $f='/people_images/'.$_FILES['reffile']['name'];
      }
      else{
         return;
      }
   }
   else{
      if(move_uploaded_file($_FILES['reffile']['tmp_name'], $_SESSION['VxCFG']->relprodimg .'/'. $_FILES['reffile']['name'])){
         $f='/product_images/'.$_FILES['reffile']['name'];
      }
      else{
         return;
      }
   }
   $qry=sprintf(image_qry5, $frm['type'],$f,$w,$h,$frm['bbp'],$frm['scale']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function listEmp()
{
   include($_SESSION['VxCFG']->styledir."/header.php");
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(employee_emp_qry13, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"4\">"._("There are no employees defined")."</td></tr></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"4\">"._("There are no employees defined")."</td></tr></table>\n";
      exit;
   }
   
   //echo "<tr>\n<td class=\"listcombo\" colspan=\"2\"><table class=\"listcombo\">\n<tr>\n";
   //echo "<td class=\"listcombo\">";
   //echo "</td>\n</tr>\n</table>\n</td>\n</tr>\n";
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='lastname'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Surname")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Surname")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=lastname\">"._("Surname")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='lastname'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='firstname'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Forename")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Forename")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=firstname\">"._("Forename")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='firstname'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='groupid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Group")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Group")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=groupid\">"._("Group")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='group'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";

   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   while($row = $result->FetchRow()){
      $gid=$row["groupid"];
      $qry=sprintf(employee_emp_qry14, $row['groupid']);
      $nresult=db_query($qry);
      $nrow=$nresult->FetchRow();
      $gname=$nrow["name"];
      
      $qry=sprintf(employee_emp_qry15, $row['contactid']);
      $nresult=db_query($qry);
      $nrow = $nresult->FetchRow();
      if($nrow["firstname"]==""){
         $nrow["firstname"]="&nbsp;";
      }
      if($nrow["lastname"]==""){
         $nrow["lastname"]="&nbsp;";
      }
      $n=$nrow["firstname"]." ".$nrow["lastname"];
      
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">".$nrow["lastname"]."</td>\n";
         echo "<td class=\"listdata\">".$nrow["firstname"]."</td>\n";
         echo "<td class=\"listdata\">$gname</td>\n";
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$nrow["lastname"]."</td>\n";
         echo "<td class=\"listdataeven\">".$nrow["firstname"]."</td>\n";
         echo "<td class=\"listdataeven\">$gname</td>\n";
         echo "<td class=\"listdataeven\">";
      }
      $wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"emp.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"emp.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"emp.php?action=delete&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
        echo "<a href=\"emp.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"emp.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"emp.php?action=delete&id=$wibbler&offset=$offset\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
   }
   echo "</table>";
}

?>
