<?php 

function WeekControl($w=1)
{
   echo "<select name=\"firstweekofyear\">\n";
   for($i=1; $i < 53; $i++){
      if($i==$w){
         echo "<option value=\"$i\" selected>$i</option>\n";
      }
      else{
         echo "<option value=\"$i\">$i</option>\n";
      }
   }
   echo "</select>\n";
}

function DayControl($d=0)
{
   echo "<select name=\"firstdayofweek\">\n";
   for($i=5; $i < 12; $i++){
      $x=$i-5;
      if($x==$d){ 
         echo "<option value=\"".$x."\" selected>".date("l", mktime(0, 0, 0, 9, $i, 2005))."</option>\n";
      }
      else{
         echo "<option value=\"".$x."\">".date("l", mktime(0, 0, 0, 9, $i, 2005))."</option>\n";
      }
   }
   echo "</select>\n";
}

function TimeControl($s=true)
{
   if($s){
      echo "<select name=\"startofday\">\n";
   }
   else{
      echo "<select name=\"endofday\">\n";
   }

   echo "<option value=\"1\">07:00</option>\n";
   echo "<option value=\"2\">08:00</option>\n";
   echo "<option value=\"3\">08:30</option>\n";
   if($s){
      echo "<option value=\"4\" selected>09:00</option>\n";
   }
   else{
      echo "<option value=\"4\">09:00</option>\n";
   }
   echo "<option value=\"5\">09:30</option>\n";
   echo "<option value=\"6\">10:00</option>\n";
   echo "<option value=\"7\">10:30</option>\n";
   echo "<option value=\"8\">11:00</option>\n";
   echo "<option value=\"9\">11:30</option>\n";
   echo "<option value=\"10\">12:00</option>\n";
   echo "<option value=\"11\">12:30</option>\n";
   echo "<option value=\"12\">13:00</option>\n";
   echo "<option value=\"13\">13:30</option>\n";
   echo "<option value=\"14\">14:00</option>\n";
   echo "<option value=\"15\">14:30</option>\n";
   echo "<option value=\"16\">15:00</option>\n";
   echo "<option value=\"17\">15:30</option>\n";
   echo "<option value=\"18\">16:00</option>\n";
   echo "<option value=\"19\">16:30</option>\n";
   if($s){
      echo "<option value=\"20\">17:00</option>\n";
   }
   else{
      echo "<option value=\"20\" selected>17:00</option>\n";
   }
   echo "<option value=\"21\">17:30</option>\n";
   echo "<option value=\"22\">18:00</option>\n";
   echo "<option value=\"23\">18:30</option>\n";
   echo "<option value=\"24\">19:00</option>\n";
   
   echo "</select>\n";
}

if(isset($_SESSION['defaults_submitted']) && $_SESSION['defaults_submitted'])
{
   $sessiontimeout = $_SESSION['sessiontimeout'];
   $defaultimgx = $_SESSION['defaultimgx'];
   $defaultimgy = $_SESSION['defaultimgy'];
   $onlinehelp = $_SESSION['onlinehelp'];
   $confirmdelete = $_SESSION['confirmdelete'];
   $pageimages = $_SESSION['pageimages'];
   $pagesize = $_SESSION['pagesize'];
   $styler = $_SESSION['styler'];
   $firstweekofyear = $_SESSION['firstweekofyear'];
   $firstdayofweek = $_SESSION['firstdayofweek'];
   $startofday = $_SESSION['startofday'];
   $endofday = $_SESSION['endofday'];
   $defspage = $_SESSION['defspage'];
   $dateformat = $_SESSION['dateformat'];
   $timeformat = $_SESSION['timeformat'];
   $nummodules = $_SESSION['nummodules'];
   $numlastviewed = $_SESSION['numlastviewed'];
   $showlinks = $_SESSION['showlinks'];
   $debug = $_SESSION['debug'];
}
else{
   $sessiontimeout = 3600;
   $defaultimgx = 100;
   $defaultimgy = 161;
   $onlinehelp = false;
   $confirmdelete = true;
   $pageimages = true;
   $pagesize = 20;
   $styler = 'default';
   $firstweekofyear = 1;
   $firstdayofweek = 1;
   $startofday = '08:00';
   $endofday = '17:00';
   $defspage = 'main.php';
   $dateformat = 'D, d M';
   $timeformat = 'H:M';
   $nummodules = 8;
   $numlastviewed = 4;
   $showlinks = true;
   $debug = false;
   
   $_SESSION['sessiontimeout'] = $sessiontimeout;
   $_SESSION['defaultimgx'] = $defaultimgx;
   $_SESSION['defaultimgy'] = $defaultimgy;
   $_SESSION['onlinehelp'] = $onlinehelp;
   $_SESSION['confirmdelete'] = $confirmdelete;
   $_SESSION['pageimages'] = $pageimages;
   $_SESSION['pagesize'] = $pagesize;
   $_SESSION['styler'] = $styler;
   $_SESSION['firstweekofyear'] = $firstweekofyear;
   $_SESSION['firstdayofweek'] = $firstdayofweek;
   $_SESSION['startofday'] = $startofday;
   $_SESSION['endofday'] = $endofday;
   $_SESSION['defspage'] = $defspage;
   $_SESSION['dateformat'] = $dateformat;
   $_SESSION['timeformat'] = $timeformat;
   $_SESSION['nummodules'] = $nummodules;
   $_SESSION['numlastviewed'] = $numlastviewed;
   $_SESSION['showlinks'] = $showlinks;
   $_SESSION['debug'] = $debug;
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <meta http-equiv="Content-Script-Type" content="text/javascript">
  <meta http-equiv="Content-Style-Type" content="text/css">
  <title>VxMIS Setup Wizard: Step 6</title>
  <link rel="stylesheet" href="install/install.css" type="text/css" />
  <script type="text/javascript" src="install/install.js"></script>
</head>
<body onload="toggleDropTables();togglePasswordRetypeRequired();toggleUsernameIsPrivileged();document.getElementById('defaultFocus').focus();">
<form action="install.php" method="post" name="setConfig" id="form">
<table cellspacing="0" cellpadding="0" border="0" align="center" class="shell">
<tr>
   <th width="400">Step 6: Default Values Configuration</th>
	<th width="200" height="30" style="text-align: right;"><a href="http://vxmis.vxgroup.com" target="_blank">
   <img src="install/install.png" alt="VxMIS" border="0" height="23" width="163"></a></th>
</tr>
<tr>
  <td colspan="2" width="600">	
  <p>Please enter your system configuration options below.
   If you are unsure of what to fill in, we suggest that you use the
   default values.</p>
  </td>
</tr>
<tr>
    <td>Session Timeout (in seconds)</td>
    <td><input type=text size="8" maxlength="16" name="sessiontimeout" value="3600"></td>
  </tr>
  <tr>
    <td>Default Image Width</td>
    <td><input type=text size="8" maxlength="8" name="defaultimgx" value="100"></td>
  </tr>
  <tr>
    <td>Default Image Length</td>
    <td><input type=text size="8" maxlength="8" name="defaultimgy" value="161"></td>
  </tr>
  <tr>
    <td>On-Line Help Enabled</td>
    <td><input type=checkbox name="onlinehelp" value="Y"></td>
  </tr>
  <tr>
    <td>Confirm Before Delete</td>
    <td><input type=checkbox name="confirmdelete" value="Y" checked></td>
  </tr>
  <tr>
    <td>Pages Images</td>
    <td><input type=checkbox name="pageimages" value="Y" checked></td>
  </tr>
  <tr>
    <td>List Page Size</td>
    <td><input type=text size="8" maxlength="8" name="pagesize" value="20"></td>
  </tr>
  <tr>
    <td>Default Style</td>
    <td>
    <select name="styler">
    <option value="default" selected>Default</option>
    <?php //<option value="red">Red</option> ?>
    <?php //<option value="black">Black</option> ?>
    <?php //<option value="flat">Flat</option> ?>
    <?php //<option value="wank">Wank</option> ?>
    </select>
    </td>
  </tr>
  <tr>
    <td>First Day of Week</td>
    <td><?php DayControl()?></td>
  </tr>
  <tr>
    <td>First Week of Year</td>
    <td><?php WeekControl()?></td>
  </tr>
  <tr>
    <td>Start of Day</td>
    <td><?php TimeControl()?></td>
  </tr>
  <tr>
    <td>End of Day</td>
    <td><?php TimeControl(false)?></td>
  </tr>
  <tr>
  <tr>
    <td>Default Start Page</td>
    <td><select name="defspage">
    <option value="main.php" selected>Information</option>
    <option value="users/usertoday.php">Today</option>
    <?php/*
    <option value="black">Black</option>
    <option value="flat">Flat</option>
    <option value="wank">Wank</option>*/?>
    </select>
    </td>
  </tr>
  </tr>
    <td>Default Date Format</td>
    <td><input type=text size="8" maxlength="16" name="dateformat" value="D, d M"></td>
  </tr>
  </tr>
    <td>Default Time Format</td>
    <td><input type=text size="8" maxlength="16" name="timeformat" value="H:M"></td>
  </tr>
  </tr>
    <td>Default Modules Size</td>
    <td><input type=text size="8" maxlength="16" name="nummodules" value="8"></td>
  </tr>
  </tr>
    <td>Default Number Last Viewed</td>
    <td><input type=text size="8" maxlength="16" name="numlastviewed" value="4"></td>
  </tr>
  </tr>
    <td>Show Static Module Links in Footer</td>
    <td><input type=checkbox name="showlinks" value="Y"></td>
  </tr>
  <tr>
    <td>Debugging</td>
    <td><input type=checkbox name="debug" value="Y"></td>
  </tr>

<tr>
<td align="right" colspan="2">
<hr>
  <input type="hidden" name="setup_page" value="5">
  <table cellspacing="0" cellpadding="0" border="0" class="nav">
  <tr>
    <td><input class="obutton" type="button" onclick="window.open('page6help.html');" value="Help" /></td>
    <td><input class="obutton" type="button" name="goto" value="Back" onclick="document.getElementById('form').submit();" />
        <input type="hidden" name="goto" value="Back" /></td>
     <td><input class="button" type="submit" name="goto" value="Next" /></td>
   </tr>
   </table>
</td>
</tr>
</table>
</form>
<br>
</body>
</html>
