<?php
/*
ledger.php

Copyright (C)2004 Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");


if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Ledger Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Ledger Maintenance");
}

if($_SESSION['pageindex']->CheckNum(ledgerm_ledger_qry1, "ledger")){
   $_SESSION['pageindex']->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addLedger();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseLedger($_REQUEST['id']);
         break;
      }
		browseLedger($_POST['id']);
		break;

	case "edit" :
		editLedger($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelLedger($_REQUEST['id']);
      }
      else{
         deleteLedger($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listLedger();
      }
		break;

	case "cfmdelete" :
		deleteLedger($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listAddress();
		break;
      
	case "add" :
		insertLedger($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listLedger();
		break;

	case "commit" :
		commitLedger($_POST);
      listLedger();
		break;

	case "list":
	default :
		listLedger();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(ledgerm_ledger_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
   $frm["parentid"]=0;
   $frm["name"]="";
   $frm["description"]="";
   
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(ledgerm_ledger_qry2, $id);
   }
   else{
      $qry=sprintf(ledgerm_ledger_qry3, $id);
   }
   $frm=clearForm();
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	if($row = $result->FetchRow()){
      $frm["id"] = $row['id'];
      $frm["parentid"]=$row["parentid"];
      $frm["name"] = $row["name"];
      $frm["descrption"] = $row["description"];
	}
   return $frm;
}

function addLedger()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   
	include("templates/ledger.php");
}

function editLedger($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/ledger.php");
}

function browseLedger($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";

	include("templates/ledger.php");
}

function insertLedger($frm) 
{
	$qry=sprintf(ledgerm_ledger_qry4,$frm["parentid"],$frm['name'],$frm['description']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitLedger($frm) 
{
   $qry=sprintf(ledgerm_ledger_qry5,$frm["parentid"],$frm['name'],$frm['description'],$frm['id']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function chkdelLedger($id)
{
   $frm=fillform($id, false);
	$frm["newaction"] = "cfmdelete";

	include("templates/ledger.php");
}

function deleteLedger($id) 
{
   $qry=sprintf(ledgerm_ledger_qry6,$id);
	$_SESSION['VxCFG']->dbh->Execute($query);
}

function fillHeadingCombo($a, $id)
{
   $acc=new Account();
   $acc->HeadingCombo($a, $id, "title");
}

function fillParentCombo($a, $id)
{
   $acc=new Account();
   $acc->Combo($a, $id, "parentid");
}

function fillAccountCombo($a, $id)
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function LedgerCombo($a, $id)
{
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"parentid\" class=\"combo\">\n";
      if($id==0){
         echo "<option selected value=\"0\">". _("None") ."</option>\n";
      }
      else{
         echo "<option value=\"0\">". _("None") ."</option>\n";
      }
      $result=$_SESSION['VxCFG']->dbh->Execute(ledgerm_ledger_qry1);
	   while($row = $result->FetchRow()){
			$boo=$row["id"];
		   $poo=$row["name"];
		   if($id==$boo){
			   echo "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		echo "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
		print "</select>\n";
   }
   else{
      $qry=sprintf(ledgerm_ledger_qry3, $id); 
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}

function listLedger()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(ledgerm_ledger_qry7, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no ledgers defined")."</td></td></table>\n";
      return;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no ledgers defined")."</td></td></table>\n";
      return;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='description'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Description")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Description")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=description\">"._("Desrciption")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='description'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
		$n=$row["name"];
      
      if(isset($row["description"]) && $row["description"]!=""){
         $d=$row["description"];
      }
      else{
         $d="&nbsp;";
      }
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">$n</td><td class=\"listdata\">$d</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">$n</td><td class=\"listdataeven\">$d</td><td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"ledger.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"ledger.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"ledger.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"ledger.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"ledger.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"ledger.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
