<?php
/*
ledgerrep.php

Copyright (C)2004 Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Customer Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Customer Maintenance");
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "balsheet" :
		balancesheet($_POST);
		break;

	case "profitloss" :
		profiloss($_POST);
		break;

	case "accstatement":
	   accountstatement($_POST);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function balancesheet($frm)
{
   $frm["heading"] = "Balance Sheet";
   echo "<br><br><center><h3>In Progress...</h3></center>\n";
}

function profiloss($frm)
{
   $frm["heading"] = "Profit and Loss";
   echo "<br><br><center><h3>In Progress...</h3></center>\n";
}

function accountstatement($frm)
{
   $frm["heading"] = "Account Statement";
   echo "<br><br><center><h3>In Progress...</h3></center>\n";
}

?>
