<?php
/*
collection.php - collection lists

Copyright (C) 2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 - 2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
/*
function CollectionCombo($id)
{
   $result=db_query("select * from collection where collectionid != '0'");
   echo "<select name=\"collection\" width=\"250\">\n";
   while($row = $result->FetchRow()){
      $cresult=db_query("select count(*) from productcollection where prodcollid = '$row[3]'");
  	   if($crow = $cresult->FetchRow()) $n=$crow[0];
      else $n=0;
      if($id == $row[0]) echo"<option value=\"$row[0]\" selected>$row[1] - $n products</option>\n";
      else echo"<option value=\"$row[0]\">$row[1] - $n products</option>\n";
   }
   echo "</select>\n";
}
*/
 
class Collection
{
   var $id;
   var $name;
   var $description;
   var $collectionid;
   
   function Collection()
   {
      $this->id=0;
      $this->name="";
      $this->description="";
      $this->collectionid=0;
   }
   
   function Fill($id)
   {
      $qry=sprintf(product_collection_qry3, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->name=$row[1];
         $this->description=$row[2];
         $this->collectionid=$row[3];
         return true;
      }
      return false;
   }
   
   function Commit()
   {
   }
   
   function AddProduct($pid)
   {
      $qry=sprintf(product_collection_qry9, $this->collectionid, $pid);
      $_SESSION['VxCFG']->dbh->Execute($qry); 
   }
   
   function DeleteProduct($pid)
   {
      $qry=sprintf(product_collection_qry10, $this->collectionid, $pid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Merge($id, $filename)
   {
      if(!$this->Fill($id)){
         return false;
      }
      $fp = fopen ($filename, "w");
      if($fp==FALSE){
         return false;
      }
      
      //name, plu, price (comma separated)
      $qry=sprintf(product_collection_qry11, $this->collectionid);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($result->RecordCount()==0){
         return false;
      }
      while($row = $result->FetchRow()){
         $qry=sprintf(product_collection_qry12, $row[1]);
         $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($prow = $presult->FetchRow()){
            if(!fwrite($fp, $prow[0].",")) {
               print "Cannot write to file ($filename)";
               exit;
            }
            fwrite($fp, $prow[1].",");
            $qry=sprintf(product_collection_qry13, $prow[2]);
            $sresult=$_SESSION['VxCFG']->dbh->Execute($qry);
            if($srow = $sresult->FetchRow()){
               fwrite($fp, $srow[0]."\n");
            }
         }
      }
      fclose($fp);
   }
   
   function Combo($a, $id, $n)
   {
      if($a=="commit" || $a=="add"){
         $result=$_SESSION['VxCFG']->dbh->Execute(product_collection_qry7);
         if($result->RecordCount()==0){
            return false;
         }
         echo "<select name=\"".$n."\">\n";
         if($id==0){
            echo "<option value='0' selected>"._("Not Set")."</option>\n";
         }
         else{
            echo "<option value='0'>"._("Not Set")."</option>\n";
         }
         while($row = $result->FetchRow()){
            if($id==$row['id']){
               echo "<option selected value=\"".$row['id']."\">".$row['name']."</option>\n";
            }
            else{
               echo "<option value=\"".$row['id']."\">".$row['name']."</option>\n";
            }
         }
         echo "</select>\n";
      }
      else{
         $qry=sprintf(product_collection_qry3, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result->RecordCount()==0){
            echo _("Not Set");
         }
         if($row = $result->FetchRow()){
            echo $row['name'];
         }
         else{
            echo _("Not Set");
         }
      }
   }
   
   function AddControl($id)
   {
   }
   
   function FillTable($id)
   {  
      if(!$this->Fill($id)){
         return false;
      }
      
      echo "<table width='100%' border='1' cellspacing='2' cellpadding='2' class=\"collection\">\n";
      echo "<tr>\n";
	   $result=db_query("select * from productcollection where prodcollid = '$this->collectionid'");
  	   while($row = $result->FetchRow()){  		   
         $productID=$row[0];
         $presult=$_SESSION['VxCFG']->dbh->Execute("select plu, name from product where id = '$productID'");
  	      if($prow = $presult->FetchRow()){
   	      echo "<tr><td>$prow[0]</td><td>$prow[1]</td><td></td></tr>\n";
         }
      }
      echo "</tr></table>\n";
      return true;
   }
   
   function FillCollectionTable($a, $id)
   {
      if(!$this->Fill($id)){
         return false;
      }
      echo "<form method=\"post\" action=\"$_SERVER[PHP_SELF]\">";
      echo "<table width='100%' border='1' cellspacing='2' cellpadding='2'>\n";
	   $result=$_SESSION['VxCFG']->dbh->Execute("select * from productcollection where prodcollid = '$this->collectionid'");
      if($result->RecordCount()==0){
         if($a=="commit"){
            echo "<tr>\n<td class=\"tinsert\"> - </td>\n<td class=\"tinsert\"> - </td>\n";
            echo "<td class=\"tinsert\"><a href=\"collection.php?action=additem\">Add</a></td>\n</tr>\n";
         }
         else{
            echo "<tr>\n<td class=\"tinsert\">No Products</td>\n</tr>\n</table>\n";
         }
         return false;
      }
  	   while($row = $result->FetchRow()){  		   
         $productID=$row[1];
         $presult=$_SESSION['VxCFG']->dbh->Execute("select plu, name from product where id = '$productID'");
  	      if($prow = $presult->FetchRow()){
   	      echo "<tr>\n<td class=\"tinsert\" width=\"15%\">$prow[0]</td><td class=\"tinsert\" width=\"100%\" nowrap>$prow[1]</td>\n";
            if($a=="commit"){
               echo "<td class=\"tinsert\"><a href=\"collection.php?action=deleteitem&cid=$this->collectionid&id=$productID\">Delete</a></td>\n";
            }
            echo "</tr>\n";
         }
      }
      if($a!="browse"){
         echo "<tr><input type=\"hidden\" name=\"action\" value=\"additem\">\n";
         echo "<input type=\"hidden\" name=\"id\" value=\"$this->id\">\n";
         echo "<input type=\"hidden\" name=\"cid\" value=\"$this->collectionid\">\n";
         echo "<td class=\"tinsert\"><input type=\"text\" name=\"PLU\" size=\"16\" maxlength=\"128\" value=\"\"></td>\n";
         echo "<td class=\"tinsert\"> - </td>\n";
         echo "<td class=\"tinsert\"><input type=\"submit\" value=\"Add\"></td></tr>\n";
      }
      echo "</table></form>\n";
      return true;
   }
}

?>
