<?php
/*
country.php

 Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
class Country
{
   var $id;
   var $name;
   var $isoname;
   var $smallisoname;
   var $addressformat;
   
   function Country($id=false)
   {
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      $this->id=0;
      $this->name="";
      $this->isoname="";
      $this->smallisoname="";
      $this->addressformat="";
   }
   
   function GetID() { return $this->id; }
   
   function Fill($id, $bOffset=false)
   {
      $qry=sprintf(misc_qry2, $id);
      
	   $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->name=$row["name"];
         $this->isoname=$row["isoname"];
         $this->smallisoname=$row["smallisoname"];
         $this->addressformat=$row["addressformat"];
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d)
   {
      $this->name=$a;
      $this->isoname=$b;
      $this->smallisoname=$c;
      $this->addressformat=$d;
   }
   
   function SetFromForm($frm)
   {
      $this->isoname=$frm["name"];
      $this->isoname=$frm["isoname"];
      $this->smallisoname=$frm["smallisoname"];
      $this->addressformat=$frm["addressformat"];
   }
   
   function Add()
   {
   }
   
   function Commit()
   {
   }
   
   function Delete()
   {
   }
   
   function Template($id=false, $smarty)
   {
      if(isset($id)){
         Fill($id);
      }
      $smarty->assign('id', $this->id);
      $smarty->assign('name', $this->name);
      $smarty->assign('isoname', $this->isoname);
      $smarty->assign('smallisoname',$this->smallisoname);
      $smarty->assign('addressformat', $this->addressformat);
   }
   
   function TemplateCombo($a, $cname, $id, $smarty)
   {
      if($a=="commit" || $a=="add"){
         $idarray=array();
         $namearray=array();
   	   $result=db_query(misc_qry8);
      	while($row = $result->FetchRow()){
            array_push($idarray, $row["id "]);
            array_push($namearray, $row["name "]);
         }
      }
      else{
         $qry=sprintf(misc_qry7, $id);
         $result=db_query($qry);      	
         if($row = $result->FetchRow()){
            $smarty->assign('name', $row["name"]);
         }
         else $smarty->assign('name', "Not Set");
      }
   }
   
   function Combo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
         if($id==0){
            $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry10);
            if($row=$result->FetchRow()){
               $id=$row['value'];
            }
         }
         $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry8);
         echo "<select name=\"$cname\">\n";
   	   while($row = $result->FetchRow()){
            $n=$row["name"];
   	   	$boo=$row["id"];
   	   	if($id==$boo){
	   	   	echo "<option selected value=\"$boo\"> $n </option>\n";
   		   }
      		else{
	      		echo "<option value=\"$boo\"> $n </option>\n";
   		   }
	      }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(misc_qry7, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($row = $result->FetchRow()){
            echo $row['name'];
         }
         else{
            echo _("Not Set");
         }
      }
   }
   
   function FillTable($a, $id, $title, $bOffset=true, $bInside=false)
   {
   }
   
   function Find($bOutput)
   {
      return true;
   }
}

?>
