<?
/**
 * A generic database entity.
 * @author	Al Kingsley <al@bananamis.com>
 * @copyright	2004 Al Kingsley
 * @package	MIS
 * @access	private
 */
define('ADODB_ASSOC_CASE', 0);
require_once($_SESSION['VxCFG']->libdir."/adodb/adodb.inc.php");

function db_connect($dbtype, $dbhost, $dbname='', $dbuser='', $dbpass='') 
{
   $dbh = NewADOConnection($dbtype);
   
   if(strcmp($dbtype, 'mysql')==0){
      $dbh->PConnect($dbhost, $dbuser, $dbpass, $dbname);
   }
   else if(strcmp($dbtype, 'pgsql')==0){
      $dbh->PConnect($dbhost);
   }
   else return false;
   //$dbh->debug = true;
	return $dbh;
}

function db_disconnect() 
{
	$_SESSION['VxCFG']->dbh->Close();
}

function db_query($query) 
{
   if(!$_SESSION['VxCFG']->dbh){
      echo "No database";
   }
   return $_SESSION['VxCFG']->dbh->Execute($query);
}

function db_quotes($qry) 
{
}

function db_close($qry) 
{
   $qry->Close();
}

function db_num_rows($qid)
{ 
   if($qid){
      return $qid->RecordCount(); 
   }
   return 0;
}

function db_fetch_array($qid){ return $qid->FetchRow(); }
function db_fetch_row($qid){ return $qid->FetchRow(); }
function db_affected_rows(){ return $_SESSION['VxCFG']->dbh->Affected_Rows(); }
function db_num_fields($qid){ return $qid->FieldCount(); }
//function db_insert_id(){ return mysql_insert_id(); }
//function db_free_result($qid){ mysql_free_result($qid); }

//function db_field_name($qid, $fieldno){ return mysql_field_name($qid, $fieldno); }
//function db_field_type($qid, $fieldno){ return mysql_field_type($qid, $fieldno); }
//function db_data_seek($qid, $row){ if (db_num_rows($qid)) { return mysql_data_seek($qid, $row); } }


?>
