<?php
/*
 * discount.php
 *
 * Part of:
 * BhPos, Copyright (C) 2001-2004 Al Kingsley
 * BhPos comes with ABSOLUTELY NO WARRANTY.
 *
 */
 
define ("BHDISCOUNT_TYPE_PRICEABSOLUTE", "1");
define ("BHDISCOUNT_TYPE_PRICEINCREMENTAL", "2");
define ("BHDISCOUNT_TYPE_PRICEMARGIN", "3");
define ("BHDISCOUNT_TYPE_ITEMABSOLUTE", "4");
define ("BHDISCOUNT_TYPE_ITEMINCREMENTAL", "5");
define ("BHDISCOUNT_TYPE_ITEMMARGIN", "6");
 
class Discount
{
   var $id;
   var $discountid;
   var $type;
   var $ident;
   var $targetid;
   var $margin;
   var $status; 
  
   function Discount($id=false, $bOffset=false)
   {
      if(isset($id)){
         if(isset($bOffset)){
            $this->Fill($id, $bOffset);
         }
         else{
            $this->Fill($id, false);
         }
      }
      else{
         $this->id=0;
         $this->discountid=0;
         $this->type=0;
         $this->ident="";
         $this->targetid=0;
         $this->margin=0.0;
         $this->status=0;
      }
   }
   
   function Fill($id, $bOffset=false)
   {
      if($bOffset){
         $qry=sprintf(supplierm_discount_qry2, $id);
      }
      else{
         $qry=sprintf(supplierm_discount_qry3, $id);
      }
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	   if($row = $result->FetchRow()){
         $this->id=$id;
         $this->discountid=$row['discountid'];
         $this->type=$row['type'];
         $this->ident=$row['ident'];
         $this->targetid=$row['targetid'];
         $this->margin=$row['margin'];
         $this->status=$row['status'];
         return false;
      }
      return true;
   }
   
   function Add()
   {
      $qry=sprintf(supplierm_discount_qry4,$this->type, $this->ident, $this->targetid, $this->margin, $this->status);
      
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
      $_SESSION['VxCFG']->dbh->Execute(misc_qry1);
      if($row = $result->FetchRow()){
         $this->id=$row[0];
      }
      return $this->id;
   }
   
   function Commit($id)
   {
      $qry=sprintf(supplierm_discount_qry5,$this->type, $this->ident, $this->targetid, $this->margin, $this->status, $this-id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete($id=false)
   {
      if(isset($id)){
         $qry=sprintf(supplierm_discount_qry6, $id);
      }
      else{
         $qry=sprintf(supplierm_discount_qry6, $this->id);
      }
	   $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Combo($a, $cname, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $result=$_SESSION['VxCFG']->dbh->Execute(supplierm_discount_qry7);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(supplierm_discount_qry3, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      	if($row = $result->FetchRow()){
		      $poo=$row["name"];
            echo $poo;
         }
         else echo "Not Set";
      }
   }
   
   function IdentCombo($a, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"ident\">\n";
         if($id==0){
            echo "<option value='0' selected>Not Set</option>\n";
         }
         else{
   	      echo "<option value='0'>Not Set</option>\n";
         }
   	   if($id==BHSQL_DISCOUNT_PRODUCT){
	      	echo "<option selected value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
		   }
   		else if($id==BHSQL_DISCOUNT_CUSTOMER){
	   	   echo "<option value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option selected value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
   	   }
         else if($id==BHSQL_DISCOUNT_USER){
            echo "<option value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option selected value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
         }
         else if($id==0){
            echo "<option value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
         }
	      echo "</select>\n";
      }
      else{
         if($id==BHSQL_DISCOUNT_PRODUCT){
	      	echo "Product";
		   }
   		else if($id==BHSQL_DISCOUNT_CUSTOMER){
	   	   echo "Customer";
   	   }
         else if($id==BHSQL_DISCOUNT_USER){
            echo "User";
         }
      }
   }
   
   function TypeCombo($a, $id, $n='')
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"type\">\n";
         if($id==0){
            echo "<option value='0' selected>Not Set</option>\n";
         }
         else{
   	      echo "<option value='0'>Not Set</option>\n";
         }
         
   	   if($id==BHDISCOUNT_TYPE_PRICEABSOLUTE){
	      	echo "<option selected value=\"".BHDISCOUNT_TYPE_PRICEABSOLUTE."\">"._("Price Absolute")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_PRICEINCREMENTAL."\">"._("Price Increment")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_PRICEMARGIN."\">"._("Price Margin")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMABSOLUTE."\">"._("Item Absolute")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMINCREMENTAL."\">"._("Item Increment")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMMARGIN."\">"._("Item Margin")."</option>\n";
		   }
         elseif($id==BHDISCOUNT_TYPE_PRICEINCREMENTAL){
	      	echo "<option value=\"".BHDISCOUNT_TYPE_PRICEABSOLUTE."\">"._("Price Absolute")."</option>\n";
            echo "<option selected value=\"".BHDISCOUNT_TYPE_PRICEINCREMENTAL."\">"._("Price Increment")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_PRICEMARGIN."\">"._("Price Margin")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMABSOLUTE."\">"._("Item Absolute")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMINCREMENTAL."\">"._("Item Increment")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMMARGIN."\">"._("Item Margin")."</option>\n";
		   }
         elseif($id==BHDISCOUNT_TYPE_PRICEMARGIN){
	      	echo "<option value=\"".BHDISCOUNT_TYPE_PRICEABSOLUTE."\">"._("Price Absolute")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_PRICEINCREMENTAL."\">"._("Price Increment")."</option>\n";
            echo "<option selected value=\"".BHDISCOUNT_TYPE_PRICEMARGIN."\">"._("Price Margin")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMABSOLUTE."\">"._("Item Absolute")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMINCREMENTAL."\">"._("Item Increment")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMMARGIN."\">"._("Item Margin")."</option>\n";
		   }
         elseif($id==BHDISCOUNT_TYPE_ITEMABSOLUTE){
	      	echo "<option value=\"".BHDISCOUNT_TYPE_PRICEABSOLUTE."\">"._("Price Absolute")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_PRICEINCREMENTAL."\">"._("Price Increment")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_PRICEMARGIN."\">"._("Price Margin")."</option>\n";
            echo "<option selected value=\"".BHDISCOUNT_TYPE_ITEMABSOLUTE."\">"._("Item Absolute")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMINCREMENTAL."\">"._("Item Increment")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMMARGIN."\">"._("Item Margin")."</option>\n";
		   }
         elseif($id==BHDISCOUNT_TYPE_ITEMINCREMENTAL){
	      	echo "<option value=\"".BHDISCOUNT_TYPE_PRICEABSOLUTE."\">"._("Price Absolute")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_PRICEINCREMENTAL."\">"._("Price Increment")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_PRICEMARGIN."\">"._("Price Margin")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMABSOLUTE."\">"._("Item Absolute")."</option>\n";
            echo "<option selected value=\"".BHDISCOUNT_TYPE_ITEMINCREMENTAL."\">"._("Item Increment")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMMARGIN."\">"._("Item Margin")."</option>\n";
		   }
         elseif($id==BHDISCOUNT_TYPE_ITEMMARGIN){
	      	echo "<option value=\"".BHDISCOUNT_TYPE_PRICEABSOLUTE."\">"._("Price Absolute")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_PRICEINCREMENTAL."\">"._("Price Increment")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_PRICEMARGIN."\">"._("Price Margin")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMABSOLUTE."\">"._("Item Absolute")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMINCREMENTAL."\">"._("Item Increment")."</option>\n";
            echo "<option selected value=\"".BHDISCOUNT_TYPE_ITEMMARGIN."\">"._("Item Margin")."</option>\n";
		   }
         elseif($id==0){
	      	echo "<option value=\"".BHDISCOUNT_TYPE_PRICEABSOLUTE."\">"._("Price Absolute")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_PRICEINCREMENTAL."\">"._("Price Increment")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_PRICEMARGIN."\">"._("Price Margin")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMABSOLUTE."\">"._("Item Absolute")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMINCREMENTAL."\">"._("Item Increment")."</option>\n";
            echo "<option value=\"".BHDISCOUNT_TYPE_ITEMMARGIN."\">"._("Item Margin")."</option>\n";
		   }
	      echo "</select>\n";
      }
      else{
         if($id==BHDISCOUNT_TYPE_PRICEABSOLUTE){
	      	echo _("Price Absolute");
		   }
         elseif($id==BHDISCOUNT_TYPE_PRICEINCREMENTAL){
            echo _("Price Increment");
		   }
         elseif($id==BHDISCOUNT_TYPE_PRICEMARGIN){
            echo _("Price Margin");
		   }
         elseif($id==BHDISCOUNT_TYPE_ITEMABSOLUTE){
            echo _("Item Absolute");
		   }
         elseif($id==BHDISCOUNT_TYPE_ITEMINCREMENTAL){
            echo _("Item Increment");
		   }
         elseif($id==BHDISCOUNT_TYPE_ITEMMARGIN){
            echo _("Item Margin");
		   }
         elseif($id==0){
            echo _("Not Set");
         }
      }
   }
   
   function Table($a, $id, $title, $bOffset=true, $bInside=false)
   {
      //if($bInside){
      //   echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\">\n";
      //   echo "<tr align=\"center\"><td colspan=\"2\"><h2>$title</h2></td></tr>\n";
      //}
      echo"<fieldset>\n<legend>"._("Discount")."</legend><table>\n";
      echo "<tr><td class=\"formlabel\">"._("Type")."</td><td class=\"formdata\">\n";
      $this->typecombo($a, $this->type);
      echo "</td></tr><tr><td class=\"formlabel\">"._("Identity")."</td><td class=\"formdata\">\n";
      entry($a, "ident", 12, 8, $this->ident);
      echo "</td></tr><tr><td class=\"formlabel\">"._("Target")."</td><td class=\"formdata\">\n";
      entry($a, "targetid", 12, 8, $this->targetid);
      echo "</td></tr><tr><td class=\"formlabel\">"._("Margin")."</td><td class=\"formdata\">\n";
      entry($a, "margin", 12, 8, $this->margin);
      echo "</td></tr><tr><td class=\"formlabel\">"._("Status")."</td><td class=\"formdata\">\n";
      entry($a, "status", 64, 64, $this->status);
      echo "</td></tr>\n";
      echo "</table>\n</fieldset>\n";
   }
}   
class DiscountCollection
{
   var $id;
   var $discountid;
   var $items;
      
   function DiscountCollection($id=false)
   {
      if(isset($id)){
         $this->Fill($id);
      }
      else{
         $this->id=0;
      }
   }
   
   function Fill($id)
   {
      $this->id=$id;
      $qry=sprintf(supplierm_discount_qry8, $id);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	   while($row = $result->FetchRow()){
         $d=new Discount($row['id'], false);
         array_push($this->items, $d);
      }
   }
   
   function Table($a, $id, $title, $bOffset=true, $bInside=false)
   {
      if($bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\">\n";
         echo "<tr align=\"center\"><td colspan=\"2\"><h2>$title</h2></td></tr>\n";
      }
      echo "<tr><td><h3>Type</h3></td><td><h3>Margin</h3></td><td><h3>Stauts</h3></td></tr>\n";
      echo "<tr><td>\n";
      entry($a, "discountid", 12, 8, $this->discountid);
      echo "</td><td>\n";
      $this->TypeCombo($a, $this->type);
      echo "</td><td>\n";
      entry($a, "margin", 12, 8, $this->margin);
      echo "</td><td>\n";
      entry($a, "status", 64, 64, $this->status);
      echo "</td></tr>\n";
      if($bInside){
         echo "</table>\n";
      }
   }
}
   
?>
