<?php
/*
gl.php

Copyright (C)2004 Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

require_once("timedate.php");

class LedgerEntry
{
   var $id;
   var $ledgerid;
   var $typeid;
   var $transactionid;
   var $entereddate;
   var $periodid;
   var $accountid;
   var $description;
   var $debit;
   var $amount;
   var $open;
   var $committed;
   var $referenceid;
	

	function LedgerEntry()
	{
		$this->id=0;
      $this->ledgerid=0;
      $this->typeid=0;
      $this->transactionid=0;
      $this->entereddate='';
      $this->periodid='';
      $this->accountid=0;
      $this->description='';
      $this->debit='N';
      $this->amount="0.00";
      $this->open='Y';
      $this->committed='N';
      $this->referenceid=0;
	}

	function Fill($id=0, $bOffset=false)
	{
      if($id==0){
         return false;
      }
      
      if($bOffset){
         $qry=sprintf(ledger_gl_qry2, $id);
      }
      else{
         $qry=sprintf(ledger_gl_qry3, $id);
      }
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!result) return false;
      
      if($row = $result->FetchRow()){
         $this->id=$row['id'];
         $this->ledgerid=$row['ledgerid'];
         $this->typeid=$row['typeid'];
         $this->transactionid=$row['transactionid'];
         $this->entereddate=$row['entereddate'];
         $this->periodid=$row['periodid'];
         $this->accountid=$row['accountid'];
         $this->description=$row['description'];
         $this->debit=$row['debit'];
         $this->amount=$row['amount'];
         $this->open=$row['open'];
         $this->committed=$row['committed'];
         $this->referenceid=$row['referenceid'];
         
         return true;
      }
      return false;
	}
   
   function Set($a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l)
   {
      $this->ledgerid=$a;
      $this->typeid=$b;
      $this->transactionid=$c;
      $this->entereddate=$d;
      $this->periodid=$e;
      $this->accountid=$f;
      $this->description=$g;
      $this->debit=$h;
      $this->amount=$i;
      $this->open=$j;
      $this->committed=$k;
      $this->referenceid=$l;
   }
   
   function SetFromForm($frm)
   {
      $this->ledgerid=$frm['ledgerid'];
      $this->typeid=$frm['typeid'];
      $this->transactionid=$frm['transactionid'];
      $this->entereddate=$frm['entereddate'];
      $this->periodid=$frm['periodid'];
      $this->accountid=$frm['accountid'];
      $this->description=$frm['description'];
      $this->debit=$frm['debit'];
      $this->amount=$frm['amount'];
      $this->open=$frm['open'];
      $this->committed=$frm['committed'];
      $this->referenceid=$frm['referenceid'];
   }
   
   function Add()
   {
      $qry=sprintf(ledger_gl_qry4, 
		   $this->ledgerid,
         $this->typeid,
         $this->transactionid,
         $this->entereddate,
         $this->periodid,
         $this->accountid,
         $this->description,
         $this->debit,
         $this->referenceid);
      
      $_SESSION['VxCFG']->dbh->Execute($qry);
      
      $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
      if($row = $result->FetchRow()){
   	   $this->id=$row[0];
      }
      return $this->id;
   }
   
   function Commit($id)
   {
      $qry=sprintf(ledger_gl_qry5, 
         $this->titleid,
         $this->transactionid,
         $this->entereddate,
         $this->periodid,
         $this->accountid,
         $this->description,
         $this->debit,
         $this->referenceid,
         $id);
         
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(ledger_gl_qry6, $id);
      
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Combo($a, $id, $cname)
   {
   }
   
   function LedgerCombo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $result=$_SESSION['VxCFG']->dbh->Execute(ledgerm_ledger_qry1);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
            break;
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(ledgerm_ledger_qry3, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if(!isset($result)){
            echo _("Not Set");
            return;
         }
      	if($row = $result->FetchRow()){
		      $poo=$row["name"];
            echo $poo;
         }
         else echo _("Not Set");
      }
   }
   
   function TypeCombo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $result=$_SESSION['VxCFG']->dbh->Execute(ledgerm_ledgertype_qry1);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
            break;
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(ledgerm_ledgertype_qry3, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if(!isset($result)){
            echo _("Not Set");
            return;
         }
      	if($row = $result->FetchRow()){
		      $poo=$row["name"];
            echo $poo;
         }
         else echo _("Not Set");
      }
   }
   
   function PeriodCombo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $result=$_SESSION['VxCFG']->dbh->Execute(ledgerm_period_qry1);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["description"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
            break;
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(ledgerm_period_qry3, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if(!isset($result)){
            echo "Not Set";
            return;
         }
      	if($row = $result->FetchRow()){
		      $poo=$row["description"];
            echo $poo;
         }
         else echo _("Not Set");
      }
   }
   
   function Table($a, $id, $title, $bOffset=true, $bInside=false)
   {
      if($this->id==0){
         $this->Fill($id, $bOffset);
      }
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"address\">\n";
         echo "<tr>\n";
	      echo "<th colspan=\"2\">$title</th>\n";
      }

	   echo "<tr>\n";
      echo "<td class=\"formlabel\">Transaction ID</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "transactionid", 16, 16, $this->transactionid);
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">When</td>\n";
      echo "<td class=\"formdata\">";
      $td=new TimeDate();
      if($a=="commit" || $a=="add"){
		   $result=db_query(login_qry1);
   		if($row = $result->FetchRow()){
            $td->parse($row[0]);
         }
      }
      else{
         $td->parse($this->enteredat);
      }
      $td->tscontrol($a, "enteredat");
      echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">Who</td>\n";
      echo "<td class=\"formdata\">";
	   FillEmployeeName($a, "enteredby", $this->enteredby);
   	echo"</td>\n";
	   echo "</tr>\n";

      echo "<tr>\n";
      echo "<td class=\"formlabel\">Where</td>\n";
      echo "<td class=\"formdata\">";
	   fillEnteredStation($a, $this->enteredstation);
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">Status</td>\n";
      echo "<td class=\"formdata\">";
	   fillStatusCombo($a, "statusid", $this->statusid);
   	echo"</td>\n";
	   echo "</tr>\n";
      /*
      echo "<tr>\n";
      echo "<td width=\"20%\" align=\"right\">Payment</td>\n";
      echo "<td class=\"formdata\">";
      //fillPayTypeCombo
	   entry($a, "PaymentTypeID", 16, 16, $this->PaymentTypeID);
   	echo"</td>\n";
	   echo "</tr>\n";
      */
      echo "<tr>\n";
      echo "<td class=\"formlabel\">Reference Number</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "refnum", 32, 32, $this->refnum);
   	echo"</td>\n";
	   echo "</tr>\n";

      echo "<tr>\n";
      echo "<td class=\"formlabel\">Description</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "description", 64, 64, $this->description);
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">Open</td>\n";
      echo "<td class=\"formdata\">";
      CheckBox($a, "open", $this->open, "open");
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">Reconciled</td>\n";
      echo "<td class=\"formdata\">";
      CheckBox($a, "reconciled", $this->reconciled, "reconciled");
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">Taxable</td>\n";
      echo "<td class=\"formdata\">";
      CheckBox($a, "taxable", $this->taxable, "taxable");
   	echo"</td>\n";
	   echo "</tr>\n";
      /*
		   $this->settlementID,
		   $this->linkID
      */   
      echo "<tr>\n";
      echo "<td class=\"formlabel\">Number Items</td>\n";
      echo "<td class=\"formdata\">";
	   echo $this->NumTransItems();
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">Number Pay Items</td>\n";
      echo "<td class=\"formdata\">";
      echo $this->NumPayItems();
      echo "</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">Total</td>\n";
      echo "<td class=\"formdata\">";
	   echo $this->Total();
   	echo"</td>\n";
	   echo "</tr>\n";
      
      if(!$bInside){
   	   echo "</table>\n";
      }
   }
}

?>
