<?php
/*
 org.php
 
 Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/

class Organisation
{
   var $site;
   var $dept;
   var $group;
   var $subgroup;
   var $subtype;
   var $selgroup;
   
   function Organisation($s=0, $d=0, $g=0)
   {
      $this->site=$s;
      $this->dept=$d;
      $this->group=$g;
      $this->subgroup=0;
      $this->subtype="employee";
      $this->selgroup="site";
   }
   
   function SetSite($id)
   {
      $this->site=$id;
   }
   
   function SetDept($id)
   {
      $this->dept=$id;
   }
   
   function SetGroup($id)
   {
      $this->group=$id;
   }
   
   function SetSubGroup($id)
   {
      $this->subgroup=$id;
   }
   
   function SetSubType($sb)
   {
      if($sb!="employee" || $sb!="station" || $sb!="user") return false;
      $this->subtype=$sb;
      return true;
   }
   
   function formhdr()
   {
      echo "<input type=\"hidden\" name=\"siteid\" value=\"$this->siteid\">";
      echo "<input type=\"hidden\" name=\"deptid\" value=\"$this->deptid\">";
      echo "<input type=\"hidden\" name=\"groupid\" value=\"$this->groupid\">";
      if($this->subtype=="employee"){ 
         echo "<input type=\"hidden\" name=\"employeeid\" value=\"$this->subgroup\">";
      }
      else if($this->subtype=="station"){
         echo "<input type=\"hidden\" name=\"stationid\" value=\"$this->subgroup\">";
      }      
      else if($this->subtype=="user"){
         echo "<input type=\"hidden\" name=\"userid\" value=\"$this->subgroup\">";
      }
   }
   
   function SetSelType($sg)
   {
      if($sg!="site" || $sg!="department" || $sg!="group") return false;
      $this->selgroup=$sg;
      return true;
   }
   
   function SiteCombo($a="browse", $id=0, $action=false)
   {
      if($a=="commit" || $a=="add" || $a=="cfmdelete"){
         $result=$_SESSION['VxCFG']->dbh->Execute($org_qry1);
         if($result->RecordCount() == 0){
            echo _("Not Set");
            return;
         }
         if($result->RecordCount() == 1 && $a=="cfmdelete"){
            echo _("The are no other sites defined");
            return;
         }
         if($action)
            echo "<select name=\"orgsite\" onChange=\"this.form.submit();\">";
         else
   	      echo "<select name=\"orgsite\">\n";
            
         if($id==0){
            echo "<option selected value=\"0\">". _("All Sites")."</option>\n";
         }
         else{
   		   echo "<option value=\"0\">". _("All Sites")."</option>\n";
      	}
	      while($row = $result->FetchRow()){
		      $boo=$row["id"];
   		   $poo=$row["name"];
            if(($a=="cfmdelete" && $id!=$boo) || $a !="cfmdelete"){
      	   	if($id==$boo){
	      	   	echo "<option selected value=\"$boo\"> $poo </option>\n";
   	      	}
	   	      else{
   		   	   echo "<option value=\"$boo\"> $poo </option>\n";
      		   }
            }
	      }
   	   echo "</select>\n";
      }
      else{
         $qry=sprintf(org_qry2, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result->RecordCount() == 0){
            echo _("Not Set");
            return;
         }
         if($row = $result->FetchRow()){
            echo $row[0];
         }
      }
   }

   function DeptCombo($a="browse", $id=0, $action=false)
   {
      if($a=="commit" || $a=="add" || $a=="cfmdelete"){
   	   $result=$_SESSION['VxCFG']->dbh->Execute(org_qry3);
         if($result->RecordCount() == 0){
            echo _("Not Set");
            return;
         }
         if($result->RecordCount() == 1 && $a=="cfmdelete"){
            echo _("The are no other departments defined");
            return;
         }
         if($action)
            echo "<select name=\"orgdept\" onChange=\"this.form.submit();\">";
         else
   	      echo "<select name=\"orgdept\">\n";
         if($id==0){
            echo "<option selected value=\"0\">". _("All Departments")."</option>\n";
         }
         else{
   		   echo "<option value=\"0\">". _("All Departments")."</option>\n";
      	}
	      while($row = $result->FetchRow()){
		      $boo=$row["id"];
   		   $poo=$row["name"];
            if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
	      	   if($id==$boo){
   	   	   	print "<option selected value=\"$boo\"> $poo </option>\n";
	   	      }
   	   	   else{
	   	   	   print "<option value=\"$boo\"> $poo </option>\n";
   		      }
            }
	      }
         echo "</select>\n";
      }
      else{
         $qry=sprintf(org_qry4, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result->RecordCount() == 0){
           echo _("Not Set");
            return;
         }
         if($row = $result->FetchRow()){
            echo $row[0];
         }
      }
   }
   
   function GroupCombo($a="browse", $id=0)
   {
      if($a=="commit" || $a=="add" || $a=="cfmdelete"){
   	   $result=$_SESSION['VxCFG']->dbh->Execute(org_qry5);
         if($result->RecordCount() == 0){
            echo "There are no groups defined for this department";
            return;
         }
         if($action)
            echo "<select name=\"orggroup\" onChange=\"this.form.submit();\">";
         else
   	      echo "<select name=\"orggroup\">\n";
         if($id==0){
            echo "<option selected value=\"0\">". _("All Groups")."</option>\n";
         }
         else{
   		   echo "<option value=\"0\">". _("All Groups")."</option>\n";
      	}
	      while($row = $result->FetchRow()){
		      $boo=$row["id"];
   		   $poo=$row["name"];
            if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
      	   	if($id==$boo){
	      	   	print "<option selected value=\"$boo\"> $poo </option>\n";
   	      	}
	   	      else{
		   	      print "<option value=\"$boo\"> $poo </option>\n";
      		   }
            }
	      }
      	echo "</select>\n";
      }
      else{
         $qry=sprintf(org_qry6, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if(!isset($result)){
            echo "Not Set";
            return;
         }
         if($result->RecordCount() == 0){
            echo "Not Set";
            return;
         }
         else{
            $row = $result->FetchRow();
            echo $row[0];
         }
      }
   }
   
   function StationCombo($a, $id)
   {
      if($a=="commit" || $a=="add" || $a=="cfmdelete"){
   	   $result=$_SESSION['VxCFG']->dbh->Execute(org_qry7);
         if($result->RecordCount() == 0){
           echo "Not Set";
            return;
         }
         if($result->RecordCount() == 1 && $a=="cfmdelete"){
            echo "The are no other stations defined";
            return;
         }
   	   echo "<select name=\"stationid\">\n";
         if($id==0){
            echo "<option selected value=\"0\">". _("All Stations")."</option>\n";
         }
         else{
   		   echo "<option value=\"0\">". _("All Stations")."</option>\n";
      	}
	      while($row = $result->FetchRow()){
		      $boo=$row["id"];
   		   $poo=$row["name"];
            if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
      	   	if($id==$boo){
	      	   	print "<option selected value=\"$boo\"> $poo </option>\n";
   	      	}
	   	      else{
		   	      print "<option value=\"$boo\"> $poo </option>\n";
         		}
            }
	      }
      	echo "</select>\n";
      }
      else{
         $qry=sprintf(org_qry8, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result->RecordCount() == 0){
           echo "Not Set";
            return;
         }
         if($row = $result->FetchRow()){
            echo $row[0];
         }
      }
   }

   function EmpCombo($a, $id)
   {
      if($a=="commit" || $a=="add" || $a=="cfmdelete"){
         $q = sprintf(org_qry9, $this->employeeid);
         $result=$_SESSION['VxCFG']->dbh->Execute($q) or die('bum employee query.'); 
         $n = $result->FetchRow();
         if(!$n){
            echo _("The are no employees defined");
            return;
         }
         if($result->RecordCount() == 0){
           echo _("Not Set");
            return;
         }
         
         //echo "<select name=\"orgemp\" onChange=\"this.form.submit();\" class=\"orgctrl\">";
         //echo "<option value=\"0\" class=\"orgctl\" selected>- "._("All Employees")." - &nbsp;</option>\n";
         
   	   echo "<select name=\"employeeid\">\n";
         if($id==0){
            echo "<option selected value=\"0\">". _("All Employees")."</option>\n";
         }
         else{
   		   echo "<option value=\"0\">". _("All Employees")."</option>\n";
      	}
	      while($row = $result->FetchRow()){
            $q = sprintf(org_qry10, $n['contactid']);
            $result=$_SESSION['VxCFG']->dbh->Execute($q) or die('bum contact query.'); 
            $n = $result->FetchRow();
            if(!$n){
               return 4;
            }
            $poo=$n['firstname']." ".$n['lastname'];
		      $boo=$row["id"];
            if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
      	   	if($id==$boo){
	      	   	print "<option selected value=\"$boo\"> $poo </option>\n";
   	      	}
	   	      else{
		   	      print "<option value=\"$boo\"> $poo </option>\n";
         		}
            }
	      }
      	echo "</select>\n";
      }
      else{
         $qry=sprintf(bhlib_qry12, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result->RecordCount() == 0){
           echo _("Not Set");
            return;
         }
         if($row = $result->FetchRow()){
            echo $row[0];
         }
      }
   }


   function fillDeptFromSiteCombo($a, $siteid)
   {
      if($a=="commit" || $a=="add" || $a=="cfmdelete"){
         $qry=sprintf(bhlib_qry15, $siteid);
	      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result->RecordCount() == 0){
            echo "There are no departments defined for this sites";
            return;
         }
	      echo "<select name=\"deptid\" width=\"250\">\n";
   	   while($row = $result->FetchRow()){
	   	   $boo=$row["id"];
   	   	$poo=$row["name"];
            if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
   	   	   if($id==$boo){
      		   	print "<option selected value=\"$boo\"> $poo </option>\n";
	      	   }
   	      	else{
	   	      	print "<option value=\"$boo\"> $poo </option>\n";
   		      }
            }
	      }
         echo "</select>\n";
      }
   }

   function fillGroupFromDeptCombo($a, $deptid)
   {
      if($a=="commit" || $a=="add" || $a=="cfmdelete"){
         $qry=sprintf(bhlib_qry16, $deptid);
   	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result->RecordCount() == 0){
            echo "Not Set";
            return;
         }
         if($result->RecordCount() == 1 && $a=="cfmdelete"){
            echo "The are no other departments defined";
            return;
         }
	      echo "<select name=\"deptid\" width=\"250\">\n";
	      while($row = $result->FetchRow()){
		      $boo=$row["id"];
      		$poo=$row["name"];
            if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
	      	   if($id==$boo){
   		      	print "<option selected value=\"$boo\"> $poo </option>\n";
	   	      }
      	   	else{
	      	   	print "<option value=\"$boo\"> $poo </option>\n";
   	   	   }
            }
   	   }
         echo "</select>\n";
      }
      else{
         $qry=sprintf(bhlib_qry8, $deptid);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result->RecordCount() == 0){
           echo "Not Set";
            return;
         }
         if($row = $result->FetchRow()){
            echo $row[0];
         }
      }
   }

   function StationEntered($a, $id)
   {
      $s=substr($id, 0, 5);
      $d=substr($id, 5, 5);
      $g=substr($id, 10, 5);
      $n=substr($id, 15, 5);
   
      echo "<table width=\"100%\" border=\"1\"><tr>\n";
      echo "<td align=\"right\" nowrap>Site</td><td nowrap>";
      SiteCombo($a, $s);
      echo "</td>\n";
      echo "<td align=\"right\" nowrap>Department</td><td nowrap>";
      DeptCombo($a, $d);
      echo "</td></tr><tr><td align=\"right\" nowrap>Group</td>";
      echo "<td nowrap>";
      GroupCombo($a, $g);
      echo "</td>\n<td align=\"right\" nowrap>Station</td>";
      echo "<td nowrap>";
      StationCombo($a, $n);
      echo "</td>";
      echo "</tr></table>\n";
   }

   function StationEnteredControl($a, $id)
   {
      $s=substr($id, 0, 5);
      $d=substr($id, 5, 5);
      $g=substr($id, 10, 5);
      $n=substr($id, 15, 5);
   
      echo "<table width=\"100%\" border=\"1\"><tr>\n";
      echo "<td align=\"right\" nowrap>Site</td><td nowrap>";
      SiteCombo($a, $s);
      echo "</td>\n";
      echo "<td align=\"right\" nowrap>Department</td><td nowrap>";
      DeptFromSiteCombo($a, $s);
      echo "</td></tr><tr><td align=\"right\" nowrap>Group</td>";
      echo "<td nowrap>";
      GroupFromDeptCombo($a, $d);
      echo "</td>\n<td align=\"right\" nowrap>Station</td>";
      echo "<td nowrap>";
      StationFromGroupCombo($a, $g);
      echo "</td>";
      echo "</tr></table>\n";
   }

   function EmpEntered($a, $id)
   {
      $s=substr($id, 0, 5);
      $d=substr($id, 5, 5);
      $g=substr($id, 10, 5);
      $n=substr($id, 15, 5);
   
      echo "<table width=\"100%\" border=\"1\"><tr>\n";
      echo "<td align=\"right\" nowrap>Site</td><td nowrap>";
      SiteCombo($a, $s);
      echo "</td>\n";
      echo "<td align=\"right\" nowrap>Department</td><td nowrap>";
      DeptCombo($a, $d);
      echo "</td></tr><tr><td align=\"right\" nowrap>Group</td>";
      echo "<td nowrap>";
      GroupCombo($a, $g);
      echo "</td>\n<td align=\"right\" nowrap>Station</td>";
      echo "<td nowrap>";
      EmpCombo($a, $n);
      echo "</td>";
      echo "</tr></table>\n";
   }

   function EmpEnteredControl($a, $id)
   {
      $s=substr($id, 0, 5);
      $d=substr($id, 5, 5);
      $g=substr($id, 10, 5);
      $n=substr($id, 15, 5);
   
      echo "<table width=\"100%\" border=\"1\"><tr>\n";
      echo "<td align=\"right\" nowrap>Site</td><td nowrap>";
      SiteCombo($a, $s);
      echo "</td>\n";
      echo "<td align=\"right\" nowrap>Department</td><td nowrap>";
      DeptFromSiteCombo($a, $s);
      echo "</td></tr><tr><td align=\"right\" nowrap>Group</td>";
      echo "<td nowrap>";
      GroupFromDeptCombo($a, $d);
      echo "</td>\n<td align=\"right\" nowrap>Station</td>";
      echo "<td nowrap>";
      EmpFromGroupCombo($a, $g);
      echo "</td>";
      echo "</tr></table>\n";
   }
   
   function ControlEmp($a, $id, $sid, $did, $gid, $eid)
   {
      echo "<form>\n";
      formhdr();
      echo "<table width=\"100%\" border=\"0\"><tr>\n";
      echo "<td align=\"right\" nowrap>Site</td><td nowrap>";
      SiteCombo($a, $sid, true);
      echo "</td>\n";
      echo "<td align=\"right\" nowrap>Department</td><td nowrap>";
      DeptFromSiteCombo($a, $did, true);
      echo "</td></tr><tr><td align=\"right\" nowrap>Group</td>";
      echo "<td nowrap>";
      GroupFromDeptCombo($a, $gid, true);
      echo "</td>\n<td align=\"right\" nowrap>Station</td>";
      echo "<td nowrap>";
      EmpFromGroupCombo($a, $eid, true);
      echo "</td>";
      echo "</tr></table>\n";
   }
   
   
   function Control($a)
   {
      echo "<form method=\"post\" action=". $_SERVER['PHP_SELF']."\">\n";
      formhdr();
      echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"emplist\">\n";
	   echo "<tr>\n";
	   echo "<td colspan=\"2\">";
      
      if($this->siteid==0){ // all sites
         // have a site combo, but text the rest
         echo "<table><tr><td>";
         SiteCombo('commit');
         echo "</td><td>". _("All Departments")."</td><td>"._("All Groups")."</td>\n</tr>\n</table>\n";
         echo "</td></tr>\n";
      }
      else{ // have a site
         if($this->deptid==0){ // all depts
            echo "<table><tr><td>";
            SiteCombo('commit', $this->siteid);
            echo "</td><td>";
            DeptCombo('commit', 0);
            echo "</td><td>"._("All Groups")."</td>\n</tr>\n</table>\n";
            echo "</td></tr>\n";
            $qry=sprintf(org_qry11,$this->siteid);
            $result=$_SESSION['VxCFG']->dbh->Execute($qry);
            while($row = $result->FetchRow()){
               $qry=sprintf(org_qry12,$row['id']);
               $dresult=$_SESSION['VxCFG']->dbh->Execute($qry);
               while($drow = $dresult->FetchRow()){
                  $qry=sprintf(org_qry13, $row['id']);
                  $gresult=$_SESSION['VxCFG']->dbh->Execute($qry);
                  while($grow = $gresult->FetchRow()){
                     // table it
                     echo "<tr>\n";
                     echo "<td width=\"20%\" align=\"right\">"._("Forename")."</td>\n";
                     echo "<td>";
	                  entry($a, "firstname", 68, 64, $row['firstname']);
   	               echo"</td>\n";
	                  echo "</tr>\n";
                  }
               }
            }
         }
         else{ // have a dept
            if($groupid==0){ // all groups
               echo "<table><tr><td>";
               SiteCombo('commit', $this->siteid);
               echo "</td><td>";
               DeptCombo('commit', $this->deptid);
               echo "</td><td>";
               GroupCombo('commit', 0);
               echo "</td>\n</tr>\n</table>\n";
               echo "</td></tr>\n";
            
               $qry=sprintf(org_qry12,$this->deptid);
               $result=$_SESSION['VxCFG']->dbh->Execute($qry);
               while($row = $result->FetchRow()){
                  $qry=sprintf(org_qry13, $row['id']);
                  $gresult=$_SESSION['VxCFG']->dbh->Execute($qry);
                  while($grow = $gresult->FetchRow()){
                     // table it
                  }
               }
            }
            else{ // have a group
               echo "<table><tr><td>";
               SiteCombo('commit', $this->siteid);
               echo "</td><td>";
               DeptCombo('commit', $this->deptid);
               echo "</td><td>";
               GroupCombo('commit', $this->groupid);
               echo "</td>\n</tr>\n</table>\n";
               echo "</td></tr>\n";
               if($this->subtype=="employee"){ 
               }
               else if($this->subtype=="station"){
               }      
               else if($this->subtype=="user"){
               }/*
               $qry=sprintf(org_qry13, $this->groupid);
               $gresult=$_SESSION['VxCFG']->dbh->Execute($qry);
               while(($grow = $gresult->FetchRow())){
                  // table it
               }*/
            }
         }
      }
      
  	   echo "</table>\n</form>\n";
   }
}

?>
