 <?php
/*
purchase.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
   
class POItem
{
	var $id;
   var $purchaseorderid;
   var $quantity;
   var $inventoryid;
   var $status;

	function POItem($id=0, $bOffset=false)
	{
      if($id!=0){
         return $this->Fill($id, $bOffset);
      }
      
		$this->id=0;
      $this->purchaseorderid=0;
      $this->quantity=0;
      $this->inventoryid=0;
      $this->status=0;
      
      return false;
	}
   
   function Fill($id, $bOffset=false)
	{
      if($id!=0){
         if($bOffset){
            $qry=sprintf(purchase_porderitem_qry2, $id);
         }
         else{
            $qry=sprintf(purchase_porderitem_qry3, $id);
         }
	      $result=db_query($qry);
         if($result){
	         if($row = $result->FetchRow()){
               $this->id=$id;
               $this->purchaseorderid=$row['purchaseorderid'];
               $this->quantity=$row['quantity'];
               $this->inventoryid=$row['inventoryid'];
               $this->status=$row['status'];
               
               return true;
            }
         }
      }
      
		$this->id=0;
      $this->purchaseorderid=0;
      $this->quantity=0;
      $this->inventoryid=0;
      $this->status=0;
      
      return false;
	}
   
   function Set($a,$b,$c,$d)
   {
      $this->purchaseorderid=$a;
      $this->quantity=$b;
      $this->inventoryid=$c;
      $this->status=$d;
   }
   
   function setfromform($frm)
   {
      $this->purchaseorderid=$frm['purchaseorderid'];
      $this->quantity=$frm['quantity'];
      $this->inventoryid=$frm['inventoryid'];
      $this->status=$frm['status'];
   }
   
   function Add()
   {
      $qry=sprintf(purchase_porderitem_qry8, $this->purchaseorderid,$this->quantity,$this->inventoryid,$this->status);
      db_query($qry);
       
       $result=db_query(misc_qry1);
       if($row = $result->FetchRow()){
          $this->id=$row[0];
       }
       return $this->id;
   }
   
   function Commit($id)
   {
      $qry=sprintf(purchase_porderitem_qry4, $this->purchaseorderid,$this->quantity,$this->inventoryid,$this->status, $id);
      db_query($qry);
   }
   
   function Delete()
   {
      if(isset($this->id)){
         $qry=sprintf(purchase_porderitem_qry5, $this->id);
         db_query($qry);
      }
   }
   
   /**
    * GetTotal
    *
    * Helper function to check on price breaks to calc the correct
    * total from quantity.
    */
   function SetQuantity($qty)
   {
      $this->quantity=$qty;
   }
   
   function GetQuantity()
   {
      return $this->quantity;
   }
   
   function GetTotal($qty)
   {
   }
   
   function StatusCombo()
   {
   }
   
   function FillRow($a, $id)
   {
      if($a=="commit" || $a=="add"){
         $this->Fill($id, false);
      }
      else{
         $this->Fill($id, true);
      }
      
      $qry=sprintf(purchase_purchase_qry13, $this->inventoryid);
      $result=db_query($qry);
      $row=$result->FetchRow();
      //$bqid=$row[
      
      $qry=sprintf(purchase_purchase_qry14, $this->inventoryid);
      $result=db_query($qry);
      $prow=$presult->FetchRow();
      
      $stotal=0.00;
      echo "<tr><td>".$prow['plu']." - ".$row['name']."</td><td>$this->quantity</td><td>$stotal</td></tr>";
   }
}

class PurchaseOrder
{
   var $id;
   var $purchaseorderid;
   var $purchasenumber;
   var $statusid;
   var $name;
   var $cmid;
   var $dispatchdate;
   var $arriveddate;
   var $supplierid;
   var $shippingid;
   var $requestedby;
   var $approvedby;
   var $accountid;
   var $transactionid;
   var $linkid;
   var $items;

	function PurchaseOrder($id=0, $bOffset=false)
	{
      if($id!=0){
         return $this->Fill($id, $bOffset);
      }
      $this->id=0;
      $this->purchaseorderid=0;
      $this->purchasenumber=0;
      $this->statusid=0;
      $this->name=0;
      $this->cmid=0;
      $this->dispatchdate=0;
      $this->arriveddate=0;
      $this->supplierid=0;
      $this->shippingid=0;
      $this->requestedby=0;
      $this->approvedby=0;
      $this->accountid=0;
      $this->transactionid=0;
      $this->linkid=0;
	}

	function cleanup() 
	{
		foreach($this->items as $i){
			unset($this->items[$i]);
		}
	}
   
   function Fill($id, $bOffset=false)
   {
      if($id!=0){
         if($bOffset){
            $qry=sprintf(purchase_purchase_qry2, $id);
         }
         else{
            $qry=sprintf(purchase_purchase_qry3, $id);
         }
	      $result=db_query($qry);
         if($result){
	         if($row = $result->FetchRow()){
               $this->id=$id;
               $this->purchaseorderid=$row['purchaseorderid'];
               $this->purchasenumber=$row['purchasenumber'];
               $this->statusid=$row['statusid'];
               $this->name=$row['name'];
               $this->cmid=$row['cmid'];
               $this->dispatchdate=$row['dispatchdate'];
               $this->arriveddate=$row['arriveddate'];
               $this->supplierid=$row['supplierid'];
               $this->shippingid=$row['shippingid'];
               $this->requestedby=$row['requestedby'];
               $this->approvedby=$row['approvedby'];
               $this->accountid=$row['accountid'];
               $this->transactionid=$row['transactionid'];
               $this->linkid=$row['linkid'];
               //$this->items=$row[''];
               
               return true;
            }
         }
      }
      
		$this->id=0;
      $this->purchaseorderid=0;
      $this->purchasenumber=0;
      $this->statusid=0;
      $this->name=0;
      $this->cmid=0;
      $this->dispatchdate=0;
      $this->arriveddate=0;
      $this->supplierid=0;
      $this->shippingid=0;
      $this->requestedby=0;
      $this->approvedby=0;
      $this->accountid=0;
      $this->transactionid=0;
      $this->linkid=0;
      
      return false;
   }
   
	function Add() 
	{
	}
   
   function Commit() 
	{
      if(!isset($this->id)){
         return false;
      }
	}
   
   function ItemExists($poitem)
   {
      $qry=sprintf(purchase_porderitem_qry13, $poitem->ipurchaseorderid, $poitem->inventoryid);
      $result=db_query($qry);
      if(!$result) return false;
      if(db_num_rows($result)==0) return false;
      
      return true;
   }
   
   function Delete() 
	{
      if(!isset($this->id)){
         return false;
      }
      $qry=sprintf(purchase_porderitem_qry12, $id);
      $result=db_query($qry);
      
      $qry=sprintf(purchase_purchase_qry5, $id);
      $result=db_query($qry);
      
      return true;
	}
   
   function SetSupplierID($sid)
   {
      $this->supplierid=$sid;
   }
   
   function Combo($a, $id, $cname)
   {
   }
   
   function InventoryCombo($a, $id, $cname)
   {
      $qry=sprintf(purchase_purchase_qry11, $id);
      $result=db_query($qry);
      if(!isset($result)) return false;
	   
      echo "<select name=\"$cname\">\n";
      
      while($row = $result->FetchRow()){
         $bqid=$row['id'];
         $qry=sprintf(purchase_purchase_qry12, $bqid);
         $sresult=db_query($qry);
         if(!isset($sresult)) return false;
        
         if($srow = $sresult->FetchRow()){
            $iid=$row["id"];
            $qry=sprintf(purchase_purchase_qry13, $iid);
			   $presult=db_query($qry);
            $prow=$presult->FetchRow();
            if($id==$iid){
      		   echo "<option selected value=\"$iid\">".$prow['plu']." - ".$prow['name']."</option>\n";
	      	}
      	   else{
	      	  	echo "<option value=\"$iid\">".$prow['plu']." - ".$prow['name']."</option>\n";
   	   	}
         }
      }
      echo "</select>\n";
   }
   
   function Table($a, $id, $title, $bInside=false)
   {
      if($a=="commit" || $a=="add"){
         $this->Fill($id, false);
      }
      else{
         $this->Fill($id, true);
      }
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"address\">\n";
         echo "<tr>\n";
	      echo "<td colspan=\"2\" align=\"center\"><h3>$title</h3></td></tr>\n";
      }
      $this->supplierid=2;
      echo "<tr><td class=\"label\">Purchase Number</td>\n<td>\n";
	   entry($a, "purchasenumber", 32, 32, $this->purchasenumber);
   	echo "</td>\n</tr>\n";
      
      echo "<tr><td class=\"label\">Supplier</td>\n<td>\n";
      fillSupplierCombo($a, "supplierid", $this->supplierid);
      echo "</td>\n</tr>\n";
      
      echo "<tr><td class=\"tinsert\" colspan=\"2\">\n";
      $cm=new CreateMod();
      $cm->Fill($this->cmid);
      $cm->FillTable();
      echo "</td></tr>\n";

      echo "<tr>\n<td class=\"label\">Dispatch Date</td>\n<td>";
      $td=new TimeDate();
      if($a=="commit" || $a=="add"){
		   $result=db_query(login_qry1);
   		if($row = $result->FetchRow()){
            $td->parse($row[0]);
         }
      }
      else{
         $td->parse($this->dispatchdate);
      }
      $td->tscontrol($a, "dispatchdate");
      echo"</td>\n</tr>\n<tr>\n";
      
      echo "<td class=\"label\">Arrived Date</td>\n";
      echo "<td>";
      $td=new TimeDate();
      if($a=="commit" || $a=="add"){
		   $result=db_query(login_qry1);
   		if($row = $result->FetchRow()){
            $td->parse($row[0]);
         }
      }
      else{
         $td->parse($this->arriveddate);
      }
      $td->tscontrol($a, "arriveddate");
      echo"</td>\n</tr>\n<tr>\n";
      
      if(!$bInside){
   	   echo "</table>\n";
      }
      $this->ItemTable($a, $id, "Items", false);  
   }

   function ItemTable($a, $id, $title, $bInside=false)
   {
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"address\">\n";
         echo "<tr>\n";
	      echo "<td colspan=\"3\" align=\"center\"><h3>$title</h3></td></tr>\n";
      }
      echo "<tr><td class=\"label\">Product</td><td class=\"label\">Quantity</td><td class=\"label\">Subtotal</td>\n";
      
      $qry=sprintf(purchase_porderitem_qry11, $id);
      $result=db_query($qry);
      if(!isset($result)) return false;
      
      if(db_num_rows($result)==0){
         echo "<tr><td>\n";
         $this->InventoryCombo($a, $this->supplierid, "poitem");
         echo "</td>\n<td>\n";
         entry($a, "quantity", 32, 32, $this->quantity);
         echo "</td>\n";
         echo "<td align=\"right\">0.00</td>\n";
         echo "<td><input type=\"hidden\" name=\"action\" value=\"itemadd\">";
			echo "<input type=\"submit\" value=\"Add\">\n</td>\n";
         echo "</tr>\n";
         if(!$bInside){
   	      echo "</table>\n";
         }
         return;
      }
      $stotal=0.00;
      $poitem= new POItem();
      while($row = $result->FetchRow()){
         $poitem->Row("browse", $row['id']);
      }
      
      echo "<tr><td>\n";
      $this->InventoryCombo($a, $this->supplierid, "poitem");
      echo "</td>\n<td>\n";
      entry($a, "quantity", 32, 32, $this->quantity);
      echo "</td>\n";
      echo "<td align=\"right\">0.00</td>\n";
      echo "<td><input type=\"submit\" value=\"Add\">\n</td>\n";
      echo "</tr>\n";
         
      if(!$bInside){
   	   echo "</table>\n";
      }
   }
	

	function listAllSupplierProducts()
	{
		$result=db_query("SELECT ID FROM invpricequantity WHERE supplierID='$this->supplierID'");
		if(db_num_rows($result)==0){
			return 1;
		}
		$row = $result->FetchRow();
		$bqid=$row["ID"];
		db_free_result($result); 

		$result=db_query("SELECT ID from inventory WHERE BuyQuantityPriceID='$bqid'");
		if(db_num_rows($result)==0){
			return 2;
		}

		echo "<table border=\"0\" cellpadding=\"2\" width=\"100%\" bgcolor=\"#FFFFFF\">\n";
		echo "<tr><td colspan=\"5\" align=\"left\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">Items by Supplier</font></td></tr>";
		echo "<tr><td><b>PLU</b></td><td><b>Name</b></td><td><b>Price</b></td><td><b>Qty</b></td><td></td></tr>\n";

		while($row = $result->FetchRow()){
			$iid=$row["ID"];
			$presult=db_query("SELECT PLU, name from product WHERE invID='$iid'");
			if(db_num_rows($presult)==0){
			}
			else{
				echo "<td>'$row[PLU]'</td>\n";
				echo "<td>'$row[name]'</td>\n";
				echo "<td>$price</td>\n";
				echo "<td><input type=\"text\" name=\"Qty\" size=\"8\" maxlength=\"8\" value=\"$qty\"></td>\n";

				db_free_result($presult); 
			}
			echo "</tr>\n";
		}
		echo "</table>\n";
	}

	function addpitems($pid)
	{
		if(count($this->items)!=0){
			foreach($this->items as $num=>$ii){
				$iid=$ii->GetInvId();
				$qty=$ii->GetQty();
				db_query("INSERT INTO purchaseorderitems VALUES ('','$pid','$qty','$iid')");
			}
		}
		else{
			return 1;
		}
	}

	function buildItemList($title)
	{
		$count=0;
		$gtotal=0.00;
		$numi=$this->num_items;
		
		echo "<table border=\"0\" cellpadding=\"2\" width=\"100%\" bgcolor=\"#FFFFFF\">\n";
		echo "<tr><td colspan=\"6\" align=\"left\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">$title - $numi Items</font></td></tr>";
		echo "<tr><td><b>PLU</b></td><td><b>Qty</b></td><td><b>Name</b></td><td><b>Price</b></td><td><b>Sub</b></td><td></td></tr>\n";
		if(count($this->items)!=0){
			foreach($this->items as $num=>$ii){
				$count++;

				$plu=$ii->GetPLU();
				$qty=$ii->GetQty();
				$name=$ii->GetName();
				$price=$ii->GetPrice();
				$total=$ii->Total();
				$gtotal+=$total;

				if(($count%2)==0){
					echo "<tr bgcolor=\"#CCCCCC\">\n";
				}
				else{
					echo "<tr bgcolor=\"FFFFFF\">\n";
				}
				if($this->curr_item==$count){
					echo "<td><input type=\"text\" name=\"PLU\" size=\"16\" maxlength=\"13\" value=\"$plu\"></td>\n";
					echo "<td><input type=\"text\" name=\"Qty\" size=\"8\" maxlength=\"8\" value=\"$qty\"></td>\n";
					echo "<td><input type=\"text\" name=\"Name\" size=\"32\" maxlength=\"32\" value=\"$name\"></td>\n";
					echo "<td><input type=\"text\" name=\"Price\" size=\"8\" maxlength=\"12\" value=\"$price\"></td>\n";
					echo "<td><input type=\"text\" name=\"Sub\" size=\"10\" maxlength=\"12\" value=\"$total\"></td>\n";
					echo "<td><input type=\"hidden\" name=\"action\" value=\"itemedit\">\n";
					echo "<input type=\"hidden\" name=\"itemid\" value=\"$num\">\n";
					echo "<a href=\"purchase.php?action=itemedit&itemid=$num\">commit</a>\n</td>\n";
				}
				else{
					echo "<td>$plu</td>\n";
					echo "<td>$qty</td>\n";
					echo "<td>$name</td>\n";
					echo "<td>$price</td>\n";
					echo "<td>$total</td>\n";
					echo "<td><a href=\"purchase.php?action=itemeditsel&itemid=$num\">edit</a>&nbsp;\n";
					echo "<a href=\"purchase.php?action=itemdelete&itemid=$num\">delete</a>&nbsp;</td>\n";
				}
				echo "</tr>\n";
			}
		}
		if($this->curr_item==0){	// no current item so add field
			echo "<tr bgcolor=\"FFFFFF\">\n";
			//echo "<form name=\"purch\" method=\"post\" action=\"$_SERVER['PHP_SELF']\">\n";
			echo "<td><input type=\"text\" name=\"PLU\" size=\"16\" maxlength=\"13\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Qty\" size=\"8\" maxlength=\"8\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Name\" size=\"32\" maxlength=\"32\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Price\" size=\"8\" maxlength=\"12\" value=\"\"></td>\n";
			echo "<td><input type=\"text\" name=\"Sub\" size=\"10\" maxlength=\"12\" value=\"\"></td>\n";
			echo "<td><input type=\"hidden\" name=\"action\" value=\"itemadd\"></td>\n";
			echo "<td><input type=\"submit\" value=\"Add\">\n</td>\n";
			echo "</tr>\n";
		}
		echo "<tr><td colspan=\"4\" align=\"right\" bgcolor=\"#002277\"><font color=\"#FFFFFF\">Total</td>\n";
		echo "<td>$gtotal</font></td><td>&nbsp;</td></tr>\n";
		echo "</table>\n";
	}
   
   function buildCheckInList($title, $poid)
	{
      $result=db_query("SELECT * from purchaseorderitems WHERE PurchaseOrderID='$poid'");
      if(db_num_rows($result)==0){
         print "<br><br><center>No purchase order items found...</center>";
      }
      else{
      	echo "<br><br>";
      	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
   	   echo "<tr><td colspan=\"5\"><h2>Purchase Order Items for Order: $poid</h2></td></tr>\n";
      	echo "<tr><td><h3>PLU</h3></td><td><h3>Name</h3></td><td><h3>Qty</h3></td><td><h3>Status</h3></td></tr>\n";
	   	while($row = $result->FetchRow()){
		   	$qty=$row["Quantity"];
			   $invID=$row["InventoryID"];

      		$sresult=db_query("SELECT StockLocation FROM inventory WHERE ID='$invID'");
            $srow = $sresult->FetchRow();
            $sl=$srow["StockLocation"];

   			$sresult=db_query("SELECT PLU,name FROM product WHERE invID='$invID'");
	   		$srow = $sresult->FetchRow();
            $plu=$srow["PLU"];
			   $name=$srow["name"];
            
            // push back inv items with status=unknown
            $ni = new InvItem();
	         $ni->SetInvID($invID);
            $ni->SetQty($qty);
            $ni->SetStatus('unknown');
            $this->Add($ni);
            
	   		echo "<tr><td>$plu</td><td>$name</td><td>$qty</td><td>\n";
            $this->statuscombo('add', 'unknown',$invID);
            echo "</td></tr>\n";
		   }
   		echo "<tr><td align=\"center\" colspan=\"5\"><input type=\"submit\" value=\"Check Items In\"></td></tr>\n";
	   	echo "</table>\n";
	   }
   }
   
   function statuscombo($a,$tid,$id)
   {
      $typelist = array('unknown','ok','missing','damaged','wrongitem','underqty','overqty');
   
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"status:$id\" width=\"250\">\n";
	      foreach ($typelist as $typeid) {
	         print "<option ";
   	      if($tid == $typeid)
	            print "selected ";
   	      print "value='$typeid'>$typeid</option>\n";
	      }
	      echo "</select>\n";
      }
      else{
         echo $type;
      }
   }
   
   function checkItemsIn($frm)
	{
      db_query("INSERT INTO transaction VALUES()");
      $tid=db_insert_id();
      
      db_query("UPDATE purchaseorder SET transactionID='$tid' WHERE purchaseorderID='$pid'");
      
      foreach($items as $iitem){
         $invid=$iitem->GetInvID();
         if($frm["status.$invid"]=='ok'){
            // credit stock, update purchaseorderitems, remove from array
            
            $result=db_query("INSERT INTO transactionitems VALUES('', '$tid', NOW(),
            '$userID','$misip','ITEMTYPE_PURCHASE','$plu','$qty')");
         }
         else{
            // create discrepancy report for status!=ok,
         }
      }
   }
}

?>
