<?php

/**********************************************************************
 * 
 * Orders Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2005
 *
 **********************************************************************/
 
 /****************************************
 * stats queries
 ****************************************/
define("order_stats_qry1","select stamper from employeelog where actionid='10' and employeeid='%d'  order by stamper desc  limit 1");
define("order_stats_qry2","select count(*) from orders where dateplaced > '%s' and statusid='2'");
define("order_stats_qry3","select count(*) from orders where dateplaced > '%s' and statusid='9'");
define("order_stats_qry4","select count(*) from orders where dateplaced > '%s' and statusid='11'");
define("order_stats_qry5","select count(*) from orders where dateplaced > '%s' and statusid='12'");
define("order_stats_qry6","select count(*) from orders where dateplaced > '%s' and statusid='13'");
define("order_stats_qry7","select count(*) from orders where dateplaced > '%s' and statusid='14'");
define("order_stats_qry8","select count(*) from orders where dateplaced > '%s' and statusid='15'");
define("order_stats_qry9","select dateplaced from orders where dateplaced > '%s' and statusid='2'");
define("order_stats_qry10","select avg(to_days(shippeddate) - to_days(dateplaced)) as otavg, 
max(to_days(shippeddate) - to_days(dateplaced)) as otmin, min(to_days(shippeddate) - to_days(dateplaced)) as otmin 
from orders where 1");
define("order_stats_qry11","select date(now())- '%s'");
define("order_stats_qry12","select day(now())- '%s'");
define("order_stats_qry13","select count(*) as c, sum(total) as t from orders where shippeddate = date(now())- 1 and statusid='13'");
define("order_stats_qry14","select count(*) as c, sum(total) as t from orders where month(shippeddate)='%s' and statusid='13'");
define("order_stats_qry15","select date(now())");
define("order_stats_qry16","select month(now())");
define("order_stats_qry17","select year(now())");
define("order_stats_qry18","select count(*) as c, sum(total) as t from orders where shippeddate between '%s' and date(now()) and statusid='13'");
define("order_stats_qry19","select count(*) from orders where statusid='2'");
define("order_stats_qry20","select count(*) from orders where statusid='9'");
define("order_stats_qry21","select count(*) from orders where statusid='11'");
define("order_stats_qry22","select count(*) from orders where statusid='12'");
define("order_stats_qry23","select count(*) from orders where statusid='13'");
define("order_stats_qry24","select count(*) from orders where statusid='14'");

/****************************************
 * approval queries
 ****************************************/
define("order_approval_qry1", "select count(*) from orders where statusid='2'");
define("order_approval_qry2", "select * from orders where statusid='2' limit 1 offset %d");
define("order_approval_qry3", "select * from orders where statusid='2' and id = '%d'");
define("order_approval_qry4", "select * from orders where statusid='2' order by '%s' %s "); 
define("order_approval_qry5", "select * from orders where id = '%d'");
define("order_approval_qry6", "select id,productid,quantity from orderitems where orderid = '%d'");
define("order_approval_qry7", "select partnumber, stocklocation, description  from inventory where id = '%d'");
define("order_approval_qry8", "update orders set statusid='11' where id='%d'"); // read to pick
define("order_approval_qry9","select contactid from customer where id = '%d'");
define("order_approval_qry10","select titleid,firstname,lastname,addressid from contacts where id = '%d'");
define("order_approval_qry11","select count(*) from orderitems where orderid = '%d'");
define("order_approval_qry12","select count(*) from address where addressid = '%d'");
define("order_approval_qry13","select * from cardpayment where id = '%d'");
define("order_approval_qry14", "insert into ledgerentry values(0,'%d','%d','%d',now(),'%s','%s','%f','%s','%d')");
define("order_approval_qry15", "select contactid from employee where id='%d'");
define("order_approval_qry16",  "select firstname,lastname from contacts where id = '%d'");

/****************************************
 * order queries
 ****************************************/
define("order_order_qry1", "select count(*) from orders where statusid='2'");
define("order_order_qry2", "select * from orders where id = '%d' limit 1 offset %d");
define("order_order_qry3", "select * from orders where id = '%d'");
define("order_order_qry4", "select * from orders where statusid <> '14' order by '%s' %s "); 
define("order_order_qry5", "select * from orders where id = '%d'");
define("order_order_qry6", "select id,productid,quantity from orderitems where orderid = '%d'");
define("order_order_qry7", "select partnumber, stocklocation, description  from inventory where id = '%d'");
define("order_order_qry8", "update orders set statusid='32' where id='%d'"); // read to package
define("order_order_qry9", "update orders set statusid='28' where id='%d'"); // dispatched
define("order_order_qry10","select contactid from customer where id = '%d'");
define("order_order_qry11","select titleid,firstname,lastname,addressid from contacts where id = '%d'");
define("order_order_qry12","select count(*) from orderitems where orderid = '%d'");
define("order_order_qry13","select count(*) from address where addressid = '%d'");
define("order_order_qry14","select id, name from orderstatus");
define("order_order_qry15","select name from orderstatus where id='%d'");
define("order_order_qry16","insert into orders values(0,'%d','%s','%d','%d','%d','%s','%s','%s','%s',
'%s','%f','%f','%f','%f','%d','%d','%d','%d'");
define("order_order_qry17","update orders set orderid='%d',ordernumber='%s',enteredby='%d',customerid='%d',
statusid='%d',waitonallitems='%s',dateplaced='%s',daterequired='%s',billeddate='%s',
shippeddate='%s',subtotal='%f',shipcost='%f',tax='%f',total='%f',basecurrencyid='%d',ledgerentryid='%d',
transactionid='%d',shipmethodid='%d' where id='%d'");
define("order_order_qry18", "select * from orders where dateplaced between '%s' and '%s' order by '%s' %s "); 
define("order_order_qry19", "select * from orders where statusid='%d' and dateplaced between '%s' and '%s' order by '%s' %s "); 
define("order_order_qry20", "select * from orders where customerid='%d' order by '%s' %s "); 
define("order_order_qry21", "select * from orders where customerid='%d' and statusid='%d' order by '%s' %s "); 
define("order_order_qry22","select CURDATE()");
define("order_order_qry23", "select * from period where id = '%d'");

?>
