<?php
/**********************************************************************
 * 
 * Product Maintenance Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/

/****************************************
 * product queries
 ****************************************/
define("productm_product_qry1", "select count(*) from product");
define("productm_product_qry2", "select * from product limit 1 offset %d");
define("productm_product_qry3", "select * from product where id = '%d'");
define("productm_product_qry4", "insert into product values('','%d','%d','%d','%d','%s','%d','%s','%s','%d','%s','%d',
   '%s','%d','%d','%d','%d','%s','%d','%s','%d','%d','%s')");
define("productm_product_qry6", "delete from product where id = '%d'");
define("productm_product_qry7", "select * from product order by '%s' %s "); 
define("productm_product_qry8", "update product set sellquantityid='%d' where id='%d'"); 
define("productm_product_qry9", "select invid, sellquantityid from product where id = '%d'"); 
define("productm_product_qry10", "select id,invid,sellquantityid from product where invid = '%d'");
define("productm_product_qry11", "select plu,plutype,name,description from product where id = '%d'");
define("productm_product_qry12", "select categoryid from productcategory where productid = '%d'");
define("productm_product_qry13", "select name from category where id = '%d'");
define("productm_product_qry14", "select id,name from category where id = '%d'");
define("productm_product_qry15", "select id,name from category");
define("productm_product_qry16", "insert into inventory values('','%d','%d','%s','%d','%s','%s','%d','%d','%d','%d','%d',
       '%d','%d','%d','%d','%d'");
define("productm_product_qry17", "insert into invpricequantity values ('','%d','%d','%d','%d','%d','%f','%d','%d','%s','%d','%d','%d')");
define("productm_product_qry18", "update invpricequantity set invprqid='%d' where id='%d'");
define("productm_product_qry19", "update inventory set buyquantitypriceid='%d' where id = '%d'");
define("productm_product_qry20", "insert into productcategory values('%d','%d')");
define("productm_product_qry21", "select id from imagedata where reffile='%s'");
define("productm_product_qry22", "insert into imagedata values('','%d','%s','%d','%d','%d','%d')");
define("productm_product_qry23", "select product.instock,maxstock,onorder,rolevel,roqty,reservedqty from inventory, 
   product where inventory.id=product.invid and product.id='%d'");
define("productm_product_qry24", "select ipq.supplierid, ipq.suppliercode, s.name, i.buyquantitypriceid, p.invid
   from invpricequantity as ipq, supplier as s, inventory as i, product as p where p.invid=i.id and 
   i.buyquantitypriceid=ipq.invprqid and s.id=ipq.supplierid and p.id='%d'");
define("productm_product_qry25", "select ipq.* from invpricequantity as ipq, supplier as s, inventory as i, 
   product as p where p.invid=i.id and i.buyquantitypriceid=ipq.invprqid and product.id='%d'");
define("productm_product_qry26", "select ipq.supplierid, ipq.suppliercode, s.name from invpricequantity as ipq, 
   supplier as s, inventory as i, product as p where p.invid=i.id and i.buyquantitypriceid=ipq.invprqid and 
   product.id='%d'");
define("productm_product_qry27", "insert into prodpricequantity values(0,'%d','%d','%d','%d','%d','%f','%d','%d')");
define("productm_product_qry28", "update prodpricequantity set pqid='%d' where id='%d'");

/****************************************
 * category queries
 ****************************************/
define("productm_category_qry1", "select count(*) from category");
define("productm_category_qry2", "select * from category order by id limit 1 offset %d");
define("productm_category_qry3", "select * from category where id = '%d'");
define("productm_category_qry4", "insert into category values('','%d','%s','%s','%s')");
define("productm_category_qry5", "update category set parentid='%d',name='%s',description='%s',eonsite='%s'	where id = '%d'");
//define("productm_category_qry6", "update category set name='unused' where id = '%d'");
define("productm_category_qry6", "delete from category where id = '%d'");
define("productm_category_qry7", "select * from category order by id");
define("productm_category_qry8", "select distinct parentid from category order by parentid");
define("productm_category_qry9", "select * from category where parentid='%d'");
define("productm_category_qry10","select * from category order by '%s' %s "); 

/*****************************************
 * catorg queries
 *****************************************/
define("productm_catorg_qry1", "select * from category where parentid='0'");
define("productm_catorg_qry2", "select * from category where parentid='%d'");
define("productm_catorg_qry3", "select * from category where parentid='%d' order by name");

/****************************************
 * quantity queries
 ****************************************/
define("productm_quantity_qry1", "select count(*) from invitemquantitytype");
define("productm_quantity_qry2", "select * from invitemquantitytype limit 1 offset %d");
define("productm_quantity_qry3", "select * from invitemquantitytype where id = '%d'");
define("productm_quantity_qry4", "insert into invitemquantitytype values('','%s')");
define("productm_quantity_qry5", "update invitemquantitytype set name='%s' where id = '%d'");
define("productm_quantity_qry6", "select * from invitemquantitytype");
define("productm_quantity_qry7", "delete from invitemquantitytype where id='%d'");
define("productm_quantity_qry8", "select * from invitemquantitytype order by '%s' %s "); 

/****************************************
 * sellpq queries
 ****************************************/
define("productm_sellpq_qry1", "select count(*) from prodpricequantity");
define("productm_sellpq_qry2", "select * from prodpricequantity limit 1 offset %d");
define("productm_sellpq_qry3", "select * from prodpricequantity where id = '%d'");
define("productm_sellpq_qry4", "insert into prodpricequantity values('','%d','%d','%d','%d','%d','%f','%d','%d')");
define("productm_sellpq_qry5", "update prodpricequantity set pqid='%d',nameid='%d',quantity='%d',quantitytypeid='%d',
   udv='%d',price='%f',basecurrencyid='%d',taxid='%d' where id='%d'");
define("productm_sellpq_qry6", "delete from prodpricequantity where id='%d'");
define("productm_sellpq_qry7", "select * from prodpricequantity");
define("productm_sellpq_qry8", "select id, plu, name, description from product where sellquantityid='%d'");
define("productm_sellpq_qry9", "update prodpricequantity set price=(price + (price * %f)) where 1");
define("productm_sellpq_qry10", "select * from prodpricequantity order by '%s' %s "); 
define("productm_sellpq_qry11", "select id, name from pqname");
define("productm_sellpq_qry12", "select name from pqname where id='%d'");
define("productm_sellpq_qry13", "select * from invitemquantitytype");
define("productm_sellpq_qry14", "select * from invitemquantitytype where id = '%d'");
define("productm_sellpq_qry15", "select * from  taxrate");
define("productm_sellpq_qry16", "select name from account where id = '%d'");

/****************************************
 * sellpqname queries
 ****************************************/
define("productm_sellpqname_qry1", "select count(*) from pqname");
define("productm_sellpqname_qry2", "select * from pqname limit 1 offset %d");
define("productm_sellpqname_qry3", "select * from pqname where id = '%d'");
define("productm_sellpqname_qry4", "insert into pqname values('%s', '%d', '%s')");
define("productm_sellpqname_qry5", "update pqname set name='%s', accountid='%d',onmenu='%s' where id='%d'");
define("productm_sellpqname_qry6", "delete from pqname where id = '%d'");
define("productm_sellpqname_qry7", "select * from pqname");
define("productm_sellpqname_qry8", "select * from pqname order by '%s' %s ");
define("productm_sellpqname_qry9", "select name from account where id='%d'");

/****************************************
 * atttribute queries
 ****************************************/
define("productm_attribute_qry1", "select count(*) from productattribute");
define("productm_attribute_qry2", "select * from productattribute limit 1 offset %d");
define("productm_attribute_qry3", "select * from productattribute where id = '%d'");
define("productm_attribute_qry4", "insert into productattribute values('','%d','%d','%s','%f','%s','%d')");
define("productm_attribute_qry5", "update productattribute set depositid='%d',cmid='%d',name='%s',percentage='%f',
   refundable='%s',type='%d'where id = '%d'");
define("productm_attribute_qry6", "delete from productattribute where id = '%d'");
define("productm_attribute_qry7", "select * productattribute");
define("productm_attribute_qry8", "select * productattribute where attributeid='%s' order by '%s' %s ");

/****************************************
 * bpqname queries
 ****************************************/
define("bpqname_qry1", "select count(*) from bqname");
define("bpqname_qry2", "select * from bqname limit 1 offset %d");
define("bpqname_qry3", "select * from bqname where id = '%d'");
define("bpqname_qry4", "insert into bqname values('', '%s', '%d','%s')");
define("bpqname_qry5", "update bqname set name='%s',accountid='%d',onmenu='%s' where id = '%d'");
define("bpqname_qry6", "delete from bqname where id = '%d'");
define("bpqname_qry7", "select * from bqname");

/****************************************
 * collection queries
 ****************************************/
define("collection_qry1", "select count(*) from collection");
define("collection_qry2", "select * from collection limit 1 offset %d");
define("collection_qry3", "select * from collection where id = '%d'");
define("collection_qry4", "insert into collection values('', '%s','%s','%d')");
define("collection_qry5", "update collection set name='%s', description='%d', collectionid='%d' where id = '%d'");
define("collection_qry6", "delete from collection where id = '%d'");
define("collection_qry7", "select * from collection");
define("collection_qry8", "select id from product where plu = '%s'");
define("collection_qry9", "insert into productcollection values ('%d','%d')");
define("collection_qry10", "delete from productcollection where prodcollid = '%d' and productid='%d'");
define("collection_qry11", "select * from productcollection where prodcollid='%d'");
define("collection_qry12", "select name, plu, sellquantityid from product where id = '%d'");
define("collection_qry13", "select price from prodpricequantity where pqid = '%d' and nameid='1'");

/****************************************
 * deposit queries
 ****************************************/
define("deposit_qry1", "select count(*) from deposit");
define("deposit_qry2", "select * from deposit limit 1 offset %d");
define("deposit_qry3", "select * from deposit where id = '%d'");
define("deposit_qry4", "insert into deposit values('','%d','%d','%s','%f','%s','%d')");
define("deposit_qry5", "update deposit set depositid='%d',cmid='%d',name='%s',percentage='%f',
   refundable='%s',type='%d'where id = '%d'");
define("deposit_qry6", "delete from deposit where id = '%d'");
define("deposit_qry7", "select * from deposit");

/****************************************
 * invpricequantity queries
 ****************************************/
define("invpq_qry1", "select count(*) from invpricequantity");
define("invpq_qry2", "select * from invpricequantity limit 1 offset %d");
define("invpq_qry3", "select * from invpricequantity where id = '%d'");
define("invpq_qry4", "insert into invpricequantity values ('','%d','%d','%d','%d','%d','%f','%d','%d','%s','%d','%d','%d')");
define("invpq_qry5", "update invpricequantity set invprqid='%d',nameid='%d',quantity='%d',quantitytypeid='%d',udv='%d',
   price='%f',basecurrencyid='%d',supplierid='%d',suppliercode='%s',ediid='%d',accountid='%d',taxid='%d' where id='%d'");
define("invpq_qry6", "delete from invpricequantity where id='%d'");
define("invpq_qry7", "select * from invpricequantity");
define("invpq_qry8", "select id, description from inventory where buyquantitypriceid='%d'");

/****************************************
 * inventory queries
 ****************************************/
define("inventory_qry1", "select count(*) from inventory");
define("inventory_qry2", "select * from inventory limit 1 offset %d");
define("inventory_qry3", "select * from inventory where id = '%d'");
define("inventory_qry4", "select * from inventory");
define("inventory_qry5", "select * from invpricequantity where nameid='%d' and quantity='%d' and
      quantitytypeid='%d' and udv='%d' and price='%f' and basecurrencyid='%d' and supplierid='%d' and
		suppliercode='%s' and accountid='%d' and taxid='%d");
define("inventory_qry6", "insert into invpricequantity values(0,0,'%d','%d','%d','%d','%f','%d','%d','%s',0,'%d','%d')");
define("inventory_qry7", "update invpricequantity set invprqid='%d' where id='%d'");
define("inventory_qry8", "update inventory set categoryid='%d',partnumber='%s',parttype='%d',stocklocation='%s',
   	description='%s',instock='%d',onorder='%d',rolevel='%d',roqty='%d',reservedqty='%d',leadtime='%d',
   	partclassification='%d',buyquantitypriceid='%d',cmid='%d',invlink='%d' where id = '%d'");
define("inventory_qry9", "select buyquantitypriceid from inventory where id = '%d'");
define("inventory_qry10", "delete from inventory where id = '%d'");
define("inventory_qry11", "insert into inventory values('','%d','%d','%s','%d','%s','%s','%d','%d','%d','%d','%d',
       '%d','%d','%d','%d','%d'");
define("inventory_qry12", "update inventory set buyquantitypriceid='%d' where id = '%d'");

/****************************************
 * label queries
 ****************************************/
define("label_qry1", "select count(*) from label");
define("label_qry2", "select * from label limit 1 offset %d");
define("label_qry3", "select * from label where id = '%d'");
define("label_qry4", "insert into label values('','%d','%d','%s','%d','%d','%s')");
define("label_qry5", "update label set labelid='%d',type='%d',name='%s',xdim='%d',ydim='%d',data='%s' where id = '%d'");
define("label_qry6", "delete from label where id = '%d'");
define("label_qry7", "select * from label");

/****************************************
 * return queries
 ****************************************/
define("return_qry1", "select count(*) from return");
define("return_qry2", "select * from return limit 1 offset %d");
define("return_qry3", "select * from return where id = '%d'");
define("return_qry4", "insert into return values('','%d','%d','%s','%s','%f','%s','%d')");
define("return_qry5", "update return set type='%d',startdate='%s',enddate='%s',margin='%f',memo='%s',
   promolinkid='%d' where id = '%d'");
define("return_qry6", "delete from return where id = '%d'");
define("return_qry7", "select * from return");
 
/****************************************
 * returntype queries
 ****************************************/
define("returntype_qry1", "select count(*) from returntype");
define("returntype_qry2", "select * from returntype limit 1 offset %d");
define("returntype_qry3", "select * from returntype where id = '%d'");
define("returntype_qry4", "insert into returntype values('','%s','%s')");
define("returntype_qry5", "update returntype set name='%s', active='%s' where id = '%d'");
define("returntype_qry6", "delete from returntype where id = '%d'");
define("returntype_qry7", "select * from returntype");
define("returntype_qry8", "select id, name from returntype where active='y'");
define("returntype_qry9", "select name from returntype where id='%d'");


/****************************************
 * stocktake queries
 ****************************************/
define("stocktake_qry1", "drop table if exists stocktake_products");
define("stocktake_qry2", "create table if not exists stocktake_products(id int(11) not null auto_increment,
	    plu varchar(16) not null, instock int(11) not null,currentstock int(11) not null,primary key (id))");
define("stocktake_qry3", "select plu, instock from product order by plu");
define("stocktake_qry4", "insert into stocktake_products values(0,'%s','%d','0')");
define("stocktake_qry5", "select currentstock from stocktake_products where plu='%s'");
define("stocktake_qry6", "update stocktake_products set currentstock='%d' where plu='%s'");
define("stocktake_qry7", "select plu, currentstock from stocktake_products order by plu");
define("stocktake_qry8", "update product set instock='%d' where plu='%s'");
define("stocktake_qry9", "select * from synch where implemented='n' and typeid='6'");
define("stocktake_qry10", "insert into synch values(0,'6',now(),now(),'','n')");
define("stocktake_qry11", "select id from synch where implemented='n' and typeid='6'");
define("stocktake_qry12", "update synch set implemented='y', implementationat=now() where id= '%d'");
define("stocktake_qry13", "select * from stocktake_products where instock!=currentstock");
define("stocktake_qry14", "update inventory set instock='%d' where id=(select invid from product where product.plu='%s')");
define("stocktake_qry15", "update stocktake_products set instock='%d' where plu='%s'");
define("stocktake_qry16", "select * from stocktake_products where plu='%s'");

/****************************************
 * uplu queries
 ****************************************/
define("uplu_qry1", "select count(*) from u_plu");
define("uplu_qry2", "select * from u_plu limit 1 offset %d");
define("uplu_qry3", "select * from u_plu where id = '%d'");
define("uplu_qry4", "insert into plu_cache values('','%d','%d','%s','%s','%s','%f','%f','%d','%f','%f','%d')");
define("uplu_qry5", "select id from taxrate where rate = '%f'");
define("uplu_qry6", "delete from u_plu where id = '%d'");
define("uplu_qry7", "select * from u_plu");
define("uplu_qry8", "select rate from taxrate where id = '%d'");

?>
