<?
/*
sql.php - constants for the vxmis

Copyright (C)2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

/**********************************************************************
 * defines
 **********************************************************************/
define ("BHSQL_LIENUM_DATA", "0");
define ("BHSQL_LIENUM_PTR", "1");
define ("BHSQL_LIENUM_PAIR", "2");

// post action values
define ("BHSQL_P_CONNECT", "1");
define ("BHSQL_P_CONNECTFAIL", "2");
define ("BHSQL_P_CONNECTREFUSE", "3");
define ("BHSQL_P_DISCONNECT", "4");
define ("BHSQL_P_STANDBY", "5");
define ("BHSQL_P_SHUTDOWN", "6");
define ("BHSQL_P_USERLOGIN", "7");
define ("BHSQL_P_USERLOGINREFUSE", "8");
define ("BHSQL_P_USERLOGOUT", "9");
define ("BHSQL_P_USERLOGOUTREFUSE", "10");
define ("BHSQL_P_SUPERLOGIN", "11");
define ("BHSQL_P_SUPERLOGINREFUSE", "12");
define ("BHSQL_P_SUPERLOGOU", "13");
define ("BHSQL_P_MANAGERLOGIN", "14");
define ("BHSQL_P_MANAGERLOGINREFUSE", "15");
define ("BHSQL_P_MANAGERLOGOUT", "16");
define ("BHSQL_P_ADMINLOGIN", "17");
define ("BHSQL_P_ADMINLOGINREFUSE", "18");
define ("BHSQL_P_ADMINLOGOUT", "19");
define ("BHSQL_P_DISCONNECTREFUSE", "20");
define ("BHSQL_P_NOSALE", "21");
define ("BHSQL_P_VOIDSALE", "22");
define ("BHSQL_P_BLINDBALANCE", "23");
define ("BHSQL_P_BLINDBALANCEDISCREP", "24");

// user action values
define ("BHSQL_U_CLOCKIN", "1");
define ("BHSQL_U_CLOCKOUT", "2");
define ("BHSQL_U_LOGIN", "3");
define ("BHSQL_U_LOGOUT", "4");
define ("BHSQL_U_WEBLOGIN", "5");
define ("BHSQL_U_WEBLOGOUT", "6");
define ("BHSQL_U_MISLOGIN", "7");
define ("BHSQL_U_MISLOGOUT", "8");
define ("BHSQL_U_NOSALE", "9");
define ("BHSQL_U_VOIDSALE", "10");

// adjustment action values
define ("BHSQL_A_CHANGE", "1");
define ("BHSQL_A_PAYIN", "2");
define ("BHSQL_A_PAYOUT", "3");
define ("BHSQL_A_OPENBAL", "4");
define ("BHSQL_A_CDEDIT", "5");
define ("BHSQL_A_SCRAPGOODS", "6");
define ("BHSQL_A_REFUND", "7");

// discrepancy action values
define ("BHSQL_D_BLINDBAL", "1");

// fixed interfaces
define ("BHSQL_IF_NULL", "1");
define ("BHSQL_IF_TRANSACTION", "2");
define ("BHSQL_IF_CASHDRAWEREDIT", "3");
define ("BHSQL_IF_PAYIN", "4");
define ("BHSQL_IF_PAYOUT", "5");
define ("BHSQL_IF_TRANSSUMMARY", "6");
define ("BHSQL_IF_USERSUMMARY", "7");
define ("BHSQL_IF_XTAPE", "8");
define ("BHSQL_IF_ZTAPE", "9");
define ("BHSQL_IF_GOODSRETURN", "10");
define ("BHSQL_IF_DISCOUNT", "11");
define ("BHSQL_IF_EPHEMERALIN", "12");

// defined itemtypes
define ("BHSQL_ITEM_UNKNOWN", "1");
define ("BHSQL_ITEM_ITEM", "2");
define ("BHSQL_ITEM_PRICE", "3");
define ("BHSQL_ITEM_RENTAL", "4");
define ("BHSQL_ITEM_RETURN", "5");
define ("BHSQL_ITEM_LAYBY", "6");

// defined paytypes (<32)
define ("BHSQL_PAY_CASH", "1");
define ("BHSQL_PAY_CREDIT", "2");
define ("BHSQL_PAY_CHEQUE", "3");
define ("BHSQL_PAY_SMARTCARD", "4");
define ("BHSQL_PAY_CREDITRETURN", "5");
define ("BHSQL_PAY_CREDITSLIP", "6");
define ("BHSQL_PAY_GIFTVOUCHER", "7");
define ("BHSQL_PAY_TPVOUCHER", "8");
define ("BHSQL_PAY_TPCOUPON", "9");
define ("BHSQL_PAY_INTCOUPON", "10");
define ("BHSQL_PAY_LUNCHSTAMP", "10");
define ("BHSQL_PAY_INHOUSECHARGE", "12");
define ("BHSQL_PAY_STORECARD", "13");
define ("BHSQL_PAY_CREDITCB", "14");
define ("BHSQL_PAY_CHEQUECB", "15");
define ("BHSQL_PAY_SMARTCARDCB", "16");

// enum types
define ("BHSQL_ACCOUNT_INCOME", "0");
define ("BHSQL_ACCOUNT_EXPENSE", "2");
define ("BHSQL_ACCOUNT_ASSET", "3");
define ("BHSQL_ACCOUNT_LIABILITY", "4");
define ("BHSQL_ACCOUNT_CAPITAL", "5");

define ("BHSQL_CONTACTDETAILS_HOME", "0");
define ("BHSQL_CONTACTDETAILS_BUSINESS", "1");
define ("BHSQL_CONTACTDETAILS_MOBILE", "2");
define ("BHSQL_CONTACTDETAILS_FAX", "3");
define ("BHSQL_CONTACTDETAILS_EMAIL", "4");
define ("BHSQL_CONTACTDETAILS_HTTP", "5");
define ("BHSQL_CONTACTDETAILS_FTP", "6");

define ("BHSQL_DELIVERY_RECEIVED", "0");
define ("BHSQL_DELIVERY_PREPARING", "1");
define ("BHSQL_DELIVERY_READY", "2");
define ("BHSQL_DELIVERY_INTRANSIT", "3");
define ("BHSQL_DELIVERY_DELIVERED", "4");

define ("BHSQL_DEPOSIT_RENTAL", "0");
define ("BHSQL_DEPOSIT_LAYBY", "1");
define ("BHSQL_DEPOSIT_RETURNABLE", "2");
define ("BHSQL_DEPOSIT_REDEMPTION", "3");

define ("BHSQL_DISCOUNT_PRODUCT", "0");
define ("BHSQL_DISCOUNT_CUSTOMER", "1");
define ("BHSQL_DISCOUNT_USER", "2");

define ("BHSQL_DISCREETDISCOUNT_PRODUCT", "0");
define ("BHSQL_DISCREETDISCOUNT_TRANSACTION", "1");

define ("BHSQL_PLU_EAN_13", "0");
define ("BHSQL_PLU_EAN_8", "1");
define ("BHSQL_PLU_UPC_A", "2");
define ("BHSQL_PLU_UPC_E", "3");
define ("BHSQL_PLU_ISBN", "4");
define ("BHSQL_PLU_EAN_13W", "5");
define ("BHSQL_PLU_EAN_13Q", "6");
define ("BHSQL_PLU_EAN_13P", "7");
define ("BHSQL_PLU_EAN_13I", "8");
define ("BHSQL_PLU_BH_SC6", "9");

define ("BHSQL_ERRORLOG_INFO", "0");
define ("BHSQL_ERRORLOG_WARNING", "1");
define ("BHSQL_ERRORLOG_ERROR", "2");
define ("BHSQL_ERRORLOG_CRITICAL", "3");

define ("BHSQL_GOODSTRANSFER_CREATED", "0");
define ("BHSQL_GOODSTRANSFER_AWAITINDISPATCH", "1");
define ("BHSQL_GOODSTRANSFER_DISPATCHED", "2");
define ("BHSQL_GOODSTRANSFER_INTRANSIT", "3");
define ("BHSQL_GOODSTRANSFER_DELIVERED", "4");
   
define ("BHSQL_IMAGEDATA_PERSON", "0");
define ("BHSQL_IMAGEDATA_PRODUCT", "1");

define ("BHSQL_ITEMFLAGS_MSG", "0");
define ("BHSQL_ITEMFLAGS_AUTH", "1");
define ("BHSQL_ITEMFLAGS_RECORD", "2");

define ("BHSQL_LABEL_ITEM", "0");
define ("BHSQL_LABEL_SHELF", "1");
define ("BHSQL_LABEL_RX", "2");

define ("BHSQL_LOGINMETHOD_DATA", "0");
define ("BHSQL_LOGINMETHOD_PTR", "1");
define ("BHSQL_LOGINMETHOD_PAIR", "2");

define ("BHSQL_MARGINCOLLECTION_SITE", "0");
define ("BHSQL_MARGINCOLLECTION_SITEGROUP", "1");

define ("BHSQL_MISMENU_MENU", "0");
define ("BHSQL_MISMENU_ITEM", "1");
define ("BHSQL_MISMENU_TABBBED", "2");

define ("BHSQL_PRESCRIPTION_GENERATED", "0");
define ("BHSQL_PRESCRIPTION_FILLED", "1");
define ("BHSQL_PRESCRIPTION_READY", "2");
define ("BHSQL_PRESCRIPTION_COLLECTED", "3");
define ("BHSQL_PRESCRIPTION_CLOSED", "4");

define ("BHSQL_PRODTARGET_DAY", "0");
define ("BHSQL_PRODTARGET_WEEK", "1");
define ("BHSQL_PRODTARGET_MONTH", "2");
define ("BHSQL_PRODTARGET_QUARTER", "3");
define ("BHSQL_PRODTARGET_YEAR", "4");

define ("BHSQL_PRODTARGET_QUANTITY", "0");
define ("BHSQL_PRODTARGET_SALES", "1");

define ("BHSQL_PROMOTION_PRICEABSOLUTE", "0");
define ("BHSQL_PROMOTION_PRICEINCREMENTAL", "1");
define ("BHSQL_PROMOTION_PRICEMARGIN", "2");
define ("BHSQL_PROMOTION_ITEMABSOLUTE", "3");
define ("BHSQL_PROMOTION_ITEMINCREMENTAL", "4");
define ("BHSQL_PROMOTION_ITEMMARGIN", "5");

define ("BHSQL_RETURN_TRANSACTION", "0");
define ("BHSQL_RETURN_TRANSITEM", "1");
define ("BHSQL_RETURN_STOCK", "0");
define ("BHSQL_RETURN_VENDOR", "1");
define ("BHSQL_RETURN_SCRAP", "2");

define ("BHSQL_SETUP_NONE", "0");
define ("BHSQL_SETUP_DIRECT", "1");
define ("BHSQL_SETUP_PASSIVE", "2");
define ("BHSQL_SETUP_ACTIVE", "3");

define ("BHSQL_STORECARD_OK", "0");
define ("BHSQL_STORECARD_VERIFY", "1");
define ("BHSQL_STORECARD_LIMIT", "2");
define ("BHSQL_STORECARD_DENIED", "3");
define ("BHSQL_STORECARD_SEIZE", "4");

define ("BHSQL_SUPPLIER_MANUFACTURER", "0");
define ("BHSQL_SUPPLIER_VENDOR", "1");

define ("BHSQL_TRANSTYPE_PRICE", "0");
define ("BHSQL_TRANSTYPE_DISCOUNT", "1");
define ("BHSQL_TRANSTYPE_PROMO", "2");
define ("BHSQL_TRANSTYPE_CUSTOMER", "3");

define ("BHSQL_VOUCHER_AMOUNT", "0");
define ("BHSQL_VOUCHER_MARGIN", "1");
define ("BHSQL_VOUCHER_ITEM", "0");

define ("BHSQL_JOURNAL_PURCHASE", "1");
define ("BHSQL_JOURNAL_SALE", "2");
define ("BHSQL_JOURNAL_PURCHASERET", "3");
define ("BHSQL_JOURNAL_SALERET", "4");
define ("BHSQL_JOURNAL_PROPER", "5");
define ("BHSQL_JOURNAL_CASH", "6");
define ("BHSQL_JOURNAL_PETTYCASH", "7");
?>
