<?php

/**********************************************************************
 * 
 * Warehouse Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2005
 *
 **********************************************************************/
 
/****************************************
 * stock pick queries
 ****************************************/
define("warehouse_stockpick_qry1", "select count(*) from orders where statusid='9'");
define("warehouse_stockpick_qry2", "select * from orders where statusid='9' limit 1 offset %d");
define("warehouse_stockpick_qry3", "select * from orders where statusid='9' and id = '%d'");
define("warehouse_stockpick_qry4", "select * from orders where statusid='9' order by '%s' %s "); 
define("warehouse_stockpick_qry5", "select * from orders where id = '%d'");
define("warehouse_stockpick_qry6", "select id,productid,quantity from orderitems where orderid = '%d'");
define("warehouse_stockpick_qry7", "select partnumber, stocklocation, description  from inventory where id = '%d'");
define("warehouse_stockpick_qry8", "update orders set statusid='11' where id='%d'"); // read to package
define("warehouse_stockpick_qry9", "update orders set statusid='14' where id='%d'"); // dispatched
define("warehouse_stockpick_qry10","select contactid from customer where id = '%d'");
define("warehouse_stockpick_qry11","select titleid,firstname,lastname,addressid from contacts where id = '%d'");
define("warehouse_stockpick_qry12","select count(*) from orderitems where orderid = '%d'");
define("warehouse_stockpick_qry13","select count(*) from address where addressid = '%d'");

/****************************************
 * package queries
 ****************************************/
define("warehouse_package_qry1", "select count(*) from orders where statusid='11'");
define("warehouse_package_qry2", "select * from orders where statusid='11' and id = '%d'");
define("warehouse_package_qry3", "select * from orders where statusid='11' order by '%s' %s "); 
define("warehouse_package_qry4", "select * from orders where id = '%d'");
define("warehouse_package_qry6", "select description from product where id='%d'"); 
define("warehouse_package_qry7", "select * from orderitems where id = '%d'");
define("warehouse_package_qry8", "update orders set statusid='12' where id='%d'"); // read to dispatch
define("warehouse_package_qry9", "select * from address where id = '%d'");
define("warehouse_package_qry10","select name from title where id = '%d'");
define("warehouse_package_qry11","select name,rate from shipping where id = '%d'");
define("warehouse_package_qry12","select value from companyattribute where name='registrationnumber' and attributeid='%d'");
define("warehouse_package_qry13","select value from companyattribute where name='taxnumber' and attributeid='%d'");
define("warehouse_package_qry14","select siteid from setup");
define("warehouse_package_qry15","select businessunitid from sites where id='%d'");
define("warehouse_package_qry16","select name from businessunit where id='%d'");	
define("warehouse_package_qry17","select addressid from sites where id='%d'");
define("warehouse_package_qry18","select value from missystemattribute where name='printerfolder'");
define("warehouse_package_qry19","select value from missystemattribute where name='autoprinter'");
define("warehouse_package_qry20","select value from companyattribute where name='shipnumber'");

/****************************************
 * dispatch queries
 ****************************************/
define("warehouse_dispatch_qry1", "select count(*) from orders where statusid='12'");
define("warehouse_dispatch_qry2", "select * from orders where statusid='12' and id = '%d'");
define("warehouse_dispatch_qry3", "select * from orders where statusid='12' order by '%s' %s "); 
define("warehouse_dispatch_qry4", "select * from orders where id = '%d'");
define("warehouse_dispatch_qry5", "update orders set statusid='13' where id='%d'"); // dispatched
define("warehouse_dispatch_qry6", "update shipping set trackingnum='%s' where id='%d'"); // dispatched

/****************************************
 * orderitem queries
 ****************************************/
define("warehouse_orderitem_qry1", "select count(*) from orderitem");
/*
define("purchase_porderitem_qry2", "select * from purchaseorderitem limit 1 offset %d");
define("purchase_porderitem_qry3", "select * from purchaseorderitem where id = '%d'");
define("purchase_porderitem_qry4", "update purchaseorderitem set purchaseorderid='%d',quantity='%d',inventoryid='%d',
status='%d' where id='%d'");
define("purchase_porderitem_qry5", "delete from purchaseorderitem where id='%d'");
define("purchase_porderitem_qry8", "insert into purchaseorderitem values(0,'%d','%d','%d','%d')");
define("purchase_porderitem_qry9", "select * from purchaseorderitem where purchaseorderid='%d'");
define("purchase_porderitem_qry10", "update inventory set onorder=onorder+%d  where id='%d'");
define("purchase_porderitem_qry11", "select id from purchaseorderitem where purchaseorderid='%d'");
define("purchase_porderitem_qry12", "delete from purchaseorderitem where purchaseorderid='%d'");
define("purchase_porderitem_qry13", "select * purchaseorderitem where purchaseorderid='%d' and inventoryid='%d'");
*/
?>
