<?php
/*
user.php
Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001 - 2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
class User
{
   var $id;
	var $login;
	var $password;
	var $userdata;
	var $profile;
	var $logintypesid;
	var $employeeid;
  
   
   function User()
   {
      $this->id=0;
      $this->login='';
	   $this->password='';
   	$this->userdata='';
	   $this->profile='';
      $this->logintypesid=0;
   	$this->employeeid=0;
      $this->stationid=0;
      $this->interfaceid=0;
   }
   
   function GetID() { return $this->id; }
   
   function Fill($id, $bOffset=true)
   {
      if($bOffset){
         $qry=sprintf(userm_user_qry2, $id);
      }
      else{
         $qry=sprintf(userm_user_qry3, $id);
      }
      
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->login=$row["pogin"];
         $this->password=$row["password"];
         $this->userdata=$row["userdata"];
         $this->profile=$row["profile"];
         $this->logintypesid=$row["logintypesid"];
	      $this->employeeid=$row["employeeid"];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e,$f)
   {
      $this->login=$a;
      $this->password=$b;
      $this->userdata=$c;
      $this->profile=$d;
      $this->logintypesid=$e;
	   $this->employeeid=$f;
   }
   
   function SetFromForm($frm)
   {
      $this->login=$frm['login'];
      $this->password=$frm['password'];
      $this->userdata=$frm['userdata'];
      $this->profile=$frm['profile'];
      $this->logintypesid=$frm['logintypesid'];
	   $this->employeeid=$frm['employeeid'];
   }
   
   function Add()
   {
      $qry=sprintf(userm_user_qry5, $this->login,$this->password,$this->userdata,$this->profile,
         $this->logintypesid,$this->employeeid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
       $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
       if($row = $result->FetchRow()){
          $this->id=$row[0];
       }
       return $this->id;
   }
   
   function Commit()
   {
      $qry=sprintf(userm_user_qry6, $this->login,$this->password,$this->userdata,$this->profile,
         $this->logintypesid,$this->employeeid, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(userm_user_qry7, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function perms($a, $row, $bLine)
   {
      $on=$_SESSION['VxCFG']->libdir."/tick.png";
      $off=$_SESSION['VxCFG']->libdir."/cancel.png";
      
      if($bLine) print "<td>Login</td>\n";
      if($a=="commit" || $a=="add"){
         if($row["perm_login"]=='Y'){
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_login\" value=\"1\" checked></td>\n";
         }
         else{
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_login\" value=\"0\"></td>\n";
         }
      }
      else{
         if($row["perm_login"]=='Y'){
            print "<td align=\"center\"><image src=\"$on\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
         else{
            print "<td align=\"center\"><image src=\"$off\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
      }
      if($bLine) print "<td>List</td>\n";
      if($a=="commit" || $a=="add"){
         if($row["perm_list"]=='Y'){
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_list\" value=\"1\" checked></td>\n";
         }
         else{
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_list\" value=\"0\"></td>\n";
         }
      }
      else{
         if($row["perm_list"]=='Y'){
            print "<td align=\"center\"><image src=\"$on\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
         else{
            print "<td align=\"center\"><image src=\"$off\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
      }
      if($bLine) print "<td>Browse</td>\n";
      if($a=="commit" || $a=="add"){
         if($row["perm_browse"]=='Y'){
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_browse\" value=\"1\" checked></td>\n";
         }
         else{
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_browse\" value=\"0\"></td>\n";
         }
      }
      else{
         if($row["perm_browse"]=='Y'){
            print "<td align=\"center\"><image src=\"$on\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
         else{
            print "<td align=\"center\"><image src=\"$off\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
      }
      if($bLine) print "<td>Add</td>\n";
      if($a=="commit" || $a=="add"){
         if($row["perm_add"]=='Y'){
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_add\" value=\"1\" checked></td>\n";
       }
         else{
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_add\" value=\"0\"></td>\n";
         }
      }
      else{
         if($row["perm_add"]=='Y'){
            print "<td align=\"center\"><image src=\"$on\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
         else{
            print "<td align=\"center\"><image src=\"$off\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
      }
      if($bLine) print "<td>Edit</td>\n";
      if($a=="commit" || $a=="add"){
         if($row["perm_edit"]=='Y'){
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_edit\" value=\"1\" checked></td>\n";
         }
         else{
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_edit\" value=\"0\"></td>\n";
         }
      }
      else{
         if($row["perm_edit"]=='Y'){
            print "<td align=\"center\"><image src=\"$on\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
         else{
            print "<td align=\"center\"><image src=\"$off\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
      }
      if($bLine) print "<td>Delete</td>\n";
      if($a=="commit" || $a=="add"){
         if($row["perm_delete"]=='Y'){
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_delete\" value=\"1\" checked></td>\n";
         }
         else{
            print "<td align=\"center\"><input type=\"checkbox\" name=\"perm_delete\" value=\"0\"></td>\n";
         }
      }
      else{
         if($row["perm_delete"]=='Y'){
            print "<td align=\"center\"><image src=\"$on\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
         else{
            print "<td align=\"center\"><image src=\"$off\" width=\"13\" height=\"13\" border=\"0\"></td>\n";
         }
      }
   }
   
   function StationCombo($a, $id, $cname)
   {
      //$this->StationID=$id;
      
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>"._("Not Set")."</option>\n";

   	   $qry=sprintf(userm_station_qry4, $id, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         echo "<select name=\"$cname\">\n";
   	   $qry=sprintf(userm_user_qry9, $id, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
   }
   
   function InterfaceCombo($a, $id, $cname)
   {
      
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $qry=sprintf(user_qry12);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      	while($row = $result->FetchRow()){
            db_query($qry);
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         echo "<select name=\"$cname\">\n";
 
   	   $qry=sprintf(user_qry10, $id, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
   }
   
   function LoginTypesCombo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $qry=sprintf(user_user_qry13, $id, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      	while($row = $result->FetchRow()){
            db_query($qry);
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         echo "<select name=\"$cname\">\n";
 
   	   $qry=sprintf(user_user_qry13, $this->id, $this->id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
   }
   
   function PermLine($a, $id)
   {
      echo "<tr>\n";
      $qry=sprintf(userm_user_qry14, $id, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         perms($a, $row, true);
      }
      echo "</tr>\n";
   }
   
   function PermTable($a, $id)
   {
      echo "<tr>\n<td><h3>login</h3></td>\n<td><h3>list</h3></td>\n<td><h3>browse</h3></td>\n";
      echo "<td><h3>add</h3></td>\n<td><h3>edit</h3></td>\n<td><h3>delete</h3></td>\n</tr>\n\n";
      $qry=sprintf(userm_user_qry8, $id, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $c=1;
      while($row = $result->FetchRow()){
         if($c%2==0){
            echo "<tr bgcolor=\"#CFCFCF\">\n";
         }
         else{
            echo "<tr>\n";
         }
         perms($a, $row, false);
      
         echo "</tr>\n";
         $c++;
      }
   }
   
   function PermTableEx($a, $id)
   {
      echo "<table>\n<tr>\n<td>";
      echo _("login")."</td>\n<td>";
      echo "list</td><td>browse</td><td>add</td><td>edit</td><td>delete</td></tr>\n";
      $qry=sprintf(userm_user_qry8, $id, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $c=1;
      while($row = $result->FetchRow()){
         if($c%2==0){
            echo "<tr bgcolor=\"#CFCFCF\">\n";
         }
         else{
            echo "<tr>\n";
         }
         perms($a, $row, false);
      
         echo "</tr>\n";
         $c++;
      }
   }
   
   function LoginTypesByPostTable($a, $userid, $postid)
   {
      $qry=sprintf(user_user_qry24, $postid, $userid);
   }
   
   function Stations($a, $id, $postID, $bInside=false)
   {
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"address\">\n";
         echo "<tr>\n";
      }
      echo "<tr><td><h3>Name</h3></td><td><h3>Interface</h3><td><h3>Type</h3></td><td><h3>login</h3></td><td><h3>list</h3></td><td><h3>browse</h3></td><td><h3>add</h3></td><td><h3>edit</h3></td><td><h3>delete</h3></td></tr>\n";
      $qry=sprintf(user_qry8, $this->ID, $this->ID);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $c=1;
      while($row = $result->FetchRow()){
         if($c%2==0){
            echo "<tr bgcolor=\"#CFCFCF\">\n";
         }
         else{
            echo "<tr>\n";
         }
         echo "<td>$row[1]</td><td>$row[2]</td><td>$row[3]</td>\n";
         perms($a, $row);
      
         echo "</tr>\n";
         $c++;
      }
      if(!$bInside){
         echo "</table>\n";
      }
   }
   
   function EmployeeCombo($a, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"employeeid\">\n";
   	   echo "<option value='0'>"._("Not Set")."</option>\n";

   	   $result=$_SESSION['VxCFG']->dbh->Execute(user_user_qry21);
         
      	while($r = $result->FetchRow()){
            $qry=sprintf(user_user_qry17, $r['id']);
            $res=$_SESSION['VxCFG']->dbh->Execute(user_user_qry21);
            $row = $res->FetchRow();
      		if($id==$r['id']){
	      		echo "<option selected value=\"".$row['id']."\">".$row['firstname']." ".$row['lastname']."</option>\n";
		      }
   		   else{
	   		   echo "<option value=\"".$row['id']."\">".$row['firstname']." ".$row['lastname']."</option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
   	   $qry=sprintf(user_user_qry20, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         $row = $result->FetchRow();
         $qry=sprintf(user_user_qry17, $r['id']);
         $result=$_SESSION['VxCFG']->dbh->Execute(user_user_qry21);
         $row = $result->FetchRow();
         echo $row['firstname']." ".$row['lastname'];
      }
   }
   
   function FillTable($a, $id, $title, $bInside=false)
   {
      if($a=="commit" || $a=="add"){
         $this->Fill($id, false);
      }
      else{
         $this->Fill($id, true);
      }
      
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"address\">\n";
         echo "<tr>\n";
	      echo "<td colspan=\"2\" align=\"center\"><h3>$title</h3></td></tr>\n";
      }

	   echo "<tr>\n";
      echo "<td width=\"20%\" align=\"right\">Login</td>\n";
      echo "<td>";
	   entry($a, "login", 32, 16, $this->login);
   	echo"</td>\n";
	   echo "</tr>\n";
	
   	echo "<tr>\n";
      echo "<td align=\"right\">Password</td>\n";
      echo "<td>";
	   entry($a, "password", 32, 16, $this->password);
   	echo"</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td align=\"right\">User Data</td>\n";
   	echo "<td>";
      entry($a, "userdata", 68, 64,$this->userdata);
   	echo"</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td align=\"right\">Profile</td>\n";
      echo "<td>";
	   entry($a, "profile", 68, 64, $this->profile);
   	echo "</td>\n";
	   echo "</tr>\n";
   
      echo "<tr>\n";
      echo "<td align=\"right\">Login Types</td>\n";
      echo "<td>";
	   entry($a, "state", 32, 32, $this->state);
   	echo "</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td align=\"right\">Employee</td>\n";
      echo "<td>";
	   entry($a, "postcode", 32, 32, $this->postcode);
   	echo "</td>\n";
	   echo "</tr>\n";
	
   	echo "<tr>\n";
      echo "<td align=\"right\">Country</td>\n";
      echo "<td>";
	   entry($a, "country", 32, 32, $this->country);
   	echo "</td>\n";
	   echo "</tr>\n";
      if(!$bInside){
   	   echo "</table>\n";
      }
   }
}

?>
