<?
/*
vxlib.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/

function redirect($url, $target="", $message="", $delay=0) 
{
   if(isset($target)){
      echo "<meta http-equiv='Window-target' content='_top'>";
   }

	echo "<meta http-equiv='Refresh' content='$delay; url=$url'>";
	if (!empty($message)) echo "<div style='font-family: Arial, Sans-serif; font-size: 12pt;' align=center>$message</div>";
	die;
}

function pv(&$var) 
{
	echo isset($var) ? htmlSpecialChars(stripslashes($var)) : "";
}

function read_template($filename, &$var) 
{
	$temp = str_replace("\\", "\\\\", implode(file($filename), ""));
	$temp = str_replace('"', '\"', $temp);
	eval("\$template = \"$temp\";");
	return $template;
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ generic funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function fillcombo($id, $cname, $valname, $fillname, $sqlquery) 
{
	$result=db_query($sqlquery) or die('Unable to combo query');
	echo "<select name=\"$cname\" class=\"combo\">\n";
	while($row = $result->FetchRow()){
		$vid=$row[$valname];
		$fn=$row[$fillname];
		if($id==$vid){ print "<option selected value=\"$vid\"> $fn </option>\n";}
		else{	print "<option value=\"$vid\"> $fn </option>\n"; }
	}
	echo "</select>\n";
}

function fillgenparentcombo($id, $cname, $tablename) 
{
   $qry=sprintf("select name from $tablename where parentid='%d'", $id);
	$result=db_query($qry) or die('Unable to parentcombo query');
	echo "<select name=\"$cname\" width=\"250\">\n";
	while($row = $result->FetchRow()){
		$vid=$row[$id];
		$name=$row[$name];
		if($id==$vid){ print "<option selected value=\"$vid\"> $name </option>\n";}
		else{	print "<option value=\"$vid\"> $fname </option>\n"; }
	}
	echo "</select>\n";
}

function entry($a, $n, $s, $l, $v,$type=NULL)
{
   if($type == NULL)
       $type = "text";
   
   
   if($a=="commit" || $a=="add" || $a=="addwithref"){
      echo "<input type=\"$type\" class=\"text\" name=\"$n\" size=\"$s\" maxlength=\"$l\" value=\"";
		pv($v);
		echo "\">";
   }
   else{
      if(isset($v) && $v != ""){
         pv($v);
      }
      else{
         echo "&nbsp;";
      }
   }
}

function pentry($a, $n, $s, $l, $v)
{
   if($a=="commit" || $a=="add" || $a=="addwithref"){
      echo "<input type=\"password\" class=\"text\" name=\"$n\" size=\"$s\" maxlength=\"$l\" value=\"";
		pv($v);
		echo "\">";
   }
   else{
      if(isset($v) && $v != ""){
         $z=preg_replace("/./", "*", $v);
         echo $z;
      }
      else{
         echo "Not Set";
      }
   }
}

function textarea($a, $n, $r, $l, $v)
{
   $c=$l/$r;
   if($a=="commit" || $a=="add" || $a=="addwithref"){
      echo "<input type=\"textarea\" name=\"$n\" rows=\"$r\" cols=\"$c\" value=\"";
		pv($v);
		echo "\">";
   }
   else{
      if(isset($v) && $v != ""){
         pv($v);
      }
      else{
         echo "Not Set";
      }
   }
}

function CheckBox($a, $cname, $value, $text="")
{  
   if($a=="add" || $a=="commit"){
      if($value=='N' || $value=='0'){
    	   echo "<input class=\"checkbox\" type=\"checkbox\" name=\"$cname\" value=\"$value\"> $text\n";
      }
  	   else{
   	   echo "<input class=\"checkbox\" type=\"checkbox\" name=\"$cname\" value=\"$value\" checked> $text\n";
      }
   }
   else{
      if($value=='N' || $value=='0'){
   	   echo "<image src=".$_SESSION['VxCFG']->styleimagedir."/icon_cb_cancel.png width=\"13\" height=\"13\" border=\"0\">$text\n";
      }
  	   else{
   	   echo "<image src=".$_SESSION['VxCFG']->styleimagedir."/icon_cb_tick.png width=\"13\" height=\"13\" border=\"0\"> $text\n";
      }
   }
}

function YN($v)
{
   if(isset($v)){
      if($v=='1' || $v=='on' || $v=='Y')
	      return "Y";
      else
	      return "N";
   }
   else{
      return "N";
   }
}

function yesno($varisset)
{
   if($varisset=='1')
	   return "Y";
   else
	   return "N";
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ misc funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function helpbutton($name)
{
   if($_SESSION['vxmisuser']->GetShowHelp()=='Y'){
      echo "<td class=\"help\">\n";
      echo "<input class=\"help\" type=\"image\" height=\"24\" width=\"24\" name=\"namehelp\" src=\"".$_SESSION['VxCFG']->styleimagedir."/icon_help.png\" onclick=\"show_help('$name');\">\n";
      echo "</td>\n";
   }
}

function fillStatusCombo($a, $cname, $id)
{	
	if($a=="commit" || $a=="add"){
	   print "<select name=\"$cname\" class=\"combo\">\n";
      $result=$_SESSION['VxCFG']->dbh->Execute(bhlib_qry1);
	   while($row = $result->FetchRow()){
			$boo=$row["id"];
		   $poo=$row["name"];
		   if($id==$boo){
			   print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
		print "</select>\n";
   }
   else{
      $qry=sprintf(vxlib_qry2, $id); 
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}

function fillTimeZoneCombo($a, $cname, $tz)
{
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"$cname\">\n";
      $z=24;
      $t=-11;
      while($z){
         if($tz==$t){
            echo "<option selected value=\"$t\">$t</option>\n";
         }
         else{
            echo "<option value=\"$t\">$t</option>\n";
         }
         $t++;
         $z--;
      }
		echo "</select>\n";
   }
   else{
      if(isset($tz)) echo $tz;
      else echo "+0";
   }
}

function fillPayTypeCombo($a, $cname, $id)
{	
	if($a=="commit" || $a=="add"){
	   print "<select name=\"$cname\" width=\"250\">\n";
      $result=$_SESSION['VxCFG']->dbh->Execute(vxlib_qry3);
	   while($row = $result->FetchRow()){
			$boo=$row["id"];
		   $poo=$row["name"];
		   if($id==$boo){
			   print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
		print "</select>\n";
   }
   else{
      $qry=sprintf(vxlib_qry4, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ site/dept/group funcs ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

function fillSiteCombo($a, $id)
{
   if($id==0 && $a=="cfmdelete"){
      echo "Not Set";
      return;
   }
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
      $result=$_SESSION['VxCFG']->dbh->Execute(vxlib_qry5);
      if($result->RecordCount()==0){
         echo "Not Set";
         return;
      }
      if($result->RecordCount()==1 && $a=="cfmdelete"){
         echo "The are no other sites defined";
         return;
      }
	   echo "<select name=\"siteid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if(($a=="cfmdelete" && $id!=$boo) || $a !="cfmdelete"){
   	   	if($id==$boo){
	   	   	print "<option selected value=\"$boo\"> $poo </option>\n";
   	   	}
	   	   else{
		   	   print "<option value=\"$boo\"> $poo </option>\n";
   		   }
         }
	   }
	   echo "</select>\n";
   }
   else{
      $qry=sprintf(vxlib_qry6, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($result->RecordCount()==0){
         echo "Not Set";
         return;
      }
      if($row = $result->FetchRow()){
         echo $row[0];
      }
   }
}

function fillDeptCombo($a, $id)
{
   if($id==0 && $a=="cfmdelete"){
      echo "Not Set";
      return;
   }
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
	   $result=$_SESSION['VxCFG']->dbh->Execute(vxlib_qry7);
      if($result->RecordCount()==0){
         echo "Not Set";
         return;
      }
      if($result->RecordCount()==1 && $a=="cfmdelete"){
         echo "The are no other departments defined";
         return;
      }
	   echo "<select name=\"deptid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
	   	   if($id==$boo){
   		   	print "<option selected value=\"$boo\"> $poo </option>\n";
	   	   }
   	   	else{
	   	   	print "<option value=\"$boo\"> $poo </option>\n";
   		   }
         }
	   }
      echo "</select>\n";
   }
   else{
      $qry=sprintf(vxlib_qry8, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($result->RecordCount()==0){
        echo "Not Set";
         return;
      }
      if($row = $result->FetchRow()){
         echo $row[0];
      }
   }
}

function fillDeptFromSiteCombo($a, $siteid)
{
   if($id==0 && $a=="cfmdelete"){
      echo "Not Set";
      return;
   }
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
      $qry=sprintf(vxlib_qry15, $siteid);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($result->RecordCount()==0){
         echo "There are no departments defined for this sites";
         return;
      }
	   echo "<select name=\"deptid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
	   	   if($id==$boo){
   		   	print "<option selected value=\"$boo\"> $poo </option>\n";
	   	   }
   	   	else{
	   	   	print "<option value=\"$boo\"> $poo </option>\n";
   		   }
         }
	   }
      echo "</select>\n";
   }
}

function fillGroupCombo($a, $id)
{
   if($id==0 && $a=="cfmdelete"){
      echo "Not Set";
      return;
   }
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
   	$result=$_SESSION['VxCFG']->dbh->Execute(vxlib_qry9);
      if($result->RecordCount()==0){
         echo "There are no groups defined for this department";
         return;
      }
	   echo "<select name=\"groupid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
   	   	if($id==$boo){
	   	   	print "<option selected value=\"$boo\"> $poo </option>\n";
   	   	}
	   	   else{
		   	   print "<option value=\"$boo\"> $poo </option>\n";
      		}
         }
	   }
   	echo "</select>\n";
   }
   else{
      $qry=sprintf(vxlib_qry10, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!isset($result)){
         echo "Not Set";
         return;
      }
      if($result->RecordCount()==0){
         echo "Not Set";
         return;
      }
      else{
         $row = $result->FetchRow();
         echo $row[0];
      }
   }
}

function fillGroupFromDeptCombo($a, $deptid)
{
   if($id==0 && $a=="cfmdelete"){
      echo "Not Set";
      return;
   }
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
      $qry=sprintf(vxlib_qry16, $deptid);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($result->RecordCount()==0){
         echo "Not Set";
         return;
      }
      if($result->RecordCount()==1 && $a=="cfmdelete"){
         echo "The are no other departments defined";
         return;
      }
	   echo "<select name=\"deptid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
	   	   if($id==$boo){
   		   	print "<option selected value=\"$boo\"> $poo </option>\n";
	   	   }
   	   	else{
	   	   	print "<option value=\"$boo\"> $poo </option>\n";
   		   }
         }
	   }
      echo "</select>\n";
   }
   else{
      $qry=sprintf(vxlib_qry8, $deptid);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($result->RecordCount()==0){
        echo "Not Set";
         return;
      }
      if($row = $result->FetchRow()){
         echo $row[0];
      }
   }
}

function fillStationCombo($a, $id)
{
   if($id==0 && $a=="cfmdelete"){
      echo "Not Set";
      return;
   }
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
   	$result=$_SESSION['VxCFG']->dbh->Execute(vxlib_qry11);
      if($result->RecordCount()==0){
        echo "Not Set";
         return;
      }
      if($result->RecordCount()==1 && $a=="cfmdelete"){
         echo "The are no other stations defined";
         return;
      }
	   echo "<select name=\"stationid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if(($a=="cfmdelete" && $id!=$boo) || $a!="cfmdelete"){
   	   	if($id==$boo){
	   	   	print "<option selected value=\"$boo\"> $poo </option>\n";
   	   	}
	   	   else{
		   	   print "<option value=\"$boo\"> $poo </option>\n";
      		}
         }
	   }
   	echo "</select>\n";
   }
   else{
      $qry=sprintf(vxlib_qry12, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($result->RecordCount()==0){
        echo "Not Set";
         return;
      }
      if($row = $result->FetchRow()){
         echo $row[0];
      }
   }
}

function fillEnteredStation($a, $id)
{
   $s=substr($id, 0, 5);
   $d=substr($id, 5, 5);
   $g=substr($id, 10, 5);
   $n=substr($id, 15, 5);
   
   echo "<table width=\"100%\" border=\"1\"><tr>\n";
   echo "<td align=\"right\" nowrap>Site</td><td nowrap>";
   fillSiteCombo($a, $s);
   echo "</td>\n";
   echo "<td align=\"right\" nowrap>Department</td><td nowrap>";
   fillDeptCombo($a, $d);
   echo "</td></tr><tr><td align=\"right\" nowrap>Group</td>";
   echo "<td nowrap>";
   fillGroupCombo($a, $g);
   echo "</td>\n<td align=\"right\" nowrap>Station</td>";
   echo "<td nowrap>";
   fillStationCombo($a, $n);
   echo "</td>";
   echo "</tr></table>\n";
}

function fillNarrowEnteredStation($a, $id)
{
   $s=substr($id, 0, 5);
   $d=substr($id, 5, 5);
   $g=substr($id, 10, 5);
   $n=substr($id, 15, 5);
   
   echo "<table class=\"nlocation\"><tr>\n";
   echo "<td class=\"nlocationlabel\">Site : </td><td class=\"nlocation\">";
   fillSiteCombo($a, $s);
   echo "</td>\n";
   echo "<td class=\"nlocationlabel\">Department : </td><td class=\"nlocation\">";
   fillDeptCombo($a, $d);
   echo "</td><td class=\"nlocationlabel\">Group : </td>";
   echo "<td class=\"nlocation\">";
   fillGroupCombo($a, $g);
   echo "</td>\n<td class=\"nlocationlabel\">Station : </td>";
   echo "<td class=\"nlocation\">";
   fillStationCombo($a, $n);
   echo "</td>";
   echo "</tr></table>\n";
}

function fillEnteredControl($a, $id)
{
   $s=substr($id, 0, 5);
   $d=substr($id, 5, 5);
   $g=substr($id, 10, 5);
   $n=substr($id, 15, 5);
   
   echo "<table width=\"100%\" border=\"1\"><tr>\n";
   echo "<td align=\"right\" nowrap>Site</td><td nowrap>";
   fillSiteCombo($a, $s);
   echo "</td>\n";
   echo "<td align=\"right\" nowrap>Department</td><td nowrap>";
   fillDeptFromSiteCombo($a, $s);
   echo "</td></tr><tr><td align=\"right\" nowrap>Group</td>";
   echo "<td nowrap>";
   fillGroupFromDeptCombo($a, $d);
   echo "</td>\n<td align=\"right\" nowrap>Station</td>";
   echo "<td nowrap>";
   //fillStationFromGroupCombo($a, $g);
   echo "</td>";
   echo "</tr></table>\n";
}

?>
