<?php
/*
stats.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/phplot/phplot.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}

if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(-1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Orders"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Orders");
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

$NoNavigationFlag=true;
include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "list":
	default :
      Details();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function Details()
{
   $frm["numneworders"]="0";
   $frm["numapporders"]="0";
   $frm["numsporders"]="0";
   $frm["numpackorders"]="0";
   $frm["numdisorders"]="0";
   $frm["numhits"]="0";
   $frm["mostviewedproduct"]="0";
   $frm["bestsellingproduct"]="0";
   //GetFirstWeekofYear() { return $this->yearstartweek; }
   
   $qry=sprintf(order_stats_qry11, $_SESSION['vxmisuser']->GetFirstDayofWeek());
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   //$numdays=

   $qry=sprintf(order_stats_qry1, $_SESSION['vxmisuser']->GetEmployee());
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result){
	   if($row = $result->FetchRow()){
         $s=$row["stamper"];
         $qry=sprintf(order_stats_qry2, $s);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result){
	         if($row = $result->FetchRow()){
               $frm["numneworders"]=$row[0];
            }
         }
         $qry=sprintf(order_stats_qry3, $s);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result){
	         if($row = $result->FetchRow()){
               $frm["numapporders"]=$row[0];
            }
         }
         $qry=sprintf(order_stats_qry4, $s);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result){
	         if($row = $result->FetchRow()){
               $frm["numsporders"]=$row[0];
            }
         }
         $qry=sprintf(order_stats_qry5, $s);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result){
	         if($row = $result->FetchRow()){
               $frm["numpackorders"]=$row[0];
            }
         }
         $qry=sprintf(order_stats_qry6, $s);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result){
	         if($row = $result->FetchRow()){
               $frm["numdisorders"]=$row[0];
            }
         }
      }
   }
   
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry19);
   if($result){
	   if($row = $result->FetchRow()){
         $frm["pnumneworders"]=$row[0];
      }
   }
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry20);
   if($result){
	   if($row = $result->FetchRow()){
         $frm["pnumapporders"]=$row[0];
      }
   }
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry21);
   if($result){
	  if($row = $result->FetchRow()){
        $frm["pnumsporders"]=$row[0];
     }
   }
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry22);
   if($result){
	   if($row = $result->FetchRow()){
         $frm["pnumpackorders"]=$row[0];
      }
   }

   
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry10);
   if($result){
	   if($row = $result->FetchRow()){
         $frm["avgorderturnaround"]=$row[0];
         $frm["maxorderturnaround"]=$row[1];
         $frm["minorderturnaround"]=$row[2];
      }
   }
   
   $frm["newaction"] = "none";
   
   include("templates/stats.php");
}

function AmountLabel($val)
{
   return sprintf('$%0.0f', $val);
   //return '$'.NumberFormat($val/1000);
}

function VolumeByMonth()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry17);
   $row = $result->FetchRow();
   $d=$row[0]."-01-01";
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry16);
   $row = $result->FetchRow();
   $m=$row[0]+1;

   $xpos=1;
   for($month=1; $month!=$m; $month++){
      $qry=sprintf(order_stats_qry14, $month);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      $label=strftime('%b',mktime(0,0,0,$month,1,0));
      $counts[] = @ array($label,$row[0]);
      $amount[] = @ array($label,$row[1]);
      $xpos++;
   }
   

   $cscale = array_search(max($counts),$counts); //Find the position of maximum value.
   $ascale = array_search(max($amount),$amount);
   
   $graphc = & new PHPlot(480,380, "volbymonth.png");
   $graphc->SetDataType("text-data");
   $graphc->SetTitle("Volume");
   $graphc->SetDataValues($counts);
   $graphc->SetPlotType('bars');
   $graphc->SetFileFormat('png');
   $graphc->SetXGridLabelType('title');
   $graphc->SetXScaleType('linear');
   $graphc->SetXTitle('Month');
   $graphc->SetYTitle('Volume');
   //$graphc->SetDataColors('orange');
   
   $grapha = new PHPlot(480,380,"amtbymonth.png");
   $grapha->SetDataType("text-data");
   $grapha->SetDataValues($amount);
   $grapha->SetTitle("Revenue");
   $grapha->SetPlotType('bars');
   $grapha->SetFileFormat('png');
   $grapha->SetXGridLabelType('title');
   $grapha->SetXScaleType('linear');
   $grapha->SetXTitle('Month');
   $grapha->SetYTitle('Amount');
   
   /*
   $graph->SetScale("textint");
   $graph->img->SetMargin(50,70,30,30);
   //$graph->AdjBackgroundImage(0.4,0.7,-1); //setting BG type
   //$graph->SetBackgroundImage("graph_bg.png",BGIMG_FILLFRAME); //adding image
   $graph->SetShadow();
   $graph->SetY2Scale('lin');
   $graph->SetY2OrderBack(false);

   $graph->xaxis->SetTickLabels($labelx);
   $graph->y2axis->SetLabelFormatCallback('AmountLabel');

   $cplot = new BarPlot($counts);
   $aplot = new BarPlot($amount);
   $czb = new BarPlot($cz);
   $azb = new BarPlot($az);

   $cplot->SetFillColor("lightgreen"); // Fill color
   $cplot->value->Show();
   //$cplot->value->SetFont(FF_ARIAL,FS_BOLD);
   //$cplot->value->SetAngle(45);
   $cplot->value->SetColor("black","navy");
   
   $aplot->SetFillColor("darkgreen"); // Fill color
   $aplot->value->Show();
   //$aplot->value->SetFont(FF_ARIAL,FS_BOLD);
   //$aplot->value->SetAngle(45);
   $aplot->value->SetColor("black","navy");

   
   $cbp= new GroupBarPlot(array($cplot, $czb));
   $abp= new GroupBarPlot(array($azb, $aplot));
   $graph->Add($cbp);
   $graph->AddY2($abp);
   //exit;
   $graph->Stroke("volumebymonth");
   */
   $graphc->SetIsInline(true);
   $grapha->SetIsInline(true);
   $graphc->DrawGraph();
   $grapha->DrawGraph();
   echo "<img src=\"volbymonth.png\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
   echo "<img src=\"amtbymonth.png\">\n";
}

?>
