<?php
/*
collection.php

Copyright (C)2005  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/tree.php");
require_once($_SESSION['VxCFG']->libdir."/collection.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(4);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_PRODUCT){
         $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
         $action='list';
      }
      else{
         $action='list';
      }
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Collection"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Collection");
}

if($_SESSION["pageindex"]->CheckNum(product_collection_qry1, "productcollection")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/headertree.php");
   
switch($action){
	case "clear" :
		addcollection();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browsecollection($_REQUEST['id']);
         break;
      }
		browsecollection($_POST['id']);
		break;

	case "edit" :
		editcollection($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelcollection($_REQUEST['id']);
      }
      else{
         deletecollection($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listcollection();
      }
      break;  
	
   case "cfmdelete" :
      deletecollection($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listcollection();
		break;

	case "add" :
		insertcollection($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listcollection();
		break;

	case "commit" :
		commitcollection($_POST);
		listcollection();
		break;
      
   case "additem":
      addItem($_POST);
      break;
      
   case "deleteitem":
      deleteItem($_REQUEST);
      break;
      
   case "merge":
      collectionMerge($_SESSION["pageindex"]->current());
      break;
   
   case "mergesave":
      mergeSave($_POST);
      break;
      
   case "catchange":
      mergeSave($_POST);
      break;
      
	case "list":
	default :
		listcollection();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(product_collection_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
	$frm["name"] = "";
	$frm["description"] = "";
	$frm["collectionid"] = "";

	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(product_collection_qry2, $id);
   }
   else{
      $qry=sprintf(product_collection_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
	
	$cid=$row["collectionid"];
	$result=$_SESSION['VxCFG']->dbh->Execute("SELECT count(*) from productcollection WHERE prodcollid='$cid'");
	$crow = $result->FetchRow();

	$frm["id"] = $id;
	$frm["name"] = $row["name"];
	$frm["description"] = $row["description"];
	$frm["collectionid"] = $cid;

	return $frm;
}

function addcollection()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	
	include("templates/collection.php");
}

function editcollection($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
		
	include("templates/collection.php");
}

function browsecollection($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
		
	include("templates/collection.php");
}

function chkdelcollection($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
		
	include("templates/collection.php");
}

function deletecollection($id) 
{
   $qry=sprintf(collection_qry6, $id);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function insertcollection($frm) 
{
   $qry=sprintf(collection_qry4, $frm['name'],$frm['description'],0);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitcollection($frm) 
{
   $qry=sprintf(collection_qry5, $frm['name'],$frm['description'],$frm['collectionid'],$frm['id']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function addItem($frm)
{
   $plu=$frm['PLU'];
   $qry=sprintf(product_collection_qry8, $frm['PLU']);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result->RecordCount()==0){
      echo "No product found with barcode $plu";
      return;
   }
   $row = $result->FetchRow();
   $qry=sprintf(product_collection_qry9,$frm['cid'],$row[0]);
   $_SESSION['VxCFG']->dbh->Execute($qry); 
   
   editcollection($frm["id"]) ;
}

function deleteItem($frm)
{
   $qry=sprintf(product_collection_qry10, $frm['cid'],$frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   editcollection($frm["id"]) ;
}

function collectionMerge($id)
{
   $frm["id"]=$id;
   $frm["newaction"] = "mergesave";
   $frm["heading"] = "Collection Label Merge";
		
	include("templates/collmerge.php");
   exit;
}

function mergeSave($frm)
{  
   $c=new Collection();
   $c->Merge($frm["id"], $frm["mergefile"]);
   /*
   if($frm["openglabel"]=="Y"){
      $fp = fopen("$label_header_template", "w+");
      if(!fp) return;
      
      // general header template layout
      <?xml version="1.0"?>
      <glabels:Label xmlns:glabels="http://snaught.com/glabels/0.4/" rotate="False" width="XXX.XXX" height="XXX.XXX">
      <glabels:Media_Type>XXXXXXXX Label Sheet Name XXXXXXXX</glabels:Media_Type>
         
      // content template
      <glabels:Text x="XXX.XX" y="XX.XX" font_family="Helvetica" font_size="14" font_weight="Regular" font_italic="False" justify="Left" color="0x000000ff">
      <glabels:Line>
      <glabels:Field name="name"/>
      </glabels:Line>
      </glabels:Text>
      <glabels:Text x="XXX.XX" y="XXX.XX" font_family="Helvetica" font_size="14" font_weight="Regular" font_italic="False" justify="Right" color="0x000000ff">
      <glabels:Line>
      <glabels:Field name="price"/>
      </glabels:Line>
      </glabels:Text>
      <glabels:Barcode x="XXX.XX" y="XXX.XX" color="0x000000ff" style="UPC" text="True" scale="0.7">
      <glabels:Field name="barcode"/>
      </glabels:Barcode>
         
      // footer template (the recently created merge file)
      <glabels:Merge_Properties type="Text/Comma" src="XXXXXXXX">
      <glabels:Field key="name" loc="1"/>
      <glabels:Field key="barcode" loc="2"/>
      <glabels:Field key="price" loc="3"/>
      </glabels:Merge_Properties>
      </glabels:Label>
   }
   */
}

function FillCollCombo($id)
{
   CollectionCombo($id);
}

function FillProdCollTable($action, $id) 
{
   if($action=="add" || $action=="add"){
   }
   else{
      $c=new Collection();
      $c->FillCollectionTable($action, $id);
   }
}

function RecurseTree($id, $catid, $node, $open, $closed)
{
   $qry=sprintf(productm_catorg_qry2, $catid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result->RecordCount()==0){
      return;
   }
   while($row = $result->FetchRow()){
      $z=&$node->addItem(new HTML_TreeNode(array('text'=>$row['name'], 'link'=>"category.php?action=catchange&if=$id&catid=".$row['id'],
               'icon'=>$closed,'expandedIcon'=>$open)));
      $sqry=sprintf(productm_catorg_qry2, $row["id"]);
      $sresult=$_SESSION['VxCFG']->dbh->Execute($sqry);
      if($sresult->RecordCount()==0){
      }
      else{
         $srow = $sresult->FetchRow();
         RecurseTree($id, $row['id'], &$z, $open, $closed);
      }
   }
}

function ProductLists($a, $id, $prodcollid, $catid=0)
{
   $closed="tree_folderclosed.png";
   $open="tree_folderopen.png";
   
   $tree = new HTML_TreeMenu();
   $acc = new HTML_TreeNode(array('text'=>_("Categories"),'icon'=>$closed,'expandedIcon'=>$open));
   // from the root category headings, loop over parentid's (0 being root headings)
	$result=$_SESSION['VxCFG']->dbh->Execute(productm_catorg_qry1);
   $row = $result->FetchRow();
   $qry=sprintf(productm_catorg_qry2, $row['id']);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   
	while($row = $result->FetchRow()){
      $z=&$acc->addItem(new HTML_TreeNode(array('text'=>$row['name'], 'link'=>"collection.php?action=catchange&id=$id&catid=".$row['id'],
            'icon'=>$closed,'expandedIcon'=>$open)));
      RecurseTree($id, $row['id'], &$z, $open, $closed);
   }
   $tree->addItem($acc);
   $treedisp = new HTML_TreeMenu_DHTML($tree, array('images'=>$_SESSION['VxCFG']->styleimagedir));
   
   echo "<table>\n<tr>\n<td align=\"left\" class=\"listctrl\">";  
   $treedisp->printMenu();
   echo "</td>\n";
   
   echo "<td align=\"right\" class=\"listctrl\">";
   $nocat=false;
   //$qry=sprintf(productm_product_qry12, $id);
	//$presult=$_SESSION['VxCFG']->dbh->Execute($qry);
   //$prow = $presult->FetchRow();
   $qry=sprintf(product_collection_qry15, $catid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   echo "<select name=\"listSrc\" multiple size=\"16\" style=\"width:160\">\n";
   if($result->RecordCount()==0){
      $nocat=true;
      //$result=$_SESSION['VxCFG']->dbh->Execute(productm_product_qry15);
      //while($row = $result->FetchRow()){
         //echo "<option value=\"".$row['id']."\">". $row['name'] ."</option>\n";
      //}
   }
   else{
      $s=array();
      while($row = $result->FetchRow()){
         array_push($s, $row['id']);
      }
      //$result=$_SESSION['VxCFG']->dbh->Execute(productm_product_qry15);
      while($row = $result->FetchRow()){
         if(!in_array($row['id'], $s)){
            echo "<option value=\"".$row['id']."\">". $row['name'] ."</option>\n";
         }
   	}
   }
   echo "</select>";
   echo "</td>\n<td align=\"center\" class=\"listctrl\"><table>\n<tr>\n";
   echo "<td class=\"listctrl\" nowrap><input type=\"button\" style=\"width:40\" onclick=\"moveList(this.form.listSrc,this.form.elements['listTarget[]'], true)\"  
      name=\">>\"  value=\">>\"></td>\n</tr>\n<tr>\n";
   echo "<td class=\"listctrl\" nowrap><input type=\"button\" style=\"width:40\" onclick=\"moveList(this.form.listSrc,this.form.elements['listTarget[]'], false)\"  
      name=\">\"  value=\">\"></td>\n</tr>\n<tr>\n";
   echo "<td class=\"listctrl\" nowrap><input type=\"button\" style=\"width:40\" onclick=\"moveList(this.form.elements['listTarget[]'],this.form.listSrc, false)\"  
      name=\"<\"  value=\"<\"></td>\n</tr>\n<tr>\n";
   echo "<td class=\"listctrl\" nowrap><input type=\"button\" style=\"width:40\" onclick=\"moveList(this.form.elements['listTarget[]'],this.form.listSrc, true)\"  
      name=\"<<\"  value=\"<<\"></td>\n</tr>\n</table>\n</td>";
  
   echo "<td align=\"left\" class=\"listctrl\">";
   echo "<select name=\"listTarget[]\" multiple size=\"16\" style=\"width:160\">\n";
   if($nocat){
   }
   else{
      $qry=sprintf(product_collection_qry11,$prodcollid);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      while($row = $result->FetchRow()){
         $qry=sprintf(product_collection_qry16,$prodcollid);
         $res=$_SESSION['VxCFG']->dbh->Execute($qry);
         $r = $res->FetchRow();
         if(!in_array($row['id'], $s)){
            echo "<option value=\"".$r['id']."\">". $r['name'] ."</option>\n";
         }
   	}
   }
   echo "</select>";
      
   echo "</td>\n<td width=\"100%\" rowspan=\"4\"></td>\n</tr>\n</table>\n";
}

function listcollection()
{

   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(product_collection_qry14, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no product collections defined.")."</td></td></table>\n";
      exit;
   }
   
	echo "<tr><td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Quantity")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Quantity")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=quantity\">"._("Quantity")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='description'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Description")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Description")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=quantity\">"._("Description")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='description'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='numprod'){
      if($sortorder=='asc'){
          echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Num Products")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Num Products")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=quantity\">"._("Num Products")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='numprod'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
	
	echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";

	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      $n=$row["name"];
      $d=$row["description"];
		$cid=$row["collectionid"];

		$nresult=db_query("SELECT count(*) from productcollection WHERE prodcollid='$cid'");
		if($nrow = $nresult->FetchRow())
		   $num=$nrow[0];
      else
         $num="0";
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">$n</td>\n";
         echo "<td class=\"listdata\">$d</td>\n";
         echo "<td class=\"listdata\">$num</td><td class=\"listdata\">\n";		
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">$n</td>\n";
         echo "<td class=\"listdataeven\">$d</td>\n";
         echo "<td class=\"listdataeven\">$num</td><td class=\"listdataeven\">\n";		
      }
      $wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"collection.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"collection.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"collection.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"collection.php?action=browse&id=$wibbler&offset=$offset\">".misc_listview."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"collection.php?action=edit&id=$wibbler&offset=$offset\">".misc_listedit."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"collection.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
