<?php
/*
images.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
   Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/image.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(3);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['siteid'])){
   $action='sitechange';
}
else if(isset($_REQUEST['deptid'])){
   $action='deptchange';
}
else if(isset($_REQUEST['groupid'])){
   $action='groupchange';
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_PRODUCT){
         $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
         $action='list';
      }
      else{
         $action='list';
      }
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Product Images"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Product Images");
}

if(isset($_REQUEST['paction'])){
}

if($_SESSION["pageindex"]->CheckNum(product_image_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

if(isset($_FILES['reffile'])){
   insertimage();
}

switch($action){
  case "clear" :
    addImage();
    break;

  case "browse":
      if(isset($_REQUEST['id'])){
         browseImage($id);
         break;
      }
    browseImage($id);
    break;

  case "edit" :
    editImage($_REQUEST['id']);
    break;

  case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelImage($_REQUEST['id']);
      }
      else{
         deleteImage($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listImage();
      }
    break;

   case "cfmdelete" :
      deleteImage($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listImage();
      break;

   case "add" :
      insertImage($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listImage();
      break;

   case "commit" :
      commitImage($_POST);
      listImage();
      break;
      
   case "list":
   default :
      $_SESSION['vxmisuser']->ClearFocus();
      listImage();
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(product_image_qry1);
   if(!$result) return 0;
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = "";
   $frm["imageid"] = "";
   $frm["name"]="";
   $frm["type"]="";
   $frm["reffile"]="";
   $frm["width"]="";
   $frm["height"]="";
   $frm["bbp"]="";
   $frm["scale"]="";
   
   return $frm;
}

function fillForm($id, $bOffset)
{
  if($bOffset){
      $qry=sprintf(product_image_qry3, $id);
   }
   else{
      $qry=sprintf(product_image_qry4, $id);
   }
  $result=$_SESSION['VxCFG']->dbh->Execute($qry);
  $row = $result->FetchRow();

   $frm["id"] = $row["id"];
   $frm["imageid"] = $row["imageid"];
   $frm["name"]=$row["name"];
   $frm["type"]=$row["type"];
   $frm["reffile"]=$row["reffile"];
   $frm["width"]=$row["width"];
   $frm["height"]=$row["height"];
   $frm["bbp"]=$row["bbp"];
   $frm["scale"]=$row["scale"];
   
   return $frm;
}

function addImage()
{
  $frm=clearForm();
  $frm["newaction"] = "add";
  include($_SESSION['VxCFG']->styledir."/header.php");
  include("templates/images.php");
}

function editImage($id) 
{
   $frm=fillForm($id, false);
   $frm["newaction"] = "commit";
   include($_SESSION['VxCFG']->styledir."/header.php");
   include("templates/images.php");
}

function browseImage($id) 
{
   $frm=fillForm($id, true);
   $frm["newaction"] = "browse";
   include($_SESSION['VxCFG']->styledir."/header.php");
   include("templates/images.php");
}


function chkdelImage($id)
{
   $frm=fillForm($id, false);
   $frm["newaction"] = "cfmdelete";
   include($_SESSION['VxCFG']->styledir."/header.php");
   include("templates/images.php");
}

function deleteImage($frm) 
{
   $qry=sprintf(product_image_qry8, $frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function insertImage($frm)
{
   $qry=sprintf(product_image_qry5, $frm['employeenumber'],$frm['groupid'],$sdate,$edate,
   $frm["titleid"],$frm['fname'],$frm['lname'],$frm['sex'],$dob,$adid,$frm['jobdesc'],$frm['imageid'],
   $frm['payid'],$frm['annualpay'],$frm["holidayentitlementid"],$frm["holidaytakenid"],
   $frm['taxcode'],$frm['nicode'],$frm['ninumber'],$frm['prevtax'],$frm['prevpay'],
   $frm['bankid'],$frm['memoid']);

   $_SESSION['VxCFG']->dbh->Execute($query);

}

function commitImage($frm) 
{
   $qry=sprintf(product_image_qry6, $frm["c_titleid"],$frm['c_fname'],$frm['c_lname'],$frm['c_sex'],$dob,$adid,
      $frm['c_imageid'],$frm['c_memoid'],$frm['c_contactid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function ImageView($action, $id)
{
   $i=new Image();
   $i->Fill($id);
   $i->SetWidth($_SESSION['VxCFG']->defaultimgx);
   $i->SetHeight($_SESSION['VxCFG']->defaultimgy);
   $i->View($action, $id, "Image");
   //echo "<a href=\"javascript:popWindow('".$_SESSION["VxCFG"]->styledir."/imgpopup.php','imgpop','reffile')\">Cunt</a>\n";
   /*
   echo "<input class=\"help\" type=\"image\" height=\"24\" width=\"24\"";
   echo "src=\"".$_SESSION['VxCFG']->styleimagedir."/icon_help.png\" name=\"test\"";
   echo "<onclick=\"popWindow('".$_SESSION["VxCFG"]->styledir."/imgpopup.php','imgpop','reffile')\">\n";*/
}
/*
function insertImage() 
{
   $size = getimagesize($_FILES['reffile']['tmp_name']);
   $w=$size[0];
   $h=$size[1];
   
   //$owner=fileowner($_SERVER['PHP_SELF']);
   
   if($frm['type']==BHSQL_IMAGEDATA_PERSON){
      if(move_uploaded_file($_FILES['reffile']['tmp_name'], $_SESSION['VxCFG']->relpeopleimg .'/'. $_FILES['reffile']['name'])){
         $f='/people_images/'.$_FILES['reffile']['name'];
      }
      else{
         return;
      }
   }
   else{
      if(move_uploaded_file($_FILES['reffile']['tmp_name'], $_SESSION['VxCFG']->relprodimg .'/'. $_FILES['reffile']['name'])){
         $f='/product_images/'.$_FILES['reffile']['name'];
      }
      else{
         return;
      }
   }
   $qry=sprintf(image_qry5, $frm['type'],$f,$w,$h,$frm['bbp'],$frm['scale']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}
*/
function listImage()
{
   include($_SESSION['VxCFG']->styledir."/header.php");
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(product_image_qry13, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no product images defined")."</td></tr></table>\n";
      exit;
   }
   
   echo "<tr>\n<td class=\"listcombo\" colspan=\"2\"><table class=\"listcombo\">\n<tr>\n";
   echo "<td class=\"listcombo\">";
   echo "</td>\n</tr>\n</table>\n</td>\n</tr>\n";
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='image'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Image")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Image")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=image\">"._("Image")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='image'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";

   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      $f=$_SESSION['VxCFG']->prodimg."s/".$row["reffile"];
      if($c%2){
         echo "<tr class=\"listdata\">\n<td class=\"listdata\"><img src=\"".$f."\" height=\"".$row["height"]."\" width=\"".$row["width"]."\"></td>\n";
         echo "<td class=\"listdata\">".$row["name"]."</td>\n";
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\">\n<td class=\"listdata\"><img src=\"".$f."\" height=\"".$row["height"]."\" width=\"".$row["width"]."\"></td>\n";
         echo "<td class=\"listdataeven\">".$row["name"]."</td>\n";
         echo "<td class=\"listdataeven\">";
      }
      $wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"images.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"images.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"images.php?action=delete&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
        echo "<a href=\"images.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"images.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"images.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
   }
   echo "</table>";
}

?>
