<?php
/*
product.php

Copyright (C)2004 Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/currency.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('plu');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Product Administration"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Product Administration");
}

if($_SESSION["pageindex"]->CheckNum(product_product_qry1, "product")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}

//include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addProd();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseProd($_REQUEST['id']);
         break;
      }
		browseProd($_POST['id']);
		break;

	case "edit" :
      if(isset($_REQUEST['catsel'])){
         $catsel=$_REQUEST['catsel'];
      }
      else{
         $catsel='';
      }

		editProd($_REQUEST['id'], $catsel);
		break;

	case "promoshow" :
		break;

	case "flagsshow" :
		break;
   
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelProd($_REQUEST['id']);
      }
      else{
         deleteProd($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listProd();
      }
      break;  
	
   case "cfmdelete" :
      deleteProd($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listProd();
		break;

	case "add" :
		insertProd($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
    	listProd();
		break;

	case "commit" :
		commitProd($_POST);
      listProd();
		break;
      
   case "duplicate" :
      $id=duplicateProd($_REQUEST['id']);
      editProd($id);
      break;
      
   case "search":
      findProduct();
      break;
      
   case "searchresults":
      searchResults($_POST);
      break;
   
   case "list":
	default :
      $_SESSION['vxmisuser']->ClearFocus();
      if(isset($_REQUEST['pcategory'])) $pl=$_REQUEST['pcategory'];
      else $pl='All';
      if(isset($_POST['punique'])) $pu='Y';
      else $pu='N';
      listProd($pl, $pu);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(product_product_qry1);
   if(!$result){ 
      return 0;
   }
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}


function clearform()
{
   $frm["id"] = '';
   $frm["productid"] = '';
   $frm["invid"] = '';
   $frm["attributeid"] = '';
   $frm["categoryid"] = '';
   $frm["plu"] = '';
   $frm["prodplu"] = 'EAN-13';
   $frm["name"] = '';
   $frm["description"] = '';
   $frm["instock"] = '';
   $frm["discontinued"] = 'N';
   $frm["imageid"] = '';
   $frm["reciepttext"] = '';
   $frm["labelid"] = '';
   $frm["sellquantityid"] = '';
   $frm["discountid"] = '';
   $frm["promotionid"] = '';
   $frm["rentable"] = 'N';
   $frm["depositid"] = '';
   $frm["ecommerce"] = 'N';
   $frm["flags"] = '';
   $frm["productlink"] = '';
   $frm["keywords"] = '';

   $frm["nameid"] = '0';
   $frm["quantitytypeid"] = '';
   $frm["price"] = '';
   $frm["udv"] = '';
   $frm["quantity"] = '';
   $frm["basecurrencyid"]= '';
   $frm["taxid"]= '';

   $frm["imgid"] = '';
   $frm["reffile"] = '';
   $frm["width"] = '';
   $frm["height"] = '';
   $frm["bbp"] = '';
   $frm["scale"] = '';

   $frm["onpromo"] = 'N';
   $frm["showpromo"] = '';
	
   $frm["promoid"] = '';
   $frm["Startdate"] = '';
   $frm["enddate"] = '';
   $frm["margin"] = '';
   $frm["memo"] = '';
   
   $frm["supplierid"]='';
   $frm["suppliercode"]='';
   $frm["bprice"]="";
   $frm["budv"]="";
   $frm["bquantity"]="";
   $frm["bquantitytypeid"]="";
   $frm["btaxid"]="";
   $frm["bbasecurrencyid"]="";
   
   $frm["catsel"]=0;
      
   return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(product_product_qry2, $id);
   }
   else{
      $qry=sprintf(product_product_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();

   $frm["id"] = $row["id"];
   
   $_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_PRODUCT);
   $_SESSION['vxmisuser']->SetFocusID($row['id']);   
   $_SESSION['vxmisuser']->SetFocusName($row['name']);
   
   $frm["id"] = $row["id"];
   $frm["productid"] = $row["id"];
   $frm["invid"] = $row["invid"];
   $frm["attributeid"] = $row["attributeid"];
   $frm["categoryid"] = $row["categoryid"];
   $frm["plu"] = $row["plu"];
   $frm["prodplu"] = $row["plutype"];
   $frm["name"] = $row["name"];
   $frm["description"] = $row["description"];
   $frm["instock"] = $row["instock"];
   $frm["discontinued"] = $row["discontinued"];
   $frm["imageid"] = $row["imageid"];
   $frm["reciepttext"] = $row["reciepttext"];
   $frm["discountid"] = $row["discountid"];
   $frm["sellquantityid"] = $row["sellquantityid"];
   $frm["promotionid"] = $row["promotionid"];
   $frm["rentable"] = $row["rentable"];
   $frm["depositid"] = $row["depositid"];
   $frm["ecommerce"] = $row["ecommerce"];
   $frm["flags"] = $row["flags"];
   $frm["productlink"] = $row["productlink"];
   $frm["keywords"] = $row["keywords"];

   $qry=sprintf(product_product_qry31, $row["sellquantityid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$qtrow = $result->FetchRow();
   $frm['pqid']=$qtrow["pqid"];
	$frm["nameid"] = $qtrow["nameid"];
	$frm["quantitytypeid"] = $qtrow["quantitytypeid"];
	$frm["price"] = $qtrow["price"];
	$frm["udv"] = $qtrow["udv"];
	$frm["quantity"] = $qtrow["quantity"];
	$frm["basecurrencyid"]=$qtrow["basecurrencyid"];
	$frm["taxid"]=$qtrow["taxid"];

	$taxid=$qtrow["taxid"];
	$qtyid=$qtrow["quantitytypeid"];
	if(!isset($qtyid) || $qtyid==0){
		$frm["qtyname"]=_("Not Set");
	}
	else{
      $qry=sprintf(product_product_qry32, $qtyid);
		$result=$_SESSION['VxCFG']->dbh->Execute($qry);
		$row = $result->FetchRow();
		$frm["qtyname"]=$row["name"];
	}
	
   $qry=sprintf(product_product_qry33, $taxid);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
	$frm["taxid"] = $row["taxid"];
	$frm["taxaccount"] = $row["accountid"];
	
	if(!isset($taxid) || $taxid==0){
		$frm["taxname"]="Not Set";
	}
	else{
      $qry=sprintf(product_product_qry34, $frm["taxaccount"]);
		$result=$_SESSION['VxCFG']->dbh->Execute($qry);
		$row=$result->FetchRow();
		$frm["taxname"]=$row["name"];
	}
	
/*
	$frm["imgid"] = '';
   $frm["reffile"] = '';
   $frm["width"] = '';
   $frm["height"] = '';
   $frm["bbp"] = '';
   $frm["scale"] = '';
*/
	$frm['onpromo'] = 'N';
	$frm["showpromo"] = 0;
/*	
	$frm["promoid"] = '';
   $frm["startdate"] = '';
   $frm["enddate"] = '';
   $frm["margin"] = '';
   $frm["memo"] = '';
*/
	$qry=sprintf(product_invpq_qry9, $frm["productid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result){
      $row = $result->FetchRow();
      $frm["buypriceqtyid"]=$row['id'];
      $frm["supplierid"]=$row['supplierid'];
      $frm["suppliercode"]=$row['suppliercode'];
      $frm["bnameid"]=$row['nameid'];
      $frm["bprice"]=$row['price'];
      $frm["budv"]=$row['udv'];
      $frm["bquantity"]=$row['quantity'];
      $frm["bquantitytypeid"]=$row['quantitytypeid'];
      $frm["btaxid"]=$row['taxid'];
      $frm["bbasecurrencyid"]=$row['basecurrencyid'];
   }
   else{
      $frm["buypriceqtyid"]=0;
      $frm["supplierid"]="";
      $frm["suppliercode"]="";
      $frm["bnameid"]="";
      $frm["bprice"]="";
      $frm["budv"]="";
      $frm["bquantity"]="";
      $frm["bquantitytypeid"]="";
      $frm["btaxid"]="";
      $frm["bbasecurrencyid"]="";
   }
   
   /*
   $qry=sprintf(productm_product_qry26, $row["id"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result){
      $row = $result->FetchRow();
      $frm["suppliercode"]=$row['suppliercode'];
   }
   */
   
	return $frm;
}

function findProduct()
{
   include($_SESSION['VxCFG']->styledir."/header.php");
   $_SESSION["vxmisuser"]->ClearFocus();
   $frm["newaction"] = "searchresults";
   include("templates/prodsearch.php");
}

function searchResults($_POST)
{
   /*
<tr>
<td class="listtitle">PLU</td>
<td class="listtitle">Name</td>
<td class="listtitle">Description</td>
<td class="listtitle">Old Stock</td>
<td class="listtitle">Sold</td>
<td class="listtitle">In Stock</td>
<td class="listtitle">Re-Order Level</td>
<td class="listtitle">On Order</td>
</tr>
ListResults();
   */
   
   if(!isset($_POST['searchin']))
     exit();

   $sorton=$_POST['sorton'];
   $sname=$_POST['searchfor'];
   $search = str_replace(" ","%",$_POST['searchfor']);
   if($search != ""){
      $search = "%" . $search . "%";

      switch($_POST['searchin']) {
         case 'plu':
            $search = "AND product.plu like '$search'";
            $sortby = "product.plu";
            break;
         case 'name':
            $search = "AND product.name LIKE '$search'";
            $sortby = "product.name";
            break;
         case 'description':
            $search = "AND inventory.description LIKE '$search'";
            $sortby = "inventory.description";
            break;
         case 'keyword':
            $search = "AND product.keywords LIKE '$search'";
            $sortby = "product.keywords";
            break;
         default:
            $search = "";
            $sortby = "inventory.description";
            break;
      }
   }
   else {
      $sortby = "inventory.description";
   }
   
   $_SESSION["vxmisuser"]->ClearFocus();
   
   $_SESSION["vxmisuser"]->SetSortOn($sorton);
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $prodcat=$_POST['scatagory'];
   if(isset($_POST['punique'])){
      $produnique=$_POST['punique'];
   }
   else{
      $produnique='N';
   }
   
   if($prodcat=='All'){
      if($produnique=='N'){
         $pqry="distinct(product.productid)";
      }
      else{
         $pqry="product.id";
      }
      $cqry="";
   }
   else{
      if($produnique=='N'){
         $pqry="distinct(product.productid)";
      }
      else{
         $pqry="product.id";
      }
      $cqry="and product.categoryid='$prodcat' ";
   }
   
   $qry=sprintf(product_product_qry38, $pqry, $cqry, $search,$sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<form action=\"".$_SERVER['PHP_SELF']."\" method=\"POST\">\n";
   $_REQUEST['action']="list";
   
   echo "<input type=\"hidden\" name=\"scatagory\" value=\"".$_POST['scatagory']."\">\n";
   echo "<input type=\"hidden\" name=\"punique\" value=\"".$produnique."\">\n";
   echo "<table class=\"listtable\">\n";
   echo "<tr>\n<td class=\"alphaselect\" align=\"left\">"._("Search Results for: ");
   echo "<b>".$_POST['searchin']." - </b><i>".$sname."</i></td>\n";
   echo "<td class=\"alphaselect\" colspan=\"5\">&nbsp</td>\n</tr>\n";
   
   if(($num=$result->RecordCount())==0){
      echo "<tr><td colspan=\"5\">"._("There are no products defined")."</td></td></table>\n";
      exit;
   }
   $_SESSION["pageindex"]->setnum($num);
   
	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='plu'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("PLU")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("PLU")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=plu\">"._("PLU")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='plu'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\" width=\"50%\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='categoryid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Category")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Category")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=categoryid\">"._("Category")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='categoryid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='instock'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("On Hand")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("On Hand")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=instock\">"._("On Hand")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='instock'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
	while($row = $result->FetchRow()){
	   $p=$row["plu"];
	   $d=$row["name"];
      
      $qry=sprintf("select instock from inventory where id='%d'", $row['invid']);
      $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
      $prow = $presult->FetchRow();
      $s=$prow["instock"];
      
      if(!isset($row['plu']) || $row['plu']=="") continue;
	   echo "<tr><td class=\"listdata\">$p</td>\n<td class=\"listdata\">$d</td>\n<td class=\"listdata\">";
      
      $qry=sprintf(productm_product_qry12, $row['id']);
	   $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
      $prow = $presult->FetchRow();
      $qry=sprintf(productm_product_qry13, $prow['categoryid']);
      $cresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($cresult->RecordCount()==0){
         echo _("Not Set");
      }
      else{
         while($crow = $cresult->FetchRow()){
            echo $crow['name']." ";
         }
      }
      echo "</td><td class=\"listdata\">$s</td>\n<td class=\"listdata\">";
		
		$wibbler=$row["id"];
		
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"product.php?action=browse&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"product.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"product.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"product.php?action=browse&id=$wibbler\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"product.php?action=edit&id=$wibbler\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"product.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
	}
	echo "</table>";
}

function addProd()
{
   $frm=clearform();
	$frm["newaction"] = "add";
   include($_SESSION['VxCFG']->styledir."/header.php");
	include("templates/product.php");
}

function editProd($id, $catsel=false) 
{
	$frm=fillform($id, false);

   if($catsel) $frm['catsel']=$catsel;
   else $frm['catsel']='';
	$frm["newaction"] = "commit";
   $_SESSION['vxmisuser']->SetFocusAction('edit');
   include($_SESSION['VxCFG']->styledir."/header.php");
	include("templates/product.php");
}

function browseProd($id) 
{
	$frm=fillform($id, true);
   $frm['catsel']='';
	$frm["newaction"] = "browse";
	$_SESSION["pageindex"]->setprev("browse");
   $_SESSION['vxmisuser']->SetFocusAction('browse');
	include($_SESSION['VxCFG']->styledir."/header.php");
	include("templates/product.php");
}

function deleteProd($id)
{
   $frm=fillform($id, false);
   
   // acquire buy price and delete it
   $qry=sprintf(inventory_qry9, $frm['invid']);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $qry=sprintf(invpq_qry6, $row[0]);
   db_query($qry);
   
   // delete inv item
   $qry=sprintf(inventory_qry10, $frm['invid']);
   db_query($qry);
   
   // delete [if exists] image, 
   // delete [if unique to product] promotion 
   // delete [if unique to product] discount 
   // delete [if unique to product/site] margin

   // delete sell price
   // !!!CHANGE ME BEFORE v0.9.6!!!
   // this is dangerous as several products can be pointed to a single sell price
   $qry=sprintf(sellpq_qry6, $frm['sellquantityid']);
   db_query($qry);
   
   //delete product
   $qry=sprintf(product_qry6, $id);
   db_query($qry);
}

function chkdelProd($id) 
{
   $frm=fillform($id);
   $frm["newaction"]="cfmdelete";
   include("templates/product.php");
}

function insertProd($frm) 
{
   $frm["rentable"]=yesno(isset($frm["rentable"]));
   $frm["discontinued"]=yesno(isset($frm["discontinued"]));
   $frm["ecommerce"]=yesno(isset($frm["ecommerce"]));
   $frm["numpromo"]=yesno(isset($frm["numpromo"]));

   $cm=new CreateMod();
   $cm->Fill(0);
   $cmid=$cm->Commit();

   // generate blank inv entry
   $qry=sprintf(product_product_qry16,0,0,'',0,'','',0,0,0,0,0,0,0,0,$cmid,0);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $invid = $row[0];
   
      
   // fill out a buy price quantity entry
   $qry=sprintf(product_product_qry17,0,$frm['nameid'],$frm['bquantity'],$frm['bquantitytypeid'],$frm['budv'],
      $frm['bprice'],$frm['bbasecurrencyid'],$frm['supplierid'],$frm['suppliercode'],0,0,
      $frm['btaxid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   
   // update invpqid
   $qry=sprintf(productm_product_qry18, $row[0], $row[0]);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   
   // update inv for invpq
   $qry=sprintf(productm_product_qry19, $row[0], $row[0]);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   // insert an image insert (if doesn't exist)
   $qry=sprintf(productm_product_qry21, $frm['reffile']);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result->RecordCount()==0){
      $qry=sprintf(productm_product_qry22, '2',$frm['reffile'], 0, 0, 0, 0);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
      $row = $result->FetchRow();
      $imageid=$row[0];
   }
   else{
      $row=$result->FetchRow();
      $imageid=$row['imageid'];
   }
   // finally the product
   $qry=sprintf(productm_product_qry4,'0','0',$invid,$frm["attributeid"],$frm['categoryid'],$frm['plu'],$frm['plutype'],
		$frm['name'],$frm['description'],$frm['instock'],$frm['discontinued'],$imageid,
		$frm['reciepttext'],$frm['discountid'],0,$frm['numpromo'],$frm['rentable'],
      $frm['depositid'],$frm['ecommerce'],$frm['flags'],$frm['productlink'],$frm['keywords']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $prodid=$row[0];
   
   // sell price
   $qry=sprintf(product_product_qry27,0,$frm['nameid'],$frm['quantity'],$frm['quantitytypeid'],$frm['udv'],
      $frm['price'],$frm['basecurrencyid'],$frm['taxid']);
    
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   
   // update pqid
   $qry=sprintf(productm_product_qry28, $row[0], $row[0]);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   // update product
   $qry=sprintf(productm_product_qry8, $row[0], $prodid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   // sell quantity names
   
   //$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   //$row = $result->FetchRow();
   
   // a set of categories
   if(isset($frm['listTarget'])){
      foreach($frm['listTarget'] as $cat){
         $qry=sprintf(product_product_qry20, $prodid, $cat);
         $_SESSION['VxCFG']->dbh->Execute($qry);
      }
   }
   
   return $prodid;
}

function commitProd($frm) 
{
	//$_SESSION["pageindex"]->setprev("commit");
	$frm["rentable"]=yesno(isset($frm["rentable"]));
	$frm["discontinued"]=yesno(isset($frm["discontinued"]));
	$frm["ecommerce"]=yesno(isset($frm["ecommerce"]));
	/* $frm["onpromo"]=yesno(isset($frm["onpromo"])); */
   
	/* temporary */
	$frm["numpromo"] = '0';
   
   // buy price/qty
   $qry=sprintf(product_product_qry40,0,$frm['bnameid'],$frm['bquantity'],$frm['bquantitytypeid'],$frm['budv'],
      $frm['bprice'],$frm['bbasecurrencyid'],$frm['supplierid'],$frm['suppliercode'],0,0,
      $frm['btaxid'],$frm['buypriceqtyid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   // sell price/qty
   $qry=sprintf(product_sellpq_qry5,$frm['pqid'],$frm['nameid'],$frm['quantity'],$frm['quantitytypeid'],$frm['udv'],
      $frm['price'],$frm['basecurrencyid'],$frm['taxid'], $frm['sellquantityid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);

   $id = $frm["id"];
   $qry=sprintf(product_product_qry29,$frm['attributeid'],$frm['categoryid'],$frm['plu'],$frm['plutype'],$frm['name'],
		$frm['description'],$frm['instock'],$frm['discontinued'],$frm['imageid'],$frm['reciepttext'],$frm['discountid'],
		$frm['pqid'],$frm['numpromo'],$frm['rentable'],$frm['depositid'],$frm['ecommerce'],$frm['flags'],$frm['productlink'],
      $frm['keywords'],$frm['id']);
   
   $_SESSION['VxCFG']->dbh->Execute($qry);
   /*
   if(isset($frm['listTarget'])){
      foreach($frm['listTarget'] as $cat){
         $qry=sprintf(product_product_qry20, $frm['id'], $cat);
         $_SESSION['VxCFG']->dbh->Execute($qry);
      }
   }*/
}

function duplicateProd($id) 
{
   $frm=fillForm($id, false);
   return insertProd($frm);
}

function PromotionTable($pid)
{
   $qry=sprintf(promotion_qry3, $pid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){
      echo "<table class=\"promotion\">\n"; //width="100%" border="1" cellspacing="2" cellpadding="2" bgcolor="#CCFFCC">
      echo "<tr><td colspan=\"4\" align=\"center\"><h3>Promotions</h3></td></tr>\n";
      echo "<tr><td class=label>Start Date</td>\n<td>";
	   echo "<td>class=label>End Date</td>\n<td>";
      echo "<td class=label>Type</td>\n<td>";
      echo "<td class=label>Margin</td>\n<td>";
      entry($a, "margin", 32, 32, $row['margin']);
      echo "<\td>\n<td class=label>Memo</td>\n<td>";
      entry($a, "memo", 32, 32, $row['memo']);
      echo "</tr></table>\n";
   }
}

function CategorySelect($a, $id, $catsel='')
{
   $qry=sprintf(productm_product_qry12, $id);
	$presult=$_SESSION['VxCFG']->dbh->Execute($qry);
   $prow = $presult->FetchRow();
   $qry=sprintf(productm_product_qry14, $prow['categoryid']);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result->RecordCount()==0){
      $result=$_SESSION['VxCFG']->dbh->Execute(productm_product_qry15);
      echo "<select name=\"categories[]\" multiple size=\"8\">\n";
      while($row = $result->FetchRow()){
         if($catsel=='all'){
            echo "<option value=\"".$row['id']."\" selected>". $row['name'] ."</option>\n";
         }
         else{
        	   echo "<option value=\"".$row['id']."\">". $row['name'] ."</option>\n";
         }
   	}
      echo "</select>";
   }
   else{
      $s=array();
      while($row = $result->FetchRow()){
         array_push($s, $row['id']);
      }
      $result=$_SESSION['VxCFG']->dbh->Execute(productm_product_qry15);
      echo "<select name=\"categories[]\" multiple size=\"8\">\n";
      while($row = $result->FetchRow()){
         if($catsel==''){
            if(in_array($row['id'], $s)){
	   	     	echo "<option selected value=\"".$row['id']."\">". $row['name'] ."</option>\n";
   		   }
         	else{
	          	echo "<option value=\"".$row['id']."\">". $row['name'] ."</option>\n";
   	   	}
         }
         else{
            if($catsel=='all'){
              echo "<option value=\"".$row['id']."\" selected>". $row['name'] ."</option>\n";
            }
            else {
        	      echo "<option value=\"".$row['id']."\">". $row['name'] ."</option>\n";
            }
         }         
         //echo $row['name']." ";
      }
      echo "</select><br\>";
      echo "<a href=\"product.php?action=edit&id=".$id."&catsel=all\">Select All</a>&nbsp;/&nbsp";
      echo "<a href=\"product.php?action=edit&id=".$id."&catsel=none\">Unselect All</a><br/><br/>";
   }
}

function CategoryLists($a, $id)
{
   echo "<table>\n<tr>\n<td align=\"right\" class=\"listctrl\">";
   $nocat=false;
   $qry=sprintf(productm_product_qry12, $id);
	$presult=$_SESSION['VxCFG']->dbh->Execute($qry);
   $prow = $presult->FetchRow();
   $qry=sprintf(productm_product_qry14, $prow['categoryid']);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   echo "<select name=\"listSrc\" multiple size=\"8\" style=\"width:160\">\n";
   if($result->RecordCount()==0){
      $nocat=true;
      $result=$_SESSION['VxCFG']->dbh->Execute(productm_product_qry15);
      while($row = $result->FetchRow()){
         echo "<option value=\"".$row['id']."\">". $row['name'] ."</option>\n";
      }
   }
   else{
      $s=array();
      while($row = $result->FetchRow()){
         array_push($s, $row['id']);
      }
      $result=$_SESSION['VxCFG']->dbh->Execute(productm_product_qry15);
      while($row = $result->FetchRow()){
         if(!in_array($row['id'], $s)){
            echo "<option value=\"".$row['id']."\">". $row['name'] ."</option>\n";
         }
   	}
   }
   echo "</select>";
   echo "</td>\n<td align=\"center\" class=\"listctrl\"><table>\n<tr>\n";
   echo "<td class=\"listctrl\" nowrap><input type=\"button\" style=\"width:40\" onclick=\"moveList(this.form.listSrc,this.form.elements['listTarget[]'], true)\"  
      name=\">>\"  value=\">>\"></td>\n</tr>\n<tr>\n";
   echo "<td class=\"listctrl\" nowrap><input type=\"button\" style=\"width:40\" onclick=\"moveList(this.form.listSrc,this.form.elements['listTarget[]'], false)\"  
      name=\">\"  value=\">\"></td>\n</tr>\n<tr>\n";
   echo "<td class=\"listctrl\" nowrap><input type=\"button\" style=\"width:40\" onclick=\"moveList(this.form.elements['listTarget[]'],this.form.listSrc, false)\"  
      name=\"<\"  value=\"<\"></td>\n</tr>\n<tr>\n";
   echo "<td class=\"listctrl\" nowrap><input type=\"button\" style=\"width:40\" onclick=\"moveList(this.form.elements['listTarget[]'],this.form.listSrc, true)\"  
      name=\"<<\"  value=\"<<\"></td>\n</tr>\n</table>\n</td>";
  
   echo "<td align=\"left\" class=\"listctrl\">";
   echo "<select name=\"listTarget[]\" multiple size=\"8\" style=\"width:160\">\n";
   if($nocat){
   }
   else{
      $result=$_SESSION['VxCFG']->dbh->Execute(productm_product_qry15);
      while($row = $result->FetchRow()){
         if(!in_array($row['id'], $s)){
            echo "<option value=\"".$row['id']."\">". $row['name'] ."</option>\n";
         }
   	}
   }
   echo "</select>";
      
   echo "</td>\n<td width=\"100%\" rowspan=\"4\"></td>\n</tr>\n</table>\n";
}

function SupplierCombo($a, $id)
{
   if($a=="commit" || $a=="add"){
		echo "<select name=\"supplierid\">\n";
      if($id==0)
         echo "<option selected value=\"0\">". _("None Set") ."</option>\n";
      else
         echo "<option value=\"0\">". _("None Set") ."</option>\n";
      
	   $result=$_SESSION['VxCFG']->dbh->Execute(product_product_qry30);
      while($row = $result->FetchRow()){
         if($id==$row['id']){
				echo "<option selected value=\"".$row['id']."\"> ".$row['name']." </option>\n";
			}
			else{
				echo "<option value=\"".$row['id']."\"> ".$row['name']." </option>\n";
			}
      }
      echo "</select>\n";
   }
   else{
      $qry=sprintf(product_product_qry41, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      echo $row['name'];
   }
}

function fillQTCombo($a,$cname,$id)
{
	if($a=="commit" || $a=="add"){
		echo "<select name=\"$cname\">\n";
	   $qtresult=$_SESSION['VxCFG']->dbh->Execute("select id, name from invitemquantitytype");
	
		while($qtrow = $qtresult->FetchRow()){
			$boo=$qtrow["id"];
			$poo=$qtrow["name"];
		
			if($id==$boo){
				echo "<option selected value=\"$boo\"> $poo </option>\n";
			}
			else{
				echo "<option value=\"$boo\"> $poo </option>\n";
			}
		}
		print "</select>\n";
	}
	else{
		$qtresult=$_SESSION['VxCFG']->dbh->Execute("select name from invitemquantitytype where id='$id'");
		if($qtrow = $qtresult->FetchRow()){
			$poo=$qtrow["name"];
			echo "$poo";
		}
	}
}

function fillTaxCombo($a, $cname, $id)
{
	if($a=="commit" || $a=="add"){
		$result=$_SESSION['VxCFG']->dbh->Execute("SELECT * FROM  taxrate");
		print "<select name=\"$cname\" width=\"250\">\n";

		while($myrow = $result->FetchRow()){
			$boo=$myrow["id"];
			$poo=$myrow["accountid"];
         $rate=$myrow["rate"] * 100;
		
			$aresult=db_query("select name from account where accountnumber = '$poo'");
			$arow=$aresult->FetchRow();
         if($arow["name"]==""){
			   $n=$rate."%";
         }
         else{
            $n=$arow["name"]." - ".$rate."%";
         }
			if($id==$boo){
				print "<option selected value=\"$boo\"> $n </option>\n";
			}
			else{
				print "<option value=\"$boo\"> $n </option>\n";
			}
		}
		print "</select>\n";
	}
	else{
		$result=$_SESSION['VxCFG']->dbh->Execute("SELECT * FROM  taxrate");
		if($myrow = $result->FetchRow()){
			$poo=$myrow["accountid"];
         $rate=$myrow["rate"] * 100;
			$aresult=db_query("select name from account where accountnumber = '$poo'");
			$arow=$aresult->FetchRow();
         if($arow["name"]==""){
			   $n=$rate."%";
         }
         else{
            $n=$arow["name"]." - ".$rate."%";
         }
			echo "$n";
		}
	}
}

function CatNarrowCombo()
{  
   echo "<select name=\"scatagory\">\n";
   $result=$_SESSION['VxCFG']->dbh->Execute(productm_category_qry7);
   echo "<option value=\"All\" selected>All</option>";
         
   while($row = $result->FetchRow()){
      echo "<option value=\"".$row['id']."\">".$row['name']."</option>\n";
	}
	echo "</select>\n";
}

function CatCombo($a, $id)
{  
   if($a=="commit" || $a=="add"){
	   echo "<select onChange=\"this.form.submit();\" name=\"pcategory\">\n";
      $result=$_SESSION['VxCFG']->dbh->Execute(productm_category_qry7);
      if($id=='All')
         echo "<option value=\"All\" selected>All</option>";
      else 
         echo "<option value=\"All\">All</option>";
         
		while($row = $result->FetchRow()){
			$boo=$row["id"];
         echo "<option ";
   	   if($id==$row['id'])
	         echo "selected ";
	      echo "value=\"".$row['id']."\">".$row['name']."</option>\n";
	   }
	   echo "</select>\n";
   }
}

function ImageSet($id) 
{
   $qry=sprintf(product_product_qry39, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result){
      echo "<td>"._("There are no product images defined")."</td>\n";
   }
   
   if(($num=$result->RecordCount())==0){
      echo "<td>"._("There are no product images defined")."</td>\n";
   }
   
   while($row = $result->FetchRow()){
      $f=$_SESSION['VxCFG']->prodimg."/".$row["reffile"];
      echo "<td align =\"left\" width=\"1%\"><table width=\"1%\"><tr>\n";
      echo "<td align =\"left\" width=\"1%\"><img src=\"".$f."\" height=\"".$row["height"]."\" width=\"".$row["width"]."\"></td>\n";
      echo "</tr>\n<tr>\n<td align =\"left\">".$row["reffile"]."</td>\n</tr>\n</table>\n</td>\n";
   }
}

function listProd($prodcat='All', $produnique='N')
{
   $_SESSION["vxmisuser"]->ClearFocus();
   
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   if($prodcat=='All'){
      if($produnique=='N'){
         $qry=sprintf(product_product_qry7, $sorton, $sortorder);
      }
      else{
         $qry=sprintf(product_product_qry35, $sorton, $sortorder);
      }
   }
   else{
      if($produnique=='N'){
         $qry=sprintf(product_product_qry36, $prodcat, $sorton, $sortorder);
      }
      else{
         $qry=sprintf(product_product_qry37, $prodcat, $sorton, $sortorder);
      }
   }

	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<form action=\"".$_SERVER['PHP_SELF']."\" method=\"POST\">\n";
   $_REQUEST['action']="list";
   
   echo "<input type=\"hidden\" name=\"pcatagory\" value=\"$prodcat\">\n";
   //echo "<input type=\"hidden\" name=\"punique\" value=\"$produnique\">\n";
   echo "<table class=\"listtable\">\n";
   echo "<tr>\n<td class=\"alphaselect\" align=\"left\" nowrap>&nbsp;&nbsp;"._("Category ");   
   CatCombo("commit", $prodcat, "pselect");
   echo "&nbsp;";
   if($produnique=='N')
      echo "<input class=\"checkbox\" onChange=\"this.form.submit();\" type=\"checkbox\" name=\"punique\" value='N'>"._("Unique")."\n";
   else
      echo "<input class=\"checkbox\" onChange=\"this.form.submit();\" type=\"checkbox\" name=\"punique\" value='Y' checked>"._("Unique")."\n";
   echo "</td>\n<td class=\"alphaselect\" colspan=\"4\">&nbsp</td>\n</tr>\n";
   
   if(($num=$result->RecordCount())==0){
      echo "<tr><td colspan=\"5\">"._("There are no products defined")."</td></tr></table>\n";
      return;
   }
   
   // erm... this needs sorting... limits/counts numbers change depending upon the above filters
   // $_SESSION["pageindex"]->setnum($num);
   
	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='plu'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("PLU")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("PLU")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=plu\">"._("PLU")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='plu'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\" width=\"50%\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='categoryid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Category")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Category")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=categoryid\">"._("Category")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='categoryid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='instock'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("On Hand")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("On Hand")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=instock\">"._("On Hand")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='instock'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
   
	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
	   $p=$row["plu"];
	   $d=$row["name"];
      
      $qry=sprintf("select instock from inventory where id='%d'", $row['invid']);
      $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
      $prow = $presult->FetchRow();
      $s=$prow["instock"];
      
      if(!isset($row['plu']) || $row['plu']=="") continue;
      
      $qry=sprintf(productm_product_qry12, $row['id']);
	   $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
      $prow = $presult->FetchRow();
      $qry=sprintf(productm_product_qry13, $prow['categoryid']);
      $cresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($cresult->RecordCount()==0){
         $cn= _("Not Set");
      }
      else{
         while($crow = $cresult->FetchRow()){
            $cn= $crow['name']." ";
         }
      }
      
      if($c%2){
	      echo "<tr class=\"listdata\">\n<td class=\"listdata\">$p</td>\n";
         echo "<td class=\"listdata\">$d</td>\n<td class=\"listdata\">$cn";
         echo "</td>\n<td class=\"listdata\">$s</td>\n<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\">\n<td class=\"listdataeven\">$p</td>\n";
         echo "<td class=\"listdataeven\">$d</td>\n<td class=\"listdataeven\">$cn";
         echo "</td>\n<td class=\"listdataeven\">$s</td>\n<td class=\"listdataeven\">";
      }
		
		$wibbler=$row["id"];
		
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"product.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"product.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"product.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"product.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"product.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"product.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

function CurrencyCombo($action, $cname, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, $cname);
}

?>
