<?php
/*
quantity.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(7);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Quantity Types"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Quantity Types");
}

if($_SESSION["pageindex"]->CheckNum(productm_quantity_qry1,"invitemquantitytype")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

$NoNavigationFlag=true;
include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addQty();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseQty($id);
         break;
      }
		browseQty($id);
		break;

	case "edit" :
		editQty($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelQty($_REQUEST['id']);
      }
      else{
         deleteQty($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listQty();
      }
      break;  
	
   case "cfmdelete" :
      deleteQty($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listQty();
		break;

	case "add" :
		insertQty($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listQty();
		break;

	case "commit" :
		commitQty($_POST);
      listQty();
		break;

	case "list":
	default :
		listQty();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(productm_quantity_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
	$frm["name"] = "";

	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(productm_quantity_qry2, $id);
   }
   else{
      $qry=sprintf(productm_quantity_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
	$frm["name"] = $row["name"];

	return $frm;
}

function addQty()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	
	include("templates/quantity.php");
}

function editQty($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/quantity.php");
}

function browseQty($id) 
{
	$frm=fillForm($id, true);

	$frm["newaction"] = "browse";
	
	include("templates/quantity.php");
}

function insertQty($frm) 
{
   $qry=sprintf(productm_quantity_qry4, $frm['name']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitQty($frm) 
{
   $qry=sprintf(productm_quantity_qry5, $frm['name'], $frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function chkdelQty($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/quantity.php");
}

function deleteQty($id) 
{
   $qry=sprintf(productm_quantity_qry6, $id);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function listQty()
{  
	$sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(productm_quantity_qry8, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("The are no quantity item types defined.")."</td></td></table>\n";
      exit;
   }
   
	echo "<tr><td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }

	echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
	
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
   		echo "<tr class=\"listdata\">\n<td class=\"listdata\">".$row['name']."</td>\n";
	   	echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\">\n<td class=\"listdataeven\">".$row['name']."</td>\n";
	   	echo "<td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"quantity.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"quantity.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"quantity.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"quantity.php?action=browse&id=$wibbler&offset=$offset\">".misc_listview."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"quantity.php?action=edit&id=$wibbler&offset=$offset\">".misc_listedit."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"quantity.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
