<?php
/*
spqname.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(8);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Price Names"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Price Names");
}

if($_SESSION["pageindex"]->CheckNum(productm_sellpqname_qry1, "pqname")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addspqname();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browsespqname($_REQUEST['id']);
         break;
      }
		browsespqname($_POST['id']);
		break;

	case "edit" :
		editspqname($_REQUEST['id']);
		break;
   
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelspqname($_REQUEST['id']);
      }
      else{
         deletespqname($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listspqname();
      }
      break;  
	
   case "cfmdelete" :
      deletespqname($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listspqname();
		break;

	case "add" :
		insertspqname($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listspqname();
		break;

	case "commit" :
		commitspqname($_POST);
		listspqname();
		break;
      
      
   case "bbrowse":
      if(isset($_REQUEST['id'])){
         browsebpqname($_REQUEST['id']);
         break;
      }
		browsesbqname($_POST['id']);
		break;

	case "bedit" :
		editbpqname($_REQUEST['id']);
		break;
   
   case "bdelete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelbpqname($_REQUEST['id']);
      }
      else{
         deletebpqname($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listspqname('N');
      }
      break;  
	
   case "bcfmdelete" :
      deletebpqname($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listbpqname('N');
		break;

	case "badd" :
		insertbpqname($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listspqname('N');
		break;

	case "bcommit" :
		commitbpqname($_POST);
		listspqname('N');
		break;

	case "list":
	default :
      if(isset($_REQUEST['sellpricename'])) $xyz='Y';
      else $xyz='N';
		listspqname($xyz);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(productm_sellpqname_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "";
	$frm["name"] = "";
	$frm["accountid"] = "";
	$frm["onmenu"] = "";

	return $frm;
}

function fillForm($id, $bOffset, $bBuy=false)
{
   if($bBuy){
      if($bOffset){
         $qry=sprintf(productm_bpqname_qry2, $id);
      }
      else{
         $qry=sprintf(productm_bpqname_qry3, $id);
      }
   }
   else{
      if($bOffset){
         $qry=sprintf(productm_sellpqname_qry2, $id);
      }
      else{
         $qry=sprintf(productm_sellpqname_qry3, $id);
      }
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm["id"] = $id;
	$frm["name"] = $row["name"];
	$frm["accountid"] = $row["accountid"];
	$frm["onmenu"] = $row["onmenu"];

	return $frm;
}

function addspqname()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	
	include("templates/spqname.php");
}

function editspqname($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
		
	include("templates/spqname.php");
}

function browsespqname($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
		
	include("templates/spqname.php");
}

function chkdelspqname($id)
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
		
	include("templates/spqname.php");
}

function deletespqname($id) 
{
   $qry=sprintf(productm_sellpqname_qry6, $id);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
}

function insertspqname($frm) 
{
   $qry=sprintf(productm_sellpqname_qry4, $frm['name'],$frm['accountid'],yesno(isset($frm['onmenu'])));
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitspqname($frm) 
{
   $qry=sprintf(productm_sellpqname_qry5, $frm['name'],$frm['accountid'],yesno(isset($frm['onmenu'])),$frm['id']);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
}

function addbpqname()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	
	include("templates/spqname.php");
}

function editbpqname($id) 
{
	$frm=fillForm($id, false, true);
	$frm["newaction"] = "bcommit";
		
	include("templates/spqname.php");
}

function browsebpqname($id) 
{
	$frm=fillForm($id, true, true);
	$frm["newaction"] = "bbrowse";
		
	include("templates/spqname.php");
}

function chkdelbpqname($id)
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "bcfmdelete";
		
	include("templates/spqname.php");
}

function deletebpqname($id) 
{
   $qry=sprintf(product_bpqname_qry6, $id);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
}

function insertbpqname($frm) 
{
   $qry=sprintf(product_bpqname_qry4, $frm['name'],$frm['accountid'],yesno(isset($frm['onmenu'])));
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitbpqname($frm) 
{
   $qry=sprintf(product_bpqname_qry5, $frm['name'],$frm['accountid'],yesno(isset($frm['onmenu'])),$frm['id']);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
}

function fillAccountNameCombo($a, $id)
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function listspqname($sellpricename='Y')
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   if($sellpricename=='Y'){
      $qry=sprintf(productm_sellpqname_qry8, $sorton, $sortorder);
   }
   else{
      $qry=sprintf(product_bpqname_qry8, $sorton, $sortorder);
   }
   
   $q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<form action=\"".$_SERVER['PHP_SELF']."\" method=\"POST\">\n";
   echo "<table class=\"listtable\">\n";
   echo "<tr>\n<td colspan=\"4\" class=\"alphaselect\" align=\"left\" nowrap>&nbsp;&nbsp;";
   if($sellpricename=='N')
      echo "<input class=\"checkbox\" onChange=\"this.form.submit();\" type=\"checkbox\" name=\"sellpricename\">"._("Sell Names")."\n";
   else
      echo "<input class=\"checkbox\" onChange=\"this.form.submit();\" type=\"checkbox\" name=\"sellpricename\" checked>"._("Sell Names")."\n";

   if(!$result){
      if($sellpricename=='N'){
         echo "<tr>\n<td colspan=\"2\">"._("The are no buy price names defined.")."</td></tr></table>\n";
      }
      else{
         echo "<tr>\n<td colspan=\"2\">"._("The are no sell price names defined.")."</td></tr></table>\n";
      }
      return;
   }
   
   if($result->RecordCount()==0){
      if($sellpricename=='N'){
         echo "<tr><td colspan=\"2\">"._("The are no buy price names defined.")."</td></tr></table>\n";
      }
      else{
         echo "<tr><td colspan=\"2\">"._("The are no sell price names defined.")."</td></tr></table>\n";
      }
      return;
   }
   echo "</td>\n</tr>\n";
   
	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='accountid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Account")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Account")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=accountid\">"._("Account")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='accountid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='onmenu'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("On Menu")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("On Menu")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=onmenu\">"._("On Menu")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='onmenu'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }

	echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";

	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">".$row['name']."</td>\n";
         $q=sprintf(productm_sellpqname_qry9, $row['accountid']);
         $aresult=$_SESSION['VxCFG']->dbh->Execute($q);
         if($arow = $aresult->FetchRow()){
            echo "<td class=\"listdata\">".$arow['name']."</td>\n";
         }
         else{
            echo "<td class=\"listdata\">"._("Not Set")."</td>\n";
         }
         echo "<td class=\"listdata\">";
         CheckBox("browse", "onmenu", $row['onmenu']);
         echo "</td><td class=\"listdata\">\n";
		}
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row['name']."</td>\n";
         $q=sprintf(productm_sellpqname_qry9, $row['accountid']);
         $aresult=$_SESSION['VxCFG']->dbh->Execute($q);
         if($arow = $aresult->FetchRow()){
            echo "<td class=\"listdataeven\">".$arow['name']."</td>\n";
         }
         else{
            echo "<td class=\"listdataeven\">"._("Not Set")."</td>\n";
         }
         echo "<td class=\"listdataeven\">";
         CheckBox("browse", "onmenu", $row['onmenu']);
         echo "</td><td class=\"listdataeven\">\n";
      }
      $wibbler=$row["id"];
      if($sellpricename=='Y'){
   		if($_SESSION['vxmisuser']->GetShowImages()){
            echo "<a href=\"spqname.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
            if($_SESSION['vxmisuser']->GetPerm('edit')){
		         echo "<a href=\"spqname.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
            }
            if($_SESSION['vxmisuser']->GetPerm('delete')){
		         echo "<a href=\"spqname.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
            }
         }
         else{
         	echo "<a href=\"spqname.php?action=browse&id=$wibbler&offset=$offset\">".misc_listview."</a>&nbsp;\n";
            if($_SESSION['vxmisuser']->GetPerm('edit')){
   		      echo "<a href=\"spqname.php?action=edit&id=$wibbler&offset=$offset\">".misc_listedit."</a>&nbsp; \n";
            }
            if($_SESSION['vxmisuser']->GetPerm('delete')){
		         echo "<a href=\"spqname.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
            }
         }
      }
      else{
         if($_SESSION['vxmisuser']->GetShowImages()){
            echo "<a href=\"spqname.php?action=bbrowse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
            if($_SESSION['vxmisuser']->GetPerm('edit')){
		         echo "<a href=\"spqname.php?action=bedit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
            }
            if($_SESSION['vxmisuser']->GetPerm('delete')){
		         echo "<a href=\"spqname.php?action=bdelete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
            }
         }
         else{
         	echo "<a href=\"spqname.php?action=bbrowse&id=$wibbler&offset=$offset\">".misc_listview."</a>&nbsp;\n";
            if($_SESSION['vxmisuser']->GetPerm('edit')){
   		      echo "<a href=\"spqname.php?action=bedit&id=$wibbler&offset=$offset\">".misc_listedit."</a>&nbsp; \n";
            }
            if($_SESSION['vxmisuser']->GetPerm('delete')){
		         echo "<a href=\"spqname.php?action=bdelete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
            }
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
