<?php
/*
stats.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/phplot/phplot.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}

if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(-1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if($_SESSION['vxmisuser']->GetFocusType()!=FOCUSIDTYPE_PRODUCT){
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("Select a product.")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Product Statistics"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Product Statistics");
}

$NoNavigationFlag=true;
include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "list":
	default :
      Details();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function Details()
{
   $productid=$_SESSION['vxmisuser']->GetFocusID();
   
   // for year
   $frm["numsold"]="0";
   $frm["numreturned"]="0";
   $frm["numordered"]="0";
   $frm["amount"]="0";
   $frm["margin"]="0";
   // current
   $frm["numinstock"]="0";
   $frm["numreserved"]="0";
   $frm["turnaround"]="0";
   $frm["rankinstock"]="0";
   $frm["rankincat"]="0";
   $frm["margin"]="0";
   $frm["trend"]="0";
   
   $result=$_SESSION['VxCFG']->dbh->Execute(product_stats_qry1);
   $row = $result->FetchRow();
   $start=$row[0]."-01-01";
   
   $result=$_SESSION['VxCFG']->dbh->Execute(product_stats_qry2);
   $row = $result->FetchRow();
   $now=$row[0];
   
   $qry=sprintf(product_stats_qry3, $productid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result){
	   if($row = $result->FetchRow()){
         $plu=$row[0];
      }
      else{
         return;
      }
   }
   else{
      return;
   }
   
   // numsold
   $qry=sprintf(product_stats_qry4, $start, $now, $plu);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result){
	   if($row = $result->FetchRow()){
         $frm["numsold"]=$row[0];
      }
   }
   // num returned
   $qry=sprintf(product_stats_qry5, $start, $now, $plu);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result){
	   if($row = $result->FetchRow()){
         $frm["amount"]=$row[0];
      }
   }
   // amount
   $qry=sprintf(product_stats_qry6, $start, $now, $plu);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result){
	   if($row = $result->FetchRow()){
         $frm["numreturned"]=$row[0];
      }
   }
   
   
   
   
   
   
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry20);
   if($result){
	   if($row = $result->FetchRow()){
         $frm["pnumapporders"]=$row[0];
      }
   }
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry21);
   if($result){
	  if($row = $result->FetchRow()){
        $frm["pnumsporders"]=$row[0];
     }
   }
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry22);
   if($result){
	   if($row = $result->FetchRow()){
         $frm["pnumpackorders"]=$row[0];
      }
   }

   

   $qry=sprintf(order_stats_qry3, $_SESSION['vxmisuser']->GetEmployee());
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result){
	   if($row = $result->FetchRow()){
         $s=$row["stamper"];
         $qry=sprintf(order_stats_qry2, $s);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result){
	         if($row = $result->FetchRow()){
               $frm["numneworders"]=$row[0];
            }
         }
         $qry=sprintf(order_stats_qry3, $s);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result){
	         if($row = $result->FetchRow()){
               $frm["numapporders"]=$row[0];
            }
         }
         $qry=sprintf(order_stats_qry4, $s);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result){
	         if($row = $result->FetchRow()){
               $frm["numsporders"]=$row[0];
            }
         }
         $qry=sprintf(order_stats_qry5, $s);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result){
	         if($row = $result->FetchRow()){
               $frm["numpackorders"]=$row[0];
            }
         }
         $qry=sprintf(order_stats_qry6, $s);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($result){
	         if($row = $result->FetchRow()){
               $frm["numdisorders"]=$row[0];
            }
         }
      }
   }
   
   
   
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry10);
   if($result){
	   if($row = $result->FetchRow()){
         $frm["avgorderturnaround"]=$row[0];
         $frm["maxorderturnaround"]=$row[1];
         $frm["minorderturnaround"]=$row[2];
      }
   }
   
   $frm["newaction"] = "none";
   
   include("templates/stats.php");
}

function Derivative($sx=0, $ex, $sy, $ey)
{
   return ($ex-$sx)/($ey-$sy);
}

function VolumeByMonth()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry17);
   $row = $result->FetchRow();
   $d=$row[0]."-01-01";
   $result=$_SESSION['VxCFG']->dbh->Execute(order_stats_qry16);
   $row = $result->FetchRow();
   $m=$row[0]+1;

   $xpos=1;
   for($month=1; $month!=$m; $month++){
      $qry=sprintf(order_stats_qry14, $month);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      $label=strftime('%b',mktime(0,0,0,$month,1,0));
      $counts[] = @ array($label,$row[0]);
      $amount[] = @ array($label,$row[1]);
      $xpos++;
   }
   

   $cscale = array_search(max($counts),$counts); //Find the position of maximum value.
   $ascale = array_search(max($amount),$amount);
   
   $graphc = & new PHPlot(400,380, "volbymonth.png");
   $graphc->SetDataType("text-data");
   $graphc->SetTitle("Volume");
   $graphc->SetDataValues($counts);
   $graphc->SetPlotType('bars');
   $graphc->SetFileFormat('png');
   $graphc->SetXGridLabelType('title');
   $graphc->SetXScaleType('linear');
   $graphc->SetXTitle('Month');
   $graphc->SetYTitle('Volume');
   //$graphc->SetDataColors('orange');
   
   $grapha = new PHPlot(400,380,"amtbymonth.png");
   $grapha->SetDataType("text-data");
   $grapha->SetDataValues($amount);
   $grapha->SetTitle("Revenue");
   $grapha->SetPlotType('bars');
   $grapha->SetFileFormat('png');
   $grapha->SetXGridLabelType('title');
   $grapha->SetXScaleType('linear');
   $grapha->SetXTitle('Month');
   $grapha->SetYTitle('Amount');
   
   /*
   // twin x/y with 2nd deriv
   $grapht = new PHPlot(400,380,"trendbymonth.png");
   $grapht->SetDataType("text-data");
   $grapht->SetDataValues($amount);
   $grapht->SetTitle("Revenue");
   $grapht->SetPlotType('bars');
   $grapht->SetFileFormat('png');
   $grapht->SetXGridLabelType('title');
   $grapht->SetXScaleType('linear');
   $grapht->SetXTitle('Month');
   $grapht->SetYTitle('Amount');
   */
   $graphc->SetIsInline(true);
   $grapha->SetIsInline(true);
   $graphc->DrawGraph();
   $grapha->DrawGraph();
   echo "<img src=\"volbymonth.png\">\n";
   echo "<img src=\"amtbymonth.png\">\n";
}

?>
