<?php
/*
areas.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Sales Areas"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Sales Areas");
}

if($_SESSION["pageindex"]->CheckNum(salesm_areas_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addItem();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         $id=$_SESSION["pageindex"]->browse($_REQUEST['id']);
         browseItem($id);
         break;
      }
		$id=updateNav($_POST);
		browseItem($id);
		break;

	case "edit" :
		editItem($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelItem($_REQUEST['id']);
      }
      else{
         deleteItem($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listItem();
      }
      break;  
	
   case "cfmdelete" :
      deleteItem($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listItem();
		break;

	case "add" :
		insertItem($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listItem();
		break;

	case "commit" :
		commitItem($_POST);
      listItem();
		break;

	case "list":
	default :
		$id=updateNav($_POST);
		listItem();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(salesm_areas_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
   $frm["code"] = "";
	$frm["name"] = "";

	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(salesm_areas_qry2, $id);
   }
   else{
      $qry=sprintf(salesm_areas_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
   $frm["code"] = $row["code"];
	$frm["name"] = $row["name"];

	return $frm;
}

function addItem()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	
	include("templates/areas.php");
}

function editItem($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/areas.php");
}

function browseItem($id) 
{
	$frm=fillForm($id, true);

	$frm["newaction"] = "browse";
	
	include("templates/areas.php");
}

function insertItem($frm) 
{
   $qry=sprintf(salesm_areas_qry4, $frm['code'],$frm['name']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitItem($frm) 
{
   $qry=sprintf(salesm_areas_qry5, $frm['code'],$frm['name'], $frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function chkdelItem($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/types.php");
}

function deleteItem($id) 
{
   $qry=sprintf(salesm_areas_qry6, $id);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function listItem()
{  
	$sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(salesm_areas_qry7, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<table class=\"listtable\">\n";
   if(db_num_rows($result)==0){
      echo "<tr><td colspan=\"2\">"._("The are no sales areas defined.")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='code'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Code")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Code")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=code\">"._("Code")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
	echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }

	echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
	
   while($row = $result->FetchRow()){
		echo "<tr><td class=\"listdata\">".$row['code']."</td>\n<td class=\"listdata\">".$row['name']."</td>\n";

		echo "<td class=\"listdata\">";
		$wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"areas.php?action=browse&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"areas.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"areas.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"areas.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"area.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"area.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
	}
	echo "</table>";
}

?>
