<?php
/*
stock.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
require_once("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/timedate.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(2);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Stock"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Stock");
}

if(!isset($start_time)){
   $start_ts=& new TimeDate();
   $start_ts->midnight();
   $start_time=$start_ts->ansidate();
}

if(!isset($end_time)){
   $end_ts=& new TimeDate();
   $end_ts->last_second();
   $end_time=$end_ts->ansidate();
}

include($_SESSION['VxCFG']->styledir."/header.php");
include("templates/stock.php");
include($_SESSION['VxCFG']->styledir."/footer.php");
   
function ReconcileStock()
{
   global $start_time;
   global $end_time;
   
   $qry=sprintf(sod_qry24, $start_time, $end_time);
	$result=db_query($qry);
   
   while($row = $result->FetchRow()){
      echo "<tr><td>$row[0]</td>\n";
      $qry=sprintf(sod_qry25, $row[0]);
	   $presult=db_query($qry);
      if($prow = $presult->FetchRow()){
         $qry=sprintf(s_qryd26, $prow[0]);
	      $iresult=db_query($qry);
         if($irow = $iresult->FetchRow()){
            echo "<td align=\"right\">$irow[1]</td>\n";
            echo "<td align=\"right\">$row[1]</td>\n";
            $nq=$irow["instock"] - $row[1];
         
            if($nq < $irow["rolevel"])
               echo "<td align=\"right\"><font color=\"FF0000\">$nq</font></td>";
            else 
               echo "<td align=\"right\">$nq</td>";
         }
         else{
            echo "<td>&nbsp;</td>";
         }
         echo "<td align=\"right\">$irow[2]</td>\n";
         echo "<td align=\"right\">$irow[3]</td>\n";
      }
      echo "</tr>";
      /*
      $presult=db_query("UPDATE InStock from inventory set InStock='(InStock-$row[qty])' WHERE
          inventory.id='product.invID' AND
          product.PLU='$row[PLU]'");
      }*/
   }
}

?>
