<?php
/*
stationorg.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/tree.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
$_REQUEST['action']='none';
$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){   // session timeout...
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(6);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}
if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Station Organization"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Station Organization");
}
$NoNavigationFlag=true;
include($_SESSION['VxCFG']->styledir."/headertree.php");
HtmlBuildTree();
include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function HtmlBuildTree()
{
   echo "<table>\n<tr>\n<td>&nbsp;</td></tr>";
   $closed="tree_folderclosed.png";
   $open="tree_folderopen.png";
   $station_icon="tree_icon_station.png";
   
   $tree = new HTML_TreeMenu();
   //$result=$_SESSION['VxCFG']->dbh->Execute(station_org_qry1);
   //if($row = $result->FetchRow()){
      //$node = new HTML_TreeNode(array('text'=>$row[0],'icon'=>$closed,'expandedIcon'=>$open));
   //}
   //else{
      $node = new HTML_TreeNode(array('text'=>"Organization",'icon'=>$closed,'expandedIcon'=>$open));
   //}
   $sites=&$node->addItem(new HTML_TreeNode(array('text'=>"Sites",'icon'=>$closed,'expandedIcon'=>$open)));
   
	$sresult=$_SESSION['VxCFG']->dbh->Execute(station_org_qry2);
	while($srow = $sresult->FetchRow()){
      $sn=&$sites->addItem(new HTML_TreeNode(array('cssClass'=>"treelink",'text'=>$srow['name'], 'link'=>"site.php?action=browse&id=".$srow['id'],
      'icon'=>$closed,'expandedIcon'=>$open)));
      
      $depts=&$sn->addItem(new HTML_TreeNode(array('text'=>"Departments",'icon'=>$closed,'expandedIcon'=>$open)));
      $dqry=sprintf(station_org_qry3, $srow['id']);
      $dresult=db_query($dqry);
      while($drow = $dresult->FetchRow()){
         $gn=&$depts->addItem(new HTML_TreeNode(array('text'=>$drow['name'], 'link'=>"dept.php?action=browse&id=".$drow['id'],
         'icon'=>$closed,'expandedIcon'=>$open)));
         
         $groups=&$gn->addItem(new HTML_TreeNode(array('text'=>"Groups",'icon'=>$closed,'expandedIcon'=>$open)));
         
         $gqry=sprintf(station_org_qry4, $drow['id']);
         $gresult=db_query($gqry);
         while($grow = $gresult->FetchRow()){
            $stn=&$groups->addItem(new HTML_TreeNode(array('text'=>$grow['name'], 'link'=>"group.php?action=browse&id=".$grow['id'],
            'icon'=>$closed,'expandedIcon'=>$open)));
         
            $stations=&$stn->addItem(new HTML_TreeNode(array('text'=>"Stations",'icon'=>$closed,'expandedIcon'=>$open)));
            
            $stqry=sprintf(station_org_qry5, $grow['id']);
            $stresult=db_query($stqry);
            while($strow = $stresult->FetchRow()){
               $stations->addItem(new HTML_TreeNode(array('text'=>$strow['name'], 'link'=>"station.php?action=browse&id=".$strow['id'],
               'icon'=>$station_icon)));
            }
         }
      }
   }
   $tree->addItem($node);
   $treedisp = new HTML_TreeMenu_DHTML($tree, array('images'=>$_SESSION['VxCFG']->styleimagedir));
   
   echo "<tr><td class=\"formdata\">";
   $treedisp->printMenu();
   echo "</td>\n</tr>\n</table>\n";
}

?>
