<?php
require_once("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/pdflib.php");

include("header.php");

$pdf = new PdfForm('P','mm','A4');
$pdf->Open();
$pdf->AddPage();
$pdf->SetFont('Arial','B',16);

$pdf->addCompany($companyname, $companyaddress, $logo);
$pdf->addDeliveryAddress($customername, $customeraddress);
$pdf->addPageNumber(1, 1);
$pdf->addClient("606431");
$pdf->OrderNumber("Order Number",500012);
$pdf->addDate("06-3-2005");
$pdf->EAN13($orderid);

$cols=array( "Item"   => 14,
             "Description" => 70,
             "Qty"         => 14,
             "Price"       => 23,
             "SubTotal"    => 23,
             "Tax"         => 23,
             "Total"       => 23);
$pdf->SetFont('Arial','B',12);
$pdf->addCols($cols);
$cols=array( "Item"   => "L",
             "Description" => "L",
             "Qty"         => "C",
             "Price"       => "R",
             "SubTotal"    => "R",
             "Tax"         => "R",
             "Total"       => "R" );
$pdf->addLineFormat($cols);
$y = 109;
$pdf->SetFont('Arial','',12);
foreach($lineitems as $item){
   //print_r($item);
   $size = $pdf->addLine($y, $item);
   $y+=$size + 2;
}
$pdf->SetFont('Arial','B',12);
$pdf->addTotals($y, $totals);

$footer="VxGroup, 21 Punch Lane, Melbourne, VIC, 3000\n ABN: ".$regnumber;
if($taxnumber!="") $footer.=" GST Registered: ".$taxnumber;

include("footer.php");

//$pdf->Watermark("Test Invoice");
$pdf->Output("invoice.pdf", "F");

?>
