<?php
/*
supplier.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/contact.php");
require_once($_SESSION['VxCFG']->libdir."/chargeaccount.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}
$_SESSION["vxmisuser"]->ClearFocus();
if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Supplier Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Supplier Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(supplierm_supplier_qry1, "supplier")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addSupplier();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseSupplier($_REQUEST['id']);
         break;
      }
		browseSupplier($_POST['id']);
		break;

	case "edit" :
		editSupplier($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelSupplier($_REQUEST['id']);
      }
      else{
         deleteSupplier($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listSupplier();
      }
      break;  
	
   case "cfmdelete" :
      deleteSupplier($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listSupplier();
		break;

	case "add" :
		insertSupplier($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listSupplier();
		break;

	case "commit" :
		commitSupplier($_POST);
      listSupplier();
		break;

   case "search" :
      searchSupplier();
      break;
      
   case "searchresults" :
		searchResults($_POST);
		break;
      
	case "list":
	default :
      if(isset($_REQUEST['cletter'])) $cl=$_REQUEST['cletter'];
      else $cl='All';
		listSupplier($cl);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(supplierm_supplier_qry1);
   if($result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = "";
   $frm["supplierid"] = "";
   $frm["intsupplierid"] = "";
   $frm["cmid"] = "";
   $frm["name"] = "";
   $frm["addressid"] = "";
   $frm["invoicename"] = "";
   $frm["invoicecontactid"] = "";
   $frm["contactid"] = "";
   $frm["chid"] = "";
   $frm["ediid"] = "";
   $frm["linkid"] = "";
   $frm["active"] = "";
   $frm["memoid"] = "";
   
   $frm["cacmid"] = "";
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(supplierm_supplier_qry2, $id);
   }
   else{
      $qry=sprintf(supplierm_supplier_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

   $frm["id"] = $id;
   $frm["supplierid"] = $row["supplierid"];
   $frm["intsupplierid"] = $row["intsupplierid"];
   $frm["cmid"] = $row["cmid"];
   $frm["name"] = $row["name"];
   $frm["addressid"] = $row["addressid"];
   $frm["contactid"] = $row["contactid"];
   $frm["invoicename"] = $row["invoicename"];
   $frm["invoicecontactid"] = $row["invoicecontactid"];
   $frm["chid"] = $row["chargeid"];
   $frm["ediid"] = $row["ediid"];
   $frm["linkid"] = $row["linkid"];
   $frm["active"] = $row["active"];
   $frm["memoid"] = $row["memoid"];
   
	return $frm;
}

function addSupplier()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	$frm["id"] = "";

	include("templates/supplier.php");
}

function editSupplier($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/supplier.php");
}

function browseSupplier($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/supplier.php");
}

function chkdelSupplier($id)
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";

	include("templates/supplier.php");
}

function deleteSupplier($id)
{
   $qry=sprintf(supplierm_supplier_qry6, $id);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function insertSupplier($frm) 
{
	$a=new Address();
   $a->SetFromForm($frm);
	if(!$a->Find(false)){
      $adid=$a->Add();
   }
   else{
      $adid=$a->GetID();
   }
   
   $cm=new CreateMod();
   $cm->Fill(0);
   $cmid=$cm->Commit();
   // add a charge account
   /*
   $frm["standardterms"] = yesno(isset($frm["standardterms"]));
	$frm["codterms"] = yesno(isset($frm["codterms"]));
	$frm["prepaidterms"] = yesno(isset($frm["prepaidterms"]));
	$frm["termstype"] = yesno(isset($frm["termstype"]));
	$frm["duemonthend"] = yesno(isset($frm["duemonthend"]));
	*/
   $ca=new ChargeAccount();
   $ca->SetFromForm($frm);
   $chid=$ca->Add();
   
   $qry=sprintf(supplierm_supplier_qry4,$frm['intsupplierid'],$cmid,$frm['name'],$adid, $frm['contactid'],
      $frm['invoicename'],$frm['invoicecontactid'],$chid,$frm['ediid'],$frm['linkid'],
      YN($frm['active']),$frm['memoid']);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   
   // update the supplier
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $qry=sprintf(supplierm_supplier_qry16,$row[0],$row[0]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   
   // add a contact
   
   /*
	// Step 2. Update Contact Info
	$frm["ContactDetailsID"]=insertContactDetails($frm);
	$cid=insertContact($frm);
   */
}

function commitSupplier($frm) 
{
	$a=new Address();
   $a->SetFromForm($frm);
	if(!$a->Find(false)){
      $adid=$a->Add();
   }
   else{
      $a->Commit($frm['addressid']);
      $adid=$a->GetID();
   }

	// Step 2. Update Contact Info
	//$frm["contactdetailsid"]=insertContactDetails($frm);
	//$cid=insertContact($frm);

	// Step 3. Update ChargeID (Or not)
   $ca=new ChargeAccount();
   $ca->SetFromForm($frm);
   $ca->SetID($frm['chid']);
   $ca->Commit();
   
   $cm=new CreateMod();
   $cm->Fill($frm['cmid']);
   $cm->Commit();
 
	// Step 4. Update Supplier
	$active = yesno(isset($frm["active"]));
   $qry=sprintf(supplierm_supplier_qry5,$frm['supplierid'],$frm['intsupplierid'],$frm['cmid'],$frm['name'],$frm['addressid'], $frm['contactid'],
      $frm['invoicename'],$frm['invoicecontactid'],$frm['chargeid'],$frm['ediid'],$frm['linkid'],
      YN($frm['active']),$frm['memoid'],$frm['id']);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
}

function searchSupplier()
{
   $frm["newaction"] = "searchresults";
   $frm["id"]=0;
   $frm["name"]="";
   $frm['errmsg']="";
	include("templates/suppliersearch.php");
}

function searchResults($frm)
{
   if(isset($_POST['name'])){
      $qry=sprintf(supplierm_supplier_qry18,$_POST['name']);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      
      if(!$result){
         $frm['errmsg']=_("Bad Query");
         $frm["newaction"] = "searchresults";
         $frm["id"]=0;
         $frm["name"]="";
         include("templates/suppliersearch.php");
         return;
      }
      if($result->RecordCount()==0){
         $frm['errmsg']=_("No Records found for name: ").$_POST['name'];
         $frm["action"] = "search";
         $frm["newaction"] = "search";
         $frm["id"]=0;
         $frm["name"]="";
         include("templates/suppliersearch.php");
         return;
      }
	   if(!($row = $result->FetchRow())){
         $frm['errmsg']=_("Bad Query");
         $frm["newaction"] = "searchresults";
         $frm["id"]=0;
         $frm["name"]="";
         include("templates/suppliersearch.php");
         return;
      }
      else{
         $frm=fillForm($row['id'], false);
         $frm['newaction']="browse";
         include("templates/supplier.php");
         return;
      }
   }
   else{
      $frm['errmsg']=_("Fill in something");
      include("templates/suppliersearch.php");
   }
}

function CMTable($a, $id)
{
   $cm=new CreateMod();
   $cm->Fill($id);
   $cm->FillTable();
}

function ContactList()
{
   /*
   $cdi=new ContactDetails($id);
   $cdi->buildItemList($a, "supplier.php", "Contact Details");
	}
   */
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "address");
}

function ChargeTable($a, $id)
{
   $c=new ChargeAccount();
   $c->Table($a, $id, "charge");
}

function listSupplier($lc='All')
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   if($lc!='All'){
      $qry=sprintf(supplierm_supplier_qry17, $lc.'%', $sorton, $sortorder);
   }
   else{
      $qry=sprintf(supplierm_supplier_qry15, $sorton, $sortorder);
   }
   
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<form action=\"".$_SERVER['PHP_SELF']."\" method=\"POST\">\n";
   echo "<input type=\"hidden\" name=\"cletter\" value=\"$lc\">\n";
   echo "<table class=\"listtable\">\n";
   echo "<tr><td class=\"listtitle\" colspan=\"4\">&nbsp;&nbsp;";
   ContactAlphabet($lc);
   echo "</td></tr>";

   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no suppliers defined")."</td></td></table>\n";
      exit;
   }
   
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no suppliers defined")."</td></td></table>\n";
      exit;
   }

   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";

   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
		$n=$row["name"];
      if($n=="") $n="&nbsp;";
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">".$row["name"]."</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row["name"]."</td><td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"supplier.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"supplier.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"supplier.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"supplier.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"supplier.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"supplier.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
