<?php
/*
printer.php

Copyright (C)2003 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], system_prn_pagetitle)!=0){
   $_SESSION['title']=system_prn_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(printer_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "clear" :
		addPrinter();
      $_SESSION["pageindex"]->setnum(CountNum());
		break;

	case "browse":
      $id=updateNav($_POST);
		browsePrinter($id);
		break;

	case "edit" :
		editPrinter($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelPrinter($_REQUEST['id']);
      }
      else{
         deletePrinter($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listPrinter($_REQUEST['id']);
      }
      break;  
	
   case "cfmdelete" :
      deletePrinter($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listPrinter($_POST['ID']);
		break;
      
	case "delete" :
		chkdelPrinter($id);
		break;

	case "add" :
		insertPrinter($_POST);
      listPrinter();
		break;

	case "commit" :
		commitPrinter($_POST);
      listPrinter();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listPrinter();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(printer_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = 0;
   $frm["name"] = "";
   $frm["description"] = "";
   $frm["address"] = "";
   $frm["port"] = "";
   $frm["active"] = "Y";

   return $frm;
}

function fillForm($id, $bOffset)
{
	if($bOffset){
      $qry=sprintf(printer_qry2, $id);
   }
   else{
      $qry=sprintf(printer_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["id"] = $id;
   $frm["name"] = $row["name"];
   $frm["description"] = $row["description"];
   $frm["address"] = $row["address"];
   $frm["port"] =$row["port"];
   $frm["active"] =$row["active"];
   
	return $frm;
}

function addPrinter()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	$frm["id"] = "";
   $frm["heading"] = "Printer Add";

	include("templates/printeredit.php");
}

function editPrinter($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Printer Edit";

	include("templates/printeredit.php");
}

function browsePrinter($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Printer Browse";
	
	include("templates/printeredit.php");
}

function chkdelPrinter($id)
{
   $frm=fillForm($id,false);
   $frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Confirm Printer Delete";
	include("templates/printeredit.php");
}

function deletePrinter($id) 
{
   $qry=sprintf(printer_qry7, $id);
	db_query($qry);
}

function insertPrinter($frm) 
{
   $qry=sprintf(printer_qry5, $frm['name'],$frm['description'],$frm['address'],$frm['port'],YN($frm['active']));
   db_query($qry);
}

function commitPrinter($frm) 
{
   $qry=sprintf(printer_qry6,$frm['name'],$frm['description'],$frm['address'],$frm['port'],YN($frm['active']),$frm['id']);
	db_query($qry);
}

function fillPrinterCombo($a, $cname, $id)
{
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
      $result=db_query(printer_qry8);
      if(db_num_rows($result) == 0){
         echo "&nbsp;";
         return;
      }
      if(db_num_rows($result) == 1 && $a=="cfmdelete"){
         echo "The are no other printers defined";
         return;
      }
	   echo "<select name=\"$cname\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
         $boo=$row["id"];
   		$poo=$row["name"];
         if($a=="cfmdelete" && $id!=$boo){
	   	   if($id==$boo){
		   	   print "<option selected value=\"$boo\"> $poo </option>\n";
   		   }
	   	   else{
		      	print "<option value=\"$boo\"> $poo </option>\n";
		      }
         }
	   }
	   echo "</select>\n";
   }
   else{
      $qry=sprintf(printer_qry8, $id);
      $result=db_query($qry);
      if(db_num_rows($result) == 0){
        echo "&nbsp;";
         return;
      }
      if($row = $result->FetchRow()){
         echo $row[0];
      }
   }
}

function listPrinter()
{
   $q=$_SESSION["pageindex"]->query(printer_qry4);
	$result=db_query($q);

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Active</h3><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$n=$myrow["name"];
		$a=$myrow["active"];
		print "<tr><td>$n</td><td>$a</td>";
		print "<td>";
		$wibbler=$myrow["id"];
		print "<a href=\"printer.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"printer.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"printer.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
