<?php
/*
printform.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], system_prnform_pagetitle)!=0){
   $_SESSION['title']=system_prnform_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(printform_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "clear" :
		addPrintForm();
      $_SESSION["pageindex"]->setnum(CountNum());
		break;

	case "browse":
      $id=updateNav($_POST);
		browsePrintForm($id);
		break;

	case "edit" :
		editPrintForm($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelPrintForm($_REQUEST['id']);
      }
      else{
         deletePrintForm($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listPrintForm($_REQUEST['id']);
      }
      break;  
	
   case "cfmdelete" :
      deletePrintForm($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listPrintForm($_POST['ID']);
		break;
      
	case "delete" :
		chkdelPrintForm($id);
		break;

	case "add" :
		insertPrintForm($_POST);
      listPrintForm();
		break;

	case "commit" :
		commitPrintForm($_POST);
      listPrintForm();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listPrintForm();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(printform_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = 0;
   $frm["name"] = "";
   $frm["description"] = "";
   $frm["printerID"] = 0;
   $frm["sheetid"] = 0;
   $frm["orientation"] = "";
   $frm["printitemid"] = 0;
   
   return $frm;
}

function fillForm($id, $bOffset)
{
	if($bOffset){
      $qry=sprintf(printform_qry2, $id);
   }
   else{
      $qry=sprintf(printform_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["id"] = $id;
   $frm["name"] = $row["name"];
   $frm["description"] = $row["description"];
   $frm["printerid"] = $row["printerid"];
   $frm["sheetID"] = $row["sheetID"];
   $frm["orientation"] = $row["orientation"];
   $frm["printitemid"] = $row["printeritemid"];
   
	return $frm;
}

function addPrintForm()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	$frm["id"] = "";
   $frm["heading"] = "Print Form Add";

	include("templates/printformedit.php");
}

function editPrintForm($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Print Form Edit";

	include("templates/printformedit.php");
}

function browsePrintForm($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Print Form Browse";
	
	include("templates/printformedit.php");
}

function chkdelPrintForm($id)
{
   $frm=fillForm($id,false);
   $frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Confirm Print Form Delete";
	include("templates/printformedit.php");
}

function deletePrintForm($id) 
{
   $qry=sprintf(printform_qry7, $id);
	db_query($qry);
}

function insertPrintForm($frm) 
{
   $qry=sprintf(printform_qry5, $frm['name'], $frm['xsize'],$frm['ysize'],$frm['left_margin'],
      $frm['right_margin'],$frm['top_margin'],$frm['bottom_margin']);
   db_query($qry);
}

function commitPrintForm($frm) 
{
   $qry=sprintf(printform_qry6,$frm['name'], $frm['xsize'],$frm['ysize'],$frm['left_margin'],
      $frm['right_margin'],$frm['top_margin'],$frm['bottom_margin'],$frm['id']);
	db_query($qry);
}

function PrinterCombo($a, $id)
{
}

function PrintSheetCombo($a, $id)
{
}

function PrintItemTree($a, $id)
{
}

function OrientationCombo($a, $id)
{
}

function Layout()
{
}

function listPrintForm()
{
   $q=$_SESSION["pageindex"]->query(printform_qry4);
	$result=db_query($q);

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Size</h3><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$n=$myrow["name"];
		$a=$myrow["xsize"]." x ".$myrow["ysize"];
		print "<tr><td>$n</td><td>$a</td>";
		print "<td>";
		$wibbler=$myrow["id"];
		print "<a href=\"printform.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		print "<a href=\"printform.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		print "<a href=\"printform.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
