<?php
/*
returns.php

Copyright (C)2003  Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

include("../vxmis.php");
if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()=='' || $_SESSION['vxmisuser']->GetSortOn()!='transid'){
   $_SESSION['vxmisuser']->SetSortOn('transid');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Returns"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Returns");
}

if($_SESSION["pageindex"]->CheckNum(transaction_return_qry1, "return")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear":
		addReturn();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseReturn($_REQUEST['id']);
         break;
      }
		browseReturn($_POST['id']);
		break;

	case "edit" :
		editReturn($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelReturn($_REQUEST['id']);
      }
      else{
         deleteReturn($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listReturn();
      }
      break;  
	
   case "cfmdelete" :
      deleteReturn($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listReturn();
		break;
      

	case "add" :
		insertReturn($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitReturn($_POST);
      listReturn();
		break;

	case "list":
	default :
		listReturn();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(transaction_return_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"] = "0";
   $frm["transid"] = "";
   $frm["destination"] = "stock";
   $frm["todestat"] = "";
   $frm["todestby"] = "";
   $frm["reasonid"]="";
   
   $frm["reasonname"]="";
   $frm["numitems"]=0;
   return $frm;
}

function fillform($id, $bOffset)
{
   
   if($bOffset){
      $qry=sprintf(transaction_return_qry2, $id);
   }
   else{
      $qry=sprintf(transaction_return_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   if($result->RecordCount()==0){
      echo "No Outstanding Returns Stock in Holding\n";
      exit;
   }
   
   $frm["id"] = $id;
   $frm["transid"] = $row["transid"];
   $frm["destination"] = $row["destination"];
   $frm["todestat"] = $row["todestat"];
   $frm["todestby"] = $row["todestby"];
   $frm["reasonid"] = $row["reasonid"];
   
   $result=db_query("select name from returntype where id = '$frm[reasonid]'");
   $row = $result->FetchRow();
   $frm["reasonname"] = $row["reasonname"];
   
   $result=db_query("select count(*) from transactionitems where id = '$frm[transid]'");
   $row = $result->FetchRow();
   $frm["numitems"] = $row[0];
   
   return $frm;
}

function addReturn()
{
   $frm=clearform();
	$frm["newaction"] = "add";

	include("templates/returns.php");
}

function editReturn($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";
	include("templates/returns.php");
}

function browseReturn($id) 
{
   $frm=fillform($id, true);
   $frm["newaction"] = "browse";
	include("templates/returns.php");
}

function chkdelReturn($id)
{
   $frm=fillform($id, false);
	$frm["newaction"] = "cfmdelete";
	include("templates/returns.php");
}

function deleteReturn($id) 
{
   $qry=sprintf(transaction_return_qry6, $id);
   $_SESSION['VxCFG']->dbh->Execute($qry); 
}

function insertReturn($frm) 
{
   $qry=sprintf(transaction_return_qry4,$frm['promotionid'],$frm['type'],$frm['startdate'],$frm['enddate'],$frm['margin'],
   $frm['memo'],$frm['promolinkid']);
   
	$_SESSION['VxCFG']->dbh->Execute($qry); 
}

function commitReturn($frm) 
{
   $qry=sprintf(transaction_return_qry5,$frm['promotionid'],$frm['type'],$frm['startdate'],$frm['enddate'],$frm['margin'],
   $frm['memo'],$frm['promolinkid'],$frm['id']);
   
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function fillReturnsDestCombo($a, $id)
{
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
      echo "<select name=\"destination\">\n";
      if($id=="stock"){
         echo "<option selected value=\"1\"> Stock </option>\n";
      }
      else{
         echo "<option value=\"1\"> Stock </option>\n";
      }
      if($id=="vendor"){
         echo "<option selected value=\"2\"> Vendor </option>\n";
      }
      else{
         echo "<option value=\"2\"> Vendor </option>\n";
      }
      if($id=="stock"){
         echo "<option selected value=\"3\"> Scrap </option>\n";
      }
      else{
         echo "<option value=\"3\"> Scrap </option>\n";
      }
   }
   else{
      echo $id;
   }
}

function fillReturnsTypeCombo($a, $id)
{
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
      $result=$_SESSION['VxCFG']->dbh->Execute(transaction_returntype_qry8);
      if($result->RecordCount()==0){
         echo "&nbsp;";
         return;
      }
	   echo "<select name=\"returnreasonid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         if($id==$boo){
	   	  	print "<option selected value=\"$boo\"> $poo </option>\n";
   	   }
	   	else{
		      print "<option value=\"$boo\"> $poo </option>\n";
   		}
	   }
	   echo "</select>\n";
   }
   else{
      $qry=sprintf(transaction_returntype_qry9, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($result->RecordCount()==0){
        echo "&nbsp;";
         return;
      }
      if($row = $result->FetchRow()){
         echo $row[0];
      }
   }
}

function listReturn()
{
	$sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(transaction_return_qry9, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no outstanding returns")."</td></td></table>\n";
      return;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='transid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Trans ID")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Trans ID")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=transid\">"._("Trans ID")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='transid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='destination'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Destination")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Destination")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=destination\">"._("Destination")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='destination'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='reasonid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Reason")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Reason")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=reasonid\">"._("Reason")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='reasonid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   while($row = $result->FetchRow()){
      if($row["transid"]){
			$wibbler=$row["id"];
			$n=$row["destination"];
         
         $qry=sprintf(transaction_returntype_qry9, $row['reasonid']);
         $res=$_SESSION["pageindex"]->query($qry);
	      $trow = $res->FetchRow();
         if($trow){
            $r=$trow[0];
         }
         else{
            $r="not set";
         }
         if($c%2){
            echo "<tr class=\"listdata\"><td class=\"listdata\">";
			   echo "$row[transid]</td><td class=\"listdata\">$n</td><td>$r</td><td class=\"listdata\">";
         }
         else{
            echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">";
			   echo "$row[transid]</td><td class=\"listdataeven\">$n</td><td>$r</td><td class=\"listdataeven\">";
         }
      }
		$wibbler=$row['id'];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"returns.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"returns.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"returns.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"returns.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"returns.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"returns.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      $c++;
      $offset++;
		echo "</td></tr>\n";
	}
	echo "</table>";
}

?>
