<?php
/*
uplu.php

Copyright (C)2005  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(2);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()=='' || $_SESSION['vxmisuser']->GetSortOn()!='plu'){
   $_SESSION['vxmisuser']->SetSortOn('plu');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){   // session timeout...
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Unknown PLUs"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Unknown PLUs");
}

if($_SESSION["pageindex"]->CheckNum(transaction_uplu_qry1, "uplu")){
   $_SESSION["pageindex"]->setnum(CountNum());
}


if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
   case "clear":
		addUplu();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseUplu($_REQUEST['id']);
         break;
      }
		browseUplu($_POST['id']);
		break;

	case "edit" :
		editUplu($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelUplu($_REQUEST['id']);
      }
      else{
         deleteUplu($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listUplu();
      }
      break;  
	
   case "cfmdelete" :
      deleteUplu($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listUplu();
		break;
      
	case "add" :
		insertUplu($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitUplu($_POST);
      listUplu();
		break;
      
	case "list":
	default :
		listUplu();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(transaction_uplu_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function fillForm($id)
{
   $qry=sprintf(uplu_qry3, $id);
   
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   $frm["id"] = $id;
   $frm["entryat"] = $row["entryat"];
   $frm["plu"] = $row["plu"];
   $frm["plutype"] = $row["plutype"];
   $frm["name"] = $row["name"];
   $frm["unitprice"] = $row["unitprice"];
   $frm["discount"] = $row["discount"];
   $frm["tax"] = $row["tax"];
   
   // additional for plu cache
   $frm["rectext"] = "";
   $frm["disptext"] = "";
   $frm["updatecache"] = 'Y';
   
   $qry=sprintf(uplu_qry5, $row["tax"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(db_num_rows($result)==0){
      $frm["taxid"]=0;
      $frm["badtax"] = "Y";
   }
   else{
      $frm["taxid"]=$row['id'];
      $frm["badtax"] = "N";
   }
	return $frm;
}

function editUplu($id) 
{
	$result=$_SESSION['VxCFG']->dbh->Execute("SELECT id FROM u_plu");
	$ret=db_num_rows($result);
	
	if($ret==0){
		include("templates/uplu_none.php");
		exit;
	}
	else{
		$frm=fillForm($id);
		$frm["newaction"] = "commit";
		include("templates/uplu.php");
	}
}

function deleteUplu($id) 
{
   $qry=sprintf(uplu_qry6, $id);
	db_query($qry);
}


function commitUplu($frm) 
{

   // throw in a minimal inv entry

   $cm=new CreateMod();
   $cm->Fill(0);
   $cmid=$cm->Commit();
 
   $qry=sprintf(inventory_qry6, 0,0,0,0,'','',0,0,0,0,0,0,0,0,0,$cmid,0);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $invid=$row[0];
   
   // add product with flags='unfinished entry' (2)
   $qry=sprintf(product_qry4, 0,$invid,0,0,$frm['plu'],0,$frm['name'],'',0,'N',0,$frm['rectext'],0,0,0,0,'N',0,'N',2,0,'');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $prodid=$row[0];
   
   // add a sell price quantity
   $qry=sprintf(sellpq_qry4, 0,0,1,2,1,$frm['unitprice'],0,$frm['taxid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $sellpqid=$row[0];
   
   // update the product for sell price
   $qry=sprintf(product_qry8, $sellpqid, $prodid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   // update plu_cache
   if(YN($frm['updatecache'])=="Y"){
      $qry=sprintf(uplu_qry8, $frm['taxid']);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      $tax=$row[0];
      $qry=sprintf(uplu_qry4, $prodid,0,$frm['plu'],$frm['disptext'],$frm['rectext'],$frm['unitprice'],0.0,0,0.0,$tax,0);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   // delete u_plu entry
   $qry=sprintf(uplu_qry6, $frm['id']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function listUplu()
{
	$sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(transaction_uplu_qry9, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no unknown plus")."</td></td></table>\n";
      return;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='plu'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("PLU")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("PLU")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=plu\">"._("PLU")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='plu'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='unitprice'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Price")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Price")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=unitprice\">"._("Price")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='unitprice'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
   $c=0;
   $offset=$_SESSION["pageindex"]->current();

	while($row = $result->FetchRow()){
      if($c%2){
         echo "<tr class=\"listdata\">\n<td class=\"listdata\">";
         echo $row['plu']."</td>\n<td class=\"listdata\">".$row['name']."</td>\n<td class=\"listdata\">";
         echo $row['unitprice']."</td>\n<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\">\n<td class=\"listdataeven\">";
         echo $row['plu']."</td>\n<td class=\"listdataeven\">".$row['name']."</td>\n<td class=\"listdata\">";
         echo $row['unitprice']."</td>\n<td class=\"listdataeven\">";
      }
		$wibbler=$row['id'];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"uplu.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"uplu.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"uplu.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"uplu.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"uplu.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"uplu.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      $c++;
      $offset++;
		echo "</td></tr>\n";
	}
	echo "</table>";
}

?>
