<?php
/*
litypes.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Login Types Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Login Types Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(userm_litype_qry1, "logintypes")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
     break;
   case 'pageprev':
     $_SESSION["pageindex"]->pgprev();
     break;
   case 'prev':
     $_SESSION["pageindex"]->prev();
     break;
   case 'next':
     $_SESSION["pageindex"]->next();
     break;
   case 'pagenext':
     $_SESSION["pageindex"]->pgnext();
     break;
   case 'end':
      if($_REQUEST['action']=="list")
        $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
     break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addLitype();
		break;
		
	case "browse" :
      if(isset($_REQUEST['id'])){
         $id=$_SESSION["pageindex"]->browse($_REQUEST['id']);
         browseLitype($id);
         break;
      }
      $id=updateNav($_POST);
      browseLitype($id);
      break;

	case "edit" :
		editLitype($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelLitype($_REQUEST['id']);
      }
      else{
         deleteLitype($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listLitype($_REQUEST['id']);
      }
		break;
      
   case "cfmdelete" :
      deleteLitype($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listLitype();
		break;

	case "add" :
		insertLitype($_POST);
      $_SESSION["pageindex"]->setnum(CountNum());
		listLitype();
		break;

	case "commit" :
		commitLitype($_POST);
		listLitype();
		break;

	case "list" :
	default :
      $id=updateNav($_POST);
		listLitype();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(userm_litype_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm['id'] = 0;
   $frm['litdata'] = BHSQL_LOGINMETHOD_DATA;
   $frm['Name'] = "" ;

   return $frm;
}

function fillform($id, $bOffset)
{

	if($bOffset){
      $qry=sprintf(userm_litype_qry2, $id);
   }
   else{
      $qry=sprintf(userm_litype_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm['id'] = $id;
   $frm['litdata'] = $row['litdata'];
   $frm['name'] = $row['name'];
   
	return $frm;
}

function addLitype() 
{
   $frm=clearForm();
   $frm["newaction"] = "add";

	include("templates/litypes.php");   
}

function browseLitype($id) 
{
	$frm = fillform($id, true);
	$frm["newaction"] = "browse";

	include("templates/litypes.php");
}

function editLitype($id) 
{
	$frm = fillform($id, false);
	$frm["newaction"] = "commit";

	include("templates/litypes.php");
}

function deleteLitype($id) 
{
   $qry=sprintf(userm_litype_qry7, $id);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function chkdelLitype($id)
{
   $frm = fillform($id, false);
	$frm["newaction"] = "cfmdelete";
   include("templates/litypes.php");
}

function insertLitype($frm) 
{
   $qry=sprintf(userm_litype_qry5, $frm['name'],$frm['litdata']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitLitype($frm) 
{
	$qry=sprintf(userm_litype_qry6,$frm['name'],$frm['litdata'],$frm['id']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function LoginTypesCombo($a, $i)
{
   if($a=="commit" || $a=="add"){
  		echo "<select name=\"litdata\" width=\"250\">\n";
     	if($i==BHSQL_LOGINMETHOD_DATA){
         print "<option selected value=\"0\"> Data </option>\n";
         print "<option value=\"1\"> Pointer </option>\n";
         print "<option value=\"2\"> Pair </option>\n";
      }
      else if($i==BHSQL_LOGINMETHOD_PTR){
         print "<option value=\"0\"> Data </option>\n";
         print "<option selectedvalue=\"1\"> Pointer </option>\n";
         print "<option value=\"2\"> Pair </option>\n";
      }
      else if($i==BHSQL_LOGINMETHOD_PAIR){
         print "<option value=\"0\"> Data </option>\n";
         print "<option value=\"1\"> Pointer </option>\n";
         print "<option selected value=\"2\"> Pair </option>\n";
      }
  		print "</select>\n";
  	}
   else{
      if($i==BHSQL_LOGINMETHOD_DATA){
         print "Data\n";
      }
      else if($i==BHSQL_LOGINMETHOD_PTR){
         print "Pointer\n";
      }
      else if($i==BHSQL_LOGINMETHOD_PAIR){
         print "Pair\n";
      }
   }
}

function listLitype()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(userm_litype_qry8, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no login types defined")."</td></td></table>\n";
      return;
   }
   
  echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
   
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   while($row = $result->FetchRow()){
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">".$row["name"]."</td>";
		   echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row["name"]."</td>";
		   echo "<td class=\"listdataeven\">";
      }
      /*
      switch($row['litdata']){
      case BHSQL_LOGINMETHOD_DATA: echo _("Data"); break;
      case BHSQL_LOGINMETHOD_PTR: echo _("Pointer"); break;
      case BHSQL_LOGINMETHOD_PAIR: echo _("Pair"); break;
      }
      echo "</td><td class=\"listdata\">\n";*/
      $wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"litypes.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"litypes.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"litypes.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
        echo "<a href=\"litypes.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"litypes.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"litypes.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
