<?php
/*
roster.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Roster Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Roster Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(userm_roster_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
     break;
   case 'pageprev':
     $_SESSION["pageindex"]->pgprev();
     break;
   case 'prev':
     $_SESSION["pageindex"]->prev();
     break;
   case 'next':
     $_SESSION["pageindex"]->next();
     break;
   case 'pagenext':
     $_SESSION["pageindex"]->pgnext();
     break;
   case 'end':
      if($_REQUEST['action']=="list")
        $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
     break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		clearRoster();
		break;
		
	case "browse" :
      if(isset($_REQUEST['id'])){
         $id=$_SESSION["pageindex"]->browse($_REQUEST['id']);
         browseRoster($id);
         break;
      }
      $id=updateNav($_POST);
      browseRoster($id);
		break;

	case "edit" :
		editRoster($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelRoster($_REQUEST['id']);
      }
      else{
         deleteRoster($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listRoster($_REQUEST['id']);
      }
		break;
      
   case "cfmdelete" :
      deleteRoster($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listRoster();
		break;

	case "add" :
		addRoster($_POST);
      $_SESSION["pageindex"]->setnum(CountNum());
		listRoster();
		break;

	case "commit" :
		commitRoster($_POST);
		listRoster();
		break;

	case "list" :
	default :
      $id=updateNav($_POST);
		listRoster();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(userm_roster_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "";
   $frm["rosterid"] = "";
   $frm["cmid"] = "";
   $frm["name"] = "";
   $frm["day"] = "";
   $frm["month"] = "";
   $frm["starttime"] = "";
   $frm["endtime"] = "";

   return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(userm_roster_qry2, $id);
   }
   else{
      $qry=sprintf(userm_roster_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
   $frm["rosterid"] = $row["rosterid"];
   $frm["cmid"] = $row["cmid"];
   $frm["name"] = $row["name"];
   $frm["rosterentryid"] = $row["rosterentryid"];
   $frm["active"] = $row["active"];

	return $frm;
}

function browseRoster($id) 
{
	$frm = fillform($id, true);
	$frm["newaction"] = "browse";
   
	include("templates/roster.php");
}

function editRoster($id) 
{
	$frm = fillform($id, false);
	$frm["newaction"] = "commit";

	include("templates/roster.php");
}

function clearRoster() 
{
   $frm=clearForm();
   $frm["newaction"] = "add";
   
	include("templates/roster.php");   
}

function deleteRoster($frm) 
{
	//$_SESSION['VxCFG']->dbh->Execute("delete from roster where id = '$id'");
}

function chkdelRoster($id)
{
   $frm = fillform($id, false);
	$frm["newaction"] = "cfmdelete";
}

function addRoster($frm) 
{
   //$frm["rosterid"],$frm["cmid"],$frm["name"],$frm["day"],$frm["month"],$frm["starttime"],$frm["endtime"]);
	
	//$_SESSION['VxCFG']->dbh->Execute($query);
}

function commitRoster($frm) 
{
	
	//$_SESSION['VxCFG']->dbh->Execute($query);
}

function listRoster()
{
	$result=db_query("SELECT * from users");
/*
	frm["login"] = $row["Login"]; 
	frm["password"] = $row["Password"];
	frm["profile"] = $row["Profile"]; 
	frm["ifauth"] = $row["InterfaceAuthID"];
	frm["logintypes"] = $row["LoginTypesID"];

	$eid=$row["ID"];
	$result=db_query("SELECT fname, lname from Employee WHERE UserID='$eid');
	$erow = $result->FetchRow();
	frm["fname"] = $erow["fname"]; 
	frm["lname"] = $erow["lname"];

	global $_SESSION;

	$action=db_query("SELECT * FROM EmployeeLog WHERE stamper < (NOW()-1) 
		ORDER BY EmployeeID, stamper, actionID DESC");
	$numaction=db_num_rows();


	$booboofish = $_SESSION["employee"]["ID"];

	$sql="SELECT actionID, stamper FROM EmployeeLog WHERE  
		actionID = '3' OR actionID = '5' OR actionID = '7' ORDER BY stamper DESC";
	$result=db_query($sql);
		

*/
		
	print "<form method=\"post\" action=\"users.php\">";
	
	print "<br><br><table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	print "<tr><td><h3>Name</h3></td>\n";
	print "<td><h3>Login</h3></td>";
	print "<td><h3>Action</h3></td>\n</tr>\n";
	
	while($row = $result->FetchRow()){

		$eid=$row["employeeid"];
		$eresult=$_SESSION['VxCFG']->dbh->Execute("SELECT id, fname, lname from employee WHERE id='$eid'");
		$erow = $eresult->FetchRow();
		print "<tr><td>";
		$name=$erow["fname"]." ".$erow["lname"]; 
		if($name == " "){
		   print "&nbsp;";
		}
		else{
   		print "$name";
      }
		print "</td>\n<td>";
		$wibbler=$row["login"];
		print "$wibbler</td><td>\n";
		$id=$row["id"];
		$eid=$erow["id"];
		print "<a href=\"users.php?action=clear&id=$id\">add</a>&nbsp;\n";
		print "<a href=\"users.php?action=edit&id=$id&emp=$eid\">edit</a>&nbsp; \n";
		print "<a href=\"users.php?action=delete&id=$id\">delete</a>&nbsp; \n";
				
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
	
}

?>
