<?php
/*
userprefs.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/country.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
$_SESSION['vxmisuser']->SetModule(2);

if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='edit';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm("list", $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Preferences"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Preferences");
}

if($_SESSION["pageindex"]->CheckNum(useradmin_userpref_qry1, "")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "commit" :
		commitUserPref($_POST);
      listModule();
		break;
      
	case "edit":
	default :
		listModule();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(useradmin_userpref_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function commitUserPref($frm) 
{
   if(strcmp($frm['password'], $frm['cpassword'])==0){
      $s=$frm['starttimehour'].":".$frm['starttimeminute'].":00";
      $e=$frm['endtimehour'].":".$frm['endtimeminute'].":00";
      $aid=$_SESSION['vxmisuser']->GetAttributeid();
      
      $qry=sprintf(useradmin_userpref_qry6, $frm['listpagesize'],'misdefaultpagesize',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(useradmin_userpref_qry6, $frm['theme'],'mistheme',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(useradmin_userpref_qry6, $frm['language'], 'mislanguage',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(useradmin_userpref_qry6, $frm['dateformat'], 'misdateformat',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(useradmin_userpref_qry6, $frm['timeformat'], 'mistimeformat',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(useradmin_userpref_qry6, $frm['defaultstartpage'], 'misdefaultstartpage',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(useradmin_userpref_qry6, $s, 'mistodaystarttime',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(useradmin_userpref_qry6, $e, 'mistodayendtime',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(useradmin_userpref_qry6, $frm['firstdayofweek'],'misfirstdayofweek',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(useradmin_userpref_qry6, $frm['firstweekofyear'],'misfirstweekofyear',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(useradmin_userpref_qry6, YN($frm['showhelp']),'misonlinehelp',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(useradmin_userpref_qry6, YN($frm['confirmdelete']), 'misconfirmdelete',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(useradmin_userpref_qry6, YN($frm['showimages']),'misinlineimages',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(misadmin_mispref_qry6, $frm['num_dispmodule'],'numdispmodules',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(misadmin_mispref_qry6, $frm['showmodulefooterlinks'],'showmodulefooterlinks',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
      $qry=sprintf(misadmin_mispref_qry6, $frm['num_last_viewed'],'numlastviewed',$aid);
      $_SESSION['VxCFG']->dbh->Execute($qry);
     
      //$_SESSION['vxmisuser']->SetLanguage($frm['language']);
      $_SESSION['vxmisuser']->SetShowHelp($frm['showhelp']);
      $_SESSION['vxmisuser']->SetShowImages($frm['showimages']);
      $_SESSION['vxmisuser']->SetPageSize($frm['listpagesize']);
      $_SESSION['vxmisuser']->SetConfirmDelete($frm['confirmdelete']);
      $_SESSION['vxmisuser']->SetTodayStart($s);
      $_SESSION['vxmisuser']->SetFirstWeekofYear($frm['firstweekofyear']);
      $_SESSION['vxmisuser']->SetFirstDayofWeek($frm['firstdayofweek']);
      $_SESSION['vxmisuser']->SetTodayEnd($e);
      $_SESSION['vxmisuser']->SetDateFormat($frm['dateformat']);
      $_SESSION['vxmisuser']->SetTimeFormat($frm['timeformat']);
      $_SESSION['vxmisuser']->SetStartPage($frm['defaultstartpage']);
      $_SESSION['vxmisuser']->SetNumDispModule($frm['numdispmodules']);
      $_SESSION['vxmisuser']->SetNumLastViewed($frm['numlastviewed']);
      $_SESSION['vxmisuser']->SetShowFooterLinks($frm['showmodulefooterlinks']);
   }
}

function ThemeCombo($a, $t)
{
   // parse theme dirs and files in /style/XXX/theme
   echo "<select name=\"theme\">\n";
   if($handle=opendir($_SESSION['VxCFG']->dirroot."/style")){
      while(false!==($file=readdir($handle))){ 
         if(is_dir($file)) continue;
         if($t==$file){
            echo "<option value=\"$file\" selected>$file</option>\n";
         }
         else{
            echo "<option value=\"$file\">$file</option>\n";
         }
      }
   }
   echo "</select>\n";
   closedir($handle); 
}

function LangCombo($a, $l)
{
   // open available languages from file /lib/lang/list
   if(file_exists($_SESSION['VxCFG']->libdir."/lang/languages")){
      echo "<select name=\"language\">\n";
      if(($fd=fopen($_SESSION['VxCFG']->libdir."/lang/languages", 'r'))){
         while(($buffer = fgets($fd, 64))){
            $buffer=trim($buffer);
            if($l==$buffer){
              echo "<option value=\"$buffer\" selected>$buffer</option>\n";
            }
            else{
               echo "<option value=\"$buffer\">$buffer</option>\n";
            }
         }
         fclose ($fd);
      }
      echo "</select>\n";
   }
}

function TimeControl($a, $t)
{
   $ts=new TimeDate($t);
   if($a=="start"){
      $ts->timecontrol("commit", "starttime");
   }
   else{
      $ts->timecontrol("commit", "endtime");
   }
}

function WeekControl($a, $w)
{
   echo "<select name=\"firstweekofyear\">\n";
   for($i=1; $i < 53; $i++){
      if($i==$w){
         echo "<option value=\"$i\" selected>$i</option>\n";
      }
      else{
         echo "<option value=\"$i\">$i</option>\n";
      }
   }
   echo "</select>\n";
}

function DayControl($a, $d)
{
   echo "<select name=\"firstdayofweek\">\n";
   for($i=5; $i < 12; $i++){
      $x=$i-5;
      if($x==$d){ 
         echo "<option value=\"".$x."\" selected>".date("l", mktime(0, 0, 0, 9, $i, 2004))."</option>\n";
      }
      else{
         echo "<option value=\"".$x."\">".date("l", mktime(0, 0, 0, 9, $i, 2004))."</option>\n";
      }
   }
   echo "</select>\n";
}

function DefPageCombo($a, $d)
{
   echo "<select name=\"defaultstartpage\">\n";
   if($d=="main.php"){
      echo "<option value=\"main.php\" selected>"._("Information")."</option>\n";
   }
   else{
      echo "<option value=\"main.php\">"._("Information")."</option>\n";
   }
   
   if($d=="users/usertoday.php"){
      echo "<option value=\"users/usertoday.php\" selected>"._("Today")."</option>\n";
   }
   else{
      echo "<option value=\"users/usertoday.php\">"._("Today")."</option>\n";
   }
   echo "</select>\n";
}

function listModule()
{
   $qry=sprintf(useradmin_userpref_qry2, $_SESSION["vxmisuser"]->GetEmployee());
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm['id']=$row['id'];
   $frm['language']=$_SESSION["vxmisuser"]->GetLanguage(); 
	$frm['showhelp']=$_SESSION["vxmisuser"]->GetShowHelp();
	$frm['showimages']=$_SESSION["vxmisuser"]->GetShowImages();
	$frm['confirmdelete']=$_SESSION["vxmisuser"]->GetConfirmDelete();
   $frm['listpagesize']= $_SESSION["vxmisuser"]->GetPageSize();
	$frm['theme']=$_SESSION["vxmisuser"]->GetTheme();
   $frm['todaystarttime']=$_SESSION["vxmisuser"]->GetTodayStart();
   $frm['todayendtime']=$_SESSION["vxmisuser"]->GetTodayEnd();
   $frm['firstweekofyear']=$_SESSION["vxmisuser"]->GetFirstWeekofYear();
   $frm['firstdayofweek']=$_SESSION["vxmisuser"]->GetFirstDayofWeek();
   $frm['defaultstartpage']=$_SESSION["vxmisuser"]->GetStartPage();
   $frm['dateformat']=$_SESSION["vxmisuser"]->GetDateFormat();
   $frm['timeformat']=$_SESSION["vxmisuser"]->GetTimeFormat();
   $frm["num_dispmodule"]=$_SESSION["vxmisuser"]->GetNumDispModule();
   $frm["num_last_viewed"]=$_SESSION["vxmisuser"]->GetNumLastViewed();
   $frm["showmodulefooterlinks"]=$_SESSION["vxmisuser"]->GetShowFooterLinks();
  
   $frm['name']=$_SESSION['vxmisuser']->GetUserName() ;
   
   $qry=sprintf(useradmin_userpref_qry3, $_SESSION["vxmisuser"]->GetEmployee());
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   $frm['password']=$row['password'];
   $frm['cpassword']=$row['password'];
   
	$frm["newaction"] = "commit";
	
	include("templates/userprefs.php");
}

?>
