<?php
/*
usertoday.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/calendar.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
$_SESSION['vxmisuser']->SetModule(3);

if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm("list", $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Today"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Today");
}

if($_SESSION["pageindex"]->CheckNum(useradmin_today_qry1, "event")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

switch($action){
	case "add" :
      include($_SESSION['VxCFG']->styledir."/header.php");
		addEvent($_POST);
		break;
      
	case "edit" :
      include($_SESSION['VxCFG']->styledir."/header.php");
      editevent($_POST);
      break;
      
   case 'd':
      $_SESSION['vxmisuser']->SetTab(0);
      include($_SESSION['VxCFG']->styledir."/header.php");
      if(isset($_REQUEST['v']))
         dayView($_REQUEST['v']);
      else 
         dayView();
      break;
      
   case 'w':
      $_SESSION['vxmisuser']->SetTab(1);
      include($_SESSION['VxCFG']->styledir."/header.php");
      if(isset($_REQUEST['v']))
         weekView($_REQUEST['v']);
      else 
         weekView();
      break;
      
   case 'm':
      $_SESSION['vxmisuser']->SetTab(2);
      include($_SESSION['VxCFG']->styledir."/header.php");
      if(isset($_REQUEST['v']))
         monthView($_REQUEST['v']);
      else
         monthView();
      break;
   
   case 'e':
      $_SESSION['vxmisuser']->SetTab(3);
      include($_SESSION['VxCFG']->styledir."/header.php");
      if(isset($_REQUEST['id'])){
         eventView($_REQUEST['id']);
      }
      else{
         eventView(0);
      }
      break;
      
   default :
      include($_SESSION['VxCFG']->styledir."/header.php");
		dayView();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
/*
   $result=db_query(useradmin_userpref_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }*/
   return 0;
}

function dayView($v=null)
{
   if(isset($v)){
      $today=new VxCalendar($_SESSION['vxmisuser']->GetEmployee(), $v);
   }
   else{
      $today=new VxCalendar($_SESSION['vxmisuser']->GetEmployee());
   }
   $today->drawToday();
}

function eventView($id)
{
   $e=new VxEvent();
   $frm=$e->FillForm($id);
   if($frm==false){
      $frm['id']=0;
      $frm['starts']='';
      $frm['ends']='';
      $frm['title']='';
      $frm['ownerid']='';
   }
   $frm['newaction']='commit';

   include("templates/userevent.php");
}

function TimeControl($a, $t)
{
   $ts=new TimeDate($t);
   if($a=="starts"){
      $ts->tscontrol_quarterhour("commit", "starts");
   }
   else{
      $ts->tscontrol_quarterhour("commit", "endts");
   }
}

function weekView($v=null)
{
   if(isset($v)){
      $today=new VxCalendar($_SESSION['vxmisuser']->GetEmployee(), $v);
   }
   else{
      $today=new VxCalendar($_SESSION['vxmisuser']->GetEmployee());
   }
   $today->drawWeek();
}

function monthView($v=null)
{
   if(isset($v)){
      $today=new VxCalendar($_SESSION['vxmisuser']->GetEmployee(), $v);
   }
   else{
      $today=new VxCalendar($_SESSION['vxmisuser']->GetEmployee());
   }
   $today->drawMonth();
}

function listModule()
{
   $qry=sprintf(misadmin_userpref_qry2, $_SESSION["vxmisuser"]->GetEmployee());
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm['id']=$row['id'];
   $frm['language']=$row['language'];
	$frm['showhelp']=$row['showhelp'];
	$frm['showimages']=$row['showimages'];
	$frm['confirmdelete']=$row['confirmdelete'];
   $frm['listpagesize']=$row['listpagesize'];
	$frm['theme']=$row['theme'];
   
   $frm['name']=$_SESSION['vxmisuser']->GetUserName() ;
   
   $qry=sprintf(misadmin_userpref_qry3, $_SESSION["vxmisuser"]->GetEmployee());
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   $frm['password']=$row['password'];
   
	$frm["newaction"] = "commit"; 
	
	include("templates/userprefs.php");
}

?>
