<?php
/*
dispatch.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/contact.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(2);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Dispatch"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Dispatch");
}

if($_SESSION["pageindex"]->CheckNum(warehouse_dispatch_qry1, "orders")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

switch($action){
   case "edit":
      include($_SESSION['VxCFG']->styledir."/header.php");
      editDispatch($_REQUEST['id']);
      break;
      break;

   case "commit" :
      include($_SESSION['VxCFG']->styledir."/header.php");
      commitDispatch($_POST);
      listDispatch();
      break;
      
   case "list":
   default :
      include($_SESSION['VxCFG']->styledir."/header.php");
      listDispatch();
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(warehouse_dispatch_qry1);
   if(!$result) return 0;
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function editDispatch($id) 
{
   $qry=sprintf(warehouse_stockpick_qry5, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["id"] = $row["id"];
   $frm["ordernumber"] = $row["ordernumber"];
   $frm["shippingid"] = $row["shippingid"];
   $frm["trackingnum"]="";
   
   $frm["newaction"] = "commit";
  
   include("templates/dispatch.php");
}

function commitDispatch($frm) 
{
   $qry=sprintf(warehouse_dispatch_qry6,$frm["trackingnum"], $frm['shippingid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   $qry=sprintf(warehouse_dispatch_qry5, $frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function miniView($orderid)
{
   require_once($_SESSION['VxCFG']->dirroot."/vxmis.php");
   echo "<html>\n<head>\n<title>";
   echo $_SESSION["VxCFG"]->pagetitle;
   echo "</title>\n<link href=\"".$_SESSION["VxCFG"]->stylerel."/main.css\" rel=\"stylesheet\" type=\"text/css\">";
   include($_SESSION['VxCFG']->libdir . '/lib.js');
   echo "<link rel=\"icon\" type=\"image/png\" href=\"". $_SESSION["VxCFG"]->imagedir."/icon.png\">";
   echo "</head>\n<body topmargin=\"0\" leftmargin=\"0\" rightmargin=\"0\">";
   echo "<form id=\"orderitems\" method=\"post\" action=\"". $_SERVER['PHP_SELF'] ."\">\n";
   echo "<input type=\"hidden\" name=\"action\" value=\"minicommit\">\n";
   echo "<input type=\"hidden\" name=\"id\" value=\"$orderid\">\n";
   
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   echo "<table class=\"minilisttable\">\n";
   $qry=sprintf(warehouse_stockpick_qry6, $orderid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      exit;
   }
   echo "<tr><td class=\"minilisttitle\"><table class=\"minilistsorttable\"><tr><td class=\"minilistsort\">";
   if($sorton=='partnumber'){
      if($sortorder=='asc'){
        echo "<a class=\"minilistsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Part No")."</a></td>\n";
      }
      else{
         echo "<a class=\"minilistsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Part No")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"minilistnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=partnumber\">"._("Part No")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='parnumber'){
      echo "<td class=\"minilistsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"minilistsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/minilist_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"minilistsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/minilist_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"minilisttitle\"><table class=\"minilistsorttable\"><tr><td class=\"minilistsort\">";
   if($sorton=='stocklocation'){
      if($sortorder=='asc'){
        echo "<a class=\"minilistsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Location")."</a></td>\n";
      }
      else{
         echo "<a class=\"minilistsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Location")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"minilistnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=stocklocation\">"._("Location")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='stocklocation'){
      echo "<td class=\"minilistsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"minilistsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/minilist_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"minilistsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/minilist_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"minilisttitle\"><table class=\"minilistsorttable\"><tr><td class=\"minilistsort\">";
   if($sorton=='description'){
      if($sortorder=='asc'){
        echo "<a class=\"minilistsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Description")."</a></td>\n";
      }
      else{
         echo "<a class=\"minilistsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Description")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"minilistnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=description\">"._("Description")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='description'){
      echo "<td class=\"minilistsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"minilistsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/minilist_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"minilistsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/minilist_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"minilisttitle \">"._("Quantity")."</td>\n";
   echo "<td class=\"minilisttitle \">";
   echo "<input class=\"checkbox\" type=\"checkbox\" name=\"checkall\" onClick=\"Checkall(document.getElementById('orderitems'))\">";
   echo "</td>\n</tr>\n";
   
   while($row = $result->FetchRow()){
      $qry=sprintf(warehouse_stockpick_qry7, $row['productid']);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$res) continue;
      if($res->RecordCount()==0) continue;
      if(!($r = $res->FetchRow())) continue;
      echo "<tr><td class=\"minilistdata\">";
      if(isset($r["partnumber"])){
         echo $r["partnumber"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n<td class=\"minilistdata\">";
      if(isset($r["stocklocation"]) && $r["stocklocation"]!=''){
         echo $r["stocklocation"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n";
      
      echo "<td class=\"minilistdata\">".$r["description"]."</td>\n";
      echo "<td class=\"minilistdata\">".$row["quantity"]."</td>\n";
      echo "<td class=\"minilistdata\">";
      echo "<input class=\"checkbox\" type=\"checkbox\" name=\"itemcheck\">";
      echo "</td></tr>\n";
   }
   echo "<tr><td colspan=\"5\" align=\"center\">";
   echo "<input type=\"submit\" value=\""._("Done")."\">\n";
   echo "</td></tr>\n</table>\n</form>\n</body>\n</html>";
}

function ContactName($a, $id) 
{
   $c=new Contact($id);
   $c->NameTable($a, $id);
}

function AddressTable($a, $id)
{
   $qry=sprintf(customerm_customer_qry9, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $aid=$row["addressid"];
   
   $addr=new Address();
   $addr->FillListTable($a, $aid);
}

function OrderItems($orderid)
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();

   echo "<table class=\"listtable\">\n";
   $qry=sprintf(warehouse_stockpick_qry6, $orderid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      exit;
   }
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='partnumber'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Part No")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Part No")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=partnumber\">"._("Part No")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='parnumber'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='stocklocation'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Location")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Location")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=stocklocation\">"._("Location")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='stocklocation'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='description'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Description")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Description")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=description\">"._("Description")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='description'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \">"._("Quantity")."</td>\n";
   echo "<td class=\"listtitle \">";
   echo "<input class=\"checkbox\" type=\"checkbox\" name=\"checkall\" onClick=\"Checkall(document.getElementById('orderitems'))\">";
   echo "</td>\n</tr>\n";
   
   while($row = $result->FetchRow()){
      $qry=sprintf(warehouse_stockpick_qry7, $row['productid']);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$res) continue;
      if($res->RecordCount()==0) continue;
      if(!($r = $res->FetchRow())) continue;
      echo "<tr><td class=\"minilistdata\">";
      if(isset($r["partnumber"])){
         echo $r["partnumber"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n<td class=\"minilistdata\">";
      if(isset($r["stocklocation"]) && $r["stocklocation"]!=''){
         echo $r["stocklocation"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n";
      
      echo "<td class=\"minilistdata\">".$r["description"]."</td>\n";
      echo "<td class=\"minilistdata\">".$row["quantity"]."</td>\n";
      echo "<td class=\"minilistdata\">";
      echo "<input class=\"checkbox\" type=\"checkbox\" name=\"itemcheck\">";
      echo "</td></tr>\n";
   }
   echo "</table>\n";
}

function listDispatch()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(warehouse_dispatch_qry3, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no outstanding orders defined")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no outstanding orders defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='orderid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Order")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Order")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=orderid\">"._("Order")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='orderid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='customer'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Customer")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Customer")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=customer\">"._("Customer")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='customer'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   while($row = $result->FetchRow()){
      $qry=sprintf(warehouse_stockpick_qry10, $row["customerid"]);
		$res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      
      $qry=sprintf(warehouse_stockpick_qry11,$r["contactid"]);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">".$row["ordernumber"]."</td>\n";
         echo "<td class=\"listdata\">".$r["firstname"]." ".$r["lastname"]."</td>\n";
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row["ordernumber"]."</td>\n";
         echo "<td class=\"listdataeven\">".$r["firstname"]." ".$r["lastname"]."</td>\n";
         echo "<td class=\"listdataeven\">";
      }
      $wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         if($_SESSION['vxmisuser']->GetPerm('edit')){
            echo "<a href=\"dispatch.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_dispatch.png\"></a>&nbsp; \n";
         }
      }
      else{
         if($_SESSION['vxmisuser']->GetPerm('edit')){
            echo "<a href=\"dispatch.php?action=edit&id=$wibbler\">"._("Dispatch")."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
   }
   echo "</table>";
}

?>
