<?php
/*
accounts.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Accounts Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Accounts Maintenance");
}

if($_SESSION['pageindex']->CheckNum(accountm_account_qry1, "account")){
   $_SESSION['pageindex']->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addAccount();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseAccount($_REQUEST['id']);
         break;
      }
		browseAccount($_POST['id']);
		break;

	case "edit" :
		editAccount($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelAccount($_REQUEST['id']);
      }
      else{
         deleteAccount($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listAccount();
      }
      break;  
	
   case "cfmdelete" :
      deleteAccount($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listAccount();
		break;
      
	case "add" :
		insertAccount($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitAccount($_POST);
      listAccount();
		break;
      
   case "duplicate" :
      $id=duplicateAccount($_REQUEST['id']);
      editAccount($id);
      break;

	case "list":
	default :
		listAccount();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(accountm_account_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "0";
   $frm["parentid"] = "0";
   $frm["headingid"]=0;
	$frm["accountnumber"] = "";
	$frm["name"]="";   
	$frm["gref"] = "";
   $frm["profitloss"] = "N";
   
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(accountm_account_qry2, $id);
   }
   else{
      $qry=sprintf(accountm_account_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	if($row = $result->FetchRow()){
      $frm["id"] = $id;
      $frm["parentid"] = $row["parentid"];
      $frm["headingid"] = $row["headingid"];
      $frm["accountnumber"] = $row["accountnumber"];
	   $frm["name"] = $row["name"];
	   $frm["gref"] = $row["gref"];
      $frm["profitloss"] = $row["profitloss"];
	}
   return $frm;
}

function addAccount()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   
	include("templates/accounts.php");
}

function editAccount($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/accounts.php");
}

function browseAccount($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";

	include("templates/accounts.php");
}

function insertAccount($frm) 
{
	$qry=sprintf(accountm_account_qry5,$frm['parentid'],$frm['headingid'],$frm['accountnumber'],$frm['name'],$frm['gref'],
   $frm['profitloss']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   return $row[0];
}

function commitAccount($frm) 
{
   $qry=sprintf(accountm_account_qry6,$frm['parentid'],$frm['headingid'],$frm['accountnumber'],$frm['name'],$frm['gref'],
      $frm['profitloss'], $frm['id']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function chkdelAccount($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/accounts.php");
}

function deleteAccount($id) 
{
   $qry=sprintf(accountm_account_qry7,$id);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function duplicateAccount($id) 
{
   $frm=fillForm($id, false);
   return insertAccount($frm);
}

function fillHeadingCombo($a, $id)
{
   $acc=new Account();
   $acc->HeadingCombo($a, $id, "headingid");
}

function fillParentCombo($a, $id)
{
   $acc=new Account();
   $acc->Combo($a, $id, "parentid");
}

function PlBsradio($a, $v)
{
   if($a=="add" || $a=="commit"){
      if($v=='Y'){
         echo "<input type=\"radio\" name=\"profitloss\" value=\"Y\" checked>Profit/Loss\n";
         echo "<input type=\"radio\" name=\"profitloss\" value=\"N\">Balance Sheet\n";
      }
      else{
         echo "<input type=\"radio\" name=\"profitloss\" value=\"Y\">Profit/Loss\n";
         echo "<input type=\"radio\" name=\"profitloss\" value=\"N\" checked>Balance Sheet\n";
      }
   }
   else{
      if($v=='Y'){
         echo "Profit/Loss";
      }
      else{
         echo "Balance Sheet";
      }
   }
}

function listAccount()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(accountm_account_qry13, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no accounts defined")."</td></td></table>\n";
      return;
   }

   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='accountnumber'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Number")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Number")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=accountnumber\">"._("Number")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='accountnumber'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='headingid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Type")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Type")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=title\">"._("Type")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='headingid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='profitloss'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("P/L")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("P/L")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=profitloss\">"._("P/L")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='profitloss'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      $qry=sprintf(accountm_account_qry14, $row['headingid']);
      $hresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      $hrow = $hresult->FetchRow();
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">".$row['name']."</td>";
	   	echo "<td class=\"listdata\">".$row['accountnumber']."</td>";
         echo "<td class=\"listdata\">".$hrow['name']."</td><td class=\"listdata\" align=\"center\">";
         CheckBox("browse", "", $row['profitloss']);
         echo "</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row['name']."</td>";
	   	echo "<td class=\"listdataeven\">".$row['accountnumber']."</td>";
         echo "<td class=\"listdataeven\">".$hrow['name']."</td><td class=\"listdataeven\" align=\"center\">";
         CheckBox("browse", "", $row['profitloss']);
         echo "</td><td class=\"listdataeven\">";
      }

		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"accounts.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"accounts.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"accounts.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"accounts.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"accounts.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"accounts.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
