<?php
/*
payable.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('arriveddate');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Accounts Payable"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Accounts Payable");
}

if($_SESSION['pageindex']->CheckNum(account_payable_qry1, "account")){
   $_SESSION['pageindex']->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addAccount();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseAccount($_REQUEST['id']);
         break;
      }
		browseAccount($_POST['id']);
		break;

	case "edit" :
		editAccount($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelAccount($_REQUEST['id']);
      }
      else{
         deleteAccount($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listAccount();
      }
      break;  
	
   case "cfmdelete" :
      deleteAccount($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listAccount();
		break;
      
	case "add" :
		insertAccount($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitAccount($_POST);
      listAccount();
		break;

	case "list":
	default :
		listAccount();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(account_payable_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "0";
   $frm["journalid"] = "";
   $frm["ledgerid"] = "";
   $frm["accountid"] = "";
   $frm["entereddate"] = "";
   $frm["description"] = "";
   $frm["debit"] = "N";
   $frm["amount"] = "";
   $frm["posted"] = "N";
   $frm["referenceid "] = "";
   
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(account_payable_qry3, $id);
   }
   else{
      $qry=sprintf(account_payable_qry4, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	if($row = $result->FetchRow()){
      $frm["id"] = $row["id"];
      $frm["journalid"] = $row["journalid"];
      $frm["ledgerid"] = $row["ledgerid"];
      $frm["accountid"] = $row["accountid"];
      $frm["entereddate"] = $row["entereddate"];
      $frm["description"] = $row["description"];
      $frm["debit"] = $row["debit"];
      $frm["amount"] = $row["amount"];
      $frm["posted"] = $row["posted"];
      $frm["referenceid "] = $row["referenceid"];
	}
   else{
      $frm["id"] = "0";
      $frm["journalid"] = "";
      $frm["ledgerid"] = "";
      $frm["accountid"] = "";
      $frm["entereddate"] = "";
      $frm["description"] = "";
      $frm["debit"] = "N";
      $frm["amount"] = "";
      $frm["posted"] = "N";
      $frm["referenceid "] = "";
   }
   return $frm;
}

function addAccount()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
   
	include("templates/payable.php");
}

function editAccount($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/payable.php");
}

function browseAccount($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";

	include("templates/payable.php");
}

function insertAccount($frm) 
{
	$qry=sprintf(account_payable_qry5,$frm["journalid"],$frm["ledgerid"],$frm["accountid"],
      $frm["entereddate"],$frm["description"],$frm["debit"],$frm["amount"],$frm["posted"],
      $frm["referenceid "]);
   $_SESSION['VxCFG']->dbh->StartTrans();
	$_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=payable&err=insert");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
}

function commitAccount($frm) 
{
   $qry=sprintf(aaccount_payable_qry6,$frm["journalid"],$frm["ledgerid"],$frm["accountid"],
      $frm["entereddate"],$frm["description"],$frm["debit"],$frm["amount"],$frm["posted"],
      $frm["referenceid "], $frm['id']);
   $_SESSION['VxCFG']->dbh->StartTrans(); 
	$_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=payable&err=commit");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
}

function chkdelAccount($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/accounts.php");
}

function deleteAccount($id) 
{
   $qry=sprintf(account_payable_qry7,$id);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function fillHeadingCombo($a, $id)
{
   $acc=new Account();
   $acc->HeadingCombo($a, $id, "title");
}

function fillParentCombo($a, $id)
{
   $acc=new Account();
   $acc->Combo($a, $id, "parentid");
}

function LedgerCombo($a, $id)
{
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"ledgerid\" class=\"combo\">\n";
      if($id==0){
         echo "<option selected value=\"0\">". _("None") ."</option>\n";
      }
      else{
         echo "<option value=\"0\">". _("None") ."</option>\n";
      }
      $result=$_SESSION['VxCFG']->dbh->Execute(ledgerm_ledger_qry1);
	   while($row = $result->FetchRow()){
			$boo=$row["id"];
		   $poo=$row["name"];
		   if($id==$boo){
			   echo "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		echo "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
		print "</select>\n";
   }
   else{
      $qry=sprintf(ledgerm_ledger_qry3, $id); 
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}

function AccountCombo($a, $id) 
{
   $acc=new Account();
   $acc->Combo($a, $id, 'accountid');
}

function DateControl($a, $d)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
	   $result=db_query(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->datecontrol($a, "");
}

function listAccount()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(account_payable_qry2, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no payable accounts defined")."</td></td></table>\n";
      return;
   }

   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='arriveddate'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Date Arrived")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Date Arrived")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=arriveddate\">"._("Date Arrived")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='arriveddate'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='duedate'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Date Due")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Date Due")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=aduedate\">"._("Date Due")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='duedate'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='purchasenumber'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("PO Number")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("PO Number")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=purchasenumber\">"._("PO Number")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='purchasenumber'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Supplier")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Supplier")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Supplier")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='amount'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Amount")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Amount")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=amount\">"._("Amount")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='amount'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";

	while($row = $result->FetchRow()){
      echo "<tr>\n";
      if($row["due"] <= 0){
         echo "<td class=\"listdata\">".$row['arriveddate']."</td>\n";
		   echo "<td class=\"listdata\">".$row['duedate']."</td>\n";
         echo "<td class=\"listdata\">".$row['purchasenumber']."</td>\n";
         echo "<td class=\"listdata\">".$row['name']."</td>\n";
         echo "<td class=\"listdata\">".$row['amount']."</td>\n"; 
         echo "</td><td class=\"listdata\">";
      }
      else{
         echo "<td class=\"listdataupdate\">".$row['arriveddate']."</td>\n";
		   echo "<td class=\"listdataupdate\">".$row['duedate']."</td>\n";
         echo "<td class=\"listdataupdate\">".$row['purchasenumber']."</td>\n";
         echo "<td class=\"listdataupdate\">".$row['name']."</td>\n"; 
         echo "<td class=\"listdataupdate\">".$row['amount']."</td>\n"; 
         echo "</td><td class=\"listdataupdate\">";
      }

		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"payable.php?action=browse&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"payable.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"payable.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"payable.php?action=browse&id=$wibbler\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"payable.php?action=edit&id=$wibbler\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"payable.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
	}
	echo "</table>";
}

?>
