<?php
/*
tax.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(4);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){   // session timeout...
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Tax Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Tax Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(accountm_tax_qry1, "taxrate")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addTax();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseTax($_REQUEST['id']);
         break;
      }
		browseTax($_POST['id']);
		break;

	case "edit" :
		editTax($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelTax($_REQUEST['id']);
      }
      else{
         deleteTax($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listTax();
      }
      break;  
	
   case "cfmdelete" :
      deleteTax($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listTax();
		break;
      
	case "add" :
		insertTax($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listTax();
		break;

	case "commit" :
		commitTax($_POST);
		listTax();
		break;
      
   case "duplicate" :
      $id=duplicateTax($_REQUEST['id']);
      editTax($id);
      break;

	case "list":
	default :
		listTax();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(accountm_tax_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"] = 0;
	$frm["taxid"]="";
	$frm["accountid"] = "";
	$frm["rate"] = "0.00";
	$frm["onmenu"] = "N";
   
   return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(accountm_tax_qry2, $id);
   }
   else{
      $qry=sprintf(accountm_tax_qry3, $id);
   }
   
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
	
	$frm["id"] = $id;
   $frm["taxid"]=$row["taxid"];
	$frm["accountid"] = $row["accountid"];
	$frm["onmenu"] = $row["onmenu"];
   $frm["rate"] = $row["rate"];
   
   return $frm;
}

function addTax()
{
   $frm=clearform();
	$frm["newaction"] = "add";

	include("templates/tax.php");
}

function editTax($id) 
{  
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";

	include("templates/tax.php");
}

function browseTax($id) 
{
   $frm=fillform($id, true);
	$frm["newaction"] = "commit";
   
	include("templates/tax.php");
}

function insertTax($frm) 
{
	if(!isset($frm['onmenu']))
		$frm['onmenu'] = 'N';
	else
		$frm['onmenu'] = 'Y';
   
   $qry=sprintf(accountm_tax_qry4, $frm['accountid']);
	$accid = $_SESSION['VxCFG']->dbh->Execute($qry");
	if(!$accid || ! ($nrow = $accid->FetchRow()))
		die('You must enter the account in Accounts first!');
	if($frm['rate'] >= 1)
		$frm['rate']=($frm['rate']/100);
   $qry=sprintf(accountm_tax_qry5, $frm['accountid'],$frm['rate'],$frm['onmenu']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
   
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   return $row[0];
}

function commitTax($frm) 
{
/*
	if ( ! isset($frm['OnMenu']) )
		$frm['OnMenu'] = 'N';
	else
		$frm['OnMenu'] = 'Y';
	$accid = db_query("select * from account where accountnumber='$frm[accountID]'");
	if (!$accid || ! ($nrow = db_fetch_array($accid)))
		die('You must use a valid Account Number!');*/
	if($frm['rate'] >= 1)
		$frm['rate']=($frm['rate']/100);
   $qry=sprintf(accountm_tax_qry6, $frm['accountid'], $frm['rate'], yesno(isset($frm['onmenu'])), $frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function chkdelTax($id)
{
   $frm=fillform($id, false);
	$frm["newaction"] = "cfmdelete";

	include("templates/tax.php");
}

function deleteTax($id)
{
   $qry=sprintf(accountm_tax_qry7, $id);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function fillAccountCombo($a, $id)
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function listTax()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(accountm_tax_qry8, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no tax rates defined")."</td></td></table>\n";
      return;
   }

   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";

	if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='rate'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Rate")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Rate")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=rate\">"._("Rate")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='rate'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='onmenu'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("On Menu")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("On Menu")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=onmmenu\">"._("On Menu")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='onmenu'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      $qry=sprintf(accountm_tax_qry9, $row['accountid']);
      $hresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      $hrow = $hresult->FetchRow();
      
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">".$hrow['name']."</td>";
   		echo "<td class=\"listdata\">".$row['rate']."</td><td class=\"listdata\">";
         CheckBox("browse", "", $row['onmenu']);
         echo "</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$hrow['name']."</td>";
   		echo "<td class=\"listdataeven\">".$row['rate']."</td><td class=\"listdataeven\">";
         CheckBox("browse", "", $row['onmenu']);
         echo "</td><td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"tax.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"tax.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"tax.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"tax.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"tax.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"tax.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
