<?php
/*
misinstall.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(3);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(!isset($_REQUEST['action'])){
   $action='list';
}
else{
   $action=$_REQUEST['action'];
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Module Install"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Module Install");
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
/*
	case "install":
		select();
		break;
      
   case "confirminstall":
      install($_POST);
      break;
   
   case "update":
		selectupdate();
		break;
  
   case "updateconfirm":
		update();
		break;
		
	case "uninstall":
		uninstall();
		break;
   
   case "uninstallall":
		uninstallall();
		break;
      */
   default:
      $_POST["action"]="none";
      echo "<table><tr><td align=\"left\">\n";
      echo "<br><br>The installer is tied to the VxMIS SOAP server, which is in test.<br>\n";
      echo "It will be available in the final release.</td></tr></table>";
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function select()
{
   $frm["newaction"]="confirminstall";
   $frm["heading"]="Select Module Installer";
   include("templates/misfileselect.php");
}

function selectupdate()
{
}

function uninstall()
{
}

function uninstallall()
{
}

function install($frm)
{
   if(!isset($frm['filename'])){
      return;
   }
   
   if(!$fp=fopen($frm['filename'], "r")){
      return;
   }
   while(!feof($fp)){
	   $line = fgets($fd, 1024);
      if(!$line) break;
      $line=ltrim($line);
      if($line[0]=='#') continue;
      $line=preg_replace("#+", "", $line);
      $line=rtrim($line);
	   $linebits = explode('=', $line);
	   switch($linebits[0]){
      case 'name':
         $name=$linebits[1];
         break;
         
      case 'title':
         $title=$linebits[1];
         break;
         
      case 'description':
         $description=$linebits[1];
         break;
      
      case 'author':
         $author=$linebits[1];
         break;
         
      case 'version':
         $version=$linebits[1];
         break;
      
      case 'parentmodule':
         $parentmodule=$linebits[1];   // blank for root
         break;
         
      case 'parentversion':
         $parentversion=$linebits[1];   // blank for root
         break;
         
      case 'created':
         $created=$linebits[1];
         break;
         
     case 'modified':
         $modified=$linebits[1];
         break;

      case 'basedir':
         $basedir=$linebits[1];
         break;
         
      case 'files':
         $files=$linebits[1];
         break;
      
      case 'templates':
         $templates=$linebits[1];
         break;
         
      case 'help':
         $help=$linebits[1];
         break;
         
      case 'lang':
         $lang=$linebits[1];
         break;
         
      case 'sql':
         $sql=$linebits[1];
         break;
         
      case 'menuimages':
         $menuimages=$linebits[1];
         break;
         
      case 'images':
         $images=$linebits[1];
         break;
         
      case 'menuimages':
         $menuimages=$linebits[1];
         break;
      
      case 'parentorder':
         $parentorder=$linebits[1];
         break;
         
      case 'parententry':
         $parententry=$linebits[1];
         break;
         
      case 'requiremodule':
         $requiresmodule=$linebits[1];
         break;
         
      case 'requires':
         $requires=$linebits[1];
         break;
   
      case 'enable':
         $enable=$linebits[1];
         break;
         
      case 'initialperms':
         $initialperms=$linebits[1];
         break;

      case 'db_schema':
         $db_schema_file=$linebits[1];
         break;
         
      case 'db_system':
         $db_system=$linebits[1];
         break;
      
      case 'db_menu':
         $db_menu=$linebits[1];
         break;
      
      case 'db_sampledata':
         $db_sampledata=$linebits[1];
         break;
      }
   }
   
   // check parent exists...
   if(isset($parentmodule)){
      $result=db_query("select moduleid, version from mismodule where title='$parentmodule'");
      if($row = $result->FetchRow()){
         echo "<br><br><center><h2>Installing $name module : under $parentmodule.</h2></center><br>\n";
      }
      else{
         echo "<br><br><center><h2>This Module requires a the module $parentmodule before it
         can be installed.</h2></center>";
         return;
      }
   }
   else{
      echo "<br><br><center><h2>Installing $name module : under base.</h2></center><br>\n";
   }
   if(isset($parentversion)){
      if($vererr=version_check($parentmodule, $parentversion)){
         // version error
         echo "<br><br><center><h2>The parent version you have installed is less than or 
         equal to the required version.</h2></center>";
         return;
      }
      else{
         echo "<br><br><center><h2>The proposed parent install has no name, or version information.</h2></center>";
         return;
      }
   }
   echo "<center><h2>$parentmodule version : OK.</h2></center><br>\n";
   
   if(isset($title) && isset($version)){
      if($vererr=version_check($title, $version)){
         // version error
         echo "<br><br><center><h2>The version you have installed is less than or 
         equal to the proposed module you want to install.</h2></center>";
         return;
      }
   }
   else{
      echo "<br><br><center><h2>The proposed install has no name, or version information.</h2></center>";
      return;
   }
   
   $result=db_query("select version from mismodule where title='$title'");
   if($row = db_fetch_array($result)){
      echo "Overwriting Old Version: ".$row[0]."<br>\n";
      echo "With New Version: ".$version."<br>\n";
   }
   else{
      echo "Installing Version: ".$version."<br>\n";
   }
   
   // make sure essential files exist
   
   // check module deps
   
   // pack arrays from comma sep file and install files
   if(isset($files)){
      $install_files=array();
      $file_list = explode(',', $files);
      foreach($files_list as $filename){
         array_push($install_files, trim($filename));
      }
   }
   if(isset($images)){
      $install_images=array();
      $image_list = explode(',', $images);
      foreach($image_list as $imagename){
         array_push($install_images, trim($imagename));
      }
   }
   if(isset($menuimages)){
      $install_menuimages=array();
      $menuimage_list = explode(',', $menuimages);
      foreach($menuimage_list as $menuimagename){
         array_push($install_menuimages, trim($menuimagename));
      }
   }
   file_install($install_files, $install_images, $install_menuimages);
   
   // install the queries file(s)
   if(isset($mysql_file)){
   }
   if(isset($pgsql_file)){
   }
   
   // update lib/sql/mysql.php file (and/or pgsql.php file) - simple append to file...
   
   // load database updates file and dump into db
   
   // penultimately install the menu list, and update the parent menu entry(ies) based on order
   
   // perhaps fix up for bad order entries compared to db?
   
   // reload the main page to refresh menu...
}

function installer_parse($install_file)
{
   $c=new conffile($install_file);
   $s=$c->enum_sections();
   
   foreach($s as $section){       
      $k=$c->enum_keys($section);
      foreach($k as $key){
         $v=$c->get_key($section, $key);
         if($v!=false){
         }
         else{
         }
      }
   }
}

// from the parent's parent increment all id's recursively (reverse traverse)
function shiftparentids($parent_id, $new_id)
{
}

// under the parent it's a simple recursion (again reversed)
function recurse_shiftparentids($parent_id, $new_id)
{
}

function version_check($title, $version)
{
   $result=db_query("select version from mismodule where title='$title'");
   if($row = db_fetch_array($result)){
      $vbits = explode(".", $row[0]);
      $nvbits = explode(".", $version);
      if($nvbits[0] > $vbits[0]) return 0;
      else{
         if($nvbits[0] == $vbits[0]){
            if($nvbits[1] > $vbits[1]) return 0;
            else{
               if($nvbits[2] > $vbits[2]) return 0;
               else{
                  if($nvbits[3] > $vbits[3]) return 0;
                  else{
                     if($nvbits[4] > $vbits[4]) return 0;
                     else return 2;
                  }
               }
            }
         }
      }
   }
   return 1;
}

function file_grepper($file, $value)
{
   // regexp it...
   return false;
}

function file_install($files, $images, $menuimages)
{
   foreach($files as $filename){
      if(!copy($filename, $_SESSION['VxCFG']->dirroot.$basename.$filename)){
         return false;
      }
      echo "installed file : ".$_SESSION['VxCFG']->dirroot.$basename.$filename."<br>\n";
   }
   
   foreach($images as $filename){
      if(!copy($filename, $_SESSION['VxCFG']->imagedir.$filename)){
         return false;
      }
      echo "installed file : ".$_SESSION['VxCFG']->imagedir.$filename."<br>\n";
   }
   
   foreach($menuimages as $filename){
      if(!copy($filename, $_SESSION['VxCFG']->menuimagedir.$filename)){
         return false;
      }
      echo "installed file : ".$_SESSION['VxCFG']->menuimagedir.$filename."<br>\n";
   }
   
   return true;
}

function dir_install($basename)
{
   if(!mkdir($_SESSION['VxCFG']->dirroot.$basename, "0764")){
      return false;
   }
   echo "created directory: ".$_SESSION['VxCFG']->dirroot.$basename."<br>\n";
   if(!mkdir($_SESSION['VxCFG']->dirroot.$basename."/templates", "0764")){
      return false;
   }
   echo "created directory: ".$_SESSION['VxCFG']->dirroot.$basename."/templates<br>\n";
   if(!mkdir($_SESSION['VxCFG']->dirroot.$basename."/help", "0764")){
      return false;
   }
   echo "created directory: ".$_SESSION['VxCFG']->dirroot.$basename."/help<br>\n";
   
   return true;
}

function adjustlang($dir, $value)
{
   if(file_exists($dir."/lib/lang")){
      if(($fd=fopen($dir."/db/db.mysql", 'r'))){
         while(($buffer = fgets($fd, 1024))){
            $buffer=trim($buffer);
            if($l==$buffer){
               
            }
         }
      }
   }
   
   return true;
}

function db_update($dir, $value)
{
   if(file_exists($dir."/db/db.mysql")){
      exec("mysql -u=".$_SESSION['VxCFG']->dbuser." -p=".$_SESSION['VxCFG']->dbpass." ".$_SESSION['VxCFG']->dbname." < ".$dir."/db/db.mysql");
   }
}

function parse_dir($dir)
{
   // parse dirs for module integrity
   if(($handle=opendir($dir))){
      while(false!==($file=readdir($handle))){ 
         if(is_dir($file)){
            if($file=='lib'){
            }
         }
         else if($t==$file){
         }
      }
   }
   closedir($handle); 
}

?>
