<?php
/*
mismenu.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(2);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(!isset($_REQUEST['action'])){
   $action='list';
}
else{
   $action=$_REQUEST['action'];
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("MIS Menu Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("MIS Menu Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(misadmin_mismenu_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
   case "browse":
      if(isset($_REQUEST['id'])){
         $id=$_SESSION["pageindex"]->browse($_REQUEST['id']);
         browseMenu($id);
         break;
      }
      $id=updateNav($_POST);
		browseMenu($id);
		break;

	case "edit" :
		editMenu($_REQUEST['id']);
		break;
      
   case "commit" :
		commitMenu($_POST);
      listModule();
		break;
   
   case "chmodule":
      ModuleChange($_REQUEST['id']);
      break;
      
	case "list":
	default :
      $id=updateNav($_POST);
		listMenu();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(misadmin_mismenu_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm['id']=0;
   $frm['menuid']=0;
	$frm['parentid']=0;
	$frm['sortorder']=0;
	$frm['name']="";
	$frm['moduleid']=0;
	$frm['phpfile']="";
	$frm['icon']="";
	$frm['type']="";
   
	return $frm;
}
function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(misadmin_mismenu_qry2, $id);
   }
   else{
      $qry=sprintf(misadmin_mismenu_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm['id']=$row['id'];
   $frm['menuid']=$row['menuid'];
   $frm['parentid']=$row['parentid'];
	$frm['sortorder']=$row['sortorder'];
	$frm['name']=$row['name'];
	$frm['moduleid']=$row['moduleid'];
	$frm['phpfile']=$row['phpfile'];
	$frm['icon']=$row['icon'];
	$frm['type']=$row['type'];
   
   $qry=sprintf(misadmin_mismenu_qry6, $frm['moduleid']);
	$result=db_query($qry);
	$row = $result->FetchRow();
   $frm['module']=$row['name'];

	return $frm;
}

function editMenu($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
	
	include("templates/mismenu.php");
}

function browseMenu($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/mismenu.php");
}

function commitMenu($frm) 
{
   $qry=sprintf(misadmin_mismenu_qry5, $frm['menuid'],$frm['parentid'],$frm['sortorder'],$frm['name'],
	   $frm['moduleid'],$frm['phpfile'],$frm['icon'],$frm['type'],$frm['id']);
      
   db_query($qry);
}

function ModuleChange($id) 
{
}

function menutypeCombo($a, $t) 
{
   $typelist = array('S'=>_("System"), 'U'=>_("User"), 'H'=>_("Hidden"));
   
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"type\">\n";
	   foreach($typelist as $typeid=>$type){
	      echo "<option ";
   	   if($t==$typeid)
	         echo "selected ";
	      echo "value='$typeid'>$type</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $typelist[$t];
   }
}

function listMenu()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(misadmin_mismenu_qry7, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
	$result=db_query($q);
   $_REQUEST['action']="list";
   
   
   echo "<table class=\"listtable\">\n";
   if(db_num_rows($result)==0){
      echo "<tr><td colspan=\"2\">"._("The are no defined menus")."</td></td></table>\n";
      exit;
   }
   
	echo "<tr><td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='version'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("File")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("File")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=version\">"._("File")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='version'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='enabled'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Type")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Type")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=enabled\">"._("Type")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='enabled'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
	while($row = $result->FetchRow()){
      echo "<tr><td class=\"listdata\">".$row['name']."</td>\n";
      echo "<td class=\"listdata\">".$row['phpfile']."</td>\n";
      echo "<td class=\"listdata\">";
      menutypeCombo("browse", $row['type']) ;
		echo "</td><td class=\"listdata\">";
		$wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"mismenu.php?action=browse&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"mismenu.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"mismenu.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"mismenu.php?action=browse&id=$wibbler\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"mismenu.php?action=edit&id=$wibbler\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"mismenu.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
	}
	echo "</table>";
}

?>
