<?php
/*
mismodule.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){   // session timeout...
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("MIS Module Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("MIS Module Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(misadmin_mismodule_qry1, "mismodule")){
   $_SESSION["pageindex"]->setnum(CountNum());
}


if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
   case "clear":
		addModule();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseModule($_REQUEST['id']);
         break;
      }
		browseModule($_POST['id']);
		break;

	case "edit" :
		editModule($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelModule($_REQUEST['id']);
      }
      else{
         deleteModule($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listModule();
      }
      break;  
	
   case "cfmdelete" :
      deleteModule($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listModule();
		break;
      
	case "add" :
		insertModule($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitModule($_POST);
      listModule();
		break;
      
	case "list":
	default :
		listModule();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(misadmin_mismodule_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm['id']=0;
   $frm['parentid']=0;
   $frm['sortorder']=0;
   $frm['version']=0;
   $frm['name']="";
   $frm['title']="";
   $frm['author']="";
   $frm['cmid']="";
   $frm['description']="";
   $frm['basedir']="";
   $frm['icon']="";
   $frm['type']="";
   $frm['enabled']="N";

	return $frm;
}
function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(misadmin_mismodule_qry2, $id);
   }
   else{
      $qry=sprintf(misadmin_mismodule_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm['id']=$row['id'];
   $frm['parentid']=$row['parentid'];
   $frm['sortorder']=$row['sortorder'];
   $frm['version']=$row['version'];
   $frm['name']=$row['name'];
   $frm['title']=$row['title'];
   $frm['author']=$row['author'];
   $frm['cmid']=$row['cmid'];
   $frm['description']=$row['description'];
   $frm['basedir']=$row['basedir'];
   $frm['icon']=$row['icon'];
   $frm['type']=$row['type'];
   $frm['enabled']=$row['enabled'];

	return $frm;
}

function addModule()
{
   $frm=clearForm();
	$frm["newaction"] = "add";

	include("templates/mismodule.php");
}

function editModule($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
	
	include("templates/mismodule.php");
}

function browseModule($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/mismodule.php");
}

function chkdelModule($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/mismodule.php");
}

function deleteModule($id) 
{
   //$qry=sprintf(misadmin_mismodule_qry10, $id);
   //$_SESSION['VxCFG']->dbh->Execute($qry);
}

function insertModule($frm) 
{
   /*
   $qry=sprintf(misadmin_mismodule_qry8, 0, $frm['parentid'],$frm['sortorder'],$frm['version'],$frm['name'],$frm['title'],$frm['author'],
   $frm['cmid'],$frm['description'],$frm['basedir'],$frm['icon'],$frm['type'],$frm['enabled']);
   
	$_SESSION['VxCFG']->dbh->Execute($qry);
   $frm["newaction"] = "commit";
   
	include("templates/mismodule.php");*/
}

function commitModule($frm) 
{
   $qry=sprintf(misadmin_mismodule_qry9, $frm['parentid'],$frm['sortorder'],$frm['version'],$frm['name'],$frm['title'],$frm['author'],
   $frm['cmid'],$frm['description'],$frm['basedir'],$frm['icon'],$frm['type'],YN($frm['enabled']),$frm['id']);
   
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function moduletypeCombo($a, $t) 
{
   $typelist = array('S'=>_("System"), 'U'=>_("User"), 'H'=>_("Hidden"));
   
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"type\">\n";
	   foreach($typelist as $typeid=>$type){
	      echo "<option ";
   	   if($t==$typeid)
	         echo "selected ";
	      echo "value='$typeid'>$type</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $typelist[$t];
   }
}

function parentCombo($a, $t) 
{
   if($a=="commit" || $a=="add"){
      $result=$_SESSION['VxCFG']->dbh->Execute(misadmin_mismodule_qry7);      
	   echo "<select name=\"parentid\">\n";
      if($t==0){
         echo "<option selected value=\"0\">Root Module</option>\n";
      }
      if(!$result){
         echo "</select>\n";
         return;
      }
	   while($row = $result->FetchRow()){
	      echo "<option ";
   	   if($t==$row['id'])
	         echo "selected ";
	      echo "value='".$row['id']."'>".$row['name']."</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      $qry=sprintf(misadmin_mismodule_qry3, $t);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo $row['name'];
      }
      else{
         echo _("Not Set");
      }
   }
}

function PageList($a, $id) 
{
   $qry=sprintf(misadmin_mismodule_qry6, $id);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   echo "<table border=\"0\" cellpadding=\"0\" width=\"100%\">\n";
   echo "<tr><th class=\"ttinsert\" colspan=\"4\">Pages</th>\n</tr>\n<tr>";
   echo "<th class=\"tinsert\">"._("Name")."</th>\n<th class=\"tinsert\">"._("Icon")."</th>\n";
   echo "<th class=\"tinsert\">"._("File")."</th>\n<th class=\"tinsert\">"._("Type")."</th></tr>\n";
   $c=1;
	while($row = $result->FetchRow()){
      if($c%2==0){
         echo "<tr class=\"tihilite\">\n";
      }
      else{
         echo "<tr class=\"tinormal\">\n";
      }
      if($row['icon']==""){
         $i="None";
      }
      else{
         $i=$row['icon'];
      }
      echo "<td class=\"tinsert\">".$row['name']."</td>\n";
      echo "<td class=\"tinsert\">".$i."</td>\n";
      echo "<td class=\"tinsert\">".$row['phpfile']."</td>\n<td class=\"tinsert\">";
      moduletypeCombo("browse", $row['type']);
      echo "</td></tr>\n";
      $c++;
   }
   echo "</table>\n";
}

function listModule()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(misadmin_mismodule_qry4, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<table class=\"listtable\">\n";
   if(db_num_rows($result)==0){
      echo "<tr><td colspan=\"5\">"._("The are no modules defined ")."</td></td></table>\n";
      return;
   }
   
	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='sortorder'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Sort Order")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Sort Order")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=sortorder\">"._("Sort Order")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='sortorder'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='version'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Version")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Version")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=version\">"._("Version")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='version'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='enabled'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Enabled")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Enabled")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=enabled\">"._("Enabled")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='enabled'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
         echo "<tr class=\"listdata\">\n";
         echo "<td class=\"listdata\">".$row['name']."</td>\n";
         echo "<td class=\"listdata\">".$row['sortorder']."</td>\n";
         echo "<td class=\"listdata\">".$row['version']."</td>\n";
         echo "<td class=\"listdata\">";
         if($row['enabled']=='S'){
            echo _("System");
         }
         else{
            CheckBox("browse", "enabled", $row['enabled'], "");
         }
	   	echo "</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\">\n";
         echo "<td class=\"listdataeven\">".$row['name']."</td>\n";
         echo "<td class=\"listdataeven\">".$row['sortorder']."</td>\n";
         echo "<td class=\"listdataeven\">".$row['version']."</td>\n";
         echo "<td class=\"listdataeven\">";
         if($row['enabled']=='S'){
            echo _("System");
         }
         else{
            CheckBox("browse", "enabled", $row['enabled'], "");
         }
	   	echo "</td><td class=\"listdataeven\">";
      }
      
		$wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"mismodule.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"mismodule.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"mismodule.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"mismodule.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"mismodule.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"mismodule.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
