<?php
/*
mismodule.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/country.php");
require_once($_SESSION['VxCFG']->libdir."/currency.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
$_SESSION['vxmisuser']->SetModule(1);

if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(2);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Mis Global Preferences"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Mis Global Preferences");
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "commit" :
		commitDef($_POST);
      listDef();
		break;
      
	default :
		listDef();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(misadmin_mispref_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function commitDef($frm) 
{
   $s=$frm['starttimehour'].":".$frm['starttimeminute'].":00";
   $e=$frm['endtimehour'].":".$frm['endtimeminute'].":00";
   $qry=sprintf(misadmin_mispref_qry3, $frm['listpagesize'],'misdefaultpagesize');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, $frm['theme'],'mistheme');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, $frm['language'], 'mislanguage');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, $frm['dateformat'], 'misdateformat');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, $frm['timeformat'], 'mistimeformat');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, $s, 'mistodaystarttime');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, $e, 'mistodayendtime');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, $frm['firstdayofweek'],'misfirstdayofweek');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, $frm['firstweekofyear'],'misfirstweekofyear');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, YN($frm['showhelp']),'misonlinehelp');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, YN($frm['confirmdelete']), 'misconfirmdelete');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, YN($frm['showimages']),'misinlineimages');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, $frm['defaultstartpage'],'misdefaultstartpage');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, $frm['num_dispmodule'],'num_dispmodule');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, $frm['showmodulefooterlinks'],'showmodulefooterlinks');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry3, $frm['num_last_viewed'],'num_last_viewed');
   $_SESSION['VxCFG']->dbh->Execute($qry);
      
   $qry=sprintf(misadmin_mispref_qry4, $frm['basedir'],'basedir');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry4, $frm['sessiontimeout'], 'sessiontimeout');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry4, $frm['defaultimgx'], 'defaultimgx');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry4, $frm['defaultimgy'], 'defaultimgy');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry4, $frm['pagesize'], 'pagesize');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry4, $frm['pdfpagesize'], 'pdfpagesize');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry4, $frm['wwwroot'], 'wwwroot');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry4, $frm['accountingmethod'], 'accountingmethod');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry4, $frm['defaultcurrency'], 'defaultcurrency');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry4, $frm['defaultcountry'], 'defaultcountry');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry4, $frm['printfolder'], 'printfolder');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(misadmin_mispref_qry4, $frm['autoprint'], 'autoprint');
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function ThemeCombo($a, $t)
{
   // parse theme dirs and files in /style/XXX/theme
   echo "<select name=\"theme\">\n";
   if($handle=opendir($_SESSION['VxCFG']->dirroot."/style")){
      while(false!==($file=readdir($handle))){ 
         if(is_dir($file)) continue;
         if($t==$file){
            echo "<option value=\"$file\" selected>$file</option>\n";
         }
         else{
            echo "<option value=\"$file\">$file</option>\n";
         }
      }
   }
   echo "</select>\n";
   closedir($handle); 
}

function PaperSizeCombo($a, $s)
{
   echo "<select name=\"pagesize\">\n";
   if($s=='A3') echo "<option value=\"A3\" selected>A3</option>\n";
   else echo "<option value=\"A3\">A3</option>\n";
   if($s=='A4' || $s='') echo "<option value=\"A4\" selected>A4</option>\n";
   else echo "<option value=\"A4\">A4</option>\n";
   if($s=='A5') echo "<option value=\"A5\" selected>A5</option>\n";
   else echo "<option value=\"A5\">A5</option>\n";
   if($s=='Letter') echo "<option value=\"Letter\" selected>Letter</option>\n";
   else echo "<option value=\"Letter\">Letter</option>\n";
   if($s=='Letter') echo "<option value=\"Legal\" selected>Legal</option>\n";
   else echo "<option value=\"Legal\">Legal</option>\n";
   echo "</select>\n";
}

function PdfPaperSizeCombo($a, $s)
{
   echo "<select name=\"pdfpagesize\">\n";
   if($s=='A3') echo "<option value=\"A3\" selected>A3</option>\n";
   else echo "<option value=\"A3\">A3</option>\n";
   if($s=='A4' || $s='') echo "<option value=\"A4\" selected>A4</option>\n";
   else echo "<option value=\"A4\">A4</option>\n";
   if($s=='A5') echo "<option value=\"A5\" selected>A5</option>\n";
   else echo "<option value=\"A5\">A5</option>\n";
   if($s=='Letter') echo "<option value=\"Letter\" selected>Letter</option>\n";
   else echo "<option value=\"Letter\">Letter</option>\n";
   if($s=='Letter') echo "<option value=\"Legal\" selected>Legal</option>\n";
   else echo "<option value=\"Legal\">Legal</option>\n";
   echo "</select>\n";
}

function AccCombo($a, $v)
{
   echo "<select name=\"accountingmethod\">\n";
   if($s=='cash') echo "<option value=\"cash\" selected>"._("Cash")."</option>\n";
   else echo "<option value=\"cash\">"._("Cash")."</option>\n";
   if($s=='accrual') echo "<option value=\"accrual\" selected>"._("Accrual")."</option>\n";
   else echo "<option value=\"accrual\">"._("Accrual")."</option>\n";
   echo "</select>\n";
}

function CurrencyCombo($a, $id)
{
   $c=new Currency();
   $c->Combo($a, $id, "defaultcurrency");
}

function CountryCombo($a, $id)
{
   $c=new Country();
   $c->Combo($a, $id, "defaultcountry");
}

function LangCombo($a, $l)
{
   // open available languages from file /lib/lang/list
   if(file_exists($_SESSION['VxCFG']->libdir."/lang")){
      echo "<select name=\"language\">\n";
      if(($fd=fopen($_SESSION['VxCFG']->libdir."/lang", 'r'))){
         while(($buffer = fgets($fd, 128))){
            $buffer=trim($buffer);
            $lang=explode(":", $buffer);
            $lc=trim($lang[0]);
            $desc=trim($lang[1]);
            if($l==$lc){
              echo "<option value=\"$lc\" selected>$lc - $desc</option>\n";
            }
            else{
               echo "<option value=\"$lc\">$lc - $desc</option>\n";
            }
         }
         fclose ($fd);
      }
      echo "</select>\n";
   }
}

function TimeControl($a, $t)
{
   $ts=new TimeDate($t);
   if($a=="start"){
      $ts->timecontrol("commit", "starttime");
   }
   else{
      $ts->timecontrol("commit", "endtime");
   }
}

function WeekControl($a, $w)
{
   echo "<select name=\"firstweekofyear\">\n";
   for($i=1; $i < 53; $i++){
      if($i==$w){
         echo "<option value=\"$i\" selected>$i</option>\n";
      }
      else{
         echo "<option value=\"$i\">$i</option>\n";
      }
   }
   echo "</select>\n";
}

function DayControl($a, $d)
{
   echo "<select name=\"firstdayofweek\">\n";
   for($i=5; $i < 12; $i++){
      $x=$i-5;
      if($x==$d){ 
         echo "<option value=\"".$x."\" selected>".date("l", mktime(0, 0, 0, 9, $i, 2005))."</option>\n";
      }
      else{
         echo "<option value=\"".$x."\">".date("l", mktime(0, 0, 0, 9, $i, 2005))."</option>\n";
      }
   }
   echo "</select>\n";
}

function DefPageCombo($a, $d)
{
   echo "<select name=\"defaultstartpage\">\n";
   if($d=="main.php"){
      echo "<option value=\"main.php\" selected>"._("Information")."</option>\n";
   }
   else{
      echo "<option value=\"main.php\">"._("Information")."</option>\n";
   }
   
   if($d=="users/usertoday.php"){
      echo "<option value=\"users/usertoday.php\" selected>"._("Today")."</option>\n";
   }
   else{
      echo "<option value=\"users/usertoday.php\">"._("Today")."</option>\n";
   }
   echo "</select>\n";
}

function listDef()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(misadmin_mispref_qry5);
      
   while($row = $result->FetchRow()){
      switch($row['name']){
      case 'basedir':
         $frm['basedir']=$row['value'];
         break;
      case 'sessiontimeout':
         $frm['sessiontimeout']=$row['value'];
         break;
      case 'defaultimgx':
         $frm['defaultimgx']=$row['value'];
         break;
      case 'defaultimgy':
         $frm['defaultimgy']=$row['value'];
         break;
      case 'papersize':
         $frm['papersize']=$row['value'];
         break;
      case 'pdfpapersize':
         $frm['pdfpapersize']=$row['value'];
         break;
      case 'wwwroot':
         $frm['wwwroot']=$row['value'];
         break;
      case 'accountingmethod':
         $frm['accountingmethod']=$row['value'];
         break;
      case 'defaultcurrency':
         $frm['defaultcurrency']=$row['value'];
         break;
      case 'defaultcountry':
         $frm['defaultcountry']=$row['value'];
         break;
      case 'printfolder':
         $frm['printfolder']=$row['value'];
         break;
      case 'autoprint':
         $frm['autoprint']=$row['value'];
         break;
      }
   }
   
   $result=$_SESSION['VxCFG']->dbh->Execute(misadmin_mispref_qry2);
   
   while($row = $result->FetchRow()){
      switch($row['name']){
      case 'misdefaultpagesize':
         $frm['listpagesize']=$row['value'];
         break;
      case 'mistheme':
         $frm['theme']=$row['value'];
         break;
      case 'mislanguage':
         $frm['language']=$row['value'];
         break;
      case 'misdateformat':
         $frm['dateformat']=$row['value'];
         break;
      case 'mistimeformat':
         $frm['timeformat']=$row['value'];
         break;
      case 'mistodaystarttime':
         $frm['todaystarttime']=$row['value'];
         break;
      case 'mistodayendtime':
         $frm['todayendtime']=$row['value'];
         break;
      case 'misfirstdayofweek':
         $frm['firstdayofweek']=$row['value'];;
         break;
      case 'misfirstweekofyear':
         $frm['firstweekofyear']=$row['value'];;
         break;
      case 'misonlinehelp':
         $frm['showhelp']=$row['value'];
         break;
      case 'misconfirmdelete':
         $frm['confirmdelete']=$row['value'];
         break;
      case 'misinlineimages':
         $frm['showimages']=$row['value'];
         break;
      case 'misdefaultstartpage':
         $frm['defaultstartpage']=$row['value'];
         break;
      case 'numdispmodules':
         $frm['num_dispmodule']=$row['value'];
         break;
      case 'showmodulefooterlinks':
         $frm['showmodulefooterlinks']=$row['value'];
         break;
      case 'numlastviewed':
         $frm['num_last_viewed']=$row['value'];
         break;
      }
   }
   
	$frm["newaction"] = "commit";
   $_REQUEST["action"] = "commit";
	
	include("templates/misprefs.php");
}

?>
