<?php
/*
misupdate.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/nusoap/nusoap.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(3);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}
//print_r($_POST);
if(isset($_REQUEST['action'])){
   $action=$_REQUEST['action'];
}
else if(isset($_POST['action'])){
   $action=$_POST['action'];
}
else{
   $action='list';
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Mis Updates"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Mis Updates");
}

include($_SESSION['VxCFG']->styledir."/header.php");
flush();
switch($action){
   case "current":
      break;
   
   case "updatecfm":
      Update($_POST);
      break;
   
   case "browse":
      viewModule($_REQUEST['id']);
      break;
         
	case "list":
	default :
		listUpdate();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(misadmin_mismodule_qry2, $id);
   }
   else{
      $qry=sprintf(misadmin_mismodule_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();

	$frm['id']=$row['id'];
   $frm['parentid']=$row['parentid'];
   $frm['sortorder']=$row['sortorder'];
   $frm['version']=$row['version'];
   $frm['name']=$row['name'];
   $frm['title']=$row['title'];
   $frm['author']=$row['author'];
   $frm['cmid']=$row['cmid'];
   $frm['description']=$row['description'];
   $frm['basedir']=$row['basedir'];
   $frm['icon']=$row['icon'];
   $frm['type']=$row['type'];
   $frm['enabled']=$row['enabled'];

	return $frm;
}

function Update($frm)
{
   //$update=$frm['update'];
   //print_r($frm);
   //print_r($update);
   //$update=serialize($frm['update']);
   //foreach($update
}

function moduletypeCombo($a, $t) 
{
   $typelist = array('S'=>'System', 'U'=>'User', 'H'=>'Hidden');
   
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"type\">\n";
	   foreach($typelist as $typeid=>$type){
	      echo "<option ";
   	   if($t==$typeid)
	         echo "selected ";
	      echo "value='$typeid'>$type</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $typelist[$t];
   }
}

function PageList($a, $id) 
{
   $qry=sprintf(misadmin_misupdate_qry2, $id);
	$result=db_query($qry);
   echo "<table border=\"0\" cellpadding=\"0\" width=\"100%\">\n";
   echo "<tr><th class=\"ttinsert\" colspan=\"4\">Pages</th>\n</tr>\n<tr>";
   echo "<th class=\"tinsert\">"._("Name")."</th>\n<th class=\"tinsert\">"._("Icon")."</th>\n";
   echo "<th class=\"tinsert\">"._("File")."</th>\n</tr>\n";
   $c=1;
	while($row = $result->FetchRow()){
      if($c%2==0){
         echo "<tr class=\"tihilite\">\n";
      }
      else{
         echo "<tr class=\"tinormal\">\n";
      }
      if($row['icon']==""){
         $i="None";
      }
      else{
         $i=$row['icon'];
      }
      echo "<td class=\"tinsert\">".$row['name']."</td>\n";
      echo "<td class=\"tinsert\">".$i."</td>\n";
      echo "<td class=\"tinsert\">".$row['phpfile']."</td>\n<td class=\"tinsert\">";
      //moduletypeCombo("browse", $row['type']);
      echo "</td></tr>\n";
      $c++;
   }
   echo "</table>\n";
}

function viewModule($id)
{
   $frm=fillForm($id, false);
   $frm['newaction']='none';
   include('templates/misupdate.php');
/*
   $ret=GetMenuList($id);
   $frm['id']=$row['id'];
   $frm['moduleid']=$row['moduleid'];
   $frm['version']=$row['version'];
   $frm['name']=$row['name'];
   $frm['title']=$row['title'];
   $frm['author']=$row['author'];
   $frm['cmid']=$row['cmid'];
   $frm['description']=$row['description'];
   $frm['basedir']=$row['basedir'];
   $frm['icon']=$row['icon'];
   $frm['type']=$row['type'];
   $frm['enabled']=$row['enabled'];*/
   //print_r($ret);
}

function GetMenuList($moduleid)
{
   $soapy=new soapclient('http://soap.bananahead.com/vxmis/module.php');
   if($soapy->getError()){
      echo "Constructor Error";
      exit;
   }
   
   $result = $soapy->call('getMenuList', array('moduleid' => $moduleid));
   
   if($soapy->fault){
      echo '<p><b>Fault: ';
      print_r($result);
      echo '</b></p>';
      return array('version' => '-1');
   }
   //echo '<h2>Request</h2>';
   //echo '<pre>' . htmlspecialchars($soapy->request, ENT_QUOTES) . '</pre>';
   //echo '<h2>Response</h2>';
   //echo '<pre>' . htmlspecialchars($soapy->response, ENT_QUOTES) . '</pre>';
   //echo '<h2>Debug</h2>';
   //echo '<pre>' . htmlspecialchars($soapy->debug_str, ENT_QUOTES) . '</pre>';
   $err = $soapy->getError();
   if($err){
      echo '<p><b>Error: ' . $err . '</b></p>';
      return array('version' => '-2');
   }
   //print_r($result);
   return $result;
}

function GetVersion()
{
   $ns="uri:vxmisversion";
   $soapy=new soapclient('http://soap.bananahead.com/vxmis/version.php');
   if($soapy->getError()){
      echo "Constructor Error";
      exit;
   }
   
   //$result = $soapy->call('getVersion',array(),$ns,$ns.'/getVersion');
   $result = $soapy->call('getVersion',"http://soap.bananahead.com/vxmis","http://soap.bananahead.com/vxmis#getVersion");//,$ns,$ns.'/getVersion');
   if($soapy->fault){
      echo '<p><b>Fault: ';
      print_r($result);
      echo '</b></p>';
      return array('version' => '-1');
   }

   $err = $soapy->getError();
   if($err){
      echo '<p><b>Error: ' . $err . '</b></p>';
      return array('version' => '-2');
   }
   return $result;
}

function  GetSimpleModuleVersion($module)
{
   $soapy=new soapclient('http://soap.bananahead.com/vxmis/version.php');
   if($soapy->getError()){
      echo "Constructor Error";
      exit;
   }

   $result = $soapy->call('getSimpleModule', array('name' => $module));//,'uri:vxmis','uri:vxmis/getModule');
   
   if($soapy->fault){
      echo '<p><b>Fault: ';
      print_r($result);
      echo '</b></p>';
      return array('version' => '-1');
   }

   //echo '<h2>Request</h2>';
   //echo '<pre>' . htmlspecialchars($soapy->request, ENT_QUOTES) . '</pre>';
   //echo '<h2>Response</h2>';
   //echo '<pre>' . htmlspecialchars($soapy->response, ENT_QUOTES) . '</pre>';
   //echo '<h2>Debug</h2>';
   //echo '<pre>' . htmlspecialchars($soapy->debug_str, ENT_QUOTES) . '</pre>';
   
  //echo $soapy->response;
   $err = $soapy->getError();
   if($err){
      echo '<p><b>Error: ' . $err . '</b></p>';
      return array('version' => '-2');
   }
   return $result;
}

function GetModuleVersion($module)
{
   $soapy=new soapclient('http://soap.bananahead.com/vxmis/version.php');
   if($soapy->getError()){
      echo "Constructor Error";
      exit;
   }

   $result = $soapy->call('getModule', array('name' => $module));//,'uri:vxmis','uri:vxmis/getModule');
   
   if($soapy->fault){
      //echo '<p><b>Fault: ';
      //print_r($result);
      //echo '</b></p>';
      //return array('version' => '-1');
      return false;
   }

   //echo '<h2>Request</h2>';
   //echo '<pre>' . htmlspecialchars($soapy->request, ENT_QUOTES) . '</pre>';
   //echo '<h2>Response</h2>';
   //echo '<pre>' . htmlspecialchars($soapy->response, ENT_QUOTES) . '</pre>';
   //echo '<h2>Debug</h2>';
   //echo '<pre>' . htmlspecialchars($soapy->debug_str, ENT_QUOTES) . '</pre>';
   
  //echo $soapy->response;
   $err = $soapy->getError();
   if($err){
      echo '<p><b>Error: ' . $err . '</b></p>';
      return array('version' => '-2');
   }
   return $result;
}

function GetModule($moduleid)
{
   $soapy=new soapclient('http://soap.bananahead.com/vxmis/module.php');
   if($soapy->getError()){
      echo "Constructor Error";
      exit;
   }

   $result = $soapy->call('getModule', array('id' => $moduleid));
   
   if($soapy->fault){
      echo '<p><b>Fault: ';
      print_r($result);
      echo '</b></p>';
      return false;
   }
   $err = $soapy->getError();
   if($err){
      echo '<p><b>Error: ' . $err . '</b></p>';
      return false;
   }
   return $result;
}

function GetMirrorList()
{
   $soapy=new soapclient('http://soap.bananahead.com/vxmis/system.php');
   if($soapy->getError()){
      echo "Constructor Error";
      exit;
   }

   $result = $soapy->call('getMirrorList', array());
   
   if($soapy->fault){
      echo '<p><b>Fault: ';
      print_r($result);
      echo '</b></p>';
      return false;
   }
   $err = $soapy->getError();
   if($err){
      echo '<p><b>Error: ' . $err . '</b></p>';
      return false;
   }
   return $result;
}

function GetNearestMirror()
{
   $soapy=new soapclient('http://soap.bananahead.com/vxmis/system.php');
   if($soapy->getError()){
      echo "Constructor Error";
      exit;
   }

   $result = $soapy->call('getNearestMirror', array());
   
   if($soapy->fault){
      echo '<p><b>Fault: ';
      print_r($result);
      echo '</b></p>';
      return false;
   }
   $err = $soapy->getError();
   if($err){
      echo '<p><b>Error: ' . $err . '</b></p>';
      return false;
   }
   return $result;
}

function GetFileList()
{
}

function FetchFile($name)
{
   
}

function listUpdate()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(misadmin_misupdate_qry1, $sorton, $sortorder);
   //$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $_REQUEST['action']="update";
   echo "<form method=\"post\" action=\"".$_SERVER['PHP_SELF']."\">\n";
   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td>"._("No modules are defined")."</td></td></table>\n";
      exit;
   }
   $v=GetVersion();
   $ver=$v['major'].".".$v['minor'].".".$v['micro']."-".$v['release'];
   echo "<tr>\n<td colspan=\"7\" class=\"listtitle\">"._("VxMIS Version :")." ".$ver."</td>\n</tr>\n";
	echo "<tr>\n<td class=\"listtitle \">\n<table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='iversion'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Installed Version")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Installed Version")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=version\">"._("Installed Version")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='iversion'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='cversion'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Current Version")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Current Version")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=cversion\">"._("Current Version")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='cversion'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='released'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Released")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Released")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=released\">"._("Released")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='released'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='update'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Update")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Update")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=enabled\">"._("Update")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='update'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      $ver=GetModuleVersion($row['name']);
      if(!$ver) continue;
      flush();
      $v=$ver['major'].".".$ver['minor'].".".$ver['micro']."-".$ver['release'];
      if($v == ""){
         $v=_("Unknown Module");
         echo "<tr>\n<td class=\"listdatamissing\">".$row['name']."</td>\n";
         echo "<td class=\"listdatamissing\">".$row['version']."</td>\n";
         echo "<td class=\"listdatamissing\">".$v."</td>\n";
         echo "<td class=\"listdatamissing\">".$ver['released']."</td>\n";
         echo "<td class=\"listdatamissing\">";
      }
      else if($v > $row['version']){
         echo "<tr>\n";
         echo "<td class=\"listdataupdate\">".$row['name']."</td>\n";
         echo "<td class=\"listdataupdate\">".$row['version']."</td>\n";
         echo "<td class=\"listdataupdate\">".$v."</td>\n";
         echo "<td class=\"listdataupdate\">".$ver['released']."</td>\n";
         echo "<td class=\"listdataupdate\">";
      }
      else{
         echo "<tr>\n";
         echo "<td class=\"listdata\">".$row['name']."</td>\n";
         echo "<td class=\"listdata\">".$row['version']."</td>\n";
         echo "<td class=\"listdata\">".$v."</td>\n";
         echo "<td class=\"listdata\">".$ver['released']."</td>\n";
         echo "<td class=\"listdata\">";
      }
      
      $iversion=$cversion=0;
      if($iversion < $cversion){
         echo "<input class=\"checkbox\" type=\"checkbox\" value=\"".$ver['id']."\" id=\"update[]\" checked> \n";
      }
      else{
         echo "<input class=\"checkbox\" type=\"checkbox\" value=\"".$ver['id']."\" id=\"update[]\"> \n";
      }
      echo "</td>\n<td class=\"listdata\">";
      $wibbler=$ver['id'];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"misupdate.php?action=browse&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
      }
      else{
        echo "<a href=\"misupdate.php?action=browse&id=$wibbler\">"._("View")."</a>&nbsp;\n";
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
   echo "<tr><td><input type=submit value=Update></td></tr>\n";
	echo "</table>\n";
   echo "</form>\n";
}

?>
