<?php
/*
bank.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001 - 2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/contact.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if($action=='list'){
   $_SESSION['vxmisuser']->ClearFocus();
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Bank Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Bank Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(bankm_bank_qry1, "bankdetails")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear":
		addBank();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseBank($_REQUEST['id']);
         break;
      }
		browseBank($_POST['id']);
		break;

	case "edit" :
		editBank($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelBank($_REQUEST['id']);
      }
      else{
         deleteBank($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listBank();
      }
      break;  
	
   case "cfmdelete" :
      deleteBank($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listBank();
		break;
      
	case "add" :
		insertBank($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitBank($_POST);
      listBank();
		break;
      
   case "duplicate" :
      $id=duplicateBank($_REQUEST['id']);
      editBank($id);
      break;

   case "find":
      searchBank($_POST);
      break;
      
	case "list":
	default :
		listBank();
		break;
      
   case "contactadd" :
		contactAdd($id, $cid);
		break;
      
   case "contacthide" :
		contactHide($_REQUEST['id']);
		break;
      
   case "contactedit" :
		contactEdit($_REQUEST['id']);
		break;

	case "contactcommit" :
		contactCommit($_POST);
		break;

	case "details" :
		bankStatus();
		break;

	case "receipts":
		bankReceipts();
		break;
		
	case "payments":
		bankPayments();
		break;
		
	case "transfer":
		bankTrans();
		break;
   
   case "transaction":
		bankTransaction();
		break;
		
	case "reconcile":
		bankReconcile();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(bankm_bank_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $_SESSION['vxmisuser']->ClearFocus();
	$frm["id"] = "";
   $frm["bankid"] = "";
   $frm["accountid"] = "";
   $frm["name"] = "";
   $frm["branch"] = "";
   $frm["addrid"] = "";
   $frm["accountid"] = "";
   $frm["contactid"] = "";
   $frm["banksortcode"] = "";
   $frm["banknumber"] = "";

	return $frm;
}
function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(bankm_bank_qry2, $id);
   }
   else{
      $qry=sprintf(bankm_bank_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm["id"] = $id;
	$frm["bankid"] = $row["bankid"];
   $frm["accountid"] = $row["accountid"];
   $frm["name"] = $row["name"];
   $frm["branch"] = $row["branch"];
   $frm["addrid"] = $row["addressid"];
	$frm["accountid"] = $row["accountid"];
   $frm["contactid"] = $row["contactid"];
   $frm["banksortcode"] = $row["banksortcode"];
   $frm["banknumber"] = $row["banknumber"];

	return $frm;
}

function addBank()
{
   $frm=clearForm();
	$frm["newaction"] = "add";

	include("templates/bank.php");
}

function editBank($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
	
	include("templates/bank.php");
}

function browseBank($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/bank.php");
}

function chkdelBank($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   $_REQUEST["action"] = "cfmdelete";
   
   include("templates/bank.php");
}

function deleteBank($id) 
{
   $qry=sprintf(bankm_bank_qry7, $id);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function insertBank($frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
   $adid=$a->Add();
   
   $qry=sprintf(bankm_bank_qry4, 0, $frm['accountid'], $frm['name'], $frm['branch'], $adid,
      0, $frm['banksortcode'], $frm['banknumber']);
   
	$_SESSION['VxCFG']->dbh->Execute($qry);
   
   $frm["newaction"] = "contactadd";
	
	include("templates/bank.php");
}

function commitBank($frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
   $aid=$frm['addrid'];
   $a->Commit($aid);
   $qry=sprintf(bankm_bank_qry5, $frm['name'], $frm['branch'], $frm['addressid'],
	   $frm['accountid'], $frm['contactid'], $frm['banksortcode'],	$frm['banknumber'],$frm['id']);
	         
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function duplicateAccount($id) 
{
   $frm=fillForm($id, false);
   return insertAccount($frm);
}


function searchBank($frm)
{
   $b=new BankDetails();
   if($b){
      $b->FillFromForm($frm);
      $b->Find(true);
   }
}

function contactAdd($tid, $cid)
{
   $c=new ContactList();
   $c->Add($cid, "bankdetails", $tid);
}

function contactHide($id)
{
   $frm=fillForm($id);
	$frm["newaction"] = "commit";
	include("templates/bank.php");
}

function contactEdit($id)
{
   $frm=fillForm($id);
   
	$frm["newaction"] = "contactcommit";
	
	include("templates/bank.php");
}

function contactCommit($frm)
{
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "Address");
}

function AccountCombo($action, $id)
{
   $a=new Account();
   $a->Combo($action, $id, "accountid");
}

function fillContact($a, $cid, $id)
{
   $ref=$_SERVER['PHP_SELF']."?action=contactedit&id=".$id;
   
   //$ref=$_SERVER['PHP_SELF']."?action=contacthide";
   
   $c=new ContactList();
   $c->fill($cid);
   $c->Table($a, $cid, $ref, "bankdetails", $id, $_SERVER['PHP_SELF']);
}

function AccountsTable($a, $id)
{
   $qry=sprintf(bankm_bank_qry9, $id);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	
   if($result->RecordCount()==0){
      echo "<table>\n<tr><td>"._("No accounts defined")."</td></tr></table>\n";
      return;
   }
   
   echo "<table>\n";
   while($row = $result->FetchRow()){
      echo "<tr>\n<td>".$row['name']."</td>\n<td>".$row['number']."</td>\n</tr>\n";
   }
   echo "</table>\n";
}

function listBank()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(bankm_bank_qry8, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no banks defined")."</td></td></table>\n";
      return;
   }

	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
   		echo "<tr class=\"listdata\"><td class=\"listdata\">";
	   	if($row["name"]){
		      $n=$row["name"];
			   echo "$n";
   		}
	   	else{
		      echo "No Name";
		   }
		   echo "</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">";
	   	if($row["name"]){
		      $n=$row["name"];
			   echo "$n";
   		}
	   	else{
		      echo "No Name";
		   }
		   echo "</td><td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"bank.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"bank.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"bank.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"bank.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"bank.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"bank.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

function bankStatus()
{
	echo "<br><br><center><h3>Not been implemented yet.</h3></center>";
   exit;
}

function bankReceipts()
{
	echo "<br><br><center><h3>Not been implemented yet.</h3></center>";
   exit;
}

function bankPayments()
{
	echo "<br><br><center><h3>Not been implemented yet.</h3></center>";
   exit;
}

function bankTransfer()
{
	echo "<br><br><center><h3>Not been implemented yet.</h3></center>";
   exit;
}

function bankTransaction()
{
}

function bankReconcile()
{
}
?>
