<?php
/*
banktrans.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");
require_once($_SESSION['VxCFG']->libdir."/gl.php");
require_once($_SESSION['VxCFG']->libdir."/bank.php");
require_once($_SESSION['VxCFG']->libdir."/transaction.php");
require_once($_SESSION['VxCFG']->libdir."/timedate.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(3);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if($action=='list'){
   $_SESSION['vxmisuser']->ClearFocus();
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Bank Transaction"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Bank Transaction");
}

if($_SESSION["pageindex"]->CheckNum(bank_banktrans_qry1, "bankitem")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear":
		addBank();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseBank($_REQUEST['id']);
         break;
      }
		browseBank($_POST['id']);
		break;

	case "edit" :
		editBank($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelBank($_REQUEST['id']);
      }
      else{
         deleteBank($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listBank();
      }
      break;  
	
   case "cfmdelete" :
      deleteBank($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listBank();
		break;
      
	case "add" :
		insertBank($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listBank();
		break;

	case "commit" :
		commitBank($_POST);
      listBank();
		break;

   case "duplicate" :
      $id=duplicateBank($_REQUEST['id']);
      editBank($id);
      break;
      
   case "find":
      searchBank($_POST);
      break;
      
	case "list":
	default :
      listBank($_REQUEST);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(bank_banktrans_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "";
   $frm["bankid"] = "";
   $frm["itemdate"] = "";
   $frm["itemtype"] = "";
   $frm["ledgerentryid"] = "";
   $frm["transid"] = "";
   $frm["referencedata"] = "";
   $frm["amount"] = "";
   $frm["gentrans"] = 'N';
   
   $frm["accountid"] = 0;
   $frm["journalid"] = 0;
   $frm["ledgerid"] = 0;
   
   $frm['debit']='N';
   
	return $frm;
}
function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(bank_banktrans_qry2, $id);
   }
   else{
      $qry=sprintf(bank_banktrans_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   
   $frm["id"] = $row["id"];
   $frm["bankid"] = $row["bankid"];
   $frm["itemdate"] = $row["itemdate"];
   $frm["itemtype"] = $row["itemtype"];
   $frm["ledgerentryid"] = $row["ledgerentryid"];
   $frm["transid"] = $row["transid"];
   $frm["referencedata"] = $row["referencedata"];
   $frm["amount"] = sprintf("%0.2f", $row["amount"]);
   $frm["gentrans"] = 'N';
   
   $qry=sprintf(bank_banktrans_qry18, $row["itemtype"]);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   $frm['debit']=$row['debit'];
   
   $qry=sprintf(bank_banktrans_qry15, $frm["ledgerentryid"]);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   $frm["accountid"] = $row["accountid"];
   $frm["journalid"] = $row["journalid"];
   $frm["ledgerid"] = $row["ledgerid"];
   
	return $frm;
}

function addBank()
{
   $frm=clearForm();
	$frm["newaction"] = "add";

	include("templates/banktrans.php");
}

function editBank($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
	
	include("templates/banktrans.php");
}

function browseBank($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/banktrans.php");
}

function chkdelbank($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/banktrans.php");
}

function deleteBank($frm) 
{
   if($frm['gentrans']=='Y'){
      $qry=sprintf(bank_banktrans_qry11, $frm['transid']);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   $qry=sprintf(bank_banktrans_qry10, $frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function insertBank($frm) 
{
   $idate=$frm['year']."-".$frm['month']."-".$frm['day'];
   $amount=sprintf("%0.2f", $frm["amount"]);
   /*
   if($frm['gentrans']=='N'){
      $qry=sprintf(bank_banktrans_qry9, $frm['bankid'],$idate,$frm['itemtype'],
         0,0,$frm['referencedata'],$amount);
   }
   else{*/
      $t=new Transaction();
      $td=new TimeDate();
      $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
      $ts=$td->ansidate();
      $t->Set($ts,
         $_SESSION['vxmisuser']->GetEmployee(),0,
         //$_SESSION['vxmisuser']->GetFullStation(),
         0,0,'','Bank','N','N','Y',0,0);
      $tid=$t->Add();

      $qry=sprintf(bank_banktrans_qry9, $frm['bankid'],$idate,$frm['itemtype'],
         0,$tid,$frm['referencedata'],$amount);
   //}
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $beid=$row[0]; 
   
   // insert ledgerentry
   $qry=sprintf(bank_banktrans_qry16, $frm['journalid'],$frm['ledgerid'],$frm['accountid'],$idate,
      '',yesno(isset($frm['debit'])),$amount,'N','');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $lid=$row[0]; 
   $qry=sprintf(bank_banktrans_qry19,$lid,$beid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   return $beid;
}

function duplicateBank($id) 
{
   $frm=fillBank($id, false);
   return insertBank($frm);
}

function commitBank($id, $frm) 
{
   $idate=$frm['year']."-".$frm['month']."-".$frm['day'];
   // needs $frm['transid']
   $qry=sprintf(bank_banktrans_qry4,$frm['bankid'],$idate,$frm['itemtype'],$frm['accountid'],0,$frm['referencedata'],
      $frm['amount'], $id);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   // adjust ledgerentry
}

function fillAccountCombo($a, $id) 
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function fillBankCombo($action, $id)
{
   $b=new BankAccount();
   $b->Combo($action, $id, "bankid");
}

function LedgerCombo($a, $id)
{
   $l=new LedgerEntry();
   $l->LedgerCombo($a, $id, "ledgerid");
}

function fillBankTypeCombo($a, $id)
{
   if($a=="commit" || $a=="add"){
      $result=$_SESSION['VxCFG']->dbh->Execute(bank_banktrans_qry12);
      echo "<select name=\"itemtype\" width=\"250\">\n";
   	while($row = $result->FetchRow()){
	   	$boo=$row["id"];
		   $poo=$row["name"];
   		if($id==$boo){
	   		print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
	   echo "</select>\n";
   }
   else{
      if($id != NULL){
         $qry=sprintf(bank_banktrans_qry13, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         $row = $result->FetchRow();
         echo $row[0];
      }
      else{
         echo _("Not Set");
      }
   }
}

function DateControl($a, $d)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
	   $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->datecontrol($a, "");
}

//function listBank($reconciled='N', $type='All', $start='', $end='')
function listBank($frm=false)
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(bank_banktrans_qry14, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no bank transactions defined")."</td></td></table>\n";
      return;
   }

	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='date'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Date")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Date")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=date\">"._("Date")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='date'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='type'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Type")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Type")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=type\">"._("Type")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='type'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='amount'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Amount")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Amount")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=amount\">"._("Amount")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='amount'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">";
   		if($row["itemdate"]){
	   	   $n=$row["itemdate"];
		   	echo "$n";
   		}
	   	else{
		      echo "No Name";
   		}
         echo "<td class=\"listdata\">";
         fillBankTypeCombo("browse", $row['itemtype']);
         $amount=sprintf("%0.2f", $row['amount']);
         echo "</td>\n<td class=\"listdata\">".$amount."</td>";
		   echo "</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">";
   		if($row["itemdate"]){
	   	   $n=$row["itemdate"];
		   	echo "$n";
   		}
	   	else{
		      echo "No Name";
   		}
         echo "<td class=\"listdataeven\">";
         fillBankTypeCombo("browse", $row['itemtype']);
         $amount=sprintf("%0.2f", $row['amount']);
         echo "</td>\n<td class=\"listdataeven\">".$amount."</td>";
		   echo "</td><td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"banktrans.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"banktrans.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"banktrans.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"banktrans.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"banktrans.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"banktrans.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
