<?php
/*
reconcile.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");
require_once($_SESSION['VxCFG']->libdir."/bank.php");
require_once($_SESSION['VxCFG']->libdir."/transaction.php");
require_once($_SESSION['VxCFG']->libdir."/timedate.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(4);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if($action=='list'){
   $_SESSION['vxmisuser']->ClearFocus();
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_nopermsp.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Reconcile"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Reconcile");
}

if($_SESSION["pageindex"]->CheckNum(bank_banktrans_qry1, "")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addBank();
		break;
/*
	case "browse":
      if(isset($_REQUEST['id'])){
         $id=$_SESSION["pageindex"]->browse($_REQUEST['id']);
         browseBank($id);
         break;
      }
      $id=updateNav($_POST);
		browseBank($id);
		break;
*/
	case "commit" :
		commitBank($_REQUEST);
      bankReconcile($_REQUEST);
		break;

	case "list":
	default :
		bankReconcile($_REQUEST);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(bank_banktrans_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function fillAccountCombo($a, $id) 
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function fillBankCombo($action, $id)
{
   $b=new BankDetails();
   $b->Combo($action, $id, "bankid");
}

function DateControl($a, $d)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
	   $result=db_query(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->datecontrol($a, "");
}

function bankReconcile($frm)
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   if(isset($frm['bankchange'])){
   }
   
   if(isset($frm['bankid'])){
      $bankid=$frm['bankid'];
      if($bankid=='All'){
         if(isset($frm['accountid'])){
            $accountid=$frm['accountid'];
            if($accountid=='All'){
               $qry=sprintf(bankm_reconcile_qry1, $sorton, $sortorder);
            }
            else{
               $qry=sprintf(bankm_reconcile_qry3, $accountid, $sorton, $sortorder);
            }
         }
         else{
            $accountid='All';
            $qry=sprintf(bankm_reconcile_qry1, $sorton, $sortorder);
         }
      }
      else{
         if(isset($frm['accountid'])){
            $accountid=$frm['accountid'];
            if($accountid=='All'){
               $qry=sprintf(bankm_reconcile_qry2, $bankid, $sorton, $sortorder);
            }
            else{
               $qry=sprintf(bankm_reconcile_qry3, $accountid, $sorton, $sortorder);
            }
         }
         else{
            $accountid='All';
            $qry=sprintf(bankm_reconcile_qry2, $bankid, $sorton, $sortorder);
         }
      }
   }
   else{
      $bankid='All';
      $qry=sprintf(bankm_reconcile_qry1, $sorton, $sortorder);
   }
   
   if(isset($frm['accountid'])){
      $accountid=$frm['accountid'];
   }
   else{
      $accountid='All';
   }
   
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="commit";

   echo "<form id=\"reconcile\" method=\"post\" action=\"".$_SERVER['PHP_SELF']."\">\n";
   echo "<input type=\"hidden\" name=\"action\" value=\"commit\">\n";
   echo "<table class=\"listtable\">\n";
   
   $b=new BankDetails();
   $ba=new BankAccount();
   echo "<tr>\n<td colspan=\"5\" class=\"listtitle\">&nbsp;&nbsp;"._("Bank ");
   $b->Combo("add", $bankid, "bankid", true);
   echo "&nbsp;&nbsp;"._("Account ");
   $ba->ComboByBank("add", $accountid, "accountid", $bankid, true);
   echo "</td>\n</tr>\n";
   
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no bank transactions defined")."</td></td></table>\n";
      return;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no bank transactions defined")."</td></td></table>\n";
      return;
   }
	
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='itemdate'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Date")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Date")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=itemdate\">"._("Date")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='itemdate'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='type'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Type")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Type")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=type\">"._("Type")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='type'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='reference'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Reference")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Reference")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=reference\">"._("Reference")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='reference'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='amount'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Amount")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Amount")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=amount\">"._("Amount")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='amount'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">";
   echo "<input type=\"checkbox\" name=\"nobby\" onClick=\"Checkall(document.getElementById('reconcile'))\">";
   echo "</td>\n</tr>\n";
   
   $td=new TimeDate();

	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      /*
      $qry=sprintf(bank_account_qry3, $row['bankid']);
      $nresult=db_query($qry);
      if($nrow = $nresult->FetchRow()){
         $bankname=$nrow['name'];
         echo "<tr><td>$bankname</td>";
      }
      else{
         echo "<tr><td>Not Set</td>";
      }*/
      if($c%2){
         if($row["itemdate"]){
            echo "<tr class=\"listdata\"><td class=\"listdata\">";
            $td->parse($row['itemdate']);
            $td->datecontrol("browse", "");
            echo "</td>\n";
	   	}
		   else{
		      echo "<td class=\"listdata\">-</td>\n";
   		}
         $qry2=sprintf(bank_banktrans_qry13, $row['itemtype']);
         $zresult=db_query($qry2);
         if($zrow = $zresult->FetchRow()){
            $typename=$zrow['name'];
            echo "<td class=\"listdata\">$typename</td>\n";
         }
         else{
            echo "<td class=\"listdata\">Not Set</td>\n";
         }
         $a=sprintf("%0.2f", $row['amount']);
         echo "<td class=\"listdata\">".$row['referencedata']."</td><td class=\"listdata\">$a</td>\n";
   		echo "<td class=\"listdata\"><input type=\"checkbox\" name=\"reclist[]\" value=\"".$row["id"]."\"></td>\n</tr>\n";
      }
      else{
         if($row["itemdate"]){
            echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">";
            $td->parse($row['itemdate']);
            $td->datecontrol("browse", "");
            echo "</td>\n";
	   	}
		   else{
		      echo "<td class=\"listdataeven\">-</td>\n";
   		}
         $qry2=sprintf(bank_banktrans_qry13, $row['itemtype']);
         $zresult=db_query($qry2);
         if($zrow = $zresult->FetchRow()){
            $typename=$zrow['name'];
            echo "<td class=\"listdataeven\">$typename</td>\n";
         }
         else{
            echo "<td class=\"listdataeven\">Not Set</td>\n";
         }
         $a=sprintf("%0.2f", $row['amount']);
         echo "<td class=\"listdataeven\">".$row['referencedata']."</td><td class=\"listdataeven\">$a</td>\n";
		   echo "<td class=\"listdataeven\"><input type=\"checkbox\" name=\"reclist[]\" value=\"".$row["id"]."\"></td>\n</tr>\n";
      }
      $c++;
      $offset++;
	}
	echo "<tr>\n<td colspan=\"5\"><br>";
   echo "<input type=\"submit\" value=\"Reconcile\">";
   echo "</td></tr></table>\n";
	echo "</form>";
}

function commitBank($frm)
{
   //print_r($frm);
   
   if(isset($frm['reclist'])){
      foreach($frm['reclist'] as $rec){
         $qry=sprintf(bankm_reconcile_qry4, $rec);
         $_SESSION['VxCFG']->dbh->Execute($qry);
      }
   }
}

?>
