<?php
/*
category.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/tree.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(5);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Product Categories"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Product Categories");
}

if($_SESSION["pageindex"]->CheckNum(productm_category_qry1, "category")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addCategory();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseCategory($_REQUEST['id']);
         break;
      }
		browseCategory($_POST['id']);
		break;

	case "edit" :
		editCategory($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelCategory($_REQUEST['id']);
      }
      else{
         deleteCategory($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listCategory();
      }
      break;  
	
   case "cfmdelete" :
      deleteCategory($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listCategory();
		break;

	case "add" :
		insertCategory($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listCategory();
		break;

	case "commit" :
		commitCategory($_POST);
      listCategory();
		break;

	case "list":
	default :
		listCategory();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(productm_category_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
	$frm["parentid"] = "";
	$frm["name"] = "";
	$frm["description"] = "";
   $frm["eonsite"] = "N";
   
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(productm_category_qry2, $id);
   }
   else{
      $qry=sprintf(productm_category_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
	$frm["name"] = $row["name"];
	$frm["parentid"] = $row["parentid"];
	$frm["description"] = $row["description"];
   $frm["eonsite"] = $row["eonsite"];

	return $frm;
}

function addCategory()
{        
	$frm=clearForm();
	$frm["newaction"] = "add";
	
	include("templates/category.php");
}

function editCategory($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/category.php");
}

function browseCategory($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/category.php");
}

function insertCategory($frm) 
{
   $qry=sprintf(productm_category_qry4, $frm['parentid'], $frm['name'], $frm['description'],YN($frm["eonsite"]));
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitCategory($frm) 
{
   $qry=sprintf(productm_category_qry5, $frm['parentid'], $frm['name'], $frm['description'],YN($frm["eonsite"]),$frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function chkdelCategory($id) 
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   
   include("templates/category.php");
}

function deleteCategory($id) 
{
   $qry=sprintf(productm_category_qry6, $id);
}

function CategoryCombo($a, $id)
{
	if($a=="commit" || $a=="add"){
		$result=$_SESSION['VxCFG']->dbh->Execute(productm_category_qry7);

		print "<select name=\"parentid\">\n";

		while($row = $result->FetchRow()){
			$boo=$row["id"];
			$poo=$row["name"];

			if($id==$boo){
				print "<option selected value=\"$boo\"> $boo - $poo </option>\n";
			}
			else{
				print "<option value=\"$boo\"> $boo - $poo </option>\n";
			}
		}
		print "</select>\n";
	}
	else{
      $qry=sprintf(productm_category_qry3, $id);
		$result=$_SESSION['VxCFG']->dbh->Execute($qry);
		if($row = $result->FetchRow()){
			$n=$row["name"];
			echo $n;
		}
		else{
			echo "Not Set";
		}
	}
}

function listCategory()
{  
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(productm_category_qry10, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<table class=\"listtable\">\n";
   if(db_num_rows($result)==0){
      echo "<tr><td colspan=\"2\">"._("The are no quantity item types defined.")."</td></td></table>\n";
      return;
   }
   
	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }

	echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">";
		   if($row["name"]){
			   printf ("%02d - %s", $row["id"], $row["name"]);
		   }
		   else{
			   printf ("%02d - Unused", $row["id"]);
		   }
		   echo "</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">";
		   if($row["name"]){
			   printf ("%02d - %s", $row["id"], $row["name"]);
		   }
		   else{
			   printf ("%02d - Unused", $row["id"]);
		   }
		   echo "</td><td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"category.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"category.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"category.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"category.php?action=browse&id=$wibbler&offset=$offset\">".misc_listview."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"category.php?action=edit&id=$wibbler&offset=$offset\">".misc_listedit."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"category.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

function parentSelection($parent_id, $newaction)
{
	if($newaction == "browse" || $newaction=="cfmdelete") {
		if ($parent_id == 0) {
			echo "Not Set";
		}
		else {
                        $qry=sprintf(invcat_qry8, $parent_id);
			$result = db_query($qry);
			$myrow = $result->FetchRow();
			echo $myrow['name'];
		}
	}
	else {
		echo "<select name='parentid'>\n";
		echo "<option value='0'>Not Set</option>\n";
		$result = db_query(invcat_qry7);
		while ($myrow = $result->FetchRow()) {
			echo "<option value='" . $myrow['id'] . "'";
			if ($myrow['id'] == $parent_id)
				echo " selected";
			echo  ">" . $myrow['name'] . "</option>\n";
		}
		echo "</select>\n";
	}
}

function HtmlBuildTree()
{
   $closed="tree_folderclosed.png";
   $open="tree_folderopen.png";
   $cat_icon="icon_category.png";
   
   $tree = new HTML_TreeMenu();
   $node = new HTML_TreeNode(array('text'=>"Categories",'icon'=>$closed,'expandedIcon'=>$open));
      
	$result=db_query(invcat_qry8);
	while($row = db_fetch_array($result)){
      $tqry=sprintf(invcat_qry3, $row[0]);
      $tresult=db_query($tqry);
      if($trow = db_fetch_array($tresult)){
         $pn=&$node->addItem(new HTML_TreeNode(array('text'=>$trow['name'], 'link'=>"category.php?action=browse&id=".$trow['ID'],
         'icon'=>$closed,'expandedIcon'=>$open)));
      }
      
      $pqry=sprintf(invcat_qry9, $row[0]);
      $presult=db_query($pqry);
      while($prow = db_fetch_array($presult)){
         $cn=&$pn->addItem(new HTML_TreeNode(array('text'=>$prow['name'], 'link'=>"category.php?action=browse&id=".$prow['ID'],
         'icon'=>$closed,'expandedIcon'=>$open)));
      }
   }
   $tree->addItem($node);
   $treedisp = new HTML_TreeMenu_DHTML($tree, array('images'=>$_SESSION['VxCFG']->styleimagedir));
   
   echo "<br>\n";
   echo "<table border=\"0\" cellpadding=\"5\" width=\"95%\">\n";
   echo "<tr><td>";
   $treedisp->printMenu();
   echo "</td></tr>\n";
   echo "</table>\n";
}

?>
