<?php
/*
featueditems.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('start');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']);
if(isset($_REQUEST['action'])){
   if($_REQUEST['action']=='navviewshiftleft'){
      $_SESSION['vxmisuser']->ModuleDecrement();
   }
   else if($_REQUEST['action']=='navviewshiftright'){
      $_SESSION['vxmisuser']->ModuleIncrement();
   }
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Featured Items Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Featured Items Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(cart_featureditems_qry1, "efeatureditem")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
   case "clear" :
      addFI();
      break;

   case "browse":
      if(isset($_REQUEST['id'])){
         $id=$_SESSION["pageindex"]->browse($_REQUEST['id']);
         browseFI($id);
         break;
      }
      $id=updateNav($_POST);
      browseFI($id);
      break;

   case "edit" :
      editFI($_REQUEST['id']);
      break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelFI($_REQUEST['id']);
      }
      else{
         deleteFI($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listFI();
      }
      break;

   case "cfmdelete" :
      deleteFI($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listFI();
      break;

   case "add" :
      insertFI($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listFI();
      break;

   case "commit" :
      commitFI($_POST);
      listFI();
      break;

   case "search" :
      searchFI();
      break;
   
   case "sresults" :
      searchResults($_POST);
      break;
      
   case "list":
   default :
      listFI();
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(cart_featureditems_qry1);
   if(!$result) return 0;
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
  $frm["newaction"] = "";
  $frm["id"] = 0;
  $frm["productid"] = "";
  $frm["tagline"]="";
  $frm["start"]="";
  $frm["end"]="";
  
  $frm['pname']="";
  return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(cart_featureditems_qry2, $id);
   }
   else{
      $qry=sprintf(cart_featureditems_qry3, $id);
   }
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();

   $frm["id"] = $row['id'];
   $frm["productid"] = $row["productid"];
   $frm["tagline"]=$row["tagline"];
   $frm["start"]=$row["start"];
   $frm["end"]=$row["end"];
   
   if($row['productid']==0){
      $frm['pname']="";
   }
   else{
      $qry=sprintf(cart_featureditems_qry8, $row["productid"]);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      $frm["pname"]=$row["name"];
   }
   
   return $frm;
}

function addFI()
{
  $frm=clearForm();
  $frm["newaction"] = "add";

  include("templates/featureditems.php");
}

function editFI($id) 
{
  $frm=fillForm($id, false);
  $frm["newaction"] = "commit";

  include("templates/featureditems.php");
}

function browseFI($id) 
{
  $frm=fillForm($id, true);
  $frm["newaction"] = "browse";
  
  include("templates/featureditems.php");
}

function chkdelFI($id)
{
  $frm=fillForm($id, false);
  $frm["newaction"] = "cfmdelete";
   
  include("templates/featureditems.php");
}

function insertFI($frm) 
{
   $qry=sprintf(cart_featureditems_qry4,$frm['productid'],$frm['tagline'],$frm['start'],$frm['end']);
   
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitFI($frm) 
{
   $qry=sprintf(cart_featureditems_qry5,$frm['productid'],$frm['tagline'],$frm['start'],$frm['end'],$frm['id']);

  $_SESSION['VxCFG']->dbh->Execute($qry);
}

function deleteFI($frm) 
{
   $qry=sprintf(cart_featureditems_qry6, $frm["id"]);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function searchFI()
{
   $frm["newaction"] = "sresults";
   
  include("templates/fisearch.php");
}

function searchResults($frm)
{
}

function DateControl($a, $d, $n)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
     $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
      if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->displayex('date', $a, $n, $d);
}

function listFI()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(cart_featureditems_qry7, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no featured items defined")."</td></td></table>\n";
      return;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no featured items defined")."</td></td></table>\n";
      return;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='start'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Starts")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Starts")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=start\">"._("Starts")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='start'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='ends'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Ends")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Ends")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=end\">"._("Ends")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='end'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='productid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Product")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Product")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=productid\">"._("Product")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='productid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   while($row = $result->FetchRow()){
      if($row['productid']==0){
         $n=_("Not Set");
      }
      else{
         $qry=sprintf(cart_featureditems_qry8, $row["productid"]);
         $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
         $prow = $presult->FetchRow();
         $n=$prow["name"];
      }
      if($c%2){
         echo "<tr class=\"listdata\">\n<td class=\"listdata\">".$row["start"]."</td>\n";
         echo "<td class=\"listdata\">".$row["end"]."</td>\n";
         echo "<td class=\"listdata\">$n</td>\n";
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\">\n<td class=\"listdataeven\">".$row["start"]."</td>\n";
         echo "<td class=\"listdataeven\">".$row["end"]."</td>\n";
         echo "<td class=\"listdataeven\">$n</td>\n";
         echo "<td class=\"listdataeven\">";
      }
      $wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"featureditems.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"featureditems.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"featureditems.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
        echo "<a href=\"featureditems.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"featureditems.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"featureditems.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
  }
  echo "</table>";
}

?>
