<?php
/*
prefs.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/country.php");
require_once($_SESSION['VxCFG']->libdir."/currency.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(5);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Cart Preferences"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Cart Preferences");
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "commit" :
		commitDef($_POST);
      listDef();
		break;
      
	default :
		listDef();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(cart_prefs_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function commitDef($frm) 
{
   $qry=sprintf(cart_prefs_qry3, $frm['sessiontimeout'],'sessiontimeout');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['language'],'language');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['dateformat'],'dateformat');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['listpagesize'],'listpagesize');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['defaultimgx'],'defaultimgx');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['defaultimgy'],'defaultimgy');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['baseinstalldir'],'baseinstalldir');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['configroot'],'configroot');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['imageroot'],'imageroot');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['wwwroot'],'wwwroot');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['theme'],'theme');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['defaultcurrency'],'defaultcurrency');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['defaultcountry'],'defaultcountry');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['style'],'style');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['maxalsobought'],'maxalsobought');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['guest_cart'],'guest_cart');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['regtype'],'regtype');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['loglevel'],'loglevel');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['papersize'],'papersize');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['taxinclusive'],'taxinclusive');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['allowguestreview'],'allowguestreview');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['checkmx'],'checkmx');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['hashlogin'],'hashlogin');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['priceprivate'],'priceprivate');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['domainname'],'domainname');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry3, $frm['mailtype'],'mailtype');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   
   $qry=sprintf(cart_prefs_qry4, $frm['lastlogin'],'lastlogin');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry4, $frm['numlogin'],'numlogin');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry4, $frm['subscribenewsletter'],'subscribenewsletter');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry4, $frm['subscribeupdates'],'subscribeupdates');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry4, $frm['subscribespecials'],'subscribespecials');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry4, $frm['subscribenewproducts'],'subscribenewproducts');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry4, $frm['carttheme'],'carttheme');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry4, $frm['cartlistpagesize'],'cartlistpagesize');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry4, $frm['cartlanguage'],'cartlanguage');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry4, $frm['catalogueid'],'catalogueid');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry4, $frm['numproductsbought'],'numproductsbought');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(cart_prefs_qry4, $frm['valueproductbought'],'valueproductbought');
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function ThemeCombo($a, $t)
{
   // parse theme dirs and files in /style/XXX/theme
   echo "<select name=\"theme\">\n";
   if($handle=opendir($_SESSION['VxCFG']->dirroot."/style")){
      while(false!==($file=readdir($handle))){ 
         if(is_dir($file)) continue;
         if($t==$file){
            echo "<option value=\"$file\" selected>$file</option>\n";
         }
         else{
            echo "<option value=\"$file\">$file</option>\n";
         }
      }
   }
   echo "</select>\n";
   closedir($handle); 
}

function PaperSizeCombo($a, $s)
{
   echo "<select name=\"pagesize\">\n";
   if($s=='A3') echo "<option value=\"A3\" selected>A3</option>\n";
   else echo "<option value=\"A3\">A3</option>\n";
   if($s=='A4' || $s='') echo "<option value=\"A4\" selected>A4</option>\n";
   else echo "<option value=\"A4\">A4</option>\n";
   if($s=='A5') echo "<option value=\"A5\" selected>A5</option>\n";
   else echo "<option value=\"A5\">A5</option>\n";
   if($s=='Letter') echo "<option value=\"Letter\" selected>Letter</option>\n";
   else echo "<option value=\"Letter\">Letter</option>\n";
   if($s=='Letter') echo "<option value=\"Legal\" selected>Legal</option>\n";
   else echo "<option value=\"Legal\">Legal</option>\n";
   echo "</select>\n";
}

function PdfPaperSizeCombo($a, $s)
{
   echo "<select name=\"pdfpagesize\">\n";
   if($s=='A3') echo "<option value=\"A3\" selected>A3</option>\n";
   else echo "<option value=\"A3\">A3</option>\n";
   if($s=='A4' || $s='') echo "<option value=\"A4\" selected>A4</option>\n";
   else echo "<option value=\"A4\">A4</option>\n";
   if($s=='A5') echo "<option value=\"A5\" selected>A5</option>\n";
   else echo "<option value=\"A5\">A5</option>\n";
   if($s=='Letter') echo "<option value=\"Letter\" selected>Letter</option>\n";
   else echo "<option value=\"Letter\">Letter</option>\n";
   if($s=='Letter') echo "<option value=\"Legal\" selected>Legal</option>\n";
   else echo "<option value=\"Legal\">Legal</option>\n";
   echo "</select>\n";
}

function AccCombo($a, $v)
{
   echo "<select name=\"accountingmethod\">\n";
   if($s=='cash') echo "<option value=\"cash\" selected>"._("Cash")."</option>\n";
   else echo "<option value=\"cash\">"._("Cash")."</option>\n";
   if($s=='accrual') echo "<option value=\"accrual\" selected>"._("Accrual")."</option>\n";
   else echo "<option value=\"accrual\">"._("Accrual")."</option>\n";
   echo "</select>\n";
}

function CurrencyCombo($a, $id)
{
   $c=new Currency();
   $c->Combo($a, $id, "defaultcurrency");
}

function CountryCombo($a, $id)
{
   $c=new Country();
   $c->Combo($a, $id, "defaultcountry");
}

function LangCombo($a, $l)
{
   // open available languages from file /lib/lang/list
   if(file_exists($_SESSION['VxCFG']->libdir."/lang")){
      echo "<select name=\"language\">\n";
      if(($fd=fopen($_SESSION['VxCFG']->libdir."/lang", 'r'))){
         while(($buffer = fgets($fd, 128))){
            $buffer=trim($buffer);
            $lang=explode(":", $buffer);
            $lc=trim($lang[0]);
            $desc=trim($lang[1]);
            if($l==$lc){
              echo "<option value=\"$lc\" selected>$lc - $desc</option>\n";
            }
            else{
               echo "<option value=\"$lc\">$lc - $desc</option>\n";
            }
         }
         fclose ($fd);
      }
      echo "</select>\n";
   }
}

function TimeControl($a, $t)
{
   $ts=new TimeDate($t);
   if($a=="start"){
      $ts->timecontrol("commit", "starttime");
   }
   else{
      $ts->timecontrol("commit", "endtime");
   }
}

function WeekControl($a, $w)
{
   echo "<select name=\"firstweekofyear\">\n";
   for($i=1; $i < 53; $i++){
      if($i==$w){
         echo "<option value=\"$i\" selected>$i</option>\n";
      }
      else{
         echo "<option value=\"$i\">$i</option>\n";
      }
   }
   echo "</select>\n";
}

function DayControl($a, $d)
{
   echo "<select name=\"firstdayofweek\">\n";
   for($i=5; $i < 12; $i++){
      $x=$i-5;
      if($x==$d){ 
         echo "<option value=\"".$x."\" selected>".date("l", mktime(0, 0, 0, 9, $i, 2005))."</option>\n";
      }
      else{
         echo "<option value=\"".$x."\">".date("l", mktime(0, 0, 0, 9, $i, 2005))."</option>\n";
      }
   }
   echo "</select>\n";
}

function DefPageCombo($a, $d)
{
   echo "<select name=\"defaultstartpage\">\n";
   if($d=="main.php"){
      echo "<option value=\"main.php\" selected>"._("Information")."</option>\n";
   }
   else{
      echo "<option value=\"main.php\">"._("Information")."</option>\n";
   }
   
   if($d=="users/usertoday.php"){
      echo "<option value=\"users/usertoday.php\" selected>"._("Today")."</option>\n";
   }
   else{
      echo "<option value=\"users/usertoday.php\">"._("Today")."</option>\n";
   }
   echo "</select>\n";
}

function CatalogueCombo($a, $d)
{
   
   echo "<select name=\"catalogueid\">\n";
   echo "<option value=\"0\" selected>"._("No Catalogues Defined")."</option>\n";
   echo "</select>\n";
}

function MailCombo($a, $d)
{
   echo "<select name=\"mailtype\">\n";
   if($d==1){
      echo "<option value=\"1\" selected>"._("Automatic")."</option>\n";
      echo "<option value=\"2\">"._("Automatic")."</option>\n";
      echo "<option value=\"3\">"._("Automatic")."</option>\n";
   }
   if($d==2){
      echo "<option value=\"1\">"._("Automatic")."</option>\n";
      echo "<option value=\"2\" selected>"._("Automatic")."</option>\n";
      echo "<option value=\"3\">"._("Automatic")."</option>\n";
   }
   if($d==3){
      echo "<option value=\"1\">"._("Automatic")."</option>\n";
      echo "<option value=\"2\">"._("Automatic")."</option>\n";
      echo "<option value=\"3\" selected>"._("Automatic")."</option>\n";
   }
   echo "</select>\n";
}

function RegCombo($a, $d)
{
   echo "<select name=\"regtype\">\n";
   if($d=='auto'){
      echo "<option value=\"auto\" selected>"._("Automatic")."</option>\n";
      echo "<option value=\"confirm\">"._("Confirm")."</option>\n";
      echo "<option value=\"approve\">"._("Approve")."</option>\n";
   }
   if($d=='confirm'){
      echo "<option value=\"auto\">"._("Automatic")."</option>\n";
      echo "<option value=\"confirm\" selected>"._("Confirm")."</option>\n";
      echo "<option value=\"approve\">"._("Approve")."</option>\n";
   }
   if($d=='approve'){
      echo "<option value=\"auto\">"._("Automatic")."</option>\n";
      echo "<option value=\"confirm\">"._("Confirm")."</option>\n";
      echo "<option value=\"approve\" selected>"._("Approve")."</option>\n";
   }
   echo "</select>\n";
}

function listDef()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(cart_pref_qry2);
 
   while($row = $result->FetchRow()){
      switch($row['name']){
      case 'baseinstalldir':
         $frm['baseinstalldir']=$row['value'];
         break;
      case 'sessiontimeout':
         $frm['sessiontimeout']=$row['value'];
         break;
      case 'language':
         $frm['language']=$row['value'];
         break;
      case 'dateformat':
         $frm['dateformat']=$row['value'];
         break;
      case 'listpagesize':
         $frm['listpagesize']=$row['value'];
         break;
      case 'defaultimgx':
         $frm['defaultimgx']=$row['value'];
         break;
      case 'defaultimgy':
         $frm['defaultimgy']=$row['value'];
         break;
      case 'configroot':
         $frm['configroot']=$row['value'];
         break;
      case 'imageroot':
         $frm['imageroot']=$row['value'];
         break;
      case 'wwwroot':
         $frm['wwwroot']=$row['value'];
         break;
      case 'theme':
         $frm['theme']=$row['value'];
         break;
      case 'defaultcurrency':
         $frm['defaultcurrency']=$row['value'];
         break;
      case 'defaultcountry':
         $frm['defaultcountry']=$row['value'];
         break;
      case 'style':
         $frm['style']=$row['value'];
         break;
      case 'maxalsobought':
         $frm['maxalsobought']=$row['value'];
         break;
      case 'guest_cart':
         $frm['guest_cart']=$row['value'];
         break;
      case 'regtype':
         $frm['regtype']=$row['value'];
         break;
      case 'loglevel':
         $frm['loglevel']=$row['value'];
         break;
      case 'taxinclusive':
         $frm['taxinclusive']=$row['value'];
         break;
      case 'allowguestreview':
         $frm['allowguestreview']=$row['value'];
         break;
      case 'checkmx':
         $frm['checkmx']=$row['value'];
         break;
      case 'hashlogin':
         $frm['hashlogin']=$row['value'];
         break;
      case 'priceprivate':
         $frm['priceprivate']=$row['value'];
         break;
      case 'domainname':
         $frm['domainname']=$row['value'];
         break;
      case 'mailtype':
         $frm['mailtype']=$row['value'];
         break;
      }
   }
 
   $result=$_SESSION['VxCFG']->dbh->Execute(cart_pref_qry5);
   /*
   'lastlogin');
   'numlogin');
   'numproductsbought'
   'valueproductbought'
   */
   while($row = $result->FetchRow()){
      switch($row['name']){
      case 'subscribenewsletter':
         $frm['subscribenewsletter']=$row['value'];
         break;
      case 'subscribeupdates':
         $frm['subscribeupdates']=$row['value'];
         break;
      case 'subscribenewproducts':
         $frm['subscribenewproducts']=$row['value'];
         break;
      case 'carttheme':
         $frm['carttheme']=$row['carttheme'];
         break;
      case 'cartlistpagesize':
         $frm['cartlistpagesize']=$row['value'];
         break;
      case 'cartlanguage':
         $frm['cartlanguage']=$row['value'];
         break;
      case 'catalogueid':
         $frm['catalogueid']=$row['value'];;
         break;
      }
   }
   
	$frm["newaction"] = "commit";
   $_REQUEST["action"] = "commit";
	
	include("templates/prefs.php");
}

?>
