<?php
/*
promo.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
//require_once($_SESSION['VxCFG']->libdir."/promo.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(4);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()=='' || $_SESSION['vxmisuser']->GetSortOn()=='startdate'){
   $_SESSION['vxmisuser']->SetSortOn('startdtat');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Product Promotions"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Product Promotions");
}

if($_SESSION["pageindex"]->CheckNum(cart_promo_qry1, "promotion")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
   case "clear" :
      addPromo();
      break;

   case "browse":
      if(isset($_REQUEST['id'])){
         browsePromo($_REQUEST['id']);
         break;
      }
      browsePromo($_POST['id']);
      break;

   case "edit" :
      editPromo($_REQUEST['id']);
      break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelPromo($_REQUEST['id']);
      }
      else{
         deletePromo($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listFI();
      }
      break;

   case "cfmdelete" :
      deletePromo($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listPromo();
      break;

   case "add" :
      insertPromo($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listPromo();
      break;

   case "commit" :
      commitPromo($_POST);
      listPromo();
      break;

   case "search" :
      searchPromo();
      break;
   
   case "sresults" :
      searchResults($_POST);
      break;
      
   case "list":
   default :
      listPromo();
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(cart_promo_qry1);
   if(!$result) return 0;
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["newaction"] = "";
   $frm["id"] = 0;
   $id;
   $frm["promotionid"] = "";
   $frm["typeid"] = "";
   $frm["name"] = "";
   $frm["startdate"] = "";
   $frm["enddate"] = "";
   $frm["targetid"] = "";
   $frm["promolinkid"] = "";
   
   return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(cart_promo_qry2, $id);
   }
   else{
      $qry=sprintf(cart_promo_qry3, $id);
   }
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();

   $frm["id"] = $row['id'];
   $frm["productid"] = $row["productid"];
   $frm["promotionid"]=$row["promotionid"];
   $frm["headline"]=$row["headline"];
   $frm["body"]=$row["body"];
   
   if($row['productid']==0){
      $frm['pname']="";
   }
   else{
      $qry=sprintf(cart_promo_qry8, $row["productid"]);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      $frm["pname"]=$row["name"];
   }
   
   $qry=sprintf(cart_promo_qry9, $frm["promotionid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["startdate"]=$row["startdate"];
	$frm["enddate"]=$row["enddate"];
	$frm["margin"]=$row["margin"];
   
   return $frm;
}

function addPromo()
{
  $frm=clearForm();
  $frm["newaction"] = "add";

  include("templates/promo.php");
}

function editPromo($id) 
{
  $frm=fillForm($id, false);
  $frm["newaction"] = "commit";

  include("templates/promo.php");
}

function browsePromo($id) 
{
  $frm=fillForm($id, true);
  $frm["newaction"] = "browse";
  
  include("templates/promo.php");
}

function chkdelPromo($id)
{
  $frm=fillForm($id, false);
  $frm["newaction"] = "cfmdelete";
   
  include("templates/promo.php");
}

function insertPromo($frm) 
{
   /*
   $qry=sprintf(cart_promo_qry4,$frm['productid'],$frm['productid'],$frm['typeid'],$frm['startdate'],$frm['enddate'],
   $frm['margin'], $frm['memo']);*/
   
   
   $qry=sprintf(cart_promo_qry4,$frm['productid'],$frm['productid'],$frm['headline'],$frm['body']);
   
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitPromo($frm) 
{
   $qry=sprintf(cart_promo_qry5,$frm['productid'],$frm['productid'],$frm['headline'],$frm['body'],$frm['id']);
   /*
   $frm['startdate'],$frm['enddate'],$frm['id']);
   echo $qry;*/
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function deletePromo($frm) 
{
   $qry=sprintf(cart_promo_qry6, $frm["id"]);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function searchPromo()
{
   $frm["newaction"] = "sresults";
   
  include("templates/fisearch.php");
}

function searchResults($frm)
{
}

function DateControl($a, $d, $n)
{
   $td=new TimeDate();
   /*
   if($a=="commit" || $a=="add"){
     $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
      if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{*/
      $td->parse($d);
   //}
   $td->displayex('date', $a, $n, $d);
}

function listPromo()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(cart_promo_qry7, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no promotions defined")."</td></td></table>\n";
      return;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no promotions defined")."</td></td></table>\n";
      return;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='startdate'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Starts")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Starts")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=startdate\">"._("Starts")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='startdate'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='enddate'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Ends")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Ends")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=enddate\">"._("Ends")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='enddate'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   while($row = $result->FetchRow()){
      $qry=sprintf(cart_promo_qry9, $row["promotionid"]);
      $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
      $prow = $presult->FetchRow();
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">".$prow["startdate"]."</td>";
         echo "<td class=\"listdata\">".$prow["enddate"]."</td>";
         echo "<td class=\"listdata\">";
         if($row['productid']==0){
            echo _("Not Set");
         }
         else{
            $qry=sprintf(cart_promo_qry8, $row["productid"]);
            $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
            $prow = $result->FetchRow();
            echo $prow["name"];
         }
         echo "</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$prow["startdate"]."</td>";
         echo "<td class=\"listdataeven\">".$prow["enddate"]."</td>";
         echo "<td class=\"listdataeven\">";
         if($row['productid']==0){
            echo _("Not Set");
         }
         else{
            $qry=sprintf(cart_promo_qry8, $row["productid"]);
            $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
            $prow = $result->FetchRow();
            echo $prow["name"];
         }
         echo "</td><td class=\"listdataeven\">";
      }
      $wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"promo.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"promo.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"promo.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
        echo "<a href=\"promo.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"promo.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"promo.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
  }
  echo "</table>";
}

?>
