<?php
/*
stats.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/phplot/phplot.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(-1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Cart Statistics"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Cart Statistics");
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
     break;
   case 'pageprev':
     $_SESSION["pageindex"]->pgprev();
     break;
   case 'prev':
     $_SESSION["pageindex"]->prev();
     break;
   case 'next':
     $_SESSION["pageindex"]->next();
     break;
   case 'pagenext':
     $_SESSION["pageindex"]->pgnext();
     break;
   case 'end':
      if($_REQUEST['action']=="list")
        $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
     break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}
$NoNavigationFlag=true;
include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
   case "list":
	default :
      Details();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(cart_ratings_qry1);
   if($result) return 0;
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function ProductName($id)
{
}

function CategoryName($id)
{
}

function Details()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(cart_stats_qry5);
   $row = $result->FetchRow();
   $yearstart=$row[0]."-01-01";
   $year=$row[0];
   $result=$_SESSION['VxCFG']->dbh->Execute(cart_stats_qry4);
   $row = $result->FetchRow();
   $monthstart=$year."-".$row[0]."-01";
   $result=$_SESSION['VxCFG']->dbh->Execute(cart_stats_qry3);
   $row = $result->FetchRow();
   $now=$row[0];

   $lastlogin=$_SESSION['vxmisuser']->get_last_login();

   //searched on
   $qry=sprintf(cart_stats_qry2, 1, $lastlogin);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(($row=$result->FetchRow())){
      $frm["mostsearchs"]=$row[0];
   }
   else{
      $frm["mostsearchs"]="0";
   }
   //cart cancelled
   $qry=sprintf(cart_stats_qry2, 2, $lastlogin);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(($row=$result->FetchRow())){
      $frm["numcartcancelled"]=$row[0];
   }
   else{
      $frm["numcartcancelled"]="0";
   }
   // product view
   $qry=sprintf(cart_stats_qry2, 7, $lastlogin);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(($row=$result->FetchRow())){
      $frm["prodview"]=$row[0];
   }
   else{
      $frm["prodview"]="0";
   }
   // logins
   $qry=sprintf(cart_stats_qry2, 8, $lastlogin);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(($row=$result->FetchRow())){
      $frm["numnlogin"]=$row[0];
   }
   else{
      $frm["numnlogin"]="0";
   }
   
   $frm["numpageview"]="0";
   $frm["numreview"]="0";
   $frm["catview"]="0";
   
   
   //searched on
   $qry=sprintf(cart_stats_qry1, 1, $monthstart, $now);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(($row=$result->FetchRow())){
      $frm["mmostsearchs"]=$row[0];
   }
   else{
      $frm["mmostsearchs"]="0";
   }
   
   //cart cancelled
   $qry=sprintf(cart_stats_qry1, 2, $monthstart, $now);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(($row=$result->FetchRow())){
      $frm["mnumcartcancelled"]=$row[0];
   }
   else{
      $frm["mnumcartcancelled"]="0";
   }
   // product view
   $qry=sprintf(cart_stats_qry1, 7, $monthstart, $now);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(($row=$result->FetchRow())){
      $frm["mprodview"]=$row[0];
   }
   else{
      $frm["mprodview"]="0";
   }
   // logins
   $qry=sprintf(cart_stats_qry1, 8, $monthstart, $now);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(($row=$result->FetchRow())){
      $frm["mnumnlogin"]=$row[0];
   }
   else{
      $frm["mnumnlogin"]="0";
   }
   
   $frm["mnumpageview"]="0";
   $frm["mnumreview"]="0";
   $frm["mcatview"]="0";
   
   
   //searched on
   $qry=sprintf(cart_stats_qry1, 1, $yearstart, $now);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(($row=$result->FetchRow())){
      $frm["ymostsearchs"]=$row[0];
   }
   else{
      $frm["ymostsearchs"]="0";
   }
   //cart cancelled
   $qry=sprintf(cart_stats_qry1, 2, $yearstart, $now);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(($row=$result->FetchRow())){
      $frm["ynumcartcancelled"]=$row[0];
   }
   else{
      $frm["ynumcartcancelled"]="0";
   }
   // product view
   $qry=sprintf(cart_stats_qry1, 7, $yearstart, $now);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(($row=$result->FetchRow())){
      $frm["yprodview"]=$row[0];
   }
   else{
      $frm["yprodview"]="0";
   }
   // logins
   $qry=sprintf(cart_stats_qry1, 8, $yearstart, $now);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(($row=$result->FetchRow())){
      $frm["ynumnlogin"]=$row[0];
   }
   else{
      $frm["ynumnlogin"]="0";
   }
   $frm["ynumpageview"]="0";
   $frm["ynumreview"]="0";
   $frm["ycatview"]="0";
   
   
   // referer
   
   // user agent
   include("templates/stats.php");
}

function VolumeByMonth()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(cart_stats_qry5);
   $row = $result->FetchRow();
   $d=$row[0]."-01-01";
   $year=$row[0];
   $result=$_SESSION['VxCFG']->dbh->Execute(cart_stats_qry4);
   $row = $result->FetchRow();
   $m=$row[0]+1;
   
   $result=$_SESSION['VxCFG']->dbh->Execute(cart_stats_qry3);
   $row = $result->FetchRow();
   $now=$row[0];

   $qry=sprintf(cart_stats_qry6, $d, $now);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   while(($row=$result->FetchRow())){
      $counts[] = @ array($row[1],$row[3],$row[3]);
      $legend[] = $row[1];
   }
   //print_r($counts);
   for($month=1; $month!=$m; $month++){
      $sd=$year."-".$month."-01";
      $ed=$year."-".$month."-31";
      $qry=sprintf(cart_stats_qry6, $sd, $ed);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $label=strftime('%b',mktime(0,0,0,$month,1,0));
      if($result){
         $row = $result->FetchRow();
         if($row) $a1=$row[2];
         else $a1=0.0;
         $row = $result->FetchRow();
         if($row) $a2=$row[2];
         else $a2=0.0;
         $row = $result->FetchRow();
         if($row) $a3=$row[2];
         else $a3=0.0;
         $row = $result->FetchRow();
         if($row) $a4=$row[2];
         else $a4=0.0;
      }
      else{
         $a1=0.0;
         $a2=0.0;
         $a3=0.0;
         $a4=0.0;
      }
      $amount[] = @ array($label,$a1,$a2,$a3,$a4);
   }
   
   /*
   $cscale = array_search(max($counts),$counts); //Find the position of maximum value.
   $ascale = array_search(max($amount),$amount);
   */
   $graphc = & new PHPlot(480,380, "volbymonth.png");
   $graphc->SetDataType("text-data-pie");
   $graphc->SetTitle("Volume by Category");
   $graphc->SetDataValues($counts);
   $graphc->SetPlotType('pie');
   $graphc->SetFileFormat('png');
   $graphc->SetLegend($legend);
   
   $grapha = new PHPlot(480,380,"amtbymonth.png");
   $grapha->SetDataType("text-data");
   $grapha->SetDataValues($amount);
   $grapha->SetTitle("Revenue");
   $grapha->SetPlotType('bars');
   $grapha->SetFileFormat('png');
   $grapha->SetXGridLabelType('title');
   $grapha->SetXScaleType('linear');
   $grapha->SetXTitle('Month');
   $grapha->SetYTitle('Amount');
   $grapha->SetShading(5);
   $grapha->SetDrawYGrid(TRUE);
   $grapha->SetMarginsPixels(80,40,40,40);
   /*
   $grapha->SetDataColors(
      array("blue","red"), //Data Colors
      array("black")       //Border Colors
   );*/

   $graphc->SetIsInline(true);
   $grapha->SetIsInline(true);
   $graphc->DrawGraph();
   $grapha->DrawGraph();
   echo "<img src=\"volbymonth.png\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
   echo "<img src=\"amtbymonth.png\">\n";
}

?>
