<?php
/*
company.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('companyname');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']);

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Company Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Company Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(company_company_qry1, "company")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
   case "clear" :
      addCompany();
      break;

   case "browse":
      if(isset($_REQUEST['id'])){
         browseCompany($_REQUEST['id']);
         break;
      }
      browseCompany($_POST['id']);
      break;

   case "edit" :
      editCompany($_REQUEST['id']);
      break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelCompany($_REQUEST['id']);
      }
      else{
         deleteCompany($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listCompany();
      }
    break;

   case "cfmdelete" :
      deleteCompany($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listCompany();
      break;

   case "add" :
      insertCompany($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listCompany();
    break;

   case "commit" :
      commitCompany($_POST);
      listCompany();
      break;
  
   case "duplicate" :
      $id=duplicateCompany($_REQUEST['id']);
      editCompany($id);
      break;

   case "search" :
      searchCompany();
      break;
   
   case "sresults" :
      searchResults($_POST);
      break;
      
   case "list":
   default :
      listCompany();
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(company_company_qry1);
   if(!$result) return 0;
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["newaction"] = "";
   $frm["showdeps"] = "";
   $frm["id"] = 0;
   $frm["attributeid"] = 0;
   $frm["tradingname"] = "";
   $frm["companyname"] = "";
   $frm['cmid']=0;
   $frm['accountingdate']="";
   $frm['registrationnumber']="";
   $frm['taxnumber']="";
   //$frm['ismaster']='N';
   $frm['cashaccounting']='Y';
   $frm['shipnumber']='000000';
   $frm['orderapproval']='Y';
   $frm['orderstockpick']='Y';
   $frm['orderpackage']='Y';
  
  return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(company_company_qry2, $id);
   }
   else{
      $qry=sprintf(company_company_qry3, $id);
   }
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();

   $frm["id"] = $row["id"];
   $frm["attributeid"] = $row["attributeid"];
   $frm["tradingname"] = $row["tradingname"];
   $frm["companyname"] = $row["companyname"];
   $frm['orderapproval']=0;
   $frm['orderstockpick']=0;
   $frm['orderpackage']=0;
   
   $qry=sprintf(company_company_qry12,$frm["attributeid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result->RecordCount()==0){
      $frm['cmid']=0;
      $frm['accountingdate']="";
      $frm['registrationnumber']="";
      $frm['taxnumber']="";
      //$frm['ismaster']='N';
      $frm['cashaccounting']='Y';
      $frm['shipnumber']='000000';
   }
   else{
      while($row = $result->FetchRow()){
         switch($row['name']){
         case 'cmid':
            $frm['cmid']=$row['value'];
            break;
         case 'accountingdate':
            $frm['accountingdate']=$row['value'];
            break;
         case 'registrationnumber':
            $frm['registrationnumber']=$row['value'];
            break;
         case 'taxnumber':
            $frm['taxnumber']=$row['value'];
            break;
         /*
         case 'ismaster':
            $frm['ismaster']=$row['value'];
            break;*/
         case 'cashaccounting':
            $frm['cashaccounting']=$row['value'];
            break;
            
         case 'shipnumber':
            $frm['shipnumber']=$row['value'];
            break;
            
         case 'orderapproval':
            $frm['orderapproval']=$row['value'];
            break;
         case 'orderstockpick':
            $frm['orderstockpick']=$row['value'];
            break;
         case 'orderpackage':
            $frm['orderpackage']=$row['value'];
            break;
         }
      }
   }

  return $frm;
}

function addCompany()
{
  $frm=clearForm();
  $frm["newaction"] = "add";

  include("templates/company.php");
}

function editCompany($id) 
{
  $frm=fillForm($id, false);
  $frm["newaction"] = "commit";

  include("templates/company.php");
}

function browseCompany($id) 
{
  $frm=fillForm($id, true);
  $frm["newaction"] = "browse";
  
  include("templates/company.php");
}

function fillsites($id)
{
   $qry=sprintf(company_company_qry10, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);  
   if(!$result) return;
   while($row = $result->FetchRow()){
      $did=$row["id"];
      $name=$row["name"];
      echo "<tr><td class=\"formdata\" colspan=\"2\"><a href=\"site.php?action=browse&id=$did\">$name</a></td></tr>";
   }
}

function fillunits($id)
{
   $qry=sprintf(company_company_qry10, $id);
   echo $qry;
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);  
   if(!$result) return;
   while($row = $result->FetchRow()){
      $did=$row["id"];
      $name=$row["name"];
      echo "<tr><td class=\"formdata\" colspan=\"2\"><a href=\"bunit.php?action=browse&id=$did\">$name</a></td></tr>";
   }
}

function chkdelCompany($id)
{
   $frm=fillForm($id, false);
   $qry=sprintf(company_company_qry10, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);  
   $frm["numsites"]=db_num_rows($result);
/*
   $qry=sprintf(company_site_qry12, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);  
   $row = $result->FetchRow();
   $frm["name"]=$row["name"];

   $frm["id"]=$id; */
   $frm["newaction"] = "cfmdelete";
   
   include("templates/company.php");
}

function insertCompany($frm) 
{
   $qry=sprintf(company_company_qry4,$frm['attributeid'],$frm['tradingname'],$frm['companyname']);
   $_SESSION['VxCFG']->dbh->StartTrans();
   $_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=company&err=insert");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $cid=$row[0];
   
   $_SESSION['VxCFG']->dbh->Execute(company_company_qry14);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   $attribid=$row[0];
   $qry=sprintf(company_company_qry17, $attribid, $cid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   $qry=sprintf(company_company_qry15, $attribid, $attribid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   $d="0000-".$frm['month']."-".$frm['day'];
   $qry=sprintf(company_company_qry18, 'accountingdate','6',$d,$attribid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry16, $attribid,'registrationnumber','1',$frm['registrationnumber']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry16, $attribid,'taxnumber','1',$frm['taxnumber']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   //$qry=sprintf(company_company_qry16, $attribid,'ismaster','3',$row[0],$frm['ismaster']);
   //$_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry16, $attribid,'cashaccounting','3',$frm['cashaccounting']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry16, $attribid,'shipnumber','1',$frm['shipnumber']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry16, $attribid,'orderapproval','3',yesno(isset($frm['orderapproval'])));
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry16, $attribid,'orderstockpick','3',yesno(isset($frm['orderstockpick'])));
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry16, $attribid,'orderpackage','3',yesno(isset($frm['orderpackage'])));
   $_SESSION['VxCFG']->dbh->Execute($qry);

   return $cid;
}

function commitCompany($frm) 
{
   $qry=sprintf(company_company_qry5,$frm['attributeid'],$frm['tradingname'],$frm['companyname'],$frm['id']);
   $_SESSION['VxCFG']->dbh->StartTrans();
   $_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=company&err=commit");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
   
   $d=$frm['day']."-".$frm['month']."-0000";
   $qry=sprintf(company_company_qry13, $d,'accountingdate',$frm['attributeid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry13, $frm['registrationnumber'],'registrationnumber',$frm['attributeid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry13, $frm['taxnumber'],'taxnumber',$frm['attributeid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   //$qry=sprintf(company_company_qry13, $frm['ismaster'],'ismaster',$frm['attributeid']);
   //$_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry13, $frm['cashaccounting'],'cashaccounting',$frm['attributeid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry13, $frm['shipnumber'],'shipnumber',$frm['attributeid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry13, yesno(isset($frm['orderapproval'])),'orderapproval',$frm['attributeid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry13, yesno(isset($frm['orderstockpick'])),'orderstockpick',$frm['attributeid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   $qry=sprintf(company_company_qry13, yesno(isset($frm['orderpackage'])),'orderpackage',$frm['attributeid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function deleteCompany($frm) 
{
   if(yesno(isset($frm["reassign"]))=="Y"){
      $nsite=$frm["sites"];
      $qry=sprintf(company_company_qry7, $nsite, $frm["id"]);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   else{
      $qry=sprintf(company_company_qry8, $frm["id"]);
      $_SESSION['VxCFG']->dbh->Execute($qry);  
   }

   $qry=sprintf(company_company_qry6, $frm["id"]);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function duplicateCompany($id) 
{
   $frm=fillForm($id, false);
   return insertCompany($frm);
}

function searchCompany()
{
   $frm["newaction"] = "sresults";
   
  include("templates/companysearch.php");
}


function Accradio($a, $v)
{
   if($a=="add" || $a=="commit"){
      if($v=='Y'){
         echo "<input type=\"radio\" name=\"cashaccounting\" value=\"Y\" checked>Cash\n";
         echo "<input type=\"radio\" name=\"cashaccounting\" value=\"N\">Accrual\n";
      }
      else{
         echo "<input type=\"radio\" name=\"cashaccounting\" value=\"Y\">Cash\n";
         echo "<input type=\"radio\" name=\"cashaccounting\" value=\"N\" checked>Accrual\n";
      }
   }
   else{
      if($v=='Y'){
         echo "Profit/Loss";
      }
      else{
         echo "Balance Sheet";
      }
   }
}

function DateControl($a, $d)
{
   $td=new TimeDate();
   if($a=="add"){
	   $result=db_query(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   //$td->displayex('datenoyear', $a, '', $d);
   $td->datecontrol_noyear($a, "");
}


function searchResults($frm)
{
}

function listCompany()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(company_company_qry9, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no companies defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='companyname'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Company Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Company Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=companyname\">"._("Company Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='companyname'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='tradingname'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Trading Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Trading Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=tradingname\">"._("Trading Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='tradingname'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   while($row = $result->FetchRow()){
      if($c%2){
         echo "<tr class=\"listdata\">\n<td class=\"listdata\">".$row["companyname"]."</td>\n";
         echo "<td class=\"listdata\">".$row["tradingname"]."</td>";
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\">\n<td class=\"listdataeven\">".$row["companyname"]."</td>\n";
         echo "<td class=\"listdataeven\">".$row["tradingname"]."</td>";
         echo "<td class=\"listdataeven\">";
      }
      $wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"company.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"company.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"company.php?action=delete&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
        echo "<a href=\"company.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"company.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"company.php?action=delete&id=$wibbler&offset=$offset\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
   }
   echo "</table>";
}

?>
