<?php
/*
site.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/locale.php");
require_once($_SESSION['VxCFG']->libdir."/currency.php");
require_once($_SESSION['VxCFG']->libdir."/bank.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(2);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Site Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Site Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(company_site_qry1, "site")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
   case "clear" :
      addSite();
      break;

   case "browse":
      if(isset($_REQUEST['id'])){
         browseSite($_REQUEST['id']);
         break;
      }
      browseSite($_POST['id']);
      break;

   case "edit" :
      editSite($_REQUEST['id']);
      break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelSite($_REQUEST['id']);
      }
      else{
         deleteSite($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listSite();
      }
      break;

   case "cfmdelete" :
      deleteSite($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listSite();
      break;

   case "add" :
      insertSite($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listSite();
      break;

   case "commit" :
      commitSite($_POST);
      listSite();
      break;
    
   case "duplicate" :
      $id=duplicateSite($_REQUEST['id']);
      editSite($id);
      break;

   case "search" :
      searchSite();
      break;
   
   case "sresults" :
      searchResults($_POST);
      break;
      
   case "list":
   default :
      listSite();
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(company_site_qry1);
   if(!$result) return 0;
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["newaction"] = "";
   $frm["showdeps"] = "";
   $frm["id"] = 0;
   $frm["name"] = "";
   $frm["businessunitid"]=0;
   $frm["addressid"]="";
   $frm["contactid"]="";
   $frm["localeid"]="";
   $frm["currencyid"]="";
   $frm["bankid"]="";
   $frm["annualbudget"] = "0.00";
   $frm["site"]="";
   $frm["encryption"]="";
   $frm["login"]="";
   $frm["password"]="";
   $frm["active"]="Y";
  
  return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(company_site_qry2, $id);
   }
   else{
      $qry=sprintf(company_site_qry3, $id);
   }
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();

   $frm["id"] = $row["id"];
   $frm["siteid"]=$row["siteid"];
   $frm["name"] = $row["name"];
   $frm["businessunitid"]=$row["businessunitid"];
   $aid=$frm["addressid"] = $row["addressid"];
   $frm["contactid"] = $row["contactid"];
   $frm["localeid"] = $row["localeid"];
   $bcid=$frm["currencyid"] = $row["currencyid"];
   $frm["bankid"]=$row["bankid"];
   $frm["annualbudget"] = $row["annualbudget"];
   $frm["site"]=$row["site"];
   $frm["encryption"]=$row["encryption"];
   $frm["login"]=$row["login"];
   $p=strlen($row["password"]);
   $frm["password"]=$row["password"];
   $frm["active"]=$row["active"];

   return $frm;
}

function addSite()
{
  $frm=clearForm();
  $frm["newaction"] = "add";

  include("templates/site.php");
}

function editSite($id) 
{
  $frm=fillForm($id, false);
  $frm["newaction"] = "commit";

  include("templates/site.php");
}

function browseSite($id) 
{
  $frm=fillForm($id, true);
  $frm["newaction"] = "browse";
  
  include("templates/site.php");
}

function filldepts($id)
{
   $qry=sprintf(company_site_qry10, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);  
   while($row = $result->FetchRow()){
      $did=$row["id"];
      $name=$row["name"];
      echo "<tr><td class=\"formdata\" colspan=\"2\"><a href=\"dept.php?action=browse&id=$did\">$name</a></td></tr>";
   }
}

function chkdelSite($id)
{
   //$frm=fillForm($id, false);
   $qry=sprintf(company_site_qry10, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);  
   $frm["numdepts"]=db_num_rows($result);

   $qry=sprintf(company_site_qry12, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);  
   $row = $result->FetchRow();
   $frm["name"]=$row["name"];

   $frm["id"]=$id; 
   $frm["newaction"] = "cfmdelete";
   
  include("templates/sitedel.php");
}

function insertSite($frm) 
{
   $name=$frm["name"];
   $ab=$frm["annualbudget"];
   $h=$frm["contactid"];
   
   $a=new Address();
   $a->SetFromForm($frm);
   $adid=$a->Add();
   
   $qry=sprintf(company_site_qry4,$frm['name'],$frm['businessunitid'],$adid,$frm['contactid'],$frm['localeid'],$frm['currencyid'], 
    $frm['bankid'],$frm['annualbudget'],$frm['site'],$frm['encryption'],$frm['login'], $frm['password'],
    yesno(isset($frm['active'])));
   //$_SESSION['VxCFG']->dbh->StartTrans();
   $_SESSION['VxCFG']->dbh->Execute($qry);
   //if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
   //   header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=site&err=insert");
   //   exit;
   //}
   //$_SESSION['VxCFG']->dbh->CompleteTrans();
   
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   return $row[0];
}

function commitSite($frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
   $aid=$frm['addressid'];
   $a->Commit($aid);

   $qry=sprintf(company_site_qry5,$frm['name'],$frm['businessunitid'],$frm['addressid'],$frm['contactid'],$frm['localeid'],
   $frm['currencyid'],$frm['annualbudget'],$frm['site'],$frm['encryption'],$frm['login'],$frm['password'],
   YN($frm['active']),$frm['bankid'],$frm['id']);
   $_SESSION['VxCFG']->dbh->StartTrans();
   $_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=site&err=commit");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
}

function deleteSite($frm) 
{
   if(isset($frm["reassign"])){
      $ndept=$frm["departments"];
      $qry=sprintf(company_site_qry8, $ndept, $frm["id"]);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   else{
      $qry=sprintf(company_site_qry9, $frm["id"]);
      $_SESSION['VxCFG']->dbh->Execute($qry);  
   }

   $qry=sprintf(company_site_qry6, $frm["id"]);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function duplicateSite($id) 
{
   $frm=fillForm($id, false);
   insertSite($frm);
}

function searchSite()
{
   $frm["newaction"] = "sresults";
   
   include("templates/sitesearch.php");
}

function searchResults($frm)
{
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "Address");
}

function fillBankCombo($a, $id)
{
   $b=new BankDetails();
   $b->Combo($a, $id, "bankid");
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "currencyid");
}

function LocaleCombo($action, $id)
{
   $a=new Locale();
   $a->Combo($action, $id, "localeid");
}

function BuCombo($a, $id)
{
   if($id==0 && $a=="cfmdelete"){
      echo "Not Set";
      return;
   }
   if($a=="commit" || $a=="add" || $a=="cfmdelete"){
      $result=$_SESSION["VxCFG"]->dbh->Execute(company_site_qry14);
      if(!($result)){
         echo "Not Set";
         return;
      }
      if($result->RecordCount()==0){
         echo "Not Set";
         return;
      }
      if($result->RecordCount()==1 && $a=="cfmdelete"){
         echo "The are no other sites defined";
         return;
      }
	   echo "<select name=\"businessunitid\" width=\"250\">\n";
	   while($row = $result->FetchRow()){
		   $boo=$row["id"];
   		$poo=$row["name"];
         //if(($a=="cfmdelete" && $id!=$boo) || $a !="cfmdelete"){
   	   	if($id==$boo){
	   	   	print "<option selected value=\"$boo\"> $poo </option>\n";
   	   	}
	   	   else{
		   	   print "<option value=\"$boo\"> $poo </option>\n";
   		   }
         //}
	   }
	   echo "</select>\n";
   }
   else{
      $qry=sprintf(company_site_qry15, $id);
      $result=$_SESSION["VxCFG"]->dbh->Execute($qry);
      if(!$result){
         echo "Not Set";
         return;
      }
      if($result->RecordCount()==0){
         echo "Not Set";
         return;
      }
      if($row = $result->FetchRow()){
         echo $row[0];
      }
   }
}

function listSite()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(company_site_qry13, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"3\">"._("There are no sites defined")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"3\">"._("There are no sites defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='bunit'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Business Unit")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Business Unit")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=bunit\">"._("Business Unit")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='bunit'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   
   while($row = $result->FetchRow()){
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">".$row["name"]."</td>";
         $qry=sprintf(company_site_qry15, $row['businessunitid']);
         $res=$_SESSION["VxCFG"]->dbh->Execute($qry);
         $r = $res->FetchRow();
         echo "<td class=\"listdata\">".$r['name']."</td>\n";
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row["name"]."</td>";
         $qry=sprintf(company_site_qry15, $row['businessunitid']);
         $res=$_SESSION["VxCFG"]->dbh->Execute($qry);
         $r = $res->FetchRow();
         echo "<td class=\"listdataeven\">".$r['name']."</td>\n";
         echo "<td class=\"listdataeven\">";
      }
      $wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"site.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"site.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"site.php?action=delete&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
        echo "<a href=\"site.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"site.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"site.php?action=delete&id=$wibbler&offset=$offset\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      $c++;
      $offset++;
      echo "</td></tr>\n";
   }
   echo "</table>";
}

?>
