<?php
/*
contact.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/contact.php");
require_once 'Contact_Vcard_Parse/Contact_Vcard_Parse.php';
require_once 'Contact_Vcard_Build.php';
require_once 'File/IMC.php';


if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_POST['pselect'])){
   $action='list';
}

if(isset($_REQUEST['caction'])){
   $action=$_REQUEST['caction'];
}
else if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Contacts"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Contacts");
}

if($_SESSION["pageindex"]->CheckNum(contact_contact_qry1, "contacts")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}

include($_SESSION['VxCFG']->styledir."/headertree.php");

switch($action){
	case "clear" :
		addContact();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseContact($_REQUEST['id']);
         break;
      }
		browseContact($_POST['id']);
      $import_flag=true;
      $export_flag=true;
		break;

	case "edit" :
		editContact($_REQUEST['id']);
      $import_flag=true;
      $export_flag=true;
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelContact($_REQUEST['id']);
      }
      else{
         deleteContact($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listContact();
      }
      break;  
	
   case "cfmdelete" :
      deleteContact($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listContact();
		break;

	case "add" :
		insertContact($_POST);
      $_SESSION["pageindex"]->addition(NumRows(CountNum()));
      listContact($id);
		break;

	case "commit" :
		commitContact($_POST);
      listContact();
		break;
   
   case "duplicate" :
      $id=duplicateContact($_REQUEST['id']);
      editContact($id);
      break;
      
   case "itemadd" :
		itemadd($_POST);
		break;
   
   case "itemedit" :
      itemedit($_REQUEST['id'], $_REQUEST['cid']);
		break;
      
   case "itemcommit" :
      itemcommit($_POST);
		break;
      
   case "itemdelete" :
		itemdelete($_REQUEST['id'], $_REQUEST['cid']);
		break;
   
   case "import" :
		import($_REQUEST['id']);
		break;

   case "importcfm" :
		importcfm($_POST);
		break;

   case "export" :
		export($_REQUEST['id']);
		break;
   
   case "exportcfm" :
		exportcfm($_POST);
		break;
   
   case "reports" :
		reports($_REQUEST['id']);
		break;
      
	case "list":
	default :  
      if(isset($_REQUEST['cletter'])) $cl=$_REQUEST['cletter'];
      else $cl='All';
      if(isset($_POST['pselect'])) $ps=$_POST['pselect'];
      else $ps='A';
      if(isset($_REQUEST['pselect'])) $ps=$_REQUEST['pselect'];
      else $ps='A';
		listContact($ps, $cl);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $eid=$_SESSION['vxmisuser']->GetEmployee();
   $qry=sprintf(contact_contact_qry1, $eid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "";
   $frm["contactid"] = "";
   $frm["attributeid"]=0;
   $frm["contactdetailsid"] = "";
   $frm["ownerid"] = "";
   $frm["addressid"] = "";
   $frm["imageid"] = "";
   $frm["titleid"] = "";
	$frm["firstname"] = "";
	$frm["lastname"] = "";
	$frm["middleinitial"] = "";
   $frm["birthdate"] = "";
	$frm["lastcontact"] = "";
   $frm["timezone"] = "";
   $frm["private"] = "";
   $frm["memoid"] = "";

   $frm["cid"]=0;
	return $frm;
}

function fillForm($id, $bOffset)
{
    if($bOffset){
      $qry=sprintf(contact_contact_qry2, $id, $_SESSION['vxmisuser']->GetEmployee());
   }
   else{
      $qry=sprintf(contact_contact_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   $frm["id"] = $row['id'];
   $frm["contactid"] = $row["contactid"];
   $frm["attributeid"] = $row['attributeid'];
   $frm["contactdetailsid"] = $row["contactdetailsid"];
   $frm["ownerid"] = $row["ownerid"];
   $frm["addressid"] = $row["addressid"];
   $frm["imageid"] = $row["imageid"];
   $frm["titleid"] = $row["titleid"];
	$frm["firstname"] = $row["firstname"];
	$frm["lastname"] = $row["lastname"];
	$frm["middleinitial"] = $row["middleinitial"];
   $frm["birthdate"] = $row["birthdate"];
	$frm["lastcontact"] = $row["lastcontact"];
   $frm["timezone"] = $row["timezone"];
   $frm["private"] = $row["private"];
   $frm["memoid"] = $row["memoid"];
   
   $frm["cid"]=0;
   
   $_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_CONTACT);
   $_SESSION['vxmisuser']->SetFocusID($row['id']);   
   $_SESSION['vxmisuser']->SetFocusName($row["firstname"]." ".$row["lastname"]);
   
	return $frm;
}

function addContact()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	
	include("templates/contact.php");
}

function editContact($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
		
	include("templates/contact.php");
}

function browseContact($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
		
	include("templates/contact.php");
}

function insertContact($frm) 
{
   // add address
   $addr=new Address();
   $addr->setfromform($frm);
   $aid=$addr->Add();
   
   // add image
   if(isset($frm['imageid'])){
      
   }
	
   $bd=$frm['birthdateyear']."-".$frm['birthdatemonth']."-".$frm['birthdateday'];
   
   $qry=sprintf(contact_contact_qry5, $_SESSION['vxmisuser']->GetEmployee(), $aid, $iid,$frm["titleid"],
	   $frm["firstname"],$frm["lastname"],$frm["middleinitial"],$bd,
      $frm["lastcontact"],$frm["timezone"],$frm["private"],$frm["memoid"]);
	$_SESSION['VxCFG']->dbh->Execute($qry);
   
   //db_query("update contacts set contactid='last_insert_id()' where id='last_insert_id()'");
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   $row = $result->FetchRow();
   return $row[0];
   
}

function commitContact($frm) 
{
   // add address
   $addr=new Address();
   $addr->setfromform($frm);
   $addr->Commit($frm['addressid']);
   
   $bd=$frm['birthdateyear']."-".$frm['birthdatemonth']."-".$frm['birthdateday'];
   /*
   $qry=sprintf(contact_contact_qry6, $frm['contactid'], $frm['contactdetailsid'],$frm['ownerid'], 
      $frm['addressid'],$frm['imageid'],$frm["titleid"], $frm["firstname"],$frm["lastname"],
      $frm["middleinitial"],$bd,$frm["lastcontact"],$frm["timezone"],
      $frm["private"], $frm['memoid'],$frm["id"]);
   */
   $qry=sprintf(contact_contact_qry20, $frm['ownerid'],$frm['addressid'],$frm['imageid'],
      $frm["titleid"], $frm["firstname"],$frm["lastname"],$frm["middleinitial"],$bd,
      $frm["lastcontact"],$frm["timezone"],
      $frm["private"], $frm['memoid'],$frm["id"]);

   //echo $qry;
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function chkdelContact($id)
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
		
	include("templates/contact.php");
}

function deleteContact($id) 
{
   $qry=sprintf(contact_qry6,$id);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function duplicateContact($id) 
{
   $frm=fillForm($id, false);
   return insertContact($frm);
}

function import($id)
{
   //$frm=fillForm($id, false);
	$frm["newaction"] = "importcfm";
		
	include("templates/import.php");
}

function importcfm($frm)
{
   $parse = new Contact_Vcard_Parse();
   error_reporting(E_ALL);
   
   $fn=$_FILES['filename']['tmp_name'];
   echo "<table class=\"formtable\">\n<tr>\n<td align=\"left\">";
   echo '<pre> This is the parsed vcard output:';
            
   // parse it
   $data = $parse->fromFile($fn);
   if($data===false){
      echo "File ".$fn." could not be read.";
   }
   //print_r($data);
   
   foreach($data as $ci) {	//one file can contain multiple vCards
   
      // Types: 'N', 'ADR','NICKNAME','ORG', 'CATEGORIES', 'GEO'
   
      // $attr (N, FN): "LAST", "FIRST", "MIDDLE", "PREF", "SUFF"
      $contact["last_name"] = $ci['N'][0]['value'][0][0];
      $contact["first_name"] = $ci['N'][0]['value'][1][0];
      $contact["given_name"] = $ci['N'][0]['value'][2][0];
      $contact["title"] = $ci['N'][0]['value'][3][0];
      $contact["suffix"] = $ci['N'][0]['value'][4][0];
      
      $contact["nick_name"] = $ci['NICKNAME'][0]['value'][0][0];
      
      $contact["birthday"] = $ci['BDAY'][0]['value'][0][0];
      $contact["company"] = $ci['ORG'][0]['value'][0][0];
      $contact["type"] = $ci['N'][0]['value'][2][0];
      
      // $attr: (string or array) "INTERNET", "X400", "PREF"(default e-mail)
      foreach($ci['EMAIL'] as $e){
         ParseEmail($e, &$contact);
      }
      //$contact["email"] = $ci['EMAIL'][0]['value'][0][0];
      //$contact["email2"] = $ci['EMAIL'][1]['value'][0][0];
      
      // "MAILER"
      
      // "TZ"
      $contact["tz"] = $ci['TZ'][0]['value'][0][0];
      
      // "GEO
      $contact["geolat"] = $ci['GEO'][0]['value'][0][0]; //latitude
      $contact["geolong"] = $ci['GEO'][0]['value'][1][0]; //longitude
      
      // $attr: (string or array) "PREF", "WORK", "HOME", "VOICE", "FAX", "MSG"
      // "CELL", "PAGER", "BBS", "CAR", "MODEM", "ISDN", "VIDEO", "PCS"
      
      foreach($ci['TEL'] as $t){
         ParsePhone($t, &$contact);
      }
      /*
      $contact["phone_home"] = $ci['TEL'][0]['value'][0][0];
      $contact["phone_work"] = $ci['TEL'][1]['value'][0][0];
      $contact["mobile"] = $ci['TEL'][2]['value'][0][0];
      */
      // $attr: (string or array) "DOM", "INTL", "HOME", "WORK", "POSTAL", "PARCEL"
      // $component: "POBOX", "EXTENDED", "STREET", "CITY", "PROVINCE", "POSTAL", "COUNTRY"
      foreach($ci['ADR'] as $addr){
         ParseAddress($addr, &$contact);
      }
 
      // "ORG"
      // "TITLE", "ROLE", 
      // $attr: "ORGNAME", "ORGUNIT", "ORGUNITS", "ALL"
      $contact["org_title"] = $ci['TITLE'][0]['value'][0][0];
      $contact["org_role"] = $ci['ROLE'][0]['value'][0][0];
      
      // notes
      $contact["notes"] = $ci['NOTE'][0]['value'][0][0];
      //$contact["order_by"] = $contactValues["contact_last_name"].', '.$contactValues["contact_first_name"];
      $contact["id"] = 0;
	}
   print_r($contact);
   
   echo '</pre>';
   echo "</td></tr></table>";
}

function ParseAddress($addr, $c)
{
   switch($addr['param']['TYPE'][0]){
   case 'DOM':
      break;
      
   case 'INTL':
      break;
      
   case 'HOME':
      if(isset($addr['value'][0][0]) && $addr['value'][0][0]!=""){  // pobox
         $c["home_address1"] = "POBOX ".$addr['value'][0][0];  // pobox
         $c["home_address2"] = $addr['value'][2][0];  // street
         $c["home_address3"] = $addr['value'][1][0];  // extend
      }
      else{
         $c["home_address1"] = $addr['value'][2][0];  // street
         $c["home_address2"] = $addr['value'][1][0];  // extend
      }
      $c["home_city"] = $addr['value'][3][0];
      $c["home_state"] = $addr['value'][4][0];
      $c["home_postcode"] = $addr['value'][5][0];
      $c["home_country"] = $addr['value'][6][0];
      break;
      
   case 'WORK':
      if(isset($addr['value'][0][0]) && $addr['value'][0][0]!=""){  // pobox
         $c["work_address1"] = "POBOX ".$addr['value'][0][0];  // pobox
         $c["work_address2"] = $addr['value'][2][0];  // street
         $c["work_address3"] = $addr['value'][1][0];  // extend
      }
      else{
         $c["work_address1"] = $addr['value'][2][0];  // street
         $c["work_address2"] = $addr['value'][1][0];  // extend
      }
      $c["work_city"] = $addr['value'][3][0];
      $c["work_state"] = $addr['value'][4][0];
      $c["work_postcode"] = $addr['value'][5][0];
      $c["work_country"] = $addr['value'][6][0];
      break;
      
   case 'POSTAL':
      break;
      
   case 'PARCEL':
      break;
   }
}

function ParsePhone($tel, $c)
{
   switch($tel['param']['TYPE'][0]){
   case 'PREF':
      $c["phone_prefered"] = $tel['value'][0][0];
      break;

   case 'VOICE':
      $c["phone_voice"] = $tel['value'][0][0];
      break;

   case 'FAX':
      $c["phone_fax"] = $tel['value'][0][0];
      break;

   case 'MSG':
      $c["phone_msg"] = $tel['value'][0][0];
      break;

   case 'CELL':
      $c["phone_mobile"] = $tel['value'][0][0];
      break;

   case 'PAGER':
      $c["phone_pager"] = $tel['value'][0][0];
      break;

   case 'BBS':
      $c["phone_bbs"] = $tel['value'][0][0];
      break;

   case 'MODEM':
      $c["phone_modem"] = $tel['value'][0][0];
      break;

   case 'CAR':
      $c["phone_car"] = $tel['value'][0][0];
      break;

   case 'ISDN':
      $c["phone_isdn"] = $tel['value'][0][0];
      break;

   case 'VIDEO':
      $c["phone_video"] = $tel['value'][0][0];
      break;

      
   case 'HOME':
      $c["phone_home"] = $tel['value'][0][0];
      break;
      
   case 'WORK':
      $c["phone_work"] = $tel['value'][0][0];
      break;
   }
}

function ParseEmail($e, $c)
{
   switch($e['param']['TYPE'][0]){
   case 'HOME':
      $c["email_home"] = $e['value'][0][0];
      break;
      
   case 'WORK':
      $c["email_work"] = $e['value'][0][0];
      break;
      
   case 'OTHER':
      $c["email_other"] = $e['value'][0][0];
      break;
   }
}

function export($id)
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "exportcfm";
   

	include("templates/export.php");
}

function exportcfm($frm)
{
}

function reports($id)
{
}

function Tree($a, $cdid)
{
   ContactTree($a, $cdid);
}
/*
function fillTitleCombo($a, $cname, $id)
{	
	if($a=="commit" || $a=="add"){
	   print "<select name=\"$cname\">\n";
      $result=$_SESSION['VxCFG']->dbh->Execute(contact_title_qry8);
	   while($row = $result->FetchRow()){
			$boo=$row["id"];
		   $poo=$row["name"];
		   if($id==$boo){
			   print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
		print "</select>\n";
   }
   else{
      $qry=sprintf(contact_title_qry3, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}
*/
function AddressTable($a, $aid)
{
   $addr=new Address();
   $addr->FillTable($a, $aid, "address");
}

function Image($a, $iid)
{
}

function BirthDate($a, $bd)
{
   $td=new TimeDate();
   /*
   if($a=="commit" || $a=="add"){
     $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
      if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{*/
      $td->parse($bd);
   //}
   $td->datecontrol_ranged($a, "birthdate", 65, 16);
}

function LastContact($a, $lc)
{
   $td=new TimeDate();
   $td->displayex('date', $a, 'lastcontact', $lc);
   //$td->datecontrol($a, $lc);
}

function MemoTable($a, $id)
{
   $bedit=false;
   echo "<table>\n";
   echo "<tr>\n<td class=\"inlisttitle\">"._("Date")."</td>\n";
   echo "<td class=\"inlisttitle\">"._("By")."</td>\n";
   echo "<td class=\"inlisttitle\">"._("Subject")."</td>\n";
   echo "<td class=\"inlisttitle\">"._("Action")."</td>\n</tr>\n";
   
   echo "<tr><td colspan=\"4\" class=\"listdata\">"._("There are no notes.")."</td></tr></table>";
   return;
   
   $qry=sprintf(contact_memo_qry4, $id);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result) return false;
   echo "<table class=\"memo\">\n";
   if($result->RecordCount()==0){
      if($a=="commit" || $a=="add"){
         echo "<tr><td>"._("There are no notes.")."</td>\n<td>";
         echo "<input type=\"submit\" name=\"memoadd\" value=\"add\"></td></tr></table>\n";
      }
      else{
         echo "<tr><td>"._("There are no notes.")."</td></tr></table>\n";
      }
      return;
   }
   $cm=new CreateMod();
      
   while($row = $result->FetchRow()){
      if($a=="commit" || $a=="add"){
         echo "<tr><td class=\"inlistdata\">";
         echo $row["subject"];
         echo "</td>\n<td class=\"inlistdata\">";
         /*
         echo "<tr>\n<td>";
	      textarea($a, "data", 64, 255, $this->data);
         echo"</td>\n";
         echo "</tr>\n";*/
      }
      else{
         echo "<tr><td class=\"inlistdata\">".$row["subject"]."</td>\n<td>";
         $cm->Fill($row['cmid']);
         $cm->FillCell();
         echo "</td>\n</tr>\n<tr><td colspan=\"2\">";
         echo $row[">data"],"</td></tr>\n";
      }
   }
   if($a=="commit" || $a=="add"){
      // add a blank for addition
   }
   echo "</table>\n";
}

function TypeCombo($a, $id, $cname)
{
   if($a=="commit" || $a=="add"){
      $result=$_SESSION['VxCFG']->dbh->Execute(contact_type_qry8);
      echo "<select name=\"$cname\">\n";
 	   while($row = $result->FetchRow()){
  	   	$boo=$row["id"];
   	   $poo=$row["name"];
  	   	if($id==$boo){
   	   	echo "<option selected value=\"$boo\"> $poo </option>\n";
  		   }
     		else{
      		echo "<option value=\"$boo\"> $poo </option>\n";
  		   }
      }
      echo "</select>\n";
   }
   else{
      $qry=sprintf(contact_type_qry3, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo $row[1];
      }
      else{
         echo "Not Set";
      }
   }
}

function PrivateCombo($a, $id, $cname)
{
   $typelist = array('A'=>_("All"), 'U'=>_("None"), 'G'=>_("Group"), 'D'=>_("Department"), 'S'=>_("Site"));
   
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"$cname\">\n";
	   foreach($typelist as $typeid=>$type){
	      echo "<option ";
   	   if($id==$typeid)
	         echo "selected ";
	      echo "value='$typeid'>$type</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $typelist[$id];
   }
}

function ShowCombo($a, $id, $cname)
{
   $typelist = array('A'=>_("All"), 'U'=>_("Mine"), 'G'=>_("Group"), 'D'=>_("Department"), 'S'=>_("Site"));
   
   if($a=="commit" || $a=="add"){
	   echo "<select onChange=\"this.form.submit();\" name=\"$cname\">\n";
	   foreach($typelist as $typeid=>$type){
	      echo "<option ";
   	   if($id==$typeid)
	         echo "selected ";
	      echo "value='$typeid'>$type</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $typelist[$id];
   }
}

function ItemTable($a, $cdid, $id, $contactid)
{
   $qry=sprintf(contact_details_qry8, $cdid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   
   $bedit=false;
   echo "<table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\" class=\"contactdetails\">\n";
   echo "<tr>\n<td colspan=\"3\" class=\"listtitle\">"._("Title")."</td>\n</tr>\n";
	echo "<tr>\n<td class=\"listtitle\">"._("Type")."</td>\n";
   echo "<td class=\"listtitle\">"._("Value")."</td>\n";
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
   if($result->RecordCount()==0){
      echo "<td colspan=\"3\" class=\"listdata\">"._("There are no contacts details defined.")."</td>\n</tr>\n</table>";
      return;
   }
   
   while($row = $result->FetchRow()){
      echo "<tr>\n<td class=\"listdata\">";
      if($a!='browse'){
         if($row['id']==$id){
            $bedit=true;
            TypeCombo("commit", $row['typeid'], "ctypeid" );
            echo"</td>\n<td class=\"listdata\">";
            entry("commit", "cdata", 68, 64, $row['data']);
            echo"</td>\n<td class=\"listdata\">";
            if($_SESSION['vxmisuser']->GetShowImages()){
               echo "<input name=\"submit\" src=\"". $_SESSION['VxCFG']->styleimagedir."/list_commit.png\" type=\"image\">";
            }
            else{
               echo "<input type=\"submit\" name=\"memoadd\" value=\""._("Commit")."\">";
            }
         }
         else{
            TypeCombo("browse", $row['typeid'], "");
            echo "</td>\n<td class=\"listdata\">".$row['data']."</td>\n<td class=\"listdata\">";
         }
      }
      else{
         TypeCombo("browse", $row['typeid'], "");
         echo "</td>\n<td class=\"listdata\">".$row['data']."</td>\n<td class=\"listdata\">";
      }
      if($row['id']!=$id){
         if($_SESSION['vxmisuser']->GetShowImages()){
            if($_SESSION['vxmisuser']->GetPerm('edit')){
               echo "<a href=\"contact.php?action=itemedit&cid=".$row['id']."&id=".$contactid."\">";
               echo "<img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp;\n";
            }
            if($_SESSION['vxmisuser']->GetPerm('delete')){
	            echo "<a href=\"contact.php?action=itemdelete&cid=".$row['id']."&id=".$contactid."\">";
               echo "<img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp;\n";
            }
         }
         else{
            if($_SESSION['vxmisuser']->GetPerm('edit')){
		        echo "<a href=\"contact.php?action=itemedit&cid=".$row['id']."&id=".$contactid."\">"._("Edit")."</a>&nbsp;\n";
            }
            if($_SESSION['vxmisuser']->GetPerm('delete')){
		         echo "<a href=\"contact.php?action=itemdelete&cid=".$row['id']."&id=".$contactid."\">"._("Delete")."</a>&nbsp;\n";
            }
         }
      }
      echo "</td>\n</tr>\n";
   }
   if($a!='browse' && $bedit==false){
      echo "<tr>\n<td class=\"listdata\">";
      TypeCombo("add", $row['typeid'], "ctypeid" );
      echo "</td>\n<td class=\"listdata\">";
      entry("add", "cdata", 68, 64, $row['data']);
      echo "</td>\n<td class=\"listdata\">";
      echo "<input type=\"hidden\" name=\"action\" value=\"itemadd\">\n";
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<input name=\"submit\" src=\"". $_SESSION['VxCFG']->styleimagedir."/list_add.png\" type=\"image\">";
      }
      else{
         echo "<input type=\"submit\" name=\"memoadd\" value=\"".misc_listadd."\">";
      }
      echo "<td></tr>\n";
   }
   echo "</table>\n";
}

function itemadd($frm)
{
   $qry=sprintf(contact_details_qry4, $frm['contactdetailsid'],$frm['ctypeid'],  $frm['cdata']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
   
   $frm=fillForm($frm['id'], false);
   $frm["newaction"] = "commit";
		
	include("templates/contact.php");
}

function itemedit($id, $cid)
{
   $frm=fillForm($id, false);
   $frm["cid"]=$cid;
   $frm["newaction"] = "itemcommit";
		
	include("templates/contact.php");
}

function itemcommit($frm)
{
   $qry=sprintf(contact_details_qry5, $frm['contactdetailsid'],$frm['ctypeid'],  $frm['cdata'], $frm['cid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
	
   $frm=fillForm($frm['id'], false);
   $frm["newaction"] = "commit";
	include("templates/contact.php");
}

function itemdelete($id, $cid)
{
   $qry=sprintf(contact_details_qry6, $cid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   $frm=fillForm($id, false);
   $frm["newaction"] = "commit";
	include("templates/contact.php");
}

function listContact($ps='U', $lc='All')
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   if($ps=='A'){
      $qry=sprintf(contact_contact_qry12, $_SESSION['vxmisuser']->GetEmployee());
   }
   else if($ps=='U'){
      $qry=sprintf(contact_contact_qry13, $_SESSION['vxmisuser']->GetEmployee());
   }
   else if($ps=='G'){
      $qry=sprintf(contact_contact_qry14, $_SESSION['vxmisuser']->GetEmployee());
      if(!$result=$_SESSION['VxCFG']->dbh->Execute($qry)){
         exit();
      }
      if(!($row = $result->FetchRow())){
         exit();
      }
      $qry=sprintf(contact_contact_qry15, $row['groupid']);
   }
   else if($ps=='D'){
      $qry=sprintf(contact_contact_qry14, $_SESSION['vxmisuser']->GetEmployee());
      if(!$result=$_SESSION['VxCFG']->dbh->Execute($qry)){
         exit();
      }
      if(!($row = $result->FetchRow())){
         exit();
      }
      $gid=$row['groupid'];
       
      $qry=sprintf(contact_contact_qry16, $gid);
      if(!$result=$_SESSION['VxCFG']->dbh->Execute($qry)){
         exit();
      }
      if(!($row = $result->FetchRow())){
         exit();
      }
      $qry=sprintf(contact_contact_qry17, $gid, $row['deptid']);
   }
   else if($ps=='S'){
      $qry=sprintf(contact_contact_qry14, $_SESSION['vxmisuser']->GetEmployee());
      if(!$result=$_SESSION['VxCFG']->dbh->Execute($qry)){
         exit();
      }
      if(!($row = $result->FetchRow())){
         exit();
      }
      $gid=$row['groupid'];
         
      $qry=sprintf(contact_contact_qry16, $gid);
      if(!$result=$_SESSION['VxCFG']->dbh->Execute($qry)){
         exit();
      }
      if(!($row = $result->FetchRow())){
         exit();
      }
      $did=$row['deptid'];
      $qry=sprintf(contact_contact_qry18, $did);
      if(!$result=$_SESSION['VxCFG']->dbh->Execute($qry)){
         exit();
      }
      if(!($row = $result->FetchRow())){
         exit();
      }
      $qry=sprintf(contact_contact_qry19, $gid, $did, $row['siteid']);
   }
   if($lc!='All'){
      $qry.=" and lastname like '$lc%' ";
   }

	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<form action=\"".$_SERVER['PHP_SELF']."\" method=\"POST\">\n";
   echo "<input type=\"hidden\" name=\"pselect\" value=\"$ps\">\n";
   echo "<input type=\"hidden\" name=\"cletter\" value=\"$lc\">\n";
   echo "<table class=\"listtable\">\n";
   echo "<tr><td class=\"alphaselect\" colspan=\"4\" align=\"left\">"._("Show ");   
   ShowCombo("commit", $ps, "pselect");
   echo "</td></tr>";
   
   echo "<tr><td class=\"listtitle\" colspan=\"4\">";
   ContactAlphabet($lc, $ps);
   echo "</td></tr>";
   
   if(!$result){
      echo "<tr><td colspan=\"4\">"._("There are no contacts defined.")."</td></tr>\n</table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"4\">"._("There are no contacts defined.")."</td></tr>\n</table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='private'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Access To")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Access To")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=private\">"._("Access To")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='private'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='lastcontact'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Last Contact")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Last Contact")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Last Contact")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='lastcontact'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      
		$wibbler=$row["id"];
		$n=$row["firstname"]." ".$row["lastname"];
		$ls=$row["lastcontact"];
      if($c%2){
         echo "<tr class=\"listdata\">\n";
         echo "<tr><td class=\"listdata\">$n</td>\n<td class=\"listdata\">";
         PrivateCombo("browse", $row["private"], "private");
         echo "</td>\n<td class=\"listdata\">$ls</td><td class=\"listdata\">\n";
      }
      else{
         echo "<tr class=\"listdataeven\">\n";
         echo "<tr><td class=\"listdataeven\">$n</td>\n<td class=\"listdataeven\">";
         PrivateCombo("browse", $row["private"], "private");
         echo "</td>\n<td class=\"listdataeven\">$ls</td><td class=\"listdataeven\">\n";
      }
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"contact.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"contact.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"contact.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"contact.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"contact.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"contact.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>\n";
}

?>
