<?php
/*
customer.php

Copyright (C)2004 Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");
require_once($_SESSION['VxCFG']->libdir."/chargeaccount.php");
require_once($_SESSION['VxCFG']->libdir."/contact.php");
require_once($_SESSION['VxCFG']->libdir."/createmod.php");
require_once($_SESSION['VxCFG']->libdir."/loyalty.php");
require_once($_SESSION['VxCFG']->libdir."/memo.php");
//require_once($_SESSION['VxCFG']->libdir."/customer.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()=='' || $_SESSION['vxmisuser']->GetSortOn()!='name'){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']);
if(isset($_REQUEST['action'])){
   if($_REQUEST['action']=='navviewshiftleft'){
      $_SESSION['vxmisuser']->ModuleDecrement();
   }
   else if($_REQUEST['action']=='navviewshiftright'){
      $_SESSION['vxmisuser']->ModuleIncrement();
   }
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if($action=='list'){
   $_SESSION['vxmisuser']->ClearFocus();
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Customer Maintenance"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Customer Maintenance");
}

if($_SESSION["pageindex"]->CheckNum(customerm_customer_qry1, "customer")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}

switch($action){
	case "clear" :
		addCustomer();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseCustomer($_REQUEST['id']);
         break;
      }
		browseCustomer($_POST['id']);
		break;

	case "edit" :
		editCustomer($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelCustomer($_REQUEST['id']);
      }
      else{
         deleteCustomer($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listCustomer();
      }
		break;

	case "cfmdelete" :
		deleteSite($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listCustomer();
		break;

	case "add" :
		insertCustomer($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listCustomer();
		break;

	case "commit" :
		commitCustomer($_POST);
      listCustomer();
		break;
      
   case "search" :
      searchCustomer();
      break;
      
   case "searchresults" :
		searchResults($_POST);
		break;
      
	case "list":
	default :
      if(isset($_REQUEST['cletter'])) $cl=$_REQUEST['cletter'];
      else $cl='All';
		listCustomer($cl);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(customerm_customer_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $_SESSION['vxmisuser']->ClearFocus();
   $frm["id"] = "";
   $frm["cmid"] = 0;
   $frm["contactid"] = "";
   $frm["storecardid"] = "";
   $frm["loyaltyid"] = "";
   $frm["signatureid"] = "";
   $frm["chargeaccountid"] = "";
   $frm["login"] = "";
   $frm["password"] = "";
   $frm["attributesid"]="";
   $frm["enabled"] = "";
   $frm["memoid"] = "";
   $frm["contactdetailsid"] = 0;
   
   return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(customerm_customer_qry2, $id);
   }
   else{
      $qry=sprintf(customerm_customer_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   
   $_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_CUSTOMER);
   $_SESSION['vxmisuser']->SetFocusID($row["id"]); 
   
   $frm["id"] = $row["id"];
   $frm["cmid"] = $row["cmid"];
   $frm["contactid"] = $row["contactid"];
   $frm["storecardid"] = $row["storecardid"];
   $frm["loyaltyid"] = $row["loyalityid"];
   $frm["signatureid"] = $row["signatureid"];
   $frm["chargeaccountid"] = $row["chargeaccountid"];
   $frm["login"] = $row["login"];
   $frm["password"] = $row["password"];
   $frm["attributesid"]=$row["attributesid"];
   $frm["enabled"] = $row["enabled"];
   $frm["memoid"] = $row["memoid"];
   
   $qry=sprintf(contact_contact_qry3, $row["contactid"]);
	$result=db_query($qry);
	$row = $result->FetchRow();
   $frm["contactdetailsid"] = $row["contactdetailsid"];

   $qry=sprintf(customerm_customer_qry11, $row["contactid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $_SESSION['vxmisuser']->SetFocusName($row["firstname"]." ".$row["lastname"]);
   
   return $frm;
}


function addCustomer()
{
   $frm=clearForm();
	$frm["newaction"] = "add";
   include($_SESSION['VxCFG']->styledir."/header.php");
	include("templates/customer.php");
}

function editCustomer($id) 
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "commit";
	include($_SESSION['VxCFG']->styledir."/header.php");
	include("templates/customer.php");
}

function browseCustomer($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   include($_SESSION['VxCFG']->styledir."/header.php");
	include("templates/customer.php");
}

function chkdelCustomer($id)
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
   include($_SESSION['VxCFG']->styledir."/header.php");
	include("templates/custdel.php");
}

function deleteCustomer($id) 
{
   $qry=sprintf(customerm_customer_qry5, $id);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
}

function searchOrder()
{
   $frm["newaction"] = "searchresults";
   $frm["id"]=0;
   $frm["name"]="";
	include("templates/customersearch.php");
}

function searchResults($frm)
{
   if(isset($_POST['name'])){
      $qry=sprintf(orderu_query_qry2,$_POST['ordernumber']);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      
      if(!$result){
         $frm['errmsg']=_("Bad Query");
         $frm["newaction"] = "searchresults";
         $frm["id"]=0;
         $frm["name"]="";
         include("templates/customersearch.php");
         return;
      }
      if($result->RecordCount()==0){
         $frm['errmsg']=_("No Records found for customer ").$_POST['ordernumber'];
         $frm["action"] = "search";
         $frm["newaction"] = "search";
         $frm["id"]=0;
         $frm["name"]="";
         include("templates/customersearch.php");
         return;
      }
	   if(!($row = $result->FetchRow())){
         $frm['errmsg']=_("Bad Query");
         $frm["newaction"] = "searchresults";
         $frm["id"]=0;
         $frm["name"]="";
         include("templates/customersearch.php");
         return;
      }
      else{
         $frm=fillForm($row['id'], false);
         $frm['newaction']="browse";
         include("templates/customer.php");
         return;
      }
   }
   else{
      $frm['errmsg']=_("Fill in something");
      include("templates/customersearch.php");
   }
}

function insertCustomer($frm) 
{
	$a=new Address();
   $a->SetFromForm($frm);
	if(!$a->Find(false)){
      $aid=$a->Add();
   }
   else{
      $aid=$a->GetID();
   }
   $c=new CreateMod();
   $cmid=$c->Commit();
   
   $cn=new Contact();
   $cn->FillFromForm($frm);
   $conid=$cn->Add();
   
   $p=new Loyalty();
   $lid=$p->Add();
   
   $qry=sprintf(customerm_customer_qry6,$cmid,$frm["contactid"],$frm["storecardid"],$lid,
   $frm["signatureid"],$frm["chargeaccountid"],$frm["login"],$frm["password"],
   $frm["attributesid"],$frm["enabled"], $frm["memoid"]);
   
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitCustomer($frm) 
{
   $c=new CreateMod();
   $cmid=$c->Fill($frm["cmid"]);
   $cmid=$c->Commit();
   
   $cn=new Contact();
   $cn->FillFromForm($frm);
   $cn->Commit();
   
   $qry=sprintf(customerm_customer_qry7,$cmid,$frm["contactid"],$frm["storecardid"],$frm["loyaltyid"],
   $frm["signatureid"],$frm["chargeaccountid"],$frm["login"],$frm["password"],
   $frm["attributesid"],$frm["enabled"], $frm["memoid"], $frm["id"]);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}
/*
function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "Address");
}
*/
function ContactName($a, $id) 
{
   $c=new Contact($id);
   $c->NameTable($a, $id);
}

function CreateModTable($id)
{
   $cm=new CreateMod();
   $cm->Fill($id);
   $cm->FillTable();
}

function ChargeAcc($a, $id)
{
   if($id==0){
      echo "<fieldset>\n<legend>"._("Charge Account")."</legend><table>\n";
      echo "<tr>\n<td class=\"formdata\">"._("There are no charge accounts defined.")."</td>\n</tr>\n</table>\n</fieldset>\n";
      return;
   }
   $c=new ChargeAccount();
   $c->Table($a, $id, "Account Details");
}

function AddressTable($a, $id)
{
   $qry=sprintf(customerm_customer_qry9, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $aid=$row["addressid"];
   
   $addr=new Address();
   $addr->FillListTable($a, $aid);
}

function ContactTable($a, $id)
{
   $c=new ContactDetailsItem();
   $c->StandardTable($a, $id);
}

function PointsList($action, $id)
{
   $qry=sprintf(customerm_customer_qry15, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $p=new PointsLog();
   $p->Summary($action, $row['pointsid']);
}


function MemoList($action, $id)
{
   $qry=sprintf(customerm_customer_qry10, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $m=new Memo();
   $m->FillList($action, $row['memoid']);
}

function addMemo($frm)
{
   $m=new Memo();
   $m->SetFromForm($frm);
   $m->Add();
}

function commitMemo($frm)
{
   $m=new Memo();
   $m->SetFromForm($frm);
   $m->Commit();
}

function listCustomer($lc='All')
{
   include($_SESSION['VxCFG']->styledir."/header.php");
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   if($lc!='All'){
      $qry=sprintf(customerm_customer_qry14, $lc.'%', $sorton, $sortorder);
   }
   else{
      $qry=sprintf(customerm_customer_qry13, $sorton, $sortorder);
   }
   
   //$qry=sprintf(customerm_customer_qry4, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<form action=\"".$_SERVER['PHP_SELF']."\" method=\"POST\">\n";
   echo "<input type=\"hidden\" name=\"cletter\" value=\"$lc\">\n";
   echo "<table class=\"listtable\">\n";
   echo "<tr><td class=\"listtitle\" colspan=\"4\">";
   ContactAlphabet($lc);
   echo "</td></tr>";
   
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no customers defined")."</td></td></table>\n";
      exit;
   }
   
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no customers defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      $qry=sprintf(customerm_customer_qry8, $row['contactid']);
	   $nresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($nrow = $nresult->FetchRow()){
         $n=$nrow[0] . " " . $nrow[1];
      }
      else{
         $n="Not Set";
      }
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">$n</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">$n</td><td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"customer.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"customer.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"customer.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"customer.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"customer.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"customer.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
