<?php
/*
points.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(2);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()=='' || $_SESSION['vxmisuser']->GetSortOn()!='name'){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_CUSTOMER){
      $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
   }
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_CUSTOMER){
         $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
         //$action=$_SESSION['vxmisuser']->GetFocusAction();
         $action='list';
      }
      else{
         $action='list';
      }
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Customer Points"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Customer Points");
}

if($_SESSION["pageindex"]->CheckNum(customerm_points_qry1, "pointslog")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}
$NoNavigationFlag=true;
include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addPoints();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browsePoints($_REQUEST['id']);
         break;
      }
		browsePoints($_POSST['id']);
		break;

	case "edit" :
		editPoints($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelPoints($_REQUEST['id']);
      }
      else{
         deletePoints($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listPoints();
      }
		break;

	case "cfmdelete" :
		deletePoints($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listPoints();
		break;

	case "add" :
		insertPoints($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listPoints();
		break;

	case "commit" :
		commitPoints($_POST);
      listPoints();
		break;

	case "list":
	default :
      if(isset($_REQUEST['pointstype'])) $pt=$_REQUEST['pointstype'];
      else $pt='All';
      if(isset($_POST['redeemed'])) $rd='Y';
      else $rd='N';
		listPoints($pt, $rd);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(customerm_points_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
	$frm["pointsid"] = "";
	$frm["pointstypeid"]="";
	$frm["issuedon"]="";
   $frm["redeemcode"]="";
   $frm["number"]="";
   $frm["redeemed"]="";
	
   $frm["name"]="";
	$frm["value"]="";
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(customerm_pointslog_qry2, $id);
   }
   else{
      $qry=sprintf(customerm_pointslog_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

   $frm["pointsid"] = $row['pointsid'];
	$frm["pointstypeid"]=$row['pointstypeid'];
	$frm["issuedon"]=$row['issuedon'];
   $frm["redeemcode"]=$row['redeemcode'];
   $frm["number"]=$row['number'];
   $frm["redeemed"]=$row['redeemed'];

   $qry=sprintf(customerm_points_qry3, $row['pointstypeid']);
	$frm["name"]=$row["name"];
	$frm["value"] = $row["value"];

	return $frm;
}

function addPoints()
{
	$frm=clearForm();
	$frm["newaction"] = "add";

	include("templates/points.php");
}

function editPoints($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/points.php");
}

function browsePoints($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/point.php");
}

function chkdelPoints($id)
{
	fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
   
	include("templates/points.php");
}

function insertPoints($frm) 
{
   $qry=sprintf(customerm_pointslog_qry4,$frm["pointsid"],$frm["pointstypeid"],$frm["issuedon"],
      $frm["redeemcode"],$frm["number"],$frm["redeemed"]);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitPoints($frm) 
{
   $qry=sprintf(customerm_pointslog_qry5,$frm["pointsid"],$frm["pointstypeid"],$frm["issuedon"],
      $frm["redeemcode"],$frm["number"],$frm["redeemed"],$frm['id']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function deletePoints($frm) 
{
   $qry=sprintf(customerm_pointslog_qry6, $frm["id"]);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function PointsTypeCombo($a, $id)
{
   if($a=="commit" || $a=="add"){
	   echo "<select onChange=\"this.form.submit();\" name=\"pointstype\">\n";
      $result=$_SESSION['VxCFG']->dbh->Execute(customerm_points_qry7);
      if($id=='All')
         echo "<option value=\"All\" selected>All</option>";
      else 
         echo "<option value=\"All\">All</option>";
         
		while($row = $result->FetchRow()){
			$boo=$row["id"];
         echo "<option ";
   	   if($id==$row['id'])
	         echo "selected ";
	      echo "value=\"".$row['id']."\">".$row['name']."</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
   }
}

function listPoints($pointstype='All', $redeemed='N')
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(customerm_pointslog_qry17, $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID());

   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result){
      echo "<table class=\"listtable\">\n<tr><td colspan=\"5\">"._("There are no points defined")."</td></td></table>\n";
      return;
   }
   $row = $result->FetchRow();
   $pid=$row[0];
   
   if($pointstype=='All'){
      $qry=sprintf(customerm_pointslog_qry15, $pid, $redeemed, $sorton, $sortorder);
   }
   else{
      $qry=sprintf(customerm_pointslog_qry16, $pid, $pointstype, $redeemed, $sorton, $sortorder);
   }
   
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   echo "<form action=\"".$_SERVER['PHP_SELF']."\" method=\"POST\">\n";
   $_REQUEST['action']="list";
   echo "<input type=\"hidden\" name=\"pointstype\" value=\"$pointstype\">\n";
   
   echo "<table class=\"listtable\">\n";
   echo "<tr>\n<td class=\"alphaselect\" align=\"left\" nowrap>&nbsp;&nbsp;"._("Type");
   PointsTypeCombo("commit", $pointstype, "pointstype");
   echo "&nbsp;";
   if($redeemed=='N')
      echo "<input class=\"checkbox\" onChange=\"this.form.submit();\" type=\"checkbox\" name=\"redeemed\">"._("Redeemed")."\n";
   else
      echo "<input class=\"checkbox\" onChange=\"this.form.submit();\" type=\"checkbox\" name=\"redeemed\" checked>"._("Redeemed")."\n";
   echo "</td>\n<td class=\"alphaselect\" colspan=\"5\">&nbsp</td>\n</tr>\n";
   
   if(!$result){
      echo "<tr><td colspan=\"5\">"._("There are no points defined")."</td></td></table>\n";
      return;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"5\">"._("There are no points defined")."</td></td></table>\n";
      return;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='value'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Value")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Value")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=value\">"._("Value")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='value'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='issuedon'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Issued")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Issued")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=issuedon\">"._("Issued")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='issuedon'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='number'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Number")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Number")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=number\">"._("Number")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='number'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='total'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Total")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Total")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=total\">"._("Total")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='total'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }

	echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      $qry=sprintf(customerm_points_qry3, $row['pointstypeid']);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r=$res->FetchRow();
      $t=$r["value"] * $row["number"];
      
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">".$r["name"]."</td>\n";
         echo "<td class=\"listdata\">".$r["value"]."</td>\n";
         echo "<td class=\"listdata\">".$row["issuedon"]."</td>\n";
         echo "<td class=\"listdata\">".$row["number"]."</td>\n";
         echo "<td class=\"listdata\">".$t."</td>\n";
	   	echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$r["name"]."</td>\n";
         echo "<td class=\"listdataeven\">".$r["value"]."</td>\n";
         echo "<td class=\"listdataeven\">".$row["issuedon"]."</td>\n";
         echo "<td class=\"listdataeven\">".$row["number"]."</td>\n";
         echo "<td class=\"listdataeven\">".$t."</td>\n";
	   	echo "<td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"points.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"points.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"points.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"points.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"points.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"points.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td>\n</tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
