<?php

if(isset($_SESSION['system_submitted']) && $_SESSION['system_submitted'])
{
   $dirroot = $_SESSION['dirroot'];
   $wwwroot = $_SESSION['wwwroot'];
   $confroot = $_SESSION['confroot'];
   $imgdir = $_SESSION['imgdir'];
   $tmpdir = $_SESSION['tmpdir'];
   $printfolder = $_SESSION['printfolder'];
   $companyname = $_SESSION['companyname'];
   $sitename = $_SESSION['sitename'];
   $locale = $_SESSION['locale'];
   $defaultcountry = $_SESSION['defaultcountry'];
   $defaultcurrency = $_SESSION['defaultcurrency'];
   $papersize = $_SESSION['papersize'];
   $pdfpapersize = $_SESSION['pdfpapersize'];
   $accountingmethod = $_SESSION['accountingmethod'];
   //$geolocator = $_SESSION['geolocator'];
}
else{
	$dirroot=$_SERVER['SCRIPT_FILENAME'];
   $wwwroot=$_SERVER['SCRIPT_NAME'];
   $confroot="";
   $imgdir="/tmp/vxmis";
   $tmpdir="/tmp/vxmis";
   $printfolder="/tmp/vxmis/print";
   $autoprint = false;
   $companyname="Your Company Name";
   $sitename="A site";
   $locale="en_GB";
   $defaultcountry=17;
   $defaultcurrency=13;
   $papersize="A4";
   $pdfpapersize="A4";
   $accountingmethod="cash";
   //$geolocator='www.mappy.com';

   $_SESSION['dirroot'] = $dirroot;
   $_SESSION['wwwroot'] = $wwwroot;
   $_SESSION['confroot'] = $confroot;
   $_SESSION['imgdir'] = $imgdir;
   $_SESSION['tmpdir'] = $tmpdir;
   $_SESSION['printfolder'] = $printfolder;
   $_SESSION['autoprint'] = $autoprint;
   $_SESSION['companyname'] = $companyname;
   $_SESSION['sitename'] = $sitename;
   $_SESSION['locale'] = $locale;
   $_SESSION['defaultcountry'] = $defaultcountry;
   $_SESSION['defaultcurrency'] = $defaultcurrency;
   $_SESSION['papersize'] = $papersize;
   $_SESSION['pdfpapersize'] = $pdfpapersize;
   $_SESSION['accountingmethod'] = $accountingmethod;
   //$_SESSION['geolocator'] = $geolocator;
}
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <meta http-equiv="Content-Script-Type" content="text/javascript">
  <meta http-equiv="Content-Style-Type" content="text/css">
  <title>VxMIS Setup Wizard: Step 5</title>
  <link rel="stylesheet" href="install/install.css" type="text/css" />
  <script type="text/javascript" src="install/install.js"></script>
</head>
<body onload="toggleDropTables();togglePasswordRetypeRequired();toggleUsernameIsPrivileged();document.getElementById('defaultFocus').focus();">
<form action="install.php" method="post" name="setConfig" id="form">
<table cellspacing="0" cellpadding="0" border="0" align="center" class="shell">
<tr>
   <th width="400">Step 5: System Configuration</th>
	<th width="200" height="30" style="text-align: right;"><a href="http://vxmis.vxgroup.com" target="_blank">
   <img src="install/install.png" alt="VxMIS" border="0" height="23" width="163"></a></th>
</tr>
<tr>
   <td colspan="2" width="600">	
      <p>Please enter your system configuration options below.
      If you are unsure of what to fill in, we suggest that you use the
      default values.</p>
<table>
  <tr>
    <td>MIS Install Directory</td>
    <td><input type=text size="64" maxlength="255" name="dirroot" value="<?php echo dirname($_SERVER['SCRIPT_FILENAME']); ?>"></td>
  </tr>
  <tr>
    <td>Base URL for MIS</td>
    <td><input type=text size="64" maxlength="255" name="wwwroot" value="<?php echo dirname($_SERVER['SCRIPT_NAME']); ?>"></td>
  </tr>
  <tr>
    <td>Configuration Install Directory</td>
    <td><input type=text size="64" maxlength="255" name="confroot" value=""></td>
  </tr>
  <tr>
    <td>Image Directory</td>
    <td><input type=text size="64" maxlength="255" name="imgdir" value="/tmp/vxmis"></td>
  </tr>
  <tr>
    <td>Temporary Download Directory</td>
    <td><input type=text size="64" maxlength="255" name="tmpdir" value="/tmp/vxmis"></td>
  </tr>
  <tr>
    <td>Print Document Directory</td>
    <td><input type=text size="64" maxlength="255" name="printfolder" value="/tmp/vxmis/print"></td>
  </tr>
  <tr>
    <td>Automatically Print</td>
    <td><input type=checkbox name="autoprint" value="Y"></td>
  </tr>
  <tr>
    <td>Company Name</td>
    <td><input type=text size="32" maxlength="64" name="companyname" value="VxGroup"></td>
  </tr>
  <tr>
    <td>WWW Site Name</td>
    <td><input type=text size="32" maxlength="64" name="sitename" value="A site"></td>
  </tr>
  <tr>
    <td>Language</td>
    <td>
    <select name="locale">
    <option value="en_GB" selected>English (UK)</option>
    <option value="en_US">English (US)</option>
    <option value="es_ES">Espanol</option>
    </select>
    </td>
  </tr>
  <tr>
    <td>Default Currency</td>
    <td>
    <select name="defaultcurrency">
    <option value="2"> Afghanistan - Afghani </option>
<option value="3"> Albania - Lek </option>
<option value="4"> Algeria - Algerian Dinar </option>
<option value="5"> American Samoa - Samoa	US Dollar </option>
<option value="6"> Andorra - Spanish Peseta </option>
<option value="7"> Andorra - French Franc </option>
<option value="8"> Andorra - Andorran Peseta </option>
<option value="9"> Angola - New Kwanza </option>
<option value="10"> Angola - Kwanza Reajustado </option>
<option value="11"> Anguilla - East Caribbean Dollar </option>
<option value="12"> Antarctica - No universal currency </option>
<option value="13"> Antigua and Barbuda - East Caribbean Dollar </option>
<option value="14"> Argentina - Argentine Peso </option>
<option value="15"> Armenia - Armenian Dram </option>
<option value="16"> Aruba - Aruban Guilder </option>
<option selected value="17"> Australia - Australian Dollar </option>
<option value="18"> Austria - Euro </option>
<option value="19"> Azerbaijan - Azerbaijanian Manat </option>
<option value="20"> Bahamas - Bahamian Dollar </option>
<option value="21"> Bahrain - Bahraini Dinar </option>
<option value="22"> Bangladesh - Taka </option>
<option value="23"> Barbados - Barbados Dollar </option>
<option value="24"> Belarus - Belarussian Ruble </option>
<option value="25"> Belgium - Euro </option>
<option value="26"> Belize - Belize Dollar </option>
<option value="27"> Benin - CFA Franc BCEAO </option>
<option value="28"> Bermuda - Bermudian Dollar </option>
<option value="29"> Bhutan - Indian Rupee </option>
<option value="30"> Bhutan - Ngultrum </option>
<option value="31"> Bolivia - Convertible Marks </option>
<option value="32"> Bosnia and Herzegowina - Pula </option>
<option value="33"> Botswana - Norwegian Krone </option>
<option value="34"> Bouvet Island - Brazilian Real </option>
<option value="35"> Brazil - US Dollar </option>
<option value="36"> British Indian Ocean Territory - Brunei Dollar </option>
<option value="37"> Brunei Darussalam - Lev </option>
<option value="38"> Brunei Darussalam - Bulgarian LEV </option>
<option value="39"> Bulgaria - CFA Franc BCEAO </option>
<option value="40"> Burkina Faso - Burundi Franc </option>
<option value="41"> Burundi - Riel </option>
<option value="42"> Cambodia - CFA Franc BEAC </option>
<option value="43"> Cameroon - Canadian Dollar </option>
<option value="44"> Canada - Cape Verde Escudo	 </option>
<option value="45"> Cape Verde - Cayman Islands Dollar </option>
<option value="46"> Cayman Islands - CFA Franc BEAC </option>
<option value="47"> Central African Republic - CFA Franc BEAC </option>
<option value="48"> Central African Republic - Chilean Peso </option>
<option value="49"> Chad - Unidades de fomento </option>
<option value="50"> Chile - Yuan Renminbi </option>
<option value="51"> China - Australian Dollar </option>
<option value="52"> Christmas Island - Australian Dollar </option>
<option value="53"> Cocos (Keeling) Islands - Colombian Peso </option>
<option value="54"> Cocos (Keeling) Islands - Comoro Franc </option>
<option value="55"> Comoros - CFA Franc BEAC </option>
<option value="56"> Congo - Franc Congolais </option>
<option value="57"> Cook Islands - New Zealand Dollar </option>
<option value="58"> Costa Rica - Costa Rican Colon </option>
<option value="59"> Cote D'Ivoire - CFA Franc BCEAO </option>
<option value="60"> Croatia - Kuna </option>
<option value="61"> Cuba - Cuban Peso </option>
<option value="62"> Cyprus - Cyprus Pound </option>
<option value="63"> Czech Republic - Czech Koruna </option>
<option value="64"> Denmark - Danish Krone </option>
<option value="65"> Djibouti - Djibouti Franc </option>
<option value="66"> Dominica - East Caribbean Dollar </option>
<option value="67"> Dominican Republic - Peso </option>
<option value="68"> East Timor - Timor Escudo </option>
<option value="69"> East Timor - Rupiah </option>
<option value="70"> Ecuador - Sucre </option>
<option value="71"> Ecuador - Unidad de Valor Constante </option>
<option value="72"> Egypt - Egyptian Pound </option>
<option value="73"> El Salvador - El Salvador Colon </option>
<option value="74"> Equatorial Guinea - CFA Franc BEAC </option>
<option value="75"> Eritrea - Kroon </option>
<option value="76"> Estonia - Nakfa </option>
<option value="77"> Ethiopia - Ethiopian Birr </option>
<option value="78"> Faeroe Islands - Danish Krone </option>
<option value="79"> Falkland Islands (Malvinas) - Pound </option>
<option value="80"> Fiji - Fiji Dollar </option>
<option value="81"> Finland - Euro </option>
<option value="82"> France - French Franc </option>
<option value="83"> France, Metropolitan - French Franc </option>
<option value="84"> French Guiana - French Franc </option>
<option value="85"> French Polynesia - Polynesia	CFP Franc </option>
<option value="86"> French Southern Territories - French Franc </option>
<option value="87"> Gabon - CFA Franc BEAC </option>
<option value="88"> French Southern Territories - Dalasi </option>
<option value="89"> Georgia - Lari </option>
<option value="90"> Germany - Euro </option>
<option value="91"> Ghana - Cedi </option>
<option value="92"> Gibraltar - Gibraltar Pound </option>
<option value="93"> Greece - Euro </option>
<option value="94"> Greenland - Danish Krone </option>
<option value="95"> Grenada - East Caribbean Dollar </option>
<option value="96"> Guadeloupe - French Franc </option>
<option value="97"> Guam - US Dollar </option>
<option value="98"> Guatemala - Quetzal </option>
<option value="99"> Guinea - Guinea Franc </option>
<option value="100"> Guinea-bissau - Guinea-Bissau Peso </option>
<option value="101"> Guinea-bissau - CFA Franc BCEAO </option>
<option value="102"> Guyana - Guyana Dollar </option>
<option value="103"> Haiti - Gourde </option>
<option value="104"> Haiti - US Dollar	 </option>
<option value="105"> Heard and Mc Donald Islands - Australian Dollar </option>
<option value="106"> Honduras - Lempira </option>
<option value="107"> Hong Kong - Hong Kong Dollar </option>
<option value="108"> Hungary - Forint </option>
<option value="109"> Iceland - Iceland Krona </option>
<option value="110"> India - Indian Rupee </option>
<option value="111"> Indonesia - Rupiah </option>
<option value="112"> Iran (Islamic Republic of) - Iranian Rial </option>
<option value="113"> Iraq - Iraqi Dinar </option>
<option value="114"> Ireland - Euro </option>
<option value="115"> Israel - New Israeli Sheqel </option>
<option value="116"> Italy - Italian Lira </option>
<option value="117"> Jamaica - Jamaican Dollar </option>
<option value="118"> Japan - Yen </option>
<option value="119"> Jordan - Jordanian Dinar </option>
<option value="120"> Kazakhstan - Tenge </option>
<option value="121"> Kenya - Kenyan Shilling </option>
<option value="122"> Kiribati - Australian Dollar </option>
<option value="123"> Korea, Democratic People's Republic of - North Korean Won </option>
<option value="124"> Korea, Republic of - Won </option>
<option value="125"> Kuwait - Kuwaiti Dinar </option>
<option value="126"> Kyrgyzstan - Som </option>
<option value="127"> Lao People's Democratic Republic - Kip </option>
<option value="128"> Latvia - Latvian Lats </option>
<option value="129"> Lebanon - Lebanese Pound </option>
<option value="130"> Lesotho - Rand </option>
<option value="131"> Lesotho - financial Rand </option>
<option value="132"> Lesotho - Loti </option>
<option value="133"> Liberia - Liberian Dollar </option>
<option value="134"> Libyan Arab Jamahiriya - Libyan Dinar </option>
<option value="135"> Liechtenstein - Swiss Franc </option>
<option value="136"> Lithuania - Lithuanian Litas </option>
<option value="137"> Luxembourg - Euro </option>
<option value="138"> Macau - Pataca </option>
<option value="139"> Macedonia, The Former Yugoslav Republic of - Denar </option>
<option value="140"> Madagascar - Malagasy Franc </option>
<option value="141"> Malawi - Kwacha </option>
<option value="142"> Malaysia - Malaysian Ringgit </option>
<option value="143"> Maldives - Rufiyaa </option>
<option value="144"> Mali - CFA Franc BCEAO </option>
<option value="145"> Malta - Maltese Lira </option>
<option value="146"> Marshall Islands - US Dollar </option>
<option value="147"> Martinique - French Franc </option>
<option value="148"> Mauritania - Ouguiya </option>
<option value="149"> Mauritius - Mauritius Rupee </option>
<option value="150"> Mayotte - Euro </option>
<option value="151"> Mexico - Mexican Peso </option>
<option value="152"> Mexico - Mexican Unidad de Inversion </option>
<option value="153"> Micronesia, Federated States of - US Dollar	 </option>
<option value="154"> Moldova, Republic of - Moldovan Leu </option>
<option value="155"> Monaco - French Franc </option>
<option value="156"> Mongolia - Tugrik </option>
<option value="157"> Montserrat - East Caribbean Dollar </option>
<option value="158"> Morocco - Moroccan Dirham </option>
<option value="159"> Mozambique - Metical </option>
<option value="160"> Myanmar - Kyat </option>
<option value="161"> Namibia - Rand </option>
<option value="162"> Namibia - Namibia Dollar </option>
<option value="163"> Nauru - Australian Dollar </option>
<option value="164"> Nepal - Nepalese Rupee </option>
<option value="165"> Netherlands - Euro </option>
<option value="166"> Netherlands Antilles - Antillian Guilder </option>
<option value="167"> New Caledonia - CFP Franc </option>
<option value="168"> New Zealand - New Zealand Dollar </option>
<option value="169"> Nicaragua - Cordoba Oro </option>
<option value="170"> Niger - CFA Franc BCEAO </option>
<option value="171"> Nigeria - Naira </option>
<option value="172"> Niue - New Zealand Dollar </option>
<option value="173"> Norfolk Island - Australian Dollar </option>
<option value="174"> Northern Mariana Islands - US Dollar </option>
<option value="175"> Norway - Norwegian Krone </option>
<option value="176"> Oman - Rial Omani </option>
<option value="177"> Pakistan - Pakistan Rupee </option>
<option value="178"> Palau - US Dollar </option>
<option value="179"> Panama - Balboa </option>
<option value="180"> Panama - US Dollar </option>
<option value="181"> Papua New Guinea - Kina </option>
<option value="182"> Paraguay - Guarani </option>
<option value="183"> Peru - Nuevo Sol </option>
<option value="184"> Philippines - Philippine Peso </option>
<option value="185"> Pitcairn - New Zealand Dollar </option>
<option value="186"> Poland - Zloty </option>
<option value="187"> Portugal - Euro </option>
<option value="188"> Puerto Rico - US Dollar </option>
<option value="189"> Qatar - Qatari Rial </option>
<option value="190"> Reunion - French Franc </option>
<option value="191"> Romania - Leu </option>
<option value="192"> Russian Federation - Russian Ruble </option>
<option value="193"> Russian Federation - Russian Ruble </option>
<option value="194"> Rwanda - Rwanda Franc </option>
<option value="195"> Saint Helena - St Helena Pound </option>
<option value="196"> Saint Kitts and Nevis - East Caribbean Dollar </option>
<option value="197"> Saint Lucia - East Caribbean Dollar </option>
<option value="198"> Saint Pierre and Miquelon - French Franc </option>
<option value="199"> Saint Vincent and the Grenadines - East Caribbean Dollar </option>
<option value="200"> Samoa - Tala </option>
<option value="201"> San Marino - Euro </option>
<option value="202"> Sao Tome and Principe - Dobra </option>
<option value="203"> Saudi Arabia - Saudi Riyal </option>
<option value="204"> Senegal - CFA Franc BCEAO </option>
<option value="205"> Seychelles - Seychelles Rupee </option>
<option value="206"> Sierra Leone - Leone </option>
<option value="207"> Singapore - Singapore Dollar </option>
<option value="208"> Slovakia (Slovak Republic) - Slovak Koruna </option>
<option value="209"> Slovenia - Tolar </option>
<option value="210"> Solomon Islands - Solomon Islands Dollar </option>
<option value="211"> Somalia - Somali Shilling </option>
<option value="212"> South Africa - Rand </option>
<option value="213"> South Georgia and the South Sandwich Islands - Pound Sterling </option>
<option value="214"> Spain - Euro </option>
<option value="215"> Sri Lanka - Sri Lanka Rupee </option>
<option value="216"> Sudan - Sudanese Dinar </option>
<option value="217"> Suriname - Surinam Guilder </option>
<option value="218"> Norwegian - Krone </option>
<option value="219"> Svalbard and Jan Mayen Islands - Lilangeni </option>
<option value="220"> Swaziland - Swedish Krona </option>
<option value="221"> Sweden - Swiss Franc </option>
<option value="222"> Switzerland - Syrian Pound </option>
<option value="223"> Syrian Arab Republic - New Taiwan Dollar </option>
<option value="224"> Taiwan - Somoni </option>
<option value="225"> Tajikistan - Tajik Ruble </option>
<option value="226"> Tanzania, United Republic of - Tanzanian Shilling </option>
<option value="227"> Thailand - Baht </option>
<option value="228"> Togo - CFA Franc BCEAO </option>
<option value="229"> Tokelau - New Zealand Dollar </option>
<option value="230"> Tonga - Pa-anga </option>
<option value="231"> Trinidad and Tobago - Trinidad and Tobago Dollar </option>
<option value="232"> Tunisia - Tunisian Dinar </option>
<option value="233"> Turkey - Turkish Lira </option>
<option value="234"> Turkmenistan - Manat </option>
<option value="235"> Turks and Caicos Islands - US Dollar </option>
<option value="236"> Tuvalu - Australian Dollar </option>
<option value="237"> Uganda - Uganda Shilling </option>
<option value="238"> Ukraine - Hryvnia </option>
<option value="239"> United Arab Emirates - UAE Dirham </option>
<option value="240"> United Kingdom - Pound Sterling </option>
<option value="241"> United States - US Dollar </option>
<option value="242"> United States Minor Outlying Islands - US Dollar </option>
<option value="243"> Uruguay - Peso Uruguayo </option>
<option value="244"> Uzbekistan - Uzbekistan Sum </option>
<option value="245"> Vanuatu - Vatu </option>
<option value="246"> Vatican City State (Holy See) - Italian Lira </option>
<option value="247"> Venezuela - Bolivar </option>
<option value="248"> Viet Nam - Dong </option>
<option value="249"> Virgin Islands (British) - US Dollar </option>
<option value="250"> Virgin Islands (U.S.) - US Dollar </option>
<option value="251"> Wallis and Futuna Islands - CFP Franc </option>
<option value="252"> Western Sahara - Moroccan Dirham </option>
<option value="253"> Yemen - Yemeni Rial </option>
<option value="254"> Yugoslavia - New Dinar </option>
<option value="255"> Zaire - New Zaire </option>
<option value="256"> Zambia - Kwacha </option>
<option value="257"> Zimbabwe - Zimbabwe Dollar </option>
    </select>
    </td>
  </tr>
  <tr>
    <td>Default Country</td>
    <td>
    <select name="defaultcountry">
    <option value="1"> Afghanistan </option>
<option value="2"> Albania </option>
<option value="3"> Algeria </option>
<option value="4"> American Samoa </option>
<option value="5"> Andorra </option>
<option value="6"> Angola </option>
<option value="7"> Anguilla </option>
<option value="8"> Antarctica </option>
<option value="9"> Antigua and Barbuda </option>
<option value="10"> Argentina </option>
<option value="11"> Armenia </option>
<option value="12"> Aruba </option>
<option selected value="13"> Australia </option>
<option value="14"> Austria </option>
<option value="15"> Azerbaijan </option>
<option value="16"> Bahamas </option>
<option value="17"> Bahrain </option>
<option value="18"> Bangladesh </option>
<option value="19"> Barbados </option>
<option value="20"> Belarus </option>
<option value="21"> Belgium </option>
<option value="22"> Belize </option>
<option value="23"> Benin </option>
<option value="24"> Bermuda </option>
<option value="25"> Bhutan </option>
<option value="26"> Bolivia </option>
<option value="27"> Bosnia and Herzegowina </option>
<option value="28"> Botswana </option>
<option value="29"> Bouvet Island </option>
<option value="30"> Brazil </option>
<option value="31"> British Indian Ocean Territory </option>
<option value="32"> Brunei Darussalam </option>
<option value="33"> Bulgaria </option>
<option value="34"> Burkina Faso </option>
<option value="35"> Burundi </option>
<option value="36"> Cambodia </option>
<option value="37"> Cameroon </option>
<option value="38"> Canada </option>
<option value="39"> Cape Verde </option>
<option value="40"> Cayman Islands </option>
<option value="41"> Central African Republic </option>
<option value="42"> Chad </option>
<option value="43"> Chile </option>
<option value="44"> China </option>
<option value="45"> Christmas Island </option>
<option value="46"> Cocos (Keeling) Islands </option>
<option value="47"> Colombia </option>
<option value="48"> Comoros </option>
<option value="49"> Congo </option>
<option value="50"> Cook Islands </option>
<option value="51"> Costa Rica </option>
<option value="52"> Cote D'Ivoire </option>
<option value="53"> Croatia </option>
<option value="54"> Cuba </option>
<option value="55"> Cyprus </option>
<option value="56"> Czech Republic </option>
<option value="57"> Denmark </option>
<option value="58"> Djibouti </option>
<option value="59"> Dominica </option>
<option value="60"> Dominican Republic </option>
<option value="61"> East Timor </option>
<option value="62"> Ecuador </option>
<option value="63"> Egypt </option>
<option value="64"> El Salvador </option>
<option value="65"> Equatorial Guinea </option>
<option value="66"> Eritrea </option>
<option value="67"> Estonia </option>
<option value="68"> Ethiopia </option>
<option value="69"> Faeroe Islands </option>
<option value="70"> Falkland Islands (Malvinas) </option>
<option value="71"> Fiji </option>
<option value="72"> Finland </option>
<option value="73"> France </option>
<option value="74"> France, Metropolitan </option>
<option value="75"> French Guiana </option>
<option value="76"> French Polynesia </option>
<option value="77"> French Southern Territories </option>
<option value="78"> Gabon </option>
<option value="79"> Gambia </option>
<option value="80"> Georgia </option>
<option value="81"> Germany </option>
<option value="82"> Ghana </option>
<option value="83"> Gibraltar </option>
<option value="84"> Greece </option>
<option value="85"> Greenland </option>
<option value="86"> Grenada </option>
<option value="87"> Guadeloupe </option>
<option value="88"> Guam </option>
<option value="89"> Guatemala </option>
<option value="90"> Guinea </option>
<option value="91"> Guinea-bissau </option>
<option value="92"> Guyana </option>
<option value="93"> Haiti </option>
<option value="94"> Heard and Mc Donald Islands </option>
<option value="95"> Honduras </option>
<option value="96"> Hong Kong </option>
<option value="97"> Hungary </option>
<option value="98"> Iceland </option>
<option value="99"> India </option>
<option value="100"> Indonesia </option>
<option value="101"> Iran (Islamic Republic of) </option>
<option value="102"> Iraq </option>
<option value="103"> Ireland </option>
<option value="104"> Israel </option>
<option value="105"> Italy </option>
<option value="106"> Jamaica </option>
<option value="107"> Japan </option>
<option value="108"> Jordan </option>
<option value="109"> Kazakhstan </option>
<option value="110"> Kenya </option>
<option value="111"> Kiribati </option>
<option value="112"> Korea, Democratic People's Republic of </option>
<option value="113"> Korea, Republic of </option>
<option value="114"> Kuwait </option>
<option value="115"> Kyrgyzstan </option>
<option value="116"> Lao People's Democratic Republic </option>
<option value="117"> Latvia </option>
<option value="118"> Lebanon </option>
<option value="119"> Lesotho </option>
<option value="120"> Liberia </option>
<option value="121"> Libyan Arab Jamahiriya </option>
<option value="122"> Liechtenstein </option>
<option value="123"> Lithuania </option>
<option value="124"> Luxembourg </option>
<option value="125"> Macau </option>
<option value="126"> Macedonia, The Former Yugoslav Republic of </option>
<option value="127"> Madagascar </option>
<option value="128"> Malawi </option>
<option value="129"> Malaysia </option>
<option value="130"> Maldives </option>
<option value="131"> Mali </option>
<option value="132"> Malta </option>
<option value="133"> Marshall Islands </option>
<option value="134"> Martinique </option>
<option value="135"> Mauritania </option>
<option value="136"> Mauritius </option>
<option value="137"> Mayotte </option>
<option value="138"> Mexico </option>
<option value="139"> Micronesia, Federated States of </option>
<option value="140"> Moldova, Republic of </option>
<option value="141"> Monaco </option>
<option value="142"> Mongolia </option>
<option value="143"> Montserrat </option>
<option value="144"> Morocco </option>
<option value="145"> Mozambique </option>
<option value="146"> Myanmar </option>
<option value="147"> Namibia </option>
<option value="148"> Nauru </option>
<option value="149"> Nepal </option>
<option value="150"> Netherlands </option>
<option value="151"> Netherlands Antilles </option>
<option value="152"> New Caledonia </option>
<option value="153"> New Zealand </option>
<option value="154"> Nicaragua </option>
<option value="155"> Niger </option>
<option value="156"> Nigeria </option>
<option value="157"> Niue </option>
<option value="158"> Norfolk Island </option>
<option value="159"> Northern Mariana Islands </option>
<option value="160"> Norway </option>
<option value="161"> Oman </option>
<option value="162"> Pakistan </option>
<option value="163"> Palau </option>
<option value="164"> Panama </option>
<option value="165"> Papua New Guinea </option>
<option value="166"> Paraguay </option>
<option value="167"> Peru </option>
<option value="168"> Philippines </option>
<option value="169"> Pitcairn </option>
<option value="170"> Poland </option>
<option value="171"> Portugal </option>
<option value="172"> Puerto Rico </option>
<option value="173"> Qatar </option>
<option value="174"> Reunion </option>
<option value="175"> Romania </option>
<option value="176"> Russian Federation </option>
<option value="177"> Rwanda </option>
<option value="178"> Saint Helena </option>
<option value="179"> Saint Kitts and Nevis </option>
<option value="180"> Saint Lucia </option>
<option value="181"> Saint Pierre and Miquelon </option>
<option value="182"> Saint Vincent and the Grenadines </option>
<option value="183"> Samoa </option>
<option value="184"> San Marino </option>
<option value="185"> Sao Tome and Principe </option>
<option value="186"> Saudi Arabia </option>
<option value="187"> Senegal </option>
<option value="188"> Seychelles </option>
<option value="189"> Sierra Leone </option>
<option value="190"> Singapore </option>
<option value="191"> Slovakia (Slovak Republic) </option>
<option value="192"> Slovenia </option>
<option value="193"> Solomon Islands </option>
<option value="194"> Somalia </option>
<option value="195"> South Africa </option>
<option value="196"> South Georgia and the South Sandwich Islands </option>
<option value="197"> Spain </option>
<option value="198"> Sri Lanka </option>
<option value="199"> Sudan </option>
<option value="200"> Suriname </option>
<option value="202"> Svalbard and Jan Mayen Islands </option>
<option value="203"> Swaziland </option>
<option value="204"> Sweden </option>
<option value="205"> Switzerland </option>
<option value="206"> Syrian Arab Republic </option>
<option value="207"> Taiwan </option>
<option value="208"> Tajikistan </option>
<option value="209"> Tanzania, United Republic of </option>
<option value="210"> Thailand </option>
<option value="211"> Togo </option>
<option value="212"> Tokelau </option>
<option value="213"> Tonga </option>
<option value="214"> Trinidad and Tobago </option>
<option value="215"> Tunisia </option>
<option value="216"> Turkey </option>
<option value="217"> Turkmenistan </option>
<option value="218"> Turks and Caicos Islands </option>
<option value="219"> Tuvalu </option>
<option value="220"> Uganda </option>
<option value="221"> Ukraine </option>
<option value="222"> United Arab Emirates </option>
<option value="223"> United Kingdom </option>
<option value="224"> United States </option>
<option value="225"> United States Minor Outlying Islands </option>
<option value="226"> Uruguay </option>
<option value="227"> Uzbekistan </option>
<option value="228"> Vanuatu </option>
<option value="229"> Vatican City State (Holy See) </option>
<option value="230"> Venezuela </option>
<option value="231"> Viet Nam </option>
<option value="232"> Virgin Islands (British) </option>
<option value="233"> Virgin Islands (U.S.) </option>
<option value="234"> Wallis and Futuna Islands </option>
<option value="235"> Western Sahara </option>
<option value="236"> Yemen </option>
<option value="237"> Yugoslavia </option>
<option value="238"> Zaire </option>
<option value="239"> Zambia </option>
<option value="240"> Zimbabwe </option>
    </select>
    </td>
  </tr>
  <tr>
    <td>Default Paper Size</td>
    <td>
    <select name="papersize">
    <option value="A3">A3</option>
    <option value="A4" selected>A4</option>
    <option value="A5">A5</option>
    <option value="Letter">Letter</option>
    <option value="Legal">Legal</option>
    </select>
    </td>
  </tr>
  <tr>
    <td>Default PDF Paper Size</td>
    <td>
    <select name="pdfpapersize">
    <option value="A3">A3</option>
    <option value="A4" selected>A4</option>
    <option value="A5">A5</option>
    <option value="Letter">Letter</option>
    <option value="Legal">Legal</option>
    </select>
    </td>
  </tr>
  <tr>
    <td>Accounting Method</td>
    <td>
    <select name="accountingmethod">
    <option value="cash" selected>Cash</option>
    <option value="accrual">Accrual</option>
    </select>
    </td>
  </tr>

<tr>
<td align="right" colspan="2">
<hr>
  <input type="hidden" name="setup_page" value="4">
  <table cellspacing="0" cellpadding="0" border="0" class="nav">
  <tr>
    <td><input class="obutton" type="button" onclick="window.open('page5help.html');" value="Help" /></td>
    <td><input class="obutton" type="button" name="goto" value="Back" onclick="document.getElementById('form').submit();" />
        <input type="hidden" name="goto" value="Back" /></td>
     <td><input class="button" type="submit" name="goto" value="Next" /></td>
   </tr>
   </table>
</td>
</tr>
</table>
</form>
<br>
</body>
</html>
