<?
/**
 * ADOdb Lite Configuration File
 */

/**
* Set the $dbtype variable to the database designator.
* If this variable is enabled it will override the database designator
* entered in the ADONewConnection( $dbtype ) function. The database
* designator in a DSN string will be overridden but the rest of the DSN
* string will be used.
*/

// $dbtype = "mysql";

/**
* If you want to maintain compatability with the ADOdb ADONewConnection( $dbtype )
* function you should designate the modules you need loaded below. If you designate
* the modules below you do not need to designate them in
* ADONewConnection( $dbtype, $modules ).
* 
* If you would like more than one module loaded at the same time concatinate the 
* module names using a colon (:).
* 
* Example:
* $modules = "pear:transaction:extend";
* 
* The above example would load the Pear, Transaction and Extend modules
* automatically.
*/

// $modules = "pear";
?>