<?php
/*
bank.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/

class BankItemType
{
   var $id;
   var $name;
   
   function BankItemType($id=false)
   {
      if($id){
         if($this->Fill($id)){
            return true;
         }
      }
      $this->id=0;
      $this->name='';
   }
   
   function GetID() { return $this->id; }
   
   function Fill($id)
   {
      if($id==0){
         return false;
      }
      
      $qry=sprintf(bank_banklib_qry1, $id);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->name=$row["name"];

         return true;
      }
      return false;
   }
   
   function Set($n)
   {
      $this->name=$n;
   }
   
   function SetFromForm($frm)
   {
      $this->name=$frm['name'];
   }
   
   function Combo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
         $result=$_SESSION['VxCFG']->dbh->Execute(bank_banklib_qry5);
         echo "<select name=\"$cname\">\n";
   	   while($row = $result->FetchRow()){
   	   	$boo=$row["id"];
	   	   $poo=$row["name"];
   	   	if($id==$boo){
	   	   	echo "<option selected value=\"$boo\"> $poo </option>\n";
   		   }
      		else{
	      		echo "<option value=\"$boo\"> $poo </option>\n";
   		   }
	      }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(bank_banklib_qry1, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($row = $result->FetchRow()){
            echo $row[0];
         }
         else{
            echo _("Not Set");
         }
      }
   }
   
   function Add()
   {
      $qry=sprintf(bank_banklib_qry2, $this->name);
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
      $_SESSION['VxCFG']->dbh->Execute(misc_qry1);
      if($row = $result->FetchRow()){
         $this->id=$row[0];
      }
      return $this->id;
   }
   
   function Commit($id)
   {
      $qry=sprintf(bank_banklib_qry3, $this->name, $id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(bank_banklib_qry4, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function FillTable($a, $id, $title, $bInside=false)
   {
      if($this->ID==0){
         $this->Fill($id);
      }
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"bank\">\n";
	      echo "<tr>\n";
	      echo "<td colspan=\"2\" align=\"center\"><h3>$title</h3></td></tr>\n";
      }
	   echo "<tr>\n";
      echo "<td  class=\"formlabel\">"._("Name")."</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "name", 68, 64, $this->name);
   	echo"</td>\n";
	   echo "</tr>\n";
      if(!$bInside){
   	   echo "</table>\n";
      }
   }
   
   function Find($bOutput)
   {
      $query="select * from bankitemtype where ";
      if($this->name!=''){
         $query.="name='$this->name'";
      }
      
      $result=$_SESSION['VxCFG']->dbh->Execute($query);
      $n=db_num_rows($result);
      if(!$bOutput){
         if($n==0){
            return false;
         }
         else{
            return true;
         }
      }
      
      if($n==0){
         echo "<br><br><center><h2>"._("No matching Item Type found for search Criteri")."a</h2></center>";
         return false;
      }
      
      echo "<table width=\"100%\"><tr><td colspan=\"6\" align=\"center\"><h3>"._("Found ").$n._(" Matches")."</h3></td></tr>\n";
      echo "<tr><td><h3>"._("Name")."</h3></td>\n";
      while($row = $result->FetchRow()){
         echo "<tr><td>\n";
         if($ba1){
            echo "<b>$row[name]</b>";
         }
         else{
             echo $row['name'];
         }
      }
      echo "</table>\n";
      
      return true;
   }
}

class BankItem
{
   var $id;
   var $bankid;
   var $itemdate;
   var $itemtype;
   var $accountid;
   var $transid;
   var $referencedata;
   var $amount;
   
   function BankItem()
   {
      $this->id=0;
      $this->bankid=0;
      $this->itemdate='';
      $this->itemtype=0;
      $this->accountid=0;
      $this->transid=0;
      $this->referencedata='';
      $this->amount=0.0;
   }
   
   function GetID() { return $this->id; }
   
   function Fill($id, $bOffset=true)
   {
      if($bOffset){
         $qry=sprintf(bank_qry7, $id);
      }
      else{
         $qry=sprintf(bank_banklib_qry6, $id);
      }
      
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->bankid=$row["bankid"];
         $this->itemdate=$row["itemdate"];
         $this->itemtype=$row["itemtype"];
         $this->accountid=$row["accountid"];
         $this->transid=$row["transid"];
         $this->referencedata=$row["referencedata"];
         $this->amount=$row["amount"];

         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e,$f,$g)
   {
      $this->bankid=$a;
      $this->itemdate=$b;
      $this->itemtype=$c;
      $this->accountid=$d;
      $this->transid=$e;
      $this->referencedata=$f;
      $this->amount=$g;
   }
   
   function SetFromForm($frm)
   {
      $this->bankid=$frm['bankid'];
      $this->itemdate=$frm['itemdate'];
      $this->itemtype=$frm['itemtype'];
      $this->accountid=$frm['accountid'];
      $this->transid=$frm['transid'];
      $this->referencedata=$frm['referencedata'];
      $this->amount=$frm['amount'];
   }
   
   function Add()
   {
      $qry=sprintf(bank_banklib_qry8, $this->name);
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
      $_SESSION['VxCFG']->dbh->Execute(misc_qry1);
      if($row = $result->FetchRow()){
         $this->id=$row[0];
      }
      return $this->id;
   }
   
   function Commit($id)
   {
      $qry=sprintf(bank_banklib_qry9, $this->name, $id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(bank_banklib_qry10, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Combo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
         $result=$_SESSION['VxCFG']->dbh->Execute(bank_banklib_qry7, $id);
         echo "<select name=\"$cname\">\n";
   	   while($row = $result->FetchRow()){
   	   	$boo=$row["id"];
	   	   $poo=$row["name"];
   	   	if($id==$boo){
	   	   	echo "<option selected value=\"$boo\"> $poo </option>\n";
   		   }
      		else{
	      		echo "<option value=\"$boo\"> $poo </option>\n";
   		   }
	      }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(bank_banklib_qry6, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($row = $result->FetchRow()){
            echo $row[0];
         }
         else{
            echo _("Not Set");
         }
      }
   }
   
   function TypeCombo($a, $id, $cname)
   {
      $tc=new BankItemType();
      $tc->Combo($a, $id, $cname);
   }
   
   function FillRangedTable($a, $id, $title, $bOffset=true, $bInside=false)
   {
   }
   
   function FillAccountTable($a, $id, $title, $bOffset=true, $bInside=false)
   {
   }
   
   function FillTable($a, $id, $title, $bOffset=true, $bInside=false)
   {
      if($this->id==0){
         if($bOffset)
            $this->Fill($id, true);
         else
            $this->Fill($id, false);
      }
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"bank\">\n";
	      echo "<tr>\n";
	      echo "<td colspan=\"2\" align=\"center\"><h3>$title</h3></td></tr>\n";
      }
	   echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Bank")."</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "name", 68, 64, $this->name);
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr><td class=\"formdata\">\n";
      $b=new BankDetails();
      $b->Combo($a, $this->bankid);
      echo "</td></tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Date")."</td>\n";
      echo "<td class=\"formdata\">";
      $td=new TimeDate();
      $td->parse($this->itemdate);
      $td->datecontrol($a, "itemdate");
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr><td class=\"formdata\">\n";
      $this->TypeCombo($a, $this->itemtype, "itemtype");
      echo "</td></tr>\n";
      
      echo "<tr><td class=\"formdata\">\n";
      $acc=new Account();
      $acc->Combo($a, $this->accountid);
      echo "</td></tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Transaction")."</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "transid", 68, 64, $this->transid);
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Reference")."</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "referencedata", 68, 64, $this->referencedata);
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Amount")."</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "amount", 68, 64, $this->amount);
   	echo"</td>\n";
	   echo "</tr>\n";
      
      if(!$bInside){
   	   echo "</table>\n";
      }
   }
   
   function Find($bOutput)
   {
      $query="select * from bankitem where ";
      if($this->name!=''){
         $query.="name='$this->name'";
      }
      
      $result=$_SESSION['VxCFG']->dbh->Execute($query);
      $n=db_num_rows($result);
      if(!$bOutput){
         if($n==0){
            return false;
         }
         else{
            return true;
         }
      }
      
      if($n==0){
         echo "<br><br><center><h2>"._("No matching Item Type found for search Criteria")."</h2></center>";
         return false;
      }
      
      echo "<table width=\"100%\"><tr><td colspan=\"6\" align=\"center\"><h3>Found $n Matches</h3></td></tr>\n";
      echo "<tr><td><h3>Name</h3></td>\n";
      while($row = $result->FetchRow()){
         echo "<tr><td>\n";
         if($ba1){
            echo "<b>$row[name]</b>";
         }
         else{
             echo $row['name'];
         }
      }
      echo "</table>\n";
      
      return true;
   }
}

class BankAccount
{
   var $id;
   var $bankid;
	var $name;
	var $number;
   var $accountid;
   
   function BankDetails()
   {
      $this->id=0;
      $this->bankid=0;
      $this->name='';
      $this->number='';
      $this->accountid=0;
   }
   function GetID() { return $this->id; }
   
   function Fill($id)
   {
      $qry=sprintf(bank_account_qry3, $id);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->bankid=$row["bankid"];
         $this->name=$row["name"];
         $this->umber=$row["number"];
         $this->accountid=$row["accountid"];

         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d)
   {
      $this->bankid=$a;
      $this->name=$b;
      $this->number=$c;
      $this->accountid=$d;
      
   }
   
   function SetFromForm($frm)
   {
      $this->bankid=$frm['bankid'];
      $this->name=$frm['name'];
      $this->number=$frm['number'];
      $this->accountid=$frm['accountid'];
   }
   
   function Combo($a, $id, $cname, $bFilter=false)
   {
      if($a=="commit" || $a=="add"){
         $result=$_SESSION['VxCFG']->dbh->Execute(bank_account_qry9);
         if($bFilter){
            if($id=='All'){
               echo "<option selected value=\"All\">"._("All")."</option>\n";
            }
            else{
               echo "<option value=\"All\">"._("All")."</option>\n";
            }
         }
         else{
            echo "<select name=\"$cname\">\n";
         }
   	   while($row = $result->FetchRow()){
            $qry=sprintf(bankm_bank_qry3, $row['bankid']);
            $bresult=$_SESSION['VxCFG']->dbh->Execute($qry);
            $brow=$bresult->FetchRow();
   	   	if($id==$row['id']){
	   	   	echo "<option selected value=\"".$row['id']."\">".$brow['name']." - ".$row['name']."</option>\n";
   		   }
      		else{
	      		echo "<option value=\"".$row['id']."\">".$brow['name']." - ".$row['name']."</option>\n";
   		   }
	      }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(bank_account_qry3, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($row = $result->FetchRow()){
            $qry=sprintf(bankm_bank_qry3, $row['bankid']);
            $bresult=$_SESSION['VxCFG']->dbh->Execute($qry);
            $brow=$bresult->FetchRow();
            echo $brow['name']." - ".$row['name'];
         }
         else{
            echo "Not Set";
         }
      }
   }
   
   function ComboByBank($a, $id, $cname, $bid, $bFilter=false)
   {
      if($a=="commit" || $a=="add"){
         if($bid=='All'){
            $result=$_SESSION['VxCFG']->dbh->Execute(bank_account_qry9);
         }
         else{
            $qry=sprintf(bank_account_qry11, $bid);
            $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         }
         if($bFilter){
            echo "<select name=\"".$cname."\" onChange=\"this.form.submit();\">\n";
            if($id=='All'){
               echo "<option selected value=\"All\">"._("All")."</option>\n";
            }
            else{
               echo "<option value=\"All\">"._("All")."</option>\n";
            }
         }
         else{
            echo "<select name=\"$cname\">\n";
         }
   	   while($row = $result->FetchRow()){
   	   	if($id==$row['id']){
	   	   	echo "<option selected value=\"".$row['id']."\">".$row['name']."</option>\n";
   		   }
      		else{
	      		echo "<option value=\"".$row['id']."\">".$row['name']."</option>\n";
   		   }
	      }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(bank_account_qry10, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($row = $result->FetchRow()){
            echo $row['name'];
         }
         else{
            echo _("Not Set");
         }
      }
   }
   
   function Add()
   {
       $qry=sprintf(bank_account_qry5, $this->bankid,$this->name,$this->number,$this->accountid);
       $_SESSION['VxCFG']->dbh->Execute($qry);
       $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
       $row = $result->FetchRow();
       $this->id=$row[0]; 
       return $this->id;
   }
   
   function Commit($id)
   {
      $qry=sprintf(bank_account_qry5, $this->bankid,$this->name,$this->number,$this->accountid, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(bank_account_qry6, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function FillTable($a, $id, $title)
   {
      echo "<fieldset>\n<legend>"._("Bank Account")."</legend><table>\n";
      if($a=='browse'){
         if(!$this->Fill($id)){
            echo "<tr><td colspan=\"2\" class=\"formdata\">"._("There are no bank accounts defined.")."</td></tr></table>\n</fieldset>\n";
            return;
         }
      }
      else{
         $this->Fill($id);
      }
      echo "<tr><td class=\"formlabel\">"._("Bank")."</td><td class=\"formdata\">\n";
      $b=new Bank();
      $b->Combo($a, "bankid", $this->bankid);
   	echo"</td></tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Name")."</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "name", 68, 64, $this->name);
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Account Number")."</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "branch", 68, 64, $this->number);
   	echo"</td>\n";
	   echo "</tr>\n";
      
      echo "<tr><td class=\"formlabel\">"._("Account")."</td><td class=\"formdata\">\n";
      $acc=new Account();
      $acc->Combo($a, $this->accountid, "accountid");
   	echo"</td></tr>\n";
      
	   echo "</table>\n</fieldset>\n";
   }
}
   

class BankDetails
{
   var $id;
   var $bankid;
   var $accountid;
   var $name;
   var $branch;
   var $addressid;
   var $contactid;
   var $banksortcode;
   var $banknumber;
   
   function BankDetails()
   {
      $this->id=0;
      $this->bankid=0;
      $this->accountid=0;
      $this->name='';
      $this->branch='';
      $this->addressid=0;
      $this->contactid=0;
      $this->banksortcode='';
      $this->banknumber='';
   }
   
   function GetID() { return $this->id; }
   
   function Fill($id)
   {
      $qry=sprintf(bank_banklib_qry11, $id);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->bankid=$row["bankid"];
         $this->accountid=$row["accountid"];
         $this->name=$row["name"];
         $this->branch=$row["branch"];
         $this->addressid=$row["addressid"];
         $this->contactid=$row["contactid"];
         $this->banksortcode=$row["banksortcode"];
         $this->banknumber=$row["banknumber"];

         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d,$e,$f,$g,$h)
   {
      $this->bankid=$a;
      $this->accountid=$b;
      $this->name=$c;
      $this->branch=$d;
      $this->addressid=$e;
      $this->contactid=$f;
      $this->banksortcode=$g;
      $this->banknumber=$h;
   }
   
   function SetFromForm($frm)
   {
      $this->bankid=$frm['bankid'];
      $this->accountid=$frm['accountid'];
      $this->name=$frm['name'];
      $this->branch=$frm['branch'];
      $this->addressid=$frm['addressid'];
      $this->contactid=$frm['contactid'];
      $this->banksortcode=$frm['banksortcode'];
      $this->banknumber=$frm['banknumber'];
   }
   
   function Combo($a, $id, $cname, $bFilter=false)
   {
      if($a=="commit" || $a=="add"){
         $result=$_SESSION['VxCFG']->dbh->Execute(bank_banklib_qry12);
         if($bFilter){
            echo "<select name=\"".$cname."\" onChange=\"this.form.submit();\">\n";
            if($id=='All'){
               echo "<option selected value=\"All\">"._("All")."</option>\n";
            }
            else{
               echo "<option value=\"All\">"._("All")."</option>\n";
            }
         }
         else{
            echo "<select name=\"".$cname."\">\n";
         }
   	   while($row = $result->FetchRow()){
   	   	if($id==$row['id']){
	   	   	echo "<option selected value=\"".$row['id']."\">".$row['name']."</option>\n";
   		   }
      		else{
	      		echo "<option value=\"".$row['id']."\">".$row['name']."</option>\n";
   		   }
	      }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(bank_banklib_qry11, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($row = $result->FetchRow()){
            echo $row['name'];
         }
         else{
            echo _("Not Set");
         }
      }
   }
   
   function Add()
   {
      /*
      $qry=sprintf(bank_banklib_qry13, );
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
       $this->id=db_insert_id();
       return $this->id;*/
   }
   
   function Commit($id)
   {
   /*
      $qry=sprintf(bank_banklib_qry14, );
      $_SESSION['VxCFG']->dbh->Execute($qry);*/
   }
   
   function Delete()
   {
      $qry=sprintf(bank_banklib_qry15, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function FillTable($a, $id, $title, $bOffset=true, $bInside=false)
   {
      if($this->id==0){
         if($bOffset)
            $this->Fill($id, true);
         else
            $this->Fill($id, false);
      }
      if(!$bInside){
         echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"bank\">\n";
	      echo "<tr>\n";
	      echo "<td colspan=\"2\" align=\"center\"><h3>$title</h3></td></tr>\n";
      }
	   echo "<tr>\n";
      echo "<td class=\"formlabel\">Name</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "name", 68, 64, $this->name);
   	echo"</td>\n";
	   echo "</tr>\n";
	
   	echo "<tr>\n";
      echo "<td class=\"formlabel\">Branch</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "branch", 68, 64, $this->branch);
   	echo"</td>\n";
	   echo "</tr>\n";
      
   	echo "<tr>\n";
      echo "<td class=\"formlabel\">Sort Code</td>\n";
   	echo "<td class=\"formdata\">";
      entry($a, "banksortcode", 68, 64,$this->banksortcode);
   	echo"</td>\n";
	   echo "</tr>\n";

   	echo "<tr>\n";
      echo "<td class=\"formlabel\">Number</td>\n";
      echo "<td class=\"formdata\">";
	   entry($a, "banknumber", 68, 64, $this->banknumber);
   	echo "</td>\n";
	   echo "</tr>\n";
   
      //$this->accountid=$frm['accountid'];
      //$this->contactid=$frm['contactid'];
      
      $a=new Address();
      $a->FillTable($a, $this->addressid, "", true);

   	echo "</td>\n";
	   echo "</tr>\n";
      if(!$bInside){
   	   echo "</table>\n";
      }
   }
   
   function Find($bOutput)
   {
      $numfunctions  = array('=', '>', '>=', '<', '<=', '!=');
      $textfunctions = array('LIKE', '=', '!=');

      $band=false;
      $bbankID=false;
      $baccountID=false;
      $bname=false;
      $bbranch=false;
      $baddressID=false;
      $bcontactID=false;
      $bBankSortCode=false;
      $bBankNumber=false;
      
      $query="select * from bankdetails where ";
      if($this->bankID!=''){
         $query.="bankid='$this->bankid'";
         $bbankID=true;
         $band=true;
      }
      if($this->accountID!=''){
         if(!$band){
            $query.="accountid='$this->accountid'";
            $baccountID=true;
         }
         else{
            $query.="and accountid='$this->accountid'";
         }
         $baccountID=true;
      }
      if($this->name!=''){
         if(!$band){
            $query.="name='$this->name'";
            $band=true;
         }
         else{
            $query.="and name='$this->name'";
         }
         $bname=true;
      }
      if($this->branch!=''){
         if(!$band){
            $query.="branch='$this->branch'";
            $band=true;
         }
         else{
            $query.="and branch='$this->branch'";
         }
         $bbranch=true;
      }
      if($this->BankSortCode!=''){
         if(!$band){
            $query.="banksortcode='$this->banksortcode'";
            $band=true;
         }
         else{
            $query.="and banksortcode='$this->banksortcode'";
         }
         $bBankSortCode=1;
      }
      if($this->BankNumber!=''){
         if(!$band){
            $query.="banknumber='$this->banknumber'";
            $band=true;
         }
         else{
            $query.="and banknumber='$this->banknumber'";
         }
         $bBankNumber=1;
      }
      
      $result=$_SESSION['VxCFG']->dbh->Execute($query);
      $n=db_num_rows($result);
      if(!$bOutput){
         if($n==0){
            return false;
         }
         else{
            return true;
         }
      }
      
      if($n==0){
         echo "<br><br><center><h2>No matching Bank found for search Criteria</h2></center>";
         return false;
      }
      
      echo "<table width=\"100%\"><tr><td colspan=\"6\" align=\"center\"><h3>Found $n Matches</h3></td></tr><tr>\n";
      if(bbankID){
         echo "<td><h3>Bank ID</h3>\n;";
      }
      if($baccountID){
         echo "</td><td><h3>Account</h3></td>\n";
      }
      if($bname){
         echo "<td><h3>Name</h3></td>\n";
      }
      if($bbranch){
         echo "<td><h3>Branch</h3></td>\n";
      }
      if($baddressID){
         echo "<td><h3>Address</h3></td>\n";
      }
      if($bcontactID){
         echo "<td><h3>Contact</h3></td>\n";
      }
      if($bBankSortCode){
         echo "<td><h3>Sort Code</h3></td>\n";
      }
      if($bBankNumber){
         echo "<td><h3>Number</h3></td>\n";
      }
         
      while($row = $result->FetchRow()){
         echo "<tr><td>\n";
         if($bbankID){
            echo "<b>$row[bankid]</b>";
         }
         else{
             echo $row['bankid'];
         }
         echo "</td><td>";
         if($baccountID){
            echo "<b>$row[accountid]</b>";
         }
         else{
            echo $row['accountid'];
         }
         echo "</td><td>";
         if($bname){
            echo "<b>$row[name]</b>";
         }
         else{
            echo $row['name'];
         }
         echo "</td><td>";
         if($bbranch){
            echo "<b>$row[branch]</b>";
         }
         else{
            echo $row['branch'];
         }
         echo "</td><td>";
         if($addressID){
            echo "<b>$row[addressid]</b>";
         }
         else{
            echo $row['addressid'];
         }
         echo "</td><td>";
         if($bcontactID){
            echo "<b>$row[contactid]</b>";
         }
         else{
            echo $row['contactid'];
         }
         echo "</td><td>";
         if($bBankSortCode){
            echo "<b>$row[banksortcode]</b>";
         }
         else{
            echo $row['banksortcode'];
         }
         echo "</td><td>";
         if($bBankNumber){
            echo "<b>$row[banknumber]</b>";
         }
         else{
            echo $row['banknumber'];
         }
         echo "</td></tr>\n";
      }
      echo "</table>\n";
      
      return true;
   }
}

class BankReporter Extends BankDetails
{
   var $sdate;
   var $edate;
   var $items;
}

?>
