<?php
/*
currency.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
/**
 * @ingroup generic
 */

/**
 \class Currency
 \brief A class to handle currency
*/
class Currency
{
   var $id;
   var $countryid;
   var $bigname;
   var $smallname;
   var $isoname;
   var $isonumber; 
   
   function Currency()
   {
      $this->id=0;
      $this->countryid=0;
      $this->bigname="";
      $this->smallname="";
      $this->isoname="";
      $this->isonumber=0;
   }
   
   function GetID() { return $this->id; }
   
   function Fill($id, $bOffset=false)
   {
      $qry=sprintf(misc_qry3, $id);
      
	   $result=db_query($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->countryid=$row["countryid"];
         $this->isoname=$row["isoname"];
         $this->isonumber=$row["isonumber"];
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c)
   {
      $this->country=$a;
      $this->isoname=$b;
      $this->isonumber=$c;
   }
   
   function SetFromForm($frm)
   {
      $this->countryid=$frm["countryid"];
      $this->isoname=$frm["isoname"];
      $this->isonumber=$frm["isonumber"];
   }
   
   function Add()
   {
   }
   
   function Commit($id)
   {
   }
   
   function Delete()
   {
   }
   
   function Combo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
         if($id==0){
            $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry9);
            if($row=$result->FetchRow()){
               $id=$row['value'];
            }
         }
         $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry3);
         echo "<select name=\"$cname\">\n";
         if($id==0){            
            echo "<option selected value=\"0\">". _("Not Set") ."</option>\n";
         }
         else{
            echo "<option value=\"0\">". _("Not Set") ."</option>\n";
         }
         while($row = $result->FetchRow()){
            $qry=sprintf(misc_qry7, $row['countryid']);
            $cresult=$_SESSION['VxCFG']->dbh->Execute($qry);
            $crow=$cresult->FetchRow();
            $n=$crow["name"] . " - " . $row["bigname"];
            $boo=$row["id"];
   	      if($id==$boo){
	   	     	echo "<option selected value=\"$boo\"> $n </option>\n";
   		   }
         	else{
	         	echo "<option value=\"$boo\"> $n </option>\n";
   	   	}
         }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(misc_qry4, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         if($row = $result->FetchRow()){
            $qry=sprintf(misc_qry7, $row['countryid']);
            $cresult=$_SESSION['VxCFG']->dbh->Execute($qry);
            $crow=$cresult->FetchRow();
            $n=$crow["name"] . " - " . $row["bigname"];
            echo $n;
         }
         else{
            echo _("Not Set");
         }
      }
   }
   
   function FillTable($a, $id, $title, $bOffset=true, $bInside=false)
   {
   }
   
   function Find($bOutput)
   {
      return true;
   }
}

class ExchangeRate
{
   var $sourceid;
   var $targetid;
   var $exchangerate;
   
   function ExchangeRate()
   {
      $this->sourceid=0;
      $this->targetid=0;
      $this->exchangerate=0.0;
   }
   
   function Combo($a, $id, $cname)
   {
      if($a=="commit" || $a=="add"){
         $result=db_query(misc_qry3);
         echo "<select name=\"$cname\">\n";
         if($id==0){
            echo "<option selected value=\"0\">". _("Not Set") ."</option>\n";
         }
         else{
            echo "<option value=\"0\">". _("Not Set") ."</option>\n";
         }
         while($row = $result->FetchRow()){
            $qry=sprintf(misc_qry7, $row['countryid']);
            $cresult=db_query($qry);
            $crow=$cresult->FetchRow();
            $n=$crow["name"] . " - " . $row["bigname"];
            $boo=$row["id"];
   	      if($id==$boo){
	   	     	echo "<option selected value=\"$boo\"> $n </option>\n";
   		   }
         	else{
	         	echo "<option value=\"$boo\"> $n </option>\n";
   	   	}
         }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(misc_qry4, $id);
         $result=db_query($qry);
         if($row = $result->FetchRow()){
            $qry=sprintf(misc_qry7, $row['countryid']);
            $cresult=db_query($qry);
            $crow=$cresult->FetchRow();
            $n=$crow["name"] . " - " . $row["bigname"];
            echo $n;
         }
         else{
            echo _("Not Set");
         }
      }
   }
}

?>
