<?php
/*
customer.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001 - 2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
 require_once("discount.php");
 //require_once("loyalty.php");
 
 class CustomerLog
 {
   var $id;
   var $customerid;
   var $actionid;
   var $stamper;
   var $data;
   
   function CustomerLog($id=false)
   {
   }
 }
 
 class Customer
 {
   var $id;
   var $cmid;
   var $contactid;
   var $storecardid;
   var $loyalityid;
   var $signatureid;
   var $chargeaccountid;
   var $login;
   var $password;
   var $memoid;
   
   function Customer($id=false, $bOffset=false)
   {
      if(isset($id)){
         if(isset($bOffset)){
            $this->Fill($id, $bOffset);
         }
         else{
            $this->Fill($id, false);
         }
      }
      else{
         $this->id = 0;
         $this->cmid = 0;
         $this->contactid = 0;
         $this->storecardid = 0;
         $this->loyalityid = 0;
         $this->signatureid = 0;
         $this->chargeaccountid = 0;
         $this->login="";
         $this->password="";
         $this->memoid = 0;
      }
   }
   
   function Fill($id, $bOffset=false)
   {
      if($bOffset){
         $qry=sprintf(customer_qry2, $id);
      }
      else{
         $qry=sprintf(customer_qry3, $id);
      }
	   $result=db_query($qry);
	   if($row = $result->FetchRow()){
         $this->id=$id;
         $this->cmid = $row["cmid"];
         $this->contactid = $row["contactid"];
         $this->storecardid = $row["storecardid"];
         $this->loyalityid = $row["loyalityid"];
         $this->signatureid = $row["signatureid"];
         $this->chargeaccountid = $row["chargeaccountid"];
         $this->login = $row["login"];
         $this->password = $row["password"];
         $this->memoid = $row["memoid"];
         
         return false;
      }
      return true;
   }
   
   function Add()
   {
      $c=new CreateMod();
      $this->cmid=$c->Add();
      
      $qry=sprintf(customer_qry4, $this->cmid,$contactid,$storecardid,$loyalityid,
         $signatureid,$chargeaccountid,$login,$password,$memoid);
      db_query($qry);
       
      $result=db_query(misc_qry1);
      if($row = $result->FetchRow()){
         $this->id=$row[0];
      }
      return $this->id;
   }
   
   function Commit($id)
   {
      $c=new CreateMod();
      $c->Fill($this->cmid);
      $c->Commit();
      
      $qry=sprintf(customer_qry5, $this->cmid,$contactid,$storecardid,$loyalityid,
         $signatureid,$chargeaccountid,$login,$password,$memoid,$this->id);
      db_query($qry);
   }
   
   function Delete($id=false)
   {
      if(isset($id)){
         $qry=sprintf(customer_qry6, $id);
      }
      else{
         $qry=sprintf(customer_qry6, $this->id);
      }
	   db_query($qry);
   }
   
   function Combo($a, $cname, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $result=db_query(chargeitem_qry7);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id "];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(chargeitem_qry3, $id);
         $result=db_query($qry);
      	if($row = $result->FetchRow()){
		      $poo=$row["name"];
            echo $poo;
         }
         else echo "Not Set";
      }
   }
   
   function TypeCombo($a, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"type\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   if($id==BHSQL_DISCOUNT_PRODUCT){
	      	echo "<option selected value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
		   }
   		else if($id==BHSQL_DISCOUNT_CUSTOMER){
	   	   echo "<option value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option selected value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
   	   }
         else if($id==BHSQL_DISCOUNT_USER){
            echo "<option value=\"BHSQL_DISCOUNT_PRODUCT\"> Product </option>\n";
            echo "<option value=\"BHSQL_DISCOUNT_CUSTOMER\"> Customer</option>\n";
            echo "<option selected value=\"BHSQL_DISCOUNT_USER\"> User </option>\n";
         }
	      echo "</select>\n";
      }
      else{
         if($id==BHSQL_DISCOUNT_PRODUCT){
	      	echo "Product";
		   }
   		else if($id==BHSQL_DISCOUNT_CUSTOMER){
	   	   echo "Customer";
   	   }
         else if($id==BHSQL_DISCOUNT_USER){
            echo "User";
         }
      }
   }
   
   /////////////////////////////////////////////
   //
   // Templated stuff - Smarty Based
   //
   //
   function Template($id=false, $smarty)
   {
      if(isset($id)){
         Fill($id);
      }
      $smarty->assign('id', $this->id);
      $smarty->assign('cmid', $this->cmid);
      $smarty->assign('contactid', $this->contactid);
      $smarty->assign('storecardid', $this->storecardid);
      $smarty->assign('loyalityid', $this->loyalityid);
      $smarty->assign('signatureid', $this->signatureid);
      $smarty->assign('chargeaccountid', $this->chargeaccountid);
      $smarty->assign('login', $this->login);
      $smarty->assign('password', $this->password);
      $smarty->assign('memoid', $this->memoid);
   }
   
   function TemplateCombo($a, $cname, $id, $smarty)
   {
      if($a=="commit" || $a=="add"){
         $idarray=array();
         $namearray=array();
   	   $result=db_query(chargeitem_qry7);
      	while($row = $result->FetchRow()){
            array_push($idarray, $row["id "]);
            array_push($namearray, $row["name "]);
         }
      }
      else{
         $qry=sprintf(chargeitem_qry3, $id);
         $result=db_query($qry);
      	if($row = $result->FetchRow()){
            $smarty->assign('name', $row["name"]);
         }
         else $smarty->assign('name', "Not Set");
      }
   }
   
   /////////////////////////////////////////////
   //
   // Soap stuff - nusoap based
   //
   //
   function Soap($a, $id, $client)
   {
      if(isset($id)){
         Fill($id);
      }
      $cust=array(
         'id' => $this->id,
         'cmid' => $this->cmid,
         'contactid' => $this->contactid,
         'storecardid' => $this->storecardid,
         'loyalityid' => $this->loyalityid,
         'signatureid' => $this->signatureid,
         'chargeaccountid' => $this->chargeaccountid,
         'login' => $this->login,
         'password' => $this->password,
         'memoid' => $this->memoid);
         
      switch($a){
      case 'get':
         $row = $client->call('getcustomer', $id);
         break;
      case 'add':
         $row = $client->call('addcustomer', $cust);
         $this->id=$row[0];
         break;
      case 'commit':
         $row = $client->call('setcustomer', $cust);
         break;
      case 'delete':
         $row = $client->call('deletecustomer', $id);
         break;
      default:
         return false;
      }
      
      if($client->fault){
         return false;
      } 
      $err = $client->getError();
      if($err){
         return false;
      }
      
      if($a=='get'){
         if($row["id"]==0) return false;
         $this->id=$row["id"];
         $this->cmid = $row["cmid"];
         $this->contactid = $row["contactid"];
         $this->storecardid = $row["storecardid"];
         $this->loyalityid = $row["loyalityid"];
         $this->signatureid = $row["signatureid"];
         $this->chargeaccountid = $row["chargeaccountid"];
         $this->login = $row["login"];
         $this->password = $row["password"];
         $this->memoid = $row["memoid"];
      }
      
      return true;
   }
   
   function Table($a, $id, $title, $bOffset=false)
   {
      if($id!=0){
         $this->Fill($id, $bOffset);
      }
      echo "<table>\n";
      if($_SESSION['CFG']->onlinehelp){
         echo "<th class=\"title\" colspan=\"3\">$title</th>\n";
      }
      else{
         echo "<th class=\"title\" colspan=\"2\">$title</th>\n";
      }
      /*
      echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\" class=\"customer\">\n";
      */
	   //echo "<tr>\n";
	   //echo "<tr>\n<td colspan=\"2\" align=\"center\"><h3>$title</h3></td></tr>\n
      echo "<tr><td colspan=\"2\">";

      $c=new Contact();
      $c->Table($a, $this->contactid, "Details", $bOffset);
      echo "</td></tr>\n";
      /*
      echo "<tr><td width=\"20%\" align=\"right\">Type</td><td>\n";
      $this->TypeCombo($a, "typeid", $this->typeid);
   	echo"</td></tr>\n";
      
      echo "<tr><td width=\"20%\" align=\"right\">Account</td><td>\n";
      $acc=new Account();
      $acc->Combo($a, $this->accountid, "accountid");
   	echo"</td></tr>\n";
      
	   echo "<tr><td width=\"20%\" align=\"right\">Credit Limit</td><td>\n";
	   entry($a, "creditlimit", 16, 16, $this->creditlimit);
   	echo"</td></tr>\n";
	
   	echo "<tr><td align=\"right\">Last Transaction</td><td>\n";
      $td=new TimeDate();
      $td->parse($this->lasttransaction);
      $td->datecontrol($a, "");
   	echo"</td></tr>\n";

   	echo "<tr><td align=\"right\">Due Days</td><td>\n";
      entry($a, "duedays", 8, 8,$this->duedays);
   	echo"</td></tr>\n";
      
      echo "<tr><td align=\"right\">Discount Days</td><td>\n";
      entry($a, "discountdays", 8, 8,$this->discountdays);
   	echo"</td></tr>\n";
      
      echo "<tr><td>&nbsp;</td><td>\n";
      CheckBox($a, "standardterms", $this->standardterms, "Standard Terms");
      echo "</td></tr>\n";
      echo "<tr><td>&nbsp;</td><td>\n";
      CheckBox($a, "codterms", $this->codterms, "COD Terms");
      echo "</td></tr>\n";
      echo "<tr><td>&nbsp;</td><td>\n";
      CheckBox($a, "prepaidterms", $this->prepaidterms, "Prepaid Terms");
      echo "</td></tr>\n";
      echo "<tr><td>&nbsp;</td><td>\n";
      CheckBox($a, "termstype", $this->termstype, "Type Terms");
      echo "</td></tr>\n";
      echo "<tr><td>&nbsp;</td><td>\n";
      CheckBox($a, "duemonthend", $this->duemonthend, "Due Month End");
      echo "</td></tr>\n";
      
      echo "<tr><td colspan=\"2\" align=\"right\">";
      $d=new Discount($this->discountid, false);
      $d->Table($a, $id, "General Discount", $bOffset, true);
   	echo"</td></tr>\n";
      */
      echo "<tr><td colspan=\"2\" align=\"right\">";
      $l=new Loyalty($this->loyalityid);
      $p=$l->Getpointsid();
      if($p){
         $pl=new PointsLog($p);
         $pl->Table($a, $p, "Accumulated Points",  $bOffset, true);
      }
   	echo"</td></tr>\n";
      
   	echo "</table>\n";
   }
}

?>
