<?php
/*
memo.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001 - 2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
require_once("createmod.php");

class Memo
{
   var $id;
   var $memoid;
   var $cmid;
   var $subject;
	var $data;
   
   function Memo($id=false)
   {
      if($id){
         if($this->Fill($id, false)){
            return true;
         }
      }
      $this->id=0;
      $this->memoid=0;
      $this->cmid=0;
      $this->subject='';
	   $this->data='';
   }
   
   function Getid() { return $this->id; }
   
   function Fill($id, $bOffset=true)
   {
      if($id==0){
         return false;
      }
      if($bOffset){
         $qry=sprintf(memo_qry2, $id);
      }
      else{
         $qry=sprintf(memo_qry3, $id);
      }
      
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         $this->id=$id;
         $this->memoid=$row["memoid"];
         $this->cmid=$row["cmid"];
         $this->subject=$row["subject"];
	      $this->data=$row["data"];
         
         return true;
      }
      return false;
   }
   
   function Set($a,$b,$c,$d)
   {
      $this->memoid=$a;
      $this->cmid=$b;
      $this->subject=$c;
	   $this->data=$d;
   }
   
   function setfromform($frm)
   {
      $this->memoid=$frm['memoid'];
      $this->cmid=$frm['cmid'];
      $this->subject=$frm['subject'];
	   $this->data=$frm['data'];
   }
   
   function Add()
   {
      $c=new CreateMod();
      $this->cmid=$c->Commit();
      $qry=sprintf(memo_qry4, $this->memoid,$this->cmid,$this->subject,$this->data);
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
      $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
      if($row = $result->FetchRow()){
         $this->id=$row[0];
      }
      return $this->id;
   }
   
   function AddWithRef($refid)
   {
      $c=new CreateMod();
      $this->cmid=$c->Commit();
      
      $qry=sprintf(memo_qry4, $this->refid,$this->cmid,$this->subject,$this->data);
     
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
      $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
      if($row = $result->FetchRow()){
         $this->id=$row[0];
      }
      if(isset($refid) && refid!=0){
         $this->memoid=$refid;
      }
      else{
         $qry=sprintf(memo_qry7, $this->id, $this->id);
      }
      return $this->id;
   }
   
   function Commit($id)
   {
      $c=new CreateMod();
      $cmid=$c->Fill($this->cmid);
      $c->Commit();
      $qry=sprintf(memo_qry4, $this->memoid,$this->cmid,$this->subject,$this->data, $id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete()
   {
      $qry=sprintf(memo_qry6, $this->id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Table($a, $id)
   {
      if($a=="commit" || $a=="add"){
         $this->Fill($id, false);
      }
      else{
         $this->Fill($id, true);
      }

	   echo "<tr><td class=\"tinsert\" colspan=\"2\">\n";
      $cm=new CreateMod();
      $cm->Fill($this->cmid);
      $cm->FillTable();
      echo "</td></tr>\n";
	
   	echo "<tr>\n";
      echo "<td class=\"formlabel\">"._("Subject")."</td>\n";
      echo "<td>";
	   textarea($a, "data", 64, 255, $this->data);
   	echo"</td>\n";
	   echo "</tr>\n";
   }
   
   function FillList($a, $id)
   {
      $qry=sprintf(contact_memo_qry4, $id);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$result) return false;
      echo "<fieldset>\n<legend>"._("Notes")."</legend>\n<table class=\"listtable\">\n";
      if($result->RecordCount()==0){
         if($a=="commit" || $a=="add"){
            echo "<tr><td colspan=\"3\" align=\"left\">". _("There are no memos")."</td></tr></table>\n</fieldset>\n";
            //echo "<tr><td class=\"inlistdata\">". _("There are no memos")."</td>\n";
            //echo "<td></tr></table>\n<fieldset>\n";            
            //echo "<input type=\"submit\" name=\"memoadd\" value=\"add\">"._("Add Memo")."</td></tr></table>\n";
            return;
         }
         else{
            echo "<tr><td colspan=\"3\" align=\"left\">". _("There are no memos")."</td></tr></table>\n</fieldset>\n";
            return;
         }
         return;
      }
      
      echo "<tr>\n<td class=\"listtitle\">"._("Date")."</td>\n";
      echo "<td class=\"listtitle\">"._("By")."</td>\n";
      echo "<td class=\"listtitle\">"._("Subject")."</td>\n</tr>\n";

      $cm=new CreateMod();
      
      while($row = $result->FetchRow()){
         $cm=new CreateMod($row['cmid']);
         echo "<tr><td class=\"listdata\">\n";
         $cm->FillCreatedWhen();
         echo "</td>\n<td class=\"listdata\">";
         $cm->FillCreatedBy();
         echo "<td class=\"listdata\">".$row["subject"]."</td>\n";
              
         if($a=="commit" || $a=="add"){
         }
         else{
         }
         echo "</tr>\n";
      }
      if($a=="commit" || $a=="add"){
         // add a blank for addition
      }
      echo "</table>\n";
   }
}

?>
