<?php
/*
 * promotion.php
 *
 * Part of:
 * BhPos, Copyright (C) 2001-2005 Al Kingsley
 * BhPos comes with ABSOLUTELY NO WARRANTY.
 *
 */
 
define(BHPROMOTION_TYPE_PRODUCT, 1);
define(BHPROMOTION_TYPE_FREE, 2);
define(BHPROMOTION_TYPE_DISCOUNT, 3);
define(BHPROMOTION_TYPE_MARGIN, 4);
define(BHPROMOTION_TYPE_CATALOGUE, 5);
define(BHPROMOTION_TYPE_COLLECTION, 6);

class Promotion
{
   var $id;
   var $promotionid;
   var $typeid;
   var $name;
   var $startdate;
   var $enddate;
   var $targetid;
   var $promolinkid; 
  
   function Promotion($id=false, $bOffset=false)
   {
      if(isset($id)){
         if(isset($bOffset)){
            $this->Fill($id, $bOffset);
         }
         else{
            $this->Fill($id, false);
         }
      }
      else{
         $this->id=0;
         $this->discountid=0;
         $this->type=0;
         $this->ident="";
         $this->targetid=0;
         $this->margin=0.0;
         $this->status=0;
      }
   }
   
   function Fill($id, $bOffset=false)
   {
      if($bOffset){
         $qry=sprintf(supplierm_discount_qry2, $id);
      }
      else{
         $qry=sprintf(supplierm_discount_qry3, $id);
      }
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	   if($row = $result->FetchRow()){
         $this->id=$id;
         $this->discountid=$row['discountid'];
         $this->type=$row['type'];
         $this->ident=$row['ident'];
         $this->targetid=$row['targetid'];
         $this->margin=$row['margin'];
         $this->status=$row['status'];
         return false;
      }
      return true;
   }
   
   function Add()
   {
      $qry=sprintf(supplierm_discount_qry4,$this->type, $this->ident, $this->targetid, $this->margin, $this->status);
      
      $_SESSION['VxCFG']->dbh->Execute($qry);
       
      $_SESSION['VxCFG']->dbh->Execute(misc_qry1);
      if($row = $result->FetchRow()){
         $this->id=$row[0];
      }
      return $this->id;
   }
   
   function Commit($id)
   {
      $qry=sprintf(supplierm_discount_qry5,$this->type, $this->ident, $this->targetid, $this->margin, $this->status, $this-id);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Delete($id=false)
   {
      if(isset($id)){
         $qry=sprintf(supplierm_discount_qry6, $id);
      }
      else{
         $qry=sprintf(supplierm_discount_qry6, $this->id);
      }
	   $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   function Combo($a, $cname, $id)
   {
      if($a=="commit" || $a=="add"){
	      echo "<select name=\"$cname\">\n";
   	   echo "<option value='0'>Not Set</option>\n";

   	   $result=$_SESSION['VxCFG']->dbh->Execute(supplierm_discount_qry7);
      	while($row = $result->FetchRow()){
	      	$boo=$row["id"];
		      $poo=$row["name"];
		
      		if($id==$boo){
	      		echo "<option selected value=\"$boo\"> $poo </option>\n";
		      }
   		   else{
	   		   echo "<option value=\"$boo\"> $poo </option>\n";
		      }
   	   }
	      echo "</select>\n";
      }
      else{
         $qry=sprintf(supplierm_discount_qry3, $id);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      	if($row = $result->FetchRow()){
		      $poo=$row["name"];
            echo $poo;
         }
         else echo "Not Set";
      }
   }
   
   function TypeCombo($a, $id, $bFilter=false)
   {
      if($a=="commit" || $a=="add"){
         if($bFilter){
	         echo "<select name=\"typeid\" onChange=\"this.form.submit();\">\n";
         }
         else{
            echo "<select name=\"typeid\">\n";
         }

         if($id==0){
            echo "<option value='0' selected>"._("Not Set")."</option>\n";
         }
         else{
   	      echo "<option value='0'>"._("Not Set")."</option>\n";
         }

   	   if($id==BHPROMOTION_TYPE_PRODUCT){
	      	echo "<option selected value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
		   }
   		else if($id==BHPROMOTION_TYPE_FREE){
	   	   echo "<option value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
            echo "<option selected value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
   	   }
         else if($id==BHPROMOTION_TYPE_DISCOUNT){
            echo "<option value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
            echo "<option selected value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
         }
         else if($id==BHPROMOTION_TYPE_MARGIN){
            echo "<option value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
            echo "<option selected value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
         }
         else if($id==BHPROMOTION_TYPE_CATALOGUE){
            echo "<option value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
            echo "<option selected value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
         }
         else if($id==BHPROMOTION_TYPE_COLLECTION){
            echo "<option value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
            echo "<option selected value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
         }
         else if($id==0){
            echo "<option value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
            echo "<option value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
         }
	      echo "</select>\n";
      }
      else{
         if($id==BHPROMOTION_TYPE_PRODUCT){
	      	echo _("Product");
		   }
   		else if($id==BHPROMOTION_TYPE_FREE){
	   	   echo _("Free Item");
   	   }
         else if($id==BHPROMOTION_TYPE_DISCOUNT){
            echo _("Discount");
         }
         else if($id==BHPROMOTION_TYPE_MARGIN){
            echo _("Margin");
         }
         else if($id==BHPROMOTION_TYPE_CATALOGUE){
            echo _("Catalogue");
         }
         else if($id==BHPROMOTION_TYPE_COLLECTION){
            echo _("Collection");
         }
      }
   }
   
   function Table($a, $id, $title, $bOffset=true, $bInside=false)
   {
      //if($bInside){
      //   echo "<table width=\"100%\" border=\"1\" cellspacing=\"2\" cellpadding=\"2\">\n";
      //   echo "<tr align=\"center\"><td colspan=\"2\"><h2>$title</h2></td></tr>\n";
      //}
      echo"<fieldset>\n<legend>"._("Discount")."</legend><table>\n";
      echo "<tr><td class=\"formlabel\">"._("Type")."</td><td class=\"formdata\">\n";
      $this->typecombo($a, $this->type);
      echo "</td></tr><tr><td class=\"formlabel\">"._("Identity")."</td><td class=\"formdata\">\n";
      entry($a, "ident", 12, 8, $this->ident);
      echo "</td></tr><tr><td class=\"formlabel\">"._("Target")."</td><td class=\"formdata\">\n";
      entry($a, "targetid", 12, 8, $this->targetid);
      echo "</td></tr><tr><td class=\"formlabel\">"._("Margin")."</td><td class=\"formdata\">\n";
      entry($a, "margin", 12, 8, $this->margin);
      echo "</td></tr><tr><td class=\"formlabel\">"._("Status")."</td><td class=\"formdata\">\n";
      entry($a, "status", 64, 64, $this->status);
      echo "</td></tr>\n";
      echo "</table>\n</fieldset>\n";
   }
}   
   
?>
