<?php

/**********************************************************************
 * 
 * Accounts Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2005
 *
 **********************************************************************/

/*****************************************
 * account payable queries
 *****************************************/
define("account_payable_qry1", "select count(*) from purchaseorder where statusid = '13'"); 
define("account_payable_qry2", "select (to_days(now()) - (to_days(po.arriveddate) + ca.duedays)) as due, 
from_days((to_days(po.arriveddate) + ca.duedays)) as duedate, le.amount, po.id as poid, po.purchasenumber, 
po.arriveddate, le.id, s.name 
from chargeaccount as ca, purchaseorder as po, supplier as s,ledgerentry as le where po.supplierid=s.id and 
s.chargeid=ca.id and po.ledgerentryid=le.id order by '%s' %s ");
define("account_payable_qry3", "select * from ledgerentry limit 1 offset %d");
define("account_payable_qry4", "select * from ledgerentry where id = '%d'");
define("account_payable_qry5", "insert into ledgerentry values(0, %d','%d','%d','%s',%s','%s','%f','%s','%d')");
define("account_payable_qry6", "update ledgerentry set journalid='%d',ledgerid='%d',accountid='%d'entereddate='%s',
   description='%s',debit='%s',amount='%f',posted='%s',referenceid='%d' where id = '%d'");
define("account_payable_qry7", "delete from ledgerentry where id = '%d'");

/*****************************************
 * account receivable queries
 *****************************************/
define("account_recable_qry1", "select count(*) from orders where statusid = '13'"); // payable
define("account_recable_qry2", "select (to_days(now()) - (to_days(o.shippeddate) + ca.duedays)) as due,from_days((to_days(o.shippeddate) + ca.duedays)) 
as duedate, le.amount, o.ordernumber, o.shippeddate from chargeaccount as ca, orders as o, customer as c,
ledgerentry as le where o.customerid=c.id and c.chargeaccountid=ca.id and o.ledgerentryid=le.id");
define("account_recable_qry3", "select * from ledgerentry limit 1 offset %d");
define("account_recable_qry4", "select * from ledgerentry where id = '%d'"); 

/*****************************************
 * aged suppliers queries
 *****************************************/
define("account_agedsupp_qry2", "select (to_days(now()) - (to_days(po.arriveddate) + ca.duedays)) as due, 
from_days((to_days(po.arriveddate) + ca.duedays)) as duedate, le.amount, po.id as poid, po.purchasenumber, 
po.arriveddate, s.id, s.name from chargeaccount as ca, purchaseorder as po, supplier as s,ledgerentry as le where 
po.supplierid=s.id and s.chargeid=ca.id and po.ledgerentryid=le.id order by '%s' %s ");

/*****************************************
 * aged customers queries
 *****************************************/ 

 
?>
