<?php

/**********************************************************************
 * 
 * Accounts Maintenance Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/

/*****************************************
 * account queries
 *****************************************/
define("accountm_account_qry1", "select count(*) from account");
define("accountm_account_qry2", "select * from account limit 1 offset %d");
define("accountm_account_qry3", "select * from account where id = '%d'");
define("accountm_account_qry4", "select * from account");
define("accountm_account_qry5", "insert into account values(0,'%d','%d','%s','%s','%d')");
define("accountm_account_qry6", "update account set parentid='%d',headingid='%d',accountnumber='%s',name='%d',gref='%d',profitloss='%s' where id = '%d'");
define("accountm_account_qry7", "delete from account where id = '%d'");
define("accountm_account_qry8", "select type from accountheading where id = '%d'");
define("accountm_account_qry9", "select * from account where parentid = '0'");
define("accountm_account_qry10", "select p.id, c.* from account, p as account, c as account where c.parentid = p.id, and p.id='0'");
define("accountm_account_qry11", "select id,name from gaccref");
define("accountm_account_qry12", "select name from gaccref where id = '%d'");
define("accountm_account_qry13", "select * from account order by '%s' %s ");
define("accountm_account_qry14", "select name from accountheading where id='%d'");

/*****************************************
 * accorg queries
 *****************************************/
define("accountm_accorg_qry1", "select * from account where parentid='0'");
define("accountm_accorg_qry2", "select * from account where parentid='%d'");

/*****************************************
 * accountheading queries
 *****************************************/
define("accountm_acchead_qry1", "select count(*) from accountheading");
define("accountm_acchead_qry2", "select * from accountheading limit 1 offset %d");
define("accountm_acchead_qry3", "select * from accountheading where id = '%d'");
define("accountm_acchead_qry4", "insert into accountheading	values (0,'%d','%s','%d','%d','%d','%d','%d')");
define("accountm_acchead_qry5", "update accountheading set parentid='%d',name='%s',sref='%d',eref='%d',gref='%d',
   type='%d', guitypeid='%d' where id='%d'");
define("accountm_acchead_qry6", "delete from accountheading where id = '%d'");
define("accountm_acchead_qry7", "select * from accountheading");
define("accountm_acchead_qry8", "select * from accountheading order by '%s' %s ");
define("accountm_acchead_qry9", "select value from misgui where id='%d'");
define("accountm_acchead_qry10", "update misgui set value='%s' where id='%d'");

/*****************************************
 * accheadorg queries
 *****************************************/
define("accountm_accheadorg_qry1", "select * from accountheading where parentid='0'");
define("accountm_accheadorg_qry2", "select * from accountheading where parentid='%d'");

/*****************************************
 * gaccref queries
 *****************************************/
define("gacc_qry1", "select count(*) from gaccref");
define("gacc_qry2", "select * from gaccref limit 1 offset %d");
define("gacc_qry3", "select * from gaccref where id = '%d'");
define("gacc_qry4", "select * from gaccref");
define("gacc_qry5", "insert into gaccref values('','%s','%s')");
define("gacc_qry6", "update gaccref set accountnumber='%s', name='%s' where id = '%d'");
define("gacc_qry7", "delete from gaccref where id = '%d'");

/*****************************************
 * ledgerentry queries
 *****************************************/
define("erp_gl_qry1", "select * from ledgerentry");
define("erp_gl_qry2", "select * from ledgerentry limit 1 offset %d");
define("erp_gl_qry3", "select * from ledgerentry where id = '%d'");
define("erp_gl_qry4", "insert into ledgerentry values(0, %d','%d','%d','%s',%d','%d','%s','%s','%d')");
define("erp_gl_qry5", "update ledgerentry set ledgerid='%d',typeid='%d',transactionid='%d',entereddate='%s',
   periodid='%d',accountid='%d',description='%s',debit='%s',amount='%f',open='%s',committed='%s',referenceid='%d' 
   where id = '%d'");
define("erp_gl_qry6", "delete from ledgerentry where id = '%d'");

define("erp_gl_qry10", "select * from ledgerentry where accountid ='%d'");
define("erp_gl_qry11", "select * from ledgerentry where accountid ='%d' and open='N'");
define("erp_gl_qry12", "select * from ledgerentry where accountid ='%d' and open='Y'");
define("erp_gl_qry13", "select * from ledgerentry where accountid ='%d' and entereddate between '%s' and '%s'");
define("erp_gl_qry14", "select * from ledgerentry where accountid ='%d' and entereddate between '%s' and '%s' and open='N'");
define("erp_gl_qry15", "select * from ledgerentry where accountid ='%d' and entereddate between '%s' and '%s' and open='Y'");
define("erp_gl_qry16", "select * from ledgerentry where accountid ='%d' and enteredby='%s'");
define("erp_gl_qry17", "select * from ledgerentry where accountid ='%d' and open='N' and debit='N'");
define("erp_gl_qry18", "select * from ledgerentry where accountid ='%d' and open='N' and debit='Y'");
define("erp_gl_qry19", "select * from ledgerentry where accountid ='%d' and open='Y' and debit='N'");
define("erp_gl_qry20", "select * from ledgerentry where accountid ='%d' and open='Y' and debit='Y'");
define("erp_gl_qry21", "select * from ledgerentry where accountid ='%d' and open='N' and typeid='%d'");
define("erp_gl_qry22", "select * from ledgerentry where accountid ='%d' and open='Y' and typeid='%d");
define("erp_gl_qry23", "select * from ledgerentry where accountid ='%d' and entereddate between '%s' and '%s' and open='N' and debit='N'");
define("erp_gl_qry24", "select * from ledgerentry where accountid ='%d' and entereddate between '%s' and '%s' and open='N' and debit='N'");
define("erp_gl_qry25", "select * from ledgerentry where accountid ='%d' and entereddate between '%s' and '%s' and open='Y' and debit='N'");
define("erp_gl_qry26", "select * from ledgerentry where accountid ='%d' and entereddate between '%s' and '%s' and open='Y' and debit='Y'");
define("erp_gl_qry27", "select * from transaction where refnum ='%s'");
define("erp_gl_qry28", "select * from transaction where refnum ='%s' and reconciled='N'");
define("erp_gl_qry29", "select * from transaction where refnum ='%s' and reconciled='Y'");
define("erp_gl_qry30", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s'");
define("erp_gl_qry31", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and reconciled='N'");
define("erp_gl_qry32", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and reconciled='Y'");
define("erp_gl_qry33", "select * from transaction where refnum ='%s' and enteredby='%s'");
define("erp_gl_qry34", "select * from transaction where refnum ='%s' and reconciled='N' and enteredby='%d'");
define("erp_gl_qry35", "select * from transaction where refnum ='%s' and reconciled='Y' and enteredby='%d'");
define("erp_gl_qry36", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and enteredby='%d' and enteredby='%d'");
define("erp_gl_qry37", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and reconciled='N' and enteredby='%d'");
define("erp_gl_qry38", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and reconciled='Y' and enteredby='%d'");
define("erp_gl_qry39", "select * from transaction where refnum ='%s' and enteredstation='%s'");
define("erp_gl_qry40", "select * from transaction where refnum ='%s' and reconciled='N' and enteredstation='%s'");
define("erp_gl_qry41", "select * from transaction where refnum ='%s' and reconciled='Y' and enteredstation='%s'");
define("erp_gl_qry42", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and enteredby='%d' and enteredstation='%s'");
define("erp_gl_qry43", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and reconciled='N' and enteredstation='%s'");
define("erp_gl_qry44", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and reconciled='Y' and enteredstation='%s'");
define("erp_gl_qry45", "select * from account where accountnumber ='%s'");
define("erp_gl_qry46", "select * from transaction where account.parentid='%d' and account.accountnumber=transaction.refnum");
define("erp_gl_qry47", "select * from transaction where account.title='%d' and account.accountnumber=transaction.refnum");
define("erp_gl_qry48", "select sum(amount) from paymentitem where transid='%d'");

/*****************************************
 * ledger queries
 *****************************************/
define("erp_ledger_qry1", "select * from ledger");
define("erp_ledger_qry2", "select * from ledger limit 1 offset %d");
define("erp_ledger_qry3", "select * from ledger where id = '%d'");
define("erp_ledger_qry4", "insert into ledger values(0, %s','%s')");
define("erp_ledger_qry5", "update ledger set name='%s',description='%s' where id = '%d'");
define("erp_ledger_qry6", "delete from ledger where id = '%d'");

/*****************************************
 * ledger type queries
 *****************************************/
define("erp_ledgertype_qry1", "select * from ledgertype");
define("erp_ledgertype_qry2", "select * from ledgertype limit 1 offset %d");
define("erp_ledgertype_qry3", "select * from ledgertype where id = '%d'");
define("erp_ledgertype_qry4", "insert into ledgertype values(0, '%s')");
define("erp_ledgertype_qry5", "update ledgertype set name='%s' where id = '%d'");
define("erp_ledgertype_qry6", "delete from ledgertype where id = '%d'");

/*****************************************
 * ledger report queries
 *****************************************/


/*****************************************
 * financial period queries
 *****************************************/
define("erp_period_qry1", "select * from period");
define("erp_period_qry2", "select * from period limit 1 offset %d");
define("erp_period_qry3", "select * from period where id = '%d'");
define("erp_period_qry4", "insert into period values(0, '%s','%s','%s')");
define("erp_period_qry5", "update period set start='%s',end='%s',description='%s' where id = '%d'");
define("erp_period_qry6", "delete from period where id = '%d'");

/*****************************************
 * payable queries
 *****************************************/
define("erp_payable_qry1", "select * from ledgerentry where 1");  // need an account type to ref a ref with ref (buggernaut)
define("erp_payable_qry2", "select * from period limit 1 offset %d");
define("erp_payable_qry3", "select * from period where id = '%d'");
define("erp_payable_qry4", "insert into period values(0, '%s','%s','%s')");
define("erp_payable_qry5", "update period set start='%s',end='%s',description='%s' where id = '%d'");
define("erp_payable_qry6", "delete from period where id = '%d'");

/*****************************************
 * recable queries
 *****************************************/
define("erp_recable_qry1", "select * from period");
define("erp_recable_qry2", "select * from period limit 1 offset %d");
define("erp_recable_qry3", "select * from period where id = '%d'");
define("erp_recable_qry4", "insert into period values(0, '%s','%s','%s')");
define("erp_recable_qry5", "update period set start='%s',end='%s',description='%s' where id = '%d'");
define("erp_recable_qry6", "delete from period where id = '%d'");

/*****************************************
 * misc financial queries
 *****************************************/
define("erp_glmisc_qry4", "select * from transaction where refnum ='%s'");
define("erp_glmisc_qry5", "select * from transaction where refnum ='%s' and reconciled='N'");
define("erp_glmisc_qry6", "select * from transaction where refnum ='%s' and reconciled='Y'");
define("erp_glmisc_qry7", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s'");
define("erp_glmisc_qry8", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and reconciled='N'");
define("erp_glmisc_qry9", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and reconciled='Y'");
define("erp_glmisc_qry10", "select * from transaction where refnum ='%s' and enteredby='%s'");
define("erp_glmisc_qry11", "select * from transaction where refnum ='%s' and reconciled='N' and enteredby='%d'");
define("erp_glmisc_qry12", "select * from transaction where refnum ='%s' and reconciled='Y' and enteredby='%d'");
define("erp_glmisc_qry13", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and enteredby='%d' and enteredby='%d'");
define("erp_glmisc_qry14", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and reconciled='N' and enteredby='%d'");
define("erp_glmisc_qry15", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and reconciled='Y' and enteredby='%d'");
define("erp_glmisc_qry16", "select * from transaction where refnum ='%s' and enteredstation='%s'");
define("erp_glmisc_qry17", "select * from transaction where refnum ='%s' and reconciled='N' and enteredstation='%s'");
define("erp_glmisc_qry18", "select * from transaction where refnum ='%s' and reconciled='Y' and enteredstation='%s'");
define("erp_glmisc_qry19", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and enteredby='%d' and enteredstation='%s'");
define("erp_glmisc_qry20", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and reconciled='N' and enteredstation='%s'");
define("erp_glmisc_qry21", "select * from transaction where refnum ='%s' and enteredat between '%s' and '%s' and reconciled='Y' and enteredstation='%s'");
define("erp_glmisc_qry22", "select * from account where accountnumber ='%s'");
define("erp_glmisc_qry24", "select * from transaction where account.parentid='%d' and account.accountnumber=transaction.refnum");
define("erp_glmisc_qry25", "select * from transaction where account.title='%d' and account.accountnumber=transaction.refnum");
define("erp_glmisc_qry26", "select sum(amount) from paymentitem where transid='%d'");

 /****************************************
 * tax queries
 *****************************************/
define("accountm_tax_qry1", "select count(*) from taxrate");
define("accountm_tax_qry2", "select * from taxrate limit 1 offset %d");
define("accountm_tax_qry3", "select * from taxrate where id = '%d'");
define("accountm_tax_qry4", "select * from account where accountnumber='%d'");
define("accountm_tax_qry5", "insert into taxrate (accountid, rate, onmenu) values('%d','%f','%s')");
define("accountm_tax_qry6", "update taxrate set accountid='%d', rate='%f', onmenu='%s' where id='%d'");
define("accountm_tax_qry7", "delete from taxrate where id = '%d'");
//define("accountm_tax_qry7", "select * from taxrate");
define("accountm_tax_qry8", "select * from taxrate order by '%s' %s ");
define("accountm_tax_qry9", "select name from account where id = '%d'");

?>
