<?php
/**********************************************************************
 * 
 * e-commerce Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/

/****************************************
 * ecomm queries
 ****************************************/
#applicant
define("cart_applicant_qry1", "select count(*) from applicant where email='%s' || login='%s'");
define("cart_applicant_qry2", "insert into applicant values('',NOW(),'%d','%s','%s','%s','%s','%s','%s',
'%s',''%s','%s','%s','%s','%s','%d','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%d','%d','%d','%d',
'%s','%s')");


# total num ecommerce prods
define("cart_product_qry1", "select count(*) from product where ecommerce='Y'");
# total num ecommerce prods in a given category
define("cart_product_qry2", "select count(*) from productcategory where categoryid='%d' and 
   (select id from product where ecommerce='Y')"); 
# quick product summary
define("cart_product_qry3", "select p.*, x.*, y.* from product as p, prodpricequantity as x, pqname as y, productcategory as z
   where x.pqid=p.sellquantityid and (z.categoryid='%d' and (p.id=z.productid and p.ecommerce='Y'))"); 

/****************************************
 * stats queries
 ****************************************/
define("cart_stats_qry1","select count(*) from ecartlog where actionid='%d' and stamper > '%s'");
define("cart_stats_qry2","select count(*) from ecartlog where actionid='%d' and stamper between '%s' and '%s'");
define("cart_stats_qry3","select date(now())");
define("cart_stats_qry4","select month(now())");
define("cart_stats_qry5","select year(now())");
define("cart_stats_qry6","select categoryid, category.name, sum(quantity*unitprice) as amt, sum(quantity)as qty from product, 
   orderitems, orders, category where orderitems.orderid=orders.id and billeddate between '%s' and '%s' and 
   orderitems.productid=product.id and product.categoryid=category.id group by category.name order by category.id desc limit 4");
//define("order_stats_qry14","select count(*) as c, sum(total) as t from orders where month(shippeddate)='%s' and statusid='13'");


/****************************************
 * featured items queries
 ****************************************/
define("cart_featureditems_qry1", "select count(*) from efeatureditem");
define("cart_featureditems_qry2", "select * from efeatureditem limit 1 offset %d");
define("cart_featureditems_qry3", "select * from efeatureditem where id = '%d'");
define("cart_featureditems_qry4", "insert into efeatureditem values('', '%d','%s','%s','%s')");
define("cart_featureditems_qry5", "update efeatureditem set productid='%d', tagline='%d', start='%s',end='%s' where id = '%d'");
define("cart_featureditems_qry6", "delete from efeatureditem where id = '%d'");
define("cart_featureditems_qry7", "select * from efeatureditem order by '%s' %s ");
define("cart_featureditems_qry8", "select name from product where id = '%d'");

/****************************************
 * promo queries
 ****************************************/
define("cart_promo_qry1", "select count(*) from epromotion");
define("cart_promo_qry2", "select * from epromotion limit 1 offset %d");
define("cart_promo_qry3", "select * from epromotion where id = '%d'");
define("cart_promo_qry4", "insert into epromotion values('', '%d','%d','%s','%s')");
define("cart_promo_qry5", "update epromotion set productid='%d', promotionid='%d', headline='%s',body='%s' where id = '%d'");
define("cart_promo_qry6", "delete from epromotion where id = '%d'");
define("cart_promo_qry7", "select * from epromotion order by '%s' %s ");
define("cart_promo_qry8", "select name from product where id = '%d'");
define("cart_promo_qry9", "select startdate, enddate,margin from promotion where id='%d'");

/****************************************
 * ratings queries
 ****************************************/
define("cart_ratings_qry1", "select count(*) from erating");
define("cart_ratings_qry2", "select * from erating limit 1 offset %d");
define("cart_ratings_qry3", "select * from erating where id = '%d'");
define("cart_ratings_qry4", "insert into erating values('', '%d','%d','%d')");
define("cart_ratings_qry5", "update erating set productid='%d', customerid='%d', rating='%d' where id = '%d'");
define("cart_ratings_qry6", "delete from erating where id = '%d'");
define("cart_ratings_qry7", "select distinct(productid),id,rating from erating group by productid order by '%s' %s ");
define("cart_ratings_qry8", "select name from product where id = '%d'");
define("cart_ratings_qry9", "select count(*) as counts, avg(rating) as avgrating from erating where productid = '%d'");

/****************************************
 * review queries
 ****************************************/
define("cart_review_qry1", "select count(*) from ereview");
define("cart_review_qry2", "select * from ereview limit 1 offset %d");
define("cart_review_qry3", "select * from ereview where id = '%d'");
define("cart_review_qry4", "insert into ereview values('', '%d','%s','%s','%s','%s','%s','%s')");
define("cart_review_qry5", "update ereview set productid='%d',postedby='%s',postedtype='%s',when='%s',numreads='%d',
   approved='%s',review='%s' where id = '%d'");
define("cart_review_qry6", "delete from ereview where id = '%d'");
define("cart_review_qry7", "select * from ereview order by '%s' %s ");
define("cart_review_qry8","select contactid from customer where id = '%d'");
define("cart_review_qry9","select titleid,firstname,lastname,addressid from contacts where id = '%d'");

/****************************************
 * efaq queries
 ****************************************/
define("cart_efaq_qry1", "select count(*) from eproductfaq");
define("cart_efaq_qry2", "select * from  eproductfaq limit 1 offset %d");
define("cart_efaq_qry3", "select * from  eproductfaq where id = '%d'");
define("cart_efaq_qry4", "insert into  eproductfaq values('', '%d','%s','%s','%s','%s','%s')");
define("cart_efaq_qry5", "update eproductfaq set targetid='%d',targettype='%s',when='%s',postedby='%s',postedtype='%s',
   subject='%s',content='%s' where id = '%d'");
define("cart_efaq_qry6", "delete from  eproductfaq where id = '%d'");
define("cart_efaq_qry7", "select * from  eproductfaq order by '%s' %s ");

/****************************************
 * prefs queries
 ****************************************/
define("cart_pref_qry1", "select count(*) from misuser");
define("cart_pref_qry2", "select * from ecartattribute where attributeid='0'");
define("cart_pref_qry3", "update ecartattribute set value='%s' where name='%s' and attributeid='0'");
define("cart_pref_qry4", "update customerattribute set value='%s' where name='%s'");
define("cart_pref_qry5", "select * from customerattribute where attributeid='0'");


/****************************************
 * collection queries
 ****************************************/
define("cart_collection_qry1", "select count(*) from collection");
define("cart_collection_qry2", "select * from collection limit 1 offset %d");
define("cart_collection_qry3", "select * from collection where id = '%d'");
define("cart_collection_qry4", "insert into collection values('', '%s','%s','%d')");
define("cart_collection_qry5", "update collection set name='%s', description='%d', collectionid='%d' where id = '%d'");
define("cart_collection_qry6", "delete from collection where id = '%d'");
define("cart_collection_qry7", "select * from collection");
define("cart_collection_qry8", "select id from product where plu = '%s'");
define("cart_collection_qry9", "insert into productcollection values ('%d','%d')");
define("cart_collection_qry10", "delete from productcollection where prodcollid = '%d' and productid='%d'");
define("cart_collection_qry11", "select * from productcollection where prodcollid='%d'");
define("cart_collection_qry12", "select name, plu, sellquantityid from product where id = '%d'");
define("cart_collection_qry13", "select price from prodpricequantity where pqid = '%d' and nameid='1'");

/****************************************
 * discount queries
 ****************************************/
define("cart_discount_qry1", "select count(*) from discount");
define("cart_discount_qry2", "select * from discount limit 1 offset %d");
define("cart_discount_qry3", "select * from discount where id = '%d'");
define("cart_discount_qry4", "insert into discount values(0,'%d','%s','%d','%d','%f','%s'");
define("cart_discount_qry5", "update discount set discountid='%d',type='%d',ident='%d',targetid='%d',
   margin='%f',status='%s' where id='%d'");
define("cart_discount_qry6", "delete from discount where id='%d'");
define("cart_discount_qry7", "select * from discount");
define("cart_discount_qry8", "select count(*) from product where discountid = '%d'");


/****************************************
 * margin queries
 ****************************************/
define("cart_margin_qry1", "select count(*) from margin");
define("cart_margin_qry2", "select * from margin limit 1 offset %d");
define("cart_margin_qry3", "select * from margin where id = '%d'");
define("cart_margin_qry4", "insert into margin values('','%d','%s','%f','%d')");
define("cart_margin_qry5", "update margin set marginid='%d',name='%s',margin='%f',productcollid='%d'where id = '%d'");
define("cart_margin_qry6", "delete from margin where id = '%d'");
define("cart_margin_qry7", "select * from margin");


/****************************************
 * return queries
 ****************************************/
define("cart_return_qry1", "select count(*) from return");
define("cart_return_qry2", "select * from return limit 1 offset %d");
define("cart_return_qry3", "select * from return where id = '%d'");
define("cart_return_qry4", "insert into return values('','%d','%d','%s','%s','%f','%s','%d')");
define("cart_return_qry5", "update return set type='%d',startdate='%s',enddate='%s',margin='%f',memo='%s',
   promolinkid='%d' where id = '%d'");
define("cart_return_qry6", "delete from return where id = '%d'");
define("cart_return_qry7", "select * from return");

/****************************************
 * promotion queries
 ****************************************/
define("cart_promotion_qry1", "select count(*) from promotion");
define("cart_promotion_qry2", "select * from promotion limit 1 offset %d");
define("cart_promotion_qry3", "select * from promotion where id = '%d'");
define("cart_promotion_qry4", "select * from promotion");

/****************************************
 * returntype queries
 ****************************************/
define("cart_returntype_qry1", "select count(*) from returntype");
define("cart_returntype_qry2", "select * from returntype limit 1 offset %d");
define("cart_returntype_qry3", "select * from returntype where id = '%d'");
define("cart_returntype_qry4", "insert into returntype values('','%s','%s')");
define("cart_returntype_qry5", "update returntype set name='%s', active='%s' where id = '%d'");
define("cart_returntype_qry6", "delete from returntype where id = '%d'");
define("cart_returntype_qry7", "select * from returntype");
define("cart_returntype_qry8", "select id, name from returntype where active='y'");
define("cart_returntype_qry9", "select name from returntype where id='%d'");

?>
