<?php

/**********************************************************************
 * 
 * Company Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/

/*****************************************
 * setup queries
 *****************************************
define("company_setup_qry1", "select * from setup");
define("company_setup_qry2", "update setup set name='%s',accountingdate='%s',regnumber='%s',vatnumber='%s',
 cmid='%d',siteid='%d',ismaster='%s',master='%s',connectmethod='%d',connectdata='%s',connectlogin='%s',
 connectpassword='%s',connecttime='%s' where id='0'");
define("company_setup_qry3", "update createmod set modifieddate='%s', modifiedby='%d' where id='%d'");
define("company_setup_qry4", "select name from setup");
*/

/*****************************************
 * company queries
 *****************************************/
define("company_company_qry1", "select count(*) from company");
define("company_company_qry2", "select * from company limit 1 offset %d");
define("company_company_qry3", "select * from company where id = '%d'");
define("company_company_qry4", "insert into company values (0,'%d','%s','%s')");
define("company_company_qry5", "update company set attributeid='%d',tradingname='%s',companyname='%s' where id='%d'");
define("company_company_qry6", "delete from company where id = '%d'");
define("company_company_qry7", "update sites set companyid = '%d' where siteid = '%d'");
define("company_company_qry8", "update sites set companyid = '0' where siteid = '%d'");
define("company_company_qry9", "select * from company order by '%s' %s ");
define("company_company_qry10", "select * from businessunit where companyid='%d'");
define("company_company_qry11", "select * from company");
define("company_company_qry12", "select * from companyattribute where attributeid='%d'");
define("company_company_qry13", "update companyattribute set value='%s' where name='%s' and attributeid='%d'");
define("company_company_qry14", "insert into companyattribute values()");
define("company_company_qry15", "update companyattribute set attributeid = '%d' where id = '%d'");
define("company_company_qry16", "insert into companyattribute values(0, '%d','%s','%d','','','%s')");
define("company_company_qry17", "update company set attributeid='%d' where id='%d'");
define("company_company_qry18", "update companyattribute set name='%s',type='%d',value='%s' where id='%d'");
define("company_company_qry19", "select * from sites where businessunitid='%d'");

/*****************************************
 * business unit queries
 *****************************************/
define("company_bu_qry1", "select count(*) from businessunit");
define("company_bu_qry2", "select * from businessunit limit 1 offset %d");
define("company_bu_qry3", "select * from businessunit where id = '%d'");
define("company_bu_qry4", "insert into businessunit values (0,'%d','%d','%s')");
define("company_bu_qry5", "update businessunit set companyid='%d',attributeid='%d',name='%s' where id='%d'");
define("company_bu_qry6", "delete from businessunit where id = '%d'");
define("company_bu_qry7", "update sites set businessunitid = '%d' where siteid = '%d'");
define("company_bu_qry8", "update sites set businessunitid = '0' where siteid = '%d'");
define("company_bu_qry9", "select * from businessunit order by '%s' %s ");
define("company_bu_qry10", "select * from sites where businessunitid='%d'");
define("company_bu_qry11", "select * from businessunit");
define("company_bu_qry12", "select * from businessunitattribute where attributeid='%d'");
define("company_bu_qry13", "update businessunitattribute set value='%s' where name='%s' and attributeid='%d'");
define("company_bu_qry14", "insert into businessunitattribute values()");
define("company_bu_qry15", "update businessunitattribute set attributeid = '%d' where id = '%d'");
define("company_bu_qry16", "insert into businessunitattribute values(0, '%d','%s','%d','','','%s')");
define("company_bu_qry17", "update businessunit set attributeid='%d' where id='%d'");
define("company_bu_qry18", "update businessunitattribute set name='%s',type='%d',value='%s' where id='%d'");
define("company_bu_qry19", "select id,name from businessunit where companyid='%d'");
define("company_bu_qry20", "select id,companyname from company");
define("company_bu_qry21", "select companyname from company where id = '%d'");

/*****************************************
 * site queries
 *****************************************/
define("company_site_qry1", "select count(*) from sites");
define("company_site_qry2", "select * from sites limit 1 offset %d");
define("company_site_qry3", "select * from sites where id = '%d'");
define("company_site_qry4", "insert into sites values (0,0,'%s','%d','%d','%d','%d','%d','%d','%f','%s','%s','%s','%s','%s')");
define("company_site_qry5", "update sites set name='%s',businessunitid='%d',addressid='%d',contactid='%d',localeid='%d',currencyid='%d',
		annualbudget='%f',site='%s',encryption='%s',login='%s',password='%s',active='%c',bankid='%d' where id='%d'");
define("company_site_qry6", "delete from sites where id = '%d'");
define("company_site_qry7", "select id, name from sites");
define("company_site_qry8", "update departments set siteid = '%d' where siteid = '%d'");
define("company_site_qry9", "update departments set siteid = '0' where siteid = '%d'");
define("company_site_qry10", "select id, name from departments where siteid = '%d'");
define("company_site_qry11", "select id, fname, lname from employee where id = '%d' order by lname");
define("company_site_qry12", "select name from sites where id = '%d'");
define("company_site_qry13", "select id, businessunitid, name from sites order by '%s' %s ");
define("company_site_qry14", "select id,name from businessunit");
define("company_site_qry15", "select name from businessunit where id = '%d'");
define("company_site_qry16", "select * from sites where businessunitid='%d'");

/*****************************************
 * department queries
 *****************************************/
define("company_dept_qry1", "select count(*) from departments");
define("company_dept_qry2", "select * from departments limit 1 offset %d");
define("company_dept_qry3", "select * from departments where id = '%d'");
define("company_dept_qry4", "select * from departments");
define("company_dept_qry5", "select * from departments where siteid='%d'");
define("company_dept_qry6", "select id, fname, lname from employee where lname like '%s' order by lname");
define("company_dept_qry7", "select groupid, name from groups where deptid = '%d'");
define("company_dept_qry8", "insert into departments values(0,'0','%s','%d','%f','%d','%d','%d','%s')");
define("company_dept_qry9", "update departments set deptid='%d', name='%s', siteid='%d', annualbudget='%f', 
   headid='%d', localeid='%d', currencyid='%d', active='%s' where id = '%d'");
define("company_dept_qry10", "select id from groups where deptid = '%d'");
define("company_dept_qry11", "select name FROM departments WHERE id = '%d'");
define("company_dept_qry12", "update groups set deptid = '%d' where deptid = '%d'");
define("company_dept_qry13", "update groups set deptid = '0' where deptid = '%d'");	
define("company_dept_qry14", "delete from departments where id = '%'");
define("company_dept_qry15", "select * from departments order by '%s' %s ");

/*****************************************
 * group queries
 *****************************************/
define("company_group_qry1", "select count(*) from groups");
define("company_group_qry2", "select * from groups limit 1 offset %d");
define("company_group_qry3", "select * from groups where id = '%d'");
define("company_group_qry5", "select * from groups where deptid='%d'");
define("company_group_qry6", "select * from groups where deptid='%d'");
define("company_group_qry7", "select count(*) from posts where groupid='%d'");
define("company_group_qry8", "select count(*) from employee where groupid='%d'");
define("company_group_qry9", "select id, name from posts where groupid='%d'");
define("company_group_qry10", "select id, fname, lname from employee where groupid='%d'");
define("company_group_qry11", "update posts set groupid = '%d' where groupid='%d'");
define("company_group_qry12", "update employee set groupid = '%d' where groupid='%d'");
define("company_group_qry13", "delete from groups where id='%d'");
define("company_group_qry14", "insert into groups values(0,'%d','%s','%d','%d','%s')"); 
define("company_group_qry15", "update groups set deptid='%d',name='%s',localeid='%d',currencyid='%d',active='%d'where id='%d'");
define("company_group_qry16", "select name from groups where id = '%d'");
define("company_group_qry17", "select * from groups");
define("company_group_qry18", "select * from groups order by '%s' %s");

?>
