<?php
/**********************************************************************
 * 
 * Contact Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/
 
/****************************************
 * address queries
 ****************************************/
define("address_qry1", "select count(*) from address");
define("address_qry2", "select * from address limit 1 offset %d");
define("address_qry3", "select * from address where id = '%d'");
define("address_qry4", "insert into address values (0,'%d','%d','%s','%s','%s','%s','%s','%s','%d')");
define("address_qry5", "update address set addressid='%d', typeid='%d',address1='%s', address2 = '%s', address3 = '%s', 
		city = '%s', state = '%s', postcode = '%s', countryid = '%d' where id = '%d'");
define("address_qry6", "delete from address where id = '%d'");
define("address_qry7", "select * from address");
define("address_qry8", "select id from employee where addressid = '%d'");
define("address_qry9", "select id from supplier where addressid = '%d'");
define("address_qry10", "select id from sites where addressid = '%d'");
define("address_qry11", "select id from customer where addressid = '%d'");
define("address_qry12", "select id from bankdetails where addressid = '%d'");
define("address_qry13", "select id, lname, fname from employee where addressid = '%d'");
define("address_qry14", "select id, name from supplier where addressid = '%d'");
define("address_qry15", "select id, name from customer where addressid = '%d'");	
define("address_qry16", "select id, name from sites where addressid = '%d'");	
define("address_qry17", "select id, name from bankdetails where addressid = '%d'");
define("address_qry18", "select name from country");
define("address_qry19", "select * from addresstype");
define("address_qry20", "select * from addresstype where id = '%d'");
define("address_qry21", "select type, address1, city, postcode from addressid where addressid = '%d'");
define("address_qry22", "select * from address where addressid = '%d'");
define("address_qry23", "update address set addressid='%d' where id='%d'");

/****************************************
 * contact queries
 ****************************************/
define("contact_contact_qry1", "select count(*) from contacts where ownerid='%d' OR private='A'");
define("contact_contact_qry2", "select * from contacts where ownerid='%d' OR private='A' limit 1 offset %d");
define("contact_contact_qry3", "select * from contacts where id = '%d'");
define("contact_contact_qry4", "select * from contacts where ownerid='%d' OR private='A'");
define("contact_contact_qry5", "insert into contacts values (0, 0,'%d','0','%d','%d','%d','%d','%s','%s','%s','%s','%s','%s','%s')");
define("contact_contact_qry6", "update contacts set contactid='%d', attributeid='%d', contactdetailsid='%d',ownerid='%d',addressid='%d',
imageid='%d',titleid='%d',firstname='%s',lastname='%s',middleinitial='%s',birthdate='%s',lastcontact='%s',
timezone='%s',private='%s',memoid='%d' where id = '%d'");
define("contact_contact_qry7", "delete from contacts where id = '%d'");
define("contact_contact_qry8", "select * from contacts where contactid='%d'");
define("contact_contact_qry9", "select * from contacts where contactid='%d' and ownerid='%d'");
define("contact_contact_qry10", "select data from memo where id='%d'");
define("contact_contact_qry11", "select * from contacts where (ownerid='%d' AND private='U') ");
define("contact_contact_qry12", "select * from contacts where (private='A' OR ownerid='%d') ");
define("contact_contact_qry13", "select * from contacts where ownerid='%d'");
define("contact_contact_qry14", "select groupid from employee where id='%d'");
define("contact_contact_qry15", "select contacts.* from contacts,employee where ((contacts.ownerid=employee.id and 
   employee.groupid='%d' and contacts.private='G')) ");
define("contact_contact_qry16", "select deptid from groups where id='%d'");
define("contact_contact_qry17", "select contacts.* from contacts,employee,groups where 
   ((contacts.ownerid=employee.id and employee.groupid='%d' and groups.deptid='%d'
   and contacts.private='D')) ");
define("contact_contact_qry18", "select siteid from departments where id='%d'");
define("contact_contact_qry19", "select contacts.* from contacts,employee,groups,departments where 
   ((contacts.ownerid=employee.id and employee.groupid='%d' and groups.deptid='%d'
   and departments.siteid='%d' and contacts.private='S')) ");
define("contact_contact_qry20", "update contacts set ownerid='%d',addressid='%d',imageid='%d',titleid='%d',
firstname='%s',lastname='%s',middleinitial='%s',birthdate='%s',lastcontact='%s',timezone='%s',private='%s',
memoid='%d' where id = '%d'");

/****************************************
 * contactdetails queries
 ****************************************/
define("contact_details_qry1", "select count(*) from contactdetails");
define("contact_details_qry2", "select * from contactdetails limit 1 offset %d");
define("contact_details_qry3", "select * from contactdetails where id = '%d'");
define("contact_details_qry4", "insert into contactdetails values(0, '%d','%d','%s')");
define("contact_details_qry5", "update contactdetails set contactdetailsid='%d',typeid='%d',data='%s' where id='%d'");
define("contact_details_qry6", "delete from contactdetails where id='%d'");
define("contact_details_qry7", "select * from contactdetails");
define("contact_details_qry8", "select * from contactdetails where contactdetailsid = '%d' order by typeid");
define("contact_details_qry9", "select firstname,lastname,contactdetailsid from contacts where private='N' or ownerid='%d'");
define("contact_details_qry10", "select * from contactdetails where contactdetailsid='%d'");

/*****************************************
 * contacttype queries
 *****************************************/
define("contact_type_qry1", "select count(*) from contacttype");
define("contact_type_qry2", "select * from contacttype limit 1 offset %d");
define("contact_type_qry3", "select * from contacttype where id = '%d'");
define("contact_type_qry4", "insert into contacttype values(0, '%s')");
define("contact_type_qry5", "update contacttype set name='%s' where id='%d'");
define("contact_type_qry6", "delete from contacttype where id='%d'");
define("contact_type_qry7", "select * from contacttype order by '%s' %s ");
define("contact_type_qry8", "select * from contacttype");

/****************************************
 * atttribute queries
 ****************************************/
define("contact_attribute_qry1", "select count(*) from contactattribute where attributeid='%d'");
define("contact_attribute_qry2", "select * from contactattribute limit 1 offset %d");
define("contact_attribute_qry3", "select * from contactattribute where id = '%d'");
define("contact_attribute_qry4", "insert into contactattribute values('','%d','%s','%d','%s','%s','%s')");
define("contact_attribute_qry5", "update contactattribute set attributeid='%d',name='%s',type='%d',format='%s',
   mask='%s',value='%s' where id = '%d'");
define("contact_attribute_qry6", "delete from contactattribute where id = '%d'");
define("contact_attribute_qry7", "select * contactattribute");
define("contact_attribute_qry8", "select * contactattribute where attributeid='%s' order by '%s' %s ");
define("contact_attribute_qry9", "select attributeid,firstname,lastname from contacts where id = '%d'");
define("contact_attribute_qry10", "select * from contactattribute where attributeid = '%d' order by '%s' %s ");
define("contact_attribute_qry11", "select attributeid from contacts where id = '%d'");
define("contact_attribute_qry12", "select count(*) from contactattribute");
define("contact_attribute_qry13", "select firstname,lastname from contacts where attributeid = '%d'");

/****************************************
 * image queries
 ****************************************/
define("image_qry1", "select count(*) from imagedata");
define("image_qry2", "select * from imagedata limit 1 offset %d");
define("image_qry3", "select * from imagedata where id = '%d'");
define("image_qry4", "select * from imagedata");
define("image_qry5", "INSERT INTO imagedata VALUES ('','%d','%d','%d','%d','%d','%d'");
define("image_qry6", "UPDATE imagedata SET type='%d',reffile='%s',width='%d',height='%d',
	   bbp='%d',scale='%d' WHERE id='%d'");
define("image_qry7", "DELETE FROM imagedata WHERE id = '%d'");
define("image_qry8", "SELECT * FROM imagedata WHERE reffile = '%s'");

/*****************************************
 * title queries
 *****************************************/
define("contact_title_qry1", "select count(*) from title");
define("contact_title_qry2", "select * from title limit 1 offset %d");
define("contact_title_qry3", "select * from title where id = '%d'");
define("contact_title_qry4", "insert into title values(0, '%s')");
define("contact_title_qry5", "update title set name='%s' where id='%d'");
define("contact_title_qry6", "delete from title where id='%d'");
define("contact_title_qry7", "select * from title order by '%s' %s ");
define("contact_title_qry8", "select * from title");

/******************************************
 * memo queries
 ******************************************/
define("contact_memo_qry1", "select * from memo where id='%d'");
define("contact_memo_qry2", "insert into memo values('','%d','%d','%s','%d')");
define("contact_memo_qry3", "update memo set memoid='%d',cmid='%d',subject='%s', data='%s' where id='%d'");
define("contact_memo_qry4", "select * from memo where memoid = '%d'");
define("contact_memo_qry5", "delete from memo where id = '%d'");
define("contact_memo_qry6", "delet from memo where memoid = '%d'");

?>
