<?php

/**********************************************************************
 * 
 * Customer Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/

/****************************************
 * customer queries
 ****************************************/
define("customerm_customer_qry1", "select count(*) from customer");
define("customerm_customer_qry2", "select * from customer limit 1 offset %d");
define("customerm_customer_qry3", "select * from customer where id = '%d'");
define("customerm_customer_qry4", "select * from customer");
define("customerm_customer_qry5", "delete from customer where id='%d'");
define("customerm_customer_qry6", "insert into customer values('','%d','%d','%d','%d','%d','%d','%d','%s','%s','%d','%s','%d')");
define("customerm_customer_qry7", "update customer set cmid='%d',contactid='%d',storecardid='%d',
loyaltyid='%d',signatureid='%d',chargeaccountid='%d',login='%s',password='%s',attributeid='%d'
enabled='%s', memoid='%d' where id='%d'");
define("customerm_customer_qry8", "select firstname, lastname from contacts where id = '%d'");
define("customerm_customer_qry9", "select addressid from contacts where id='%d'");
define("customerm_customer_qry10","select memoid from contacts where id='%d'");
define("customerm_customer_qry11","select firstname,lastname from contacts where id='%d'");
define("customerm_customer_qry12", "select id from contacts where lastname like '%s' order by '%s' %s ");
define("customerm_customer_qry13", "select * from customer order by '%s' %s ");
define("customerm_customer_qry14", "select * from customer,contacts where contacts.lastname like '%s' and 
contacts.contactid=customer.contactid order by '%s' %s ");
define("customerm_customer_qry15", "select pointsid from loyalty where id='%d'");

/****************************************
 * chargeaccount queries
 ****************************************/
define("customerm_chargeacc_qry1", "select count(*) from chargeaccount");
define("customerm_chargeacc_qry2", "select * from chargeaccount limit 1 offset %d");
define("customerm_chargeacc_qry3", "select * from chargeaccount where id = '%d'");
define("customerm_chargeacc_qry4", "select * from chargeaccount");
define("customerm_chargeacc_qry5", "delete from chargeaccount where id = '%d'");
define("customerm_chargeacc_qry6", "insert into chargeaccount values('','','%d','%d','%d','%f','%s','%d','%s',
'%s','%s','%s','%s','%d','%d','%d','%s')");
define("customerm_chargeacc_qry7", "update chargeaccount set chargeid='%d',typeid='%d',cmid='%d',bsankid='%d',creditlimit='%f',
lasttransaction='%s',accountid='%d',standardterms='%s',codterms='%s',prepaidterms='%s',termstype='%s',
duemonthend='%s',duedays='%d',discountdays='%d',discountid='%d',notes='%s' where id='%d'");
define("customerm_chargeacc_qry8", "update chargeaccount set chargeid='%d' where id='%d'");
define("customerm_chargeacc_qry9", "insert into chargeaccount values('','%d','%d','%d','%f','%s','%d','%s',
'%s','%s','%s','%s','%d','%d','%d','%s')");
define("customerm_chargeacc_qry10", "select * from chargeitem from chargeaccountid='%d'");
define("customerm_chargeacc_qry11", "select reconciled from transaction where id='%d'");

/****************************************
 * chargeaccount type queries
 ****************************************/
define("customerm_chargeacctype_qry1", "select count(*) from chargeacctype");
define("customerm_chargeacctype_qry2", "select * from chargeacctype limit 1 offset %d");
define("customerm_chargeacctype_qry3", "select * from chargeacctype where id = '%d'");
define("customerm_chargeacctype_qry4", "select * from chargeacctype");

/****************************************
 * orders queries
 ****************************************/
define("customerm_orders_qry1", "select count(*) from orders");
define("customerm_orders_qry2", "select * from orders limit 1 offset %d");
define("customerm_orders_qry3", "select * from orders where id = '%d'");
define("customerm_orders_qry4", "select * from orders");
define("customerm_orders_qry7", "select * from orders order by '%s' %s ");

/****************************************
 * pointstype queries
 ****************************************/
define("customerm_points_qry1", "select count(*) from pointstype");
define("customerm_points_qry2", "select * from pointstype limit 1 offset %d");
define("customerm_points_qry3", "select * from pointstype where id = '%d'");
define("customerm_points_qry4", "insert into pointstype values(0,'%s','%s','%f')");
define("customerm_points_qry5", "update pointstype set name='%s',description='%s',value='%f' where id='%d'");
define("customerm_points_qry6", "delete from pointstype where id='%d'");
define("customerm_points_qry7", "select * from pointstype");
define("customerm_points_qry8", "select * from pointstype order by '%s' %s ");
define("customerm_points_qry9", "select distinct(name),id, value from pointstype");

/****************************************
 * loyalty queries
 ****************************************/
define("customerm_loyalty_qry1", "select count(*) from loyalty");
define("customerm_loyalty_qry2", "select * from loyalty limit 1 offset %d");
define("customerm_loyalty_qry3", "select * from loyalty where id = '%d'");
define("customerm_loyalty_qry4", "insert into loyalty values(0,'%d','%d','%d')");
define("customerm_loyalty_qry5", "update loyalty set loyaltyid='%d',pointsid='%d',catalogueid='%d' where id='%d'");
define("customerm_loyalty_qry6", "delete from loyalty where id='%d'");
define("customerm_loyalty_qry7", "select * from loyalty");

/****************************************
 * pointslog queries
 ****************************************/
define("customerm_pointslog_qry1", "select count(*) from pointslog");
define("customerm_pointslog_qry2", "select * from pointslog limit 1 offset %d");
define("customerm_pointslog_qry3", "select * from pointslog where id = '%d'");
define("customerm_pointslog_qry4", "insert into pointslog values(0,'%d','%d','%d','%s')");
define("customerm_pointslog_qry5", "update pointslog set pointsid='%d',pointstypeid='%d',issuedon='%s',redeemcode='%s',
typeid='%d',number='%d',redeemed='%s' where id='%d'");
define("customerm_pointslog_qry6", "delete from pointslog where id='%d'");
define("customerm_pointslog_qry7", "select * from pointslog"); 
define("customerm_pointslog_qry8", "select * from pointslog where pointsid = '%d'");
define("customerm_pointslog_qry9", "select value from loyalty where id = '%d'");
define("customerm_pointslog_qry10","select * from pointslog where pointsid = '%d' and redeemed='%s'");
define("customerm_pointslog_qry11","select * from pointslog where pointsid = '%d' and pointstypeid='%d' and redeemed='%s'");
define("customerm_pointslog_qry12","select * from pointslog where redeemed='%s'");
define("customerm_pointslog_qry13","select * from pointslog where pointstypeid='%d' and redeemed='%s'");
define("customerm_pointslog_qry14","select sum(number) from pointslog where pointstypeid='%d' and redeemed='%s' and pointsid='%d'");
define("customerm_pointslog_qry15","select * from pointslog where pointsid = '%d' and redeemed='%s' order by '%s' %s ");
define("customerm_pointslog_qry16","select * from pointslog where pointsid = '%d' and pointstypeid='%d' and redeemed='%s' order by '%s' %s ");
define("customerm_pointslog_qry17","select pointsid from loyalty, customer where customer.loyalityid=loyalty.id and
   customer.id='%d'");
?>
