<?php
/**********************************************************************
 * 
 * e-commerce Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/

/****************************************
 * ecomm queries
 ****************************************/
#applicant
define("ecomm_applicant_qry1", "select count(*) from applicant where email='%s' || login='%s'");
define("ecomm_applicant_qry2", "insert into applicant values('',NOW(),'%d','%s','%s','%s','%s','%s','%s',
'%s',''%s','%s','%s','%s','%s','%d','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%d','%d','%d','%d',
'%s','%s')");


# total num ecommerce prods
define("ecomm_product_qry1", "select count(*) from product where ecommerce='Y'");
# total num ecommerce prods in a given category
define("ecomm_product_qry2", "select count(*) from productcategory where categoryid='%d' and 
   (select id from product where ecommerce='Y')"); 
# quick product summary
define("ecomm_product_qry3", "select p.*, x.*, y.* from product as p, prodpricequantity as x, pqname as y, productcategory as z
   where x.pqid=p.sellquantityid and (z.categoryid='%d' and (p.id=z.productid and p.ecommerce='Y'))"); 


/****************************************
 * collection queries
 ****************************************/
define("ecomm_collection_qry1", "select count(*) from collection");
define("ecomm_collection_qry2", "select * from collection limit 1 offset %d");
define("ecomm_collection_qry3", "select * from collection where id = '%d'");
define("ecomm_collection_qry4", "insert into collection values('', '%s','%s','%d')");
define("ecomm_collection_qry5", "update collection set name='%s', description='%d', collectionid='%d' where id = '%d'");
define("ecomm_collection_qry6", "delete from collection where id = '%d'");
define("ecomm_collection_qry7", "select * from collection");
define("ecomm_collection_qry8", "select id from product where plu = '%s'");
define("ecomm_collection_qry9", "insert into productcollection values ('%d','%d')");
define("ecomm_collection_qry10", "delete from productcollection where prodcollid = '%d' and productid='%d'");
define("ecomm_collection_qry11", "select * from productcollection where prodcollid='%d'");
define("ecomm_collection_qry12", "select name, plu, sellquantityid from product where id = '%d'");
define("ecomm_collection_qry13", "select price from prodpricequantity where pqid = '%d' and nameid='1'");

/****************************************
 * discount queries
 ****************************************/
define("ecomm_discount_qry1", "select count(*) from discount");
define("ecomm_discount_qry2", "select * from discount limit 1 offset %d");
define("ecomm_discount_qry3", "select * from discount where id = '%d'");
define("ecomm_discount_qry4", "insert into discount values(0,'%d','%s','%d','%d','%f','%s'");
define("ecomm_discount_qry5", "update discount set discountid='%d',type='%d',ident='%d',targetid='%d',
   margin='%f',status='%s' where id='%d'");
define("ecomm_discount_qry6", "delete from discount where id='%d'");
define("ecomm_discount_qry7", "select * from discount");
define("ecomm_discount_qry8", "select count(*) from product where discountid = '%d'");


/****************************************
 * margin queries
 ****************************************/
define("ecomm_margin_qry1", "select count(*) from margin");
define("ecomm_margin_qry2", "select * from margin limit 1 offset %d");
define("ecomm_margin_qry3", "select * from margin where id = '%d'");
define("ecomm_margin_qry4", "insert into margin values('','%d','%s','%f','%d')");
define("ecomm_margin_qry5", "update margin set marginid='%d',name='%s',margin='%f',productcollid='%d'where id = '%d'");
define("ecomm_margin_qry6", "delete from margin where id = '%d'");
define("ecomm_margin_qry7", "select * from margin");


/****************************************
 * return queries
 ****************************************/
define("ecomm_return_qry1", "select count(*) from return");
define("ecomm_return_qry2", "select * from return limit 1 offset %d");
define("ecomm_return_qry3", "select * from return where id = '%d'");
define("ecomm_return_qry4", "insert into return values('','%d','%d','%s','%s','%f','%s','%d')");
define("ecomm_return_qry5", "update return set type='%d',startdate='%s',enddate='%s',margin='%f',memo='%s',
   promolinkid='%d' where id = '%d'");
define("ecomm_return_qry6", "delete from return where id = '%d'");
define("ecomm_return_qry7", "select * from return");

/****************************************
 * promotion queries
 ****************************************/
define("ecomm_promotion_qry1", "select count(*) from promotion");
define("ecomm_promotion_qry2", "select * from promotion limit 1 offset %d");
define("ecomm_promotion_qry3", "select * from promotion where id = '%d'");
define("ecomm_promotion_qry4", "select * from promotion");

/****************************************
 * returntype queries
 ****************************************/
define("ecomm_returntype_qry1", "select count(*) from returntype");
define("ecomm_returntype_qry2", "select * from returntype limit 1 offset %d");
define("ecomm_returntype_qry3", "select * from returntype where id = '%d'");
define("ecomm_returntype_qry4", "insert into returntype values('','%s','%s')");
define("ecomm_returntype_qry5", "update returntype set name='%s', active='%s' where id = '%d'");
define("ecomm_returntype_qry6", "delete from returntype where id = '%d'");
define("ecomm_returntype_qry7", "select * from returntype");
define("ecomm_returntype_qry8", "select id, name from returntype where active='y'");
define("ecomm_returntype_qry9", "select name from returntype where id='%d'");

?>
