<?php
/**********************************************************************
 * 
 * End of Day Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/
 
/****************************************
 * summary queries
 ****************************************/
define("eod_summary_qry1", "select count(*) from transaction where enteredat between '%s' and '%s'");
define("eod_summary_qry2", "select sum(amount) from paymentitem where enteredat between '%s' and '%s' and amount >= 0.0");
define("eod_summary_qry3", "select count(*) from transaction where enteredat between '%s' and '%s' and return.trans.id=id");
define("eod_summary_qry4", "select sum(amount) from paymentitem where enteredat between '%s' and '%s' and amount < 0.0");
define("eod_summary_qry5", "select count(*) from postlog where stamper between '%s' and '%s' and actionid='9'");
define("eod_summary_qry6", "select count(*) from postlog where stamper between '%s' and '%s' and actionid='10'");
define("eod_summary_qry7", "select count(*), sum(amount) from paymentitem where enteredat between '%s' and '%s' and paytype='1'");
define("eod_summary_qry8", "select count(*), sum(amount) from paymentitem where enteredat between '%s' and '%s' and paytype='2'");
define("eod_summary_qry9", "select count(*), sum(amount) from paymentitem where enteredat between '%s' and '%s' and paytype='3'");
define("eod_summary_qry10", "select count(*), sum(amount) from paymentitem where enteredat between '%s' and '%s' and paytype > '3'");
define("eod_summary_qry11", "select count(*), sum(amount) from paymentitem where enteredat between '%s' and '%s'");
define("eod_summary_qry12", "select count(*), sum(amount) from discrepancy where enteredat between '%s' and '%s' and type='%d'");

/****************************************
 * station queries
 ****************************************/
define("eod_station_qry1", "select posts.id as postid, name, mac, enteredstation, right(transaction.enteredstation, 5) as es,
   count(*) as sale_count from posts, transaction where enteredat between '%s' and '%s' and posts.id=right(transaction.enteredstation, 5)
   group by enteredstation");
define("eod_station_qry2", "select sum(amount) from paymentitem where enteredat between '%s' and '%s' and right(enteredstation, 5) = '%d'");
define("eod_station_qry3", "select actionid, count(*) as action_count from postlog where postid = '%d' and 
   stamper between '%s' and '%s' and actionid='%d' group by actionid");
define("eod_station_qry4", "select sum(amount) from adjustment where enteredat between '%s' and '%s' and
   typeid='%d' and right(stationid, 5)= '%d'");
   
/****************************************
 * employee queries
 ****************************************/
define("eod_emp_qry1", "select employeeid, employeenumber, fname, lname, enteredby,  count(*) as sale_count from employee, transaction
   where enteredat between '%s' and '%s' and employee.employeeid = transaction.enteredby group by enteredby, 
   employee.employeeid, employee.employeenumber, employee.fname, employee.lname order by lname, fname");
define("eod_emp_qry2", "select sum(amount) from paymentitem where enteredat between '%s' and '%s' and enteredby='%d'");
define("eod_emp_qry3", "select count(*) from employeelog where stamper between '%s' and '%s' and
   actionid='%d' and employeeid='%d'");
define("eod_emp_qry4", "select sum(amount) from adjustment where enteredat between '%s' and '%s' and
   typeid='%d' and userid='%d'");

/****************************************
 * stock queries
 ****************************************/
define("eod_stock_qry1", "select ti.plu, ti.quantity from transactionitems as ti, transaction as t, paymentitem as pi
   where ti.enteredat between '%s' and '%s' group by ti.plu, ti.quantity");
define("eod_stock_qry2", "select invid from product where plu='%s'");
define("eod_stock_qry3", "select inventory.id, inventory.instock, rolevel,onorder from inventory, product where inventory.id='%d'");
define("eod_stock_qry4", "select id, instock, onorder, rolevel, roqty, reservedqty from inventory where instock < rolevel");

/****************************************
 * bank queries
 ****************************************/
define("eod_bank_qry1", "select count(*), sum(amount) from paymentitem where enteredat between 
   '%s' and '%s' and paytype = '1' and amount > '0.0'");
define("eod_bank_qry2", "select count(*), sum(amount) from paymentitem where enteredat between '%s' and '%s' and paytype='3'");
define("eod_bank_qry3", "select count(*), sum(amount) from paymentitem where enteredat between 
   '%s' and '%s' and paytype='1' and amount > '0.0'");
define("eod_bank_qry4", "select count(*), sum(amount) from paymentitem where enteredat between '%s' and '%s' and paytype='3'");

?>
