<?php

/**********************************************************************
 * 
 * FinRep Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2005
 *
 **********************************************************************/

/*****************************************
 * balance sheet queries
 *****************************************/
define("finrep_balance_qry1", "select count(*) from purchaseorder where statusid = '13'"); // payable

define("finrep_balance_qry2", "select sum(le.amount), a.name as accountname, ah.name from ledgerentry as le, accounts as a, 
accountheading as ah where le.accountid=a.id and a.type=ah.id and ah.type='2' and le.posted='Y' and 
le.entereddate between '%s' and '%s' group by ah.name");

define("finrep_balance_qry3", "select sum(le.amount), a.name as accountname, ah.name from ledgerentry as le, accounts as a, 
accountheading as ah where le.accountid=a.id and a.type=ah.id and ah.type='3' and le.posted='Y' and 
le.entereddate between '%s' and '%s' group by ah.name");
/*
select (to_days(now()) - (to_days(po.arriveddate) + ca.duedays)) as due, 
from_days((to_days(po.arriveddate) + ca.duedays)) as duedate, le.amount, po.id, po.purchasenumber, po.arriveddate, 
s.name from chargeaccount as ca, purchaseorder as po, supplier as s,ledgerentry as le where po.supplierid=s.id and 
s.chargeid=ca.id and po.ledgerentryid=le.id order by '%s' %s ");
*/
/*****************************************
 * profit and loss queries
 *****************************************/
define("finrep_pandl_qry1", "select count(*) from purchaseorder where statusid = '13'"); // payable

define("finrep_pandl_qry2", "select (to_days(now()) - (to_days(o.shippeddate) + ca.duedays)) as due, 
from_days((to_days(o.shippeddate) + ca.duedays)) as duedate, le.amount, o.orderenumber, o.shippeddate, c.name from 
chargeaccount as ca, order as o, customer as c,ledgerentry as le where o.customerid=c.id and 
c.chargeid=ca.id and o.ledgerentryid=le.id order by '%s' %s ");

 
?>
