<?php
/**********************************************************************
 * 
 * System Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/
 
/****************************************
 * backup queries
 ****************************************/
//define("backup_qry1", "SELECT count(*) FROM supplier");

/****************************************
 * config queries
 ****************************************/
//define("config_qry1", "SELECT count(*) FROM supplier");

/****************************************
 * synchtype queries
 ****************************************/
define("system_synchtype_qry1", "select count(*) from synchtype");
define("system_synchtype_qry2", "select * from synchtype limit 1 offset %d");
define("system_synchtype_qry3", "select * from synchtype where id = '%d'");
define("system_synchtype_qry4", "delete from synchtype where id = '%d'");
define("system_synchtype_qry5", "insert into synchtype values(0,'%s')");
define("system_synchtype_qry6", "update synchtype set name='%s' where id='%d'");
define("system_synchtype_qry7", "select * from synchtype");


/****************************************
 * printer queries
 ****************************************/
define("system_printer_qry1", "select count(*) from printer");
define("system_printer_qry2", "select * from printer limit 1 offset %d");
define("system_printer_qry3", "select * from printer where id = '%d'");
define("system_printer_qry4", "select * from printer");
define("system_printer_qry5", "insert into printer values(0,'%s','%s','%s','%s','%s')");
define("system_printer_qry6", "update printer set name='%s',description='%s',address='%s',port='%s',active='%s' where id='%d'");
define("system_printer_qry7", "delete from printer where id = '%d'");
define("system_printer_qry8", "select id, name from printer");
define("system_printer_qry9", "select name from printer where id='%d'");

/****************************************
 * printsheet queries
 ****************************************/
define("system_printsheet_qry1", "select count(*) from printsheet");
define("system_printsheet_qry2", "select * from printsheet limit 1 offset %d");
define("system_printsheet_qry3", "select * from printsheet where id = '%d'");
define("system_printsheet_qry4", "select * from printsheet");
define("system_printsheet_qry5", "insert into printsheet values(0,'%s','%d','%d','%d','%d','%d','%d')");
define("system_printsheet_qry6", "update printsheet set name='%s',xsize='%d',ysize='%d',left_margin='%d',
   right_margin='%d',top_margin='%d',bottom_margin='%d' where id='%d'");
define("system_printsheet_qry7", "delete from printsheet where id = '%d'");

/****************************************
 * printitem queries
 ****************************************/
define("system_printitem_qry1", "select count(*) from printitem");
define("system_printitem_qry2", "select * from printitem limit 1 offset %d");
define("system_printitem_qry3", "select * from printitem where id = '%d'");
define("system_printitem_qry4", "select * from printitem");
define("system_printitem_qry5", "insert into printitem values(0,0,'%s','%d','%d','%d','%d','%s')");
define("system_printitem_qry6", "update printitem set name='%s',x='%d',y='%d',xsize='%d',ysize='%d',content='%s' where id='%d'");
define("system_printitem_qry7", "delete from printitem where id = '%d'");

/****************************************
 * printform queries
 ****************************************/
define("system_printform_qry1", "select count(*) from printform");
define("system_printform_qry2", "select * from printform limit 1 offset %d");
define("system_printform_qry3", "select * from printform where id = '%d'");
define("system_printform_qry4", "select * from printform");
define("system_printform_qry5", "insert into printform values(0,'%s','%s','%d','%d','%s','%d')");
define("system_printform_qry6", "update printform set name='%s',description='%s',printerid='%d',sheetid='%d',
   orientation='%s',printitemid='%d' where id='%d'");
define("system_printform_qry7", "delete from printform where id = '%d'");

/****************************************
 * stocktake queries
 ****************************************/
define("system_stocktake_qry1", "drop table if exists stocktake_products");
define("system_stocktake_qry2", "create table if not exists stocktake_products(id int(11) not null auto_increment,
	    plu varchar(16) not null, instock int(11) not null,currentstock int(11) not null,primary key (id))");
define("system_stocktake_qry3", "select plu, instock from product order by plu");
define("system_stocktake_qry4", "insert into stocktake_products values(0,'%s','%d','0')");
define("system_stocktake_qry5", "select currentstock from stocktake_products where plu='%s'");
define("system_stocktake_qry6", "update stocktake_products set currentstock='%d' where plu='%s'");
define("system_stocktake_qry7", "select plu, currentstock from stocktake_products order by plu");
define("system_stocktake_qry8", "update product set instock='%d' where plu='%s'");
define("system_stocktake_qry9", "select * from synch where implemented='n' and typeid='6'");
define("system_stocktake_qry10", "insert into synch values(0,'6',now(),now(),'','n')");
define("system_stocktake_qry11", "select id from synch where implemented='n' and typeid='6'");
define("system_stocktake_qry12", "update synch set implemented='y', implementationat=now() where id= '%d'");
define("system_stocktake_qry13", "select * from stocktake_products where instock!=currentstock");
define("system_stocktake_qry14", "update inventory set instock='%d' where id=(select invid from product where product.plu='%s')");
define("system_stocktake_qry15", "update stocktake_products set instock='%d' where plu='%s'");
define("system_stocktake_qry16", "select * from stocktake_products where plu='%s'");

?>
