<?php

/**********************************************************************
 * 
 * Base System Module
 *
 * @author Al Kingsley <al@bananahead.com>
 * @license	GPL version 2 or later.
 * @copyright Al Kingsley 2004
 *
 **********************************************************************/
 
/******************************************
 * misuser lib queries
 ******************************************/
 
define("misuser_qry1", "select * from users where id = '%d'");
define("misuser_qry2", "select users.* from users, logintypes where logintypes.loginid = users.id and logintypes.loginmethodid = 1 and logintypes.ident = '%s' and logintypes.data = '%s'");
define("misuser_qry3", "select employeenumber, groupid, fname, lname from employee where employeeid = '%d'");
define("misuser_qry4", "insert into employeelog values (0, '%d', '%d', now())");
define("misuser_qry5", "select stamper as last_login from employeelog where employeeid = '%d' and actionid = '%d' order by stamper desc limit 1");
define("misuser_qry6", "select contactid,groupid from employee where id = '%d'");
define("misuser_qry7", "select siteid from sites where siteid =
   (select siteid from departments where deptid =
   (select deptid from groups where groupid =
   (select groupid from employee where employeeid = '%d')))");
define("misuser_qry8", "select * from misuser where userid='%d'");
define("misuser_qry9", "select distinct(b.moduleid) from mismodule as a, mismenu as b where 
   b.menuid='%d' and b.moduleid=a.id and a.enabled='Y' and b.type <> 'H' order by a.parentid, a.sortorder");
define("misuser_qry10", "select * from mismenu where moduleid='%d' and menuid='%d' and type <> 'H' and sortorder >='0'
order by sortorder");
define("misuser_qry11", "select * from mismenu, mismodule where mismodule.basedir='%s' and mismenu.phpfile='%s'");
define("misuser_qry12", "select * from mismodule where id='%d'");
define("misuser_qry13", "select firstname, lastname from contacts where id = '%d'");
define("misuser_qry14", "select name from groups where id = '%d'");

/******************************************
 * attribute queries
 ******************************************/
define("misattribute_qry1", "select attributeid from misuser where id='%d'");
define("misattribute_qry2", "select * from misattribute where attributeid='0'"); // default settings
define("misattribute_qry3", "select * from misattribute where attributeid='%d'");
define("misattribute_qry4", "select * from missystemattribute where attributeid='0'");

/******************************************
 * misc queries
 ******************************************/
define("misc_qry1", "select last_insert_id()");
define("misc_qry2", "select id,country,isoname,isonumber from currency");
define("misc_qry3", "select * from currency");
define("misc_qry4", "select * from currency where id = '%d'");
define("misc_qry5", "select * from taxrate where id = '%d'");
define("misc_qry6", "select * from taxrate");
define("misc_qry7", "select name from country where id='%d'");
define("misc_qry8", "select id, name from country");
define("misc_qry9", "select value from missystemattribute where attributeid='0' and name='defaultcurrency'");
define("misc_qry10","select value from missystemattribute where attributeid='0' and name='defaultcountry'");

/******************************************
 * createmod queries
 ******************************************/
define("createmod_qry1", "select * from createmod where id='%d'");
define("createmod_qry2", "insert into createmod values('','%s','%s','%d','%d')");
define("createmod_qry3", "update createmod set modifieddate='%s', modifiedby='%d' where id='%d'");
define("createmod_qry4", "select contactid from employee where id = '%d'");
define("createmod_qry5", "select firstname, lastname from contacts where id = '%d'");
 
/*****************************************
 * login/logout/mainframe queries
 *****************************************/
define("login_qry1", "select now()");
define("login_qry2", "select * from users where login = '%s' and password = '%s'");
define("login_qry3", "select * from employee where id = '%d'");
define("login_qry4", "insert into employeelog values ('', '%d', '9', now())");
define("login_qry5", "select siteid, ismaster, name from setup");
define("login_qry6", "select name from sites where id='%d'");
define("login_qry7", "select id, name from sites where active='Y'");
define("login_qry8", "select * from sites where id='%d'");
define("login_qry9", "select value from systemattribute where name='companyid' and attributeid='0'");
define("login_qry10","select id,name from sites where businessunitid='%d' and active='Y'");
define("login_qry11", "select value from systemattribute where attributeid='0' and name='companyid'");
define("login_qry12", "select id from businessunit where id='%d'");
define("login_qry13", "select value from companyattribute where attributeid='1' and name='siteid'");
define("login_qry14", "select companyname from company where id='%d'");

define("logout_qry1", "insert into employeelog values ('', '%d', '10', now())");

define("mainframe_qry1", "select * from employeeaction");
define("mainframe_qry2", "select stamper from employeelog where employeeid = '%d' and actionid = '9' order by stamper desc limit 2");

/******************************************
 * calendar/event queries
 ******************************************/
define("calendar_qry1", "select * from event where ownerid = '%d' and (when after '%s' and when before '%s')");
define("calendar_qry2", "select count(*) from event where ownerid = '%d' and starts between '%s' and '%s')");
define("calendar_qry3", "select * from event where ownerid = '%d' and starts between '%s' and '%s' order by starts");
define("calendar_qry4", "select count(*) from event where ownerid = '%d' and starts between '%s' and '%s'");
define("calendar_qry5", "select count(*) from event where ownerid = '%d' and ((starts after '%s' and ends before '%s')
   or ends after '%s')");

/******************************************
 * org queries
 ******************************************/
define("org_qry1", "select id, name from sites");
define("org_qry2", "select name from sites where id='%d'");
define("org_qry3", "select * from departments");
define("org_qry4", "select name from departments where id='%d'");
define("org_qry5", "select * from groups");
define("org_qry6", "select name from groups where id='%d'");
define("org_qry7", "select * from posts");
define("org_qry8", "select name from posts where id='%d'");
define("org_qry9", "select contactid from employee where employeeid = '%d'");
define("org_qry10","select id, firstname, lastname from contacts where id = '%d'");
define("org_qry11","select id from deptartments where siteid='%d'");
define("org_qry12","select id from groups where deptid='%d'");
define("org_qry13","select contactid from employee where groupid='%d'");
define("org_qry14","select name from posts where id='%d'");
define("org_qry15","select name from users where id='%d'");

/******************************************
 * general attributes
 ******************************************/
define("attribute_qry1",  "select * from misattribute where attributeid='%d'");
define("attribute_qry2",  "select * from %s where attributeid='%d'");
define("attribute_qry3",  "select * from missystemattribute where attributeid='%d'");

/******************************************
 * more queries
 ******************************************/
define("vxlib_qry1",  "select id, name from status");
define("vxlib_qry2",  "select name from status where id = '%d'");
define("vxlib_qry3",  "select id, name from paymenttyp");
define("vxlib_qry4",  "select id, name from paymenttype where id='%d'");
define("vxlib_qry5",  "select id, name from sites");
define("vxlib_qry6",  "select name from sites where id='%d'");
define("vxlib_qry7",  "select * from departments");
define("vxlib_qry8",  "select name from departments where id='%d'");
define("vxlib_qry9",  "select * from groups");
define("vxlib_qry10", "select name from groups where id='%d'");
define("vxlib_qry11", "select * from posts");
define("vxlib_qry12", "select name from posts where id='%d'");
define("vxlib_qry13", "select id,fname,lname from employee");
define("vxlib_qry14", "select fname,lname from employee where employeeid = '%d'");
define("vxlib_qry15", "select * from departments where siteid='%d'");
define("vxlib_qry16", "select * from groups where deptid='%d'");

?>
