<?php
/*
approval.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/currency.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('dateplaced');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Orders"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Orders");
}

if($_SESSION["pageindex"]->CheckNum(order_order_qry1, "orders")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addOrder();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseOrder($_REQUEST['id']);
         break;
      }
		browseOrder($_POST['id']);
		break;

	case "approve" :
		editOrder($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelOrder($_REQUEST['id']);
      }
      else{
         deleteOrder($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listOrder();
      }
		break;

	case "cfmdelete" :
		deleteOrder($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listOrder();
		break;

	case "add" :
		insertOrder($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listOrder();
		break;
      
   case "approvecfm" :
		approveOrder($_POST);
      //$_SESSION["pageindex"]->addition(CountNum());
      listOrder();
		break;

	case "commit" :
		commitOrder($_POST);
		break;

   case "search" :
		searchOrder();
		break;
   
   case "sresults" :
		searchResults($_POST);
		break;
      
	case "list":
	default :
		listOrder();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(order_order_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
   $frm["orderid"] = 0;
   $frm["ordernumber"] = "";
   $frm["enteredby"]=0;
   $frm["customerid"] = "";
   $frm["statusid"] = "";
   $frm['waitonallitems']='Y';
   $frm["dateplaced"] = "";
   $frm["daterequired"] = "";
   $frm["billeddate"] = "";
   $frm["shippeddate"] = "";
   $frm["subtotal"] = "";
   $frm["shipcost"] = "";
   $frm["tax"] = "";
   $frm["total"] = "";
   $frm["basecurrencyid"] = "";
   $frm["ledgerentryid"] = "";
   $frm["transactionid"] = "";
   $frm["shipmethodid"] = "";
   
   $frm["paytype"]=0;
   $frm["cardnumber"]="";
   $frm["expdate"]="";
   
   $frm["shipcarrierid"]=0;
   $frm["weight"]="";
   $frm["volume"]="";
	$frm["shipamount"]="";
   
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(order_approval_qry2, $id);
   }
   else{
      $qry=sprintf(order_approval_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

   $frm["id"] = $row['id'];
   $frm["orderid"] = $row["orderid"];
   $frm["ordernumber"] = $row["ordernumber"];
   $frm["enteredby"] = $row["enteredby"];
   $frm["customerid"] = $row["customerid"];
   $frm["statusid"] = $row["statusid"];
   $frm["waitonallitems"] = $row["waitonallitems"];
   $frm["dateplaced"] = $row["dateplaced"];
   $frm["daterequired"] = $row["daterequired"];
   $frm["billeddate"] = $row["billeddate"];
   $frm["shippeddate"] = $row["shippeddate"];
   $frm["subtotal"] = $row["subtotal"];
   $frm["shipcost"] = $row["shipcost"];
   $frm["tax"] = $row["tax"];
   $frm["total"] = $row["total"];
   $frm["basecurrencyid"] = $row["basecurrencyid"];
   $frm["ledgerentryid"] = $row["ledgerentryid"];
   $frm["transactionid"] = $row["transactionid"];
   $frm["shippingid"] = $row["shippingid"];
   
   $qry=sprintf(order_approval_qry13, $frm["id"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   $frm["paytype"]=$row["bank"];
   $frm["cardnumber"]=$row["cardnumber"];
   $frm["expdate"]=$row["expdate"];
   
   /*
   $frm["shipcarrierid"]=row['shipperid'];
	$frm["shipamount"]="";
   $frm["trackingnumber"]="";
   */
	return $frm;
}

function addOrder()
{
	$frm=clearForm();
	$frm["newaction"] = "add";

	include("templates/approval.php");
}

function editOrder($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "approvecfm";

	include("templates/approval.php");
}

function approveOrder($frm)
{
   $qry=sprintf(order_approval_qry8, $frm["id"]);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   //$qry=sprintf(order_approval_qry14,BHSQL_JOURNAL_SALE,0,$frm['ledgerentryid'],'','N',$frm['total'],'N',$frm['id']);
}

function browseOrder($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/approval.php");
}

function chkdelOrder($id)
{
	$qry=sprintf(order_order_qry10, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);	
	$frm["numdepts"]=db_num_rows($result);

   $qry=sprintf(order_order_qry12, $id);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);	
	$row = $result->FetchRow();
	$frm["name"]=$row["name"];

   $frm["id"]=$id; 
	$frm["newaction"] = "cfmdelete";
   
	include("templates/approval.php");
}

function insertOrder($frm) 
{
	$name=$frm["name"];
	$ab=$frm["annualbudget"];
	$h=$frm["contactid"];
   
   $a=new Address();
   $a->SetFromForm($frm);
   $adid=$a->Add();
	
   $qry=sprintf(order_order_qry4,$frm["orderid"],
   $frm["ordernumber"],
   $frm["enteredby"],
   $frm["customerid"],
   $frm["statusid"],
   $frm['waitonallitems'],
   $frm["dateplaced"],
   $frm["daterequired"],
   $frm["billeddate"],
   $frm["shippeddate"],
   $frm["subtotal"],
   $frm["shipcost"],
   $frm["tax"],
   $frm["total"],
   $frm["basecurrencyid"],
   $frm["ledgerentryid"],
   $frm["transactionid"],
   $frm["shipmethodid"]);
   $_SESSION['VxCFG']->dbh->StartTrans();
	$_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=approval&err=insert");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
}

function commitOrder($frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
   $aid=$frm['addressid'];
   $a->Commit($aid);

   $qry=sprintf(order_order_qry5,$frm["orderid"],
   $frm["ordernumber"],
   $frm["enteredby"],
   $frm["customerid"],
   $frm["statusid"],
   $frm['waitonallitems'],
   $frm["dateplaced"],
   $frm["daterequired"],
   $frm["billeddate"],
   $frm["shippeddate"],
   $frm["subtotal"],
   $frm["shipcost"],
   $frm["tax"],
   $frm["total"],
   $frm["basecurrencyid"],
   $frm["ledgerentryid"],
   $frm["transactionid"],
   $frm["shipmethodid"],$frm['id']);
   $_SESSION['VxCFG']->dbh->StartTrans();
	$_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=approval&err=commit");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
}

function deleteOrder($frm) 
{
	if($frm["reassign"]=="1"){
		$ndept=$frm["departments"];
      $qry=sprintf(order_order_qry8, $ndept, $frm["id"]);
		$_SESSION['VxCFG']->dbh->Execute($qry);
	}
	else{
      $qry=sprintf(order_order_qry9, $frm["id"]);
		$_SESSION['VxCFG']->dbh->Execute($qry);	
	}

   $qry=sprintf(order_order_qry6, $frm["id"]);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function searchOrder()
{
   $frm["newaction"] = "sresults";
   
	include("templates/ordersearch.php");
}

function searchResults($frm)
{
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "Address");
}

function fillBankCombo($a, $id)
{
   $b=new BankDetails();
   $b->Combo($a, $id, "bankid");
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "currencyid");
}

function LocaleCombo($action, $id)
{
   $a=new Locale();
   $a->Combo($action, $id, "localeid");
}

function Customer($action, $id)
{
   $qry=sprintf(order_approval_qry9, $id);
   $res=$_SESSION['VxCFG']->dbh->Execute($qry);
   $r = $res->FetchRow();
      
   $qry=sprintf(order_approval_qry10,$r["contactid"]);
   $res=$_SESSION['VxCFG']->dbh->Execute($qry);
   $r = $res->FetchRow();
      
   echo $r["firstname"]." ".$r["lastname"];
}

function AccountCombo($a, $id) 
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function DateControl($a, $d)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
	   $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
  		if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->displayex('datenoyear', $a, '', $d);
   //$td->datecontrol($a, "");
}

function EnteredBy($action, $id)
{
   $qry=sprintf(order_approval_qry15, $id);
   $res=$_SESSION['VxCFG']->dbh->Execute($qry);
   $r = $res->FetchRow();
   
   $qry=sprintf(order_approval_qry16, $r['contactid']);
   $res=$_SESSION['VxCFG']->dbh->Execute($qry);
   $r = $res->FetchRow();
   echo $r["firstname"]." ".$r["lastname"];
}

function Shipper($a, $id)
{
   
}

function OrderItems($orderid)
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();

   echo "<table class=\"listtable\">\n";
   $qry=sprintf(order_approval_qry6, $orderid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      exit;
   }
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='partnumber'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Part No")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Part No")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=partnumber\">"._("Part No")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='parnumber'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='stocklocation'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Location")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Location")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=stocklocation\">"._("Location")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='stocklocation'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='description'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Description")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Description")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=description\">"._("Description")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='description'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \">"._("Quantity")."</td>\n";
   echo "</tr>\n";
   
   while($row = $result->FetchRow()){
      $qry=sprintf(warehouse_stockpick_qry7, $row['productid']);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$res) continue;
      if($res->RecordCount()==0) continue;
      if(!($r = $res->FetchRow())) continue;
      echo "<tr><td class=\"listdata\">";
      if(isset($r["partnumber"])){
         echo $r["partnumber"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n<td class=\"listdata\">";
      if(isset($r["stocklocation"]) && $r["stocklocation"]!=''){
         echo $r["stocklocation"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n";
      
      echo "<td class=\"listdata\">".$r["description"]."</td>\n";
      echo "<td class=\"listdata\">".$row["quantity"]."</td>\n";
      echo "</tr>\n";
   }
   echo "</table>\n";
}

function listOrder()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(order_approval_qry4, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no orders defined")."</td></td></table>\n";
      exit;
   }
   
	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='dateplaced'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Date")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Date")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=dateplaced\">"._("Date")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='dateplaced'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='ordernumber'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Order Number")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Order Number")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=ordernumber\">"._("Order Number")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='ordernumber'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">".$row["dateplaced"]."</td>\n";
         echo "<td class=\"listdata\">".$row["ordernumber"]."</td>\n";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row["dateplaced"]."</td>\n";
         echo "<td class=\"listdataeven\">".$row["ordernumber"]."</td>\n";
      }
      $qry=sprintf(order_approval_qry9, $row["customerid"]);
		$res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      
      $qry=sprintf(order_approval_qry10,$r["contactid"]);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      
      if($c%2){
         echo "<td class=\"listdata\">".$r["firstname"]." ".$r["lastname"]."</td>\n";
		   echo "<td class=\"listdata\">";
      }
      else{
         echo "<td class=\"listdataeven\">".$r["firstname"]." ".$r["lastname"]."</td>\n";
		   echo "<td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"approval.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"approval.php?action=approve&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"approval.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"approval.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"approval.php?action=approve&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"approval.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
