<?php
/*
newcustomer.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/contact.php");
require_once($_SESSION['VxCFG']->libdir."/country.php");
require_once($_SESSION['VxCFG']->libdir."/chargeaccount.php");
require_once($_SESSION['VxCFG']->libdir."/loyalty.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(3);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('dateplaced');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_CUSTOMER){
      $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
   }
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_CUSTOMER){
         $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
         if($_REQUEST['id']==0){
            $action='clear';
            $_REQUEST['action']='clear';
         }
         else{
            $action='clear';
            $_REQUEST['action']='clear';
         }
      }
      else{
         $action='clear';
         $_REQUEST['action']='clear';
      }
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("New Customer Order"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("New Customer Order");
}

if($_SESSION["pageindex"]->CheckNum(orderu_newcust_qry1, "orders")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addOrder();
		break;

	case "add" :
		insertOrder($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listOrder();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(orderu_newcust_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$_SESSION['vxmisuser']->ClearFocus();
   $frm["id"] = "";
   $frm["cmid"] = 0;
   $frm["contactid"] = "";
   $frm["storecardid"] = "";
   $frm["loyalityid"] = "";
   $frm["signatureid"] = "";
   $frm["chargeaccountid"] = "";
   $frm["login"] = "";
   $frm["password"] = "";
   $frm["attributesid"]="";
   $frm["enabled"] = "";
   $frm["memoid"] = "";
   
   $frm["timezone"] = 0;
   $frm["birthdate"] = "";
   
   $frm["subscribenewsletter"]='N';
	$frm["subscribeupdates"]='N';
	$frm["subscribespecials"]='N';
	$frm["subscribenewproducts"]='N';
   
   $frm["titleid"]="";
   $frm["firstname"]="";
   $frm["lastname"]="";
   $frm["login"]="";
   $frm["password"]="";
   $frm["cpassword"]="";
   
   $frm["typeid"]=1;
   $frm["addressid"]=0;
   $frm["address1"]="";
   $frm["address2"]="";
   $frm["address3"]="";
   $frm["city"]="";
   $frm["state"]="";
   $frm["postcode"]="";
   $frm["countryid"]="";
   
   $frm["daddrsame"]="1";
   $frm["dtypeid"]="4";
   $frm["daddress1"]="";
   $frm["daddress2"]="";
   $frm["daddress3"]="";
   $frm["dcity"]="";
   $frm["dstate"]="";
   $frm["dpostcode"]="";
   $frm["dcountryid"]="";
	
   $frm["email"]="";
   $frm["phonenumber"]="";
   $frm["faxnumber"]="";
   $frm["mobilenumber"]="";
   
	return $frm;
}

function addOrder()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	include("templates/newcustomer.php");
}

function insertOrder($frm) 
{
	$a=new Address();
   $a->SetFromForm($frm);
	if(!$a->Find(false)){
      $aid=$a->Add();
   }
   else{
      $aid=$a->GetID();
   }
   
   if(!isset($frm['daddrsame'])){
      $a->Set($aid,
         $frm['dtypeid'],
         $frm['daddress1'],
	      $frm['daddress2'],
   	   $frm['daddress3'],
	      $frm['dcity'],
         $frm['dstate'],
   	   $frm['dpostcode'],
	      $frm['dcountryid']);
	   if(!$a->Find(false)){
         $daid=$a->Add();
      }
      else{
         $daid=$a->GetID();
      }
   }
   
   $c=new CreateMod();
   $cmid=$c->Commit();
   
   $p=new Loyalty();
   $loyalityid=$p->Add();
   
   $ch=new ChargeAccount();
   $chid=$ch->Add();
   
   $qry=sprintf(orderu_newcust_qry3, 0, 5, $frm["email"]);
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   if($row = $result->FetchRow()){
      $cdid=$row[0];
   }
   $qry=sprintf(orderu_newcust_qry7,$cdid,$cdid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   if($frm["phonenumber"]!=""){
      $qry=sprintf(orderu_newcust_qry3, $cdid, 1, $frm["phonenumber"]);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   if($frm["faxnumber"]!=""){
      $qry=sprintf(orderu_newcust_qry3, $cdid, 4, $frm["faxnumber"]);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   if($frm["mobilenumber"]!=""){
      $qry=sprintf(orderu_newcust_qry3, $cdid, 3, $frm["mobilenumber"]);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   
   $bd=$frm['birthdateyear']."-".$frm['birthdatemonth']."-".$frm['birthdateday'];
   
   $qry=sprintf(orderu_newcust_qry8, $cdid, $_SESSION['vxmisuser']->GetEmployee(), $aid, 0,$frm["titleid"],
	   $frm["firstname"],$frm["lastname"],'',$bd,$frm["timezone"],'N',0);
   
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   if($row = $result->FetchRow()){
      $contactid=$row[0];
   }
   $qry=sprintf(orderu_newcust_qry9, $contactid, $contactid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   $qry=sprintf(orderu_newcust_qry4, 'lastlogin', '6','','');
   $_SESSION['VxCFG']->dbh->StartTrans();
   $_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=newcustomer&err=insertattrib");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
       
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   if($row = $result->FetchRow()){
      $attributesid=$row[0];
   }
   $qry=sprintf(orderu_newcust_qry6, $attributesid, $attributesid);
   $_SESSION['VxCFG']->dbh->StartTrans();
   $_SESSION['VxCFG']->dbh->Execute($qry);
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=newcustomer&err=updateattrib");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
   
   //$_SESSION['VxCFG']->dbh->StartTrans();
   $qry=sprintf(orderu_newcust_qry5,$attributesid,'numlogin', '2','','','0');
   $_SESSION['VxCFG']->dbh->Execute($qry);
	$qry=sprintf(orderu_newcust_qry5,$attributesid,'subscribenewsletter', '3','','',YN($frm["subscribenewsletter"]));
   $_SESSION['VxCFG']->dbh->Execute($qry);
	$qry=sprintf(orderu_newcust_qry5,$attributesid,'subscribeupdates', '3','','',YN($frm["subscribeupdates"]));
   $_SESSION['VxCFG']->dbh->Execute($qry);
	$qry=sprintf(orderu_newcust_qry5,$attributesid,'subscribespecials', '3','','',YN($frm["subscribespecials"]));
   $_SESSION['VxCFG']->dbh->Execute($qry);
	$qry=sprintf(orderu_newcust_qry5,$attributesid,'subscribenewproducts', '3','','',YN($frm["subscribenewproducts"]));
   $_SESSION['VxCFG']->dbh->Execute($qry);
	$qry=sprintf(orderu_newcust_qry5,$attributesid,'carttheme', '1','','', "Default");
   $_SESSION['VxCFG']->dbh->Execute($qry);
	$qry=sprintf(orderu_newcust_qry5,$attributesid,'cartlistpagesize', '2','','', "20");
   $_SESSION['VxCFG']->dbh->Execute($qry);
	$qry=sprintf(orderu_newcust_qry5,$attributesid,'cartlanguage', '1','','',"EN");
   $_SESSION['VxCFG']->dbh->Execute($qry);
	$qry=sprintf(orderu_newcust_qry5,$attributesid,'catalogueid', '2','','','0');
   $_SESSION['VxCFG']->dbh->Execute($qry);
	$qry=sprintf(orderu_newcust_qry5,$attributesid,'numproductsbought', '2','','','0');
   $_SESSION['VxCFG']->dbh->Execute($qry);
	$qry=sprintf(orderu_newcust_qry5,$attributesid,'valueproductbought', '5','','','0.0');
   $_SESSION['VxCFG']->dbh->Execute($qry);
   /*
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=newcustomer&err=insertattrib");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
   */
   //$_SESSION['VxCFG']->dbh->StartTrans();
   $qry=sprintf(customerm_customer_qry6,$cmid,$contactid,0,$loyalityid,'0.0',0,$chid,
      $frm["login"],$frm["password"],$attributesid,'Y',0);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   /*
   if($_SESSION['VxCFG']->dbh->HasFailedTrans()){
      header("Location: ".$_SESSION['VxCFG']->errorpage."?ep=newcustomer&err=insertcust");
		exit;
   }
   $_SESSION['VxCFG']->dbh->CompleteTrans();
   */
   $result=$_SESSION['VxCFG']->dbh->Execute(misc_qry1);
   if($row = $result->FetchRow()){
      $customerid=$row[0];
   }
   $_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_CUSTOMER);
   $_SESSION['vxmisuser']->SetFocusID($customerid);
   
   echo "<meta http-equiv='refresh' content='0; url=\"neworder.php?action=clear\"'>";
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "Address");
}

function CountryCombo($a, $id)
{
   $c=new Country();
   $c->Combo($a, $id, "countryid");
}

function BirthDate($a, $bd)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
     $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
      if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->datecontrol_ranged($a, "birthdate", 65, 16);
}

?>
