<?php
/*
neworder.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/account.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/currency.php");
require_once($_SESSION['VxCFG']->libdir."/contact.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(4);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('dateplaced');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_CUSTOMER){
      $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
   }
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_CUSTOMER){
         $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
         //$action=$_SESSION['vxmisuser']->GetFocusAction();
         $action='add';
      }
      else{
         $action='list';
      }
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Orders"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Orders");
}

if($_SESSION["pageindex"]->CheckNum(order_order_qry1, "orders")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
}

include($_SESSION['VxCFG']->styledir."/header.php");
flush();
switch($action){
	case "clear" :
		addOrder();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseOrder($_REQUEST['id']);
         break;
      }
		browseOrder($_POST['id']);
		break;

	case "edit" :
		editOrder($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelOrder($_REQUEST['id']);
      }
      else{
         deleteOrder($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listOrder();
      }
		break;

	case "cfmdelete" :
		deleteOrder($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listOrder();
		break;

	case "add" :
		insertOrder($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listOrder();
		break;

	case "commit" :
		commitOrder($_POST);
		break;

   case "search" :
		searchOrder();
		break;
   
   case "searchresults" :
		searchResults($_POST);
		break;
   
   default :
	case "list":	
      if(isset($_REQUEST['cletter'])) $cl=$_REQUEST['cletter'];
      else $cl='All';
		listOrder($cl);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(order_order_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = 0;
   $frm["orderid"] = 0;
   $frm["ordernumber"] = "";
   $frm["enteredby"] = 0;
   if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_CUSTOMER){
      $frm["customerid"]=$_SESSION['vxmisuser']->GetFocusID();
   }
   else{
      $frm["customerid"] = "";
   }
   $frm["deliveryaddressid"] = "";
   $frm["billingaddressid"] = "";
   $frm["statusid"] = 0;
   $frm['waitonallitems']='Y';
   $frm["dateplaced"] = "";
   $frm["daterequired"] = "";
   $frm["billeddate"] = "";
   $frm["shippeddate"] = "";
   $frm["subtotal"] = "";
   $frm["shipcost"] = "";
   $frm["tax"] = "";
   $frm["total"] = "";
   $frm["basecurrencyid"] = "";
   $frm["accountid"] = "";
   $frm["transactionid"] = "";
   $frm["shipmethodid"] = "";
	
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(customerm_customer_qry2, $id);
   }
   else{
      $qry=sprintf(customerm_customer_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   
   $frm["id"] = $row["$id"];
   $frm["cmid"] = $row["cmid"];
   $frm["contactid"] = $row["contactid"];
   $frm["storecardid"] = $row["storecardid"];
   $frm["loyaltyid"] = $row["loyalityid"];
   $frm["signatureid"] = $row["signatureid"];
   $frm["chargeaccountid"] = $row["chargeaccountid"];
   $frm["login"] = $row["login"];
   $frm["password"] = $row["password"];
   $frm["attributesid"]=$row["attributesid"];
   $frm["enabled"] = $row["enabled"];
   $frm["memoid"] = $row["memoid"];
   
   $qry=sprintf(contact_contact_qry3, $row["contactid"]);
	$result=db_query($qry);
	$row = $result->FetchRow();
   $frm["contactdetailsid"] = $row["contactdetailsid"];
   /*
   $frm["id"] = $row['id'];
   $frm["orderid"] = $row["orderid"];
   $frm["ordernumber"] = $row["ordernumber"];
   $frm["enteredby"] = $row["enteredby"];
   $frm["customerid"] = $row["customerid"];
   $frm["deliveryaddressid"] = $row["deliveryaddressid"];
   $frm["billingaddressid"] = $row["billingaddressid"];
   $frm["statusid"] = $row["statusid"];
   $frm["waitonallitems"] = $row["waitonallitems"];
   $frm["dateplaced"] = $row["dateplaced"];
   $frm["daterequired"] = $row["daterequired"];
   $frm["billeddate"] = $row["billeddate"];
   $frm["shippeddate"] = $row["shippeddate"];
   $frm["subtotal"] = $row["subtotal"];
   $frm["shipcost"] = $row["shipcost"];
   $frm["tax"] = $row["tax"];
   $frm["total"] = $row["total"];
   $frm["basecurrencyid"] = $row["basecurrencyid"];
   $frm["ledgerentryid"] = $row["ledgerentryid"];
   $frm["transactionid"] = $row["transactionid"];
   $frm["shippingid"] = $row["shippingid"];
   
   $qry=sprintf(order_approval_qry13, $frm["id"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   $frm["paytype"]=$row["bank"];
   $frm["cardnumber"]=$row["cardnumber"];
   $frm["expdate"]=$row["expdate"];
   
   $frm["shipcarrierid"]=row['shipperid'];
	$frm["shipamount"]="";
   $frm["trackingnumber"]="";
   */
	return $frm;
}

function addOrder()
{
	$frm=clearForm();
	$frm["newaction"] = "add";

	include("templates/orders.php");
}

function editOrder($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/orders.php");
}

function browseOrder($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/orders.php");
}

function chkdelOrder($id)
{
   $frm["id"]=$id; 
	$frm["newaction"] = "cfmdelete";
   
	include("templates/orders.php");
}

function insertOrder($frm) 
{
	$qry=sprintf(order_order_qry16,$frm["orderid"],
   $frm["ordernumber"],
   $frm["enteredby"],
   $frm["customerid"],
   $frm["statusid"],
   $frm['waitonallitems'],
   $frm["dateplaced"],
   $frm["daterequired"],
   $frm["billeddate"],
   $frm["shippeddate"],
   $frm["subtotal"],
   $frm["shipcost"],
   $frm["tax"],
   $frm["total"],
   $frm["basecurrencyid"],
   $frm["ledgerentryid"],
   $frm["transactionid"],
   $frm["shipmethodid"]);
   
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitOrder($frm) 
{
   $qry=sprintf(order_order_qry17,$frm["orderid"],
   $frm["ordernumber"],
   $frm["enteredby"],
   $frm["customerid"],
   $frm["statusid"],
   $frm['waitonallitems'],
   $frm["dateplaced"],
   $frm["daterequired"],
   $frm["billeddate"],
   $frm["shippeddate"],
   $frm["subtotal"],
   $frm["shipcost"],
   $frm["tax"],
   $frm["total"],
   $frm["basecurrencyid"],
   $frm["ledgerentryid"],
   $frm["transactionid"],
   $frm["shipmethodid"],$frm['id']);

	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function deleteOrder($frm) 
{
}

function searchOrder()
{
   $frm["newaction"] = "searchresults";
   $frm["id"]=0;
   $frm["ordernumber"]="";
   $frm["customersn"]="";
   $frm["customerfn"]="";
	include("templates/query.php");
}

function searchResults($frm)
{
   if(isset($_POST['ordernumber']) && $_POST['ordernumber']!=""){
      $qry=sprintf(orderu_query_qry2,$_POST['ordernumber']);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      
      if(!$result){
         $frm['errmsg']=_("Bad Query");
         $frm["newaction"] = "searchresults";
         $frm["id"]=0;
         $frm["ordernumber"]="";
         $frm["customersn"]="";
         $frm["customerfn"]="";
         include("templates/query.php");
         return;
      }
      if($result->RecordCount()==0){
         $frm['errmsg']=_("No Records found for order number ").$_POST['ordernumber'];
         $frm["action"] = "search";
         $frm["newaction"] = "search";
         $frm["id"]=0;
         $frm["ordernumber"]="";
         $frm["customersn"]="";
         $frm["customerfn"]="";
         include("templates/query.php");
         return;
      }
	   if(!($row = $result->FetchRow())){
         $frm['errmsg']=_("Bad Query");
         $frm["newaction"] = "searchresults";
         $frm["id"]=0;
         $frm["ordernumber"]="";
         $frm["customersn"]="";
         $frm["customerfn"]="";
         include("templates/query.php");
         return;
      }
      else{
         $frm=fillForm($row['id'], false);
         $frm['newaction']="browse";
         include("templates/neworder.php");
         return;
      }
   }
   else if(isset($_POST['customersn'])){
      $qry=sprintf(orderu_query_qry10,$_POST['customersn']);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      
      if(!$result){
         $frm['errmsg']=_("Bad Query");
         $frm["newaction"] = "searchresults";
         $frm["id"]=0;
         $frm["ordernumber"]="";
         $frm["customersn"]="";
         $frm["customerfn"]="";
         include("templates/query.php");
         return;
      }
      if($result->RecordCount()==0){
         $frm['errmsg']=_("No Records found for customer surname: ").$_POST['customersn'];
         $frm["action"] = "search";
         $frm["newaction"] = "search";
         $frm["id"]=0;
         $frm["ordernumber"]="";
         $frm["customersn"]="";
         $frm["customerfn"]="";
         include("templates/query.php");
         return;
      }
	   if(!($row = $result->FetchRow())){
         $frm['errmsg']=_("Bad Query");
         $frm["newaction"] = "searchresults";
         $frm["id"]=0;
         $frm["ordernumber"]="";
         $frm["customersn"]="";
         $frm["customerfn"]="";
         include("templates/query.php");
         return;
      }
      else{
         $qry=sprintf(orderu_query_qry9,$row['id']);
         $result=$_SESSION['VxCFG']->dbh->Execute($qry);
         $row = $result->FetchRow();
         $frm=fillForm($row['id'], false);
         $frm['newaction']="browse";
         include("templates/orders.php");
         return;
      }
   }
   else{
      $frm['errmsg']=_("Fill in something");
      include("templates/query.php");
   }
}

function ItemsTable($action, $id)
{
   //$a=new Address();
   //$a->FillTable($action, $id, "Address");
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "Address");
}

function fillBankCombo($a, $id)
{
   $b=new BankDetails();
   $b->Combo($a, $id, "bankid");
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "currencyid");
}

function LocaleCombo($action, $id)
{
   $a=new Locale();
   $a->Combo($action, $id, "localeid");
}

function EnteredBy($action, $id)
{

}

function Customer($action, $id)
{
   $qry=sprintf(order_approval_qry9, $id);
   $res=$_SESSION['VxCFG']->dbh->Execute($qry);
   $r = $res->FetchRow();
      
   $qry=sprintf(order_approval_qry10,$r["contactid"]);
   $res=$_SESSION['VxCFG']->dbh->Execute($qry);
   $r = $res->FetchRow();
      
   echo $r["firstname"]." ".$r["lastname"];
}

function AccountCombo($a, $id) 
{
   $acc=new Account();
   $acc->Combo($a, $id, "accountid");
}

function StatusCombo($a, $id)
{
   if($a=="commit" || $a=="add"){
      echo "<select name=\"statusid\">\n";
      if($id==0){
         echo "<option selected value='0'>Not Set</option>\n";
      }
      else{
         echo "<option value='0'>Not Set</option>\n";
      }
      $qry=sprintf(order_order_qry14);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      while($row = $result->FetchRow()){
         if($row["id"]==$id){
            echo "<option selected value=\"".$row["id"]."\">".$row["name"]."</option>\n";
         }
         else{
            echo "<option value=\"".$row["id"]."\">".$row["name"]."</option>\n";
         }
      }
      echo "</select>\n";
   }
   else{
      $qry=sprintf(order_order_qry15, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo $row["name"];
      }
      else{
         echo _("Not Set");
      }
   }
}

function StatusFormCombo($a, $id)
{
   echo "<select onChange=\"this.form.submit();\" name=\"statusfilter\">\n";
   if($id=='All'){
      echo "<option selected value='All'>All</option>\n";
   }
   else{
      echo "<option value='All'>All</option>\n";
   }
   $qry=sprintf(order_order_qry14);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   while($row = $result->FetchRow()){
      if($row["id"]==$id){
         echo "<option selected value=\"".$row["id"]."\">".$row["name"]."</option>\n";
      }
      else{
         echo "<option value=\"".$row["id"]."\">".$row["name"]."</option>\n";
      }
   }
   echo "</select>\n";
}

function ordderNumber($orderid)
{
   return sprintf(date('y').'%010d', $orderid);
}

function listOrder($lc='All')
{
   //include($_SESSION['VxCFG']->styledir."/header.php");
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   if($lc!='All'){
      $qry=sprintf(customerm_customer_qry14, $lc.'%', $sorton, $sortorder);
   }
   else{
      $qry=sprintf(customerm_customer_qry13, $sorton, $sortorder);
   }
   
   //$qry=sprintf(customerm_customer_qry4, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<form action=\"".$_SERVER['PHP_SELF']."\" method=\"POST\">\n";
   echo "<input type=\"hidden\" name=\"cletter\" value=\"$lc\">\n";
   echo "<table class=\"listtable\">\n";
   echo "<tr><td class=\"listtitle\" colspan=\"4\">";
   ContactAlphabet($lc);
   echo "</td></tr>";
   
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no customers defined")."</td></td></table>\n";
      exit;
   }
   
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no customers defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
   
	while($row = $result->FetchRow()){
      $qry=sprintf(customerm_customer_qry8, $row['contactid']);
	   $nresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($nrow = $nresult->FetchRow()){
         $n=$nrow[0] . " " . $nrow[1];
      }
      else{
         $n="Not Set";
      }
		print "<tr><td class=\"listdata\">$n</td><td class=\"listdata\">";
		$wibbler=$row["id"];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"neworder.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_select.png\"></a>&nbsp;\n";
      }
      else{
      	echo "<a href=\"neworder.php?action=edit&id=$wibbler\">"._("Select")."</a>&nbsp;\n";
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
