<?php
/*
promotion.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/promo.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(3);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('startdate');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Promotion Administration"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Promotion Administration");
}

if($_SESSION["pageindex"]->CheckNum(product_promotion_qry1, "promotion")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}
$NoNavigationFlag=true;
include("../templates/pheader.php");
   
switch($_REQUEST['action']){
	case "clear" :
		addPromotion();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browsePromotion($id);
         break;
      }
		browsePromotion($id);
		break;

	case "edit" :
		editPromotion($id);
		break;

	case "delete" :
		deletePromotion($id);
      $_SESSION["pageindex"]->deletion(CountNum());
		listPromotion($id);
		break;

	case "add" :
		insertPromotion();
      $_SESSION["pageindex"]->addition(CountNum());
		listPromotion($id);
		break;

	case "commit" :
		commitPromotion($id, $_POST);
		listPromotion($id);
		break;

	case "list":
	default :
		listPromotion();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(product_promotion_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"] = "";
   $frm["promotionid"] = "";
   $frm["typeid"] = "";
   $frm["name"] = "";
   $frm["startdate"] = "";
   $frm["enddate"]= "";
   $frm["targetid"] = "";
   $frm["promolinkid"] = "";
   
   /*
   $result=db_query("SELECT NOW()");
	$row = $result->FetchRow();
   $frm["startdate"]=$row[0];
   $frm["enddate"]=$row[0];
   */
   return $frm;
}

function fillform($id, $bOffset)
{
   
   if($bOffset){
      $qry=sprintf(product_promotion_qry2, $id);
   }
   else{
      $qry=sprintf(product_promotion_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["id"] = $row["id"];
   $frm["promotionid"] = $row["promotionid"];
   $frm["typeid"] = $row["typeid"];
   $frm["name"] = $row["name"];
   $frm["startdate"] = $row["startdate"];
   $frm["enddate"] = $row["enddate"];
   $frm["targetid"] = $row["targetid"];
   $frm["promolinkid"] = $row["promolinkid"];
   
   /*
   if($frm["targetID"]!=0){
      $result=db_query("SELECT count(*) FROM productcollection WHERE prodcollID = '$frm[targetID]'");
      $row = $result->FetchRow());
      $frm["numproduct"]=$row[0];
   }
   else{
      $frm["numproduct"]=0;
   }
   */
   return $frm;
}

function addPromotion()
{
   $frm=clearform();
	$frm["newaction"] = "add";

	include("templates/promotion.php");
}

function editPromotion($id) 
{
   $frm=fillform($id,false);
	$frm["newaction"] = "commit";
	include("templates/promotion.php");
}

function browsePromotion($id) 
{
   $frm=fillform($id, true);
   $frm["newaction"] = "browse";
	include("templates/promotion.php");
}

function deletePromotion($id) 
{
   db_query("delete from promotion where id='$id'"); 
}

function insertPromotion($id, $frm) 
{
	$qid = db_query("insert into promotion values ('',
   '$frm[promotionid]',
   '$frm[type]',
   '$frm[startdate]',
   '$frm[enddate]',
   '$frm[margin]',
   '$frm[memo]',
   '$frm[promolinkid]')");
}

function commitPromotion($id, $frm) 
{
   $qid = db_query("update promotion set
   promotionid='$frm[promotionid]',
   type='$frm[type]',
   startdate=$frm[startdate]',
   enddate='$frm[enddate]',
   margin='$frm[margin]',
   meo='$frm[memo]',
   promolinkid='$frm[promolinkid]
   where id='$id'");
}

function PromoProducts($a, $t, $v)
{
   if($a=="commit" || $a=="add"){
      switch($t){
      case BHPROMOTION_TYPE_PRODUCT:
      case BHPROMOTION_TYPE_FREE:
         break;
      case BHPROMOTION_TYPE_DISCOUNT:
         $c=new Discount;
         $c->TypeCombo($a, $v, "targetid");
         break;
      case BHPROMOTION_TYPE_MARGIN:
      case BHPROMOTION_TYPE_CATALOGUE:
         break;
      case BHPROMOTION_TYPE_COLLECTION:
         $c=new Collection;
         $c->Combo($a, $v, "targetid");
         break;
      }
   }
   else{
   }
}

function CollectionCombo($a, $t, $v)
{
   $c=new Collection;
   $c->Combo($a, $v, "targetid");
}

function DateCombo($a, $n, $v)
{
   $td=new TimeDate();
   $td->displayex('date', $a, $n, $v);
}

function TypeCombo($a, $id, $bFilter=false)
{
   if($a=="commit" || $a=="add"){
      if($bFilter){
         echo "<select name=\"typeid\" onChange=\"this.form.submit();\">\n";
      }
      else{
         echo "<select name=\"typeid\">\n";
      }

      if($id==0){
         echo "<option value='0' selected>"._("Not Set")."</option>\n";
      }
      else{
         echo "<option value='0'>"._("Not Set")."</option>\n";
      }

      if($id==BHPROMOTION_TYPE_PRODUCT){
         echo "<option selected value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
      }
      else if($id==BHPROMOTION_TYPE_FREE){
         echo "<option value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
         echo "<option selected value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
      }
      else if($id==BHPROMOTION_TYPE_DISCOUNT){
         echo "<option value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
         echo "<option selected value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
      }
      else if($id==BHPROMOTION_TYPE_MARGIN){
         echo "<option value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
         echo "<option selected value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
      }
      else if($id==BHPROMOTION_TYPE_CATALOGUE){
         echo "<option value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
         echo "<option selected value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
      }
      else if($id==BHPROMOTION_TYPE_COLLECTION){
         echo "<option value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
         echo "<option selected value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
      }
      else if($id==0){
         echo "<option value=\"".BHPROMOTION_TYPE_PRODUCT."\">"._("Product")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_FREE."\">"._("Free Item")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_DISCOUNT."\">"._("Discount")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_MARGIN."\">"._("Margin")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_CATALOGUE."\">"._("Catalogue")."</option>\n";
         echo "<option value=\"".BHPROMOTION_TYPE_COLLECTION."\">"._("Collection")."</option>\n";
      }
      echo "</select>\n";
   }
   else{
      if($id==BHPROMOTION_TYPE_PRODUCT){
         echo _("Product");
      }
      else if($id==BHPROMOTION_TYPE_FREE){
         echo _("Free Item");
      }
      else if($id==BHPROMOTION_TYPE_DISCOUNT){
         echo _("Discount");
      }
      else if($id==BHPROMOTION_TYPE_MARGIN){
         echo _("Margin");
      }
      else if($id==BHPROMOTION_TYPE_CATALOGUE{
         echo _("Catalogue");
      }
      else if($id==BHPROMOTION_TYPE_COLLECTION{
         echo _("Collection");
      }
   }
}

function listPromotion()
{  
	$sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(product_promotion_qry8, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no promotions defined")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no promotions defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='startdate'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Starts")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Starts")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=startdate\">"._("Starts")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='startdate'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='enddate'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Ends")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Ends")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=enddate\">"._("Ends")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='enddate'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='typeid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Type")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Type")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=typeid\">"._("Type")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='typeid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   while($row = $result->FetchRow()){
      //$qry=sprintf(product_promotion_qry9, $row["promotionid"]);
      //$presult=$_SESSION['VxCFG']->dbh->Execute($qry);
      //$prow = $presult->FetchRow();
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">".$row["startdate"]."</td>";
         echo "<td class=\"listdata\">".$row["enddate"]."</td>";
         echo "<td class=\"listdata\">".$row["name"]."</td>";
         echo "<td class=\"listdata\">";
         TypeCombo("browse", $row['typeid']);
         /*
         if($row['productid']==0){
            echo _("Not Set");
         }
         else{
            $qry=sprintf(product_promotion_qry8, $row["productid"]);
            $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
            $prow = $result->FetchRow();
            echo $prow["name"];
         }*/
         echo "</td><td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row["startdate"]."</td>";
         echo "<td class=\"listdataeven\">".$row["enddate"]."</td>";
         echo "<td class=\"listdataeven\">".$row["name"]."</td>";
         echo "<td class=\"listdataeven\">";
         TypeCombo("browse", $row['typeid']);
         /*
         if($row['productid']==0){
            echo _("Not Set");
         }
         else{
            $qry=sprintf(product_promotion, $row["productid"]);
            $presult=$_SESSION['VxCFG']->dbh->Execute($qry);
            $prow = $result->FetchRow();
            echo $prow["name"];
         }*/
         echo "</td><td class=\"listdataeven\">";
      }
      $wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"promotion.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"promotion.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"promotion.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
        echo "<a href=\"promotion.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"promotion.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
          echo "<a href=\"promotion.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
  }
  echo "</table>";
}

?>
