<?php
/*
sellpq.php

Copyright (C)2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/currency.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if($_SESSION['vxmisuser']->GetFocusType()!=FOCUSIDTYPE_PRODUCT){
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("Select a product.")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(isset($_REQUEST['paction'])){
   if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_PRODUCT){
      $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
   }
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_PRODUCT){
         $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
         $action=$_SESSION['vxmisuser']->GetFocusAction();
      }
      else{
         $action='list';
      }
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Sell Price Quantity"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Sell Price Quantity");
}

if($_SESSION["pageindex"]->CheckNum(product_sellpq_qry1, "prodpricequantity")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}
$NoNavigationFlag=true;
include($_SESSION['VxCFG']->styledir."/header.php");

$nid=0;
$bnid=0;

if(isset($_REQUEST['nameid'])){
   $nid=$_REQUEST['nameid'];
   $bnid=$_REQUEST['bqid'];
}
if(isset($_REQUEST['bnameid'])){
   $bnid=$_REQUEST['bnameid'];
   $nid=$_REQUEST['sqid'];
}
if(isset($_REQUEST['baction'])){
   $action=$_REQUEST['baction'];
   if($action=='commit') $action='edit';
}
if(isset($_REQUEST['saction'])){
   $action=$_REQUEST['saction'];
   if($action=='commit') $action='edit';
}


switch($action){
	case "clear" :
		addSellPrice();
		break;

	case "browse":
		browseSellPrice($_SESSION['vxmisuser']->GetFocusID(), $nid, $bnid);
		break;

	case "edit" :
      if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_PRODUCT){
         editSellPrice($_SESSION['vxmisuser']->GetFocusID(), $nid, $bnid);
      }
      else{
         editSellPrice($_REQUEST['id'], $nid, $bnid);
      }
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelSellPrice($_REQUEST['id']);
      }
      else{
         deleteSellPrice($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listSellPrice();
      }
      break;  
	
   case "cfmdelete" :
      deleteSellPrice($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listSellPrice();
		break;

	case "add" :
		insertSellPrice($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		listSellPrice();
		break;

	case "commit" :
		commitSellPrice($_POST);
		browseSellPrice($_POST['id']);
		break;

	case "all" :
		allSellPrice();
		break;

	case "commitall":
		allSellPriceCommit($_POST);
		break;

	case "list":
	default :
		listSellPrice();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(productm_sellpq_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"]="";
   $frm["pqid"]="";
   $frm["nameid"]="";
   $frm["quantity"]="";
   $frm["quantitytypeid"]="";
   $frm["udv"]="";
   $frm["price"]="";
   $frm["basecurrencyid"]="";
   $frm["taxid"]="";
   
   $frm["buypriceqtyid"]="";
   $frm["supplierid"]="";
   $frm["suppliercode"]="";
   $frm["bnameid"]="";
   $frm["bprice"]="";
   $frm["budv"]="";
   $frm["bquantity"]="";
   $frm["bquantitytypeid"]="";
   $frm["btaxid"]="";
   $frm["bbasecurrencyid"]="";
   
   return $frm;
}

function fillform($id, $bOffset, $nid, $bnid)
{
   $qry=sprintf(product_sellpq_qry17, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
	
   $frm["name"]=$row["name"];
   
   if($nid==0){
      $qry=sprintf(product_sellpq_qry3, $row['sellquantityid']);
   }
   else{
      $qry=sprintf(product_sellpq_qry18, $row['sellquantityid'], $nid);
   }

   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   
   $frm["id"]=$row["id"];
   $frm["pqid"]=$row["pqid"];
   $frm["nameid"]=$row["nameid"];
   $frm["quantity"]=$row["quantity"];
   $frm["quantitytypeid"]=$row["quantitytypeid"];
   $frm["udv"]=$row["udv"];
   $frm["price"]=$row["price"];
   $frm["basecurrencyid"]=$row["basecurrencyid"];
   $frm["taxid"]=$row["taxid"];
   
   if($bnid==0){
      $qry=sprintf(product_invpq_qry9, $frm["id"]);
   }
   else{
      $qry=sprintf(product_invpq_qry10, $frm["id"], $bnid);
   }
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result){
      $row = $result->FetchRow();
      $frm["buypriceqtyid"]=$row['id'];
      $frm["supplierid"]=$row['supplierid'];
      $frm["suppliercode"]=$row['suppliercode'];
      $frm["bnameid"]=$row['nameid'];
      $frm["bprice"]=$row['price'];
      $frm["budv"]=$row['udv'];
      $frm["bquantity"]=$row['quantity'];
      $frm["bquantitytypeid"]=$row['quantitytypeid'];
      $frm["btaxid"]=$row['taxid'];
      $frm["bbasecurrencyid"]=$row['basecurrencyid'];
   }
  
   return $frm;
}

function addSellPrice()
{
   $frm=clearform();
	$frm["newaction"] = "add";
	$frm["id"] = 0;

	include("templates/sellpq.php");
}

function editSellPrice($id, $nid, $bnid) 
{
   $frm=fillform($id, false, $nid, $bnid);
	$frm["newaction"] = "commit";
   $_REQUEST['action'] = "commit";
	include("templates/sellpq.php");
}

function browseSellPrice($id, $nid, $bnid) 
{
   $frm=fillform($id, true, $nid, $bnid);
   $frm["newaction"] = "browse";
	
	include("templates/sellpq.php");
}

function chkdelSellPrice($id) 
{
   $frm=fillform($id, false);
   $frm["newaction"] = "cfmdelete";
   
   include("templates/sellpq.php");
}


function deleteSellPrice($id) 
{
   $qry=srpintf(product_sellpq_qry6, $id);
   db_query($qry);
}

function insertSellPrice($frm) 
{
   $qry=sprintf(product_sellpq_qry4,$frm['pqid'],$frm['nameid'],$frm['quantity'],$frm['quantitytypeid'],$frm['udv'],
   $frm['price'],$frm['basecurrencyid'],$frm['taxid']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitSellPrice($frm) 
{
   $qry=sprintf(product_sellpq_qry5,$frm['pqid'],$frm['nameid'],$frm['quantity'],$frm['quantitytypeid'],$frm['udv'],
   $frm['price'],$frm['basecurrencyid'],$frm['taxid'],$frm['id']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}
/*
function fillDependantProducts($id)
{
   $qry=sprintf(product_sellpq_qry8,$id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $ret=db_num_rows($result);
   print "<tr><td colspan=\"2\" class=\"formdata\"><h4>Dependant Products - $ret items</h4></td></tr>\n";
   while($r = $result->FetchRow()){
      print "<tr><td colspan=\"2\" class=\"formdata\"><a href=\"product.php?action=browse&id=$r[0]\">$r[1] - $r[2]</a></td></tr>\n";
   }
}
*/
function allSellPrice()
{
	$frm["newaction"] = "commitall";
	include("templates/spall.php");	
}

function allSellPriceCommit($frm)
{
	$p=$frm["value"];

	if($p < 0){
		$p=abs($p);
		echo "<br><br><center><i><h3>All sales prices have been reduced by $p%</h3></i></center>";
	}
	else{
		echo "<br><br><center><i><h3>All sales prices have been increased by $p%</h3></i></center>";
	}
   $n=$p/100;
   echo "p change $n";
   $qry=sprintf(product_sellpq_qry9,$n);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function CurrencyCombo($action, $id)
{
   $a=new Currency();
   $a->Combo($action, $id, "basecurrencyid");
}

function PriceNameCombo($a, $id, $bid)
{
   if($a=="commit" || $a=="add"){
      echo "<form name=\"snav\" method=\"POST\" action=\"".$_SERVER['PHP_SELF']."\">\n";
      echo "<input type=\"hidden\" name=\"saction\" value=\"".$a."\">\n";
      echo "<input type=\"hidden\" name=\"bqid\" value=\"".$bid."\">\n";
      echo "<input type=\"hidden\" name=\"sqid\" value=\"".$id."\">\n";
   	echo "<legend>\n<select name=\"nameid\" onChange=\"this.form.submit();\">\n";
      if($id==0){
   	   print "<option value='0' selected>Not Set</option>\n";
      }
      else{
         print "<option value='0'>Not Set</option>\n";
      }
      $result=$_SESSION['VxCFG']->dbh->Execute(productm_sellpq_qry11);
	
      while($row = $result->FetchRow()){
   		if($id==$row["id"]){
	   		print "<option selected value=\"".$row["id"]."\">".$row["name"]."</option>\n";
		   }
   		else{
	   		print "<option value=\"".$row["id"]."\">".$row["name"]."</option>\n";
		   }
   	}
	   print "</select>\n</legend>\n</form>\n";
   }
   else{
      $qry=sprintf(product_sellpq_qry12, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo "<legend>\n".$row[0]. "</legend>\n";
      }
      else{
         echo "<legend>\n". _("Not Set"). "</legend>\n";
      }
   }
}

function BuyPriceNameCombo($a, $id, $sid)
{
   if($a=="commit" || $a=="add"){
      echo "<form name=\"bnav\" method=\"POST\" action=\"".$_SERVER['PHP_SELF']."\">\n";
      echo "<input type=\"hidden\" name=\"baction\" value=\"".$a."\">\n";
      echo "<input type=\"hidden\" name=\"bqid\" value=\"".$id."\">\n";
      echo "<input type=\"hidden\" name=\"sqid\" value=\"".$sid."\">\n";
   	echo "<legend>\n<select name=\"bnameid\" onChange=\"this.form.submit();\">\n";
      if($id==0){
   	   print "<option value='0' selected>Not Set</option>\n";
      }
      else{
         print "<option value='0'>Not Set</option>\n";
      }
      $result=$_SESSION['VxCFG']->dbh->Execute(product_bpqname_qry7);
	
      while($row = $result->FetchRow()){
   		if($id==$row["id"]){
	   		print "<option selected value=\"".$row["id"]."\">".$row["name"]."</option>\n";
		   }
   		else{
	   		print "<option value=\"".$row["id"]."\">".$row["name"]."</option>\n";
		   }
   	}
	   print "</select>\n</legend>\n</form>\n";
   }
   else{
      $qry=sprintf(product_bpqname_qry3, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo "<legend>\n".$row['name']. "</legend>\n";
      }
      else{
         echo "<legend>\n". _("Not Set"). "</legend>\n";
      }
   }
}

function fillQTCombo($a,$id)
{
	if($a=="commit" || $a=="add"){
		print "<select name=\"quantitytypeid\">\n";
	   $result=$_SESSION['VxCFG']->dbh->Execute(product_sellpq_qry13);
	
		while($row = $result->FetchRow()){
			$boo=$row["id"];
			$poo=$row["name"];
		
			if($id==$boo){
				print "<option selected value=\"$boo\"> $poo </option>\n";
			}
			else{
				print "<option value=\"$boo\"> $poo </option>\n";
			}
		}
		print "</select>\n";
	}
	else{
      $qry=sprintf(product_sellpq_qry14, $id);
		$result=$_SESSION['VxCFG']->dbh->Execute($qry);
		if($row = $result->FetchRow()){
			echo $row["name"];
		}
      else{
         echo "Not Set";
      }
	}
}

function TaxCombo($a, $id)
{
	if($a=="commit" || $a=="add"){
		$result=$_SESSION['VxCFG']->dbh->Execute(product_sellpq_qry15);
		print "<select name=\"taxid\">\n";

		while($row = $result->FetchRow()){
			$boo=$row["id"];
			$poo=$row["accountid"];
         $rate=$row["rate"] * 100;
		
         $q=sprintf(product_sellpq_qry16, $poo);
			$aresult=$_SESSION['VxCFG']->dbh->Execute($q);
			$arow=$aresult->FetchRow();
         if($arow["name"]==""){
			   $n=$rate."%";
         }
         else{
            $n=$arow["name"]." - ".$rate."%";
         }
			if($id==$boo){
				print "<option selected value=\"$boo\"> $n </option>\n";
			}
			else{
				print "<option value=\"$boo\"> $n </option>\n";
			}
		}
		print "</select>\n";
	}
	else{
      $q=sprintf(product_sellpq_qry15, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($q);
		if($row = $result->FetchRow()){
			$poo=$row["accountid"];
         $rate=$row["rate"] * 100;
			$q=sprintf(product_sellpq_qry16, $poo);
			$aresult=$_SESSION['VxCFG']->dbh->Execute($q);
         $arow = $aresult->FetchRow();
         if($arow["name"]==""){
			   $n=$rate."%";
         }
         else{
            $n=$arow["name"]." - ".$rate."%";
         }
			echo "$n";
		}
	}
}

function SupplierCombo($a, $id)
{
   if($a=="commit" || $a=="add"){
		echo "<select name=\"supplierid\">\n";
      if($id==0)
         echo "<option selected value=\"0\">". _("None Set") ."</option>\n";
      else
         echo "<option value=\"0\">". _("None Set") ."</option>\n";
      
	   $result=$_SESSION['VxCFG']->dbh->Execute(product_product_qry30);
      while($row = $result->FetchRow()){
         if($id==$row['id']){
				echo "<option selected value=\"".$row['id']."\"> ".$row['name']." </option>\n";
			}
			else{
				echo "<option value=\"".$row['id']."\"> ".$row['name']." </option>\n";
			}
      }
      echo "</select>\n";
   }
   else{
      $qry=sprintf(product_product_qry41, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      echo $row['name'];
   }
}

function listSellPrice()
{
	$sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   $pid=$_SESSION['vxmisuser']->GetFocusID();
   
   $qry=sprintf(product_sellpq_qry10, $pid, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no price quantity items defined.")."</td></td></table>\n";
      exit;
   }
   
	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Quantity")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Quantity")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=quantity\">"._("Quantity")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='udv'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Pack Size")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Pack Size")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=udv\">"._("Pack Size")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='udv'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='price'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Price")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Price")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=price\">"._("Price")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='price'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }

	echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";

	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
		   echo "<tr class=\"listdata\">\n<td class=\"listdata\">".$row['quantity']."</td>\n";
         echo "<td class=\"listdata\">".$row['udv']."</td>\n";
         echo "<td class=\"listdata\">".$row['price']."</td>\n";
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\">\n<td class=\"listdataeven\">".$row['quantity']."</td>\n";
         echo "<td class=\"listdataeven\">".$row['udv']."</td>\n";
         echo "<td class=\"listdataeven\">".$row['price']."</td>\n";
         echo "<td class=\"listdataeven\">";
      }
      $wibbler=$row['id'];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"sellpq.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"sellpq.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"sellpq.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"sellpq.php?action=browse&id=$wibbler&offset=$offset\">".misc_listview."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"sellpq.php?action=edit&id=$wibbler&offset=$offset\">".misc_listedit."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"sellpq.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
