<?php
/*
purchase.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/purchase.php");
require_once($_SESSION['VxCFG']->libdir."/supplier.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()=='' || $_SESSION['vxmisuser']->GetSortOn()!='name'){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Purchase Order"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Purchase Order");
}

if($_SESSION["pageindex"]->CheckNum(purchase_puchase_qry1, "purchaseorder")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
     break;
   case 'pageprev':
     $_SESSION["pageindex"]->pgprev();
     break;
   case 'prev':
     $_SESSION["pageindex"]->prev();
     break;
   case 'next':
     $_SESSION["pageindex"]->next();
     break;
   case 'pagenext':
     $_SESSION["pageindex"]->pgnext();
     break;
   case 'end':
      if($_REQUEST['action']=="list")
        $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
     break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
   case "clear" :
      addPurchase();
      break;

   case "browse":
      if(isset($_REQUEST['id'])){
         browsePurchase($_REQUEST['id']);
         break;
      }
      browsePurchase($_REQUEST['id']);
      break;

   case "edit" :
      editPurchase($_REQUEST['id']);
      break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelPurchase($_REQUEST['id']);
      }
      else{
         deletePurchase($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listPurchase();
      }
    break;

   case "cfmdelete" :
      deletePurchase($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listPurchase();
      break;

   case "add" :
      insertPurchase($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listPurchase();
    break;

   case "commit" :
      commitPurchase($_POST);
      listPurchase();
      break;

   case "search" :
      searchPurchase();
      break;
   
   case "sresults" :
      searchResults($_POST);
      break;
      
   case "list":
   default :
      listPurchase($_REQUEST);
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(purchase_puchase_qry1);
   if(!$result) return 0;
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = "";
   $frm["purchaseorderid"] = "";
   $frm["purchasenumber"] = "";
   $frm["statusid"] = "0";
   $frm["name"] = "";
   $frm["cmid"] = "";
   $frm["placeddate"] = "";
   $frm["dispatchdate"] = "";
   $frm["arriveddate"] = "";
   $frm["supplierid"] = "";
   $frm["shippingid"] = "";
   $frm["requestedby"] = "";
   $frm["approvedby"] = "";
   $frm["accountid"] = "";
   $frm["transactionid"] = "";
   $frm["linkid"] = "";
   
   $frm["supplierid"]=0;
	$frm["suppliername"]="";
   $frm["supplieraddr1"]="";
   $frm["supplieraddr2"]="";
   $frm["supplieraddr3"]="";
   $frm["suppliercity"]="";
   $frm["supplierstate"]="";
   $frm["supplierzip"]="";
   $frm["suppliercountry"]="";
   
   $frm["delivertoid"]=0;
   $frm["delivertoname"]="";
   $frm["delivertoaddr1"]="";
   $frm["delivertoaddr2"]="";
   $frm["delivertoaddr3"]="";
   $frm["delivertocity"]="";
   $frm["delivertostate"]="";
   $frm["delivertozip"]="";
   $frm["delivertocountry"]="";
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(purchase_purchase_qry2, $id);
   }
   else{
      $qry=sprintf(purchase_purchase_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
	
	$frm["id"]=$row["id"];
   $frm["purchaseorderid"] = $row["purchaseorderid"];
   $frm["purchasenumber"] = $row["purchasenumber"];
   $frm["statusid"] = $row["statusid"];
   $frm["name"] = $row["name"];
   $frm["cmid"] = $row["cmid"];
   $frm["placeddate"] = $row["placeddate"];
   $frm["dispatchdate"] = $row["dispatchdate"];
   $frm["arriveddate"] = $row["arriveddate"];
   $frm["supplierid"] = $row["supplierid"];
   $frm["shippingid"] = $row["shippingid"];
   $frm["requestedby"] = $row["requestedby"];
   $frm["approvedby"] = $row["approvedby"];
   $frm["accountid"] = $row["accountid"];
   $frm["transactionid"] = $row["transactionid"];
   $frm["linkid"] = $row["linkid"];

	return $frm;
}

function addPurchase()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	
	include("templates/purchase.php");

	exit;
}

function supplierSelect()
{
	$frm=clearForm();
	$frm["newaction"] = "clear";
	
	include("templates/purchase.php");

	exit;
}

function editPurchase($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
		
	include("templates/purchase.php");

}

function browsePurchase($id) 
{
   $result=db_query(purchase_purchase_qry1);
	$row = $result->FetchRow();
   if($row[0]==0){
      include("templates/purchnone.php");
      exit;
   }

	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
		
	include("templates/purchase.php");
}

function deletePurchase($id) 
{
   $qry=sprintf(purchase_purchase_qry5, $id);
	db_query($qry);
	
	include("templates/purchdel.php");
}

function insertPurchase($frm) 
{
	//$qid = db_query("INSERT INTO purchaseorder VALUES ('', '$fn','$ln','$pid','$lc')");
}

function commitPurchase($id, $frm) 
{

}

function PurchaseDetails($a, $id)
{
   $po=new PurchaseOrder($id);
   $po->SetSupplierID(2);
   $po->Table($a, $id, "Purchase Order", true);
}

function itemAdd($frm)
{
   $id=$frm['id'];
   if(isset($id)){
      $po=new PurchaseOrder($id);
   }
   else{
      $po=new PurchaseOrder();
      $po->SetFromForm($frm);
      $id=$po->Add();
   }
   
   $poitem=new POItem();
   $poitem->Set($id, $frm['itemqty'], $frm['iteminvid'], 0);
   
   if($po->ItemExists($poitem)){
      // inc quantity
      $poitem->SetQuantity($poitem->GetQuantity() + $frm['itemqty']);
      $poitem->Commit();
   }
   else{
      $poitem->Add();
   }
}
/*
function createOrder()
{
	global $_SESSION;
	$eid=$_SESSION["user"]["employeeid"];
	$sid=$_SESSION["purchaseorder"]->GetSupplier();
	db_query("INSERT INTO createmod VALUES ('',CURDATE(),CURDATE(),'$eid','$eid')");

	db_query("INSERT INTO purchaseorder VALUES ('',
      '0',
      '0',
      '2',
		'No Name',
		LAST_INSERT_ID(),
		'0000-00-00',
		'0000-00-00',
		'$sid',
      '0',
		'$eid',
		'0','0','0','0')");

	$pid= db_insert_id();
	db_query("UPDATE purchaseorder SET purchaseorderID = '$pid'");
	$_SESSION["purchaseorder"]->fillpitems($pid);

	echo "<br><br><center><h3>Purchase Order has been placed - awaiting approval</h3></center>";
}

function approvalPurchase()
{
	$result=db_query("SELECT * from purchaseorder WHERE statusid='2'");
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Created On</h3></td><td><h3>Created By</h3></td><td><h3>Supplier</h3><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$pid=$row["id"];
		$wibbler=$row["supplierid"];
		$cmid=$row["cmid"];
		$sresult=db_query("SELECT name from supplier WHERE id='$wibbler'");
		$srow = $sresult->FetchRow();
		$sname=$srow["name"];
		db_free_result($sresult); 
		
		$sresult=db_query("Select creationdate, createdby from createmod where id='$cmid'");
		$srow = $sresult->FetchRow();
		$cdate=$srow["CreationDate"];
		$cwho=$srow["CreatedBy"];
		db_free_result($sresult);

		$sresult=db_query("SELECT fname, lname from employee WHERE id='$cwho'");
		$srow = $sresult->FetchRow();
		$who=$srow["fname"]." ".$srow["lname"] ;

		db_free_result($sresult);

		print "<tr><td>$cdate</td><td>$who</td><td>$sname</td><td>\n";
		print "<a href=\"purchase.php?action=approvecommit&id=$pid\">approve</a>&nbsp;\n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";

   exit;
}

function approvalCommmit($id)
{
	$eid=$_SESSION["user"]["employeeid"];
	db_query("update purchaseorder set approvedby ='$eid', statusid='3' where id='$id'");
	echo "<br><br><center><h3>Purchase Approved - Awaiting Dispatch</h3></center>";
	exit;
}

function dispatchPurchase()
{
	$result=db_query("SELECT * from purchaseorder WHERE statusid='3'");
	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Created On</h3></td><td><h3>Created By</h3></td><td><h3>Supplier</h3><td><h3>Action</h3></td></tr>";
	while($row = $result->FetchRow()){
		$pid=$row["ID"];
		$wibbler=$row["supplierID"];
		$cmid=$row["cmID"];
		$sresult=db_query("select name from supplier where id='$wibbler'");
		$srow = $sresult->FetchRow();
		$sname=$srow["name"];
		db_free_result($sresult); 
		
		$sresult=db_query("select creationdate, createdby from createmod where id='$cmid'");
		$srow = $sresult->FetchRow();
		$cdate=$srow["CreationDate"];
		$cwho=$srow["CreatedBy"];
		db_free_result($sresult);

		$sresult=db_query("select fname, lname from employee where id='$cwho'");
		$srow = $sresult->FetchRow();
		$who=$srow["fname"]." ".$srow["lname"] ;

		db_free_result($sresult);

		print "<tr><td>$cdate</td><td>$who</td><td>$sname</td><td>\n";
		print "<a href=\"purchase.php?action=dispatchcommit&id=$pid\">dispatch</a>&nbsp;\n";
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";

   exit;
}

function dispatchCommit($id)
{
	db_query("update purchaseorder set statusid='4' where id='$id'");
	db_query("update purchaseorder set dispatchdate=CURDATE() WHERE ID='$id'");
   $qry=sprintf(porderitem_qry9, $id);
   $result=db_query($qry);
   while($row = $result->FetchRow()){
      $qry=sprintf(porderitem_qry10, $row['Quantity'], $row['InventoryID']);
      db_query($qry);
   }
	echo "<br><br><center><h3>Order Dispatched - awaiting Goods In<br><br><br>Need to fill in print form code here...</h3></center>";
	exit;
}
*/
function itemList($a, $id)
{
   if($a=='add'){
      
   }
   else{
      $poitem=new POItems($id, false);
	   if(isset($poitem)){
		   $poitem->buildItemList($a, "Purchase Order");
	   }
	   else{
		   echo "no purchase order class instansiated...";
	   }
   }
}

function SupplierSelection($a, $sid)
{
   $s=new Supplier($sid);
   $s->Combo($a, "supplierid", $sid);
}

function StatusFormCombo($a, $id)
{
   echo "<select onChange=\"this.form.submit();\" name=\"statusfilter\">\n";
   if($id=='All'){
      echo "<option selected value='All'>All</option>\n";
   }
   else{
      echo "<option value='All'>All</option>\n";
   }
   $qry=sprintf(purchase_purchase_qry21);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   while($row = $result->FetchRow()){
      if($row["id"]==$id){
         echo "<option selected value=\"".$row["id"]."\">".$row["name"]."</option>\n";
      }
      else{
         echo "<option value=\"".$row["id"]."\">".$row["name"]."</option>\n";
      }
   }
   echo "</select>\n";
}

function OrderItems($orderid)
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();

   echo "<table class=\"listtable\">\n";
   $qry=sprintf(order_approval_qry6, $orderid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      return;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      return;
   }
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='partnumber'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Part No")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Part No")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=partnumber\">"._("Part No")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='parnumber'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='stocklocation'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Location")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Location")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=stocklocation\">"._("Location")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='stocklocation'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='description'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Description")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Description")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=description\">"._("Description")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='description'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \">"._("Quantity")."</td>\n";
   echo "</tr>\n";
   
   while($row = $result->FetchRow()){
      $qry=sprintf(warehouse_stockpick_qry7, $row['productid']);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$res) continue;
      if($res->RecordCount()==0) continue;
      if(!($r = $res->FetchRow())) continue;
      echo "<tr><td class=\"listdata\">";
      if(isset($r["partnumber"])){
         echo $r["partnumber"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n<td class=\"listdata\">";
      if(isset($r["stocklocation"]) && $r["stocklocation"]!=''){
         echo $r["stocklocation"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n";
      
      echo "<td class=\"listdata\">".$r["description"]."</td>\n";
      echo "<td class=\"listdata\">".$row["quantity"]."</td>\n";
      echo "</tr>\n";
   }
   echo "</table>\n";
}

function listOrder($frm)
{
   if(isset($frm['statusfilter'])) $statusfilter=$frm['statusfilter'];
   else $statusfilter='All';
   
   $result=$_SESSION['VxCFG']->dbh->Execute(purchase_purchase_qry19);
   $row=$result->FetchRow();
   $current_date=$row[0];
      
   if(isset($frm['periodid'])){
      $qry=sprintf(purchase_purchase_qry20, $_POST['periodid']);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row=$result->FetchRow();
      $period_start=substr($current_date,0,5) . substr($row['start'],5,10);
      $period_end=substr($current_date,0,5) . substr($row['end'],5,10);
      $period=$_REQUEST['periodid'];
   }
   else{
      $qry=sprintf(purchase_purchase_qry20, 1);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row=$result->FetchRow();
      $period_start=substr($current_date,0,5) . substr($row['start'],5,10);
      $period_end=substr($current_date,0,5) . substr($row['end'],5,10);
      $period=1;
   }

   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   if($statusfilter=='All'){
      $qry=sprintf(purchase_purchase_qry17, $period_start, $period_end, $sorton, $sortorder);
   }
   else{
      $qry=sprintf(purchase_purchase_qry18, $statusfilter, $period_start, $period_end, $sorton, $sortorder);
   }
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<form action=\"".$_SERVER['PHP_SELF']."\" method=\"POST\">\n";
   $_REQUEST['action']="list";
   
   echo "<table class=\"listtable\">\n";
   echo "<tr>\n<td class=\"alphaselect\" colspan=\"5\">&nbsp;&nbsp;"._("Status Filter ");   
   StatusFormCombo("commit", $statusfilter);
   echo "&nbsp;&nbsp;". _("Period ");
   PeriodCombo("commit", $period, true);
   echo "</form>\n</td>\n</tr>\n";
   
   if(!$result){
      echo "<tr><td colspan=\"5\">"._("There are no purchase orders defined")."</td></td></table>\n";
      return;
   }
   
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"5\">"._("There are no purchase orders defined")."</td></td></table>\n";
      return;
   }
   
	echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='dateplaced'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Date")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Date")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=dateplaced\">"._("Date")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='dateplaced'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='ordernumber'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Order Number")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Order Number")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=ordernumber\">"._("Order Number")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='ordernumber'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='status'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Status")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Status")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=status\">"._("Status")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='status'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">".$row["placeddate"]."</td>\n";
         echo "<td class=\"listdata\">".$row["purchasenumber"]."</td>\n";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row["placeddate"]."</td>\n";
         echo "<td class=\"listdataeven\">".$row["purchasenumber"]."</td>\n";
      }
      $qry=sprintf(purchase_purchase_qry15, $row["supplierid"]);
		$res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();

      if($c%2){
         echo "<td class=\"listdata\">".$r["name"]."</td>\n";
      }
      else{
         echo "<td class=\"listdataeven\">".$r["name"]."</td>\n";
      }
      
      $qry=sprintf(order_order_qry15,$row["statusid"]);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      if($c%2){
         echo "<td class=\"listdata\">".$r["name"]."</td>\n";
      	echo "<td class=\"listdata\">";
      }
      else{
         echo "<td class=\"listdataeven\">".$r["name"]."</td>\n";
      	echo "<td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"purchase.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"purchase.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"purchase.php?action=delete&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"purchase.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"purchase.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"purchase.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
