<?php
/*
warning.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
require_once("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/timedate.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Warnings"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Warnings");
}

$_SESSION["pageindex"]->CheckNum("", "");

if(!isset($start_time)){
   $start_ts=& new TimeDate();
   $start_ts->midnight();
   $start_time=$start_ts->ansidate();
}

if(!isset($end_time)){
   $end_ts=& new TimeDate();
   $end_ts->last_second();
   $end_time=$end_ts->ansidate();
}

include($_SESSION['VxCFG']->styledir."/header.php");

$_SESSION['vxmisuser']->SetTab(0);
include("templates/warning.php");
include($_SESSION['VxCFG']->styledir."/footer.php");
   
exit();

function warning()
{
   $qry=sprintf(sod_warning_qry1);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result){
      if($result->RecordCount()==0){
	      echo "<tr><td colspan=\"2\" align=\"left\"><h4>"._("There are no outstanding warnings.")."</h4></td></tr>\n";
         return;
      }
   }
   while($row = $result->FetchRow()){
      echo "<tr><td class=\"listdata\">";
      switch($row[1]){
      case '1': echo _("PLU Cache Build"); break;
      case '2': echo _("Daily Database Backup"); break;
      case '3': echo _("Reconcile Stock"); break;
      case '4': echo _("Bank Run"); break;
      case '5': echo _("PO generation"); break;
      case '6': echo _("Stock Take"); break;
      case '7': echo _("Product Search Cache"); break;
      }
      echo "</td><td class=\"listdata\">$row[2]</td>\n";
   }
}

?>
