<?php
/*
cashdrawer.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/locale.php");
require_once($_SESSION['VxCFG']->libdir."/currency.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(2);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('unit');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}
if($_SESSION['vxmisuser']->GetFocusType()!=FOCUSIDTYPE_STATION){
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("Select a station.")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(isset($_REQUEST['paction'])){
   if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_STATION){
      $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
   }
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_STATION){
         $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
         //$action=$_SESSION['vxmisuser']->GetFocusAction();
         $action='list';
      }
      else{
         $action='list';
      }
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Cash Drawer"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Cash Drawer");
}

if($_SESSION["pageindex"]->CheckNum(stationm_cashdrawer_qry1, "monetaryunits")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

$NoNavigationFlag=true;
include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addCashDrawer();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseCashDrawer($id);
         break;
      }
		browseCashDrawer($_POST['id']);
		break;

	case "edit" :
		editCashDrawer($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelCashDrawer($_REQUEST['id']);
      }
      else{
         deleteCashDrawer($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listCashDrawer($_REQUEST['id']);
      }
		break;
      
   case "cfmdelete" :
      deleteCashDrawer($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listCashDrawer();
		break;

	case "add" :
		insertCashDrawer($_POST);
		break;

	case "commit" :
		commitCashDrawer($_POST);
		listCashDrawer();
		break;

	case "list":
	default :
		listCashDrawer($_REQUEST['id']);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
 function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(stationm_cashdrawer_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearform()
{
   $frm["id"] = 0;
   $frm["muid"] = "";
   $frm["unit"] = "";
   $frm["value"] = "";
   $frm["lowamount"] = "";
   $frm["highamount"] = "";
   $frm["defamount"] = "";
   $frm["defround"] = "";

   return $frm;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(stationm_cashdrawer_qry2, $id);
   }
   else{
      $qry=sprintf(stationm_cashdrawer_qry3, $id);
   }
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row=$result->FetchRow();
   $frm["id"] = $row['id'];
   $frm["muid"] = $row['muid'];
   $frm["unit"] = $row['unit'];
   $frm["value"] = $row['value'];
   $frm["lowamount"] = $row['lowamount'];
   $frm["highamount"] = $row['highamount'];
   $frm["defamount"] = $row['defamount'];
   $frm["defround"] = $row['defround'];
   
   return $frm;
}

function addCashDrawer()
{
   $frm=clearform();
	$frm["newaction"] = "add";
		
	include("templates/cashdrawer.php");
}

function editCashDrawer($id) 
{
   $frm=fillform($id, false);
	$frm["newaction"] = "commit";

	include("templates/cashdrawer.php");
}

function browseCashDrawer($id) 
{
	$frm=fillform($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/cashdrawer.php");
}

function chkdelCashDrawer($id)
{
	$frm=fillform($id, false);
	$frm["newaction"] = "cfmdelete";
	include("templates/cashdrawer.php");
}

function deleteCashDrawer($id) 
{
   $qry=sprintf(stationm_cashdrawer_qry6, $id);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function insertCashDrawer($frm) 
{
   $qry=sprintf(stationm_cashdrawer_qry4, $frm["name"],YN($frm["cashback"]),$frm["cashbacklimit"],YN($frm["bacceptable"]));
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitCashDrawer($frm) 
{
	$qry=sprintf(stationm_cashdrawer_qry5, $frm["name"],YN($frm["cashback"]),$frm["cashbacklimit"],YN($frm["bacceptable"]),$frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function listCashDrawer($id)
{
   $qry=sprintf(stationm_cashdrawer_qry8, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   
   $qry=sprintf(stationm_cashdrawer_qry9, $row[0]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(stationm_cashdrawer_qry11, $row[0], $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no cash drawers defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='unit'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Unit")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Unit")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=unit\">"._("Unit")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='unit'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='value'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Value")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Value")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=value\">"._("Value")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='value'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='defamount'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Quantity")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Quantity")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=defamount\">"._("Quantity")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='defamount'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='total'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Total")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Total")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=total\">"._("Total")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='total'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Round")."</td>\n";
   
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";

	$c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
		   echo "<tr class=\"listdata\">\n<td class=\"listdata\">".$row['unit']."</td>\n";
         echo "<td class=\"listdata\">".$row['value']."</td>\n";
         echo "<td class=\"listdata\">".$row['defamount']."</td>\n";
         $t=$row['value'] * $row['defamount'];
         echo "<td class=\"listdata\">".$t."</td>\n";
         if($row['defround']=='Y'){
            echo "<td class=\"listdata\">"._("Y")."</td>\n";
         }
         else{
            echo "<td class=\"listdata\">&nbsp;</td>\n";
         }
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\">\n<td class=\"listdataeven\">".$row['unit']."</td>\n";
         echo "<td class=\"listdataeven\">".$row['value']."</td>\n";
         echo "<td class=\"listdataeven\">".$row['defamount']."</td>\n";
         $t=$row['value'] * $row['defamount'];
         echo "<td class=\"listdataeven\">".$t."</td>\n";
         if($row['defround']=='Y'){
            echo "<td class=\"listdataeven\">"._("Y")."</td>\n";
         }
         else{
            echo "<td class=\"listdataeven\">&nbsp;</td>\n";
         }
         echo "<td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"cashdrawer.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"cashdrawer.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"cashdrawer.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"cashdrawer.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"cashdrawer.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"cashdrawer.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
