<?php
/*
user.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001 - 2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/user.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if($_SESSION['vxmisuser']->GetFocusType()!=FOCUSIDTYPE_STATION){
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("Select a station.")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(isset($_REQUEST['paction'])){
   //if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_STATION){
   //   $_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
   //}
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      if($_SESSION['vxmisuser']->GetFocusType()==FOCUSIDTYPE_STATION){
         //$_REQUEST['id']=$_SESSION['vxmisuser']->GetFocusID();
         //$action=$_SESSION['vxmisuser']->GetFocusAction();
         $action='list';
      }
      else{
         $action='list';
      }
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Station Users"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Station Users");
}

if($_SESSION["pageindex"]->CheckNum(user_user_qry1, "users")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
      if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

switch($action){
	case "clear" :
		clearUser();
		break;
		
	case "browse" :
      if(isset($_REQUEST['id'])){
         $id=$_SESSION["pageindex"]->browse($_REQUEST['id']);
         browseUser($id);
         break;
      }
      $id=updateNav($_POST);
		browseUser($id);
		break;

	case "edit" :
		editUser($_REQUEST['id']);
		break;

	case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelUser($_REQUEST['id']);
      }
      else{
         deleteUser($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listUser($_REQUEST['id']);
      }
		break;
      
   case "cfmdelete" :
      deleteUser($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listUser();
		break;

	case "add" :
		addUser($_POST);
      $_SESSION["pageindex"]->setnum(CountNum());
		listUser();
		break;

	case "commit" :
		userCommit($_POST);
		listUser();
		break;

	case "list" :
	default :
		listUser();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(user_user_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function fillform($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(user_user_qry2, $id);
   }
   else{
      $qry=sprintf(user_user_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm["id"] = $row["id"];
	$frm["login"] = $row["login"];
	$frm["password"] = $row["password"];
	$frm["userdata"] = $row["userdata"];
	$frm["profile"] = $row["profile"];
	$frm["logintypesid"] = $row["logintypesid"];
	$frm["employeeid"] = $row["employeeid"];
   
	$qry=sprintf(user_user_qry15, $row["employeeid"]);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
	$frm["employeenumber"] = $row["employeenumber"];
	$frm["groupid"] = $row["groupid"];
   
   $qry=sprintf(user_user_qry17, $row['contactid']);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
	$frm["fname"] = $row["firstname"];
	$frm["lname"] = $row["lastname"];
	
	$qry = sprintf(user_user_qry16, $frm["groupid"]);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
	$frm["groupname"]=$row["name"];

	return $frm;
}

function clearForm()
{
	$frm["id"] = "";
	$frm["login"] = "";
	$frm["password"] = "";
	$frm["userdata"] = "";
	$frm["profile"] = "";
	$frm["logintypesid"] = "";
	$frm["employeeid"] = "";

	$frm["fname"] = "";
	$frm["lname"] = "";
	$frm["enumber"] = "";
	$frm["groupid"] = "";
   $frm["groupname"] = "";

   return $frm;
}

function browseUser($id) 
{
	$frm = fillform($id, true);
   $NoNavigationFlag=true;
   include($_SESSION['VxCFG']->styledir."/header.php");
   flush();
	$frm["newaction"] = "browse";

	include("templates/user.php");
}

function editUser($id) 
{
	$frm = fillform($id, false);
   $NoNavigationFlag=true;
   include($_SESSION['VxCFG']->styledir."/header.php");
   flush();
	$frm["newaction"] = "commit";

	include("templates/user.php");
}

function clearUser() 
{
   $frm=clearForm();
   $NoNavigationFlag=true;
   include($_SESSION['VxCFG']->styledir."/header.php");
   flush();
   $frm["newaction"] = "add";

	include("templates/useradd.php");   
}

function deleteUser($frm) 
{
   //$qry=sprintf(user_user_qry7, $frm['id']);
   //$_SESSION['VxCFG']->dbh->Execute($qry);
}

function chkdelUser($id)
{
}

function userInsert($frm) 
{
   //$qry=sprintf(user_user_qry5, $frm['logintypesid'],$frm['login'],$frm['password'],$frm['userid'],
      //$frm['passivelogin'], $frm['userdata']);
   //$_SESSION['VxCFG']->dbh->Execute($query);
}

function chkaddUser($frm)
{
   /*
   $qry = sprintf(user_user_qry18, $frm['login']);
	$result = $_SESSION['VxCFG']->dbh->Execute($qry);
	$chkid = $result->FetchRow();
	if($chkid['id'] != ''){
	      return true;
	}
   else{
	      return false;
	}*/
}

function addUser($frm)
{
   /*
   if(chkaddUser($frm) == false){
      $query = sprintf(userm_user_qry5, $frm['logintypesid'],$frm['login'],$frm['password'],$frm['userid'],$frm['passivelogin'], $frm['userdata']);
	   $_SESSION['VxCFG']->dbh->Execute($query);
	}
   else{
	   print "User exists";
	}*/
}

function userCommit($frm) 
{
   /*
   $qry=sprintf(user_user_qry5, $frm['logintypesid'],$frm['login'],$frm['password'],$frm['userid'],
      $frm['passivelogin'], $frm['userdata'],$frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($query);
   */
}

function groupCombo($a, $id)
{
   if($a=='add' || $a=='commit'){
   }
   else{
      $qry = sprintf(user_user_qry16, $id);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	   $row = $result->FetchRow();
	   echo $row["name"];
   }
}

function empCombo($a, $id)
{
   if($a=='add'){
      $qry=sprintf(user_user_qry23);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      echo "<select name=\"employeeid\">\n";
   	while($row = $result->FetchRow()){
         $qry=sprintf(user_user_qry17, $row['contactid']);
   	   $res=$_SESSION['VxCFG']->dbh->Execute($qry);
         $r = $res->FetchRow();
         if($row['id']==$id){
            echo "<option value=\"".$row['id']."\" selected>".$r["firstname"]." ".$r["lastname"]."</option>\n";
         }
         else{
            echo "<option value=\"".$row['id']."\">".$r["firstname"]." ".$r["lastname"]."</option>\n";
         }
      }
   }
   else{
      $qry=sprintf(user_user_qry15, $id);
	   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   	$row = $result->FetchRow();
   
      $qry=sprintf(user_user_qry17, $row['contactid']);
   	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
      $row = $result->FetchRow();
      echo $row["firstname"]." ".$row["lastname"];
   }
}

function postControl($a, $id)
{
   $u=new User();
   $u->StationCombo($a, $id, "postid");
}

function ifControl($a, $id)
{
   $u=new User();
   $u->InterfaceCombo($a, $id, "interfaceid");
}

function liControl($a, $id)
{
   $u=new User();
   $u->LoginTypesCombo($a, $id, "logintypesid");
}

function userCombo()
{
   $qry=sprintf(user_user_qry26,$_SESSION['vxmisuser']->GetFocusID());
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result->RecordCount()==0){
      echo _("No users to add");
      return;
   }
   echo "<select name=\"userid\">\n";
   while($row = $result->FetchRow()){
      $qry=sprintf(user_user_qry20, $row['employeeid']);
      $nresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      $nrow = $nresult->FetchRow();
      
      $qry=sprintf(user_user_qry17, $nrow['contactid']);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      echo "<option value=\"".$row['id']."\">".$r["firstname"]." ".$r["lastname"]."</option>\n";
   }
   echo "</select>\n";
   
}

function PermTable($a, $id)
{
   $qry=sprintf(user_user_qry25, $_SESSION['vxmisuser']->GetFocusID(), $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   echo "<table class=\"listtable\">\n";
   $c=0;
   while($row = $result->FetchRow()){
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">".$row["name"]."</td>\n";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row["name"]."</td>\n";
      }
      echo "</tr>\n";
      $c++;
   }
   echo "</table>\n";
}

function listUser()
{
   $NoNavigationFlag=true;
   include($_SESSION['VxCFG']->styledir."/header.php");
   flush();
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(user_user_qry24, $_SESSION['vxmisuser']->GetFocusID(), $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"2\">&nbsp</td></tr>\n<tr><td colspan=\"2\">"._("There are no users defined for this station.")."</td></tr><tr><td colspan=\"2\">&nbsp</td></tr>\n</table>\n";
      return;
   }
   if($result->RecordCount()==0){
      echo "<tr><tr><td colspan=\"2\">&nbsp</td></tr>\n<td colspan=\"2\">"._("There are no users defined for this station.")."</td></tr><tr><td colspan=\"2\">&nbsp</td></tr>\n</table>\n";
      return;
   }
   
	echo "<tr><td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";

   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      $qry=sprintf(user_user_qry20, $row['employeeid']);
      $nresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      $nrow = $nresult->FetchRow();
      
      $qry=sprintf(user_user_qry17, $nrow['contactid']);
      $nresult=$_SESSION['VxCFG']->dbh->Execute($qry);
      $nrow = $nresult->FetchRow();
      
      if($c%2){
		   echo "<tr class=\"listdata\"><td class=\"listdata\">".$nrow["firstname"]." ".$nrow["lastname"]."</td>\n";
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$nrow["firstname"]." ".$nrow["lastname"]."</td>\n";
         echo "<td class=\"listdataeven\">";
      }
		$wibbler=$row["id"];
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"user.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"user.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"user.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"user.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"user.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"user.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}

?>
