<?php
/*
printitem.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

include("../bhmis.php");
if(!$_SESSION['misuser']->isloggedin()){
   redirect($_SESSION['CFG']->wwwroot."/login.php");
}
if(!$_SESSION['misuser']->hasPerm($_REQUEST['action'], $_SERVER['PHP_SELF'])){
   include($_SESSION['CFG']->templatedir."/noperm.php");
   exit;
}

if(!isset($_SESSION['title']) || strcmp($_SESSION['title'], system_prnitem_pagetitle)!=0){
   $_SESSION['title']=system_prnitem_pagetitle;
   //echo "<meta http-equiv=\"refresh\" content=\"0\" target="header.php\">";
}

if($_SESSION["pageindex"]->CheckNum(printitem_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

if($_SESSION['CFG']->onlinehelp){
   include($_SESSION['CFG']->templatedir."/phheader.php");
}
else{
   include($_SESSION['CFG']->templatedir."/pheader.php");
}


switch($_REQUEST['action']){
	case "clear" :
		addPrintItem();
      $_SESSION["pageindex"]->setnum(CountNum());
		break;

	case "browse":
      $id=updateNav($_POST);
		browsePrintItem($id);
		break;

	case "edit" :
		editPrintItem($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['CFG']->confirmdelete){
         chkdelPrintItem($_REQUEST['id']);
      }
      else{
         deletePrintItem($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listPrintItem($_REQUEST['id']);
      }
      break;  
	
   case "cfmdelete" :
      deletePrintItem($_POST['ID']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listPrintItem($_POST['ID']);
		break;
      
	case "delete" :
		chkdelPrintItem($id);
		break;

	case "add" :
		insertPrintItem($_POST);
      listPrintItem();
		break;

	case "commit" :
		commitPrintItem($_POST);
      listPrintItem();
		break;

	case "list":
	default :
      $id=updateNav($_POST);
		listPrintItem();
		break;
}

include($_SESSION['CFG']->templatedir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=db_query(printitem_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = 0;
   $frm["printitemid"] = 0;
   $frm["name"] = "";
   $frm["x"] = 0;
   $frm["y"] = 0;
   $frm["xsize"] = 0;
   $frm["ysize"] = 0;
   $frm["content"] = "";
   

   return $frm;
}

function fillForm($id, $bOffset)
{
	if($bOffset){
      $qry=sprintf(printitem_qry2, $id);
   }
   else{
      $qry=sprintf(printitem_qry3, $id);
   }
	$result=db_query($qry);
	$row = $result->FetchRow();
   
   $frm["id"] = $id;
   $frm["printitemid"] = $row["printitemid"];
   $frm["name"] = $row["name"];
   $frm["x"] = $row["x"];
   $frm["y"] = $row["y"];
   $frm["xsize"] = $row["xsize"];
   $frm["ysize"] = $row["ysize"];
   $frm["content"] = $row["content"];
   
	return $frm;
}

function addPrintItem()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	$frm["ID"] = "Auto number";
   $frm["heading"] = "Print Item Add";

	include("templates/printitemedit.php");
}

function editPrintItem($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
   $frm["heading"] = "Print Item Edit";

	include("templates/printitemedit.php");
}

function browsePrintItem($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
   $frm["heading"] = "Print Item Browse";
	
	include("templates/printitemedit.php");
}

function chkdelPrintItem($id)
{
   $frm=fillForm($id,false);
   $frm["newaction"] = "cfmdelete";
   $frm["heading"] = "Confirm Print Item Delete";
	include("templates/printitemedit.php");
}

function deletePrintItem($id) 
{
   $qry=sprintf(printitem_qry7, $id);
	db_query($qry);
}

function insertPrintItem($frm) 
{
   $qry=sprintf(printitem_qry5, $frm['name'], $frm['x'],$frm['y'],$frm['xsize'],$frm['ysize'],$frm['content']);
   db_query($qry);
}

function commitPrintItem($frm) 
{
   $qry=sprintf(printitem_qry6,$frm['name'], $frm['x'],$frm['y'],$frm['xsize'],$frm['ysize'],$frm['content'],$frm['id']);
	db_query($qry);
}

function listPrintItem()
{
   $q=$_SESSION["pageindex"]->query(printitem_qry4);
	$result=db_query($q);

	echo "<br><br>";
	echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\">\n";
	echo "<tr><td><h3>Name</h3></td><td><h3>Size</h3><td><h3>Action</h3></td></tr>";
	while($myrow = $result->FetchRow()){
		$n=$myrow["name"];
		$a=$myrow["x"].", ".$myrow["y"]." - ".$myrow["xsize"]." x ".$myrow["ysize"];
		echo "<tr><td>$n</td><td>$a</td><td>";
		$wibbler=$myrow["id"];
		if($_SESSION['CFG']->pageimages){
         echo "<a href=\"printitem.php?action=browse&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['CFG']->menuimagedir."/menu_node_view.png\"></a>&nbsp;\n";
		   echo "<a href=\"printitem.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['CFG']->menuimagedir."/menu_node_edit.png\"></a>&nbsp; \n";
		   echo "<a href=\"printitem.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['CFG']->menuimagedir."/menu_node_delete.png\"></a>&nbsp; \n";
      }
      else{
      	echo "<a href=\"printitem.php?action=browse&id=$wibbler\">".misc_listview."</a>&nbsp;\n";
		   echo "<a href=\"printitem.php?action=edit&id=$wibbler\">".misc_listedit."</a>&nbsp; \n";
		   echo "<a href=\"printitem.php?action=delete&id=$wibbler\">".misc_listdelete."</a>&nbsp; \n";
      }
		echo "</td></tr>\n";
	}
	echo "</table>";
	echo "<br><br>";
}

?>
