<?php
/*
transaction.php

Copyright (C)2004  Al Kinglsey

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/transaction.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Transactions"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Transactions");
}

if($_SESSION["pageindex"]->CheckNum(transaction_transaction_qry1, "transaction")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'prev':
	   $_SESSION["pageindex"]->prev();
	   break;
   case 'next':
	   $_SESSION["pageindex"]->next();
   	break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear":
		addTrans();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseTrans($_REQUEST['id']);
         break;
      }
		browseTrans($_POST['id']);
		break;

	case "edit" :
		editTrans($_REQUEST['id']);
		break;

   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelTrans($_REQUEST['id']);
      }
      else{
         deleteTrans($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listTrans();
      }
      break;  
	
   case "cfmdelete" :
      deleteTrans($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listTrans();
		break;

	case "add" :
		insertTrans($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
		break;

	case "commit" :
		commitTrans($_POST);
      listBank();
		break;

	case "list":
	default :
		listTrans();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(transaction_transaction_qry1);
   if(!$result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["id"] = 0;
   $frm["transactionid"] = "";
   $frm["enteredat"] = "";
   $frm["enteredby"] = "";
   $frm["enteredstation"] = "";
   $frm["statusid"] = "";
   $frm["paymenttypeid"] = "";
   $frm["refnum"] = "";
   $frm["description"] = "";
   $frm["open"] = "";
   $frm["reconciled"] = "";
   $frm["taxable"] = "";
   $frm["settlementid"] = "";
   $frm["linkid"] = "";

	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(transaction_qry2, $id);
   }
   else{
      $qry=sprintf(transaction_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm["id"] = $id;
	$frm["transactionid"] = $row["transactionid"];
	$frm["enteredat"] = $row["enteredat"];
	$frm["enteredby"] = $row["enteredby"];
	$frm["enteredstation"] = $row["enteredstation"];
	$frm["statusid"]=$row["statusid"];
	$frm["paymenttypeid"]=$row["paymenttypeid"];
	$frm["refnum"]=$row["refnum"];
	$frm["description"]=$row["description"];
	$frm["open"] = $row["open"];
   $frm["reconciled"] = $row["reconciled"];
   $frm["taxable"] = $row["taxable"];
   $frm["settlementid"] = $row["settlementid"];
   $frm["linkid"] = $row["linkid"];
	
	return $frm;
}

function addTrans()
{
	$frm=clearForm();
	$frm["newaction"] = "add";

	include("templates/transaction.php");
}

function editTrans($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/transaction.php");
}

function browseTrans($id) 
{
   $frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/transaction.php");
}

function chkdelTrans($id)
{
   $frm=fillForm($id, false);
   $frm["id"] = $id;
   $frm["newaction"] = "cfmdelete";
   $_REQUEST["action"] = "cfmdelete";
   /*
   $qry=sprintf(transaction_transaction_qry10, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$frm["numitems"]=$result->RecordCount()

	$result=db_query("SELECT name FROM departments WHERE id = '$id'");
	$row = $result->FetchRow();
	$frm["name"]=$row["name"];

	$frm["newaction"] = "cfmdelete";*/
	include("templates/transaction.php");
}

function deleteTrans($id) 
{
}

function insertTrans($frm) 
{
   /*
   "insert into transaction values();
   
   */
}

function commitTrans($id, $frm) 
{
}

function DateControl($a, $id)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
      $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
      if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($this->enteredat);
   }
   //$td->tscontrol($a, "enteredat");
   $td->displayex('date', $a, "enteredat");
}

function fillTransCombo($id)
{
	$result=$_SESSION['VxCFG']->dbh->Execute(transaction_transaction_qry4);
	echo "<select name=\"department\" width=\"250\">\n";
	while($row = $result->FetchRow()){
		$boo=$row["id"];
		$poo=$row["name"];
		if($id==$boo){
			print "<option selected value=\"$boo\"> $poo </option>\n";
		}
		else{
			print "<option value=\"$boo\"> $poo </option>\n";
		}
	}
	echo "</select>\n";
}

function TransTable($a, $id)
{
   $t=new Transaction();
   if($a=='edit'){
      $t->Table($a, $id, "", false);
   }
   else{
      $t->Table($a, $id, "", true);
   }
}

function listTrans()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(transaction_transaction_qry15, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no transactions defined")."</td></td></table>\n";
      return;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='enteredat'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("When")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("When")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=enteredat\">"._("When")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='enteredat'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='description'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Description")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Description")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=description\">"._("Description")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='description'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='numitems'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Num Items")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Num Items")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=numitems\">"._("Num Items")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='numitems'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='total'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Total")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Total")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=total\">"._("Total")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='total'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   while($row = $result->FetchRow()){
      $td=new TimeDate();
      $td->parse($row['enteredat']);
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">";
         $td->tscontrol("browse", "enteredat");
		   echo "</td>\n<td class=\"listdata\">";
         if(isset($row['description']) && $row['description']!=""){
            echo $row['description'];
         }
         else{
            echo "&nbsp";
         }
         echo "</td>\n<td class=\"listdata\">";
         $qry=sprintf(transaction_transaction_qry11, $row['id']);
         $tresult=db_query($qry);
         if($trow = $result->FetchRow()){
            echo $trow[0];
         }
         else{
            echo "0";
		   }
   		echo "</td>\n<td class=\"listdata\">";
         $qry=sprintf(transaction_transaction_qry12, $row['id']);
         $tresult=db_query($qry);
         if($trow = $result->FetchRow()){
            echo sprintf("%0.2f", $trow[0]);
         }
         else{
            echo "0.00";
		   }
         echo "</td>\n<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">";
         $td->tscontrol("browse", "enteredat");
		   echo "</td>\n<td class=\"listdata\">";
         if(isset($row['description']) && $row['description']!=""){
            echo $row['description'];
         }
         else{
            echo "&nbsp";
         }
         echo "</td>\n<td class=\"listdataeven\">";
         $qry=sprintf(transaction_transaction_qry11, $row['id']);
         $tresult=db_query($qry);
         if($trow = $result->FetchRow()){
            echo $trow[0];
         }
         else{
            echo "0";
		   }
   		echo "</td>\n<td class=\"listdataeven\">";
         $qry=sprintf(transaction_transaction_qry12, $row['id']);
         $tresult=db_query($qry);
         if($trow = $result->FetchRow()){
            echo sprintf("%0.2f", $trow[0]);
         }
         else{
            echo "0.00";
		   }
         echo "</td>\n<td class=\"listdataeven\">";
      }
      
		$wibbler=$row['id'];
		if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"transaction.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"transaction.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"transaction.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"transaction.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"transaction.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"transaction.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
      $c++;
      $offset++;
		echo "</td></tr>\n";
	}
	echo "</table>";
}

function listTranItems($tid)
{
   $result=db_query("SELECT plu, quantity from transactionitems where transactionid='$tid'");
   $rt=0.00;
   $st=0.00;
   echo "<table border=\"1\" cellpadding=\"2\" width=\"100%\" bgcolor=\"#FFFFFF\">\n";
   echo "<tr><td colspan=\"6\" align=\"center\">Transaction Items</td></tr>";
   echo "<tr><td>PLU</td><td>Name</td><td>Qty</td><td>Price</td><td>Sub</td><td>Total</td></tr>\n";
	while($row = $result->FetchRow()){
	   $p=$row["plu"];
	   $q=$row["quantity"];
      $nresult=db_query("SELECT disptext, unitprice from plu_cache where plu='$p'");
	   if($nrow = $result->FetchRow()){
   	   $n=$nrow["disptext"];
   	   $up=$nrow["unitprice"];
   	}
	   $st=(float) $up*$q;
	   $rt+=$st;
	   echo "<tr><td>\n";
	   echo "$p</td><td>$n</td><td>$q</td><td>";
	   printf("%0.2f", $up);
	   echo "</td>\n<td>";
	   printf("%0.2f", $st);
	   echo "</td>\n<td>";
	   printf("%0.2f", $rt);
	   echo "</td></tr>\n";
	}
	echo "</table>";
}

?>
