<?php
/*
contact.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/contact.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(3);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_POST['pselect'])){
   $action='list';
}

if(isset($_REQUEST['caction'])){
   $action=$_REQUEST['caction'];
}
else if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Contacts"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Contacts");
}

if($_SESSION["pageindex"]->CheckNum(contact_contact_qry1, "contacts")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addContact();
		break;

	case "browse":
      if(isset($_REQUEST['id'])){
         browseContact($id);
         break;
      }
		browseContact($id);
		break;

	case "edit" :
		editContact($_REQUEST['id']);
		break;
      
   case "delete" :
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelContact($_REQUEST['id']);
      }
      else{
         deleteContact($_REQUEST['id']);
         $_SESSION["pageindex"]->deletion(CountNum());
         listContact();
      }
      break;  
	
   case "cfmdelete" :
      deleteContact($_POST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listContact();
		break;

	case "add" :
		insertContact($_POST);
      $_SESSION["pageindex"]->addition(NumRows(CountNum()));
      listContact($id);
		break;

	case "commit" :
		commitContact($_POST);
      listContact();
		break;
   
   case "itemadd" :
		itemadd($_POST);
		break;
   
   case "itemedit" :
      itemedit($_REQUEST['id'], $_REQUEST['cid']);
		break;
      
   case "itemcommit" :
      itemcommit($_POST);
		break;
      
   case "itemdelete" :
		itemdelete($_REQUEST['id'], $_REQUEST['cid']);
		break;
   
	case "list":
	default :
      if(isset($_REQUEST['cletter'])) $cl=$_REQUEST['cletter'];
      else $cl='All';
      if(isset($_POST['pselect'])) $ps=$_POST['pselect'];
      else $ps='A';
      if(isset($_REQUEST['pselect'])) $ps=$_REQUEST['pselect'];
      else $ps='A';
		listContact($ps, $cl);
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $eid=$_SESSION['vxmisuser']->GetEmployee();
   $qry=sprintf(contact_contact_qry1, $eid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($result) return 0;
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["id"] = "";
   $frm["contactid"] = "";
   $frm["contactdetailsid"] = "";
   $frm["ownerid"] = "";
   $frm["addressid"] = "";
   $frm["imageid"] = "";
   $frm["titleid"] = "";
	$frm["firstname"] = "";
	$frm["lastname"] = "";
	$frm["middleinitial"] = "";
   $frm["birthdate"] = "";
	$frm["lastcontact"] = "";
   $frm["timezone"] = "";
   $frm["private"] = "";
   $frm["memoid"] = "";

   $frm["cid"]=0;
	return $frm;
}

function fillForm($id, $bOffset)
{
    if($bOffset){
      $qry=sprintf(contact_contact_qry2, $id, $_SESSION['vxmisuser']->GetEmployee());
   }
   else{
      $qry=sprintf(contact_contact_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();
   $frm["id"] = $id;
   $frm["contactid"] = $row["contactid"];
   $frm["contactdetailsid"] = $row["contactdetailsid"];
   $frm["ownerid"] = $row["ownerid"];
   $frm["addressid"] = $row["addressid"];
   $frm["imageid"] = $row["imageid"];
   $frm["titleid"] = $row["titleid"];
	$frm["firstname"] = $row["firstname"];
	$frm["lastname"] = $row["lastname"];
	$frm["middleinitial"] = $row["middleinitial"];
   $frm["birthdate"] = $row["birthdate"];
	$frm["lastcontact"] = $row["lastcontact"];
   $frm["timezone"] = $row["timezone"];
   $frm["private"] = $row["private"];
   $frm["memoid"] = $row["memoid"];
   
   $frm["cid"]=0;
   
	return $frm;
}

function addContact()
{
	$frm=clearForm();
	$frm["newaction"] = "add";
	
	include("templates/contact.php");
}

function editContact($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";
		
	include("templates/contact.php");
}

function browseContact($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
		
	include("templates/contact.php");
}

function insertContact($frm) 
{
   // add address
   $addr=new Address();
   $addr->FillFromForm($frm);
   $aid=$addr->Commit();
   
   // add image
   if(isset($frm['imageid'])){
      
   }
	
   $qry=sprintf(contact_contact_qry5, $_SESSION['misuser']->GetEmployee(), $aid, $iid,$frm["titleid"],
	   $frm["firstname"],$frm["lastname"],$frm["middleinitial"],$frm["birthdate"],
      $frm["lastcontact"],$frm["timezone"],YN($frm["private"]),$frm["memoid"]);
	$_SESSION['VxCFG']->dbh->Execute($qry);
   
   //db_query("update contacts set contactid='last_insert_id()' where id='last_insert_id()'");
   
}

function commitContact($frm) 
{
	 $qry=sprintf(contact_contact_qry6, $_SESSION['misuser']->GetEmployee(), $aid, $iid,$frm["titleid"],
	   $frm["firstname"],$frm["lastname"],$frm["middleinitial"],$frm["lastcontact"],$frm["timezone"],
      YN($frm["private"]), $frm["id"]);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function chkdelContact($id)
{
   $frm=fillForm($id, false);
	$frm["newaction"] = "cfmdelete";
		
	include("templates/contact.php");
}

function deleteContact($id) 
{
   $qry=sprintf(contact_qry6,$id);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function Tree($a, $cdid)
{
   ContactTree($a, $cdid);
}
/*
function fillTitleCombo($a, $cname, $id)
{	
	if($a=="commit" || $a=="add"){
	   print "<select name=\"$cname\">\n";
      $result=$_SESSION['VxCFG']->dbh->Execute(contact_title_qry8);
	   while($row = $result->FetchRow()){
			$boo=$row["id"];
		   $poo=$row["name"];
		   if($id==$boo){
			   print "<option selected value=\"$boo\"> $poo </option>\n";
		   }
   		else{
	   		print "<option value=\"$boo\"> $poo </option>\n";
		   }
	   }
		print "</select>\n";
   }
   else{
      $qry=sprintf(contact_title_qry3, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo $row[0];
      }
      else{
         echo "Not Set";
      }
   }
}
*/
function AddressTable($a, $aid)
{
   $addr=new Address();
   $addr->FillTable($a, $aid, "address");
}

function Image($a, $iid)
{
}

function BirthDate($a, $bd)
{
   $td=new TimeDate();
   $td->datecontrol_ranged($a, "birthdate", 65, 0);
}

function LastContact($a, $lc)
{
   $td=new TimeDate();
   $td->datecontrol($a, $lc);
}

function MemoTable($a, $id)
{
   $bedit=false;
   echo "<table>\n";
   echo "<tr>\n<td class=\"inlisttitle\">"._("Date")."</td>\n";
   echo "<td class=\"inlisttitle\">"._("By")."</td>\n";
   echo "<td class=\"inlisttitle\">"._("Subject")."</td>\n";
   echo "<td class=\"inlisttitle\">"._("Action")."</td>\n</tr>\n";
   
   echo "<tr><td colspan=\"4\" class=\"listdata\">"._("There are no notes.")."</td></tr></table>";
   return;
   
   $qry=sprintf(contact_memo_qry4, $id);
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result) return false;
   echo "<table class=\"memo\">\n";
   if($result->RecordCount()==0){
      if($a=="commit" || $a=="add"){
         echo "<tr><td>"._("There are no notes.")."</td>\n<td>";
         echo "<input type=\"submit\" name=\"memoadd\" value=\"add\"></td></tr></table>\n";
      }
      else{
         echo "<tr><td>"._("There are no notes.")."</td></tr></table>\n";
      }
      return;
   }
   $cm=new CreateMod();
      
   while($row = $result->FetchRow()){
      if($a=="commit" || $a=="add"){
         echo "<tr><td class=\"inlistdata\">";
         echo $row["subject"];
         echo "</td>\n<td class=\"inlistdata\">";
         /*
         echo "<tr>\n<td>";
	      textarea($a, "data", 64, 255, $this->data);
         echo"</td>\n";
         echo "</tr>\n";*/
      }
      else{
         echo "<tr><td class=\"inlistdata\">".$row["subject"]."</td>\n<td>";
         $cm->Fill($row['cmid']);
         $cm->FillCell();
         echo "</td>\n</tr>\n<tr><td colspan=\"2\">";
         echo $row[">data"],"</td></tr>\n";
      }
   }
   if($a=="commit" || $a=="add"){
      // add a blank for addition
   }
   echo "</table>\n";
}

function TypeCombo($a, $id, $cname)
{
   if($a=="commit" || $a=="add"){
      $result=$_SESSION['VxCFG']->dbh->Execute(contact_type_qry8);
      echo "<select name=\"$cname\">\n";
 	   while($row = $result->FetchRow()){
  	   	$boo=$row["id"];
   	   $poo=$row["name"];
  	   	if($id==$boo){
   	   	echo "<option selected value=\"$boo\"> $poo </option>\n";
  		   }
     		else{
      		echo "<option value=\"$boo\"> $poo </option>\n";
  		   }
      }
      echo "</select>\n";
   }
   else{
      $qry=sprintf(contact_type_qry3, $id);
      $result=$_SESSION['VxCFG']->dbh->Execute($qry);
      if($row = $result->FetchRow()){
         echo $row[1];
      }
      else{
         echo "Not Set";
      }
   }
}

function PrivateCombo($a, $id, $cname)
{
   $typelist = array('A'=>_("All"), 'U'=>_("None"), 'G'=>_("Group"), 'D'=>_("Department"), 'S'=>_("Site"));
   
   if($a=="commit" || $a=="add"){
	   echo "<select name=\"$cname\">\n";
	   foreach($typelist as $typeid=>$type){
	      echo "<option ";
   	   if($id==$typeid)
	         echo "selected ";
	      echo "value='$typeid'>$type</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $typelist[$id];
   }
}

function ShowCombo($a, $id, $cname)
{
   $typelist = array('A'=>_("All"), 'U'=>_("Mine"), 'G'=>_("Group"), 'D'=>_("Department"), 'S'=>_("Site"));
   
   if($a=="commit" || $a=="add"){
	   echo "<select onChange=\"this.form.submit();\" name=\"$cname\">\n";
	   foreach($typelist as $typeid=>$type){
	      echo "<option ";
   	   if($id==$typeid)
	         echo "selected ";
	      echo "value='$typeid'>$type</option>\n";
	   }
	   echo "</select>\n";
   }
   else{
      echo $typelist[$id];
   }
}

function ItemTable($a, $cdid, $id, $contactid)
{
   $qry=sprintf(contact_details_qry8, $cdid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   
   $bedit=false;
   echo "<table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\" class=\"contactdetails\">\n";
   echo "<tr>\n<td colspan=\"3\" class=\"listtitle\">"._("Title")."</td>\n</tr>\n";
	echo "<tr>\n<td class=\"listtitle\">"._("Type")."</td>\n";
   echo "<td class=\"listtitle\">"._("Value")."</td>\n";
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   
   if($result->RecordCount()==0){
      echo "<td colspan=\"3\" class=\"listdata\">"._("There are no contacts details defined.")."</td>\n</tr>\n</table>";
      return;
   }
   
   while($row = $result->FetchRow()){
      echo "<tr>\n<td class=\"listdata\">";
      if($a!='browse'){
         if($row['id']==$id){
            $bedit=true;
            TypeCombo("commit", $row['typeid'], "ctypeid" );
            echo"</td>\n<td class=\"listdata\">";
            entry("commit", "cdata", 68, 64, $row['data']);
            echo"</td>\n<td class=\"listdata\">";
            if($_SESSION['vxmisuser']->GetShowImages()){
               echo "<input name=\"submit\" src=\"". $_SESSION['VxCFG']->styleimagedir."/list_commit.png\" type=\"image\">";
            }
            else{
               echo "<input type=\"submit\" name=\"memoadd\" value=\""._("Commit")."\">";
            }
         }
         else{
            TypeCombo("browse", $row['typeid'], "");
            echo "</td>\n<td class=\"listdata\">".$row['data']."</td>\n<td class=\"listdata\">";
         }
      }
      else{
         TypeCombo("browse", $row['typeid'], "");
         echo "</td>\n<td class=\"listdata\">".$row['data']."</td>\n<td class=\"listdata\">";
      }
      if($row['id']!=$id){
         if($_SESSION['vxmisuser']->GetShowImages()){
            if($_SESSION['vxmisuser']->GetPerm('edit')){
               echo "<a href=\"contact.php?action=itemedit&cid=".$row['id']."&id=".$contactid."\">";
               echo "<img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp;\n";
            }
            if($_SESSION['vxmisuser']->GetPerm('delete')){
	            echo "<a href=\"contact.php?action=itemdelete&cid=".$row['id']."&id=".$contactid."\">";
               echo "<img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp;\n";
            }
         }
         else{
            if($_SESSION['vxmisuser']->GetPerm('edit')){
		        echo "<a href=\"contact.php?action=itemedit&cid=".$row['id']."&id=".$contactid."\">"._("Edit")."</a>&nbsp;\n";
            }
            if($_SESSION['vxmisuser']->GetPerm('delete')){
		         echo "<a href=\"contact.php?action=itemdelete&cid=".$row['id']."&id=".$contactid."\">"._("Delete")."</a>&nbsp;\n";
            }
         }
      }
      echo "</td>\n</tr>\n";
   }
   if($a!='browse' && $bedit==false){
      echo "<tr>\n<td class=\"listdata\">";
      TypeCombo("add", $row['typeid'], "ctypeid" );
      echo "</td>\n<td class=\"listdata\">";
      entry("add", "cdata", 68, 64, $row['data']);
      echo "</td>\n<td class=\"listdata\">";
      echo "<input type=\"hidden\" name=\"action\" value=\"itemadd\">\n";
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<input name=\"submit\" src=\"". $_SESSION['VxCFG']->styleimagedir."/list_add.png\" type=\"image\">";
      }
      else{
         echo "<input type=\"submit\" name=\"memoadd\" value=\"".misc_listadd."\">";
      }
      echo "<td></tr>\n";
   }
   echo "</table>\n";
}

function itemadd($frm)
{
   $qry=sprintf(contact_details_qry4, $frm['contactdetailsid'],$frm['ctypeid'],  $frm['cdata']);
	$_SESSION['VxCFG']->dbh->Execute($qry);
   
   $frm=fillForm($frm['id'], false);
   $frm["newaction"] = "commit";
		
	include("templates/contact.php");
}

function itemedit($id, $cid)
{
   $frm=fillForm($id, false);
   $frm["cid"]=$cid;
   $frm["newaction"] = "itemcommit";
		
	include("templates/contact.php");
}

function itemcommit($frm)
{
   $qry=sprintf(contact_details_qry5, $frm['contactdetailsid'],$frm['ctypeid'],  $frm['cdata'], $frm['cid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
	
   $frm=fillForm($frm['id'], false);
   $frm["newaction"] = "commit";
	include("templates/contact.php");
}

function itemdelete($id, $cid)
{
   $qry=sprintf(contact_details_qry6, $cid);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   $frm=fillForm($id, false);
   $frm["newaction"] = "commit";
	include("templates/contact.php");
}

function listContact($ps='U', $lc='All')
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   $qry=sprintf(contact_contact_qry13, $_SESSION['vxmisuser']->GetEmployee());
   if($lc!='All'){
      $qry.=" and lastname like '$lc%' ";
   }

	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";
   
   echo "<form action=\"".$_SERVER['PHP_SELF']."\" method=\"POST\">\n";
   echo "<input type=\"hidden\" name=\"cletter\" value=\"$lc\">\n";
   echo "<table class=\"listtable\">\n";
   echo "<tr><td class=\"listtitle\" colspan=\"4\">";
   ContactAlphabet($lc, $ps);
   echo "</td></tr>";
   
   if(!$result){
      echo "<tr><td colspan=\"4\">"._("There are no contacts defined.")."</td></tr>\n</table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"4\">"._("There are no contacts defined.")."</td></tr>\n</table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='name'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Name")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Name")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Name")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='name'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='private'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Access To")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Access To")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=private\">"._("Access To")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='private'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='lastcontact'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Last Contact")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Last Contact")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=name\">"._("Last Contact")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='lastcontact'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";

	while($row = $result->FetchRow()){
		$wibbler=$row["id"];
		$n=$row["firstname"]." ".$row["lastname"];
		$ls=$row["lastcontact"];

		echo "<tr><td class=\"listdata\">$n</td>\n<td class=\"listdata\">";
      PrivateCombo("browse", $row["private"], "private");
      echo "</td>\n<td class=\"listdata\">$ls</td><td class=\"listdata\">\n";
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"contact.php?action=browse&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"contact.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"contact.php?action=delete&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"contact.php?action=browse&id=$wibbler\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"contact.php?action=edit&id=$wibbler\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"contact.php?action=delete&id=$wibbler\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
	}
	echo "</table>\n</form>";
}

?>
