<?php
/*
userdetails.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/bank.php");
require_once($_SESSION['VxCFG']->libdir."/contact.php");
require_once($_SESSION['VxCFG']->libdir."/createmod.php");
require_once($_SESSION['VxCFG']->libdir."/image.php");
require_once($_SESSION['VxCFG']->libdir."/memo.php");
//require_once($_SESSION['VxCFG']->libdir."/org.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='browse';
   }
   else{
      $action=$_REQUEST['action'];
   }
}
$_SESSION['vxmisuser']->SetModule(2);
$action='browse';
$_SESSION['vxmisuser']->ClearFocus();
$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("My Details"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("My Details");
}

if($_SESSION["pageindex"]->CheckNum(employee_emp_qry1, "employee")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

if(isset($_FILES['reffile'])){
   insertimage();
}

if(isset($_POST['memoadd'])){

   $frm=fillForm($frm['id'], false);
   $frm["newaction"] = "memoadd";
   include($_SESSION['VxCFG']->styledir."/header.php");
   include("templates/emp.php");
   include($_SESSION['CFG']->templatedir."/footer.php");
   exit;
}

switch($action){
   case "clear" :
      addEmp();
      break;

   case "browse":
      browseEmp();
      break;

   case "edit" :
      editEmp();
      break;

   case "commit" :
      commitEmp($_POST);
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(employee_emp_qry1);
   if($result) return 0;
  if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function fillForm()
{
  $qry=sprintf(employee_emp_qry3, $_SESSION["vxmisuser"]->GetEmployee());
  $result=$_SESSION['VxCFG']->dbh->Execute($qry);
  $row = $result->FetchRow();

   $frm["id"] = $row["id"];
   $frm["employeeid"] = $row["employeeid"];
   $frm["employeenumber"] = $row["employeenumber"];
   $frm["contactid"] = $row["contactid"];
   $frm["groupid"] = $row["groupid"];
   $frm["startdate"] = $row["startdate"];
   $frm["enddate"] = $row["enddate"];
   $frm["gender"] = $row["gender"];
   $frm["jobdesc"] = $row["jobdesc"];
   $frm["payid"] = $row["payid"];
   $frm["annualpay"] = $row["annualpay"];
   $frm["holidayentitlementid"] = $row["holidayentitlementid"];
   $frm["holidaytakenid"] = $row["holidaytakenid"];
   $frm["taxcode"] = $row["taxcode"];
   $frm["nicode"] = $row["nicode"];
   $frm["ninumber"] = $row["ninumber"];
   $frm["prevtax"] = $row["prevtax"];
   $frm["prevpay"] = $row["prevpay"];
   $frm["bankid"] = $row["bankid"];

   $qry=sprintf(employee_emp_qry6, $_SESSION["vxmisuser"]->GetEmployee());
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if($row = $result->FetchRow()){
      $frm["userid"]=$row["id"];
   }
   else{
      $frm["userid"]=0;
   }
   $qry=sprintf(employee_emp_qry14, $frm["groupid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["groupname"]=$row["name"];
   
   $qry=sprintf(contact_contact_qry3, $frm["contactid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["c_id"] = $row["id"];
   $frm["c_contactid"] = $row["contactid"];
   $frm["c_contactdetailsid"] = $row["contactdetailsid"];
   $frm["c_ownerid"] = $row["ownerid"];
   $frm["c_addressid"] = $row["addressid"];
   $frm["c_imageid"] = $row["imageid"];
   $frm["c_titleid"] = $row["titleid"];
   $frm["c_firstname"] = $row["firstname"];
   $frm["c_lastname"] = $row["lastname"];
   $frm["c_givenname"] = $row["givenname"];
   $frm["c_middleinitial"] = $row["middleinitial"];
   $frm["c_suffix"] = $row["suffix"];
   $frm["c_birthdate"] = $row["birthdate"];
   $frm["c_lastcontact"] = $row["lastcontact"];
   $frm["c_timezone"] = $row["timezone"];
   $frm["c_private"] = $row["private"];
   $frm["c_memoid"] = $row["memoid"];

  return $frm;
}

function editEmp($id) 
{
   $frm=fillForm();
   $frm["newaction"] = "commit";
   include($_SESSION['VxCFG']->styledir."/header.php");
   include("templates/userdetails.php");
}

function browseEmp() 
{
   $frm=fillForm();
   $frm["newaction"] = "browse";
   include($_SESSION['VxCFG']->styledir."/header.php");
   include("templates/userdetails.php");
}

function commitEmp($frm) 
{
   $a=new Address();
   $a->SetFromForm($frm);
   $aid=$frm['addressid'];
   $a->Commit($aid);
   
   $sdate=$frm['startdateyear']."-".$frm['startdatemonth']."-".$frm['startdateday'];
   $edate="1971-01-01";
   $dob=$frm['c_birthdateyear']."-".$frm['c_birthdatemonth']."-".$frm['c_birthdateday'];

   $qry=sprintf(employee_emp_qry12, $frm['employeeid'],$frm['employeenumber'],$frm['groupid'],$sdate,$edate,
   $frm['jobdesc'],$frm['payid'],$frm['annualpay'],$frm["holidayentitlementid"],$frm["holidaytakenid"],$frm['taxcode'],
   $frm['nicode'],$frm['ninumber'],$frm['prevtax'],$frm['prevpay'],$frm['bankid'],$frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
   
   $qry=sprintf(employee_emp_qry666, $frm["c_titleid"],$frm['c_fname'],$frm['c_lname'],$frm['c_sex'],$dob,$adid,
      $frm['c_imageid'],$frm['c_memoid'],$frm['c_contactid']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function AddressTable($action, $id)
{
   $a=new Address();
   $a->FillTable($action, $id, "Address");
}

function DateControl($a, $d, $n)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
     $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
      if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->datecontrol($a, $n);
}

function DateControlRanged($a, $d, $n)
{
   $td=new TimeDate();
   if($a=="commit" || $a=="add"){
     $result=$_SESSION['VxCFG']->dbh->Execute(login_qry1);
      if($row = $result->FetchRow()){
         $td->parse($row[0]);
      }
   }
   else{
      $td->parse($d);
   }
   $td->datecontrol_ranged($a, $n, 65, 16);
}

function ImageView($action, $id)
{
   $i=new Image();
   $i->Fill($id);
   $i->SetWidth($_SESSION['vxmisuser']->GetDefaultImageX());
   $i->SetHeight($_SESSION['vxmisuser']->GetDefaultImageY());
   $i->View($action, $id, "Image");
   //echo "<a href=\"javascript:popWindow('".$_SESSION["VxCFG"]->styledir."/imgpopup.php','imgpop','reffile')\">Cunt</a>\n";
   /*
   echo "<input class=\"help\" type=\"image\" height=\"24\" width=\"24\"";
   echo "src=\"".$_SESSION['VxCFG']->styleimagedir."/icon_help.png\" name=\"test\"";
   echo "<onclick=\"popWindow('".$_SESSION["VxCFG"]->styledir."/imgpopup.php','imgpop','reffile')\">\n";*/
}

function BankDetails($action, $id)
{
   $b=new BankDetails();
   //$b->Fill($id);
   $b->Combo($action, $id, "bankid");
}

function PayGradeCombo($action, $id)
{
}

function MemoList($action, $id)
{
   $m=new Memo();
   $m->FillList($action, $id);
}

function fillUserTable($a, $id)
{
   $qry=sprintf(employee_emp_qry16, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $login=$row["login"];
   $password=$row["password"];
   $passivelogin=$row["profile"];
   $bclogin=$row["userdata"];
   $logintypeid=$row["logintypesid"];
   
   echo "<fieldset>\n<legend>"._("User Entry")."</legend>\n<table>\n";
   echo "<tr>\n";
   echo "<td class=\"formlabel\">"._("login")."</td>\n";
   echo "<td class=\"formdata\">\n";
   entry($a, "login", 22, 16, $login);
   echo "</td class=\"formdata\">\n";
   echo "</tr>\n";

   echo "<tr>\n";
   echo "<td class=\"formlabel\">"._("password")."</td>\n";
   echo "<td class=\"formdata\">\n";
   pentry($a, "password", 22, 16, $password, "password");
   echo "</td>\n";
   echo "</tr>\n";
  
   echo "<tr>\n";
   echo "<td class=\"formlabel\">"._("passive login")."</td>\n";
   echo "<td class=\"formdata\">\n";
   entry($a, "passivelogin", 22, 10, $passivelogin);
   echo "</td>\n";
   echo "</tr>\n";
  
   echo "<tr>\n";
   echo "<td class=\"formlabel\">"._("barcode login")."</td>\n";
   echo "<td class=\"formdata\">\n";
   entry($a, "userdata", 22, 10, $bclogin);
   echo "</td>\n</tr></table>\n</fieldset>\n";
}

?>
