<?php
/*
userevent.php

Copyright (C)2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/calendar.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
$_SESSION['vxmisuser']->SetModule(3);

if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(3);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stop.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Events"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Events");
}

if($_SESSION["pageindex"]->CheckNum(useradmin_event_qry1, "event")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

include($_SESSION['VxCFG']->styledir."/header.php");

switch($action){
	case "clear" :
		addEvent();
		break;
   
   case "browse":
		browseEvent($id);
		break;
      
	case "edit" :
      editEvent($_REQUEST['id']);
      break;
   
   case "add" :
		insertEvent($_POST);
      $_SESSION["pageindex"]->addition(CountNum());
      listEvent();
		break;

	case "commit" :
		commitEvent($_POST);
		break;
   
   case 'cfmdelete':
      deleteEvent($_REQUEST['id']);
      $_SESSION["pageindex"]->deletion(CountNum());
      listEvent();
      nreak;
      
   case 'delete':
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelEvent($_REQUEST['id']);
      }
      else{
         deleteEvent($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listEvent();
      }
      break;
            
   case "list":
	default :
		listEvent();
		break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/
function CountNum()
{
   $result=db_query(useradmin_event_qry1);
	if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
	$frm["newaction"] = "";
	$frm["id"] = 0;
   $frm["parentid"] = 0;
   $frm["ownerid"] = 0;
   $frm["title"] = '';
   $frm["icon"] = '';
   $frm["starts"] = '';
   $frm["ends"] = '';
	
	return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(useradmin_event_qry2, $id);
   }
   else{
      $qry=sprintf(useradmin_event_qry3, $id);
   }
	$result=$_SESSION['VxCFG']->dbh->Execute($qry);
	$row = $result->FetchRow();

	$frm["id"] = $id;
   $frm["parentid"] = $row['parentid'];
   $frm["ownerid"] = $row['ownerid'];
   $frm["title"] = $row['title'];
   $frm["icon"] = $row['icon'];
   $frm["starts"] = $row['starts'];
   $frm["ends"] = $row['ends'];

	return $frm;
}

function addEvent()
{
	$frm=clearForm();
	$frm["newaction"] = "add";

	include("templates/userevent.php");
}

function editEvent($id) 
{
	$frm=fillForm($id, false);
	$frm["newaction"] = "commit";

	include("templates/userevent.php");
}

function browseEvent($id) 
{
	$frm=fillForm($id, true);
	$frm["newaction"] = "browse";
	
	include("templates/userevent.php");
}

function insertEvent($frm) 
{
   $qry=sprintf(useradmin_event_qry4,$frm["parentid"],$frm["ownerid"],$frm["title"],$frm["icon"],$frm["starts"],$frm["ends"]);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitEvent($frm) 
{
   $qry=sprintf(useradmin_event_qry5,$frm["parentid"],$frm["ownerid"],$frm["title"],$frm["icon"],$frm["starts"],
   $frm["ends"],$frm['id']);

	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function chkdelEvent($id)
{
   fillForm($id, true);
	$frm["id"]=$id; 
	$frm["newaction"] = "cfmdelete";
   
	include("templates/userevent.php");
}

function deleteEvent($frm) 
{
   $qry=sprintf(useradmin_event_qry6, $frm["id"]);
	$_SESSION['VxCFG']->dbh->Execute($qry);
}

function listEvent()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(useradmin_event_qry7, $sorton, $sortorder);
	$q=$_SESSION["pageindex"]->query($qry);
	$result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no events defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='starts'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Starts")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Starts")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=starts\">"._("Starts")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='starts'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='ends'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Ends")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Ends")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=ends\">"._("Ends")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='ends'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
	echo "<td class=\"listtitle \"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='title'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Title")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Title")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=title\">"._("Title")."</a></td></tr></table>\n</td>\n";
   }
   
   if($sorton=='title'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
	while($row = $result->FetchRow()){
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">".$row["starts"]."</td>\n";
         echo "<td class=\"listdata\">".$row["ends"]."</td>\n";
         echo "<td class=\"listdata\">".$row["title"]."</td>\n";
   		echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row["starts"]."</td>\n";
         echo "<td class=\"listdataeven\">".$row["ends"]."</td>\n";
         echo "<td class=\"listdataeven\">".$row["title"]."</td>\n";
   		echo "<td class=\"listdataeven\">";
      }
      
		$wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         echo "<a href=\"userevent.php?action=browse&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_view.png\"></a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"userevent.php?action=edit&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_edit.png\"></a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"userevent.php?action=delete&id=$wibbler&offset=$offset\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_delete.png\"></a>&nbsp; \n";
         }
      }
      else{
      	echo "<a href=\"userevent.php?action=browse&id=$wibbler&offset=$offset\">"._("View")."</a>&nbsp;\n";
         if($_SESSION['vxmisuser']->GetPerm('edit')){
		      echo "<a href=\"userevent.php?action=edit&id=$wibbler&offset=$offset\">"._("Edit")."</a>&nbsp; \n";
         }
         if($_SESSION['vxmisuser']->GetPerm('delete')){
		      echo "<a href=\"userevent.php?action=delete&id=$wibbler&offset=$offset\">"._("Delete")."</a>&nbsp; \n";
         }
      }
		echo "</td></tr>\n";
      $c++;
      $offset++;
	}
	echo "</table>";
}



function eventView($id)
{
   $e=new VxEvent();
   $frm=$e->FillForm($id);
   if($frm==false){
      $frm['id']=0;
      $frm['starts']='';
      $frm['ends']='';
      $frm['title']='';
      $frm['ownerid']='';
   }
   $frm['newaction']='commit';

   include("templates/userevent.php");
}

function TimeControl($a, $t)
{
   $ts=new TimeDate($t);
   if($a=="starts"){
      $ts->tscontrol_quarterhour("commit", "starts");
   }
   else{
      $ts->tscontrol_quarterhour("commit", "endts");
   }
}


?>
