<?php
/*
package.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/contact.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(1);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logout.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/header.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_noperms.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footer.php");
   exit;
}

$_SESSION["vxmisuser"]->AddRecentlyVisited($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']);

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Package"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Package");
}

if($_SESSION["pageindex"]->CheckNum(warehouse_package_qry1, "orders")){
   $_SESSION["pageindex"]->setnum(CountNum());
}

if(isset($_REQUEST["navaction"])){
   $na=$_REQUEST["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
   	break;
   case 'pageprev':
	   $_SESSION["pageindex"]->pgprev();
	   break;
   case 'pagenext':
	   $_SESSION["pageindex"]->pgnext();
	   break;
   case 'end':
	   if($_REQUEST['action']=="list")
	      $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
	   break;
   }
   $_REQUEST['id']=$_SESSION["pageindex"]->current();
}

switch($action){
   case "edit":
      include($_SESSION['VxCFG']->styledir."/header.php");
      editPackage($_REQUEST['id']);
      break;

   case "commit" :
      include($_SESSION['VxCFG']->styledir."/header.php");
      commitPackage($_POST);
      listPackage();
      break;
   
   case "labelprint":
      printLabel($_POST);
      exit;
   
   case "invoiceprint":
      printInvoice($_POST);
      exit;
      
   case "list":
   default :
      include($_SESSION['VxCFG']->styledir."/header.php");
      listPackage();
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(warehouse_package_qry1);
   if(!$result) return 0;
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["newaction"] = "";
   $frm["showdeps"] = "";
   $frm["id"] = 0;
  
  return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(warehouse_package_qry2, $id);
   }
   else{
      $qry=sprintf(warehouse_package_qry3, $id);
   }
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();

   $frm["id"] = $row["id"];

  return $frm;
}

function editPackage($id) 
{

   $qry=sprintf(warehouse_package_qry4, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();

   $frm["id"] = $row["id"];
   $frm["orderid"] = $row["orderid"];
	$frm["ordernumber"] = $row["ordernumber"];
/*
   $qry=sprintf(warehouse_stockpick_qry5, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["id"] = $row["id"];
*/   
   $qry=sprintf(warehouse_stockpick_qry10, $row["customerid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["contactid"] = $row["contactid"];
   
   $qry=sprintf(warehouse_stockpick_qry11, $row["contactid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["titleid"] = $row["titleid"];
   $frm["firstname"] = $row["firstname"];
   $frm["lastname"] = $row["lastname"];
   printInvoice($id);
   $frm["newaction"] = "none";
  
   include("templates/package.php");
}

function commitPackage($frm) 
{
   $qry=sprintf(warehouse_package_qry8,$frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function printLabel()
{
}

function printInvoice($id)
{
   $qry=sprintf(warehouse_package_qry4, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $da=$row["deliveryaddressid"];
   $shid=$row["shippingid"];
   $frm['ordernumber']=$ordernumber=$row["ordernumber"];
   $orderid=$id;
   
   $qry=sprintf(warehouse_stockpick_qry10, $row["customerid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["contactid"] = $row["contactid"];
   
   $qry=sprintf(warehouse_stockpick_qry11, $row["contactid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $qry=sprintf(warehouse_package_qry10, $row["titleid"]);
   $tresult=$_SESSION['VxCFG']->dbh->Execute($qry);
   $trow = $tresult->FetchRow();
   
   $customername = $trow["name"]." ".$row["firstname"]." ".$row["lastname"];
   $addr=new Address();
   $customeraddress=$addr->LabelLayout($da);
   
   $regnumber="";
   $taxnumber="";
   $qry=sprintf(warehouse_package_qry12, '1');
   if($result=$_SESSION['VxCFG']->dbh->Execute($qry)){
      if($row = $result->FetchRow()){
         $regnumber=$row["value"];
      }
   }
   
   $qry=sprintf(warehouse_package_qry13, '1');
   if($result=$_SESSION['VxCFG']->dbh->Execute($qry)){
      if($row = $result->FetchRow()){
         $taxnumber=$row["value"];
      }
   }
   
   $lineitems=array();
   $totals=array();
   $numsheets=2;
   
   $qry=sprintf(warehouse_package_qry14);
   if($result=$_SESSION['VxCFG']->dbh->Execute($qry)){
      if($row = $result->FetchRow()){
         $siteid=$row["siteid"];
      }
   }
   $qry=sprintf(warehouse_package_qry17, $siteid);
   if($result=$_SESSION['VxCFG']->dbh->Execute($qry)){
      if($row = $result->FetchRow()){
         $addrid=$row["addressid"];
      }
   }
   
   $qry=sprintf(warehouse_package_qry15, $siteid);
   if($result=$_SESSION['VxCFG']->dbh->Execute($qry)){
      if($row = $result->FetchRow()){
         $buid=$row["businessunitid"];
      }
   }
   $qry=sprintf(warehouse_package_qry16, $buid);
   if($result=$_SESSION['VxCFG']->dbh->Execute($qry)){
      if($row = $result->FetchRow()){
         $companyname=$row["name"];
      }
   }
   $addr=new Address();
   $companyaddress=$addr->LabelLayout($siteid);
   $postcode=$addr->Get('postcode');
   
   $qry=sprintf(warehouse_package_qry7, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $n=1;
   $a=$b=$c=0.0;
   while($row = $result->FetchRow()){
      $qry=sprintf(warehouse_package_qry6, $row['productid']);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$res) continue;
      if($res->RecordCount()==0) continue;
      if(!($r = $res->FetchRow())) continue;
      
      $st=sprintf("%0.2f", ($row["unitprice"]*$row["quantity"])+(($row["unitprice"]*$row["quantity"])*$row["taxrate"]));
      $line = array("Item" => $n,
         "Description"     => $r["description"],
         "Qty"             => $row["quantity"],
         "Price"           => $row["unitprice"],
         "SubTotal"        => sprintf("%0.2f", ($row["unitprice"]*$row["quantity"])),
         "Tax"             => sprintf("%0.2f", (($row["unitprice"]*$row["quantity"])*$row["taxrate"])),
         "Total"           => $st);
      array_push($lineitems, $line);
      $a+=$row["unitprice"]*$row["quantity"];
      $b+=(($row["unitprice"]*$row["quantity"])*$row["taxrate"]);
      $c+=$st;
      $n++;
   }
   
   $qry=sprintf(warehouse_package_qry11, $shid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   
   $a+=$row["rate"];
   //$b+=(($row["unitprice"]*$row["quantity"])*$row["taxrate"]);
   $c+=$row["rate"];
   $line = array("Item" => $n,
      "Description"     => $row["name"],
      "Qty"             => "-",
      "Price"           => $row["rate"],
      "SubTotal"        => $row["rate"],
      "Tax"             => "-",
      "Total"           => $c);
   array_push($lineitems, $line);
   
   $totals=array("price" => $a,"tax" =>$b,"total"=>$c);
   include($_SESSION['VxCFG']->formtmpldir."/invoice.php");
   include($_SESSION['VxCFG']->formtmpldir."/label.php");
   echo "<table class=\"formtable\">\n<tr>\n"; 
   echo "<td class=\"formdata\">";
   echo "<input type=button onClick=\"javascript=popPrintWindow('invoice.pdf', 'Invoice')\" value=\"Invoice\"></td>\n";
   echo "<tr>\n<tr>\n"; 
   echo "<td class=\"formdata\">";
   echo "<input type=button onClick=\"javascript=popPrintWindow('label.pdf', 'Label')\" value=\"Label\"></td>\n";
   echo "</tr>\n</table>\n";
}

function listPackage()
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(warehouse_package_qry3, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no outstanding orders defined")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no outstanding orders defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='orderid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Order")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Order")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=orderid\">"._("Order")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='orderid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='customer'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Customer")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Customer")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=customer\">"._("Customer")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='customer'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle\">"._("Action")."</td>\n</tr>\n";
   $c=0;
   $offset=$_SESSION["pageindex"]->current();
   while($row = $result->FetchRow()){
      $qry=sprintf(warehouse_stockpick_qry10, $row["customerid"]);
		$res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      
      $qry=sprintf(warehouse_stockpick_qry11,$r["contactid"]);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      if($c%2){
         echo "<tr class=\"listdata\"><td class=\"listdata\">".$row["ordernumber"]."</td>\n";
         echo "<td class=\"listdata\">".$r["firstname"]." ".$r["lastname"]."</td>\n";
         echo "<td class=\"listdata\">";
      }
      else{
         echo "<tr class=\"listdataeven\"><td class=\"listdataeven\">".$row["ordernumber"]."</td>\n";
         echo "<td class=\"listdataeven\">".$r["firstname"]." ".$r["lastname"]."</td>\n";
         echo "<td class=\"listdataeven\">";
      }
      $wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         if($_SESSION['vxmisuser']->GetPerm('edit')){
            echo "<a href=\"package.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_package.png\"></a>&nbsp; \n";
         }
      }
      else{
         if($_SESSION['vxmisuser']->GetPerm('edit')){
            echo "<a href=\"package.php?action=edit&id=$wibbler\">"._("Package")."</a>&nbsp; \n";
         }
      }
      echo "</td></tr>\n";
      $c++;
      $offset++;
   }
   echo "</table>";
}

?>
