<?php
/*
stockpick.php

Copyright (C)2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Don't write to me at: kingsley@bananahead.com 
*/
include("../vxmis.php");
require_once($_SESSION['VxCFG']->libdir."/address.php");
require_once($_SESSION['VxCFG']->libdir."/contact.php");

if(!$_SESSION['vxmisuser']->isloggedin()){
   redirect($_SESSION['VxCFG']->wwwroot."/login.php");
}
if(isset($_REQUEST['mid'])){
   $_SESSION['vxmisuser']->SetModule($_REQUEST['mid']);
}
if(!isset($_REQUEST['tid'])){
   $_SESSION['vxmisuser']->SetTab(0);
}
else{
   $_SESSION['vxmisuser']->SetTab($_REQUEST['tid']);
}

if(isset($_REQUEST['son'])){
   $_SESSION['vxmisuser']->SetSortOn($_REQUEST['son']);
}

if(isset($_REQUEST['sorder'])){
   $_SESSION['vxmisuser']->SetSortOrder($_REQUEST['sorder']);
}

if($_SESSION['vxmisuser']->GetSortOn()==''){
   $_SESSION['vxmisuser']->SetSortOn('name');
   $_SESSION['vxmisuser']->SetSortOrder('asc');
}

if(isset($_REQUEST['paction'])){
   $action=$_REQUEST['paction'];
}
else{
   if(!isset($_REQUEST['action'])){
      $action='list';
   }
   else{
      $action=$_REQUEST['action'];
   }
}

$_SESSION['vxmisuser']->SetFocusType(FOCUSIDTYPE_HIDE);

if(($err=$_SESSION['vxmisuser']->hasPerm($action, $_SERVER['PHP_SELF']))){
   if($err==3 || $err==4){ 
      header("Location: ".$_SESSION['VxCFG']->wwwroot."/logoutpda.php?errormsg=".$err);
      exit;
   }
   include($_SESSION['VxCFG']->styledir."/headerpda.php");
   echo "<table class=\"formtable\">\n<tr>\n<td class=\"formlabel\">";
   echo "<img src=\"". $_SESSION['VxCFG']->styleimagedir."/icon_stoppda.png\"></td>\n<td class=\"formdata\" valign=middle>";
   echo "<b>"._("You do not have permissions for this page")."</b>\n";
   echo "</td>\n</tr>\n</table>\n";
   $_REQUEST['action']='none';
   include($_SESSION['VxCFG']->styledir."/footerpda.php");
   exit;
}

if(!isset($_SESSION['VxCFG']->pagetitle) || strcmp($_SESSION['VxCFG']->pagetitle, _("Stock Pick"))!=0){
   $_SESSION['VxCFG']->pagetitle=_("Stock Pick");
}

if($_SESSION["pageindex"]->CheckNum(warehouse_stockpick_qry1)){
   $_SESSION["pageindex"]->setnum(CountNum());
}

function updateNav($frm)
{  
   if(!isset($frm["navaction"])) return 0;
   
   $na=$frm["navaction"];
   
   switch($na){
   case 'home':
      $_SESSION["pageindex"]->start();
     break;
   case 'pageprev':
     $_SESSION["pageindex"]->pgprev();
     break;
   case 'prev':
     $_SESSION["pageindex"]->prev();
     break;
   case 'next':
     $_SESSION["pageindex"]->next();
     break;
   case 'pagenext':
     $_SESSION["pageindex"]->pgnext();
     break;
   case 'end':
      if($_REQUEST['action']=="list")
        $_SESSION["pageindex"]->end(0);
      else
         $_SESSION["pageindex"]->end(1);
     break;
   case 'list_pagenext':
   case 'list_pagenext':
      break;
   }

   return $_SESSION["pageindex"]->current();
}

switch($action){
   case "browse":
      include($_SESSION['VxCFG']->styledir."/header.php");
      if(isset($_REQUEST['id'])){
         $id=$_SESSION["pageindex"]->browse($_REQUEST['id']);
         browseStockPick($id);
         break;
      }
      $id=updateNav($_POST);
      browseStockPick($id);
      break;

   case "edit" :
      include($_SESSION['VxCFG']->styledir."/header.php");
      editStockPick($_REQUEST['id']);
      break;

   case "delete" :
      include($_SESSION['VxCFG']->styledir."/header.php");
      if($_SESSION['vxmisuser']->GetConfirmDelete()){
         chkdelStockPick($_REQUEST['id']);
      }
      else{
         deleteStockPick($_POST);
         $_SESSION["pageindex"]->deletion(CountNum());
         listStockPick();
      }
    break;

   case "cfmdelete" :
      include($_SESSION['VxCFG']->styledir."/header.php");
      deleteStockPick($_POST);
      $_SESSION["pageindex"]->deletion(CountNum());
      listStockPick();
      break;

   case "commit" :
      include($_SESSION['VxCFG']->styledir."/header.php");
      commitStockPick($_POST);
      listStockPick();
      break;
      
   case "minicommit" :
      commitmStockPick($_POST);
      listStockPick();
      break;
   
   case "miniview":
   default :
      miniview($_REQUEST['id']);
      exit;
      
   case "list":
   default :
      updateNav($_POST);
      if($_SESSION['vxmisuser']->GetPDAlogin()){
         listminiStockPick();
      }
      else{
         listStockPick();
      }
      break;
}

include($_SESSION['VxCFG']->styledir."/footer.php");

/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

function CountNum()
{
   $result=$_SESSION['VxCFG']->dbh->Execute(warehouse_stockpick_qry1);
   if(!$result) return 0;
   if($row = $result->FetchRow()){
      return $row[0];
   }
   return 0;
}

function clearForm()
{
   $frm["newaction"] = "";
   $frm["showdeps"] = "";
   $frm["id"] = 0;
  
  return $frm;
}

function fillForm($id, $bOffset)
{
   if($bOffset){
      $qry=sprintf(warehouse_stockpick_qry2, $id);
   }
   else{
      $qry=sprintf(warehouse_stockpick_qry3, $id);
   }
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();

   $frm["id"] = $row["id"];

  return $frm;
}

function editStockPick($id) 
{
   $qry=sprintf(warehouse_stockpick_qry5, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["id"] = $row["id"];
   $frm["ordernumber"] = $row["ordernumber"];
   
   $qry=sprintf(warehouse_stockpick_qry10, $row["customerid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["contactid"] = $row["contactid"];
   
   $qry=sprintf(warehouse_stockpick_qry11, $row["contactid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["titleid"] = $row["titleid"];
   $frm["firstname"] = $row["firstname"];
   $frm["lastname"] = $row["lastname"];
   
   $qry=sprintf(warehouse_stockpick_qry12, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["numitems"]=$row[0];
   
   $frm["newaction"] = "commit";
   
   include("templates/stockpick.php");
}

function browseStockPick($id) 
{
   $qry=sprintf(warehouse_stockpick_qry5, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["id"] = $row["id"];
   $frm["ordernumber"] = $row["ordernumber"];
   
   $qry=sprintf(warehouse_stockpick_qry10, $row["customerid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["contactid"] = $row["contactid"];
   
   $qry=sprintf(warehouse_stockpick_qry11, $row["contactid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["titleid"] = $row["titleid"];
   $frm["firstname"] = $row["firstname"];
   $frm["lastname"] = $row["lastname"];
   /*
   $qry=sprintf(warehouse_stockpick_qry12, $row["addressid"]);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["firstname"] = $row["firstname"];
   */
   
   $qry=sprintf(warehouse_stockpick_qry12, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $frm["numitems"]=$row[0];
   
   $frm["newaction"] = "browse";
  
   include("templates/stockpick.php");
}

function chkdelStockPick($id)
{
   $qry=sprintf(warehouse_stockpick_qry10, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);  
   $frm["numsites"]=db_num_rows($result);

   $qry=sprintf(warehouse_stockpick_qry12, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);  
   $row = $result->FetchRow();
   $frm["name"]=$row["name"];

   $frm["id"]=$id; 
   $frm["newaction"] = "cfmdelete";
   
   include("templates/sitedel.php");
}

function insertStockPick($frm) 
{
   $qry=sprintf(warehouse_stockpick_qry4,$frm['attributeid'],$frm['tradingname'],$frm['companyname']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function commitStockPick($frm) 
{
   if($frm["numitems"] != count($frm['itemcheck'])){
      echo "Not all checked - partial orders not handled yet.";
      exit;
   }
   else{
      $qry=sprintf(warehouse_stockpick_qry8,$frm['id']);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
}

function commitmStockPick($frm) 
{
   $qry=sprintf(warehouse_stockpick_qry8,$frm['id']);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function deleteStockPick($frm) 
{
   if($frm["reassign"]=="1"){
      $nsite=$frm["sites"];
      $qry=sprintf(warehouse_stockpick_qry7, $nsite, $frm["id"]);
      $_SESSION['VxCFG']->dbh->Execute($qry);
   }
   else{
      $qry=sprintf(warehouse_stockpick_qry8, $frm["id"]);
      $_SESSION['VxCFG']->dbh->Execute($qry);  
   }

   $qry=sprintf(warehouse_stockpick_qry6, $frm["id"]);
   $_SESSION['VxCFG']->dbh->Execute($qry);
}

function listminiStockPick()
{
   include($_SESSION['VxCFG']->styledir."/headerpda.php");
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(warehouse_stockpick_qry4, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no outstanding orders defined")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no outstanding orders defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='orderid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Order")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Order")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=orderid\">"._("Order")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='orderid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='customer'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Customer")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Customer")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=customer\">"._("Customer")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='customer'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
   
   while($row = $result->FetchRow()){
      echo "<tr><td class=\"listdata\">".$row["ordernumber"]."</td>\n";
      $qry=sprintf(warehouse_stockpick_qry10, $row["customerid"]);
		$res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      
      $qry=sprintf(warehouse_stockpick_qry11,$r["contactid"]);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      echo "<td class=\"listdata\">".$r["firstname"]." ".$r["lastname"]."</td>\n";

      echo "<td class=\"listdata\">";
      $wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"stockpick.php?action=miniview&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_stockpick.png\"></a>&nbsp; \n";
         }

      }
      else{
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"stockpick.php?action=miniview&id=$wibbler\">"._("Stock Pick")."</a>&nbsp; \n";
         }
      }
    echo "</td></tr>\n";
  }
  echo "</table>";
  include($_SESSION['VxCFG']->styledir."/footerpda.php");
  exit;
}

function miniView($orderid)
{
   include($_SESSION['VxCFG']->styledir."/headerpda.php");
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   echo "<table class=\"minilisttable\">\n";
   $qry=sprintf(warehouse_stockpick_qry6, $orderid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      exit;
   }
   echo "<tr><td class=\"minilisttitle\"><table class=\"minilistsorttable\"><tr><td class=\"minilistsort\">";
   if($sorton=='partnumber'){
      if($sortorder=='asc'){
        echo "<a class=\"minilistsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Part No")."</a></td>\n";
      }
      else{
         echo "<a class=\"minilistsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Part No")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"minilistnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=partnumber\">"._("Part No")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='parnumber'){
      echo "<td class=\"minilistsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"minilistsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/minilist_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"minilistsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/minilist_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"minilisttitle\"><table class=\"minilistsorttable\"><tr><td class=\"minilistsort\">";
   if($sorton=='stocklocation'){
      if($sortorder=='asc'){
        echo "<a class=\"minilistsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Location")."</a></td>\n";
      }
      else{
         echo "<a class=\"minilistsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Location")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"minilistnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=stocklocation\">"._("Location")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='stocklocation'){
      echo "<td class=\"minilistsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"minilistsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/minilist_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"minilistsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/minilist_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"minilisttitle\"><table class=\"minilistsorttable\"><tr><td class=\"minilistsort\">";
   if($sorton=='description'){
      if($sortorder=='asc'){
        echo "<a class=\"minilistsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Description")."</a></td>\n";
      }
      else{
         echo "<a class=\"minilistsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Description")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"minilistnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=description\">"._("Description")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='description'){
      echo "<td class=\"minilistsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"minilistsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/minilist_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"minilistsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/minilist_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"minilisttitle \">"._("Quantity")."</td>\n";
   echo "<td class=\"minilisttitle \">";
   echo "<input class=\"checkbox\" type=\"checkbox\" name=\"checkall\" onClick=\"Checkall(document.getElementById('orderitems'))\">";
   echo "</td>\n</tr>\n";
   
   while($row = $result->FetchRow()){
      $qry=sprintf(warehouse_stockpick_qry7, $row['productid']);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$res) continue;
      if($res->RecordCount()==0) continue;
      if(!($r = $res->FetchRow())) continue;
      echo "<tr><td class=\"minilistdata\">";
      if(isset($r["partnumber"])){
         echo $r["partnumber"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n<td class=\"minilistdata\">";
      if(isset($r["stocklocation"]) && $r["stocklocation"]!=''){
         echo $r["stocklocation"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n";
      
      echo "<td class=\"minilistdata\">".$r["description"]."</td>\n";
      echo "<td class=\"minilistdata\">".$row["quantity"]."</td>\n";
      echo "<td class=\"minilistdata\">";
      echo "<input class=\"checkbox\" type=\"checkbox\" name=\"itemcheck\">";
      echo "</td></tr>\n";
   }
   echo "<tr><td colspan=\"5\" align=\"center\">";
   echo "<input type=\"submit\" value=\""._("Done")."\">\n";
   echo "</td></tr>\n</table>\n</form>\n</body>\n</html>";
}

function ContactName($a, $contactid) 
{
   $c=new Contact($id);
   $c->NameTable($a, $id);
}

function AddressTable($a, $id)
{
   $qry=sprintf(customerm_customer_qry9, $id);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   $row = $result->FetchRow();
   $aid=$row["addressid"];
   
   $addr=new Address();
   $addr->FillListTable($a, $aid);
}

function OrderItems($orderid)
{
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();

   echo "<table class=\"listtable\">\n";
   $qry=sprintf(warehouse_stockpick_qry6, $orderid);
   $result=$_SESSION['VxCFG']->dbh->Execute($qry);
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no items for this order")."</td></td></table>\n";
      exit;
   }
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='partnumber'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Part No")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Part No")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=partnumber\">"._("Part No")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='parnumber'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='stocklocation'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Location")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Location")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=stocklocation\">"._("Location")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='stocklocation'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='description'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Description")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Description")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=description\">"._("Description")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='description'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle \">"._("Quantity")."</td>\n";
   echo "<td class=\"listtitle \">";
   echo "<input class=\"checkbox\" type=\"checkbox\" name=\"checkall\" onClick=\"Checkall(document.getElementById('stockpick'))\">";
   echo "</td>\n</tr>\n";
   
   while($row = $result->FetchRow()){
      $qry=sprintf(warehouse_stockpick_qry7, $row['productid']);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      if(!$res) continue;
      if($res->RecordCount()==0) continue;
      if(!($r = $res->FetchRow())) continue;
      echo "<tr><td class=\"listdata\">";
      if(isset($r["partnumber"])){
         echo $r["partnumber"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n<td class=\"listdata\">";
      if(isset($r["stocklocation"]) && $r["stocklocation"]!=''){
         echo $r["stocklocation"];
      }
      else{
         echo "&nbsp;";
      }
      echo "</td>\n";
      
      echo "<td class=\"listdata\">".$r["description"]."</td>\n";
      echo "<td class=\"listdata\">".$row["quantity"]."</td>\n";
      echo "<td class=\"listdata\">";
      echo "<input class=\"checkbox\" type=\"checkbox\" name=\"itemcheck[]\ value=\"".$row['id']."\">";
      echo "</td></tr>\n";
   }
   echo "</table>\n";
}

function listStockPick()
{
   include($_SESSION['VxCFG']->styledir."/header.php");
   $sorton=$_SESSION["vxmisuser"]->GetSortOn();
   $sortorder=$_SESSION["vxmisuser"]->GetSortOrder();
   
   $qry=sprintf(warehouse_stockpick_qry4, $sorton, $sortorder);
   $q=$_SESSION["pageindex"]->query($qry);
   $result=$_SESSION['VxCFG']->dbh->Execute($q);
   $_REQUEST['action']="list";

   echo "<table class=\"listtable\">\n";
   if(!$result){
      echo "<tr><td colspan=\"2\">"._("There are no outstanding orders defined")."</td></td></table>\n";
      exit;
   }
   if($result->RecordCount()==0){
      echo "<tr><td colspan=\"2\">"._("There are no outstanding orders defined")."</td></td></table>\n";
      exit;
   }
   
   echo "<tr><td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='orderid'){
      if($sortorder=='asc'){
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Order")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Order")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=orderid\">"._("Order")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='orderid'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   
   echo "<td class=\"listtitle\"><table class=\"listsorttable\"><tr><td class=\"listsort\">";
   if($sorton=='customer'){
      if($sortorder=='asc'){
        echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=desc\">"._("Customer")."</a></td>\n";
      }
      else{
         echo "<a class=\"listsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&sorder=asc\">"._("Customer")."</a></td>\n";
      }
   }
   else{
      echo "<a class=\"listnsort\" href=\"".$_SERVER['PHP_SELF']."?action=list&son=customer\">"._("Customer")."</a></td></tr></table>\n</td>\n";
   }
   if($sorton=='customer'){
      echo "<td class=\"listsortimg\">";
      if($sortorder=='asc'){
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortasc.png\"></td></tr></table>\n</td>\n";
      }
      else{
         echo "<img class=\"listsort\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_sortdesc.png\"></td></tr></table>\n</td>\n";
      }
   }
   echo "<td class=\"listtitle \">"._("Action")."</td>\n</tr>\n";
   
   while($row = $result->FetchRow()){
      echo "<tr><td class=\"listdata\">".$row["ordernumber"]."</td>\n";
      $qry=sprintf(warehouse_stockpick_qry10, $row["customerid"]);
		$res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      
      $qry=sprintf(warehouse_stockpick_qry11,$r["contactid"]);
      $res=$_SESSION['VxCFG']->dbh->Execute($qry);
      $r = $res->FetchRow();
      echo "<td class=\"listdata\">".$r["firstname"]." ".$r["lastname"]."</td>\n";

      echo "<td class=\"listdata\">";
      $wibbler=$row["id"];
      
      if($_SESSION['vxmisuser']->GetShowImages()){
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"stockpick.php?action=edit&id=$wibbler\"><img class=\"page\" src=\"".$_SESSION['VxCFG']->styleimagedir."/list_stockpick.png\"></a>&nbsp; \n";
         }

      }
      else{
         if($_SESSION['vxmisuser']->GetPerm('edit')){
          echo "<a href=\"stockpick.php?action=edit&id=$wibbler\">"._("Stock Pick")."</a>&nbsp; \n";
         }
      }
    echo "</td></tr>\n";
  }
  echo "</table>";
}

?>
